;;
;; PDDL file for the AIPS2000 Planning Competition
;; based on the data generated by the airport simulator Astras.
;;

;; Author: Sebastian Trueg thisshouldbethecurrentdateandtime :(
;; Created with PreInstancerDomainExporter 0.6 by Sebastian Trueg <trueg@informatik.uni-freiburg.de>
;; Modified by Andrew Coles
;;


(define (domain airport_fixed_structure)

(:requirements :duration-inequalities :fluents :durative-actions :typing)

(:types airplane segment direction airplanetype)

(:constants
                north
                south - direction

                light
                medium
                heavy - airplanetype

                seg_08R_B2a_0_80
                seg_08R_B2b_0_80
                seg_B2_1_0_80
                seg_08R_B2B3_0_900
                seg_08r_0_80
                seg_08R_B3a_0_80
                seg_08R_B3c_0_161_245
                seg_08R_B3B4_0_520
                seg_B3_a_0_156_924
                seg_08R_B4a_0_161_245
                seg_08R_B4c_0_80
                seg_08R_B4b_0_80
                seg_08R_B4d_0_161_245
                seg_B5_a_0_158_647
                seg_08R_B4B6_0_360
                seg_B4_a_0_156_924
                seg_08R_B6a_0_161_245
                seg_08R_B6c_0_80
                seg_08R_B6b_0_80
                seg_08R_B6d_0_161_245
                seg_B8_a_0_156_924
                seg_08R_B6B9_0_420
                seg_B6_a_0_158_647
                seg_08R_B9a_0_161_245
                seg_08R_B9c_0_80
                seg_09r_0_80
                seg_B9_a_0_156_924
                seg_08R_B9B10_0_980
                seg_08R_B10a_0_80
                seg_08R_B10b_0_80
                seg_B10_1_0_80
                seg_T_B2a_0_60
                seg_T_B2b_0_60
                seg_T_B2c_0_60
                seg_S_B2b_0_60
                seg_T_B2B3a_0_140
                seg_B2_0_80
                seg_T_B2B3b_0_140
                seg_T_B2B3c_0_140
                seg_T_B3a_0_60
                seg_T_B3b_0_60
                seg_T_B3c_0_120_934
                seg_T_B3d_0_60
                seg_S_B3b_0_60
                seg_T_B3B4a_0_140
                seg_B3_b_0_80_6226
                seg_T_B3B4b_0_140
                seg_T_B3B4c_0_140
                seg_T_B3B4d_0_140
                seg_T_B4a_0_60
                seg_T_B4b_0_60
                seg_T_B4c_0_120_934
                seg_T_B4d_0_60
                seg_S_B4b_0_60
                seg_T_B4B6a_0_135
                seg_B4_b_0_80_6226
                seg_T_B4B6b_0_135
                seg_T_B4B6c_0_130
                seg_T_B6a_0_60
                seg_T_B6b_0_60
                seg_T_B6c_0_120_934
                seg_T_B6d_0_60
                seg_S_B6b_0_60
                seg_T_B6B7a_0_140
                seg_B6_b_0_159_512
                seg_T_B6B7b_0_140
                seg_T_B7a_0_60
                seg_T_B7b_0_60
                seg_T_B7c_0_60
                seg_S_B7c_0_60
                seg_T_B5d_0_60
                seg_T_B5a_0_60
                seg_T_B5b_0_60
                seg_T_B5c_0_120_934
                seg_S_B5c_0_60
                seg_T_B5B8a_0_135
                seg_B5_b_0_159_512
                seg_T_B5B8b_0_135
                seg_T_B5B8c_0_130
                seg_T_B8a_0_60
                seg_T_B8b_0_60
                seg_T_B8c_0_120_934
                seg_T_B8d_0_60
                seg_S_B8b_0_60
                seg_T_B8B9a_0_115
                seg_B8_b_0_80_6226
                seg_T_B8B9b_0_115
                seg_T_B8B9c_1_0_115
                seg_T_B9a_0_60
                seg_T_B9b_0_60
                seg_T_B9c_0_120_934
                seg_T_B9d_0_60
                seg_S_B9b_0_60
                seg_T_B9B10a_0_125
                seg_B9_b_0_80_6226
                seg_T_B8B9c_0_115
                seg_T_B9B10b_0_125
                seg_T_B9B10c_1_0_83
                seg_T_B10a_0_60
                seg_T_B10b_0_60
                seg_T_B10c_0_60
                seg_S_B10a_0_60
                seg_B10_0_80
                seg_T_B9B10c_0_84
                seg_S_B2a_0_60
                seg_S_B2B3a_0_140
                seg_S_B2B3b_0_140
                seg_S_B2B3c_0_140
                seg_S_B3a_0_60
                seg_S_B3c_0_60
                seg_S_B3B4a_0_140
                seg_S_B3B4b_0_140
                seg_S_B3B4c_0_140
                seg_S_B3B4d_0_140
                seg_S_B4a_0_60
                seg_S_B4c_0_60
                seg_S_B4B6a_0_135
                seg_S_B4B6b_0_135
                seg_S_B4B6c_0_130
                seg_S_B6a_0_60
                seg_S_B6c_0_60
                seg_S_B6B7a_0_140
                seg_S_B6B7b_0_140
                seg_S_B7a_0_60
                seg_S_B7b_0_60
                seg_S_B7d_0_60
                seg_S5_0_94
                seg_S_B5d_0_60
                seg_S_B5a_0_60
                seg_S_B5b_0_60
                seg_S6_0_94
                seg_S_B5B8a_0_135
                seg_S_B5B8b_0_135
                seg_S_B5B8c_0_130
                seg_S_B8a_0_60
                seg_S_B8c_0_60
                seg_S_B8B9a_0_115
                seg_S_B8B9b_0_115
                seg_S_B8B9c_1_0_115
                seg_S_B9a_0_60
                seg_S_B9c_0_60
                seg_S_B9B10a_0_125
                seg_S_B8B9c_0_115
                seg_S_B9B10b_0_125
                seg_S_B9B10c_1_0_83
                seg_S_B10b_0_60
                seg_S_B9B10c_0_84
                seg_B3_b_1_0_80_6226
                seg_B4_b_1_0_80_6226
                seg_B8_b_1_0_80_6226
                seg_B9_b_1_0_80_6226
                seg_W1_C1a_0_60
                seg_W1_C1b_0_60
                seg_W1_C1c_0_34
                seg_N1_0_108
                seg_C1_n2c_0_60
                seg_W1_141a_0_34
                seg_W1_141b_0_45
                seg_W1_141c_0_34
                seg_p141_0_75
                seg_W1_142a_0_34
                seg_W1_142b_0_45
                seg_W1_142c_0_34
                seg_p142_0_75
                seg_W1_143a_0_34
                seg_W1_143b_0_45
                seg_W1_143c_0_60
                seg_p143_0_75
                seg_W1_C2a_0_60
                seg_W1_C2b_0_60
                seg_W1_C2c_0_34
                seg_C2_a_0_80
                seg_W1_151a_0_34
                seg_W1_151b_0_45
                seg_W1_151c_0_34
                seg_p151_0_75
                seg_W1_152a_0_34
                seg_W1_152b_0_45
                seg_W1_152c_0_34
                seg_p152_0_75
                seg_W1_153a_0_34
                seg_W1_153b_0_45
                seg_W1_153c_0_34
                seg_p153_0_75
                seg_W1_154a_0_34
                seg_W1_154b_0_45
                seg_W1_154c_0_34
                seg_p154_0_75
                seg_W1_C3a_0_34
                seg_W1_C3b_0_60
                seg_W1_C3c_0_48
                seg_C3_a_0_80
                seg_W1_161a_0_34
                seg_W1_161b_0_45
                seg_W1_161c_0_34
                seg_p161_0_75
                seg_W1_162a_0_34
                seg_W1_162b_0_45
                seg_W1_162c_0_34
                seg_p162_0_75
                seg_W1_163a_0_34
                seg_W1_163b_0_45
                seg_W1_163c_0_34
                seg_p163_0_75
                seg_W1_164a_0_34
                seg_W1_164b_0_45
                seg_W1_164c_0_34
                seg_p164_0_75
                seg_W1_C4a_0_34
                seg_W1_C4b_0_60
                seg_W1_C4c_0_60
                seg_C4_S6c_0_60
                seg_O1_C1a_0_60
                seg_O1_C1b_0_34
                seg_O1_C1c_0_80
                seg_p101_0_76
                seg_O1_102a_0_34
                seg_C1_n2b_0_80
                seg_O1_102b_0_60
                seg_O1_102c_0_34
                seg_p102_0_76
                seg_O1_103a_0_34
                seg_O1_103b_0_60
                seg_O1_103c_0_34
                seg_p103_0_76
                seg_O1_104a_0_34
                seg_O1_104b_0_60
                seg_O1_104c_0_60
                seg_p104_0_76
                seg_O1_C2a_0_60
                seg_O1_C2b_0_60
                seg_O1_C2c_0_34
                seg_O1_C2d_0_60
                seg_p107_0_76
                seg_O1_108a_0_34
                seg_C2_b_0_80
                seg_O1_108b_0_60
                seg_O1_108c_0_34
                seg_O1_108d_0_45
                seg_p108_0_76
                seg_O1_109a_0_34
                seg_p131_0_75
                seg_O1_109b_0_60
                seg_O1_109c_0_34
                seg_O1_109d_0_45
                seg_p109_0_76
                seg_O1_110a_0_34
                seg_p132_0_75
                seg_O1_110b_0_60
                seg_O1_110c_0_34
                seg_O1_110d_0_45
                seg_p110_0_76
                seg_O1_111a_0_34
                seg_p133_0_75
                seg_O1_111b_0_60
                seg_O1_111c_0_34
                seg_O1_111d_0_45
                seg_p111_0_76
                seg_p134_0_75
                seg_O1_C3a_0_34
                seg_O1_C3b_0_60
                seg_O1_C3c_0_48
                seg_O1_C3d_0_60
                seg_p112_0_76
                seg_O1_115a_0_34
                seg_C3_b_0_80
                seg_O1_115b_0_60
                seg_O1_115c_0_34
                seg_p115_0_76
                seg_O1_116a_0_34
                seg_O1_116b_0_60
                seg_O1_116c_0_34
                seg_p116_0_76
                seg_O1_117a_0_34
                seg_O1_117b_0_60
                seg_O1_117c_0_34
                seg_p117_0_76
                seg_O1_118a_0_34
                seg_O1_118b_0_60
                seg_O1_118c_0_34
                seg_p118_0_76
                seg_O1_C4a_0_34
                seg_O1_C4b_0_60
                seg_O1_C4c_0_80
                seg_p119_0_76
                seg_C4_S6a_0_80
                seg_C1_n2a_0_60
                seg_N2_0_108
                seg_C4_S6b_0_60
                seg_08L_A2a_0_80
                seg_08L_A2b_0_80
                seg_08L_A2A3_0_970
                seg_A2_a_0_90
                seg_08L_A3a_0_80
                seg_08L_A3b_0_161_245
                seg_08l_0_80
                seg_08L_A3A4_0_450
                seg_A3_a_0_158_647
                seg_08L_A4a_0_80
                seg_08L_A4b_0_161_245
                seg_08L_A4c_0_161_245
                seg_08L_A4d_0_80
                seg_08L_A6A7_0_450
                seg_A6_a_0_158_647
                seg_A4_a_0_157_785
                seg_08L_A7a_0_80
                seg_08L_A7b_0_161_245
                seg_08L_A7c_0_161_245
                seg_08L_A7d_0_80
                seg_08L_A7A9_0_270
                seg_A8_a_0_157_785
                seg_A7_a_0_156_924
                seg_09l_0_80
                seg_08L_A9b_0_161_245
                seg_08L_A9c_0_80
                seg_08L_A9A10_0_1010
                seg_A9_a_0_158_647
                seg_08L_A10a_0_80
                seg_08L_A10b_0_80
                seg_A10_1_0_80
                seg_M_A3a_0_120_934
                seg_M_A3b_0_60
                seg_M_A3c_0_60
                seg_A3_b_0_159_512
                seg_M_A3A4a_0_75
                seg_N_A3a_0_60
                seg_M_A3A4b_0_75
                seg_M_A3A4c_0_75
                seg_M_A3A4d_0_75
                seg_M_A3A4e_0_75
                seg_M_A3A4f_0_115
                seg_M_A4a_0_120_934
                seg_M_A4b_0_60
                seg_M_A4c_0_60
                seg_M_A4d_0_60
                seg_A4_b_0_79_7559
                seg_M_A4A7a_0_75
                seg_N_A4a_0_60
                seg_M_A4A7b_0_75
                seg_M_A4A7c_0_75
                seg_M_A4A7d_0_75
                seg_M_A4A7e_0_75
                seg_M_A4A7f_0_115
                seg_M_A7a_0_120_934
                seg_M_A7b_0_60
                seg_M_A7c_0_60
                seg_M_A7d_0_60
                seg_A7_b_0_80_6226
                seg_M_A7A6a_0_75
                seg_N_A7a_0_60
                seg_M_A7A6b_0_75
                seg_M_A7A6c_0_75
                seg_M_A7A6d_0_85
                seg_M_A6a_0_60
                seg_M_A6b_0_60
                seg_M_A6c_0_60
                seg_M_A6d_0_120_934
                seg_M_A6A8a_0_75
                seg_N_A6a_0_60
                seg_A6_b_0_159_512
                seg_M_A6A8b_0_75
                seg_M_A6A8c_0_75
                seg_M_A6A8d_0_75
                seg_M_A6A8e_0_75
                seg_M_A6A8f_0_115
                seg_M_A8a_0_60
                seg_M_A8b_0_60
                seg_M_A8c_0_60
                seg_M_A8d_0_120_934
                seg_M_A8A9a_0_75
                seg_N_A8a_0_60
                seg_A8_b_0_80_6226
                seg_M_A8A9b_0_75
                seg_M_A8A9c_0_75
                seg_M_A8A9d_0_85
                seg_M_A9a_0_60
                seg_M_A9b_0_60
                seg_M_A9c_0_60
                seg_M_A9d_0_120_934
                seg_M_A9A10a_0_75
                seg_N_A9a_0_60
                seg_A9_b_0_159_512
                seg_M_A9A10b_0_75
                seg_M_A9A10c_0_75
                seg_M_A9A10d_0_75
                seg_M_A9A10e_0_75
                seg_M_A9A10f_0_75
                seg_M_A9A10g_0_80
                seg_M_A10a_0_60
                seg_M_A10b_0_60
                seg_M_A10c_0_60
                seg_A10_0_80
                seg_N_A10a_0_60
                seg_N_A2a_0_60
                seg_N_A2b_0_60
                seg_A2_c_0_100
                seg_N_A2A3a_0_75
                seg_N_A2A3b_0_75
                seg_N_A2A3c_0_75
                seg_N_A2A3d_0_75
                seg_N_A2A3e_0_75
                seg_N_A2A3f_0_115
                seg_N_A3b_0_60
                seg_N_A3c_0_60
                seg_N_A3d_0_60
                seg_N_N2c_0_60
                seg_N_N2a_0_60
                seg_N_N2b_0_60
                seg_N_N2A4a_0_70
                seg_N_N2A4b_0_75
                seg_N_N2A4c_0_75
                seg_N_N2A4d_0_75
                seg_N_N2A4e_0_75
                seg_N_A4b_0_60
                seg_N_A4c_0_60
                seg_N_A4A7a_0_115
                seg_N_A4A7b_0_75
                seg_N_A4A7c_0_75
                seg_N_A4A7d_0_75
                seg_N_A4A7e_0_75
                seg_N_A4A7f_0_75
                seg_N_A7b_0_60
                seg_N_A7c_0_60
                seg_N_A7A6a_0_85
                seg_N_A7A6b_0_75
                seg_N_A7A6c_0_75
                seg_N_A7A6d_0_75
                seg_N_A6b_0_60
                seg_N_A6c_0_60
                seg_N_A6A8a_0_115
                seg_N_A6A8b_0_75
                seg_N_A6A8c_0_75
                seg_N_A6A8d_0_75
                seg_N_A6A8e_0_75
                seg_N_A6A8f_0_75
                seg_N_A8b_0_60
                seg_N_A8c_0_60
                seg_N_A8A9a_0_85
                seg_N_A8A9b_0_75
                seg_N_A8A9c_0_75
                seg_N_A8A9d_0_75
                seg_N_A9b_0_60
                seg_N_A9c_0_60
                seg_N_A9A10a_0_80
                seg_N_A9A10b_0_75
                seg_N_A9A10c_0_75
                seg_N_A9A10d_0_75
                seg_N_A9A10e_0_75
                seg_N_A9A10f_0_75
                seg_N_A9A10g_0_75
                seg_N_A10b_0_60
                seg_A2_b_0_90
                seg_A4_b_1_0_80_6226
                seg_A7_b_1_0_80_6226
                seg_A8_b_1_0_79_7559
                seg_T_B9B10c_2_0_83
                seg_S_B9B10c_2_0_83 - segment

                airplane_CFBEG
                airplane_CFBE1
                airplane_CFBE3
                airplane_DAEW8
                airplane_DAEW9
                airplane_DAEW0
                airplane_DAEW3
                airplane_DAEWH
                airplane_DAEW1
                airplane_DAEW2
                airplane_DAEW4
                airplane_DAEW5
                airplane_DAEW6
                airplane_DAEW7
                airplane_CFBE2 - airplane
)

(:predicates
	(needs-to-be-parked ?a - airplane)
	(needs-to-be-airborne ?a - airplane)
		(not-burning-fuel ?a - airplane)
		(taken-off ?a - airplane)
		(should-be-moving ?a - airplane)
		(not-already-moving ?a - airplane)
		(candostuff)
		(nothing)
		(can-start-burning-windows)
		(in-air ?a - airplane)
		(can-start ?a - airplane)
                ;; airport information
                (has-type ?a - airplane ?t - airplanetype)
                ;; plane a has type t
                (at-segment ?a - airplane ?s - segment)
                ;; planes are at segments, ie at their end in driving direction
                (facing ?a - airplane ?d - direction)
                ;; planes face into their driving direction

                ;; how the planes affect the airport
                (occupied ?s - segment)
                ;; a plane is in here
                (not_occupied ?s - segment)
                (blocked ?s - segment ?a - airplane)
                ;; segment s is blocked if it is endangered by plane p
                (not_blocked ?s - segment ?a - airplane)

                ;; an airplane may lineup on segment s when facing d
                (is-start-runway ?s - segment ?d - direction)

                ;; airplane a is starting from runway s
                (airborne ?a - airplane ?s - segment)

                (is-moving ?a - airplane)
                (is-pushing ?a - airplane)
                (is-parked ?a - airplane ?s - segment)

)

(:functions
		(fuel-wasted)
                ;; the length of a segment
                (length ?s - segment)

                ;; the number of engines of an airplane
                (engines ?a - airplane)
)

(:durative-action fuel_loss_starting
 :parameters ()
 :duration  (= ?duration 1)
 :condition (and (at start(nothing)))
 :effect
     (and
                (at end (candostuff))
		(at end (not (nothing)))
                (at start (can-start-burning-windows))
                (at end (not (can-start-burning-windows)))
    )
)
(:durative-action fuel_loss_should_be_moving
 :parameters (?a - airplane ?s - segment)
 :duration  (and (>= ?duration 1)
              (<= ?duration 10000 ))
 :condition
     (and
		(at start (can-start-burning-windows))
                (at start(not-burning-fuel ?a))
	(at start (needs-to-be-parked ?a))
                (at start(should-be-moving ?a))
                (at end (is-parked ?a ?s))
     )
 :effect
     (and
                (at start (is-moving ?a))
		(at start (not (should-be-moving ?a)))
                (at start (not (not-burning-fuel ?a)))
	(increase (fuel-wasted) (* #t (engines ?a)))
)
)
(:durative-action fuel_loss_should_be_moving_takeoff
 :parameters (?a - airplane ?s - segment)
 :duration  (and (>= ?duration 1)
              (<= ?duration 10000 ))
 :condition
     (and
		(at start (can-start-burning-windows))
                (at start(not-burning-fuel ?a))
	(at start (needs-to-be-airborne ?a))
                (at start(should-be-moving ?a))
                (at end (taken-off ?a))
     )
 :effect
     (and
                (at start (is-moving ?a))
		(at start (not (should-be-moving ?a)))
                (at start (not (not-burning-fuel ?a)))
	(increase (fuel-wasted) (* #t (engines ?a)))
)
)
(:durative-action fuel_loss_to_park
 :parameters (?a - airplane ?s - segment)
 :duration  (and (>= ?duration 1)
              (<= ?duration 10000 ))
 :condition
     (and
		(at start (candostuff))
	(at start (needs-to-be-parked ?a))
                (at start(not-already-moving ?a))
                (at start(not-burning-fuel ?a))
                (at end (is-parked ?a ?s))
     )
 :effect
     (and
                (at start (can-start ?a))
                (at start (not (not-burning-fuel ?a)))
	(increase (fuel-wasted) (* #t (engines ?a)))
)
)
(:durative-action fuel_loss
 :parameters (?a - airplane)
 :duration  (and (>= ?duration 1)
	      (<= ?duration 10000 ))
 :condition
     (and
		(at start (candostuff))
		(at start(not-burning-fuel ?a))
	(at start (needs-to-be-airborne ?a))
		(at start(not-already-moving ?a))
		(at end (taken-off ?a))
     )
 :effect
     (and
                (at start (can-start ?a))
		(at start (not (not-burning-fuel ?a)))
	(increase (fuel-wasted) (* #t (engines ?a)))
		(at end (not-burning-fuel ?a))
)
)
(:durative-action move_seg_p141_0_75_seg_W1_141b_0_45_north_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_p141_0_75))
                 (at start (not_occupied seg_W1_141b_0_45))
                 (at start (not_blocked seg_W1_141b_0_45 airplane_CFBEG))
                 (at start (not_blocked seg_W1_141b_0_45 airplane_CFBE1))
                 (at start (not_blocked seg_W1_141b_0_45 airplane_CFBE3))
                 (at start (not_blocked seg_W1_141b_0_45 airplane_DAEW8))
                 (at start (not_blocked seg_W1_141b_0_45 airplane_DAEW9))
                 (at start (not_blocked seg_W1_141b_0_45 airplane_DAEW0))
                 (at start (not_blocked seg_W1_141b_0_45 airplane_DAEW3))
                 (at start (not_blocked seg_W1_141b_0_45 airplane_DAEWH))
                 (at start (not_blocked seg_W1_141b_0_45 airplane_DAEW1))
                 (at start (not_blocked seg_W1_141b_0_45 airplane_DAEW2))
                 (at start (not_blocked seg_W1_141b_0_45 airplane_DAEW4))
                 (at start (not_blocked seg_W1_141b_0_45 airplane_DAEW5))
                 (at start (not_blocked seg_W1_141b_0_45 airplane_DAEW6))
                 (at start (not_blocked seg_W1_141b_0_45 airplane_DAEW7))
                 (at start (not_blocked seg_W1_141b_0_45 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_p141_0_75)))
                 (at end (not_occupied seg_p141_0_75))
                 (at start (not (at-segment ?a seg_p141_0_75)))

                 (at start (occupied seg_W1_141b_0_45))
                 (at start (not (not_occupied seg_W1_141b_0_45)))
                 (at start (blocked seg_W1_141b_0_45 ?a))
                 (at start (not (not_blocked seg_W1_141b_0_45 ?a)))
                 (at end (at-segment ?a seg_W1_141b_0_45))


                )
)

(:durative-action move_seg_W1_141b_0_45_seg_W1_141a_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_W1_141b_0_45))
                 (at start (not_occupied seg_W1_141a_0_34))
                 (at start (not_blocked seg_W1_141a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_W1_141a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_W1_141a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_W1_141a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_W1_141a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_W1_141a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_W1_141a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_W1_141a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_W1_141a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_W1_141a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_W1_141a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_W1_141a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_W1_141a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_W1_141a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_W1_141a_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_W1_141c_0_34))
              )

 :effect        (and
                 (at end (not (occupied seg_W1_141b_0_45)))
                 (at end (not_occupied seg_W1_141b_0_45))
                 (at start (not (at-segment ?a seg_W1_141b_0_45)))

                 (at start (occupied seg_W1_141a_0_34))
                 (at start (not (not_occupied seg_W1_141a_0_34)))
                 (at start (blocked seg_W1_141a_0_34 ?a))
                 (at start (not (not_blocked seg_W1_141a_0_34 ?a)))
                 (at end (at-segment ?a seg_W1_141a_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_p141_0_75 ?a)))
                 (at end (not_blocked seg_p141_0_75 ?a))

                 (at start (blocked seg_W1_141c_0_34 ?a))
                 (at start (not (not_blocked seg_W1_141c_0_34 ?a)))
                )
)

(:durative-action move_seg_W1_141a_0_34_seg_W1_C1c_0_34_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_W1_141a_0_34))
                 (at start (not_occupied seg_W1_C1c_0_34))
                 (at start (not_blocked seg_W1_C1c_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_W1_C1c_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_W1_C1c_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_W1_C1c_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_W1_C1c_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_W1_C1c_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_W1_C1c_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_W1_C1c_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_W1_C1c_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_W1_C1c_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_W1_C1c_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_W1_C1c_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_W1_C1c_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_W1_C1c_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_W1_C1c_0_34 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_W1_141a_0_34)))
                 (at end (not_occupied seg_W1_141a_0_34))
                 (at start (not (at-segment ?a seg_W1_141a_0_34)))

                 (at start (occupied seg_W1_C1c_0_34))
                 (at start (not (not_occupied seg_W1_C1c_0_34)))
                 (at start (blocked seg_W1_C1c_0_34 ?a))
                 (at start (not (not_blocked seg_W1_C1c_0_34 ?a)))
                 (at end (at-segment ?a seg_W1_C1c_0_34))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_W1_141b_0_45 ?a)))
                 (at end (not_blocked seg_W1_141b_0_45 ?a))
                 (at end (not (blocked seg_W1_141c_0_34 ?a)))
                 (at end (not_blocked seg_W1_141c_0_34 ?a))

                )
)

(:durative-action move_seg_W1_C1c_0_34_seg_W1_141a_0_34_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_W1_C1c_0_34))
                 (at start (not_occupied seg_W1_141a_0_34))
                 (at start (not_blocked seg_W1_141a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_W1_141a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_W1_141a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_W1_141a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_W1_141a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_W1_141a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_W1_141a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_W1_141a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_W1_141a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_W1_141a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_W1_141a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_W1_141a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_W1_141a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_W1_141a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_W1_141a_0_34 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_W1_C1c_0_34)))
                 (at end (not_occupied seg_W1_C1c_0_34))
                 (at start (not (at-segment ?a seg_W1_C1c_0_34)))

                 (at start (occupied seg_W1_141a_0_34))
                 (at start (not (not_occupied seg_W1_141a_0_34)))
                 (at start (blocked seg_W1_141a_0_34 ?a))
                 (at start (not (not_blocked seg_W1_141a_0_34 ?a)))
                 (at end (at-segment ?a seg_W1_141a_0_34))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_W1_C1a_0_60 ?a)))
                 (at end (not_blocked seg_W1_C1a_0_60 ?a))
                 (at end (not (blocked seg_W1_C1b_0_60 ?a)))
                 (at end (not_blocked seg_W1_C1b_0_60 ?a))

                )
)

(:durative-action move_seg_W1_141a_0_34_seg_W1_141c_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_W1_141a_0_34))
                 (at start (not_occupied seg_W1_141c_0_34))
                 (at start (not_blocked seg_W1_141c_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_W1_141c_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_W1_141c_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_W1_141c_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_W1_141c_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_W1_141c_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_W1_141c_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_W1_141c_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_W1_141c_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_W1_141c_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_W1_141c_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_W1_141c_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_W1_141c_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_W1_141c_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_W1_141c_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_W1_141b_0_45))
              )

 :effect        (and
                 (at end (not (occupied seg_W1_141a_0_34)))
                 (at end (not_occupied seg_W1_141a_0_34))
                 (at start (not (at-segment ?a seg_W1_141a_0_34)))

                 (at start (occupied seg_W1_141c_0_34))
                 (at start (not (not_occupied seg_W1_141c_0_34)))
                 (at start (blocked seg_W1_141c_0_34 ?a))
                 (at start (not (not_blocked seg_W1_141c_0_34 ?a)))
                 (at end (at-segment ?a seg_W1_141c_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_W1_C1c_0_34 ?a)))
                 (at end (not_blocked seg_W1_C1c_0_34 ?a))

                 (at start (blocked seg_W1_141b_0_45 ?a))
                 (at start (not (not_blocked seg_W1_141b_0_45 ?a)))
                )
)

(:durative-action move_seg_W1_141c_0_34_seg_W1_142a_0_34_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_W1_141c_0_34))
                 (at start (not_occupied seg_W1_142a_0_34))
                 (at start (not_blocked seg_W1_142a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_W1_142a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_W1_142a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_W1_142a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_W1_142a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_W1_142a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_W1_142a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_W1_142a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_W1_142a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_W1_142a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_W1_142a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_W1_142a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_W1_142a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_W1_142a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_W1_142a_0_34 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_W1_141c_0_34)))
                 (at end (not_occupied seg_W1_141c_0_34))
                 (at start (not (at-segment ?a seg_W1_141c_0_34)))

                 (at start (occupied seg_W1_142a_0_34))
                 (at start (not (not_occupied seg_W1_142a_0_34)))
                 (at start (blocked seg_W1_142a_0_34 ?a))
                 (at start (not (not_blocked seg_W1_142a_0_34 ?a)))
                 (at end (at-segment ?a seg_W1_142a_0_34))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_W1_141a_0_34 ?a)))
                 (at end (not_blocked seg_W1_141a_0_34 ?a))
                 (at end (not (blocked seg_W1_141b_0_45 ?a)))
                 (at end (not_blocked seg_W1_141b_0_45 ?a))

                )
)

(:durative-action move_seg_W1_142a_0_34_seg_W1_142c_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_W1_142a_0_34))
                 (at start (not_occupied seg_W1_142c_0_34))
                 (at start (not_blocked seg_W1_142c_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_W1_142c_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_W1_142c_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_W1_142c_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_W1_142c_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_W1_142c_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_W1_142c_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_W1_142c_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_W1_142c_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_W1_142c_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_W1_142c_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_W1_142c_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_W1_142c_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_W1_142c_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_W1_142c_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_W1_142b_0_45))
              )

 :effect        (and
                 (at end (not (occupied seg_W1_142a_0_34)))
                 (at end (not_occupied seg_W1_142a_0_34))
                 (at start (not (at-segment ?a seg_W1_142a_0_34)))

                 (at start (occupied seg_W1_142c_0_34))
                 (at start (not (not_occupied seg_W1_142c_0_34)))
                 (at start (blocked seg_W1_142c_0_34 ?a))
                 (at start (not (not_blocked seg_W1_142c_0_34 ?a)))
                 (at end (at-segment ?a seg_W1_142c_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_W1_141c_0_34 ?a)))
                 (at end (not_blocked seg_W1_141c_0_34 ?a))

                 (at start (blocked seg_W1_142b_0_45 ?a))
                 (at start (not (not_blocked seg_W1_142b_0_45 ?a)))
                )
)

(:durative-action move_seg_W1_142c_0_34_seg_W1_143a_0_34_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_W1_142c_0_34))
                 (at start (not_occupied seg_W1_143a_0_34))
                 (at start (not_blocked seg_W1_143a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_W1_143a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_W1_143a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_W1_143a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_W1_143a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_W1_143a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_W1_143a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_W1_143a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_W1_143a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_W1_143a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_W1_143a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_W1_143a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_W1_143a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_W1_143a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_W1_143a_0_34 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_W1_142c_0_34)))
                 (at end (not_occupied seg_W1_142c_0_34))
                 (at start (not (at-segment ?a seg_W1_142c_0_34)))

                 (at start (occupied seg_W1_143a_0_34))
                 (at start (not (not_occupied seg_W1_143a_0_34)))
                 (at start (blocked seg_W1_143a_0_34 ?a))
                 (at start (not (not_blocked seg_W1_143a_0_34 ?a)))
                 (at end (at-segment ?a seg_W1_143a_0_34))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_W1_142a_0_34 ?a)))
                 (at end (not_blocked seg_W1_142a_0_34 ?a))
                 (at end (not (blocked seg_W1_142b_0_45 ?a)))
                 (at end (not_blocked seg_W1_142b_0_45 ?a))

                )
)

(:durative-action move_seg_W1_143a_0_34_seg_W1_143c_0_60_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_W1_143a_0_34))
                 (at start (not_occupied seg_W1_143c_0_60))
                 (at start (not_blocked seg_W1_143c_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_W1_143c_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_W1_143c_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_W1_143c_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_W1_143c_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_W1_143c_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_W1_143c_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_W1_143c_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_W1_143c_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_W1_143c_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_W1_143c_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_W1_143c_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_W1_143c_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_W1_143c_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_W1_143c_0_60 airplane_CFBE2))

                 (over all (not_occupied seg_W1_143b_0_45))
              )

 :effect        (and
                 (at end (not (occupied seg_W1_143a_0_34)))
                 (at end (not_occupied seg_W1_143a_0_34))
                 (at start (not (at-segment ?a seg_W1_143a_0_34)))

                 (at start (occupied seg_W1_143c_0_60))
                 (at start (not (not_occupied seg_W1_143c_0_60)))
                 (at start (blocked seg_W1_143c_0_60 ?a))
                 (at start (not (not_blocked seg_W1_143c_0_60 ?a)))
                 (at end (at-segment ?a seg_W1_143c_0_60))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_W1_142c_0_34 ?a)))
                 (at end (not_blocked seg_W1_142c_0_34 ?a))

                 (at start (blocked seg_W1_143b_0_45 ?a))
                 (at start (not (not_blocked seg_W1_143b_0_45 ?a)))
                )
)

(:durative-action move_seg_W1_143c_0_60_seg_W1_C2a_0_60_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_W1_143c_0_60))
                 (at start (not_occupied seg_W1_C2a_0_60))
                 (at start (not_blocked seg_W1_C2a_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_W1_C2a_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_W1_C2a_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_W1_C2a_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_W1_C2a_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_W1_C2a_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_W1_C2a_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_W1_C2a_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_W1_C2a_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_W1_C2a_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_W1_C2a_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_W1_C2a_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_W1_C2a_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_W1_C2a_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_W1_C2a_0_60 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_W1_143c_0_60)))
                 (at end (not_occupied seg_W1_143c_0_60))
                 (at start (not (at-segment ?a seg_W1_143c_0_60)))

                 (at start (occupied seg_W1_C2a_0_60))
                 (at start (not (not_occupied seg_W1_C2a_0_60)))
                 (at start (blocked seg_W1_C2a_0_60 ?a))
                 (at start (not (not_blocked seg_W1_C2a_0_60 ?a)))
                 (at end (at-segment ?a seg_W1_C2a_0_60))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_W1_143a_0_34 ?a)))
                 (at end (not_blocked seg_W1_143a_0_34 ?a))
                 (at end (not (blocked seg_W1_143b_0_45 ?a)))
                 (at end (not_blocked seg_W1_143b_0_45 ?a))

                )
)

(:durative-action move_seg_W1_C2a_0_60_seg_W1_C2c_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_W1_C2a_0_60))
                 (at start (not_occupied seg_W1_C2c_0_34))
                 (at start (not_blocked seg_W1_C2c_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_W1_C2c_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_W1_C2c_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_W1_C2c_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_W1_C2c_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_W1_C2c_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_W1_C2c_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_W1_C2c_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_W1_C2c_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_W1_C2c_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_W1_C2c_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_W1_C2c_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_W1_C2c_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_W1_C2c_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_W1_C2c_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_W1_C2b_0_60))
              )

 :effect        (and
                 (at end (not (occupied seg_W1_C2a_0_60)))
                 (at end (not_occupied seg_W1_C2a_0_60))
                 (at start (not (at-segment ?a seg_W1_C2a_0_60)))

                 (at start (occupied seg_W1_C2c_0_34))
                 (at start (not (not_occupied seg_W1_C2c_0_34)))
                 (at start (blocked seg_W1_C2c_0_34 ?a))
                 (at start (not (not_blocked seg_W1_C2c_0_34 ?a)))
                 (at end (at-segment ?a seg_W1_C2c_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_W1_143c_0_60 ?a)))
                 (at end (not_blocked seg_W1_143c_0_60 ?a))

                 (at start (blocked seg_W1_C2b_0_60 ?a))
                 (at start (not (not_blocked seg_W1_C2b_0_60 ?a)))
                )
)

(:durative-action move_seg_W1_C2c_0_34_seg_W1_151a_0_34_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_W1_C2c_0_34))
                 (at start (not_occupied seg_W1_151a_0_34))
                 (at start (not_blocked seg_W1_151a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_W1_151a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_W1_151a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_W1_151a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_W1_151a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_W1_151a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_W1_151a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_W1_151a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_W1_151a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_W1_151a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_W1_151a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_W1_151a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_W1_151a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_W1_151a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_W1_151a_0_34 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_W1_C2c_0_34)))
                 (at end (not_occupied seg_W1_C2c_0_34))
                 (at start (not (at-segment ?a seg_W1_C2c_0_34)))

                 (at start (occupied seg_W1_151a_0_34))
                 (at start (not (not_occupied seg_W1_151a_0_34)))
                 (at start (blocked seg_W1_151a_0_34 ?a))
                 (at start (not (not_blocked seg_W1_151a_0_34 ?a)))
                 (at end (at-segment ?a seg_W1_151a_0_34))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_W1_C2a_0_60 ?a)))
                 (at end (not_blocked seg_W1_C2a_0_60 ?a))
                 (at end (not (blocked seg_W1_C2b_0_60 ?a)))
                 (at end (not_blocked seg_W1_C2b_0_60 ?a))

                )
)

(:durative-action move_seg_W1_151a_0_34_seg_W1_151c_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_W1_151a_0_34))
                 (at start (not_occupied seg_W1_151c_0_34))
                 (at start (not_blocked seg_W1_151c_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_W1_151c_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_W1_151c_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_W1_151c_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_W1_151c_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_W1_151c_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_W1_151c_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_W1_151c_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_W1_151c_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_W1_151c_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_W1_151c_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_W1_151c_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_W1_151c_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_W1_151c_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_W1_151c_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_W1_151b_0_45))
              )

 :effect        (and
                 (at end (not (occupied seg_W1_151a_0_34)))
                 (at end (not_occupied seg_W1_151a_0_34))
                 (at start (not (at-segment ?a seg_W1_151a_0_34)))

                 (at start (occupied seg_W1_151c_0_34))
                 (at start (not (not_occupied seg_W1_151c_0_34)))
                 (at start (blocked seg_W1_151c_0_34 ?a))
                 (at start (not (not_blocked seg_W1_151c_0_34 ?a)))
                 (at end (at-segment ?a seg_W1_151c_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_W1_C2c_0_34 ?a)))
                 (at end (not_blocked seg_W1_C2c_0_34 ?a))

                 (at start (blocked seg_W1_151b_0_45 ?a))
                 (at start (not (not_blocked seg_W1_151b_0_45 ?a)))
                )
)

(:durative-action move_seg_W1_151c_0_34_seg_W1_152a_0_34_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_W1_151c_0_34))
                 (at start (not_occupied seg_W1_152a_0_34))
                 (at start (not_blocked seg_W1_152a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_W1_152a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_W1_152a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_W1_152a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_W1_152a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_W1_152a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_W1_152a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_W1_152a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_W1_152a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_W1_152a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_W1_152a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_W1_152a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_W1_152a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_W1_152a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_W1_152a_0_34 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_W1_151c_0_34)))
                 (at end (not_occupied seg_W1_151c_0_34))
                 (at start (not (at-segment ?a seg_W1_151c_0_34)))

                 (at start (occupied seg_W1_152a_0_34))
                 (at start (not (not_occupied seg_W1_152a_0_34)))
                 (at start (blocked seg_W1_152a_0_34 ?a))
                 (at start (not (not_blocked seg_W1_152a_0_34 ?a)))
                 (at end (at-segment ?a seg_W1_152a_0_34))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_W1_151a_0_34 ?a)))
                 (at end (not_blocked seg_W1_151a_0_34 ?a))
                 (at end (not (blocked seg_W1_151b_0_45 ?a)))
                 (at end (not_blocked seg_W1_151b_0_45 ?a))

                )
)

(:durative-action move_seg_W1_152a_0_34_seg_W1_152c_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_W1_152a_0_34))
                 (at start (not_occupied seg_W1_152c_0_34))
                 (at start (not_blocked seg_W1_152c_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_W1_152c_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_W1_152c_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_W1_152c_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_W1_152c_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_W1_152c_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_W1_152c_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_W1_152c_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_W1_152c_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_W1_152c_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_W1_152c_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_W1_152c_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_W1_152c_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_W1_152c_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_W1_152c_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_W1_152b_0_45))
              )

 :effect        (and
                 (at end (not (occupied seg_W1_152a_0_34)))
                 (at end (not_occupied seg_W1_152a_0_34))
                 (at start (not (at-segment ?a seg_W1_152a_0_34)))

                 (at start (occupied seg_W1_152c_0_34))
                 (at start (not (not_occupied seg_W1_152c_0_34)))
                 (at start (blocked seg_W1_152c_0_34 ?a))
                 (at start (not (not_blocked seg_W1_152c_0_34 ?a)))
                 (at end (at-segment ?a seg_W1_152c_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_W1_151c_0_34 ?a)))
                 (at end (not_blocked seg_W1_151c_0_34 ?a))

                 (at start (blocked seg_W1_152b_0_45 ?a))
                 (at start (not (not_blocked seg_W1_152b_0_45 ?a)))
                )
)

(:durative-action move_seg_W1_152c_0_34_seg_W1_153a_0_34_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_W1_152c_0_34))
                 (at start (not_occupied seg_W1_153a_0_34))
                 (at start (not_blocked seg_W1_153a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_W1_153a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_W1_153a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_W1_153a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_W1_153a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_W1_153a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_W1_153a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_W1_153a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_W1_153a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_W1_153a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_W1_153a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_W1_153a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_W1_153a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_W1_153a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_W1_153a_0_34 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_W1_152c_0_34)))
                 (at end (not_occupied seg_W1_152c_0_34))
                 (at start (not (at-segment ?a seg_W1_152c_0_34)))

                 (at start (occupied seg_W1_153a_0_34))
                 (at start (not (not_occupied seg_W1_153a_0_34)))
                 (at start (blocked seg_W1_153a_0_34 ?a))
                 (at start (not (not_blocked seg_W1_153a_0_34 ?a)))
                 (at end (at-segment ?a seg_W1_153a_0_34))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_W1_152a_0_34 ?a)))
                 (at end (not_blocked seg_W1_152a_0_34 ?a))
                 (at end (not (blocked seg_W1_152b_0_45 ?a)))
                 (at end (not_blocked seg_W1_152b_0_45 ?a))

                )
)

(:durative-action move_seg_W1_153a_0_34_seg_W1_153c_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_W1_153a_0_34))
                 (at start (not_occupied seg_W1_153c_0_34))
                 (at start (not_blocked seg_W1_153c_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_W1_153c_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_W1_153c_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_W1_153c_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_W1_153c_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_W1_153c_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_W1_153c_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_W1_153c_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_W1_153c_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_W1_153c_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_W1_153c_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_W1_153c_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_W1_153c_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_W1_153c_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_W1_153c_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_W1_153b_0_45))
              )

 :effect        (and
                 (at end (not (occupied seg_W1_153a_0_34)))
                 (at end (not_occupied seg_W1_153a_0_34))
                 (at start (not (at-segment ?a seg_W1_153a_0_34)))

                 (at start (occupied seg_W1_153c_0_34))
                 (at start (not (not_occupied seg_W1_153c_0_34)))
                 (at start (blocked seg_W1_153c_0_34 ?a))
                 (at start (not (not_blocked seg_W1_153c_0_34 ?a)))
                 (at end (at-segment ?a seg_W1_153c_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_W1_152c_0_34 ?a)))
                 (at end (not_blocked seg_W1_152c_0_34 ?a))

                 (at start (blocked seg_W1_153b_0_45 ?a))
                 (at start (not (not_blocked seg_W1_153b_0_45 ?a)))
                )
)

(:durative-action move_seg_W1_153c_0_34_seg_W1_154a_0_34_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_W1_153c_0_34))
                 (at start (not_occupied seg_W1_154a_0_34))
                 (at start (not_blocked seg_W1_154a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_W1_154a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_W1_154a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_W1_154a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_W1_154a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_W1_154a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_W1_154a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_W1_154a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_W1_154a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_W1_154a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_W1_154a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_W1_154a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_W1_154a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_W1_154a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_W1_154a_0_34 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_W1_153c_0_34)))
                 (at end (not_occupied seg_W1_153c_0_34))
                 (at start (not (at-segment ?a seg_W1_153c_0_34)))

                 (at start (occupied seg_W1_154a_0_34))
                 (at start (not (not_occupied seg_W1_154a_0_34)))
                 (at start (blocked seg_W1_154a_0_34 ?a))
                 (at start (not (not_blocked seg_W1_154a_0_34 ?a)))
                 (at end (at-segment ?a seg_W1_154a_0_34))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_W1_153a_0_34 ?a)))
                 (at end (not_blocked seg_W1_153a_0_34 ?a))
                 (at end (not (blocked seg_W1_153b_0_45 ?a)))
                 (at end (not_blocked seg_W1_153b_0_45 ?a))

                )
)

(:durative-action move_seg_W1_154a_0_34_seg_W1_154c_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_W1_154a_0_34))
                 (at start (not_occupied seg_W1_154c_0_34))
                 (at start (not_blocked seg_W1_154c_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_W1_154c_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_W1_154c_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_W1_154c_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_W1_154c_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_W1_154c_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_W1_154c_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_W1_154c_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_W1_154c_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_W1_154c_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_W1_154c_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_W1_154c_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_W1_154c_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_W1_154c_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_W1_154c_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_W1_154b_0_45))
              )

 :effect        (and
                 (at end (not (occupied seg_W1_154a_0_34)))
                 (at end (not_occupied seg_W1_154a_0_34))
                 (at start (not (at-segment ?a seg_W1_154a_0_34)))

                 (at start (occupied seg_W1_154c_0_34))
                 (at start (not (not_occupied seg_W1_154c_0_34)))
                 (at start (blocked seg_W1_154c_0_34 ?a))
                 (at start (not (not_blocked seg_W1_154c_0_34 ?a)))
                 (at end (at-segment ?a seg_W1_154c_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_W1_153c_0_34 ?a)))
                 (at end (not_blocked seg_W1_153c_0_34 ?a))

                 (at start (blocked seg_W1_154b_0_45 ?a))
                 (at start (not (not_blocked seg_W1_154b_0_45 ?a)))
                )
)

(:durative-action move_seg_W1_154c_0_34_seg_W1_C3a_0_34_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_W1_154c_0_34))
                 (at start (not_occupied seg_W1_C3a_0_34))
                 (at start (not_blocked seg_W1_C3a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_W1_C3a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_W1_C3a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_W1_C3a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_W1_C3a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_W1_C3a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_W1_C3a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_W1_C3a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_W1_C3a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_W1_C3a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_W1_C3a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_W1_C3a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_W1_C3a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_W1_C3a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_W1_C3a_0_34 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_W1_154c_0_34)))
                 (at end (not_occupied seg_W1_154c_0_34))
                 (at start (not (at-segment ?a seg_W1_154c_0_34)))

                 (at start (occupied seg_W1_C3a_0_34))
                 (at start (not (not_occupied seg_W1_C3a_0_34)))
                 (at start (blocked seg_W1_C3a_0_34 ?a))
                 (at start (not (not_blocked seg_W1_C3a_0_34 ?a)))
                 (at end (at-segment ?a seg_W1_C3a_0_34))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_W1_154a_0_34 ?a)))
                 (at end (not_blocked seg_W1_154a_0_34 ?a))
                 (at end (not (blocked seg_W1_154b_0_45 ?a)))
                 (at end (not_blocked seg_W1_154b_0_45 ?a))

                )
)

(:durative-action move_seg_W1_C3a_0_34_seg_W1_C3c_0_48_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_W1_C3a_0_34))
                 (at start (not_occupied seg_W1_C3c_0_48))
                 (at start (not_blocked seg_W1_C3c_0_48 airplane_CFBEG))
                 (at start (not_blocked seg_W1_C3c_0_48 airplane_CFBE1))
                 (at start (not_blocked seg_W1_C3c_0_48 airplane_CFBE3))
                 (at start (not_blocked seg_W1_C3c_0_48 airplane_DAEW8))
                 (at start (not_blocked seg_W1_C3c_0_48 airplane_DAEW9))
                 (at start (not_blocked seg_W1_C3c_0_48 airplane_DAEW0))
                 (at start (not_blocked seg_W1_C3c_0_48 airplane_DAEW3))
                 (at start (not_blocked seg_W1_C3c_0_48 airplane_DAEWH))
                 (at start (not_blocked seg_W1_C3c_0_48 airplane_DAEW1))
                 (at start (not_blocked seg_W1_C3c_0_48 airplane_DAEW2))
                 (at start (not_blocked seg_W1_C3c_0_48 airplane_DAEW4))
                 (at start (not_blocked seg_W1_C3c_0_48 airplane_DAEW5))
                 (at start (not_blocked seg_W1_C3c_0_48 airplane_DAEW6))
                 (at start (not_blocked seg_W1_C3c_0_48 airplane_DAEW7))
                 (at start (not_blocked seg_W1_C3c_0_48 airplane_CFBE2))

                 (over all (not_occupied seg_W1_C3b_0_60))
              )

 :effect        (and
                 (at end (not (occupied seg_W1_C3a_0_34)))
                 (at end (not_occupied seg_W1_C3a_0_34))
                 (at start (not (at-segment ?a seg_W1_C3a_0_34)))

                 (at start (occupied seg_W1_C3c_0_48))
                 (at start (not (not_occupied seg_W1_C3c_0_48)))
                 (at start (blocked seg_W1_C3c_0_48 ?a))
                 (at start (not (not_blocked seg_W1_C3c_0_48 ?a)))
                 (at end (at-segment ?a seg_W1_C3c_0_48))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_W1_154c_0_34 ?a)))
                 (at end (not_blocked seg_W1_154c_0_34 ?a))

                 (at start (blocked seg_W1_C3b_0_60 ?a))
                 (at start (not (not_blocked seg_W1_C3b_0_60 ?a)))
                )
)

(:durative-action move_seg_W1_C3c_0_48_seg_W1_161a_0_34_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_W1_C3c_0_48))
                 (at start (not_occupied seg_W1_161a_0_34))
                 (at start (not_blocked seg_W1_161a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_W1_161a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_W1_161a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_W1_161a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_W1_161a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_W1_161a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_W1_161a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_W1_161a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_W1_161a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_W1_161a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_W1_161a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_W1_161a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_W1_161a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_W1_161a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_W1_161a_0_34 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_W1_C3c_0_48)))
                 (at end (not_occupied seg_W1_C3c_0_48))
                 (at start (not (at-segment ?a seg_W1_C3c_0_48)))

                 (at start (occupied seg_W1_161a_0_34))
                 (at start (not (not_occupied seg_W1_161a_0_34)))
                 (at start (blocked seg_W1_161a_0_34 ?a))
                 (at start (not (not_blocked seg_W1_161a_0_34 ?a)))
                 (at end (at-segment ?a seg_W1_161a_0_34))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_W1_C3a_0_34 ?a)))
                 (at end (not_blocked seg_W1_C3a_0_34 ?a))
                 (at end (not (blocked seg_W1_C3b_0_60 ?a)))
                 (at end (not_blocked seg_W1_C3b_0_60 ?a))

                )
)

(:durative-action move_seg_W1_161a_0_34_seg_W1_161c_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_W1_161a_0_34))
                 (at start (not_occupied seg_W1_161c_0_34))
                 (at start (not_blocked seg_W1_161c_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_W1_161c_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_W1_161c_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_W1_161c_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_W1_161c_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_W1_161c_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_W1_161c_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_W1_161c_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_W1_161c_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_W1_161c_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_W1_161c_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_W1_161c_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_W1_161c_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_W1_161c_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_W1_161c_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_W1_161b_0_45))
              )

 :effect        (and
                 (at end (not (occupied seg_W1_161a_0_34)))
                 (at end (not_occupied seg_W1_161a_0_34))
                 (at start (not (at-segment ?a seg_W1_161a_0_34)))

                 (at start (occupied seg_W1_161c_0_34))
                 (at start (not (not_occupied seg_W1_161c_0_34)))
                 (at start (blocked seg_W1_161c_0_34 ?a))
                 (at start (not (not_blocked seg_W1_161c_0_34 ?a)))
                 (at end (at-segment ?a seg_W1_161c_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_W1_C3c_0_48 ?a)))
                 (at end (not_blocked seg_W1_C3c_0_48 ?a))

                 (at start (blocked seg_W1_161b_0_45 ?a))
                 (at start (not (not_blocked seg_W1_161b_0_45 ?a)))
                )
)

(:durative-action move_seg_W1_161c_0_34_seg_W1_162a_0_34_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_W1_161c_0_34))
                 (at start (not_occupied seg_W1_162a_0_34))
                 (at start (not_blocked seg_W1_162a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_W1_162a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_W1_162a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_W1_162a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_W1_162a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_W1_162a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_W1_162a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_W1_162a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_W1_162a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_W1_162a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_W1_162a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_W1_162a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_W1_162a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_W1_162a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_W1_162a_0_34 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_W1_161c_0_34)))
                 (at end (not_occupied seg_W1_161c_0_34))
                 (at start (not (at-segment ?a seg_W1_161c_0_34)))

                 (at start (occupied seg_W1_162a_0_34))
                 (at start (not (not_occupied seg_W1_162a_0_34)))
                 (at start (blocked seg_W1_162a_0_34 ?a))
                 (at start (not (not_blocked seg_W1_162a_0_34 ?a)))
                 (at end (at-segment ?a seg_W1_162a_0_34))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_W1_161a_0_34 ?a)))
                 (at end (not_blocked seg_W1_161a_0_34 ?a))
                 (at end (not (blocked seg_W1_161b_0_45 ?a)))
                 (at end (not_blocked seg_W1_161b_0_45 ?a))

                )
)

(:durative-action move_seg_W1_162a_0_34_seg_W1_162c_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_W1_162a_0_34))
                 (at start (not_occupied seg_W1_162c_0_34))
                 (at start (not_blocked seg_W1_162c_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_W1_162c_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_W1_162c_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_W1_162c_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_W1_162c_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_W1_162c_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_W1_162c_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_W1_162c_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_W1_162c_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_W1_162c_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_W1_162c_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_W1_162c_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_W1_162c_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_W1_162c_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_W1_162c_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_W1_162b_0_45))
              )

 :effect        (and
                 (at end (not (occupied seg_W1_162a_0_34)))
                 (at end (not_occupied seg_W1_162a_0_34))
                 (at start (not (at-segment ?a seg_W1_162a_0_34)))

                 (at start (occupied seg_W1_162c_0_34))
                 (at start (not (not_occupied seg_W1_162c_0_34)))
                 (at start (blocked seg_W1_162c_0_34 ?a))
                 (at start (not (not_blocked seg_W1_162c_0_34 ?a)))
                 (at end (at-segment ?a seg_W1_162c_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_W1_161c_0_34 ?a)))
                 (at end (not_blocked seg_W1_161c_0_34 ?a))

                 (at start (blocked seg_W1_162b_0_45 ?a))
                 (at start (not (not_blocked seg_W1_162b_0_45 ?a)))
                )
)

(:durative-action move_seg_W1_162c_0_34_seg_W1_163a_0_34_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_W1_162c_0_34))
                 (at start (not_occupied seg_W1_163a_0_34))
                 (at start (not_blocked seg_W1_163a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_W1_163a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_W1_163a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_W1_163a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_W1_163a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_W1_163a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_W1_163a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_W1_163a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_W1_163a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_W1_163a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_W1_163a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_W1_163a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_W1_163a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_W1_163a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_W1_163a_0_34 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_W1_162c_0_34)))
                 (at end (not_occupied seg_W1_162c_0_34))
                 (at start (not (at-segment ?a seg_W1_162c_0_34)))

                 (at start (occupied seg_W1_163a_0_34))
                 (at start (not (not_occupied seg_W1_163a_0_34)))
                 (at start (blocked seg_W1_163a_0_34 ?a))
                 (at start (not (not_blocked seg_W1_163a_0_34 ?a)))
                 (at end (at-segment ?a seg_W1_163a_0_34))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_W1_162a_0_34 ?a)))
                 (at end (not_blocked seg_W1_162a_0_34 ?a))
                 (at end (not (blocked seg_W1_162b_0_45 ?a)))
                 (at end (not_blocked seg_W1_162b_0_45 ?a))

                )
)

(:durative-action move_seg_W1_163a_0_34_seg_W1_163c_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_W1_163a_0_34))
                 (at start (not_occupied seg_W1_163c_0_34))
                 (at start (not_blocked seg_W1_163c_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_W1_163c_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_W1_163c_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_W1_163c_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_W1_163c_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_W1_163c_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_W1_163c_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_W1_163c_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_W1_163c_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_W1_163c_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_W1_163c_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_W1_163c_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_W1_163c_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_W1_163c_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_W1_163c_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_W1_163b_0_45))
              )

 :effect        (and
                 (at end (not (occupied seg_W1_163a_0_34)))
                 (at end (not_occupied seg_W1_163a_0_34))
                 (at start (not (at-segment ?a seg_W1_163a_0_34)))

                 (at start (occupied seg_W1_163c_0_34))
                 (at start (not (not_occupied seg_W1_163c_0_34)))
                 (at start (blocked seg_W1_163c_0_34 ?a))
                 (at start (not (not_blocked seg_W1_163c_0_34 ?a)))
                 (at end (at-segment ?a seg_W1_163c_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_W1_162c_0_34 ?a)))
                 (at end (not_blocked seg_W1_162c_0_34 ?a))

                 (at start (blocked seg_W1_163b_0_45 ?a))
                 (at start (not (not_blocked seg_W1_163b_0_45 ?a)))
                )
)

(:durative-action move_seg_W1_163c_0_34_seg_W1_164a_0_34_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_W1_163c_0_34))
                 (at start (not_occupied seg_W1_164a_0_34))
                 (at start (not_blocked seg_W1_164a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_W1_164a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_W1_164a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_W1_164a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_W1_164a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_W1_164a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_W1_164a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_W1_164a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_W1_164a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_W1_164a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_W1_164a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_W1_164a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_W1_164a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_W1_164a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_W1_164a_0_34 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_W1_163c_0_34)))
                 (at end (not_occupied seg_W1_163c_0_34))
                 (at start (not (at-segment ?a seg_W1_163c_0_34)))

                 (at start (occupied seg_W1_164a_0_34))
                 (at start (not (not_occupied seg_W1_164a_0_34)))
                 (at start (blocked seg_W1_164a_0_34 ?a))
                 (at start (not (not_blocked seg_W1_164a_0_34 ?a)))
                 (at end (at-segment ?a seg_W1_164a_0_34))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_W1_163a_0_34 ?a)))
                 (at end (not_blocked seg_W1_163a_0_34 ?a))
                 (at end (not (blocked seg_W1_163b_0_45 ?a)))
                 (at end (not_blocked seg_W1_163b_0_45 ?a))

                )
)

(:durative-action move_seg_W1_164a_0_34_seg_W1_164c_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_W1_164a_0_34))
                 (at start (not_occupied seg_W1_164c_0_34))
                 (at start (not_blocked seg_W1_164c_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_W1_164c_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_W1_164c_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_W1_164c_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_W1_164c_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_W1_164c_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_W1_164c_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_W1_164c_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_W1_164c_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_W1_164c_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_W1_164c_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_W1_164c_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_W1_164c_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_W1_164c_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_W1_164c_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_W1_164b_0_45))
              )

 :effect        (and
                 (at end (not (occupied seg_W1_164a_0_34)))
                 (at end (not_occupied seg_W1_164a_0_34))
                 (at start (not (at-segment ?a seg_W1_164a_0_34)))

                 (at start (occupied seg_W1_164c_0_34))
                 (at start (not (not_occupied seg_W1_164c_0_34)))
                 (at start (blocked seg_W1_164c_0_34 ?a))
                 (at start (not (not_blocked seg_W1_164c_0_34 ?a)))
                 (at end (at-segment ?a seg_W1_164c_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_W1_163c_0_34 ?a)))
                 (at end (not_blocked seg_W1_163c_0_34 ?a))

                 (at start (blocked seg_W1_164b_0_45 ?a))
                 (at start (not (not_blocked seg_W1_164b_0_45 ?a)))
                )
)

(:durative-action move_seg_W1_164c_0_34_seg_W1_C4a_0_34_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_W1_164c_0_34))
                 (at start (not_occupied seg_W1_C4a_0_34))
                 (at start (not_blocked seg_W1_C4a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_W1_C4a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_W1_C4a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_W1_C4a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_W1_C4a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_W1_C4a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_W1_C4a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_W1_C4a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_W1_C4a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_W1_C4a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_W1_C4a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_W1_C4a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_W1_C4a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_W1_C4a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_W1_C4a_0_34 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_W1_164c_0_34)))
                 (at end (not_occupied seg_W1_164c_0_34))
                 (at start (not (at-segment ?a seg_W1_164c_0_34)))

                 (at start (occupied seg_W1_C4a_0_34))
                 (at start (not (not_occupied seg_W1_C4a_0_34)))
                 (at start (blocked seg_W1_C4a_0_34 ?a))
                 (at start (not (not_blocked seg_W1_C4a_0_34 ?a)))
                 (at end (at-segment ?a seg_W1_C4a_0_34))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_W1_164a_0_34 ?a)))
                 (at end (not_blocked seg_W1_164a_0_34 ?a))
                 (at end (not (blocked seg_W1_164b_0_45 ?a)))
                 (at end (not_blocked seg_W1_164b_0_45 ?a))

                )
)

(:durative-action move_seg_W1_C4a_0_34_seg_W1_C4c_0_60_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_W1_C4a_0_34))
                 (at start (not_occupied seg_W1_C4c_0_60))
                 (at start (not_blocked seg_W1_C4c_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_W1_C4c_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_W1_C4c_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_W1_C4c_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_W1_C4c_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_W1_C4c_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_W1_C4c_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_W1_C4c_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_W1_C4c_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_W1_C4c_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_W1_C4c_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_W1_C4c_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_W1_C4c_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_W1_C4c_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_W1_C4c_0_60 airplane_CFBE2))

                 (over all (not_occupied seg_W1_C4b_0_60))
              )

 :effect        (and
                 (at end (not (occupied seg_W1_C4a_0_34)))
                 (at end (not_occupied seg_W1_C4a_0_34))
                 (at start (not (at-segment ?a seg_W1_C4a_0_34)))

                 (at start (occupied seg_W1_C4c_0_60))
                 (at start (not (not_occupied seg_W1_C4c_0_60)))
                 (at start (blocked seg_W1_C4c_0_60 ?a))
                 (at start (not (not_blocked seg_W1_C4c_0_60 ?a)))
                 (at end (at-segment ?a seg_W1_C4c_0_60))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_W1_164c_0_34 ?a)))
                 (at end (not_blocked seg_W1_164c_0_34 ?a))

                 (at start (blocked seg_W1_C4b_0_60 ?a))
                 (at start (not (not_blocked seg_W1_C4b_0_60 ?a)))
                )
)

(:durative-action move_seg_W1_C4c_0_60_seg_S5_0_94_south_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_W1_C4c_0_60))
                 (at start (not_occupied seg_S5_0_94))
                 (at start (not_blocked seg_S5_0_94 airplane_CFBEG))
                 (at start (not_blocked seg_S5_0_94 airplane_CFBE1))
                 (at start (not_blocked seg_S5_0_94 airplane_CFBE3))
                 (at start (not_blocked seg_S5_0_94 airplane_DAEW8))
                 (at start (not_blocked seg_S5_0_94 airplane_DAEW9))
                 (at start (not_blocked seg_S5_0_94 airplane_DAEW0))
                 (at start (not_blocked seg_S5_0_94 airplane_DAEW3))
                 (at start (not_blocked seg_S5_0_94 airplane_DAEWH))
                 (at start (not_blocked seg_S5_0_94 airplane_DAEW1))
                 (at start (not_blocked seg_S5_0_94 airplane_DAEW2))
                 (at start (not_blocked seg_S5_0_94 airplane_DAEW4))
                 (at start (not_blocked seg_S5_0_94 airplane_DAEW5))
                 (at start (not_blocked seg_S5_0_94 airplane_DAEW6))
                 (at start (not_blocked seg_S5_0_94 airplane_DAEW7))
                 (at start (not_blocked seg_S5_0_94 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_W1_C4c_0_60)))
                 (at end (not_occupied seg_W1_C4c_0_60))
                 (at start (not (at-segment ?a seg_W1_C4c_0_60)))

                 (at start (occupied seg_S5_0_94))
                 (at start (not (not_occupied seg_S5_0_94)))
                 (at start (blocked seg_S5_0_94 ?a))
                 (at start (not (not_blocked seg_S5_0_94 ?a)))
                 (at end (at-segment ?a seg_S5_0_94))

                 (at end (not (blocked seg_W1_C4a_0_34 ?a)))
                 (at end (not_blocked seg_W1_C4a_0_34 ?a))
                 (at end (not (blocked seg_W1_C4b_0_60 ?a)))
                 (at end (not_blocked seg_W1_C4b_0_60 ?a))

                )
)

(:durative-action move_seg_S5_0_94_seg_S_B7a_0_60_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 3)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_S5_0_94))
                 (at start (not_occupied seg_S_B7a_0_60))
                 (at start (not_blocked seg_S_B7a_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_S_B7a_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_S_B7a_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_S_B7a_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_S_B7a_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_S_B7a_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_S_B7a_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_S_B7a_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_S_B7a_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_S_B7a_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_S_B7a_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_S_B7a_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_S_B7a_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_S_B7a_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_S_B7a_0_60 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_S5_0_94)))
                 (at end (not_occupied seg_S5_0_94))
                 (at start (not (at-segment ?a seg_S5_0_94)))

                 (at start (occupied seg_S_B7a_0_60))
                 (at start (not (not_occupied seg_S_B7a_0_60)))
                 (at start (blocked seg_S_B7a_0_60 ?a))
                 (at start (not (not_blocked seg_S_B7a_0_60 ?a)))
                 (at end (at-segment ?a seg_S_B7a_0_60))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_W1_C4c_0_60 ?a)))
                 (at end (not_blocked seg_W1_C4c_0_60 ?a))

                )
)

(:durative-action move_seg_S_B7a_0_60_seg_S_B7d_0_60_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_S_B7a_0_60))
                 (at start (not_occupied seg_S_B7d_0_60))
                 (at start (not_blocked seg_S_B7d_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_S_B7d_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_S_B7d_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_S_B7d_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_S_B7d_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_S_B7d_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_S_B7d_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_S_B7d_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_S_B7d_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_S_B7d_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_S_B7d_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_S_B7d_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_S_B7d_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_S_B7d_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_S_B7d_0_60 airplane_CFBE2))

                 (over all (not_occupied seg_S_B7b_0_60))
                 (over all (not_occupied seg_S_B7c_0_60))
              )

 :effect        (and
                 (at end (not (occupied seg_S_B7a_0_60)))
                 (at end (not_occupied seg_S_B7a_0_60))
                 (at start (not (at-segment ?a seg_S_B7a_0_60)))

                 (at start (occupied seg_S_B7d_0_60))
                 (at start (not (not_occupied seg_S_B7d_0_60)))
                 (at start (blocked seg_S_B7d_0_60 ?a))
                 (at start (not (not_blocked seg_S_B7d_0_60 ?a)))
                 (at end (at-segment ?a seg_S_B7d_0_60))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_S5_0_94 ?a)))
                 (at end (not_blocked seg_S5_0_94 ?a))

                 (at start (blocked seg_S_B7b_0_60 ?a))
                 (at start (not (not_blocked seg_S_B7b_0_60 ?a)))
                 (at start (blocked seg_S_B7c_0_60 ?a))
                 (at start (not (not_blocked seg_S_B7c_0_60 ?a)))
                )
)

(:durative-action move_seg_S_B7d_0_60_seg_S_B6B7b_0_140_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_S_B7d_0_60))
                 (at start (not_occupied seg_S_B6B7b_0_140))
                 (at start (not_blocked seg_S_B6B7b_0_140 airplane_CFBEG))
                 (at start (not_blocked seg_S_B6B7b_0_140 airplane_CFBE1))
                 (at start (not_blocked seg_S_B6B7b_0_140 airplane_CFBE3))
                 (at start (not_blocked seg_S_B6B7b_0_140 airplane_DAEW8))
                 (at start (not_blocked seg_S_B6B7b_0_140 airplane_DAEW9))
                 (at start (not_blocked seg_S_B6B7b_0_140 airplane_DAEW0))
                 (at start (not_blocked seg_S_B6B7b_0_140 airplane_DAEW3))
                 (at start (not_blocked seg_S_B6B7b_0_140 airplane_DAEWH))
                 (at start (not_blocked seg_S_B6B7b_0_140 airplane_DAEW1))
                 (at start (not_blocked seg_S_B6B7b_0_140 airplane_DAEW2))
                 (at start (not_blocked seg_S_B6B7b_0_140 airplane_DAEW4))
                 (at start (not_blocked seg_S_B6B7b_0_140 airplane_DAEW5))
                 (at start (not_blocked seg_S_B6B7b_0_140 airplane_DAEW6))
                 (at start (not_blocked seg_S_B6B7b_0_140 airplane_DAEW7))
                 (at start (not_blocked seg_S_B6B7b_0_140 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_S_B7d_0_60)))
                 (at end (not_occupied seg_S_B7d_0_60))
                 (at start (not (at-segment ?a seg_S_B7d_0_60)))

                 (at start (occupied seg_S_B6B7b_0_140))
                 (at start (not (not_occupied seg_S_B6B7b_0_140)))
                 (at start (blocked seg_S_B6B7b_0_140 ?a))
                 (at start (not (not_blocked seg_S_B6B7b_0_140 ?a)))
                 (at end (at-segment ?a seg_S_B6B7b_0_140))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_S_B7a_0_60 ?a)))
                 (at end (not_blocked seg_S_B7a_0_60 ?a))
                 (at end (not (blocked seg_S_B7b_0_60 ?a)))
                 (at end (not_blocked seg_S_B7b_0_60 ?a))
                 (at end (not (blocked seg_S_B7c_0_60 ?a)))
                 (at end (not_blocked seg_S_B7c_0_60 ?a))

                )
)

(:durative-action move_seg_S_B6B7b_0_140_seg_S_B6B7a_0_140_north_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 4)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_S_B6B7b_0_140))
                 (at start (not_occupied seg_S_B6B7a_0_140))
                 (at start (not_blocked seg_S_B6B7a_0_140 airplane_CFBEG))
                 (at start (not_blocked seg_S_B6B7a_0_140 airplane_CFBE1))
                 (at start (not_blocked seg_S_B6B7a_0_140 airplane_CFBE3))
                 (at start (not_blocked seg_S_B6B7a_0_140 airplane_DAEW8))
                 (at start (not_blocked seg_S_B6B7a_0_140 airplane_DAEW9))
                 (at start (not_blocked seg_S_B6B7a_0_140 airplane_DAEW0))
                 (at start (not_blocked seg_S_B6B7a_0_140 airplane_DAEW3))
                 (at start (not_blocked seg_S_B6B7a_0_140 airplane_DAEWH))
                 (at start (not_blocked seg_S_B6B7a_0_140 airplane_DAEW1))
                 (at start (not_blocked seg_S_B6B7a_0_140 airplane_DAEW2))
                 (at start (not_blocked seg_S_B6B7a_0_140 airplane_DAEW4))
                 (at start (not_blocked seg_S_B6B7a_0_140 airplane_DAEW5))
                 (at start (not_blocked seg_S_B6B7a_0_140 airplane_DAEW6))
                 (at start (not_blocked seg_S_B6B7a_0_140 airplane_DAEW7))
                 (at start (not_blocked seg_S_B6B7a_0_140 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_S_B6B7b_0_140)))
                 (at end (not_occupied seg_S_B6B7b_0_140))
                 (at start (not (at-segment ?a seg_S_B6B7b_0_140)))

                 (at start (occupied seg_S_B6B7a_0_140))
                 (at start (not (not_occupied seg_S_B6B7a_0_140)))
                 (at start (blocked seg_S_B6B7a_0_140 ?a))
                 (at start (not (not_blocked seg_S_B6B7a_0_140 ?a)))
                 (at end (at-segment ?a seg_S_B6B7a_0_140))

                 (at end (not (blocked seg_S_B7d_0_60 ?a)))
                 (at end (not_blocked seg_S_B7d_0_60 ?a))

                )
)

(:durative-action move_seg_S_B6B7a_0_140_seg_S_B6a_0_60_north_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 4)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_S_B6B7a_0_140))
                 (at start (not_occupied seg_S_B6a_0_60))
                 (at start (not_blocked seg_S_B6a_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_S_B6a_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_S_B6a_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_S_B6a_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_S_B6a_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_S_B6a_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_S_B6a_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_S_B6a_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_S_B6a_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_S_B6a_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_S_B6a_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_S_B6a_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_S_B6a_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_S_B6a_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_S_B6a_0_60 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_S_B6B7a_0_140)))
                 (at end (not_occupied seg_S_B6B7a_0_140))
                 (at start (not (at-segment ?a seg_S_B6B7a_0_140)))

                 (at start (occupied seg_S_B6a_0_60))
                 (at start (not (not_occupied seg_S_B6a_0_60)))
                 (at start (blocked seg_S_B6a_0_60 ?a))
                 (at start (not (not_blocked seg_S_B6a_0_60 ?a)))
                 (at end (at-segment ?a seg_S_B6a_0_60))

                 (at end (not (blocked seg_S_B6B7b_0_140 ?a)))
                 (at end (not_blocked seg_S_B6B7b_0_140 ?a))

                )
)

(:durative-action move_seg_S_B6a_0_60_seg_S_B6c_0_60_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_S_B6a_0_60))
                 (at start (not_occupied seg_S_B6c_0_60))
                 (at start (not_blocked seg_S_B6c_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_S_B6c_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_S_B6c_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_S_B6c_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_S_B6c_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_S_B6c_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_S_B6c_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_S_B6c_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_S_B6c_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_S_B6c_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_S_B6c_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_S_B6c_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_S_B6c_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_S_B6c_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_S_B6c_0_60 airplane_CFBE2))

                 (over all (not_occupied seg_S_B6b_0_60))
              )

 :effect        (and
                 (at end (not (occupied seg_S_B6a_0_60)))
                 (at end (not_occupied seg_S_B6a_0_60))
                 (at start (not (at-segment ?a seg_S_B6a_0_60)))

                 (at start (occupied seg_S_B6c_0_60))
                 (at start (not (not_occupied seg_S_B6c_0_60)))
                 (at start (blocked seg_S_B6c_0_60 ?a))
                 (at start (not (not_blocked seg_S_B6c_0_60 ?a)))
                 (at end (at-segment ?a seg_S_B6c_0_60))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_S_B6B7a_0_140 ?a)))
                 (at end (not_blocked seg_S_B6B7a_0_140 ?a))

                 (at start (blocked seg_S_B6b_0_60 ?a))
                 (at start (not (not_blocked seg_S_B6b_0_60 ?a)))
                )
)

(:durative-action move_seg_S_B6c_0_60_seg_S_B4B6c_0_130_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_S_B6c_0_60))
                 (at start (not_occupied seg_S_B4B6c_0_130))
                 (at start (not_blocked seg_S_B4B6c_0_130 airplane_CFBEG))
                 (at start (not_blocked seg_S_B4B6c_0_130 airplane_CFBE1))
                 (at start (not_blocked seg_S_B4B6c_0_130 airplane_CFBE3))
                 (at start (not_blocked seg_S_B4B6c_0_130 airplane_DAEW8))
                 (at start (not_blocked seg_S_B4B6c_0_130 airplane_DAEW9))
                 (at start (not_blocked seg_S_B4B6c_0_130 airplane_DAEW0))
                 (at start (not_blocked seg_S_B4B6c_0_130 airplane_DAEW3))
                 (at start (not_blocked seg_S_B4B6c_0_130 airplane_DAEWH))
                 (at start (not_blocked seg_S_B4B6c_0_130 airplane_DAEW1))
                 (at start (not_blocked seg_S_B4B6c_0_130 airplane_DAEW2))
                 (at start (not_blocked seg_S_B4B6c_0_130 airplane_DAEW4))
                 (at start (not_blocked seg_S_B4B6c_0_130 airplane_DAEW5))
                 (at start (not_blocked seg_S_B4B6c_0_130 airplane_DAEW6))
                 (at start (not_blocked seg_S_B4B6c_0_130 airplane_DAEW7))
                 (at start (not_blocked seg_S_B4B6c_0_130 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_S_B6c_0_60)))
                 (at end (not_occupied seg_S_B6c_0_60))
                 (at start (not (at-segment ?a seg_S_B6c_0_60)))

                 (at start (occupied seg_S_B4B6c_0_130))
                 (at start (not (not_occupied seg_S_B4B6c_0_130)))
                 (at start (blocked seg_S_B4B6c_0_130 ?a))
                 (at start (not (not_blocked seg_S_B4B6c_0_130 ?a)))
                 (at end (at-segment ?a seg_S_B4B6c_0_130))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_S_B6a_0_60 ?a)))
                 (at end (not_blocked seg_S_B6a_0_60 ?a))
                 (at end (not (blocked seg_S_B6b_0_60 ?a)))
                 (at end (not_blocked seg_S_B6b_0_60 ?a))

                )
)

(:durative-action move_seg_S_B4B6c_0_130_seg_S_B4B6b_0_135_north_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 4)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_S_B4B6c_0_130))
                 (at start (not_occupied seg_S_B4B6b_0_135))
                 (at start (not_blocked seg_S_B4B6b_0_135 airplane_CFBEG))
                 (at start (not_blocked seg_S_B4B6b_0_135 airplane_CFBE1))
                 (at start (not_blocked seg_S_B4B6b_0_135 airplane_CFBE3))
                 (at start (not_blocked seg_S_B4B6b_0_135 airplane_DAEW8))
                 (at start (not_blocked seg_S_B4B6b_0_135 airplane_DAEW9))
                 (at start (not_blocked seg_S_B4B6b_0_135 airplane_DAEW0))
                 (at start (not_blocked seg_S_B4B6b_0_135 airplane_DAEW3))
                 (at start (not_blocked seg_S_B4B6b_0_135 airplane_DAEWH))
                 (at start (not_blocked seg_S_B4B6b_0_135 airplane_DAEW1))
                 (at start (not_blocked seg_S_B4B6b_0_135 airplane_DAEW2))
                 (at start (not_blocked seg_S_B4B6b_0_135 airplane_DAEW4))
                 (at start (not_blocked seg_S_B4B6b_0_135 airplane_DAEW5))
                 (at start (not_blocked seg_S_B4B6b_0_135 airplane_DAEW6))
                 (at start (not_blocked seg_S_B4B6b_0_135 airplane_DAEW7))
                 (at start (not_blocked seg_S_B4B6b_0_135 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_S_B4B6c_0_130)))
                 (at end (not_occupied seg_S_B4B6c_0_130))
                 (at start (not (at-segment ?a seg_S_B4B6c_0_130)))

                 (at start (occupied seg_S_B4B6b_0_135))
                 (at start (not (not_occupied seg_S_B4B6b_0_135)))
                 (at start (blocked seg_S_B4B6b_0_135 ?a))
                 (at start (not (not_blocked seg_S_B4B6b_0_135 ?a)))
                 (at end (at-segment ?a seg_S_B4B6b_0_135))

                 (at end (not (blocked seg_S_B6c_0_60 ?a)))
                 (at end (not_blocked seg_S_B6c_0_60 ?a))

                )
)

(:durative-action move_seg_S_B4B6b_0_135_seg_S_B4B6a_0_135_north_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 4)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_S_B4B6b_0_135))
                 (at start (not_occupied seg_S_B4B6a_0_135))
                 (at start (not_blocked seg_S_B4B6a_0_135 airplane_CFBEG))
                 (at start (not_blocked seg_S_B4B6a_0_135 airplane_CFBE1))
                 (at start (not_blocked seg_S_B4B6a_0_135 airplane_CFBE3))
                 (at start (not_blocked seg_S_B4B6a_0_135 airplane_DAEW8))
                 (at start (not_blocked seg_S_B4B6a_0_135 airplane_DAEW9))
                 (at start (not_blocked seg_S_B4B6a_0_135 airplane_DAEW0))
                 (at start (not_blocked seg_S_B4B6a_0_135 airplane_DAEW3))
                 (at start (not_blocked seg_S_B4B6a_0_135 airplane_DAEWH))
                 (at start (not_blocked seg_S_B4B6a_0_135 airplane_DAEW1))
                 (at start (not_blocked seg_S_B4B6a_0_135 airplane_DAEW2))
                 (at start (not_blocked seg_S_B4B6a_0_135 airplane_DAEW4))
                 (at start (not_blocked seg_S_B4B6a_0_135 airplane_DAEW5))
                 (at start (not_blocked seg_S_B4B6a_0_135 airplane_DAEW6))
                 (at start (not_blocked seg_S_B4B6a_0_135 airplane_DAEW7))
                 (at start (not_blocked seg_S_B4B6a_0_135 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_S_B4B6b_0_135)))
                 (at end (not_occupied seg_S_B4B6b_0_135))
                 (at start (not (at-segment ?a seg_S_B4B6b_0_135)))

                 (at start (occupied seg_S_B4B6a_0_135))
                 (at start (not (not_occupied seg_S_B4B6a_0_135)))
                 (at start (blocked seg_S_B4B6a_0_135 ?a))
                 (at start (not (not_blocked seg_S_B4B6a_0_135 ?a)))
                 (at end (at-segment ?a seg_S_B4B6a_0_135))

                 (at end (not (blocked seg_S_B4B6c_0_130 ?a)))
                 (at end (not_blocked seg_S_B4B6c_0_130 ?a))

                )
)

(:durative-action move_seg_S_B4B6a_0_135_seg_S_B4a_0_60_north_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 4)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_S_B4B6a_0_135))
                 (at start (not_occupied seg_S_B4a_0_60))
                 (at start (not_blocked seg_S_B4a_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_S_B4a_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_S_B4a_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_S_B4a_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_S_B4a_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_S_B4a_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_S_B4a_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_S_B4a_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_S_B4a_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_S_B4a_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_S_B4a_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_S_B4a_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_S_B4a_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_S_B4a_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_S_B4a_0_60 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_S_B4B6a_0_135)))
                 (at end (not_occupied seg_S_B4B6a_0_135))
                 (at start (not (at-segment ?a seg_S_B4B6a_0_135)))

                 (at start (occupied seg_S_B4a_0_60))
                 (at start (not (not_occupied seg_S_B4a_0_60)))
                 (at start (blocked seg_S_B4a_0_60 ?a))
                 (at start (not (not_blocked seg_S_B4a_0_60 ?a)))
                 (at end (at-segment ?a seg_S_B4a_0_60))

                 (at end (not (blocked seg_S_B4B6b_0_135 ?a)))
                 (at end (not_blocked seg_S_B4B6b_0_135 ?a))

                )
)

(:durative-action move_seg_S_B4a_0_60_seg_S_B4c_0_60_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_S_B4a_0_60))
                 (at start (not_occupied seg_S_B4c_0_60))
                 (at start (not_blocked seg_S_B4c_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_S_B4c_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_S_B4c_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_S_B4c_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_S_B4c_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_S_B4c_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_S_B4c_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_S_B4c_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_S_B4c_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_S_B4c_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_S_B4c_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_S_B4c_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_S_B4c_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_S_B4c_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_S_B4c_0_60 airplane_CFBE2))

                 (over all (not_occupied seg_S_B4b_0_60))
              )

 :effect        (and
                 (at end (not (occupied seg_S_B4a_0_60)))
                 (at end (not_occupied seg_S_B4a_0_60))
                 (at start (not (at-segment ?a seg_S_B4a_0_60)))

                 (at start (occupied seg_S_B4c_0_60))
                 (at start (not (not_occupied seg_S_B4c_0_60)))
                 (at start (blocked seg_S_B4c_0_60 ?a))
                 (at start (not (not_blocked seg_S_B4c_0_60 ?a)))
                 (at end (at-segment ?a seg_S_B4c_0_60))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_S_B4B6a_0_135 ?a)))
                 (at end (not_blocked seg_S_B4B6a_0_135 ?a))

                 (at start (blocked seg_S_B4b_0_60 ?a))
                 (at start (not (not_blocked seg_S_B4b_0_60 ?a)))
                )
)

(:durative-action move_seg_S_B4c_0_60_seg_S_B3B4d_0_140_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_S_B4c_0_60))
                 (at start (not_occupied seg_S_B3B4d_0_140))
                 (at start (not_blocked seg_S_B3B4d_0_140 airplane_CFBEG))
                 (at start (not_blocked seg_S_B3B4d_0_140 airplane_CFBE1))
                 (at start (not_blocked seg_S_B3B4d_0_140 airplane_CFBE3))
                 (at start (not_blocked seg_S_B3B4d_0_140 airplane_DAEW8))
                 (at start (not_blocked seg_S_B3B4d_0_140 airplane_DAEW9))
                 (at start (not_blocked seg_S_B3B4d_0_140 airplane_DAEW0))
                 (at start (not_blocked seg_S_B3B4d_0_140 airplane_DAEW3))
                 (at start (not_blocked seg_S_B3B4d_0_140 airplane_DAEWH))
                 (at start (not_blocked seg_S_B3B4d_0_140 airplane_DAEW1))
                 (at start (not_blocked seg_S_B3B4d_0_140 airplane_DAEW2))
                 (at start (not_blocked seg_S_B3B4d_0_140 airplane_DAEW4))
                 (at start (not_blocked seg_S_B3B4d_0_140 airplane_DAEW5))
                 (at start (not_blocked seg_S_B3B4d_0_140 airplane_DAEW6))
                 (at start (not_blocked seg_S_B3B4d_0_140 airplane_DAEW7))
                 (at start (not_blocked seg_S_B3B4d_0_140 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_S_B4c_0_60)))
                 (at end (not_occupied seg_S_B4c_0_60))
                 (at start (not (at-segment ?a seg_S_B4c_0_60)))

                 (at start (occupied seg_S_B3B4d_0_140))
                 (at start (not (not_occupied seg_S_B3B4d_0_140)))
                 (at start (blocked seg_S_B3B4d_0_140 ?a))
                 (at start (not (not_blocked seg_S_B3B4d_0_140 ?a)))
                 (at end (at-segment ?a seg_S_B3B4d_0_140))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_S_B4a_0_60 ?a)))
                 (at end (not_blocked seg_S_B4a_0_60 ?a))
                 (at end (not (blocked seg_S_B4b_0_60 ?a)))
                 (at end (not_blocked seg_S_B4b_0_60 ?a))

                )
)

(:durative-action move_seg_S_B3B4d_0_140_seg_S_B3B4c_0_140_north_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 4)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_S_B3B4d_0_140))
                 (at start (not_occupied seg_S_B3B4c_0_140))
                 (at start (not_blocked seg_S_B3B4c_0_140 airplane_CFBEG))
                 (at start (not_blocked seg_S_B3B4c_0_140 airplane_CFBE1))
                 (at start (not_blocked seg_S_B3B4c_0_140 airplane_CFBE3))
                 (at start (not_blocked seg_S_B3B4c_0_140 airplane_DAEW8))
                 (at start (not_blocked seg_S_B3B4c_0_140 airplane_DAEW9))
                 (at start (not_blocked seg_S_B3B4c_0_140 airplane_DAEW0))
                 (at start (not_blocked seg_S_B3B4c_0_140 airplane_DAEW3))
                 (at start (not_blocked seg_S_B3B4c_0_140 airplane_DAEWH))
                 (at start (not_blocked seg_S_B3B4c_0_140 airplane_DAEW1))
                 (at start (not_blocked seg_S_B3B4c_0_140 airplane_DAEW2))
                 (at start (not_blocked seg_S_B3B4c_0_140 airplane_DAEW4))
                 (at start (not_blocked seg_S_B3B4c_0_140 airplane_DAEW5))
                 (at start (not_blocked seg_S_B3B4c_0_140 airplane_DAEW6))
                 (at start (not_blocked seg_S_B3B4c_0_140 airplane_DAEW7))
                 (at start (not_blocked seg_S_B3B4c_0_140 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_S_B3B4d_0_140)))
                 (at end (not_occupied seg_S_B3B4d_0_140))
                 (at start (not (at-segment ?a seg_S_B3B4d_0_140)))

                 (at start (occupied seg_S_B3B4c_0_140))
                 (at start (not (not_occupied seg_S_B3B4c_0_140)))
                 (at start (blocked seg_S_B3B4c_0_140 ?a))
                 (at start (not (not_blocked seg_S_B3B4c_0_140 ?a)))
                 (at end (at-segment ?a seg_S_B3B4c_0_140))

                 (at end (not (blocked seg_S_B4c_0_60 ?a)))
                 (at end (not_blocked seg_S_B4c_0_60 ?a))

                )
)

(:durative-action move_seg_S_B3B4c_0_140_seg_S_B3B4b_0_140_north_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 4)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_S_B3B4c_0_140))
                 (at start (not_occupied seg_S_B3B4b_0_140))
                 (at start (not_blocked seg_S_B3B4b_0_140 airplane_CFBEG))
                 (at start (not_blocked seg_S_B3B4b_0_140 airplane_CFBE1))
                 (at start (not_blocked seg_S_B3B4b_0_140 airplane_CFBE3))
                 (at start (not_blocked seg_S_B3B4b_0_140 airplane_DAEW8))
                 (at start (not_blocked seg_S_B3B4b_0_140 airplane_DAEW9))
                 (at start (not_blocked seg_S_B3B4b_0_140 airplane_DAEW0))
                 (at start (not_blocked seg_S_B3B4b_0_140 airplane_DAEW3))
                 (at start (not_blocked seg_S_B3B4b_0_140 airplane_DAEWH))
                 (at start (not_blocked seg_S_B3B4b_0_140 airplane_DAEW1))
                 (at start (not_blocked seg_S_B3B4b_0_140 airplane_DAEW2))
                 (at start (not_blocked seg_S_B3B4b_0_140 airplane_DAEW4))
                 (at start (not_blocked seg_S_B3B4b_0_140 airplane_DAEW5))
                 (at start (not_blocked seg_S_B3B4b_0_140 airplane_DAEW6))
                 (at start (not_blocked seg_S_B3B4b_0_140 airplane_DAEW7))
                 (at start (not_blocked seg_S_B3B4b_0_140 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_S_B3B4c_0_140)))
                 (at end (not_occupied seg_S_B3B4c_0_140))
                 (at start (not (at-segment ?a seg_S_B3B4c_0_140)))

                 (at start (occupied seg_S_B3B4b_0_140))
                 (at start (not (not_occupied seg_S_B3B4b_0_140)))
                 (at start (blocked seg_S_B3B4b_0_140 ?a))
                 (at start (not (not_blocked seg_S_B3B4b_0_140 ?a)))
                 (at end (at-segment ?a seg_S_B3B4b_0_140))

                 (at end (not (blocked seg_S_B3B4d_0_140 ?a)))
                 (at end (not_blocked seg_S_B3B4d_0_140 ?a))

                )
)

(:durative-action move_seg_S_B3B4b_0_140_seg_S_B3B4a_0_140_north_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 4)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_S_B3B4b_0_140))
                 (at start (not_occupied seg_S_B3B4a_0_140))
                 (at start (not_blocked seg_S_B3B4a_0_140 airplane_CFBEG))
                 (at start (not_blocked seg_S_B3B4a_0_140 airplane_CFBE1))
                 (at start (not_blocked seg_S_B3B4a_0_140 airplane_CFBE3))
                 (at start (not_blocked seg_S_B3B4a_0_140 airplane_DAEW8))
                 (at start (not_blocked seg_S_B3B4a_0_140 airplane_DAEW9))
                 (at start (not_blocked seg_S_B3B4a_0_140 airplane_DAEW0))
                 (at start (not_blocked seg_S_B3B4a_0_140 airplane_DAEW3))
                 (at start (not_blocked seg_S_B3B4a_0_140 airplane_DAEWH))
                 (at start (not_blocked seg_S_B3B4a_0_140 airplane_DAEW1))
                 (at start (not_blocked seg_S_B3B4a_0_140 airplane_DAEW2))
                 (at start (not_blocked seg_S_B3B4a_0_140 airplane_DAEW4))
                 (at start (not_blocked seg_S_B3B4a_0_140 airplane_DAEW5))
                 (at start (not_blocked seg_S_B3B4a_0_140 airplane_DAEW6))
                 (at start (not_blocked seg_S_B3B4a_0_140 airplane_DAEW7))
                 (at start (not_blocked seg_S_B3B4a_0_140 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_S_B3B4b_0_140)))
                 (at end (not_occupied seg_S_B3B4b_0_140))
                 (at start (not (at-segment ?a seg_S_B3B4b_0_140)))

                 (at start (occupied seg_S_B3B4a_0_140))
                 (at start (not (not_occupied seg_S_B3B4a_0_140)))
                 (at start (blocked seg_S_B3B4a_0_140 ?a))
                 (at start (not (not_blocked seg_S_B3B4a_0_140 ?a)))
                 (at end (at-segment ?a seg_S_B3B4a_0_140))

                 (at end (not (blocked seg_S_B3B4c_0_140 ?a)))
                 (at end (not_blocked seg_S_B3B4c_0_140 ?a))

                )
)

(:durative-action move_seg_S_B3B4a_0_140_seg_S_B3a_0_60_north_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 4)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_S_B3B4a_0_140))
                 (at start (not_occupied seg_S_B3a_0_60))
                 (at start (not_blocked seg_S_B3a_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_S_B3a_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_S_B3a_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_S_B3a_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_S_B3a_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_S_B3a_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_S_B3a_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_S_B3a_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_S_B3a_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_S_B3a_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_S_B3a_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_S_B3a_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_S_B3a_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_S_B3a_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_S_B3a_0_60 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_S_B3B4a_0_140)))
                 (at end (not_occupied seg_S_B3B4a_0_140))
                 (at start (not (at-segment ?a seg_S_B3B4a_0_140)))

                 (at start (occupied seg_S_B3a_0_60))
                 (at start (not (not_occupied seg_S_B3a_0_60)))
                 (at start (blocked seg_S_B3a_0_60 ?a))
                 (at start (not (not_blocked seg_S_B3a_0_60 ?a)))
                 (at end (at-segment ?a seg_S_B3a_0_60))

                 (at end (not (blocked seg_S_B3B4b_0_140 ?a)))
                 (at end (not_blocked seg_S_B3B4b_0_140 ?a))

                )
)

(:durative-action move_seg_S_B3a_0_60_seg_S_B3c_0_60_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_S_B3a_0_60))
                 (at start (not_occupied seg_S_B3c_0_60))
                 (at start (not_blocked seg_S_B3c_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_S_B3c_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_S_B3c_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_S_B3c_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_S_B3c_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_S_B3c_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_S_B3c_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_S_B3c_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_S_B3c_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_S_B3c_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_S_B3c_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_S_B3c_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_S_B3c_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_S_B3c_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_S_B3c_0_60 airplane_CFBE2))

                 (over all (not_occupied seg_S_B3b_0_60))
              )

 :effect        (and
                 (at end (not (occupied seg_S_B3a_0_60)))
                 (at end (not_occupied seg_S_B3a_0_60))
                 (at start (not (at-segment ?a seg_S_B3a_0_60)))

                 (at start (occupied seg_S_B3c_0_60))
                 (at start (not (not_occupied seg_S_B3c_0_60)))
                 (at start (blocked seg_S_B3c_0_60 ?a))
                 (at start (not (not_blocked seg_S_B3c_0_60 ?a)))
                 (at end (at-segment ?a seg_S_B3c_0_60))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_S_B3B4a_0_140 ?a)))
                 (at end (not_blocked seg_S_B3B4a_0_140 ?a))

                 (at start (blocked seg_S_B3b_0_60 ?a))
                 (at start (not (not_blocked seg_S_B3b_0_60 ?a)))
                )
)

(:durative-action move_seg_S_B3c_0_60_seg_S_B2B3c_0_140_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_S_B3c_0_60))
                 (at start (not_occupied seg_S_B2B3c_0_140))
                 (at start (not_blocked seg_S_B2B3c_0_140 airplane_CFBEG))
                 (at start (not_blocked seg_S_B2B3c_0_140 airplane_CFBE1))
                 (at start (not_blocked seg_S_B2B3c_0_140 airplane_CFBE3))
                 (at start (not_blocked seg_S_B2B3c_0_140 airplane_DAEW8))
                 (at start (not_blocked seg_S_B2B3c_0_140 airplane_DAEW9))
                 (at start (not_blocked seg_S_B2B3c_0_140 airplane_DAEW0))
                 (at start (not_blocked seg_S_B2B3c_0_140 airplane_DAEW3))
                 (at start (not_blocked seg_S_B2B3c_0_140 airplane_DAEWH))
                 (at start (not_blocked seg_S_B2B3c_0_140 airplane_DAEW1))
                 (at start (not_blocked seg_S_B2B3c_0_140 airplane_DAEW2))
                 (at start (not_blocked seg_S_B2B3c_0_140 airplane_DAEW4))
                 (at start (not_blocked seg_S_B2B3c_0_140 airplane_DAEW5))
                 (at start (not_blocked seg_S_B2B3c_0_140 airplane_DAEW6))
                 (at start (not_blocked seg_S_B2B3c_0_140 airplane_DAEW7))
                 (at start (not_blocked seg_S_B2B3c_0_140 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_S_B3c_0_60)))
                 (at end (not_occupied seg_S_B3c_0_60))
                 (at start (not (at-segment ?a seg_S_B3c_0_60)))

                 (at start (occupied seg_S_B2B3c_0_140))
                 (at start (not (not_occupied seg_S_B2B3c_0_140)))
                 (at start (blocked seg_S_B2B3c_0_140 ?a))
                 (at start (not (not_blocked seg_S_B2B3c_0_140 ?a)))
                 (at end (at-segment ?a seg_S_B2B3c_0_140))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_S_B3a_0_60 ?a)))
                 (at end (not_blocked seg_S_B3a_0_60 ?a))
                 (at end (not (blocked seg_S_B3b_0_60 ?a)))
                 (at end (not_blocked seg_S_B3b_0_60 ?a))

                )
)

(:durative-action move_seg_S_B2B3c_0_140_seg_S_B2B3b_0_140_north_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 4)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_S_B2B3c_0_140))
                 (at start (not_occupied seg_S_B2B3b_0_140))
                 (at start (not_blocked seg_S_B2B3b_0_140 airplane_CFBEG))
                 (at start (not_blocked seg_S_B2B3b_0_140 airplane_CFBE1))
                 (at start (not_blocked seg_S_B2B3b_0_140 airplane_CFBE3))
                 (at start (not_blocked seg_S_B2B3b_0_140 airplane_DAEW8))
                 (at start (not_blocked seg_S_B2B3b_0_140 airplane_DAEW9))
                 (at start (not_blocked seg_S_B2B3b_0_140 airplane_DAEW0))
                 (at start (not_blocked seg_S_B2B3b_0_140 airplane_DAEW3))
                 (at start (not_blocked seg_S_B2B3b_0_140 airplane_DAEWH))
                 (at start (not_blocked seg_S_B2B3b_0_140 airplane_DAEW1))
                 (at start (not_blocked seg_S_B2B3b_0_140 airplane_DAEW2))
                 (at start (not_blocked seg_S_B2B3b_0_140 airplane_DAEW4))
                 (at start (not_blocked seg_S_B2B3b_0_140 airplane_DAEW5))
                 (at start (not_blocked seg_S_B2B3b_0_140 airplane_DAEW6))
                 (at start (not_blocked seg_S_B2B3b_0_140 airplane_DAEW7))
                 (at start (not_blocked seg_S_B2B3b_0_140 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_S_B2B3c_0_140)))
                 (at end (not_occupied seg_S_B2B3c_0_140))
                 (at start (not (at-segment ?a seg_S_B2B3c_0_140)))

                 (at start (occupied seg_S_B2B3b_0_140))
                 (at start (not (not_occupied seg_S_B2B3b_0_140)))
                 (at start (blocked seg_S_B2B3b_0_140 ?a))
                 (at start (not (not_blocked seg_S_B2B3b_0_140 ?a)))
                 (at end (at-segment ?a seg_S_B2B3b_0_140))

                 (at end (not (blocked seg_S_B3c_0_60 ?a)))
                 (at end (not_blocked seg_S_B3c_0_60 ?a))

                )
)

(:durative-action move_seg_S_B2B3b_0_140_seg_S_B2B3a_0_140_north_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 4)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_S_B2B3b_0_140))
                 (at start (not_occupied seg_S_B2B3a_0_140))
                 (at start (not_blocked seg_S_B2B3a_0_140 airplane_CFBEG))
                 (at start (not_blocked seg_S_B2B3a_0_140 airplane_CFBE1))
                 (at start (not_blocked seg_S_B2B3a_0_140 airplane_CFBE3))
                 (at start (not_blocked seg_S_B2B3a_0_140 airplane_DAEW8))
                 (at start (not_blocked seg_S_B2B3a_0_140 airplane_DAEW9))
                 (at start (not_blocked seg_S_B2B3a_0_140 airplane_DAEW0))
                 (at start (not_blocked seg_S_B2B3a_0_140 airplane_DAEW3))
                 (at start (not_blocked seg_S_B2B3a_0_140 airplane_DAEWH))
                 (at start (not_blocked seg_S_B2B3a_0_140 airplane_DAEW1))
                 (at start (not_blocked seg_S_B2B3a_0_140 airplane_DAEW2))
                 (at start (not_blocked seg_S_B2B3a_0_140 airplane_DAEW4))
                 (at start (not_blocked seg_S_B2B3a_0_140 airplane_DAEW5))
                 (at start (not_blocked seg_S_B2B3a_0_140 airplane_DAEW6))
                 (at start (not_blocked seg_S_B2B3a_0_140 airplane_DAEW7))
                 (at start (not_blocked seg_S_B2B3a_0_140 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_S_B2B3b_0_140)))
                 (at end (not_occupied seg_S_B2B3b_0_140))
                 (at start (not (at-segment ?a seg_S_B2B3b_0_140)))

                 (at start (occupied seg_S_B2B3a_0_140))
                 (at start (not (not_occupied seg_S_B2B3a_0_140)))
                 (at start (blocked seg_S_B2B3a_0_140 ?a))
                 (at start (not (not_blocked seg_S_B2B3a_0_140 ?a)))
                 (at end (at-segment ?a seg_S_B2B3a_0_140))

                 (at end (not (blocked seg_S_B2B3c_0_140 ?a)))
                 (at end (not_blocked seg_S_B2B3c_0_140 ?a))

                )
)

(:durative-action move_seg_S_B2B3a_0_140_seg_S_B2a_0_60_north_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 4)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_S_B2B3a_0_140))
                 (at start (not_occupied seg_S_B2a_0_60))
                 (at start (not_blocked seg_S_B2a_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_S_B2a_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_S_B2a_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_S_B2a_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_S_B2a_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_S_B2a_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_S_B2a_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_S_B2a_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_S_B2a_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_S_B2a_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_S_B2a_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_S_B2a_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_S_B2a_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_S_B2a_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_S_B2a_0_60 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_S_B2B3a_0_140)))
                 (at end (not_occupied seg_S_B2B3a_0_140))
                 (at start (not (at-segment ?a seg_S_B2B3a_0_140)))

                 (at start (occupied seg_S_B2a_0_60))
                 (at start (not (not_occupied seg_S_B2a_0_60)))
                 (at start (blocked seg_S_B2a_0_60 ?a))
                 (at start (not (not_blocked seg_S_B2a_0_60 ?a)))
                 (at end (at-segment ?a seg_S_B2a_0_60))

                 (at end (not (blocked seg_S_B2B3b_0_140 ?a)))
                 (at end (not_blocked seg_S_B2B3b_0_140 ?a))

                )
)

(:durative-action move_seg_S_B2a_0_60_seg_S_B2b_0_60_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_S_B2a_0_60))
                 (at start (not_occupied seg_S_B2b_0_60))
                 (at start (not_blocked seg_S_B2b_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_S_B2b_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_S_B2b_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_S_B2b_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_S_B2b_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_S_B2b_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_S_B2b_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_S_B2b_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_S_B2b_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_S_B2b_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_S_B2b_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_S_B2b_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_S_B2b_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_S_B2b_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_S_B2b_0_60 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_S_B2a_0_60)))
                 (at end (not_occupied seg_S_B2a_0_60))
                 (at start (not (at-segment ?a seg_S_B2a_0_60)))

                 (at start (occupied seg_S_B2b_0_60))
                 (at start (not (not_occupied seg_S_B2b_0_60)))
                 (at start (blocked seg_S_B2b_0_60 ?a))
                 (at start (not (not_blocked seg_S_B2b_0_60 ?a)))
                 (at end (at-segment ?a seg_S_B2b_0_60))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_S_B2B3a_0_140 ?a)))
                 (at end (not_blocked seg_S_B2B3a_0_140 ?a))

                )
)

(:durative-action move_seg_S_B2b_0_60_seg_T_B2a_0_60_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_S_B2b_0_60))
                 (at start (not_occupied seg_T_B2a_0_60))
                 (at start (not_blocked seg_T_B2a_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_T_B2a_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_T_B2a_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_T_B2a_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_T_B2a_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_T_B2a_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_T_B2a_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_T_B2a_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_T_B2a_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_T_B2a_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_T_B2a_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_T_B2a_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_T_B2a_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_T_B2a_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_T_B2a_0_60 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_S_B2b_0_60)))
                 (at end (not_occupied seg_S_B2b_0_60))
                 (at start (not (at-segment ?a seg_S_B2b_0_60)))

                 (at start (occupied seg_T_B2a_0_60))
                 (at start (not (not_occupied seg_T_B2a_0_60)))
                 (at start (blocked seg_T_B2a_0_60 ?a))
                 (at start (not (not_blocked seg_T_B2a_0_60 ?a)))
                 (at end (at-segment ?a seg_T_B2a_0_60))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_S_B2a_0_60 ?a)))
                 (at end (not_blocked seg_S_B2a_0_60 ?a))

                )
)

(:durative-action move_seg_T_B2a_0_60_seg_T_B2c_0_60_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_T_B2a_0_60))
                 (at start (not_occupied seg_T_B2c_0_60))
                 (at start (not_blocked seg_T_B2c_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_T_B2c_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_T_B2c_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_T_B2c_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_T_B2c_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_T_B2c_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_T_B2c_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_T_B2c_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_T_B2c_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_T_B2c_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_T_B2c_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_T_B2c_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_T_B2c_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_T_B2c_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_T_B2c_0_60 airplane_CFBE2))

                 (over all (not_occupied seg_T_B2b_0_60))
              )

 :effect        (and
                 (at end (not (occupied seg_T_B2a_0_60)))
                 (at end (not_occupied seg_T_B2a_0_60))
                 (at start (not (at-segment ?a seg_T_B2a_0_60)))

                 (at start (occupied seg_T_B2c_0_60))
                 (at start (not (not_occupied seg_T_B2c_0_60)))
                 (at start (blocked seg_T_B2c_0_60 ?a))
                 (at start (not (not_blocked seg_T_B2c_0_60 ?a)))
                 (at end (at-segment ?a seg_T_B2c_0_60))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_S_B2b_0_60 ?a)))
                 (at end (not_blocked seg_S_B2b_0_60 ?a))

                 (at start (blocked seg_T_B2b_0_60 ?a))
                 (at start (not (not_blocked seg_T_B2b_0_60 ?a)))
                )
)

(:durative-action move_seg_T_B2c_0_60_seg_B2_0_80_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_T_B2c_0_60))
                 (at start (not_occupied seg_B2_0_80))
                 (at start (not_blocked seg_B2_0_80 airplane_CFBEG))
                 (at start (not_blocked seg_B2_0_80 airplane_CFBE1))
                 (at start (not_blocked seg_B2_0_80 airplane_CFBE3))
                 (at start (not_blocked seg_B2_0_80 airplane_DAEW8))
                 (at start (not_blocked seg_B2_0_80 airplane_DAEW9))
                 (at start (not_blocked seg_B2_0_80 airplane_DAEW0))
                 (at start (not_blocked seg_B2_0_80 airplane_DAEW3))
                 (at start (not_blocked seg_B2_0_80 airplane_DAEWH))
                 (at start (not_blocked seg_B2_0_80 airplane_DAEW1))
                 (at start (not_blocked seg_B2_0_80 airplane_DAEW2))
                 (at start (not_blocked seg_B2_0_80 airplane_DAEW4))
                 (at start (not_blocked seg_B2_0_80 airplane_DAEW5))
                 (at start (not_blocked seg_B2_0_80 airplane_DAEW6))
                 (at start (not_blocked seg_B2_0_80 airplane_DAEW7))
                 (at start (not_blocked seg_B2_0_80 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_T_B2c_0_60)))
                 (at end (not_occupied seg_T_B2c_0_60))
                 (at start (not (at-segment ?a seg_T_B2c_0_60)))

                 (at start (occupied seg_B2_0_80))
                 (at start (not (not_occupied seg_B2_0_80)))
                 (at start (blocked seg_B2_0_80 ?a))
                 (at start (not (not_blocked seg_B2_0_80 ?a)))
                 (at end (at-segment ?a seg_B2_0_80))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_T_B2a_0_60 ?a)))
                 (at end (not_blocked seg_T_B2a_0_60 ?a))
                 (at end (not (blocked seg_T_B2b_0_60 ?a)))
                 (at end (not_blocked seg_T_B2b_0_60 ?a))

                )
)

(:durative-action move_seg_B2_0_80_seg_B2_1_0_80_north_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_B2_0_80))
                 (at start (not_occupied seg_B2_1_0_80))
                 (at start (not_blocked seg_B2_1_0_80 airplane_CFBEG))
                 (at start (not_blocked seg_B2_1_0_80 airplane_CFBE1))
                 (at start (not_blocked seg_B2_1_0_80 airplane_CFBE3))
                 (at start (not_blocked seg_B2_1_0_80 airplane_DAEW8))
                 (at start (not_blocked seg_B2_1_0_80 airplane_DAEW9))
                 (at start (not_blocked seg_B2_1_0_80 airplane_DAEW0))
                 (at start (not_blocked seg_B2_1_0_80 airplane_DAEW3))
                 (at start (not_blocked seg_B2_1_0_80 airplane_DAEWH))
                 (at start (not_blocked seg_B2_1_0_80 airplane_DAEW1))
                 (at start (not_blocked seg_B2_1_0_80 airplane_DAEW2))
                 (at start (not_blocked seg_B2_1_0_80 airplane_DAEW4))
                 (at start (not_blocked seg_B2_1_0_80 airplane_DAEW5))
                 (at start (not_blocked seg_B2_1_0_80 airplane_DAEW6))
                 (at start (not_blocked seg_B2_1_0_80 airplane_DAEW7))
                 (at start (not_blocked seg_B2_1_0_80 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_B2_0_80)))
                 (at end (not_occupied seg_B2_0_80))
                 (at start (not (at-segment ?a seg_B2_0_80)))

                 (at start (occupied seg_B2_1_0_80))
                 (at start (not (not_occupied seg_B2_1_0_80)))
                 (at start (blocked seg_B2_1_0_80 ?a))
                 (at start (not (not_blocked seg_B2_1_0_80 ?a)))
                 (at end (at-segment ?a seg_B2_1_0_80))

                 (at end (not (blocked seg_T_B2c_0_60 ?a)))
                 (at end (not_blocked seg_T_B2c_0_60 ?a))

                )
)

(:durative-action move_seg_B2_1_0_80_seg_08R_B2a_0_80_north_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_B2_1_0_80))
                 (at start (not_occupied seg_08R_B2a_0_80))
                 (at start (not_blocked seg_08R_B2a_0_80 airplane_CFBEG))
                 (at start (not_blocked seg_08R_B2a_0_80 airplane_CFBE1))
                 (at start (not_blocked seg_08R_B2a_0_80 airplane_CFBE3))
                 (at start (not_blocked seg_08R_B2a_0_80 airplane_DAEW8))
                 (at start (not_blocked seg_08R_B2a_0_80 airplane_DAEW9))
                 (at start (not_blocked seg_08R_B2a_0_80 airplane_DAEW0))
                 (at start (not_blocked seg_08R_B2a_0_80 airplane_DAEW3))
                 (at start (not_blocked seg_08R_B2a_0_80 airplane_DAEWH))
                 (at start (not_blocked seg_08R_B2a_0_80 airplane_DAEW1))
                 (at start (not_blocked seg_08R_B2a_0_80 airplane_DAEW2))
                 (at start (not_blocked seg_08R_B2a_0_80 airplane_DAEW4))
                 (at start (not_blocked seg_08R_B2a_0_80 airplane_DAEW5))
                 (at start (not_blocked seg_08R_B2a_0_80 airplane_DAEW6))
                 (at start (not_blocked seg_08R_B2a_0_80 airplane_DAEW7))
                 (at start (not_blocked seg_08R_B2a_0_80 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_B2_1_0_80)))
                 (at end (not_occupied seg_B2_1_0_80))
                 (at start (not (at-segment ?a seg_B2_1_0_80)))

                 (at start (occupied seg_08R_B2a_0_80))
                 (at start (not (not_occupied seg_08R_B2a_0_80)))
                 (at start (blocked seg_08R_B2a_0_80 ?a))
                 (at start (not (not_blocked seg_08R_B2a_0_80 ?a)))
                 (at end (at-segment ?a seg_08R_B2a_0_80))

                 (at end (not (blocked seg_B2_0_80 ?a)))
                 (at end (not_blocked seg_B2_0_80 ?a))

                )
)

(:durative-action move_seg_08R_B2a_0_80_seg_08R_B2b_0_80_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_08R_B2a_0_80))
                 (at start (not_occupied seg_08R_B2b_0_80))
                 (at start (not_blocked seg_08R_B2b_0_80 airplane_CFBEG))
                 (at start (not_blocked seg_08R_B2b_0_80 airplane_CFBE1))
                 (at start (not_blocked seg_08R_B2b_0_80 airplane_CFBE3))
                 (at start (not_blocked seg_08R_B2b_0_80 airplane_DAEW8))
                 (at start (not_blocked seg_08R_B2b_0_80 airplane_DAEW9))
                 (at start (not_blocked seg_08R_B2b_0_80 airplane_DAEW0))
                 (at start (not_blocked seg_08R_B2b_0_80 airplane_DAEW3))
                 (at start (not_blocked seg_08R_B2b_0_80 airplane_DAEWH))
                 (at start (not_blocked seg_08R_B2b_0_80 airplane_DAEW1))
                 (at start (not_blocked seg_08R_B2b_0_80 airplane_DAEW2))
                 (at start (not_blocked seg_08R_B2b_0_80 airplane_DAEW4))
                 (at start (not_blocked seg_08R_B2b_0_80 airplane_DAEW5))
                 (at start (not_blocked seg_08R_B2b_0_80 airplane_DAEW6))
                 (at start (not_blocked seg_08R_B2b_0_80 airplane_DAEW7))
                 (at start (not_blocked seg_08R_B2b_0_80 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_08R_B2a_0_80)))
                 (at end (not_occupied seg_08R_B2a_0_80))
                 (at start (not (at-segment ?a seg_08R_B2a_0_80)))

                 (at start (occupied seg_08R_B2b_0_80))
                 (at start (not (not_occupied seg_08R_B2b_0_80)))
                 (at start (blocked seg_08R_B2b_0_80 ?a))
                 (at start (not (not_blocked seg_08R_B2b_0_80 ?a)))
                 (at end (at-segment ?a seg_08R_B2b_0_80))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_B2_1_0_80 ?a)))
                 (at end (not_blocked seg_B2_1_0_80 ?a))

                )
)

(:durative-action move_seg_08R_B2b_0_80_seg_08R_B2B3_0_900_south_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_08R_B2b_0_80))
                 (at start (not_occupied seg_08R_B2B3_0_900))
                 (at start (not_blocked seg_08R_B2B3_0_900 airplane_CFBEG))
                 (at start (not_blocked seg_08R_B2B3_0_900 airplane_CFBE1))
                 (at start (not_blocked seg_08R_B2B3_0_900 airplane_CFBE3))
                 (at start (not_blocked seg_08R_B2B3_0_900 airplane_DAEW8))
                 (at start (not_blocked seg_08R_B2B3_0_900 airplane_DAEW9))
                 (at start (not_blocked seg_08R_B2B3_0_900 airplane_DAEW0))
                 (at start (not_blocked seg_08R_B2B3_0_900 airplane_DAEW3))
                 (at start (not_blocked seg_08R_B2B3_0_900 airplane_DAEWH))
                 (at start (not_blocked seg_08R_B2B3_0_900 airplane_DAEW1))
                 (at start (not_blocked seg_08R_B2B3_0_900 airplane_DAEW2))
                 (at start (not_blocked seg_08R_B2B3_0_900 airplane_DAEW4))
                 (at start (not_blocked seg_08R_B2B3_0_900 airplane_DAEW5))
                 (at start (not_blocked seg_08R_B2B3_0_900 airplane_DAEW6))
                 (at start (not_blocked seg_08R_B2B3_0_900 airplane_DAEW7))
                 (at start (not_blocked seg_08R_B2B3_0_900 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_08R_B2b_0_80)))
                 (at end (not_occupied seg_08R_B2b_0_80))
                 (at start (not (at-segment ?a seg_08R_B2b_0_80)))

                 (at start (occupied seg_08R_B2B3_0_900))
                 (at start (not (not_occupied seg_08R_B2B3_0_900)))
                 (at start (blocked seg_08R_B2B3_0_900 ?a))
                 (at start (not (not_blocked seg_08R_B2B3_0_900 ?a)))
                 (at end (at-segment ?a seg_08R_B2B3_0_900))

                 (at end (not (blocked seg_08R_B2a_0_80 ?a)))
                 (at end (not_blocked seg_08R_B2a_0_80 ?a))

                )
)

(:durative-action move_seg_08R_B2B3_0_900_seg_08r_0_80_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 30)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_08R_B2B3_0_900))
                 (at start (not_occupied seg_08r_0_80))
                 (at start (not_blocked seg_08r_0_80 airplane_CFBEG))
                 (at start (not_blocked seg_08r_0_80 airplane_CFBE1))
                 (at start (not_blocked seg_08r_0_80 airplane_CFBE3))
                 (at start (not_blocked seg_08r_0_80 airplane_DAEW8))
                 (at start (not_blocked seg_08r_0_80 airplane_DAEW9))
                 (at start (not_blocked seg_08r_0_80 airplane_DAEW0))
                 (at start (not_blocked seg_08r_0_80 airplane_DAEW3))
                 (at start (not_blocked seg_08r_0_80 airplane_DAEWH))
                 (at start (not_blocked seg_08r_0_80 airplane_DAEW1))
                 (at start (not_blocked seg_08r_0_80 airplane_DAEW2))
                 (at start (not_blocked seg_08r_0_80 airplane_DAEW4))
                 (at start (not_blocked seg_08r_0_80 airplane_DAEW5))
                 (at start (not_blocked seg_08r_0_80 airplane_DAEW6))
                 (at start (not_blocked seg_08r_0_80 airplane_DAEW7))
                 (at start (not_blocked seg_08r_0_80 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_08R_B2B3_0_900)))
                 (at end (not_occupied seg_08R_B2B3_0_900))
                 (at start (not (at-segment ?a seg_08R_B2B3_0_900)))

                 (at start (occupied seg_08r_0_80))
                 (at start (not (not_occupied seg_08r_0_80)))
                 (at start (blocked seg_08r_0_80 ?a))
                 (at start (not (not_blocked seg_08r_0_80 ?a)))
                 (at end (at-segment ?a seg_08r_0_80))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_08R_B2b_0_80 ?a)))
                 (at end (not_blocked seg_08R_B2b_0_80 ?a))

                )
)

(:durative-action move_seg_08r_0_80_seg_08R_B3a_0_80_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_08r_0_80))
                 (at start (not_occupied seg_08R_B3a_0_80))
                 (at start (not_blocked seg_08R_B3a_0_80 airplane_CFBEG))
                 (at start (not_blocked seg_08R_B3a_0_80 airplane_CFBE1))
                 (at start (not_blocked seg_08R_B3a_0_80 airplane_CFBE3))
                 (at start (not_blocked seg_08R_B3a_0_80 airplane_DAEW8))
                 (at start (not_blocked seg_08R_B3a_0_80 airplane_DAEW9))
                 (at start (not_blocked seg_08R_B3a_0_80 airplane_DAEW0))
                 (at start (not_blocked seg_08R_B3a_0_80 airplane_DAEW3))
                 (at start (not_blocked seg_08R_B3a_0_80 airplane_DAEWH))
                 (at start (not_blocked seg_08R_B3a_0_80 airplane_DAEW1))
                 (at start (not_blocked seg_08R_B3a_0_80 airplane_DAEW2))
                 (at start (not_blocked seg_08R_B3a_0_80 airplane_DAEW4))
                 (at start (not_blocked seg_08R_B3a_0_80 airplane_DAEW5))
                 (at start (not_blocked seg_08R_B3a_0_80 airplane_DAEW6))
                 (at start (not_blocked seg_08R_B3a_0_80 airplane_DAEW7))
                 (at start (not_blocked seg_08R_B3a_0_80 airplane_CFBE2))

                 (over all (not_occupied seg_08R_B3c_0_161_245))
              )

 :effect        (and
                 (at end (not (occupied seg_08r_0_80)))
                 (at end (not_occupied seg_08r_0_80))
                 (at start (not (at-segment ?a seg_08r_0_80)))

                 (at start (occupied seg_08R_B3a_0_80))
                 (at start (not (not_occupied seg_08R_B3a_0_80)))
                 (at start (blocked seg_08R_B3a_0_80 ?a))
                 (at start (not (not_blocked seg_08R_B3a_0_80 ?a)))
                 (at end (at-segment ?a seg_08R_B3a_0_80))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_08R_B2B3_0_900 ?a)))
                 (at end (not_blocked seg_08R_B2B3_0_900 ?a))

                 (at start (blocked seg_08R_B3c_0_161_245 ?a))
                 (at start (not (not_blocked seg_08R_B3c_0_161_245 ?a)))
                )
)

(:durative-action move_seg_08R_B3a_0_80_seg_08R_B3B4_0_520_south_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_08R_B3a_0_80))
                 (at start (not_occupied seg_08R_B3B4_0_520))
                 (at start (not_blocked seg_08R_B3B4_0_520 airplane_CFBEG))
                 (at start (not_blocked seg_08R_B3B4_0_520 airplane_CFBE1))
                 (at start (not_blocked seg_08R_B3B4_0_520 airplane_CFBE3))
                 (at start (not_blocked seg_08R_B3B4_0_520 airplane_DAEW8))
                 (at start (not_blocked seg_08R_B3B4_0_520 airplane_DAEW9))
                 (at start (not_blocked seg_08R_B3B4_0_520 airplane_DAEW0))
                 (at start (not_blocked seg_08R_B3B4_0_520 airplane_DAEW3))
                 (at start (not_blocked seg_08R_B3B4_0_520 airplane_DAEWH))
                 (at start (not_blocked seg_08R_B3B4_0_520 airplane_DAEW1))
                 (at start (not_blocked seg_08R_B3B4_0_520 airplane_DAEW2))
                 (at start (not_blocked seg_08R_B3B4_0_520 airplane_DAEW4))
                 (at start (not_blocked seg_08R_B3B4_0_520 airplane_DAEW5))
                 (at start (not_blocked seg_08R_B3B4_0_520 airplane_DAEW6))
                 (at start (not_blocked seg_08R_B3B4_0_520 airplane_DAEW7))
                 (at start (not_blocked seg_08R_B3B4_0_520 airplane_CFBE2))

                 (over all (not_occupied seg_08R_B2b_0_80))
                 (over all (not_occupied seg_08r_0_80))
              )

 :effect        (and
                 (at end (not (occupied seg_08R_B3a_0_80)))
                 (at end (not_occupied seg_08R_B3a_0_80))
                 (at start (not (at-segment ?a seg_08R_B3a_0_80)))

                 (at start (occupied seg_08R_B3B4_0_520))
                 (at start (not (not_occupied seg_08R_B3B4_0_520)))
                 (at start (blocked seg_08R_B3B4_0_520 ?a))
                 (at start (not (not_blocked seg_08R_B3B4_0_520 ?a)))
                 (at end (at-segment ?a seg_08R_B3B4_0_520))

                 (at end (not (blocked seg_08R_B3c_0_161_245 ?a)))
                 (at end (not_blocked seg_08R_B3c_0_161_245 ?a))

                 (at start (blocked seg_08R_B2b_0_80 ?a))
                 (at start (not (not_blocked seg_08R_B2b_0_80 ?a)))
                )
)

(:durative-action move_seg_08R_B3B4_0_520_seg_08R_B4c_0_80_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 17)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_08R_B3B4_0_520))
                 (at start (not_occupied seg_08R_B4c_0_80))
                 (at start (not_blocked seg_08R_B4c_0_80 airplane_CFBEG))
                 (at start (not_blocked seg_08R_B4c_0_80 airplane_CFBE1))
                 (at start (not_blocked seg_08R_B4c_0_80 airplane_CFBE3))
                 (at start (not_blocked seg_08R_B4c_0_80 airplane_DAEW8))
                 (at start (not_blocked seg_08R_B4c_0_80 airplane_DAEW9))
                 (at start (not_blocked seg_08R_B4c_0_80 airplane_DAEW0))
                 (at start (not_blocked seg_08R_B4c_0_80 airplane_DAEW3))
                 (at start (not_blocked seg_08R_B4c_0_80 airplane_DAEWH))
                 (at start (not_blocked seg_08R_B4c_0_80 airplane_DAEW1))
                 (at start (not_blocked seg_08R_B4c_0_80 airplane_DAEW2))
                 (at start (not_blocked seg_08R_B4c_0_80 airplane_DAEW4))
                 (at start (not_blocked seg_08R_B4c_0_80 airplane_DAEW5))
                 (at start (not_blocked seg_08R_B4c_0_80 airplane_DAEW6))
                 (at start (not_blocked seg_08R_B4c_0_80 airplane_DAEW7))
                 (at start (not_blocked seg_08R_B4c_0_80 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_08R_B3B4_0_520)))
                 (at end (not_occupied seg_08R_B3B4_0_520))
                 (at start (not (at-segment ?a seg_08R_B3B4_0_520)))

                 (at start (occupied seg_08R_B4c_0_80))
                 (at start (not (not_occupied seg_08R_B4c_0_80)))
                 (at start (blocked seg_08R_B4c_0_80 ?a))
                 (at start (not (not_blocked seg_08R_B4c_0_80 ?a)))
                 (at end (at-segment ?a seg_08R_B4c_0_80))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_08R_B3a_0_80 ?a)))
                 (at end (not_blocked seg_08R_B3a_0_80 ?a))
                 (at end (not (blocked seg_08R_B2b_0_80 ?a)))
                 (at end (not_blocked seg_08R_B2b_0_80 ?a))
                 (at end (not (blocked seg_08r_0_80 ?a)))
                 (at end (not_blocked seg_08r_0_80 ?a))

                )
)

(:durative-action move_seg_08R_B4c_0_80_seg_08R_B4b_0_80_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_08R_B4c_0_80))
                 (at start (not_occupied seg_08R_B4b_0_80))
                 (at start (not_blocked seg_08R_B4b_0_80 airplane_CFBEG))
                 (at start (not_blocked seg_08R_B4b_0_80 airplane_CFBE1))
                 (at start (not_blocked seg_08R_B4b_0_80 airplane_CFBE3))
                 (at start (not_blocked seg_08R_B4b_0_80 airplane_DAEW8))
                 (at start (not_blocked seg_08R_B4b_0_80 airplane_DAEW9))
                 (at start (not_blocked seg_08R_B4b_0_80 airplane_DAEW0))
                 (at start (not_blocked seg_08R_B4b_0_80 airplane_DAEW3))
                 (at start (not_blocked seg_08R_B4b_0_80 airplane_DAEWH))
                 (at start (not_blocked seg_08R_B4b_0_80 airplane_DAEW1))
                 (at start (not_blocked seg_08R_B4b_0_80 airplane_DAEW2))
                 (at start (not_blocked seg_08R_B4b_0_80 airplane_DAEW4))
                 (at start (not_blocked seg_08R_B4b_0_80 airplane_DAEW5))
                 (at start (not_blocked seg_08R_B4b_0_80 airplane_DAEW6))
                 (at start (not_blocked seg_08R_B4b_0_80 airplane_DAEW7))
                 (at start (not_blocked seg_08R_B4b_0_80 airplane_CFBE2))

                 (over all (not_occupied seg_08R_B4a_0_161_245))
                 (over all (not_occupied seg_08R_B4d_0_161_245))
              )

 :effect        (and
                 (at end (not (occupied seg_08R_B4c_0_80)))
                 (at end (not_occupied seg_08R_B4c_0_80))
                 (at start (not (at-segment ?a seg_08R_B4c_0_80)))

                 (at start (occupied seg_08R_B4b_0_80))
                 (at start (not (not_occupied seg_08R_B4b_0_80)))
                 (at start (blocked seg_08R_B4b_0_80 ?a))
                 (at start (not (not_blocked seg_08R_B4b_0_80 ?a)))
                 (at end (at-segment ?a seg_08R_B4b_0_80))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_08R_B3B4_0_520 ?a)))
                 (at end (not_blocked seg_08R_B3B4_0_520 ?a))

                 (at start (blocked seg_08R_B4a_0_161_245 ?a))
                 (at start (not (not_blocked seg_08R_B4a_0_161_245 ?a)))
                 (at start (blocked seg_08R_B4d_0_161_245 ?a))
                 (at start (not (not_blocked seg_08R_B4d_0_161_245 ?a)))
                )
)

(:durative-action move_seg_08R_B4b_0_80_seg_08R_B4B6_0_360_south_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_08R_B4b_0_80))
                 (at start (not_occupied seg_08R_B4B6_0_360))
                 (at start (not_blocked seg_08R_B4B6_0_360 airplane_CFBEG))
                 (at start (not_blocked seg_08R_B4B6_0_360 airplane_CFBE1))
                 (at start (not_blocked seg_08R_B4B6_0_360 airplane_CFBE3))
                 (at start (not_blocked seg_08R_B4B6_0_360 airplane_DAEW8))
                 (at start (not_blocked seg_08R_B4B6_0_360 airplane_DAEW9))
                 (at start (not_blocked seg_08R_B4B6_0_360 airplane_DAEW0))
                 (at start (not_blocked seg_08R_B4B6_0_360 airplane_DAEW3))
                 (at start (not_blocked seg_08R_B4B6_0_360 airplane_DAEWH))
                 (at start (not_blocked seg_08R_B4B6_0_360 airplane_DAEW1))
                 (at start (not_blocked seg_08R_B4B6_0_360 airplane_DAEW2))
                 (at start (not_blocked seg_08R_B4B6_0_360 airplane_DAEW4))
                 (at start (not_blocked seg_08R_B4B6_0_360 airplane_DAEW5))
                 (at start (not_blocked seg_08R_B4B6_0_360 airplane_DAEW6))
                 (at start (not_blocked seg_08R_B4B6_0_360 airplane_DAEW7))
                 (at start (not_blocked seg_08R_B4B6_0_360 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_08R_B4b_0_80)))
                 (at end (not_occupied seg_08R_B4b_0_80))
                 (at start (not (at-segment ?a seg_08R_B4b_0_80)))

                 (at start (occupied seg_08R_B4B6_0_360))
                 (at start (not (not_occupied seg_08R_B4B6_0_360)))
                 (at start (blocked seg_08R_B4B6_0_360 ?a))
                 (at start (not (not_blocked seg_08R_B4B6_0_360 ?a)))
                 (at end (at-segment ?a seg_08R_B4B6_0_360))

                 (at end (not (blocked seg_08R_B4a_0_161_245 ?a)))
                 (at end (not_blocked seg_08R_B4a_0_161_245 ?a))
                 (at end (not (blocked seg_08R_B4c_0_80 ?a)))
                 (at end (not_blocked seg_08R_B4c_0_80 ?a))
                 (at end (not (blocked seg_08R_B4d_0_161_245 ?a)))
                 (at end (not_blocked seg_08R_B4d_0_161_245 ?a))

                )
)

(:durative-action move_seg_08R_B4B6_0_360_seg_08R_B6c_0_80_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 12)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_08R_B4B6_0_360))
                 (at start (not_occupied seg_08R_B6c_0_80))
                 (at start (not_blocked seg_08R_B6c_0_80 airplane_CFBEG))
                 (at start (not_blocked seg_08R_B6c_0_80 airplane_CFBE1))
                 (at start (not_blocked seg_08R_B6c_0_80 airplane_CFBE3))
                 (at start (not_blocked seg_08R_B6c_0_80 airplane_DAEW8))
                 (at start (not_blocked seg_08R_B6c_0_80 airplane_DAEW9))
                 (at start (not_blocked seg_08R_B6c_0_80 airplane_DAEW0))
                 (at start (not_blocked seg_08R_B6c_0_80 airplane_DAEW3))
                 (at start (not_blocked seg_08R_B6c_0_80 airplane_DAEWH))
                 (at start (not_blocked seg_08R_B6c_0_80 airplane_DAEW1))
                 (at start (not_blocked seg_08R_B6c_0_80 airplane_DAEW2))
                 (at start (not_blocked seg_08R_B6c_0_80 airplane_DAEW4))
                 (at start (not_blocked seg_08R_B6c_0_80 airplane_DAEW5))
                 (at start (not_blocked seg_08R_B6c_0_80 airplane_DAEW6))
                 (at start (not_blocked seg_08R_B6c_0_80 airplane_DAEW7))
                 (at start (not_blocked seg_08R_B6c_0_80 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_08R_B4B6_0_360)))
                 (at end (not_occupied seg_08R_B4B6_0_360))
                 (at start (not (at-segment ?a seg_08R_B4B6_0_360)))

                 (at start (occupied seg_08R_B6c_0_80))
                 (at start (not (not_occupied seg_08R_B6c_0_80)))
                 (at start (blocked seg_08R_B6c_0_80 ?a))
                 (at start (not (not_blocked seg_08R_B6c_0_80 ?a)))
                 (at end (at-segment ?a seg_08R_B6c_0_80))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_08R_B4b_0_80 ?a)))
                 (at end (not_blocked seg_08R_B4b_0_80 ?a))

                )
)

(:durative-action move_seg_08R_B6c_0_80_seg_08R_B6b_0_80_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_08R_B6c_0_80))
                 (at start (not_occupied seg_08R_B6b_0_80))
                 (at start (not_blocked seg_08R_B6b_0_80 airplane_CFBEG))
                 (at start (not_blocked seg_08R_B6b_0_80 airplane_CFBE1))
                 (at start (not_blocked seg_08R_B6b_0_80 airplane_CFBE3))
                 (at start (not_blocked seg_08R_B6b_0_80 airplane_DAEW8))
                 (at start (not_blocked seg_08R_B6b_0_80 airplane_DAEW9))
                 (at start (not_blocked seg_08R_B6b_0_80 airplane_DAEW0))
                 (at start (not_blocked seg_08R_B6b_0_80 airplane_DAEW3))
                 (at start (not_blocked seg_08R_B6b_0_80 airplane_DAEWH))
                 (at start (not_blocked seg_08R_B6b_0_80 airplane_DAEW1))
                 (at start (not_blocked seg_08R_B6b_0_80 airplane_DAEW2))
                 (at start (not_blocked seg_08R_B6b_0_80 airplane_DAEW4))
                 (at start (not_blocked seg_08R_B6b_0_80 airplane_DAEW5))
                 (at start (not_blocked seg_08R_B6b_0_80 airplane_DAEW6))
                 (at start (not_blocked seg_08R_B6b_0_80 airplane_DAEW7))
                 (at start (not_blocked seg_08R_B6b_0_80 airplane_CFBE2))

                 (over all (not_occupied seg_08R_B6a_0_161_245))
                 (over all (not_occupied seg_08R_B6d_0_161_245))
              )

 :effect        (and
                 (at end (not (occupied seg_08R_B6c_0_80)))
                 (at end (not_occupied seg_08R_B6c_0_80))
                 (at start (not (at-segment ?a seg_08R_B6c_0_80)))

                 (at start (occupied seg_08R_B6b_0_80))
                 (at start (not (not_occupied seg_08R_B6b_0_80)))
                 (at start (blocked seg_08R_B6b_0_80 ?a))
                 (at start (not (not_blocked seg_08R_B6b_0_80 ?a)))
                 (at end (at-segment ?a seg_08R_B6b_0_80))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_08R_B4B6_0_360 ?a)))
                 (at end (not_blocked seg_08R_B4B6_0_360 ?a))

                 (at start (blocked seg_08R_B6a_0_161_245 ?a))
                 (at start (not (not_blocked seg_08R_B6a_0_161_245 ?a)))
                 (at start (blocked seg_08R_B6d_0_161_245 ?a))
                 (at start (not (not_blocked seg_08R_B6d_0_161_245 ?a)))
                )
)

(:durative-action move_seg_08R_B6b_0_80_seg_08R_B6B9_0_420_south_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_08R_B6b_0_80))
                 (at start (not_occupied seg_08R_B6B9_0_420))
                 (at start (not_blocked seg_08R_B6B9_0_420 airplane_CFBEG))
                 (at start (not_blocked seg_08R_B6B9_0_420 airplane_CFBE1))
                 (at start (not_blocked seg_08R_B6B9_0_420 airplane_CFBE3))
                 (at start (not_blocked seg_08R_B6B9_0_420 airplane_DAEW8))
                 (at start (not_blocked seg_08R_B6B9_0_420 airplane_DAEW9))
                 (at start (not_blocked seg_08R_B6B9_0_420 airplane_DAEW0))
                 (at start (not_blocked seg_08R_B6B9_0_420 airplane_DAEW3))
                 (at start (not_blocked seg_08R_B6B9_0_420 airplane_DAEWH))
                 (at start (not_blocked seg_08R_B6B9_0_420 airplane_DAEW1))
                 (at start (not_blocked seg_08R_B6B9_0_420 airplane_DAEW2))
                 (at start (not_blocked seg_08R_B6B9_0_420 airplane_DAEW4))
                 (at start (not_blocked seg_08R_B6B9_0_420 airplane_DAEW5))
                 (at start (not_blocked seg_08R_B6B9_0_420 airplane_DAEW6))
                 (at start (not_blocked seg_08R_B6B9_0_420 airplane_DAEW7))
                 (at start (not_blocked seg_08R_B6B9_0_420 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_08R_B6b_0_80)))
                 (at end (not_occupied seg_08R_B6b_0_80))
                 (at start (not (at-segment ?a seg_08R_B6b_0_80)))

                 (at start (occupied seg_08R_B6B9_0_420))
                 (at start (not (not_occupied seg_08R_B6B9_0_420)))
                 (at start (blocked seg_08R_B6B9_0_420 ?a))
                 (at start (not (not_blocked seg_08R_B6B9_0_420 ?a)))
                 (at end (at-segment ?a seg_08R_B6B9_0_420))

                 (at end (not (blocked seg_08R_B6a_0_161_245 ?a)))
                 (at end (not_blocked seg_08R_B6a_0_161_245 ?a))
                 (at end (not (blocked seg_08R_B6c_0_80 ?a)))
                 (at end (not_blocked seg_08R_B6c_0_80 ?a))
                 (at end (not (blocked seg_08R_B6d_0_161_245 ?a)))
                 (at end (not_blocked seg_08R_B6d_0_161_245 ?a))

                )
)

(:durative-action move_seg_08R_B6B9_0_420_seg_08R_B9c_0_80_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 14)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_08R_B6B9_0_420))
                 (at start (not_occupied seg_08R_B9c_0_80))
                 (at start (not_blocked seg_08R_B9c_0_80 airplane_CFBEG))
                 (at start (not_blocked seg_08R_B9c_0_80 airplane_CFBE1))
                 (at start (not_blocked seg_08R_B9c_0_80 airplane_CFBE3))
                 (at start (not_blocked seg_08R_B9c_0_80 airplane_DAEW8))
                 (at start (not_blocked seg_08R_B9c_0_80 airplane_DAEW9))
                 (at start (not_blocked seg_08R_B9c_0_80 airplane_DAEW0))
                 (at start (not_blocked seg_08R_B9c_0_80 airplane_DAEW3))
                 (at start (not_blocked seg_08R_B9c_0_80 airplane_DAEWH))
                 (at start (not_blocked seg_08R_B9c_0_80 airplane_DAEW1))
                 (at start (not_blocked seg_08R_B9c_0_80 airplane_DAEW2))
                 (at start (not_blocked seg_08R_B9c_0_80 airplane_DAEW4))
                 (at start (not_blocked seg_08R_B9c_0_80 airplane_DAEW5))
                 (at start (not_blocked seg_08R_B9c_0_80 airplane_DAEW6))
                 (at start (not_blocked seg_08R_B9c_0_80 airplane_DAEW7))
                 (at start (not_blocked seg_08R_B9c_0_80 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_08R_B6B9_0_420)))
                 (at end (not_occupied seg_08R_B6B9_0_420))
                 (at start (not (at-segment ?a seg_08R_B6B9_0_420)))

                 (at start (occupied seg_08R_B9c_0_80))
                 (at start (not (not_occupied seg_08R_B9c_0_80)))
                 (at start (blocked seg_08R_B9c_0_80 ?a))
                 (at start (not (not_blocked seg_08R_B9c_0_80 ?a)))
                 (at end (at-segment ?a seg_08R_B9c_0_80))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_08R_B6b_0_80 ?a)))
                 (at end (not_blocked seg_08R_B6b_0_80 ?a))

                )
)

(:durative-action move_seg_08R_B9c_0_80_seg_09r_0_80_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_08R_B9c_0_80))
                 (at start (not_occupied seg_09r_0_80))
                 (at start (not_blocked seg_09r_0_80 airplane_CFBEG))
                 (at start (not_blocked seg_09r_0_80 airplane_CFBE1))
                 (at start (not_blocked seg_09r_0_80 airplane_CFBE3))
                 (at start (not_blocked seg_09r_0_80 airplane_DAEW8))
                 (at start (not_blocked seg_09r_0_80 airplane_DAEW9))
                 (at start (not_blocked seg_09r_0_80 airplane_DAEW0))
                 (at start (not_blocked seg_09r_0_80 airplane_DAEW3))
                 (at start (not_blocked seg_09r_0_80 airplane_DAEWH))
                 (at start (not_blocked seg_09r_0_80 airplane_DAEW1))
                 (at start (not_blocked seg_09r_0_80 airplane_DAEW2))
                 (at start (not_blocked seg_09r_0_80 airplane_DAEW4))
                 (at start (not_blocked seg_09r_0_80 airplane_DAEW5))
                 (at start (not_blocked seg_09r_0_80 airplane_DAEW6))
                 (at start (not_blocked seg_09r_0_80 airplane_DAEW7))
                 (at start (not_blocked seg_09r_0_80 airplane_CFBE2))

                 (over all (not_occupied seg_08R_B9a_0_161_245))
              )

 :effect        (and
                 (at end (not (occupied seg_08R_B9c_0_80)))
                 (at end (not_occupied seg_08R_B9c_0_80))
                 (at start (not (at-segment ?a seg_08R_B9c_0_80)))

                 (at start (occupied seg_09r_0_80))
                 (at start (not (not_occupied seg_09r_0_80)))
                 (at start (blocked seg_09r_0_80 ?a))
                 (at start (not (not_blocked seg_09r_0_80 ?a)))
                 (at end (at-segment ?a seg_09r_0_80))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_08R_B6B9_0_420 ?a)))
                 (at end (not_blocked seg_08R_B6B9_0_420 ?a))

                 (at start (blocked seg_08R_B9a_0_161_245 ?a))
                 (at start (not (not_blocked seg_08R_B9a_0_161_245 ?a)))
                )
)

(:durative-action move_seg_W1_141b_0_45_seg_W1_141c_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_W1_141b_0_45))
                 (at start (not_occupied seg_W1_141c_0_34))
                 (at start (not_blocked seg_W1_141c_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_W1_141c_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_W1_141c_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_W1_141c_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_W1_141c_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_W1_141c_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_W1_141c_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_W1_141c_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_W1_141c_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_W1_141c_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_W1_141c_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_W1_141c_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_W1_141c_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_W1_141c_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_W1_141c_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_W1_141a_0_34))
              )

 :effect        (and
                 (at end (not (occupied seg_W1_141b_0_45)))
                 (at end (not_occupied seg_W1_141b_0_45))
                 (at start (not (at-segment ?a seg_W1_141b_0_45)))

                 (at start (occupied seg_W1_141c_0_34))
                 (at start (not (not_occupied seg_W1_141c_0_34)))
                 (at start (blocked seg_W1_141c_0_34 ?a))
                 (at start (not (not_blocked seg_W1_141c_0_34 ?a)))
                 (at end (at-segment ?a seg_W1_141c_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_p141_0_75 ?a)))
                 (at end (not_blocked seg_p141_0_75 ?a))

                 (at start (blocked seg_W1_141a_0_34 ?a))
                 (at start (not (not_blocked seg_W1_141a_0_34 ?a)))
                )
)

(:durative-action move_seg_W1_142a_0_34_seg_W1_141c_0_34_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_W1_142a_0_34))
                 (at start (not_occupied seg_W1_141c_0_34))
                 (at start (not_blocked seg_W1_141c_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_W1_141c_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_W1_141c_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_W1_141c_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_W1_141c_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_W1_141c_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_W1_141c_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_W1_141c_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_W1_141c_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_W1_141c_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_W1_141c_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_W1_141c_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_W1_141c_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_W1_141c_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_W1_141c_0_34 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_W1_142a_0_34)))
                 (at end (not_occupied seg_W1_142a_0_34))
                 (at start (not (at-segment ?a seg_W1_142a_0_34)))

                 (at start (occupied seg_W1_141c_0_34))
                 (at start (not (not_occupied seg_W1_141c_0_34)))
                 (at start (blocked seg_W1_141c_0_34 ?a))
                 (at start (not (not_blocked seg_W1_141c_0_34 ?a)))
                 (at end (at-segment ?a seg_W1_141c_0_34))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_W1_142b_0_45 ?a)))
                 (at end (not_blocked seg_W1_142b_0_45 ?a))
                 (at end (not (blocked seg_W1_142c_0_34 ?a)))
                 (at end (not_blocked seg_W1_142c_0_34 ?a))

                )
)

(:durative-action move_seg_W1_141c_0_34_seg_W1_141a_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_W1_141c_0_34))
                 (at start (not_occupied seg_W1_141a_0_34))
                 (at start (not_blocked seg_W1_141a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_W1_141a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_W1_141a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_W1_141a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_W1_141a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_W1_141a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_W1_141a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_W1_141a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_W1_141a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_W1_141a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_W1_141a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_W1_141a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_W1_141a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_W1_141a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_W1_141a_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_W1_141b_0_45))
              )

 :effect        (and
                 (at end (not (occupied seg_W1_141c_0_34)))
                 (at end (not_occupied seg_W1_141c_0_34))
                 (at start (not (at-segment ?a seg_W1_141c_0_34)))

                 (at start (occupied seg_W1_141a_0_34))
                 (at start (not (not_occupied seg_W1_141a_0_34)))
                 (at start (blocked seg_W1_141a_0_34 ?a))
                 (at start (not (not_blocked seg_W1_141a_0_34 ?a)))
                 (at end (at-segment ?a seg_W1_141a_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_W1_142a_0_34 ?a)))
                 (at end (not_blocked seg_W1_142a_0_34 ?a))

                 (at start (blocked seg_W1_141b_0_45 ?a))
                 (at start (not (not_blocked seg_W1_141b_0_45 ?a)))
                )
)

(:durative-action move_seg_W1_C1c_0_34_seg_W1_C1a_0_60_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_W1_C1c_0_34))
                 (at start (not_occupied seg_W1_C1a_0_60))
                 (at start (not_blocked seg_W1_C1a_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_W1_C1a_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_W1_C1a_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_W1_C1a_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_W1_C1a_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_W1_C1a_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_W1_C1a_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_W1_C1a_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_W1_C1a_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_W1_C1a_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_W1_C1a_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_W1_C1a_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_W1_C1a_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_W1_C1a_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_W1_C1a_0_60 airplane_CFBE2))

                 (over all (not_occupied seg_W1_C1b_0_60))
              )

 :effect        (and
                 (at end (not (occupied seg_W1_C1c_0_34)))
                 (at end (not_occupied seg_W1_C1c_0_34))
                 (at start (not (at-segment ?a seg_W1_C1c_0_34)))

                 (at start (occupied seg_W1_C1a_0_60))
                 (at start (not (not_occupied seg_W1_C1a_0_60)))
                 (at start (blocked seg_W1_C1a_0_60 ?a))
                 (at start (not (not_blocked seg_W1_C1a_0_60 ?a)))
                 (at end (at-segment ?a seg_W1_C1a_0_60))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_W1_141a_0_34 ?a)))
                 (at end (not_blocked seg_W1_141a_0_34 ?a))

                 (at start (blocked seg_W1_C1b_0_60 ?a))
                 (at start (not (not_blocked seg_W1_C1b_0_60 ?a)))
                )
)

(:durative-action move_seg_W1_C1a_0_60_seg_N1_0_108_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_W1_C1a_0_60))
                 (at start (not_occupied seg_N1_0_108))
                 (at start (not_blocked seg_N1_0_108 airplane_CFBEG))
                 (at start (not_blocked seg_N1_0_108 airplane_CFBE1))
                 (at start (not_blocked seg_N1_0_108 airplane_CFBE3))
                 (at start (not_blocked seg_N1_0_108 airplane_DAEW8))
                 (at start (not_blocked seg_N1_0_108 airplane_DAEW9))
                 (at start (not_blocked seg_N1_0_108 airplane_DAEW0))
                 (at start (not_blocked seg_N1_0_108 airplane_DAEW3))
                 (at start (not_blocked seg_N1_0_108 airplane_DAEWH))
                 (at start (not_blocked seg_N1_0_108 airplane_DAEW1))
                 (at start (not_blocked seg_N1_0_108 airplane_DAEW2))
                 (at start (not_blocked seg_N1_0_108 airplane_DAEW4))
                 (at start (not_blocked seg_N1_0_108 airplane_DAEW5))
                 (at start (not_blocked seg_N1_0_108 airplane_DAEW6))
                 (at start (not_blocked seg_N1_0_108 airplane_DAEW7))
                 (at start (not_blocked seg_N1_0_108 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_W1_C1a_0_60)))
                 (at end (not_occupied seg_W1_C1a_0_60))
                 (at start (not (at-segment ?a seg_W1_C1a_0_60)))

                 (at start (occupied seg_N1_0_108))
                 (at start (not (not_occupied seg_N1_0_108)))
                 (at start (blocked seg_N1_0_108 ?a))
                 (at start (not (not_blocked seg_N1_0_108 ?a)))
                 (at end (at-segment ?a seg_N1_0_108))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_W1_C1b_0_60 ?a)))
                 (at end (not_blocked seg_W1_C1b_0_60 ?a))
                 (at end (not (blocked seg_W1_C1c_0_34 ?a)))
                 (at end (not_blocked seg_W1_C1c_0_34 ?a))

                )
)

(:durative-action move_seg_N1_0_108_seg_N_A3c_0_60_north_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 3)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_N1_0_108))
                 (at start (not_occupied seg_N_A3c_0_60))
                 (at start (not_blocked seg_N_A3c_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_N_A3c_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_N_A3c_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_N_A3c_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_N_A3c_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_N_A3c_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_N_A3c_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_N_A3c_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_N_A3c_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_N_A3c_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_N_A3c_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_N_A3c_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_N_A3c_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_N_A3c_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_N_A3c_0_60 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_N1_0_108)))
                 (at end (not_occupied seg_N1_0_108))
                 (at start (not (at-segment ?a seg_N1_0_108)))

                 (at start (occupied seg_N_A3c_0_60))
                 (at start (not (not_occupied seg_N_A3c_0_60)))
                 (at start (blocked seg_N_A3c_0_60 ?a))
                 (at start (not (not_blocked seg_N_A3c_0_60 ?a)))
                 (at end (at-segment ?a seg_N_A3c_0_60))

                 (at end (not (blocked seg_W1_C1a_0_60 ?a)))
                 (at end (not_blocked seg_W1_C1a_0_60 ?a))

                )
)

(:durative-action move_seg_N_A3c_0_60_seg_N_A3d_0_60_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_N_A3c_0_60))
                 (at start (not_occupied seg_N_A3d_0_60))
                 (at start (not_blocked seg_N_A3d_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_N_A3d_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_N_A3d_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_N_A3d_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_N_A3d_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_N_A3d_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_N_A3d_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_N_A3d_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_N_A3d_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_N_A3d_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_N_A3d_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_N_A3d_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_N_A3d_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_N_A3d_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_N_A3d_0_60 airplane_CFBE2))

                 (over all (not_occupied seg_N_A3a_0_60))
                 (over all (not_occupied seg_N_A3b_0_60))
              )

 :effect        (and
                 (at end (not (occupied seg_N_A3c_0_60)))
                 (at end (not_occupied seg_N_A3c_0_60))
                 (at start (not (at-segment ?a seg_N_A3c_0_60)))

                 (at start (occupied seg_N_A3d_0_60))
                 (at start (not (not_occupied seg_N_A3d_0_60)))
                 (at start (blocked seg_N_A3d_0_60 ?a))
                 (at start (not (not_blocked seg_N_A3d_0_60 ?a)))
                 (at end (at-segment ?a seg_N_A3d_0_60))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_N1_0_108 ?a)))
                 (at end (not_blocked seg_N1_0_108 ?a))

                 (at start (blocked seg_N_A3a_0_60 ?a))
                 (at start (not (not_blocked seg_N_A3a_0_60 ?a)))
                 (at start (blocked seg_N_A3b_0_60 ?a))
                 (at start (not (not_blocked seg_N_A3b_0_60 ?a)))
                )
)

(:durative-action move_seg_N_A3d_0_60_seg_N_A2A3f_0_115_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_N_A3d_0_60))
                 (at start (not_occupied seg_N_A2A3f_0_115))
                 (at start (not_blocked seg_N_A2A3f_0_115 airplane_CFBEG))
                 (at start (not_blocked seg_N_A2A3f_0_115 airplane_CFBE1))
                 (at start (not_blocked seg_N_A2A3f_0_115 airplane_CFBE3))
                 (at start (not_blocked seg_N_A2A3f_0_115 airplane_DAEW8))
                 (at start (not_blocked seg_N_A2A3f_0_115 airplane_DAEW9))
                 (at start (not_blocked seg_N_A2A3f_0_115 airplane_DAEW0))
                 (at start (not_blocked seg_N_A2A3f_0_115 airplane_DAEW3))
                 (at start (not_blocked seg_N_A2A3f_0_115 airplane_DAEWH))
                 (at start (not_blocked seg_N_A2A3f_0_115 airplane_DAEW1))
                 (at start (not_blocked seg_N_A2A3f_0_115 airplane_DAEW2))
                 (at start (not_blocked seg_N_A2A3f_0_115 airplane_DAEW4))
                 (at start (not_blocked seg_N_A2A3f_0_115 airplane_DAEW5))
                 (at start (not_blocked seg_N_A2A3f_0_115 airplane_DAEW6))
                 (at start (not_blocked seg_N_A2A3f_0_115 airplane_DAEW7))
                 (at start (not_blocked seg_N_A2A3f_0_115 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_N_A3d_0_60)))
                 (at end (not_occupied seg_N_A3d_0_60))
                 (at start (not (at-segment ?a seg_N_A3d_0_60)))

                 (at start (occupied seg_N_A2A3f_0_115))
                 (at start (not (not_occupied seg_N_A2A3f_0_115)))
                 (at start (blocked seg_N_A2A3f_0_115 ?a))
                 (at start (not (not_blocked seg_N_A2A3f_0_115 ?a)))
                 (at end (at-segment ?a seg_N_A2A3f_0_115))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_N_A3a_0_60 ?a)))
                 (at end (not_blocked seg_N_A3a_0_60 ?a))
                 (at end (not (blocked seg_N_A3b_0_60 ?a)))
                 (at end (not_blocked seg_N_A3b_0_60 ?a))
                 (at end (not (blocked seg_N_A3c_0_60 ?a)))
                 (at end (not_blocked seg_N_A3c_0_60 ?a))

                )
)

(:durative-action move_seg_N_A2A3f_0_115_seg_N_A2A3e_0_75_north_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 3)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_N_A2A3f_0_115))
                 (at start (not_occupied seg_N_A2A3e_0_75))
                 (at start (not_blocked seg_N_A2A3e_0_75 airplane_CFBEG))
                 (at start (not_blocked seg_N_A2A3e_0_75 airplane_CFBE1))
                 (at start (not_blocked seg_N_A2A3e_0_75 airplane_CFBE3))
                 (at start (not_blocked seg_N_A2A3e_0_75 airplane_DAEW8))
                 (at start (not_blocked seg_N_A2A3e_0_75 airplane_DAEW9))
                 (at start (not_blocked seg_N_A2A3e_0_75 airplane_DAEW0))
                 (at start (not_blocked seg_N_A2A3e_0_75 airplane_DAEW3))
                 (at start (not_blocked seg_N_A2A3e_0_75 airplane_DAEWH))
                 (at start (not_blocked seg_N_A2A3e_0_75 airplane_DAEW1))
                 (at start (not_blocked seg_N_A2A3e_0_75 airplane_DAEW2))
                 (at start (not_blocked seg_N_A2A3e_0_75 airplane_DAEW4))
                 (at start (not_blocked seg_N_A2A3e_0_75 airplane_DAEW5))
                 (at start (not_blocked seg_N_A2A3e_0_75 airplane_DAEW6))
                 (at start (not_blocked seg_N_A2A3e_0_75 airplane_DAEW7))
                 (at start (not_blocked seg_N_A2A3e_0_75 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_N_A2A3f_0_115)))
                 (at end (not_occupied seg_N_A2A3f_0_115))
                 (at start (not (at-segment ?a seg_N_A2A3f_0_115)))

                 (at start (occupied seg_N_A2A3e_0_75))
                 (at start (not (not_occupied seg_N_A2A3e_0_75)))
                 (at start (blocked seg_N_A2A3e_0_75 ?a))
                 (at start (not (not_blocked seg_N_A2A3e_0_75 ?a)))
                 (at end (at-segment ?a seg_N_A2A3e_0_75))

                 (at end (not (blocked seg_N_A3d_0_60 ?a)))
                 (at end (not_blocked seg_N_A3d_0_60 ?a))

                )
)

(:durative-action move_seg_N_A2A3e_0_75_seg_N_A2A3d_0_75_north_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_N_A2A3e_0_75))
                 (at start (not_occupied seg_N_A2A3d_0_75))
                 (at start (not_blocked seg_N_A2A3d_0_75 airplane_CFBEG))
                 (at start (not_blocked seg_N_A2A3d_0_75 airplane_CFBE1))
                 (at start (not_blocked seg_N_A2A3d_0_75 airplane_CFBE3))
                 (at start (not_blocked seg_N_A2A3d_0_75 airplane_DAEW8))
                 (at start (not_blocked seg_N_A2A3d_0_75 airplane_DAEW9))
                 (at start (not_blocked seg_N_A2A3d_0_75 airplane_DAEW0))
                 (at start (not_blocked seg_N_A2A3d_0_75 airplane_DAEW3))
                 (at start (not_blocked seg_N_A2A3d_0_75 airplane_DAEWH))
                 (at start (not_blocked seg_N_A2A3d_0_75 airplane_DAEW1))
                 (at start (not_blocked seg_N_A2A3d_0_75 airplane_DAEW2))
                 (at start (not_blocked seg_N_A2A3d_0_75 airplane_DAEW4))
                 (at start (not_blocked seg_N_A2A3d_0_75 airplane_DAEW5))
                 (at start (not_blocked seg_N_A2A3d_0_75 airplane_DAEW6))
                 (at start (not_blocked seg_N_A2A3d_0_75 airplane_DAEW7))
                 (at start (not_blocked seg_N_A2A3d_0_75 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_N_A2A3e_0_75)))
                 (at end (not_occupied seg_N_A2A3e_0_75))
                 (at start (not (at-segment ?a seg_N_A2A3e_0_75)))

                 (at start (occupied seg_N_A2A3d_0_75))
                 (at start (not (not_occupied seg_N_A2A3d_0_75)))
                 (at start (blocked seg_N_A2A3d_0_75 ?a))
                 (at start (not (not_blocked seg_N_A2A3d_0_75 ?a)))
                 (at end (at-segment ?a seg_N_A2A3d_0_75))

                 (at end (not (blocked seg_N_A2A3f_0_115 ?a)))
                 (at end (not_blocked seg_N_A2A3f_0_115 ?a))

                )
)

(:durative-action move_seg_N_A2A3d_0_75_seg_N_A2A3c_0_75_north_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_N_A2A3d_0_75))
                 (at start (not_occupied seg_N_A2A3c_0_75))
                 (at start (not_blocked seg_N_A2A3c_0_75 airplane_CFBEG))
                 (at start (not_blocked seg_N_A2A3c_0_75 airplane_CFBE1))
                 (at start (not_blocked seg_N_A2A3c_0_75 airplane_CFBE3))
                 (at start (not_blocked seg_N_A2A3c_0_75 airplane_DAEW8))
                 (at start (not_blocked seg_N_A2A3c_0_75 airplane_DAEW9))
                 (at start (not_blocked seg_N_A2A3c_0_75 airplane_DAEW0))
                 (at start (not_blocked seg_N_A2A3c_0_75 airplane_DAEW3))
                 (at start (not_blocked seg_N_A2A3c_0_75 airplane_DAEWH))
                 (at start (not_blocked seg_N_A2A3c_0_75 airplane_DAEW1))
                 (at start (not_blocked seg_N_A2A3c_0_75 airplane_DAEW2))
                 (at start (not_blocked seg_N_A2A3c_0_75 airplane_DAEW4))
                 (at start (not_blocked seg_N_A2A3c_0_75 airplane_DAEW5))
                 (at start (not_blocked seg_N_A2A3c_0_75 airplane_DAEW6))
                 (at start (not_blocked seg_N_A2A3c_0_75 airplane_DAEW7))
                 (at start (not_blocked seg_N_A2A3c_0_75 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_N_A2A3d_0_75)))
                 (at end (not_occupied seg_N_A2A3d_0_75))
                 (at start (not (at-segment ?a seg_N_A2A3d_0_75)))

                 (at start (occupied seg_N_A2A3c_0_75))
                 (at start (not (not_occupied seg_N_A2A3c_0_75)))
                 (at start (blocked seg_N_A2A3c_0_75 ?a))
                 (at start (not (not_blocked seg_N_A2A3c_0_75 ?a)))
                 (at end (at-segment ?a seg_N_A2A3c_0_75))

                 (at end (not (blocked seg_N_A2A3e_0_75 ?a)))
                 (at end (not_blocked seg_N_A2A3e_0_75 ?a))

                )
)

(:durative-action move_seg_N_A2A3c_0_75_seg_N_A2A3b_0_75_north_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_N_A2A3c_0_75))
                 (at start (not_occupied seg_N_A2A3b_0_75))
                 (at start (not_blocked seg_N_A2A3b_0_75 airplane_CFBEG))
                 (at start (not_blocked seg_N_A2A3b_0_75 airplane_CFBE1))
                 (at start (not_blocked seg_N_A2A3b_0_75 airplane_CFBE3))
                 (at start (not_blocked seg_N_A2A3b_0_75 airplane_DAEW8))
                 (at start (not_blocked seg_N_A2A3b_0_75 airplane_DAEW9))
                 (at start (not_blocked seg_N_A2A3b_0_75 airplane_DAEW0))
                 (at start (not_blocked seg_N_A2A3b_0_75 airplane_DAEW3))
                 (at start (not_blocked seg_N_A2A3b_0_75 airplane_DAEWH))
                 (at start (not_blocked seg_N_A2A3b_0_75 airplane_DAEW1))
                 (at start (not_blocked seg_N_A2A3b_0_75 airplane_DAEW2))
                 (at start (not_blocked seg_N_A2A3b_0_75 airplane_DAEW4))
                 (at start (not_blocked seg_N_A2A3b_0_75 airplane_DAEW5))
                 (at start (not_blocked seg_N_A2A3b_0_75 airplane_DAEW6))
                 (at start (not_blocked seg_N_A2A3b_0_75 airplane_DAEW7))
                 (at start (not_blocked seg_N_A2A3b_0_75 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_N_A2A3c_0_75)))
                 (at end (not_occupied seg_N_A2A3c_0_75))
                 (at start (not (at-segment ?a seg_N_A2A3c_0_75)))

                 (at start (occupied seg_N_A2A3b_0_75))
                 (at start (not (not_occupied seg_N_A2A3b_0_75)))
                 (at start (blocked seg_N_A2A3b_0_75 ?a))
                 (at start (not (not_blocked seg_N_A2A3b_0_75 ?a)))
                 (at end (at-segment ?a seg_N_A2A3b_0_75))

                 (at end (not (blocked seg_N_A2A3d_0_75 ?a)))
                 (at end (not_blocked seg_N_A2A3d_0_75 ?a))

                )
)

(:durative-action move_seg_N_A2A3b_0_75_seg_N_A2A3a_0_75_north_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_N_A2A3b_0_75))
                 (at start (not_occupied seg_N_A2A3a_0_75))
                 (at start (not_blocked seg_N_A2A3a_0_75 airplane_CFBEG))
                 (at start (not_blocked seg_N_A2A3a_0_75 airplane_CFBE1))
                 (at start (not_blocked seg_N_A2A3a_0_75 airplane_CFBE3))
                 (at start (not_blocked seg_N_A2A3a_0_75 airplane_DAEW8))
                 (at start (not_blocked seg_N_A2A3a_0_75 airplane_DAEW9))
                 (at start (not_blocked seg_N_A2A3a_0_75 airplane_DAEW0))
                 (at start (not_blocked seg_N_A2A3a_0_75 airplane_DAEW3))
                 (at start (not_blocked seg_N_A2A3a_0_75 airplane_DAEWH))
                 (at start (not_blocked seg_N_A2A3a_0_75 airplane_DAEW1))
                 (at start (not_blocked seg_N_A2A3a_0_75 airplane_DAEW2))
                 (at start (not_blocked seg_N_A2A3a_0_75 airplane_DAEW4))
                 (at start (not_blocked seg_N_A2A3a_0_75 airplane_DAEW5))
                 (at start (not_blocked seg_N_A2A3a_0_75 airplane_DAEW6))
                 (at start (not_blocked seg_N_A2A3a_0_75 airplane_DAEW7))
                 (at start (not_blocked seg_N_A2A3a_0_75 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_N_A2A3b_0_75)))
                 (at end (not_occupied seg_N_A2A3b_0_75))
                 (at start (not (at-segment ?a seg_N_A2A3b_0_75)))

                 (at start (occupied seg_N_A2A3a_0_75))
                 (at start (not (not_occupied seg_N_A2A3a_0_75)))
                 (at start (blocked seg_N_A2A3a_0_75 ?a))
                 (at start (not (not_blocked seg_N_A2A3a_0_75 ?a)))
                 (at end (at-segment ?a seg_N_A2A3a_0_75))

                 (at end (not (blocked seg_N_A2A3c_0_75 ?a)))
                 (at end (not_blocked seg_N_A2A3c_0_75 ?a))

                )
)

(:durative-action move_seg_N_A2A3a_0_75_seg_N_A2b_0_60_north_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_N_A2A3a_0_75))
                 (at start (not_occupied seg_N_A2b_0_60))
                 (at start (not_blocked seg_N_A2b_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_N_A2b_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_N_A2b_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_N_A2b_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_N_A2b_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_N_A2b_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_N_A2b_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_N_A2b_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_N_A2b_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_N_A2b_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_N_A2b_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_N_A2b_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_N_A2b_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_N_A2b_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_N_A2b_0_60 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_N_A2A3a_0_75)))
                 (at end (not_occupied seg_N_A2A3a_0_75))
                 (at start (not (at-segment ?a seg_N_A2A3a_0_75)))

                 (at start (occupied seg_N_A2b_0_60))
                 (at start (not (not_occupied seg_N_A2b_0_60)))
                 (at start (blocked seg_N_A2b_0_60 ?a))
                 (at start (not (not_blocked seg_N_A2b_0_60 ?a)))
                 (at end (at-segment ?a seg_N_A2b_0_60))

                 (at end (not (blocked seg_N_A2A3b_0_75 ?a)))
                 (at end (not_blocked seg_N_A2A3b_0_75 ?a))

                )
)

(:durative-action move_seg_N_A2b_0_60_seg_N_A2a_0_60_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_N_A2b_0_60))
                 (at start (not_occupied seg_N_A2a_0_60))
                 (at start (not_blocked seg_N_A2a_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_N_A2a_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_N_A2a_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_N_A2a_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_N_A2a_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_N_A2a_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_N_A2a_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_N_A2a_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_N_A2a_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_N_A2a_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_N_A2a_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_N_A2a_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_N_A2a_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_N_A2a_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_N_A2a_0_60 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_N_A2b_0_60)))
                 (at end (not_occupied seg_N_A2b_0_60))
                 (at start (not (at-segment ?a seg_N_A2b_0_60)))

                 (at start (occupied seg_N_A2a_0_60))
                 (at start (not (not_occupied seg_N_A2a_0_60)))
                 (at start (blocked seg_N_A2a_0_60 ?a))
                 (at start (not (not_blocked seg_N_A2a_0_60 ?a)))
                 (at end (at-segment ?a seg_N_A2a_0_60))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_N_A2A3a_0_75 ?a)))
                 (at end (not_blocked seg_N_A2A3a_0_75 ?a))

                )
)

(:durative-action move_seg_N_A2a_0_60_seg_A2_c_0_100_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_N_A2a_0_60))
                 (at start (not_occupied seg_A2_c_0_100))
                 (at start (not_blocked seg_A2_c_0_100 airplane_CFBEG))
                 (at start (not_blocked seg_A2_c_0_100 airplane_CFBE1))
                 (at start (not_blocked seg_A2_c_0_100 airplane_CFBE3))
                 (at start (not_blocked seg_A2_c_0_100 airplane_DAEW8))
                 (at start (not_blocked seg_A2_c_0_100 airplane_DAEW9))
                 (at start (not_blocked seg_A2_c_0_100 airplane_DAEW0))
                 (at start (not_blocked seg_A2_c_0_100 airplane_DAEW3))
                 (at start (not_blocked seg_A2_c_0_100 airplane_DAEWH))
                 (at start (not_blocked seg_A2_c_0_100 airplane_DAEW1))
                 (at start (not_blocked seg_A2_c_0_100 airplane_DAEW2))
                 (at start (not_blocked seg_A2_c_0_100 airplane_DAEW4))
                 (at start (not_blocked seg_A2_c_0_100 airplane_DAEW5))
                 (at start (not_blocked seg_A2_c_0_100 airplane_DAEW6))
                 (at start (not_blocked seg_A2_c_0_100 airplane_DAEW7))
                 (at start (not_blocked seg_A2_c_0_100 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_N_A2a_0_60)))
                 (at end (not_occupied seg_N_A2a_0_60))
                 (at start (not (at-segment ?a seg_N_A2a_0_60)))

                 (at start (occupied seg_A2_c_0_100))
                 (at start (not (not_occupied seg_A2_c_0_100)))
                 (at start (blocked seg_A2_c_0_100 ?a))
                 (at start (not (not_blocked seg_A2_c_0_100 ?a)))
                 (at end (at-segment ?a seg_A2_c_0_100))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_N_A2b_0_60 ?a)))
                 (at end (not_blocked seg_N_A2b_0_60 ?a))

                )
)

(:durative-action move_seg_A2_c_0_100_seg_A2_b_0_90_north_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 3)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_A2_c_0_100))
                 (at start (not_occupied seg_A2_b_0_90))
                 (at start (not_blocked seg_A2_b_0_90 airplane_CFBEG))
                 (at start (not_blocked seg_A2_b_0_90 airplane_CFBE1))
                 (at start (not_blocked seg_A2_b_0_90 airplane_CFBE3))
                 (at start (not_blocked seg_A2_b_0_90 airplane_DAEW8))
                 (at start (not_blocked seg_A2_b_0_90 airplane_DAEW9))
                 (at start (not_blocked seg_A2_b_0_90 airplane_DAEW0))
                 (at start (not_blocked seg_A2_b_0_90 airplane_DAEW3))
                 (at start (not_blocked seg_A2_b_0_90 airplane_DAEWH))
                 (at start (not_blocked seg_A2_b_0_90 airplane_DAEW1))
                 (at start (not_blocked seg_A2_b_0_90 airplane_DAEW2))
                 (at start (not_blocked seg_A2_b_0_90 airplane_DAEW4))
                 (at start (not_blocked seg_A2_b_0_90 airplane_DAEW5))
                 (at start (not_blocked seg_A2_b_0_90 airplane_DAEW6))
                 (at start (not_blocked seg_A2_b_0_90 airplane_DAEW7))
                 (at start (not_blocked seg_A2_b_0_90 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_A2_c_0_100)))
                 (at end (not_occupied seg_A2_c_0_100))
                 (at start (not (at-segment ?a seg_A2_c_0_100)))

                 (at start (occupied seg_A2_b_0_90))
                 (at start (not (not_occupied seg_A2_b_0_90)))
                 (at start (blocked seg_A2_b_0_90 ?a))
                 (at start (not (not_blocked seg_A2_b_0_90 ?a)))
                 (at end (at-segment ?a seg_A2_b_0_90))

                 (at end (not (blocked seg_N_A2a_0_60 ?a)))
                 (at end (not_blocked seg_N_A2a_0_60 ?a))

                )
)

(:durative-action move_seg_A2_b_0_90_seg_A2_a_0_90_north_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 3)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_A2_b_0_90))
                 (at start (not_occupied seg_A2_a_0_90))
                 (at start (not_blocked seg_A2_a_0_90 airplane_CFBEG))
                 (at start (not_blocked seg_A2_a_0_90 airplane_CFBE1))
                 (at start (not_blocked seg_A2_a_0_90 airplane_CFBE3))
                 (at start (not_blocked seg_A2_a_0_90 airplane_DAEW8))
                 (at start (not_blocked seg_A2_a_0_90 airplane_DAEW9))
                 (at start (not_blocked seg_A2_a_0_90 airplane_DAEW0))
                 (at start (not_blocked seg_A2_a_0_90 airplane_DAEW3))
                 (at start (not_blocked seg_A2_a_0_90 airplane_DAEWH))
                 (at start (not_blocked seg_A2_a_0_90 airplane_DAEW1))
                 (at start (not_blocked seg_A2_a_0_90 airplane_DAEW2))
                 (at start (not_blocked seg_A2_a_0_90 airplane_DAEW4))
                 (at start (not_blocked seg_A2_a_0_90 airplane_DAEW5))
                 (at start (not_blocked seg_A2_a_0_90 airplane_DAEW6))
                 (at start (not_blocked seg_A2_a_0_90 airplane_DAEW7))
                 (at start (not_blocked seg_A2_a_0_90 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_A2_b_0_90)))
                 (at end (not_occupied seg_A2_b_0_90))
                 (at start (not (at-segment ?a seg_A2_b_0_90)))

                 (at start (occupied seg_A2_a_0_90))
                 (at start (not (not_occupied seg_A2_a_0_90)))
                 (at start (blocked seg_A2_a_0_90 ?a))
                 (at start (not (not_blocked seg_A2_a_0_90 ?a)))
                 (at end (at-segment ?a seg_A2_a_0_90))

                 (at end (not (blocked seg_A2_c_0_100 ?a)))
                 (at end (not_blocked seg_A2_c_0_100 ?a))

                )
)

(:durative-action move_seg_A2_a_0_90_seg_08L_A2b_0_80_north_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 3)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_A2_a_0_90))
                 (at start (not_occupied seg_08L_A2b_0_80))
                 (at start (not_blocked seg_08L_A2b_0_80 airplane_CFBEG))
                 (at start (not_blocked seg_08L_A2b_0_80 airplane_CFBE1))
                 (at start (not_blocked seg_08L_A2b_0_80 airplane_CFBE3))
                 (at start (not_blocked seg_08L_A2b_0_80 airplane_DAEW8))
                 (at start (not_blocked seg_08L_A2b_0_80 airplane_DAEW9))
                 (at start (not_blocked seg_08L_A2b_0_80 airplane_DAEW0))
                 (at start (not_blocked seg_08L_A2b_0_80 airplane_DAEW3))
                 (at start (not_blocked seg_08L_A2b_0_80 airplane_DAEWH))
                 (at start (not_blocked seg_08L_A2b_0_80 airplane_DAEW1))
                 (at start (not_blocked seg_08L_A2b_0_80 airplane_DAEW2))
                 (at start (not_blocked seg_08L_A2b_0_80 airplane_DAEW4))
                 (at start (not_blocked seg_08L_A2b_0_80 airplane_DAEW5))
                 (at start (not_blocked seg_08L_A2b_0_80 airplane_DAEW6))
                 (at start (not_blocked seg_08L_A2b_0_80 airplane_DAEW7))
                 (at start (not_blocked seg_08L_A2b_0_80 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_A2_a_0_90)))
                 (at end (not_occupied seg_A2_a_0_90))
                 (at start (not (at-segment ?a seg_A2_a_0_90)))

                 (at start (occupied seg_08L_A2b_0_80))
                 (at start (not (not_occupied seg_08L_A2b_0_80)))
                 (at start (blocked seg_08L_A2b_0_80 ?a))
                 (at start (not (not_blocked seg_08L_A2b_0_80 ?a)))
                 (at end (at-segment ?a seg_08L_A2b_0_80))

                 (at end (not (blocked seg_A2_b_0_90 ?a)))
                 (at end (not_blocked seg_A2_b_0_90 ?a))

                )
)

(:durative-action move_seg_08L_A2b_0_80_seg_08L_A2a_0_80_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_08L_A2b_0_80))
                 (at start (not_occupied seg_08L_A2a_0_80))
                 (at start (not_blocked seg_08L_A2a_0_80 airplane_CFBEG))
                 (at start (not_blocked seg_08L_A2a_0_80 airplane_CFBE1))
                 (at start (not_blocked seg_08L_A2a_0_80 airplane_CFBE3))
                 (at start (not_blocked seg_08L_A2a_0_80 airplane_DAEW8))
                 (at start (not_blocked seg_08L_A2a_0_80 airplane_DAEW9))
                 (at start (not_blocked seg_08L_A2a_0_80 airplane_DAEW0))
                 (at start (not_blocked seg_08L_A2a_0_80 airplane_DAEW3))
                 (at start (not_blocked seg_08L_A2a_0_80 airplane_DAEWH))
                 (at start (not_blocked seg_08L_A2a_0_80 airplane_DAEW1))
                 (at start (not_blocked seg_08L_A2a_0_80 airplane_DAEW2))
                 (at start (not_blocked seg_08L_A2a_0_80 airplane_DAEW4))
                 (at start (not_blocked seg_08L_A2a_0_80 airplane_DAEW5))
                 (at start (not_blocked seg_08L_A2a_0_80 airplane_DAEW6))
                 (at start (not_blocked seg_08L_A2a_0_80 airplane_DAEW7))
                 (at start (not_blocked seg_08L_A2a_0_80 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_08L_A2b_0_80)))
                 (at end (not_occupied seg_08L_A2b_0_80))
                 (at start (not (at-segment ?a seg_08L_A2b_0_80)))

                 (at start (occupied seg_08L_A2a_0_80))
                 (at start (not (not_occupied seg_08L_A2a_0_80)))
                 (at start (blocked seg_08L_A2a_0_80 ?a))
                 (at start (not (not_blocked seg_08L_A2a_0_80 ?a)))
                 (at end (at-segment ?a seg_08L_A2a_0_80))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_A2_a_0_90 ?a)))
                 (at end (not_blocked seg_A2_a_0_90 ?a))

                )
)

(:durative-action move_seg_08L_A2a_0_80_seg_08L_A2A3_0_970_south_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_08L_A2a_0_80))
                 (at start (not_occupied seg_08L_A2A3_0_970))
                 (at start (not_blocked seg_08L_A2A3_0_970 airplane_CFBEG))
                 (at start (not_blocked seg_08L_A2A3_0_970 airplane_CFBE1))
                 (at start (not_blocked seg_08L_A2A3_0_970 airplane_CFBE3))
                 (at start (not_blocked seg_08L_A2A3_0_970 airplane_DAEW8))
                 (at start (not_blocked seg_08L_A2A3_0_970 airplane_DAEW9))
                 (at start (not_blocked seg_08L_A2A3_0_970 airplane_DAEW0))
                 (at start (not_blocked seg_08L_A2A3_0_970 airplane_DAEW3))
                 (at start (not_blocked seg_08L_A2A3_0_970 airplane_DAEWH))
                 (at start (not_blocked seg_08L_A2A3_0_970 airplane_DAEW1))
                 (at start (not_blocked seg_08L_A2A3_0_970 airplane_DAEW2))
                 (at start (not_blocked seg_08L_A2A3_0_970 airplane_DAEW4))
                 (at start (not_blocked seg_08L_A2A3_0_970 airplane_DAEW5))
                 (at start (not_blocked seg_08L_A2A3_0_970 airplane_DAEW6))
                 (at start (not_blocked seg_08L_A2A3_0_970 airplane_DAEW7))
                 (at start (not_blocked seg_08L_A2A3_0_970 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_08L_A2a_0_80)))
                 (at end (not_occupied seg_08L_A2a_0_80))
                 (at start (not (at-segment ?a seg_08L_A2a_0_80)))

                 (at start (occupied seg_08L_A2A3_0_970))
                 (at start (not (not_occupied seg_08L_A2A3_0_970)))
                 (at start (blocked seg_08L_A2A3_0_970 ?a))
                 (at start (not (not_blocked seg_08L_A2A3_0_970 ?a)))
                 (at end (at-segment ?a seg_08L_A2A3_0_970))

                 (at end (not (blocked seg_08L_A2b_0_80 ?a)))
                 (at end (not_blocked seg_08L_A2b_0_80 ?a))

                )
)

(:durative-action move_seg_08L_A2A3_0_970_seg_08l_0_80_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 32)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_08L_A2A3_0_970))
                 (at start (not_occupied seg_08l_0_80))
                 (at start (not_blocked seg_08l_0_80 airplane_CFBEG))
                 (at start (not_blocked seg_08l_0_80 airplane_CFBE1))
                 (at start (not_blocked seg_08l_0_80 airplane_CFBE3))
                 (at start (not_blocked seg_08l_0_80 airplane_DAEW8))
                 (at start (not_blocked seg_08l_0_80 airplane_DAEW9))
                 (at start (not_blocked seg_08l_0_80 airplane_DAEW0))
                 (at start (not_blocked seg_08l_0_80 airplane_DAEW3))
                 (at start (not_blocked seg_08l_0_80 airplane_DAEWH))
                 (at start (not_blocked seg_08l_0_80 airplane_DAEW1))
                 (at start (not_blocked seg_08l_0_80 airplane_DAEW2))
                 (at start (not_blocked seg_08l_0_80 airplane_DAEW4))
                 (at start (not_blocked seg_08l_0_80 airplane_DAEW5))
                 (at start (not_blocked seg_08l_0_80 airplane_DAEW6))
                 (at start (not_blocked seg_08l_0_80 airplane_DAEW7))
                 (at start (not_blocked seg_08l_0_80 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_08L_A2A3_0_970)))
                 (at end (not_occupied seg_08L_A2A3_0_970))
                 (at start (not (at-segment ?a seg_08L_A2A3_0_970)))

                 (at start (occupied seg_08l_0_80))
                 (at start (not (not_occupied seg_08l_0_80)))
                 (at start (blocked seg_08l_0_80 ?a))
                 (at start (not (not_blocked seg_08l_0_80 ?a)))
                 (at end (at-segment ?a seg_08l_0_80))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_08L_A2a_0_80 ?a)))
                 (at end (not_blocked seg_08L_A2a_0_80 ?a))

                )
)

(:durative-action move_seg_08l_0_80_seg_08L_A3a_0_80_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_08l_0_80))
                 (at start (not_occupied seg_08L_A3a_0_80))
                 (at start (not_blocked seg_08L_A3a_0_80 airplane_CFBEG))
                 (at start (not_blocked seg_08L_A3a_0_80 airplane_CFBE1))
                 (at start (not_blocked seg_08L_A3a_0_80 airplane_CFBE3))
                 (at start (not_blocked seg_08L_A3a_0_80 airplane_DAEW8))
                 (at start (not_blocked seg_08L_A3a_0_80 airplane_DAEW9))
                 (at start (not_blocked seg_08L_A3a_0_80 airplane_DAEW0))
                 (at start (not_blocked seg_08L_A3a_0_80 airplane_DAEW3))
                 (at start (not_blocked seg_08L_A3a_0_80 airplane_DAEWH))
                 (at start (not_blocked seg_08L_A3a_0_80 airplane_DAEW1))
                 (at start (not_blocked seg_08L_A3a_0_80 airplane_DAEW2))
                 (at start (not_blocked seg_08L_A3a_0_80 airplane_DAEW4))
                 (at start (not_blocked seg_08L_A3a_0_80 airplane_DAEW5))
                 (at start (not_blocked seg_08L_A3a_0_80 airplane_DAEW6))
                 (at start (not_blocked seg_08L_A3a_0_80 airplane_DAEW7))
                 (at start (not_blocked seg_08L_A3a_0_80 airplane_CFBE2))

                 (over all (not_occupied seg_08L_A3b_0_161_245))
              )

 :effect        (and
                 (at end (not (occupied seg_08l_0_80)))
                 (at end (not_occupied seg_08l_0_80))
                 (at start (not (at-segment ?a seg_08l_0_80)))

                 (at start (occupied seg_08L_A3a_0_80))
                 (at start (not (not_occupied seg_08L_A3a_0_80)))
                 (at start (blocked seg_08L_A3a_0_80 ?a))
                 (at start (not (not_blocked seg_08L_A3a_0_80 ?a)))
                 (at end (at-segment ?a seg_08L_A3a_0_80))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_08L_A2A3_0_970 ?a)))
                 (at end (not_blocked seg_08L_A2A3_0_970 ?a))

                 (at start (blocked seg_08L_A3b_0_161_245 ?a))
                 (at start (not (not_blocked seg_08L_A3b_0_161_245 ?a)))
                )
)

(:durative-action move_seg_08L_A3a_0_80_seg_08L_A3A4_0_450_south_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_08L_A3a_0_80))
                 (at start (not_occupied seg_08L_A3A4_0_450))
                 (at start (not_blocked seg_08L_A3A4_0_450 airplane_CFBEG))
                 (at start (not_blocked seg_08L_A3A4_0_450 airplane_CFBE1))
                 (at start (not_blocked seg_08L_A3A4_0_450 airplane_CFBE3))
                 (at start (not_blocked seg_08L_A3A4_0_450 airplane_DAEW8))
                 (at start (not_blocked seg_08L_A3A4_0_450 airplane_DAEW9))
                 (at start (not_blocked seg_08L_A3A4_0_450 airplane_DAEW0))
                 (at start (not_blocked seg_08L_A3A4_0_450 airplane_DAEW3))
                 (at start (not_blocked seg_08L_A3A4_0_450 airplane_DAEWH))
                 (at start (not_blocked seg_08L_A3A4_0_450 airplane_DAEW1))
                 (at start (not_blocked seg_08L_A3A4_0_450 airplane_DAEW2))
                 (at start (not_blocked seg_08L_A3A4_0_450 airplane_DAEW4))
                 (at start (not_blocked seg_08L_A3A4_0_450 airplane_DAEW5))
                 (at start (not_blocked seg_08L_A3A4_0_450 airplane_DAEW6))
                 (at start (not_blocked seg_08L_A3A4_0_450 airplane_DAEW7))
                 (at start (not_blocked seg_08L_A3A4_0_450 airplane_CFBE2))

                 (over all (not_occupied seg_08L_A2a_0_80))
                 (over all (not_occupied seg_09l_0_80))
                 (over all (not_occupied seg_08L_A7a_0_80))
                 (over all (not_occupied seg_08L_A4a_0_80))
                 (over all (not_occupied seg_08l_0_80))
              )

 :effect        (and
                 (at end (not (occupied seg_08L_A3a_0_80)))
                 (at end (not_occupied seg_08L_A3a_0_80))
                 (at start (not (at-segment ?a seg_08L_A3a_0_80)))

                 (at start (occupied seg_08L_A3A4_0_450))
                 (at start (not (not_occupied seg_08L_A3A4_0_450)))
                 (at start (blocked seg_08L_A3A4_0_450 ?a))
                 (at start (not (not_blocked seg_08L_A3A4_0_450 ?a)))
                 (at end (at-segment ?a seg_08L_A3A4_0_450))

                 (at end (not (blocked seg_08L_A3b_0_161_245 ?a)))
                 (at end (not_blocked seg_08L_A3b_0_161_245 ?a))

                 (at start (blocked seg_08L_A2a_0_80 ?a))
                 (at start (not (not_blocked seg_08L_A2a_0_80 ?a)))
                 (at start (blocked seg_09l_0_80 ?a))
                 (at start (not (not_blocked seg_09l_0_80 ?a)))
                 (at start (blocked seg_08L_A7a_0_80 ?a))
                 (at start (not (not_blocked seg_08L_A7a_0_80 ?a)))
                 (at start (blocked seg_08L_A4a_0_80 ?a))
                 (at start (not (not_blocked seg_08L_A4a_0_80 ?a)))
                )
)

(:durative-action move_seg_08L_A3A4_0_450_seg_08L_A4d_0_80_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 15)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_08L_A3A4_0_450))
                 (at start (not_occupied seg_08L_A4d_0_80))
                 (at start (not_blocked seg_08L_A4d_0_80 airplane_CFBEG))
                 (at start (not_blocked seg_08L_A4d_0_80 airplane_CFBE1))
                 (at start (not_blocked seg_08L_A4d_0_80 airplane_CFBE3))
                 (at start (not_blocked seg_08L_A4d_0_80 airplane_DAEW8))
                 (at start (not_blocked seg_08L_A4d_0_80 airplane_DAEW9))
                 (at start (not_blocked seg_08L_A4d_0_80 airplane_DAEW0))
                 (at start (not_blocked seg_08L_A4d_0_80 airplane_DAEW3))
                 (at start (not_blocked seg_08L_A4d_0_80 airplane_DAEWH))
                 (at start (not_blocked seg_08L_A4d_0_80 airplane_DAEW1))
                 (at start (not_blocked seg_08L_A4d_0_80 airplane_DAEW2))
                 (at start (not_blocked seg_08L_A4d_0_80 airplane_DAEW4))
                 (at start (not_blocked seg_08L_A4d_0_80 airplane_DAEW5))
                 (at start (not_blocked seg_08L_A4d_0_80 airplane_DAEW6))
                 (at start (not_blocked seg_08L_A4d_0_80 airplane_DAEW7))
                 (at start (not_blocked seg_08L_A4d_0_80 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_08L_A3A4_0_450)))
                 (at end (not_occupied seg_08L_A3A4_0_450))
                 (at start (not (at-segment ?a seg_08L_A3A4_0_450)))

                 (at start (occupied seg_08L_A4d_0_80))
                 (at start (not (not_occupied seg_08L_A4d_0_80)))
                 (at start (blocked seg_08L_A4d_0_80 ?a))
                 (at start (not (not_blocked seg_08L_A4d_0_80 ?a)))
                 (at end (at-segment ?a seg_08L_A4d_0_80))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_08L_A3a_0_80 ?a)))
                 (at end (not_blocked seg_08L_A3a_0_80 ?a))
                 (at end (not (blocked seg_08L_A2a_0_80 ?a)))
                 (at end (not_blocked seg_08L_A2a_0_80 ?a))
                 (at end (not (blocked seg_09l_0_80 ?a)))
                 (at end (not_blocked seg_09l_0_80 ?a))
                 (at end (not (blocked seg_08L_A7a_0_80 ?a)))
                 (at end (not_blocked seg_08L_A7a_0_80 ?a))
                 (at end (not (blocked seg_08L_A4a_0_80 ?a)))
                 (at end (not_blocked seg_08L_A4a_0_80 ?a))
                 (at end (not (blocked seg_08l_0_80 ?a)))
                 (at end (not_blocked seg_08l_0_80 ?a))

                )
)

(:durative-action move_seg_08L_A4d_0_80_seg_08L_A4a_0_80_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_08L_A4d_0_80))
                 (at start (not_occupied seg_08L_A4a_0_80))
                 (at start (not_blocked seg_08L_A4a_0_80 airplane_CFBEG))
                 (at start (not_blocked seg_08L_A4a_0_80 airplane_CFBE1))
                 (at start (not_blocked seg_08L_A4a_0_80 airplane_CFBE3))
                 (at start (not_blocked seg_08L_A4a_0_80 airplane_DAEW8))
                 (at start (not_blocked seg_08L_A4a_0_80 airplane_DAEW9))
                 (at start (not_blocked seg_08L_A4a_0_80 airplane_DAEW0))
                 (at start (not_blocked seg_08L_A4a_0_80 airplane_DAEW3))
                 (at start (not_blocked seg_08L_A4a_0_80 airplane_DAEWH))
                 (at start (not_blocked seg_08L_A4a_0_80 airplane_DAEW1))
                 (at start (not_blocked seg_08L_A4a_0_80 airplane_DAEW2))
                 (at start (not_blocked seg_08L_A4a_0_80 airplane_DAEW4))
                 (at start (not_blocked seg_08L_A4a_0_80 airplane_DAEW5))
                 (at start (not_blocked seg_08L_A4a_0_80 airplane_DAEW6))
                 (at start (not_blocked seg_08L_A4a_0_80 airplane_DAEW7))
                 (at start (not_blocked seg_08L_A4a_0_80 airplane_CFBE2))

                 (over all (not_occupied seg_08L_A4b_0_161_245))
                 (over all (not_occupied seg_08L_A4c_0_161_245))
                 (over all (not_occupied seg_08L_A2a_0_80))
                 (over all (not_occupied seg_09l_0_80))
                 (over all (not_occupied seg_08L_A7a_0_80))
              )

 :effect        (and
                 (at end (not (occupied seg_08L_A4d_0_80)))
                 (at end (not_occupied seg_08L_A4d_0_80))
                 (at start (not (at-segment ?a seg_08L_A4d_0_80)))

                 (at start (occupied seg_08L_A4a_0_80))
                 (at start (not (not_occupied seg_08L_A4a_0_80)))
                 (at start (blocked seg_08L_A4a_0_80 ?a))
                 (at start (not (not_blocked seg_08L_A4a_0_80 ?a)))
                 (at end (at-segment ?a seg_08L_A4a_0_80))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_08L_A3A4_0_450 ?a)))
                 (at end (not_blocked seg_08L_A3A4_0_450 ?a))

                 (at start (blocked seg_08L_A4b_0_161_245 ?a))
                 (at start (not (not_blocked seg_08L_A4b_0_161_245 ?a)))
                 (at start (blocked seg_08L_A4c_0_161_245 ?a))
                 (at start (not (not_blocked seg_08L_A4c_0_161_245 ?a)))
                 (at start (blocked seg_08L_A2a_0_80 ?a))
                 (at start (not (not_blocked seg_08L_A2a_0_80 ?a)))
                 (at start (blocked seg_09l_0_80 ?a))
                 (at start (not (not_blocked seg_09l_0_80 ?a)))
                 (at start (blocked seg_08L_A7a_0_80 ?a))
                 (at start (not (not_blocked seg_08L_A7a_0_80 ?a)))
                )
)

(:durative-action move_seg_08L_A4a_0_80_seg_08L_A6A7_0_450_south_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_08L_A4a_0_80))
                 (at start (not_occupied seg_08L_A6A7_0_450))
                 (at start (not_blocked seg_08L_A6A7_0_450 airplane_CFBEG))
                 (at start (not_blocked seg_08L_A6A7_0_450 airplane_CFBE1))
                 (at start (not_blocked seg_08L_A6A7_0_450 airplane_CFBE3))
                 (at start (not_blocked seg_08L_A6A7_0_450 airplane_DAEW8))
                 (at start (not_blocked seg_08L_A6A7_0_450 airplane_DAEW9))
                 (at start (not_blocked seg_08L_A6A7_0_450 airplane_DAEW0))
                 (at start (not_blocked seg_08L_A6A7_0_450 airplane_DAEW3))
                 (at start (not_blocked seg_08L_A6A7_0_450 airplane_DAEWH))
                 (at start (not_blocked seg_08L_A6A7_0_450 airplane_DAEW1))
                 (at start (not_blocked seg_08L_A6A7_0_450 airplane_DAEW2))
                 (at start (not_blocked seg_08L_A6A7_0_450 airplane_DAEW4))
                 (at start (not_blocked seg_08L_A6A7_0_450 airplane_DAEW5))
                 (at start (not_blocked seg_08L_A6A7_0_450 airplane_DAEW6))
                 (at start (not_blocked seg_08L_A6A7_0_450 airplane_DAEW7))
                 (at start (not_blocked seg_08L_A6A7_0_450 airplane_CFBE2))

                 (over all (not_occupied seg_08L_A2a_0_80))
                 (over all (not_occupied seg_09l_0_80))
                 (over all (not_occupied seg_08L_A7a_0_80))
                 (over all (not_occupied seg_08L_A3a_0_80))
                 (over all (not_occupied seg_08l_0_80))
                 (over all (not_occupied seg_08L_A3A4_0_450))
                 (over all (not_occupied seg_08L_A4d_0_80))
              )

 :effect        (and
                 (at end (not (occupied seg_08L_A4a_0_80)))
                 (at end (not_occupied seg_08L_A4a_0_80))
                 (at start (not (at-segment ?a seg_08L_A4a_0_80)))

                 (at start (occupied seg_08L_A6A7_0_450))
                 (at start (not (not_occupied seg_08L_A6A7_0_450)))
                 (at start (blocked seg_08L_A6A7_0_450 ?a))
                 (at start (not (not_blocked seg_08L_A6A7_0_450 ?a)))
                 (at end (at-segment ?a seg_08L_A6A7_0_450))

                 (at end (not (blocked seg_08L_A4b_0_161_245 ?a)))
                 (at end (not_blocked seg_08L_A4b_0_161_245 ?a))
                 (at end (not (blocked seg_08L_A4c_0_161_245 ?a)))
                 (at end (not_blocked seg_08L_A4c_0_161_245 ?a))

                 (at start (blocked seg_08L_A3a_0_80 ?a))
                 (at start (not (not_blocked seg_08L_A3a_0_80 ?a)))
                 (at start (blocked seg_08l_0_80 ?a))
                 (at start (not (not_blocked seg_08l_0_80 ?a)))
                 (at start (blocked seg_08L_A3A4_0_450 ?a))
                 (at start (not (not_blocked seg_08L_A3A4_0_450 ?a)))
                )
)

(:durative-action move_seg_08L_A6A7_0_450_seg_08L_A7d_0_80_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 15)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_08L_A6A7_0_450))
                 (at start (not_occupied seg_08L_A7d_0_80))
                 (at start (not_blocked seg_08L_A7d_0_80 airplane_CFBEG))
                 (at start (not_blocked seg_08L_A7d_0_80 airplane_CFBE1))
                 (at start (not_blocked seg_08L_A7d_0_80 airplane_CFBE3))
                 (at start (not_blocked seg_08L_A7d_0_80 airplane_DAEW8))
                 (at start (not_blocked seg_08L_A7d_0_80 airplane_DAEW9))
                 (at start (not_blocked seg_08L_A7d_0_80 airplane_DAEW0))
                 (at start (not_blocked seg_08L_A7d_0_80 airplane_DAEW3))
                 (at start (not_blocked seg_08L_A7d_0_80 airplane_DAEWH))
                 (at start (not_blocked seg_08L_A7d_0_80 airplane_DAEW1))
                 (at start (not_blocked seg_08L_A7d_0_80 airplane_DAEW2))
                 (at start (not_blocked seg_08L_A7d_0_80 airplane_DAEW4))
                 (at start (not_blocked seg_08L_A7d_0_80 airplane_DAEW5))
                 (at start (not_blocked seg_08L_A7d_0_80 airplane_DAEW6))
                 (at start (not_blocked seg_08L_A7d_0_80 airplane_DAEW7))
                 (at start (not_blocked seg_08L_A7d_0_80 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_08L_A6A7_0_450)))
                 (at end (not_occupied seg_08L_A6A7_0_450))
                 (at start (not (at-segment ?a seg_08L_A6A7_0_450)))

                 (at start (occupied seg_08L_A7d_0_80))
                 (at start (not (not_occupied seg_08L_A7d_0_80)))
                 (at start (blocked seg_08L_A7d_0_80 ?a))
                 (at start (not (not_blocked seg_08L_A7d_0_80 ?a)))
                 (at end (at-segment ?a seg_08L_A7d_0_80))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_08L_A4a_0_80 ?a)))
                 (at end (not_blocked seg_08L_A4a_0_80 ?a))
                 (at end (not (blocked seg_08L_A2a_0_80 ?a)))
                 (at end (not_blocked seg_08L_A2a_0_80 ?a))
                 (at end (not (blocked seg_09l_0_80 ?a)))
                 (at end (not_blocked seg_09l_0_80 ?a))
                 (at end (not (blocked seg_08L_A7a_0_80 ?a)))
                 (at end (not_blocked seg_08L_A7a_0_80 ?a))
                 (at end (not (blocked seg_08L_A3a_0_80 ?a)))
                 (at end (not_blocked seg_08L_A3a_0_80 ?a))
                 (at end (not (blocked seg_08l_0_80 ?a)))
                 (at end (not_blocked seg_08l_0_80 ?a))
                 (at end (not (blocked seg_08L_A3A4_0_450 ?a)))
                 (at end (not_blocked seg_08L_A3A4_0_450 ?a))
                 (at end (not (blocked seg_08L_A4d_0_80 ?a)))
                 (at end (not_blocked seg_08L_A4d_0_80 ?a))

                )
)

(:durative-action move_seg_08L_A7d_0_80_seg_08L_A7a_0_80_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_08L_A7d_0_80))
                 (at start (not_occupied seg_08L_A7a_0_80))
                 (at start (not_blocked seg_08L_A7a_0_80 airplane_CFBEG))
                 (at start (not_blocked seg_08L_A7a_0_80 airplane_CFBE1))
                 (at start (not_blocked seg_08L_A7a_0_80 airplane_CFBE3))
                 (at start (not_blocked seg_08L_A7a_0_80 airplane_DAEW8))
                 (at start (not_blocked seg_08L_A7a_0_80 airplane_DAEW9))
                 (at start (not_blocked seg_08L_A7a_0_80 airplane_DAEW0))
                 (at start (not_blocked seg_08L_A7a_0_80 airplane_DAEW3))
                 (at start (not_blocked seg_08L_A7a_0_80 airplane_DAEWH))
                 (at start (not_blocked seg_08L_A7a_0_80 airplane_DAEW1))
                 (at start (not_blocked seg_08L_A7a_0_80 airplane_DAEW2))
                 (at start (not_blocked seg_08L_A7a_0_80 airplane_DAEW4))
                 (at start (not_blocked seg_08L_A7a_0_80 airplane_DAEW5))
                 (at start (not_blocked seg_08L_A7a_0_80 airplane_DAEW6))
                 (at start (not_blocked seg_08L_A7a_0_80 airplane_DAEW7))
                 (at start (not_blocked seg_08L_A7a_0_80 airplane_CFBE2))

                 (over all (not_occupied seg_08L_A7b_0_161_245))
                 (over all (not_occupied seg_08L_A7c_0_161_245))
                 (over all (not_occupied seg_08L_A2a_0_80))
                 (over all (not_occupied seg_09l_0_80))
              )

 :effect        (and
                 (at end (not (occupied seg_08L_A7d_0_80)))
                 (at end (not_occupied seg_08L_A7d_0_80))
                 (at start (not (at-segment ?a seg_08L_A7d_0_80)))

                 (at start (occupied seg_08L_A7a_0_80))
                 (at start (not (not_occupied seg_08L_A7a_0_80)))
                 (at start (blocked seg_08L_A7a_0_80 ?a))
                 (at start (not (not_blocked seg_08L_A7a_0_80 ?a)))
                 (at end (at-segment ?a seg_08L_A7a_0_80))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_08L_A6A7_0_450 ?a)))
                 (at end (not_blocked seg_08L_A6A7_0_450 ?a))

                 (at start (blocked seg_08L_A7b_0_161_245 ?a))
                 (at start (not (not_blocked seg_08L_A7b_0_161_245 ?a)))
                 (at start (blocked seg_08L_A7c_0_161_245 ?a))
                 (at start (not (not_blocked seg_08L_A7c_0_161_245 ?a)))
                 (at start (blocked seg_08L_A2a_0_80 ?a))
                 (at start (not (not_blocked seg_08L_A2a_0_80 ?a)))
                 (at start (blocked seg_09l_0_80 ?a))
                 (at start (not (not_blocked seg_09l_0_80 ?a)))
                )
)

(:durative-action move_seg_08L_A7a_0_80_seg_08L_A7A9_0_270_south_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_08L_A7a_0_80))
                 (at start (not_occupied seg_08L_A7A9_0_270))
                 (at start (not_blocked seg_08L_A7A9_0_270 airplane_CFBEG))
                 (at start (not_blocked seg_08L_A7A9_0_270 airplane_CFBE1))
                 (at start (not_blocked seg_08L_A7A9_0_270 airplane_CFBE3))
                 (at start (not_blocked seg_08L_A7A9_0_270 airplane_DAEW8))
                 (at start (not_blocked seg_08L_A7A9_0_270 airplane_DAEW9))
                 (at start (not_blocked seg_08L_A7A9_0_270 airplane_DAEW0))
                 (at start (not_blocked seg_08L_A7A9_0_270 airplane_DAEW3))
                 (at start (not_blocked seg_08L_A7A9_0_270 airplane_DAEWH))
                 (at start (not_blocked seg_08L_A7A9_0_270 airplane_DAEW1))
                 (at start (not_blocked seg_08L_A7A9_0_270 airplane_DAEW2))
                 (at start (not_blocked seg_08L_A7A9_0_270 airplane_DAEW4))
                 (at start (not_blocked seg_08L_A7A9_0_270 airplane_DAEW5))
                 (at start (not_blocked seg_08L_A7A9_0_270 airplane_DAEW6))
                 (at start (not_blocked seg_08L_A7A9_0_270 airplane_DAEW7))
                 (at start (not_blocked seg_08L_A7A9_0_270 airplane_CFBE2))

                 (over all (not_occupied seg_08L_A2a_0_80))
                 (over all (not_occupied seg_09l_0_80))
                 (over all (not_occupied seg_08L_A4a_0_80))
                 (over all (not_occupied seg_08L_A3a_0_80))
                 (over all (not_occupied seg_08l_0_80))
                 (over all (not_occupied seg_08L_A3A4_0_450))
                 (over all (not_occupied seg_08L_A4d_0_80))
                 (over all (not_occupied seg_08L_A6A7_0_450))
                 (over all (not_occupied seg_08L_A7d_0_80))
              )

 :effect        (and
                 (at end (not (occupied seg_08L_A7a_0_80)))
                 (at end (not_occupied seg_08L_A7a_0_80))
                 (at start (not (at-segment ?a seg_08L_A7a_0_80)))

                 (at start (occupied seg_08L_A7A9_0_270))
                 (at start (not (not_occupied seg_08L_A7A9_0_270)))
                 (at start (blocked seg_08L_A7A9_0_270 ?a))
                 (at start (not (not_blocked seg_08L_A7A9_0_270 ?a)))
                 (at end (at-segment ?a seg_08L_A7A9_0_270))

                 (at end (not (blocked seg_08L_A7b_0_161_245 ?a)))
                 (at end (not_blocked seg_08L_A7b_0_161_245 ?a))
                 (at end (not (blocked seg_08L_A7c_0_161_245 ?a)))
                 (at end (not_blocked seg_08L_A7c_0_161_245 ?a))

                 (at start (blocked seg_08L_A4a_0_80 ?a))
                 (at start (not (not_blocked seg_08L_A4a_0_80 ?a)))
                 (at start (blocked seg_08L_A3a_0_80 ?a))
                 (at start (not (not_blocked seg_08L_A3a_0_80 ?a)))
                 (at start (blocked seg_08l_0_80 ?a))
                 (at start (not (not_blocked seg_08l_0_80 ?a)))
                 (at start (blocked seg_08L_A3A4_0_450 ?a))
                 (at start (not (not_blocked seg_08L_A3A4_0_450 ?a)))
                 (at start (blocked seg_08L_A4d_0_80 ?a))
                 (at start (not (not_blocked seg_08L_A4d_0_80 ?a)))
                 (at start (blocked seg_08L_A6A7_0_450 ?a))
                 (at start (not (not_blocked seg_08L_A6A7_0_450 ?a)))
                )
)

(:durative-action move_seg_08L_A7A9_0_270_seg_08L_A9c_0_80_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 9)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_08L_A7A9_0_270))
                 (at start (not_occupied seg_08L_A9c_0_80))
                 (at start (not_blocked seg_08L_A9c_0_80 airplane_CFBEG))
                 (at start (not_blocked seg_08L_A9c_0_80 airplane_CFBE1))
                 (at start (not_blocked seg_08L_A9c_0_80 airplane_CFBE3))
                 (at start (not_blocked seg_08L_A9c_0_80 airplane_DAEW8))
                 (at start (not_blocked seg_08L_A9c_0_80 airplane_DAEW9))
                 (at start (not_blocked seg_08L_A9c_0_80 airplane_DAEW0))
                 (at start (not_blocked seg_08L_A9c_0_80 airplane_DAEW3))
                 (at start (not_blocked seg_08L_A9c_0_80 airplane_DAEWH))
                 (at start (not_blocked seg_08L_A9c_0_80 airplane_DAEW1))
                 (at start (not_blocked seg_08L_A9c_0_80 airplane_DAEW2))
                 (at start (not_blocked seg_08L_A9c_0_80 airplane_DAEW4))
                 (at start (not_blocked seg_08L_A9c_0_80 airplane_DAEW5))
                 (at start (not_blocked seg_08L_A9c_0_80 airplane_DAEW6))
                 (at start (not_blocked seg_08L_A9c_0_80 airplane_DAEW7))
                 (at start (not_blocked seg_08L_A9c_0_80 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_08L_A7A9_0_270)))
                 (at end (not_occupied seg_08L_A7A9_0_270))
                 (at start (not (at-segment ?a seg_08L_A7A9_0_270)))

                 (at start (occupied seg_08L_A9c_0_80))
                 (at start (not (not_occupied seg_08L_A9c_0_80)))
                 (at start (blocked seg_08L_A9c_0_80 ?a))
                 (at start (not (not_blocked seg_08L_A9c_0_80 ?a)))
                 (at end (at-segment ?a seg_08L_A9c_0_80))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_08L_A7a_0_80 ?a)))
                 (at end (not_blocked seg_08L_A7a_0_80 ?a))
                 (at end (not (blocked seg_08L_A2a_0_80 ?a)))
                 (at end (not_blocked seg_08L_A2a_0_80 ?a))
                 (at end (not (blocked seg_09l_0_80 ?a)))
                 (at end (not_blocked seg_09l_0_80 ?a))
                 (at end (not (blocked seg_08L_A4a_0_80 ?a)))
                 (at end (not_blocked seg_08L_A4a_0_80 ?a))
                 (at end (not (blocked seg_08L_A3a_0_80 ?a)))
                 (at end (not_blocked seg_08L_A3a_0_80 ?a))
                 (at end (not (blocked seg_08l_0_80 ?a)))
                 (at end (not_blocked seg_08l_0_80 ?a))
                 (at end (not (blocked seg_08L_A3A4_0_450 ?a)))
                 (at end (not_blocked seg_08L_A3A4_0_450 ?a))
                 (at end (not (blocked seg_08L_A4d_0_80 ?a)))
                 (at end (not_blocked seg_08L_A4d_0_80 ?a))
                 (at end (not (blocked seg_08L_A6A7_0_450 ?a)))
                 (at end (not_blocked seg_08L_A6A7_0_450 ?a))
                 (at end (not (blocked seg_08L_A7d_0_80 ?a)))
                 (at end (not_blocked seg_08L_A7d_0_80 ?a))

                )
)

(:durative-action move_seg_08L_A9c_0_80_seg_09l_0_80_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_08L_A9c_0_80))
                 (at start (not_occupied seg_09l_0_80))
                 (at start (not_blocked seg_09l_0_80 airplane_CFBEG))
                 (at start (not_blocked seg_09l_0_80 airplane_CFBE1))
                 (at start (not_blocked seg_09l_0_80 airplane_CFBE3))
                 (at start (not_blocked seg_09l_0_80 airplane_DAEW8))
                 (at start (not_blocked seg_09l_0_80 airplane_DAEW9))
                 (at start (not_blocked seg_09l_0_80 airplane_DAEW0))
                 (at start (not_blocked seg_09l_0_80 airplane_DAEW3))
                 (at start (not_blocked seg_09l_0_80 airplane_DAEWH))
                 (at start (not_blocked seg_09l_0_80 airplane_DAEW1))
                 (at start (not_blocked seg_09l_0_80 airplane_DAEW2))
                 (at start (not_blocked seg_09l_0_80 airplane_DAEW4))
                 (at start (not_blocked seg_09l_0_80 airplane_DAEW5))
                 (at start (not_blocked seg_09l_0_80 airplane_DAEW6))
                 (at start (not_blocked seg_09l_0_80 airplane_DAEW7))
                 (at start (not_blocked seg_09l_0_80 airplane_CFBE2))

                 (over all (not_occupied seg_08L_A9b_0_161_245))
                 (over all (not_occupied seg_08L_A2a_0_80))
              )

 :effect        (and
                 (at end (not (occupied seg_08L_A9c_0_80)))
                 (at end (not_occupied seg_08L_A9c_0_80))
                 (at start (not (at-segment ?a seg_08L_A9c_0_80)))

                 (at start (occupied seg_09l_0_80))
                 (at start (not (not_occupied seg_09l_0_80)))
                 (at start (blocked seg_09l_0_80 ?a))
                 (at start (not (not_blocked seg_09l_0_80 ?a)))
                 (at end (at-segment ?a seg_09l_0_80))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_08L_A7A9_0_270 ?a)))
                 (at end (not_blocked seg_08L_A7A9_0_270 ?a))

                 (at start (blocked seg_08L_A9b_0_161_245 ?a))
                 (at start (not (not_blocked seg_08L_A9b_0_161_245 ?a)))
                 (at start (blocked seg_08L_A2a_0_80 ?a))
                 (at start (not (not_blocked seg_08L_A2a_0_80 ?a)))
                )
)

(:durative-action move_seg_08R_B6c_0_80_seg_08R_B6a_0_161_245_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_08R_B6c_0_80))
                 (at start (not_occupied seg_08R_B6a_0_161_245))
                 (at start (not_blocked seg_08R_B6a_0_161_245 airplane_CFBEG))
                 (at start (not_blocked seg_08R_B6a_0_161_245 airplane_CFBE1))
                 (at start (not_blocked seg_08R_B6a_0_161_245 airplane_CFBE3))
                 (at start (not_blocked seg_08R_B6a_0_161_245 airplane_DAEW8))
                 (at start (not_blocked seg_08R_B6a_0_161_245 airplane_DAEW9))
                 (at start (not_blocked seg_08R_B6a_0_161_245 airplane_DAEW0))
                 (at start (not_blocked seg_08R_B6a_0_161_245 airplane_DAEW3))
                 (at start (not_blocked seg_08R_B6a_0_161_245 airplane_DAEWH))
                 (at start (not_blocked seg_08R_B6a_0_161_245 airplane_DAEW1))
                 (at start (not_blocked seg_08R_B6a_0_161_245 airplane_DAEW2))
                 (at start (not_blocked seg_08R_B6a_0_161_245 airplane_DAEW4))
                 (at start (not_blocked seg_08R_B6a_0_161_245 airplane_DAEW5))
                 (at start (not_blocked seg_08R_B6a_0_161_245 airplane_DAEW6))
                 (at start (not_blocked seg_08R_B6a_0_161_245 airplane_DAEW7))
                 (at start (not_blocked seg_08R_B6a_0_161_245 airplane_CFBE2))

                 (over all (not_occupied seg_08R_B6b_0_80))
                 (over all (not_occupied seg_08R_B6d_0_161_245))
              )

 :effect        (and
                 (at end (not (occupied seg_08R_B6c_0_80)))
                 (at end (not_occupied seg_08R_B6c_0_80))
                 (at start (not (at-segment ?a seg_08R_B6c_0_80)))

                 (at start (occupied seg_08R_B6a_0_161_245))
                 (at start (not (not_occupied seg_08R_B6a_0_161_245)))
                 (at start (blocked seg_08R_B6a_0_161_245 ?a))
                 (at start (not (not_blocked seg_08R_B6a_0_161_245 ?a)))
                 (at end (at-segment ?a seg_08R_B6a_0_161_245))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_08R_B4B6_0_360 ?a)))
                 (at end (not_blocked seg_08R_B4B6_0_360 ?a))

                 (at start (blocked seg_08R_B6b_0_80 ?a))
                 (at start (not (not_blocked seg_08R_B6b_0_80 ?a)))
                 (at start (blocked seg_08R_B6d_0_161_245 ?a))
                 (at start (not (not_blocked seg_08R_B6d_0_161_245 ?a)))
                )
)

(:durative-action move_seg_08R_B6a_0_161_245_seg_B8_a_0_156_924_south_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 5)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_08R_B6a_0_161_245))
                 (at start (not_occupied seg_B8_a_0_156_924))
                 (at start (not_blocked seg_B8_a_0_156_924 airplane_CFBEG))
                 (at start (not_blocked seg_B8_a_0_156_924 airplane_CFBE1))
                 (at start (not_blocked seg_B8_a_0_156_924 airplane_CFBE3))
                 (at start (not_blocked seg_B8_a_0_156_924 airplane_DAEW8))
                 (at start (not_blocked seg_B8_a_0_156_924 airplane_DAEW9))
                 (at start (not_blocked seg_B8_a_0_156_924 airplane_DAEW0))
                 (at start (not_blocked seg_B8_a_0_156_924 airplane_DAEW3))
                 (at start (not_blocked seg_B8_a_0_156_924 airplane_DAEWH))
                 (at start (not_blocked seg_B8_a_0_156_924 airplane_DAEW1))
                 (at start (not_blocked seg_B8_a_0_156_924 airplane_DAEW2))
                 (at start (not_blocked seg_B8_a_0_156_924 airplane_DAEW4))
                 (at start (not_blocked seg_B8_a_0_156_924 airplane_DAEW5))
                 (at start (not_blocked seg_B8_a_0_156_924 airplane_DAEW6))
                 (at start (not_blocked seg_B8_a_0_156_924 airplane_DAEW7))
                 (at start (not_blocked seg_B8_a_0_156_924 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_08R_B6a_0_161_245)))
                 (at end (not_occupied seg_08R_B6a_0_161_245))
                 (at start (not (at-segment ?a seg_08R_B6a_0_161_245)))

                 (at start (occupied seg_B8_a_0_156_924))
                 (at start (not (not_occupied seg_B8_a_0_156_924)))
                 (at start (blocked seg_B8_a_0_156_924 ?a))
                 (at start (not (not_blocked seg_B8_a_0_156_924 ?a)))
                 (at end (at-segment ?a seg_B8_a_0_156_924))

                 (at end (not (blocked seg_08R_B6c_0_80 ?a)))
                 (at end (not_blocked seg_08R_B6c_0_80 ?a))
                 (at end (not (blocked seg_08R_B6b_0_80 ?a)))
                 (at end (not_blocked seg_08R_B6b_0_80 ?a))
                 (at end (not (blocked seg_08R_B6d_0_161_245 ?a)))
                 (at end (not_blocked seg_08R_B6d_0_161_245 ?a))

                )
)

(:durative-action move_seg_B8_a_0_156_924_seg_B8_b_1_0_80_6226_south_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 5)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_B8_a_0_156_924))
                 (at start (not_occupied seg_B8_b_1_0_80_6226))
                 (at start (not_blocked seg_B8_b_1_0_80_6226 airplane_CFBEG))
                 (at start (not_blocked seg_B8_b_1_0_80_6226 airplane_CFBE1))
                 (at start (not_blocked seg_B8_b_1_0_80_6226 airplane_CFBE3))
                 (at start (not_blocked seg_B8_b_1_0_80_6226 airplane_DAEW8))
                 (at start (not_blocked seg_B8_b_1_0_80_6226 airplane_DAEW9))
                 (at start (not_blocked seg_B8_b_1_0_80_6226 airplane_DAEW0))
                 (at start (not_blocked seg_B8_b_1_0_80_6226 airplane_DAEW3))
                 (at start (not_blocked seg_B8_b_1_0_80_6226 airplane_DAEWH))
                 (at start (not_blocked seg_B8_b_1_0_80_6226 airplane_DAEW1))
                 (at start (not_blocked seg_B8_b_1_0_80_6226 airplane_DAEW2))
                 (at start (not_blocked seg_B8_b_1_0_80_6226 airplane_DAEW4))
                 (at start (not_blocked seg_B8_b_1_0_80_6226 airplane_DAEW5))
                 (at start (not_blocked seg_B8_b_1_0_80_6226 airplane_DAEW6))
                 (at start (not_blocked seg_B8_b_1_0_80_6226 airplane_DAEW7))
                 (at start (not_blocked seg_B8_b_1_0_80_6226 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_B8_a_0_156_924)))
                 (at end (not_occupied seg_B8_a_0_156_924))
                 (at start (not (at-segment ?a seg_B8_a_0_156_924)))

                 (at start (occupied seg_B8_b_1_0_80_6226))
                 (at start (not (not_occupied seg_B8_b_1_0_80_6226)))
                 (at start (blocked seg_B8_b_1_0_80_6226 ?a))
                 (at start (not (not_blocked seg_B8_b_1_0_80_6226 ?a)))
                 (at end (at-segment ?a seg_B8_b_1_0_80_6226))

                 (at end (not (blocked seg_08R_B6a_0_161_245 ?a)))
                 (at end (not_blocked seg_08R_B6a_0_161_245 ?a))

                )
)

(:durative-action move_seg_B8_b_1_0_80_6226_seg_B8_b_0_80_6226_south_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_B8_b_1_0_80_6226))
                 (at start (not_occupied seg_B8_b_0_80_6226))
                 (at start (not_blocked seg_B8_b_0_80_6226 airplane_CFBEG))
                 (at start (not_blocked seg_B8_b_0_80_6226 airplane_CFBE1))
                 (at start (not_blocked seg_B8_b_0_80_6226 airplane_CFBE3))
                 (at start (not_blocked seg_B8_b_0_80_6226 airplane_DAEW8))
                 (at start (not_blocked seg_B8_b_0_80_6226 airplane_DAEW9))
                 (at start (not_blocked seg_B8_b_0_80_6226 airplane_DAEW0))
                 (at start (not_blocked seg_B8_b_0_80_6226 airplane_DAEW3))
                 (at start (not_blocked seg_B8_b_0_80_6226 airplane_DAEWH))
                 (at start (not_blocked seg_B8_b_0_80_6226 airplane_DAEW1))
                 (at start (not_blocked seg_B8_b_0_80_6226 airplane_DAEW2))
                 (at start (not_blocked seg_B8_b_0_80_6226 airplane_DAEW4))
                 (at start (not_blocked seg_B8_b_0_80_6226 airplane_DAEW5))
                 (at start (not_blocked seg_B8_b_0_80_6226 airplane_DAEW6))
                 (at start (not_blocked seg_B8_b_0_80_6226 airplane_DAEW7))
                 (at start (not_blocked seg_B8_b_0_80_6226 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_B8_b_1_0_80_6226)))
                 (at end (not_occupied seg_B8_b_1_0_80_6226))
                 (at start (not (at-segment ?a seg_B8_b_1_0_80_6226)))

                 (at start (occupied seg_B8_b_0_80_6226))
                 (at start (not (not_occupied seg_B8_b_0_80_6226)))
                 (at start (blocked seg_B8_b_0_80_6226 ?a))
                 (at start (not (not_blocked seg_B8_b_0_80_6226 ?a)))
                 (at end (at-segment ?a seg_B8_b_0_80_6226))

                 (at end (not (blocked seg_B8_a_0_156_924 ?a)))
                 (at end (not_blocked seg_B8_a_0_156_924 ?a))

                )
)

(:durative-action move_seg_B8_b_0_80_6226_seg_T_B8c_0_120_934_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_B8_b_0_80_6226))
                 (at start (not_occupied seg_T_B8c_0_120_934))
                 (at start (not_blocked seg_T_B8c_0_120_934 airplane_CFBEG))
                 (at start (not_blocked seg_T_B8c_0_120_934 airplane_CFBE1))
                 (at start (not_blocked seg_T_B8c_0_120_934 airplane_CFBE3))
                 (at start (not_blocked seg_T_B8c_0_120_934 airplane_DAEW8))
                 (at start (not_blocked seg_T_B8c_0_120_934 airplane_DAEW9))
                 (at start (not_blocked seg_T_B8c_0_120_934 airplane_DAEW0))
                 (at start (not_blocked seg_T_B8c_0_120_934 airplane_DAEW3))
                 (at start (not_blocked seg_T_B8c_0_120_934 airplane_DAEWH))
                 (at start (not_blocked seg_T_B8c_0_120_934 airplane_DAEW1))
                 (at start (not_blocked seg_T_B8c_0_120_934 airplane_DAEW2))
                 (at start (not_blocked seg_T_B8c_0_120_934 airplane_DAEW4))
                 (at start (not_blocked seg_T_B8c_0_120_934 airplane_DAEW5))
                 (at start (not_blocked seg_T_B8c_0_120_934 airplane_DAEW6))
                 (at start (not_blocked seg_T_B8c_0_120_934 airplane_DAEW7))
                 (at start (not_blocked seg_T_B8c_0_120_934 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_B8_b_0_80_6226)))
                 (at end (not_occupied seg_B8_b_0_80_6226))
                 (at start (not (at-segment ?a seg_B8_b_0_80_6226)))

                 (at start (occupied seg_T_B8c_0_120_934))
                 (at start (not (not_occupied seg_T_B8c_0_120_934)))
                 (at start (blocked seg_T_B8c_0_120_934 ?a))
                 (at start (not (not_blocked seg_T_B8c_0_120_934 ?a)))
                 (at end (at-segment ?a seg_T_B8c_0_120_934))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_B8_b_1_0_80_6226 ?a)))
                 (at end (not_blocked seg_B8_b_1_0_80_6226 ?a))

                )
)

(:durative-action move_seg_T_B8c_0_120_934_seg_T_B8a_0_60_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 4)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_T_B8c_0_120_934))
                 (at start (not_occupied seg_T_B8a_0_60))
                 (at start (not_blocked seg_T_B8a_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_T_B8a_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_T_B8a_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_T_B8a_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_T_B8a_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_T_B8a_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_T_B8a_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_T_B8a_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_T_B8a_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_T_B8a_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_T_B8a_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_T_B8a_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_T_B8a_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_T_B8a_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_T_B8a_0_60 airplane_CFBE2))

                 (over all (not_occupied seg_T_B8b_0_60))
                 (over all (not_occupied seg_T_B8d_0_60))
              )

 :effect        (and
                 (at end (not (occupied seg_T_B8c_0_120_934)))
                 (at end (not_occupied seg_T_B8c_0_120_934))
                 (at start (not (at-segment ?a seg_T_B8c_0_120_934)))

                 (at start (occupied seg_T_B8a_0_60))
                 (at start (not (not_occupied seg_T_B8a_0_60)))
                 (at start (blocked seg_T_B8a_0_60 ?a))
                 (at start (not (not_blocked seg_T_B8a_0_60 ?a)))
                 (at end (at-segment ?a seg_T_B8a_0_60))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_B8_b_0_80_6226 ?a)))
                 (at end (not_blocked seg_B8_b_0_80_6226 ?a))

                 (at start (blocked seg_T_B8b_0_60 ?a))
                 (at start (not (not_blocked seg_T_B8b_0_60 ?a)))
                 (at start (blocked seg_T_B8d_0_60 ?a))
                 (at start (not (not_blocked seg_T_B8d_0_60 ?a)))
                )
)

(:durative-action move_seg_T_B8a_0_60_seg_S_B8b_0_60_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_T_B8a_0_60))
                 (at start (not_occupied seg_S_B8b_0_60))
                 (at start (not_blocked seg_S_B8b_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_S_B8b_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_S_B8b_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_S_B8b_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_S_B8b_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_S_B8b_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_S_B8b_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_S_B8b_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_S_B8b_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_S_B8b_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_S_B8b_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_S_B8b_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_S_B8b_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_S_B8b_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_S_B8b_0_60 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_T_B8a_0_60)))
                 (at end (not_occupied seg_T_B8a_0_60))
                 (at start (not (at-segment ?a seg_T_B8a_0_60)))

                 (at start (occupied seg_S_B8b_0_60))
                 (at start (not (not_occupied seg_S_B8b_0_60)))
                 (at start (blocked seg_S_B8b_0_60 ?a))
                 (at start (not (not_blocked seg_S_B8b_0_60 ?a)))
                 (at end (at-segment ?a seg_S_B8b_0_60))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_T_B8b_0_60 ?a)))
                 (at end (not_blocked seg_T_B8b_0_60 ?a))
                 (at end (not (blocked seg_T_B8c_0_120_934 ?a)))
                 (at end (not_blocked seg_T_B8c_0_120_934 ?a))
                 (at end (not (blocked seg_T_B8d_0_60 ?a)))
                 (at end (not_blocked seg_T_B8d_0_60 ?a))

                )
)

(:durative-action move_seg_S_B8b_0_60_seg_S_B8c_0_60_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_S_B8b_0_60))
                 (at start (not_occupied seg_S_B8c_0_60))
                 (at start (not_blocked seg_S_B8c_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_S_B8c_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_S_B8c_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_S_B8c_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_S_B8c_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_S_B8c_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_S_B8c_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_S_B8c_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_S_B8c_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_S_B8c_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_S_B8c_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_S_B8c_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_S_B8c_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_S_B8c_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_S_B8c_0_60 airplane_CFBE2))

                 (over all (not_occupied seg_S_B8a_0_60))
              )

 :effect        (and
                 (at end (not (occupied seg_S_B8b_0_60)))
                 (at end (not_occupied seg_S_B8b_0_60))
                 (at start (not (at-segment ?a seg_S_B8b_0_60)))

                 (at start (occupied seg_S_B8c_0_60))
                 (at start (not (not_occupied seg_S_B8c_0_60)))
                 (at start (blocked seg_S_B8c_0_60 ?a))
                 (at start (not (not_blocked seg_S_B8c_0_60 ?a)))
                 (at end (at-segment ?a seg_S_B8c_0_60))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_T_B8a_0_60 ?a)))
                 (at end (not_blocked seg_T_B8a_0_60 ?a))

                 (at start (blocked seg_S_B8a_0_60 ?a))
                 (at start (not (not_blocked seg_S_B8a_0_60 ?a)))
                )
)

(:durative-action move_seg_S_B8c_0_60_seg_S_B5B8c_0_130_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_S_B8c_0_60))
                 (at start (not_occupied seg_S_B5B8c_0_130))
                 (at start (not_blocked seg_S_B5B8c_0_130 airplane_CFBEG))
                 (at start (not_blocked seg_S_B5B8c_0_130 airplane_CFBE1))
                 (at start (not_blocked seg_S_B5B8c_0_130 airplane_CFBE3))
                 (at start (not_blocked seg_S_B5B8c_0_130 airplane_DAEW8))
                 (at start (not_blocked seg_S_B5B8c_0_130 airplane_DAEW9))
                 (at start (not_blocked seg_S_B5B8c_0_130 airplane_DAEW0))
                 (at start (not_blocked seg_S_B5B8c_0_130 airplane_DAEW3))
                 (at start (not_blocked seg_S_B5B8c_0_130 airplane_DAEWH))
                 (at start (not_blocked seg_S_B5B8c_0_130 airplane_DAEW1))
                 (at start (not_blocked seg_S_B5B8c_0_130 airplane_DAEW2))
                 (at start (not_blocked seg_S_B5B8c_0_130 airplane_DAEW4))
                 (at start (not_blocked seg_S_B5B8c_0_130 airplane_DAEW5))
                 (at start (not_blocked seg_S_B5B8c_0_130 airplane_DAEW6))
                 (at start (not_blocked seg_S_B5B8c_0_130 airplane_DAEW7))
                 (at start (not_blocked seg_S_B5B8c_0_130 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_S_B8c_0_60)))
                 (at end (not_occupied seg_S_B8c_0_60))
                 (at start (not (at-segment ?a seg_S_B8c_0_60)))

                 (at start (occupied seg_S_B5B8c_0_130))
                 (at start (not (not_occupied seg_S_B5B8c_0_130)))
                 (at start (blocked seg_S_B5B8c_0_130 ?a))
                 (at start (not (not_blocked seg_S_B5B8c_0_130 ?a)))
                 (at end (at-segment ?a seg_S_B5B8c_0_130))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_S_B8a_0_60 ?a)))
                 (at end (not_blocked seg_S_B8a_0_60 ?a))
                 (at end (not (blocked seg_S_B8b_0_60 ?a)))
                 (at end (not_blocked seg_S_B8b_0_60 ?a))

                )
)

(:durative-action move_seg_S_B5B8c_0_130_seg_S_B5B8b_0_135_north_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 4)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_S_B5B8c_0_130))
                 (at start (not_occupied seg_S_B5B8b_0_135))
                 (at start (not_blocked seg_S_B5B8b_0_135 airplane_CFBEG))
                 (at start (not_blocked seg_S_B5B8b_0_135 airplane_CFBE1))
                 (at start (not_blocked seg_S_B5B8b_0_135 airplane_CFBE3))
                 (at start (not_blocked seg_S_B5B8b_0_135 airplane_DAEW8))
                 (at start (not_blocked seg_S_B5B8b_0_135 airplane_DAEW9))
                 (at start (not_blocked seg_S_B5B8b_0_135 airplane_DAEW0))
                 (at start (not_blocked seg_S_B5B8b_0_135 airplane_DAEW3))
                 (at start (not_blocked seg_S_B5B8b_0_135 airplane_DAEWH))
                 (at start (not_blocked seg_S_B5B8b_0_135 airplane_DAEW1))
                 (at start (not_blocked seg_S_B5B8b_0_135 airplane_DAEW2))
                 (at start (not_blocked seg_S_B5B8b_0_135 airplane_DAEW4))
                 (at start (not_blocked seg_S_B5B8b_0_135 airplane_DAEW5))
                 (at start (not_blocked seg_S_B5B8b_0_135 airplane_DAEW6))
                 (at start (not_blocked seg_S_B5B8b_0_135 airplane_DAEW7))
                 (at start (not_blocked seg_S_B5B8b_0_135 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_S_B5B8c_0_130)))
                 (at end (not_occupied seg_S_B5B8c_0_130))
                 (at start (not (at-segment ?a seg_S_B5B8c_0_130)))

                 (at start (occupied seg_S_B5B8b_0_135))
                 (at start (not (not_occupied seg_S_B5B8b_0_135)))
                 (at start (blocked seg_S_B5B8b_0_135 ?a))
                 (at start (not (not_blocked seg_S_B5B8b_0_135 ?a)))
                 (at end (at-segment ?a seg_S_B5B8b_0_135))

                 (at end (not (blocked seg_S_B8c_0_60 ?a)))
                 (at end (not_blocked seg_S_B8c_0_60 ?a))

                )
)

(:durative-action move_seg_S_B5B8b_0_135_seg_S_B5B8a_0_135_north_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 4)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_S_B5B8b_0_135))
                 (at start (not_occupied seg_S_B5B8a_0_135))
                 (at start (not_blocked seg_S_B5B8a_0_135 airplane_CFBEG))
                 (at start (not_blocked seg_S_B5B8a_0_135 airplane_CFBE1))
                 (at start (not_blocked seg_S_B5B8a_0_135 airplane_CFBE3))
                 (at start (not_blocked seg_S_B5B8a_0_135 airplane_DAEW8))
                 (at start (not_blocked seg_S_B5B8a_0_135 airplane_DAEW9))
                 (at start (not_blocked seg_S_B5B8a_0_135 airplane_DAEW0))
                 (at start (not_blocked seg_S_B5B8a_0_135 airplane_DAEW3))
                 (at start (not_blocked seg_S_B5B8a_0_135 airplane_DAEWH))
                 (at start (not_blocked seg_S_B5B8a_0_135 airplane_DAEW1))
                 (at start (not_blocked seg_S_B5B8a_0_135 airplane_DAEW2))
                 (at start (not_blocked seg_S_B5B8a_0_135 airplane_DAEW4))
                 (at start (not_blocked seg_S_B5B8a_0_135 airplane_DAEW5))
                 (at start (not_blocked seg_S_B5B8a_0_135 airplane_DAEW6))
                 (at start (not_blocked seg_S_B5B8a_0_135 airplane_DAEW7))
                 (at start (not_blocked seg_S_B5B8a_0_135 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_S_B5B8b_0_135)))
                 (at end (not_occupied seg_S_B5B8b_0_135))
                 (at start (not (at-segment ?a seg_S_B5B8b_0_135)))

                 (at start (occupied seg_S_B5B8a_0_135))
                 (at start (not (not_occupied seg_S_B5B8a_0_135)))
                 (at start (blocked seg_S_B5B8a_0_135 ?a))
                 (at start (not (not_blocked seg_S_B5B8a_0_135 ?a)))
                 (at end (at-segment ?a seg_S_B5B8a_0_135))

                 (at end (not (blocked seg_S_B5B8c_0_130 ?a)))
                 (at end (not_blocked seg_S_B5B8c_0_130 ?a))

                )
)

(:durative-action move_seg_S_B5B8a_0_135_seg_S_B5b_0_60_north_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 4)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_S_B5B8a_0_135))
                 (at start (not_occupied seg_S_B5b_0_60))
                 (at start (not_blocked seg_S_B5b_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_S_B5b_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_S_B5b_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_S_B5b_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_S_B5b_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_S_B5b_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_S_B5b_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_S_B5b_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_S_B5b_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_S_B5b_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_S_B5b_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_S_B5b_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_S_B5b_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_S_B5b_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_S_B5b_0_60 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_S_B5B8a_0_135)))
                 (at end (not_occupied seg_S_B5B8a_0_135))
                 (at start (not (at-segment ?a seg_S_B5B8a_0_135)))

                 (at start (occupied seg_S_B5b_0_60))
                 (at start (not (not_occupied seg_S_B5b_0_60)))
                 (at start (blocked seg_S_B5b_0_60 ?a))
                 (at start (not (not_blocked seg_S_B5b_0_60 ?a)))
                 (at end (at-segment ?a seg_S_B5b_0_60))

                 (at end (not (blocked seg_S_B5B8b_0_135 ?a)))
                 (at end (not_blocked seg_S_B5B8b_0_135 ?a))

                )
)

(:durative-action move_seg_S_B5b_0_60_seg_S_B5a_0_60_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_S_B5b_0_60))
                 (at start (not_occupied seg_S_B5a_0_60))
                 (at start (not_blocked seg_S_B5a_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_S_B5a_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_S_B5a_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_S_B5a_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_S_B5a_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_S_B5a_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_S_B5a_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_S_B5a_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_S_B5a_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_S_B5a_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_S_B5a_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_S_B5a_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_S_B5a_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_S_B5a_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_S_B5a_0_60 airplane_CFBE2))

                 (over all (not_occupied seg_S_B5c_0_60))
                 (over all (not_occupied seg_S_B5d_0_60))
              )

 :effect        (and
                 (at end (not (occupied seg_S_B5b_0_60)))
                 (at end (not_occupied seg_S_B5b_0_60))
                 (at start (not (at-segment ?a seg_S_B5b_0_60)))

                 (at start (occupied seg_S_B5a_0_60))
                 (at start (not (not_occupied seg_S_B5a_0_60)))
                 (at start (blocked seg_S_B5a_0_60 ?a))
                 (at start (not (not_blocked seg_S_B5a_0_60 ?a)))
                 (at end (at-segment ?a seg_S_B5a_0_60))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_S_B5B8a_0_135 ?a)))
                 (at end (not_blocked seg_S_B5B8a_0_135 ?a))

                 (at start (blocked seg_S_B5c_0_60 ?a))
                 (at start (not (not_blocked seg_S_B5c_0_60 ?a)))
                 (at start (blocked seg_S_B5d_0_60 ?a))
                 (at start (not (not_blocked seg_S_B5d_0_60 ?a)))
                )
)

(:durative-action move_seg_S_B5a_0_60_seg_S6_0_94_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_S_B5a_0_60))
                 (at start (not_occupied seg_S6_0_94))
                 (at start (not_blocked seg_S6_0_94 airplane_CFBEG))
                 (at start (not_blocked seg_S6_0_94 airplane_CFBE1))
                 (at start (not_blocked seg_S6_0_94 airplane_CFBE3))
                 (at start (not_blocked seg_S6_0_94 airplane_DAEW8))
                 (at start (not_blocked seg_S6_0_94 airplane_DAEW9))
                 (at start (not_blocked seg_S6_0_94 airplane_DAEW0))
                 (at start (not_blocked seg_S6_0_94 airplane_DAEW3))
                 (at start (not_blocked seg_S6_0_94 airplane_DAEWH))
                 (at start (not_blocked seg_S6_0_94 airplane_DAEW1))
                 (at start (not_blocked seg_S6_0_94 airplane_DAEW2))
                 (at start (not_blocked seg_S6_0_94 airplane_DAEW4))
                 (at start (not_blocked seg_S6_0_94 airplane_DAEW5))
                 (at start (not_blocked seg_S6_0_94 airplane_DAEW6))
                 (at start (not_blocked seg_S6_0_94 airplane_DAEW7))
                 (at start (not_blocked seg_S6_0_94 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_S_B5a_0_60)))
                 (at end (not_occupied seg_S_B5a_0_60))
                 (at start (not (at-segment ?a seg_S_B5a_0_60)))

                 (at start (occupied seg_S6_0_94))
                 (at start (not (not_occupied seg_S6_0_94)))
                 (at start (blocked seg_S6_0_94 ?a))
                 (at start (not (not_blocked seg_S6_0_94 ?a)))
                 (at end (at-segment ?a seg_S6_0_94))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_S_B5b_0_60 ?a)))
                 (at end (not_blocked seg_S_B5b_0_60 ?a))
                 (at end (not (blocked seg_S_B5c_0_60 ?a)))
                 (at end (not_blocked seg_S_B5c_0_60 ?a))
                 (at end (not (blocked seg_S_B5d_0_60 ?a)))
                 (at end (not_blocked seg_S_B5d_0_60 ?a))

                )
)

(:durative-action move_seg_S6_0_94_seg_C4_S6b_0_60_north_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 3)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_S6_0_94))
                 (at start (not_occupied seg_C4_S6b_0_60))
                 (at start (not_blocked seg_C4_S6b_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_C4_S6b_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_C4_S6b_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_C4_S6b_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_C4_S6b_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_C4_S6b_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_C4_S6b_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_C4_S6b_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_C4_S6b_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_C4_S6b_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_C4_S6b_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_C4_S6b_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_C4_S6b_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_C4_S6b_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_C4_S6b_0_60 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_S6_0_94)))
                 (at end (not_occupied seg_S6_0_94))
                 (at start (not (at-segment ?a seg_S6_0_94)))

                 (at start (occupied seg_C4_S6b_0_60))
                 (at start (not (not_occupied seg_C4_S6b_0_60)))
                 (at start (blocked seg_C4_S6b_0_60 ?a))
                 (at start (not (not_blocked seg_C4_S6b_0_60 ?a)))
                 (at end (at-segment ?a seg_C4_S6b_0_60))

                 (at end (not (blocked seg_S_B5a_0_60 ?a)))
                 (at end (not_blocked seg_S_B5a_0_60 ?a))

                )
)

(:durative-action move_seg_C4_S6b_0_60_seg_C4_S6c_0_60_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_C4_S6b_0_60))
                 (at start (not_occupied seg_C4_S6c_0_60))
                 (at start (not_blocked seg_C4_S6c_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_C4_S6c_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_C4_S6c_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_C4_S6c_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_C4_S6c_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_C4_S6c_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_C4_S6c_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_C4_S6c_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_C4_S6c_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_C4_S6c_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_C4_S6c_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_C4_S6c_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_C4_S6c_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_C4_S6c_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_C4_S6c_0_60 airplane_CFBE2))

                 (over all (not_occupied seg_C4_S6a_0_80))
              )

 :effect        (and
                 (at end (not (occupied seg_C4_S6b_0_60)))
                 (at end (not_occupied seg_C4_S6b_0_60))
                 (at start (not (at-segment ?a seg_C4_S6b_0_60)))

                 (at start (occupied seg_C4_S6c_0_60))
                 (at start (not (not_occupied seg_C4_S6c_0_60)))
                 (at start (blocked seg_C4_S6c_0_60 ?a))
                 (at start (not (not_blocked seg_C4_S6c_0_60 ?a)))
                 (at end (at-segment ?a seg_C4_S6c_0_60))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_S6_0_94 ?a)))
                 (at end (not_blocked seg_S6_0_94 ?a))

                 (at start (blocked seg_C4_S6a_0_80 ?a))
                 (at start (not (not_blocked seg_C4_S6a_0_80 ?a)))
                )
)

(:durative-action move_seg_C4_S6c_0_60_seg_W1_C4b_0_60_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_C4_S6c_0_60))
                 (at start (not_occupied seg_W1_C4b_0_60))
                 (at start (not_blocked seg_W1_C4b_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_W1_C4b_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_W1_C4b_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_W1_C4b_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_W1_C4b_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_W1_C4b_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_W1_C4b_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_W1_C4b_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_W1_C4b_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_W1_C4b_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_W1_C4b_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_W1_C4b_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_W1_C4b_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_W1_C4b_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_W1_C4b_0_60 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_C4_S6c_0_60)))
                 (at end (not_occupied seg_C4_S6c_0_60))
                 (at start (not (at-segment ?a seg_C4_S6c_0_60)))

                 (at start (occupied seg_W1_C4b_0_60))
                 (at start (not (not_occupied seg_W1_C4b_0_60)))
                 (at start (blocked seg_W1_C4b_0_60 ?a))
                 (at start (not (not_blocked seg_W1_C4b_0_60 ?a)))
                 (at end (at-segment ?a seg_W1_C4b_0_60))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_C4_S6a_0_80 ?a)))
                 (at end (not_blocked seg_C4_S6a_0_80 ?a))
                 (at end (not (blocked seg_C4_S6b_0_60 ?a)))
                 (at end (not_blocked seg_C4_S6b_0_60 ?a))

                )
)

(:durative-action move_seg_W1_C4b_0_60_seg_W1_C4a_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_W1_C4b_0_60))
                 (at start (not_occupied seg_W1_C4a_0_34))
                 (at start (not_blocked seg_W1_C4a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_W1_C4a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_W1_C4a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_W1_C4a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_W1_C4a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_W1_C4a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_W1_C4a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_W1_C4a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_W1_C4a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_W1_C4a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_W1_C4a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_W1_C4a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_W1_C4a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_W1_C4a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_W1_C4a_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_W1_C4c_0_60))
              )

 :effect        (and
                 (at end (not (occupied seg_W1_C4b_0_60)))
                 (at end (not_occupied seg_W1_C4b_0_60))
                 (at start (not (at-segment ?a seg_W1_C4b_0_60)))

                 (at start (occupied seg_W1_C4a_0_34))
                 (at start (not (not_occupied seg_W1_C4a_0_34)))
                 (at start (blocked seg_W1_C4a_0_34 ?a))
                 (at start (not (not_blocked seg_W1_C4a_0_34 ?a)))
                 (at end (at-segment ?a seg_W1_C4a_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_C4_S6c_0_60 ?a)))
                 (at end (not_blocked seg_C4_S6c_0_60 ?a))

                 (at start (blocked seg_W1_C4c_0_60 ?a))
                 (at start (not (not_blocked seg_W1_C4c_0_60 ?a)))
                )
)

(:durative-action move_seg_W1_C4a_0_34_seg_W1_164c_0_34_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_W1_C4a_0_34))
                 (at start (not_occupied seg_W1_164c_0_34))
                 (at start (not_blocked seg_W1_164c_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_W1_164c_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_W1_164c_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_W1_164c_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_W1_164c_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_W1_164c_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_W1_164c_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_W1_164c_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_W1_164c_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_W1_164c_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_W1_164c_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_W1_164c_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_W1_164c_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_W1_164c_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_W1_164c_0_34 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_W1_C4a_0_34)))
                 (at end (not_occupied seg_W1_C4a_0_34))
                 (at start (not (at-segment ?a seg_W1_C4a_0_34)))

                 (at start (occupied seg_W1_164c_0_34))
                 (at start (not (not_occupied seg_W1_164c_0_34)))
                 (at start (blocked seg_W1_164c_0_34 ?a))
                 (at start (not (not_blocked seg_W1_164c_0_34 ?a)))
                 (at end (at-segment ?a seg_W1_164c_0_34))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_W1_C4b_0_60 ?a)))
                 (at end (not_blocked seg_W1_C4b_0_60 ?a))
                 (at end (not (blocked seg_W1_C4c_0_60 ?a)))
                 (at end (not_blocked seg_W1_C4c_0_60 ?a))

                )
)

(:durative-action move_seg_W1_164c_0_34_seg_W1_164a_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_W1_164c_0_34))
                 (at start (not_occupied seg_W1_164a_0_34))
                 (at start (not_blocked seg_W1_164a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_W1_164a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_W1_164a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_W1_164a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_W1_164a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_W1_164a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_W1_164a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_W1_164a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_W1_164a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_W1_164a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_W1_164a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_W1_164a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_W1_164a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_W1_164a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_W1_164a_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_W1_164b_0_45))
              )

 :effect        (and
                 (at end (not (occupied seg_W1_164c_0_34)))
                 (at end (not_occupied seg_W1_164c_0_34))
                 (at start (not (at-segment ?a seg_W1_164c_0_34)))

                 (at start (occupied seg_W1_164a_0_34))
                 (at start (not (not_occupied seg_W1_164a_0_34)))
                 (at start (blocked seg_W1_164a_0_34 ?a))
                 (at start (not (not_blocked seg_W1_164a_0_34 ?a)))
                 (at end (at-segment ?a seg_W1_164a_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_W1_C4a_0_34 ?a)))
                 (at end (not_blocked seg_W1_C4a_0_34 ?a))

                 (at start (blocked seg_W1_164b_0_45 ?a))
                 (at start (not (not_blocked seg_W1_164b_0_45 ?a)))
                )
)

(:durative-action move_seg_W1_164a_0_34_seg_W1_163c_0_34_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_W1_164a_0_34))
                 (at start (not_occupied seg_W1_163c_0_34))
                 (at start (not_blocked seg_W1_163c_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_W1_163c_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_W1_163c_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_W1_163c_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_W1_163c_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_W1_163c_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_W1_163c_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_W1_163c_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_W1_163c_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_W1_163c_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_W1_163c_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_W1_163c_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_W1_163c_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_W1_163c_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_W1_163c_0_34 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_W1_164a_0_34)))
                 (at end (not_occupied seg_W1_164a_0_34))
                 (at start (not (at-segment ?a seg_W1_164a_0_34)))

                 (at start (occupied seg_W1_163c_0_34))
                 (at start (not (not_occupied seg_W1_163c_0_34)))
                 (at start (blocked seg_W1_163c_0_34 ?a))
                 (at start (not (not_blocked seg_W1_163c_0_34 ?a)))
                 (at end (at-segment ?a seg_W1_163c_0_34))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_W1_164b_0_45 ?a)))
                 (at end (not_blocked seg_W1_164b_0_45 ?a))
                 (at end (not (blocked seg_W1_164c_0_34 ?a)))
                 (at end (not_blocked seg_W1_164c_0_34 ?a))

                )
)

(:durative-action move_seg_W1_163c_0_34_seg_W1_163a_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_W1_163c_0_34))
                 (at start (not_occupied seg_W1_163a_0_34))
                 (at start (not_blocked seg_W1_163a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_W1_163a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_W1_163a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_W1_163a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_W1_163a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_W1_163a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_W1_163a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_W1_163a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_W1_163a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_W1_163a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_W1_163a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_W1_163a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_W1_163a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_W1_163a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_W1_163a_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_W1_163b_0_45))
              )

 :effect        (and
                 (at end (not (occupied seg_W1_163c_0_34)))
                 (at end (not_occupied seg_W1_163c_0_34))
                 (at start (not (at-segment ?a seg_W1_163c_0_34)))

                 (at start (occupied seg_W1_163a_0_34))
                 (at start (not (not_occupied seg_W1_163a_0_34)))
                 (at start (blocked seg_W1_163a_0_34 ?a))
                 (at start (not (not_blocked seg_W1_163a_0_34 ?a)))
                 (at end (at-segment ?a seg_W1_163a_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_W1_164a_0_34 ?a)))
                 (at end (not_blocked seg_W1_164a_0_34 ?a))

                 (at start (blocked seg_W1_163b_0_45 ?a))
                 (at start (not (not_blocked seg_W1_163b_0_45 ?a)))
                )
)

(:durative-action move_seg_W1_163a_0_34_seg_W1_162c_0_34_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_W1_163a_0_34))
                 (at start (not_occupied seg_W1_162c_0_34))
                 (at start (not_blocked seg_W1_162c_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_W1_162c_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_W1_162c_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_W1_162c_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_W1_162c_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_W1_162c_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_W1_162c_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_W1_162c_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_W1_162c_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_W1_162c_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_W1_162c_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_W1_162c_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_W1_162c_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_W1_162c_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_W1_162c_0_34 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_W1_163a_0_34)))
                 (at end (not_occupied seg_W1_163a_0_34))
                 (at start (not (at-segment ?a seg_W1_163a_0_34)))

                 (at start (occupied seg_W1_162c_0_34))
                 (at start (not (not_occupied seg_W1_162c_0_34)))
                 (at start (blocked seg_W1_162c_0_34 ?a))
                 (at start (not (not_blocked seg_W1_162c_0_34 ?a)))
                 (at end (at-segment ?a seg_W1_162c_0_34))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_W1_163b_0_45 ?a)))
                 (at end (not_blocked seg_W1_163b_0_45 ?a))
                 (at end (not (blocked seg_W1_163c_0_34 ?a)))
                 (at end (not_blocked seg_W1_163c_0_34 ?a))

                )
)

(:durative-action move_seg_W1_162c_0_34_seg_W1_162a_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_W1_162c_0_34))
                 (at start (not_occupied seg_W1_162a_0_34))
                 (at start (not_blocked seg_W1_162a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_W1_162a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_W1_162a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_W1_162a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_W1_162a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_W1_162a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_W1_162a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_W1_162a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_W1_162a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_W1_162a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_W1_162a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_W1_162a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_W1_162a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_W1_162a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_W1_162a_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_W1_162b_0_45))
              )

 :effect        (and
                 (at end (not (occupied seg_W1_162c_0_34)))
                 (at end (not_occupied seg_W1_162c_0_34))
                 (at start (not (at-segment ?a seg_W1_162c_0_34)))

                 (at start (occupied seg_W1_162a_0_34))
                 (at start (not (not_occupied seg_W1_162a_0_34)))
                 (at start (blocked seg_W1_162a_0_34 ?a))
                 (at start (not (not_blocked seg_W1_162a_0_34 ?a)))
                 (at end (at-segment ?a seg_W1_162a_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_W1_163a_0_34 ?a)))
                 (at end (not_blocked seg_W1_163a_0_34 ?a))

                 (at start (blocked seg_W1_162b_0_45 ?a))
                 (at start (not (not_blocked seg_W1_162b_0_45 ?a)))
                )
)

(:durative-action move_seg_W1_162a_0_34_seg_W1_161c_0_34_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_W1_162a_0_34))
                 (at start (not_occupied seg_W1_161c_0_34))
                 (at start (not_blocked seg_W1_161c_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_W1_161c_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_W1_161c_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_W1_161c_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_W1_161c_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_W1_161c_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_W1_161c_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_W1_161c_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_W1_161c_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_W1_161c_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_W1_161c_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_W1_161c_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_W1_161c_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_W1_161c_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_W1_161c_0_34 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_W1_162a_0_34)))
                 (at end (not_occupied seg_W1_162a_0_34))
                 (at start (not (at-segment ?a seg_W1_162a_0_34)))

                 (at start (occupied seg_W1_161c_0_34))
                 (at start (not (not_occupied seg_W1_161c_0_34)))
                 (at start (blocked seg_W1_161c_0_34 ?a))
                 (at start (not (not_blocked seg_W1_161c_0_34 ?a)))
                 (at end (at-segment ?a seg_W1_161c_0_34))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_W1_162b_0_45 ?a)))
                 (at end (not_blocked seg_W1_162b_0_45 ?a))
                 (at end (not (blocked seg_W1_162c_0_34 ?a)))
                 (at end (not_blocked seg_W1_162c_0_34 ?a))

                )
)

(:durative-action move_seg_W1_161c_0_34_seg_W1_161a_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_W1_161c_0_34))
                 (at start (not_occupied seg_W1_161a_0_34))
                 (at start (not_blocked seg_W1_161a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_W1_161a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_W1_161a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_W1_161a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_W1_161a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_W1_161a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_W1_161a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_W1_161a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_W1_161a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_W1_161a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_W1_161a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_W1_161a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_W1_161a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_W1_161a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_W1_161a_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_W1_161b_0_45))
              )

 :effect        (and
                 (at end (not (occupied seg_W1_161c_0_34)))
                 (at end (not_occupied seg_W1_161c_0_34))
                 (at start (not (at-segment ?a seg_W1_161c_0_34)))

                 (at start (occupied seg_W1_161a_0_34))
                 (at start (not (not_occupied seg_W1_161a_0_34)))
                 (at start (blocked seg_W1_161a_0_34 ?a))
                 (at start (not (not_blocked seg_W1_161a_0_34 ?a)))
                 (at end (at-segment ?a seg_W1_161a_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_W1_162a_0_34 ?a)))
                 (at end (not_blocked seg_W1_162a_0_34 ?a))

                 (at start (blocked seg_W1_161b_0_45 ?a))
                 (at start (not (not_blocked seg_W1_161b_0_45 ?a)))
                )
)

(:durative-action move_seg_W1_161a_0_34_seg_W1_C3c_0_48_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_W1_161a_0_34))
                 (at start (not_occupied seg_W1_C3c_0_48))
                 (at start (not_blocked seg_W1_C3c_0_48 airplane_CFBEG))
                 (at start (not_blocked seg_W1_C3c_0_48 airplane_CFBE1))
                 (at start (not_blocked seg_W1_C3c_0_48 airplane_CFBE3))
                 (at start (not_blocked seg_W1_C3c_0_48 airplane_DAEW8))
                 (at start (not_blocked seg_W1_C3c_0_48 airplane_DAEW9))
                 (at start (not_blocked seg_W1_C3c_0_48 airplane_DAEW0))
                 (at start (not_blocked seg_W1_C3c_0_48 airplane_DAEW3))
                 (at start (not_blocked seg_W1_C3c_0_48 airplane_DAEWH))
                 (at start (not_blocked seg_W1_C3c_0_48 airplane_DAEW1))
                 (at start (not_blocked seg_W1_C3c_0_48 airplane_DAEW2))
                 (at start (not_blocked seg_W1_C3c_0_48 airplane_DAEW4))
                 (at start (not_blocked seg_W1_C3c_0_48 airplane_DAEW5))
                 (at start (not_blocked seg_W1_C3c_0_48 airplane_DAEW6))
                 (at start (not_blocked seg_W1_C3c_0_48 airplane_DAEW7))
                 (at start (not_blocked seg_W1_C3c_0_48 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_W1_161a_0_34)))
                 (at end (not_occupied seg_W1_161a_0_34))
                 (at start (not (at-segment ?a seg_W1_161a_0_34)))

                 (at start (occupied seg_W1_C3c_0_48))
                 (at start (not (not_occupied seg_W1_C3c_0_48)))
                 (at start (blocked seg_W1_C3c_0_48 ?a))
                 (at start (not (not_blocked seg_W1_C3c_0_48 ?a)))
                 (at end (at-segment ?a seg_W1_C3c_0_48))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_W1_161b_0_45 ?a)))
                 (at end (not_blocked seg_W1_161b_0_45 ?a))
                 (at end (not (blocked seg_W1_161c_0_34 ?a)))
                 (at end (not_blocked seg_W1_161c_0_34 ?a))

                )
)

(:durative-action move_seg_W1_C3c_0_48_seg_W1_C3a_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_W1_C3c_0_48))
                 (at start (not_occupied seg_W1_C3a_0_34))
                 (at start (not_blocked seg_W1_C3a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_W1_C3a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_W1_C3a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_W1_C3a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_W1_C3a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_W1_C3a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_W1_C3a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_W1_C3a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_W1_C3a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_W1_C3a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_W1_C3a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_W1_C3a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_W1_C3a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_W1_C3a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_W1_C3a_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_W1_C3b_0_60))
              )

 :effect        (and
                 (at end (not (occupied seg_W1_C3c_0_48)))
                 (at end (not_occupied seg_W1_C3c_0_48))
                 (at start (not (at-segment ?a seg_W1_C3c_0_48)))

                 (at start (occupied seg_W1_C3a_0_34))
                 (at start (not (not_occupied seg_W1_C3a_0_34)))
                 (at start (blocked seg_W1_C3a_0_34 ?a))
                 (at start (not (not_blocked seg_W1_C3a_0_34 ?a)))
                 (at end (at-segment ?a seg_W1_C3a_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_W1_161a_0_34 ?a)))
                 (at end (not_blocked seg_W1_161a_0_34 ?a))

                 (at start (blocked seg_W1_C3b_0_60 ?a))
                 (at start (not (not_blocked seg_W1_C3b_0_60 ?a)))
                )
)

(:durative-action move_seg_W1_C3a_0_34_seg_W1_154c_0_34_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_W1_C3a_0_34))
                 (at start (not_occupied seg_W1_154c_0_34))
                 (at start (not_blocked seg_W1_154c_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_W1_154c_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_W1_154c_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_W1_154c_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_W1_154c_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_W1_154c_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_W1_154c_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_W1_154c_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_W1_154c_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_W1_154c_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_W1_154c_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_W1_154c_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_W1_154c_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_W1_154c_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_W1_154c_0_34 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_W1_C3a_0_34)))
                 (at end (not_occupied seg_W1_C3a_0_34))
                 (at start (not (at-segment ?a seg_W1_C3a_0_34)))

                 (at start (occupied seg_W1_154c_0_34))
                 (at start (not (not_occupied seg_W1_154c_0_34)))
                 (at start (blocked seg_W1_154c_0_34 ?a))
                 (at start (not (not_blocked seg_W1_154c_0_34 ?a)))
                 (at end (at-segment ?a seg_W1_154c_0_34))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_W1_C3b_0_60 ?a)))
                 (at end (not_blocked seg_W1_C3b_0_60 ?a))
                 (at end (not (blocked seg_W1_C3c_0_48 ?a)))
                 (at end (not_blocked seg_W1_C3c_0_48 ?a))

                )
)

(:durative-action move_seg_W1_154c_0_34_seg_W1_154a_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_W1_154c_0_34))
                 (at start (not_occupied seg_W1_154a_0_34))
                 (at start (not_blocked seg_W1_154a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_W1_154a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_W1_154a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_W1_154a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_W1_154a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_W1_154a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_W1_154a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_W1_154a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_W1_154a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_W1_154a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_W1_154a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_W1_154a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_W1_154a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_W1_154a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_W1_154a_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_W1_154b_0_45))
              )

 :effect        (and
                 (at end (not (occupied seg_W1_154c_0_34)))
                 (at end (not_occupied seg_W1_154c_0_34))
                 (at start (not (at-segment ?a seg_W1_154c_0_34)))

                 (at start (occupied seg_W1_154a_0_34))
                 (at start (not (not_occupied seg_W1_154a_0_34)))
                 (at start (blocked seg_W1_154a_0_34 ?a))
                 (at start (not (not_blocked seg_W1_154a_0_34 ?a)))
                 (at end (at-segment ?a seg_W1_154a_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_W1_C3a_0_34 ?a)))
                 (at end (not_blocked seg_W1_C3a_0_34 ?a))

                 (at start (blocked seg_W1_154b_0_45 ?a))
                 (at start (not (not_blocked seg_W1_154b_0_45 ?a)))
                )
)

(:durative-action move_seg_W1_154a_0_34_seg_W1_153c_0_34_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_W1_154a_0_34))
                 (at start (not_occupied seg_W1_153c_0_34))
                 (at start (not_blocked seg_W1_153c_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_W1_153c_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_W1_153c_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_W1_153c_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_W1_153c_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_W1_153c_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_W1_153c_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_W1_153c_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_W1_153c_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_W1_153c_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_W1_153c_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_W1_153c_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_W1_153c_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_W1_153c_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_W1_153c_0_34 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_W1_154a_0_34)))
                 (at end (not_occupied seg_W1_154a_0_34))
                 (at start (not (at-segment ?a seg_W1_154a_0_34)))

                 (at start (occupied seg_W1_153c_0_34))
                 (at start (not (not_occupied seg_W1_153c_0_34)))
                 (at start (blocked seg_W1_153c_0_34 ?a))
                 (at start (not (not_blocked seg_W1_153c_0_34 ?a)))
                 (at end (at-segment ?a seg_W1_153c_0_34))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_W1_154b_0_45 ?a)))
                 (at end (not_blocked seg_W1_154b_0_45 ?a))
                 (at end (not (blocked seg_W1_154c_0_34 ?a)))
                 (at end (not_blocked seg_W1_154c_0_34 ?a))

                )
)

(:durative-action move_seg_W1_153c_0_34_seg_W1_153a_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_W1_153c_0_34))
                 (at start (not_occupied seg_W1_153a_0_34))
                 (at start (not_blocked seg_W1_153a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_W1_153a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_W1_153a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_W1_153a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_W1_153a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_W1_153a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_W1_153a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_W1_153a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_W1_153a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_W1_153a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_W1_153a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_W1_153a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_W1_153a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_W1_153a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_W1_153a_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_W1_153b_0_45))
              )

 :effect        (and
                 (at end (not (occupied seg_W1_153c_0_34)))
                 (at end (not_occupied seg_W1_153c_0_34))
                 (at start (not (at-segment ?a seg_W1_153c_0_34)))

                 (at start (occupied seg_W1_153a_0_34))
                 (at start (not (not_occupied seg_W1_153a_0_34)))
                 (at start (blocked seg_W1_153a_0_34 ?a))
                 (at start (not (not_blocked seg_W1_153a_0_34 ?a)))
                 (at end (at-segment ?a seg_W1_153a_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_W1_154a_0_34 ?a)))
                 (at end (not_blocked seg_W1_154a_0_34 ?a))

                 (at start (blocked seg_W1_153b_0_45 ?a))
                 (at start (not (not_blocked seg_W1_153b_0_45 ?a)))
                )
)

(:durative-action move_seg_W1_153a_0_34_seg_W1_152c_0_34_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_W1_153a_0_34))
                 (at start (not_occupied seg_W1_152c_0_34))
                 (at start (not_blocked seg_W1_152c_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_W1_152c_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_W1_152c_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_W1_152c_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_W1_152c_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_W1_152c_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_W1_152c_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_W1_152c_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_W1_152c_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_W1_152c_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_W1_152c_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_W1_152c_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_W1_152c_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_W1_152c_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_W1_152c_0_34 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_W1_153a_0_34)))
                 (at end (not_occupied seg_W1_153a_0_34))
                 (at start (not (at-segment ?a seg_W1_153a_0_34)))

                 (at start (occupied seg_W1_152c_0_34))
                 (at start (not (not_occupied seg_W1_152c_0_34)))
                 (at start (blocked seg_W1_152c_0_34 ?a))
                 (at start (not (not_blocked seg_W1_152c_0_34 ?a)))
                 (at end (at-segment ?a seg_W1_152c_0_34))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_W1_153b_0_45 ?a)))
                 (at end (not_blocked seg_W1_153b_0_45 ?a))
                 (at end (not (blocked seg_W1_153c_0_34 ?a)))
                 (at end (not_blocked seg_W1_153c_0_34 ?a))

                )
)

(:durative-action move_seg_W1_152c_0_34_seg_W1_152a_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_W1_152c_0_34))
                 (at start (not_occupied seg_W1_152a_0_34))
                 (at start (not_blocked seg_W1_152a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_W1_152a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_W1_152a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_W1_152a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_W1_152a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_W1_152a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_W1_152a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_W1_152a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_W1_152a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_W1_152a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_W1_152a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_W1_152a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_W1_152a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_W1_152a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_W1_152a_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_W1_152b_0_45))
              )

 :effect        (and
                 (at end (not (occupied seg_W1_152c_0_34)))
                 (at end (not_occupied seg_W1_152c_0_34))
                 (at start (not (at-segment ?a seg_W1_152c_0_34)))

                 (at start (occupied seg_W1_152a_0_34))
                 (at start (not (not_occupied seg_W1_152a_0_34)))
                 (at start (blocked seg_W1_152a_0_34 ?a))
                 (at start (not (not_blocked seg_W1_152a_0_34 ?a)))
                 (at end (at-segment ?a seg_W1_152a_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_W1_153a_0_34 ?a)))
                 (at end (not_blocked seg_W1_153a_0_34 ?a))

                 (at start (blocked seg_W1_152b_0_45 ?a))
                 (at start (not (not_blocked seg_W1_152b_0_45 ?a)))
                )
)

(:durative-action move_seg_W1_152a_0_34_seg_W1_151c_0_34_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_W1_152a_0_34))
                 (at start (not_occupied seg_W1_151c_0_34))
                 (at start (not_blocked seg_W1_151c_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_W1_151c_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_W1_151c_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_W1_151c_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_W1_151c_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_W1_151c_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_W1_151c_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_W1_151c_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_W1_151c_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_W1_151c_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_W1_151c_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_W1_151c_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_W1_151c_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_W1_151c_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_W1_151c_0_34 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_W1_152a_0_34)))
                 (at end (not_occupied seg_W1_152a_0_34))
                 (at start (not (at-segment ?a seg_W1_152a_0_34)))

                 (at start (occupied seg_W1_151c_0_34))
                 (at start (not (not_occupied seg_W1_151c_0_34)))
                 (at start (blocked seg_W1_151c_0_34 ?a))
                 (at start (not (not_blocked seg_W1_151c_0_34 ?a)))
                 (at end (at-segment ?a seg_W1_151c_0_34))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_W1_152b_0_45 ?a)))
                 (at end (not_blocked seg_W1_152b_0_45 ?a))
                 (at end (not (blocked seg_W1_152c_0_34 ?a)))
                 (at end (not_blocked seg_W1_152c_0_34 ?a))

                )
)

(:durative-action move_seg_W1_151c_0_34_seg_W1_151a_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_W1_151c_0_34))
                 (at start (not_occupied seg_W1_151a_0_34))
                 (at start (not_blocked seg_W1_151a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_W1_151a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_W1_151a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_W1_151a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_W1_151a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_W1_151a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_W1_151a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_W1_151a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_W1_151a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_W1_151a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_W1_151a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_W1_151a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_W1_151a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_W1_151a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_W1_151a_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_W1_151b_0_45))
              )

 :effect        (and
                 (at end (not (occupied seg_W1_151c_0_34)))
                 (at end (not_occupied seg_W1_151c_0_34))
                 (at start (not (at-segment ?a seg_W1_151c_0_34)))

                 (at start (occupied seg_W1_151a_0_34))
                 (at start (not (not_occupied seg_W1_151a_0_34)))
                 (at start (blocked seg_W1_151a_0_34 ?a))
                 (at start (not (not_blocked seg_W1_151a_0_34 ?a)))
                 (at end (at-segment ?a seg_W1_151a_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_W1_152a_0_34 ?a)))
                 (at end (not_blocked seg_W1_152a_0_34 ?a))

                 (at start (blocked seg_W1_151b_0_45 ?a))
                 (at start (not (not_blocked seg_W1_151b_0_45 ?a)))
                )
)

(:durative-action move_seg_W1_151a_0_34_seg_W1_C2c_0_34_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_W1_151a_0_34))
                 (at start (not_occupied seg_W1_C2c_0_34))
                 (at start (not_blocked seg_W1_C2c_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_W1_C2c_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_W1_C2c_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_W1_C2c_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_W1_C2c_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_W1_C2c_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_W1_C2c_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_W1_C2c_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_W1_C2c_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_W1_C2c_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_W1_C2c_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_W1_C2c_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_W1_C2c_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_W1_C2c_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_W1_C2c_0_34 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_W1_151a_0_34)))
                 (at end (not_occupied seg_W1_151a_0_34))
                 (at start (not (at-segment ?a seg_W1_151a_0_34)))

                 (at start (occupied seg_W1_C2c_0_34))
                 (at start (not (not_occupied seg_W1_C2c_0_34)))
                 (at start (blocked seg_W1_C2c_0_34 ?a))
                 (at start (not (not_blocked seg_W1_C2c_0_34 ?a)))
                 (at end (at-segment ?a seg_W1_C2c_0_34))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_W1_151b_0_45 ?a)))
                 (at end (not_blocked seg_W1_151b_0_45 ?a))
                 (at end (not (blocked seg_W1_151c_0_34 ?a)))
                 (at end (not_blocked seg_W1_151c_0_34 ?a))

                )
)

(:durative-action move_seg_W1_C2c_0_34_seg_W1_C2a_0_60_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_W1_C2c_0_34))
                 (at start (not_occupied seg_W1_C2a_0_60))
                 (at start (not_blocked seg_W1_C2a_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_W1_C2a_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_W1_C2a_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_W1_C2a_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_W1_C2a_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_W1_C2a_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_W1_C2a_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_W1_C2a_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_W1_C2a_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_W1_C2a_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_W1_C2a_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_W1_C2a_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_W1_C2a_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_W1_C2a_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_W1_C2a_0_60 airplane_CFBE2))

                 (over all (not_occupied seg_W1_C2b_0_60))
              )

 :effect        (and
                 (at end (not (occupied seg_W1_C2c_0_34)))
                 (at end (not_occupied seg_W1_C2c_0_34))
                 (at start (not (at-segment ?a seg_W1_C2c_0_34)))

                 (at start (occupied seg_W1_C2a_0_60))
                 (at start (not (not_occupied seg_W1_C2a_0_60)))
                 (at start (blocked seg_W1_C2a_0_60 ?a))
                 (at start (not (not_blocked seg_W1_C2a_0_60 ?a)))
                 (at end (at-segment ?a seg_W1_C2a_0_60))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_W1_151a_0_34 ?a)))
                 (at end (not_blocked seg_W1_151a_0_34 ?a))

                 (at start (blocked seg_W1_C2b_0_60 ?a))
                 (at start (not (not_blocked seg_W1_C2b_0_60 ?a)))
                )
)

(:durative-action move_seg_W1_C2a_0_60_seg_W1_143c_0_60_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_W1_C2a_0_60))
                 (at start (not_occupied seg_W1_143c_0_60))
                 (at start (not_blocked seg_W1_143c_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_W1_143c_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_W1_143c_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_W1_143c_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_W1_143c_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_W1_143c_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_W1_143c_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_W1_143c_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_W1_143c_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_W1_143c_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_W1_143c_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_W1_143c_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_W1_143c_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_W1_143c_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_W1_143c_0_60 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_W1_C2a_0_60)))
                 (at end (not_occupied seg_W1_C2a_0_60))
                 (at start (not (at-segment ?a seg_W1_C2a_0_60)))

                 (at start (occupied seg_W1_143c_0_60))
                 (at start (not (not_occupied seg_W1_143c_0_60)))
                 (at start (blocked seg_W1_143c_0_60 ?a))
                 (at start (not (not_blocked seg_W1_143c_0_60 ?a)))
                 (at end (at-segment ?a seg_W1_143c_0_60))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_W1_C2b_0_60 ?a)))
                 (at end (not_blocked seg_W1_C2b_0_60 ?a))
                 (at end (not (blocked seg_W1_C2c_0_34 ?a)))
                 (at end (not_blocked seg_W1_C2c_0_34 ?a))

                )
)

(:durative-action move_seg_W1_143c_0_60_seg_W1_143a_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_W1_143c_0_60))
                 (at start (not_occupied seg_W1_143a_0_34))
                 (at start (not_blocked seg_W1_143a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_W1_143a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_W1_143a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_W1_143a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_W1_143a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_W1_143a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_W1_143a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_W1_143a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_W1_143a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_W1_143a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_W1_143a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_W1_143a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_W1_143a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_W1_143a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_W1_143a_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_W1_143b_0_45))
              )

 :effect        (and
                 (at end (not (occupied seg_W1_143c_0_60)))
                 (at end (not_occupied seg_W1_143c_0_60))
                 (at start (not (at-segment ?a seg_W1_143c_0_60)))

                 (at start (occupied seg_W1_143a_0_34))
                 (at start (not (not_occupied seg_W1_143a_0_34)))
                 (at start (blocked seg_W1_143a_0_34 ?a))
                 (at start (not (not_blocked seg_W1_143a_0_34 ?a)))
                 (at end (at-segment ?a seg_W1_143a_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_W1_C2a_0_60 ?a)))
                 (at end (not_blocked seg_W1_C2a_0_60 ?a))

                 (at start (blocked seg_W1_143b_0_45 ?a))
                 (at start (not (not_blocked seg_W1_143b_0_45 ?a)))
                )
)

(:durative-action move_seg_W1_143a_0_34_seg_W1_142c_0_34_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_W1_143a_0_34))
                 (at start (not_occupied seg_W1_142c_0_34))
                 (at start (not_blocked seg_W1_142c_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_W1_142c_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_W1_142c_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_W1_142c_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_W1_142c_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_W1_142c_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_W1_142c_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_W1_142c_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_W1_142c_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_W1_142c_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_W1_142c_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_W1_142c_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_W1_142c_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_W1_142c_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_W1_142c_0_34 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_W1_143a_0_34)))
                 (at end (not_occupied seg_W1_143a_0_34))
                 (at start (not (at-segment ?a seg_W1_143a_0_34)))

                 (at start (occupied seg_W1_142c_0_34))
                 (at start (not (not_occupied seg_W1_142c_0_34)))
                 (at start (blocked seg_W1_142c_0_34 ?a))
                 (at start (not (not_blocked seg_W1_142c_0_34 ?a)))
                 (at end (at-segment ?a seg_W1_142c_0_34))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_W1_143b_0_45 ?a)))
                 (at end (not_blocked seg_W1_143b_0_45 ?a))
                 (at end (not (blocked seg_W1_143c_0_60 ?a)))
                 (at end (not_blocked seg_W1_143c_0_60 ?a))

                )
)

(:durative-action move_seg_W1_142c_0_34_seg_W1_142a_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_W1_142c_0_34))
                 (at start (not_occupied seg_W1_142a_0_34))
                 (at start (not_blocked seg_W1_142a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_W1_142a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_W1_142a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_W1_142a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_W1_142a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_W1_142a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_W1_142a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_W1_142a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_W1_142a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_W1_142a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_W1_142a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_W1_142a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_W1_142a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_W1_142a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_W1_142a_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_W1_142b_0_45))
              )

 :effect        (and
                 (at end (not (occupied seg_W1_142c_0_34)))
                 (at end (not_occupied seg_W1_142c_0_34))
                 (at start (not (at-segment ?a seg_W1_142c_0_34)))

                 (at start (occupied seg_W1_142a_0_34))
                 (at start (not (not_occupied seg_W1_142a_0_34)))
                 (at start (blocked seg_W1_142a_0_34 ?a))
                 (at start (not (not_blocked seg_W1_142a_0_34 ?a)))
                 (at end (at-segment ?a seg_W1_142a_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_W1_143a_0_34 ?a)))
                 (at end (not_blocked seg_W1_143a_0_34 ?a))

                 (at start (blocked seg_W1_142b_0_45 ?a))
                 (at start (not (not_blocked seg_W1_142b_0_45 ?a)))
                )
)

(:durative-action move_seg_W1_141c_0_34_seg_W1_141b_0_45_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_W1_141c_0_34))
                 (at start (not_occupied seg_W1_141b_0_45))
                 (at start (not_blocked seg_W1_141b_0_45 airplane_CFBEG))
                 (at start (not_blocked seg_W1_141b_0_45 airplane_CFBE1))
                 (at start (not_blocked seg_W1_141b_0_45 airplane_CFBE3))
                 (at start (not_blocked seg_W1_141b_0_45 airplane_DAEW8))
                 (at start (not_blocked seg_W1_141b_0_45 airplane_DAEW9))
                 (at start (not_blocked seg_W1_141b_0_45 airplane_DAEW0))
                 (at start (not_blocked seg_W1_141b_0_45 airplane_DAEW3))
                 (at start (not_blocked seg_W1_141b_0_45 airplane_DAEWH))
                 (at start (not_blocked seg_W1_141b_0_45 airplane_DAEW1))
                 (at start (not_blocked seg_W1_141b_0_45 airplane_DAEW2))
                 (at start (not_blocked seg_W1_141b_0_45 airplane_DAEW4))
                 (at start (not_blocked seg_W1_141b_0_45 airplane_DAEW5))
                 (at start (not_blocked seg_W1_141b_0_45 airplane_DAEW6))
                 (at start (not_blocked seg_W1_141b_0_45 airplane_DAEW7))
                 (at start (not_blocked seg_W1_141b_0_45 airplane_CFBE2))

                 (over all (not_occupied seg_W1_141a_0_34))
              )

 :effect        (and
                 (at end (not (occupied seg_W1_141c_0_34)))
                 (at end (not_occupied seg_W1_141c_0_34))
                 (at start (not (at-segment ?a seg_W1_141c_0_34)))

                 (at start (occupied seg_W1_141b_0_45))
                 (at start (not (not_occupied seg_W1_141b_0_45)))
                 (at start (blocked seg_W1_141b_0_45 ?a))
                 (at start (not (not_blocked seg_W1_141b_0_45 ?a)))
                 (at end (at-segment ?a seg_W1_141b_0_45))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_W1_142a_0_34 ?a)))
                 (at end (not_blocked seg_W1_142a_0_34 ?a))

                 (at start (blocked seg_W1_141a_0_34 ?a))
                 (at start (not (not_blocked seg_W1_141a_0_34 ?a)))
                )
)

(:durative-action move_seg_W1_141b_0_45_seg_p141_0_75_south_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_W1_141b_0_45))
                 (at start (not_occupied seg_p141_0_75))
                 (at start (not_blocked seg_p141_0_75 airplane_CFBEG))
                 (at start (not_blocked seg_p141_0_75 airplane_CFBE1))
                 (at start (not_blocked seg_p141_0_75 airplane_CFBE3))
                 (at start (not_blocked seg_p141_0_75 airplane_DAEW8))
                 (at start (not_blocked seg_p141_0_75 airplane_DAEW9))
                 (at start (not_blocked seg_p141_0_75 airplane_DAEW0))
                 (at start (not_blocked seg_p141_0_75 airplane_DAEW3))
                 (at start (not_blocked seg_p141_0_75 airplane_DAEWH))
                 (at start (not_blocked seg_p141_0_75 airplane_DAEW1))
                 (at start (not_blocked seg_p141_0_75 airplane_DAEW2))
                 (at start (not_blocked seg_p141_0_75 airplane_DAEW4))
                 (at start (not_blocked seg_p141_0_75 airplane_DAEW5))
                 (at start (not_blocked seg_p141_0_75 airplane_DAEW6))
                 (at start (not_blocked seg_p141_0_75 airplane_DAEW7))
                 (at start (not_blocked seg_p141_0_75 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_W1_141b_0_45)))
                 (at end (not_occupied seg_W1_141b_0_45))
                 (at start (not (at-segment ?a seg_W1_141b_0_45)))

                 (at start (occupied seg_p141_0_75))
                 (at start (not (not_occupied seg_p141_0_75)))
                 (at start (blocked seg_p141_0_75 ?a))
                 (at start (not (not_blocked seg_p141_0_75 ?a)))
                 (at end (at-segment ?a seg_p141_0_75))

                 (at end (not (blocked seg_W1_141a_0_34 ?a)))
                 (at end (not_blocked seg_W1_141a_0_34 ?a))
                 (at end (not (blocked seg_W1_141c_0_34 ?a)))
                 (at end (not_blocked seg_W1_141c_0_34 ?a))

                )
)

(:durative-action move_seg_08L_A7d_0_80_seg_08L_A7b_0_161_245_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_08L_A7d_0_80))
                 (at start (not_occupied seg_08L_A7b_0_161_245))
                 (at start (not_blocked seg_08L_A7b_0_161_245 airplane_CFBEG))
                 (at start (not_blocked seg_08L_A7b_0_161_245 airplane_CFBE1))
                 (at start (not_blocked seg_08L_A7b_0_161_245 airplane_CFBE3))
                 (at start (not_blocked seg_08L_A7b_0_161_245 airplane_DAEW8))
                 (at start (not_blocked seg_08L_A7b_0_161_245 airplane_DAEW9))
                 (at start (not_blocked seg_08L_A7b_0_161_245 airplane_DAEW0))
                 (at start (not_blocked seg_08L_A7b_0_161_245 airplane_DAEW3))
                 (at start (not_blocked seg_08L_A7b_0_161_245 airplane_DAEWH))
                 (at start (not_blocked seg_08L_A7b_0_161_245 airplane_DAEW1))
                 (at start (not_blocked seg_08L_A7b_0_161_245 airplane_DAEW2))
                 (at start (not_blocked seg_08L_A7b_0_161_245 airplane_DAEW4))
                 (at start (not_blocked seg_08L_A7b_0_161_245 airplane_DAEW5))
                 (at start (not_blocked seg_08L_A7b_0_161_245 airplane_DAEW6))
                 (at start (not_blocked seg_08L_A7b_0_161_245 airplane_DAEW7))
                 (at start (not_blocked seg_08L_A7b_0_161_245 airplane_CFBE2))

                 (over all (not_occupied seg_08L_A7a_0_80))
                 (over all (not_occupied seg_08L_A7c_0_161_245))
              )

 :effect        (and
                 (at end (not (occupied seg_08L_A7d_0_80)))
                 (at end (not_occupied seg_08L_A7d_0_80))
                 (at start (not (at-segment ?a seg_08L_A7d_0_80)))

                 (at start (occupied seg_08L_A7b_0_161_245))
                 (at start (not (not_occupied seg_08L_A7b_0_161_245)))
                 (at start (blocked seg_08L_A7b_0_161_245 ?a))
                 (at start (not (not_blocked seg_08L_A7b_0_161_245 ?a)))
                 (at end (at-segment ?a seg_08L_A7b_0_161_245))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_08L_A6A7_0_450 ?a)))
                 (at end (not_blocked seg_08L_A6A7_0_450 ?a))

                 (at start (blocked seg_08L_A7a_0_80 ?a))
                 (at start (not (not_blocked seg_08L_A7a_0_80 ?a)))
                 (at start (blocked seg_08L_A7c_0_161_245 ?a))
                 (at start (not (not_blocked seg_08L_A7c_0_161_245 ?a)))
                )
)

(:durative-action move_seg_08L_A7b_0_161_245_seg_A8_a_0_157_785_south_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 5)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_08L_A7b_0_161_245))
                 (at start (not_occupied seg_A8_a_0_157_785))
                 (at start (not_blocked seg_A8_a_0_157_785 airplane_CFBEG))
                 (at start (not_blocked seg_A8_a_0_157_785 airplane_CFBE1))
                 (at start (not_blocked seg_A8_a_0_157_785 airplane_CFBE3))
                 (at start (not_blocked seg_A8_a_0_157_785 airplane_DAEW8))
                 (at start (not_blocked seg_A8_a_0_157_785 airplane_DAEW9))
                 (at start (not_blocked seg_A8_a_0_157_785 airplane_DAEW0))
                 (at start (not_blocked seg_A8_a_0_157_785 airplane_DAEW3))
                 (at start (not_blocked seg_A8_a_0_157_785 airplane_DAEWH))
                 (at start (not_blocked seg_A8_a_0_157_785 airplane_DAEW1))
                 (at start (not_blocked seg_A8_a_0_157_785 airplane_DAEW2))
                 (at start (not_blocked seg_A8_a_0_157_785 airplane_DAEW4))
                 (at start (not_blocked seg_A8_a_0_157_785 airplane_DAEW5))
                 (at start (not_blocked seg_A8_a_0_157_785 airplane_DAEW6))
                 (at start (not_blocked seg_A8_a_0_157_785 airplane_DAEW7))
                 (at start (not_blocked seg_A8_a_0_157_785 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_08L_A7b_0_161_245)))
                 (at end (not_occupied seg_08L_A7b_0_161_245))
                 (at start (not (at-segment ?a seg_08L_A7b_0_161_245)))

                 (at start (occupied seg_A8_a_0_157_785))
                 (at start (not (not_occupied seg_A8_a_0_157_785)))
                 (at start (blocked seg_A8_a_0_157_785 ?a))
                 (at start (not (not_blocked seg_A8_a_0_157_785 ?a)))
                 (at end (at-segment ?a seg_A8_a_0_157_785))

                 (at end (not (blocked seg_08L_A7a_0_80 ?a)))
                 (at end (not_blocked seg_08L_A7a_0_80 ?a))
                 (at end (not (blocked seg_08L_A7c_0_161_245 ?a)))
                 (at end (not_blocked seg_08L_A7c_0_161_245 ?a))
                 (at end (not (blocked seg_08L_A7d_0_80 ?a)))
                 (at end (not_blocked seg_08L_A7d_0_80 ?a))

                )
)

(:durative-action move_seg_A8_a_0_157_785_seg_A8_b_1_0_79_7559_south_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 5)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_A8_a_0_157_785))
                 (at start (not_occupied seg_A8_b_1_0_79_7559))
                 (at start (not_blocked seg_A8_b_1_0_79_7559 airplane_CFBEG))
                 (at start (not_blocked seg_A8_b_1_0_79_7559 airplane_CFBE1))
                 (at start (not_blocked seg_A8_b_1_0_79_7559 airplane_CFBE3))
                 (at start (not_blocked seg_A8_b_1_0_79_7559 airplane_DAEW8))
                 (at start (not_blocked seg_A8_b_1_0_79_7559 airplane_DAEW9))
                 (at start (not_blocked seg_A8_b_1_0_79_7559 airplane_DAEW0))
                 (at start (not_blocked seg_A8_b_1_0_79_7559 airplane_DAEW3))
                 (at start (not_blocked seg_A8_b_1_0_79_7559 airplane_DAEWH))
                 (at start (not_blocked seg_A8_b_1_0_79_7559 airplane_DAEW1))
                 (at start (not_blocked seg_A8_b_1_0_79_7559 airplane_DAEW2))
                 (at start (not_blocked seg_A8_b_1_0_79_7559 airplane_DAEW4))
                 (at start (not_blocked seg_A8_b_1_0_79_7559 airplane_DAEW5))
                 (at start (not_blocked seg_A8_b_1_0_79_7559 airplane_DAEW6))
                 (at start (not_blocked seg_A8_b_1_0_79_7559 airplane_DAEW7))
                 (at start (not_blocked seg_A8_b_1_0_79_7559 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_A8_a_0_157_785)))
                 (at end (not_occupied seg_A8_a_0_157_785))
                 (at start (not (at-segment ?a seg_A8_a_0_157_785)))

                 (at start (occupied seg_A8_b_1_0_79_7559))
                 (at start (not (not_occupied seg_A8_b_1_0_79_7559)))
                 (at start (blocked seg_A8_b_1_0_79_7559 ?a))
                 (at start (not (not_blocked seg_A8_b_1_0_79_7559 ?a)))
                 (at end (at-segment ?a seg_A8_b_1_0_79_7559))

                 (at end (not (blocked seg_08L_A7b_0_161_245 ?a)))
                 (at end (not_blocked seg_08L_A7b_0_161_245 ?a))

                )
)

(:durative-action move_seg_A8_b_1_0_79_7559_seg_A8_b_0_80_6226_south_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_A8_b_1_0_79_7559))
                 (at start (not_occupied seg_A8_b_0_80_6226))
                 (at start (not_blocked seg_A8_b_0_80_6226 airplane_CFBEG))
                 (at start (not_blocked seg_A8_b_0_80_6226 airplane_CFBE1))
                 (at start (not_blocked seg_A8_b_0_80_6226 airplane_CFBE3))
                 (at start (not_blocked seg_A8_b_0_80_6226 airplane_DAEW8))
                 (at start (not_blocked seg_A8_b_0_80_6226 airplane_DAEW9))
                 (at start (not_blocked seg_A8_b_0_80_6226 airplane_DAEW0))
                 (at start (not_blocked seg_A8_b_0_80_6226 airplane_DAEW3))
                 (at start (not_blocked seg_A8_b_0_80_6226 airplane_DAEWH))
                 (at start (not_blocked seg_A8_b_0_80_6226 airplane_DAEW1))
                 (at start (not_blocked seg_A8_b_0_80_6226 airplane_DAEW2))
                 (at start (not_blocked seg_A8_b_0_80_6226 airplane_DAEW4))
                 (at start (not_blocked seg_A8_b_0_80_6226 airplane_DAEW5))
                 (at start (not_blocked seg_A8_b_0_80_6226 airplane_DAEW6))
                 (at start (not_blocked seg_A8_b_0_80_6226 airplane_DAEW7))
                 (at start (not_blocked seg_A8_b_0_80_6226 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_A8_b_1_0_79_7559)))
                 (at end (not_occupied seg_A8_b_1_0_79_7559))
                 (at start (not (at-segment ?a seg_A8_b_1_0_79_7559)))

                 (at start (occupied seg_A8_b_0_80_6226))
                 (at start (not (not_occupied seg_A8_b_0_80_6226)))
                 (at start (blocked seg_A8_b_0_80_6226 ?a))
                 (at start (not (not_blocked seg_A8_b_0_80_6226 ?a)))
                 (at end (at-segment ?a seg_A8_b_0_80_6226))

                 (at end (not (blocked seg_A8_a_0_157_785 ?a)))
                 (at end (not_blocked seg_A8_a_0_157_785 ?a))

                )
)

(:durative-action move_seg_A8_b_0_80_6226_seg_M_A8d_0_120_934_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_A8_b_0_80_6226))
                 (at start (not_occupied seg_M_A8d_0_120_934))
                 (at start (not_blocked seg_M_A8d_0_120_934 airplane_CFBEG))
                 (at start (not_blocked seg_M_A8d_0_120_934 airplane_CFBE1))
                 (at start (not_blocked seg_M_A8d_0_120_934 airplane_CFBE3))
                 (at start (not_blocked seg_M_A8d_0_120_934 airplane_DAEW8))
                 (at start (not_blocked seg_M_A8d_0_120_934 airplane_DAEW9))
                 (at start (not_blocked seg_M_A8d_0_120_934 airplane_DAEW0))
                 (at start (not_blocked seg_M_A8d_0_120_934 airplane_DAEW3))
                 (at start (not_blocked seg_M_A8d_0_120_934 airplane_DAEWH))
                 (at start (not_blocked seg_M_A8d_0_120_934 airplane_DAEW1))
                 (at start (not_blocked seg_M_A8d_0_120_934 airplane_DAEW2))
                 (at start (not_blocked seg_M_A8d_0_120_934 airplane_DAEW4))
                 (at start (not_blocked seg_M_A8d_0_120_934 airplane_DAEW5))
                 (at start (not_blocked seg_M_A8d_0_120_934 airplane_DAEW6))
                 (at start (not_blocked seg_M_A8d_0_120_934 airplane_DAEW7))
                 (at start (not_blocked seg_M_A8d_0_120_934 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_A8_b_0_80_6226)))
                 (at end (not_occupied seg_A8_b_0_80_6226))
                 (at start (not (at-segment ?a seg_A8_b_0_80_6226)))

                 (at start (occupied seg_M_A8d_0_120_934))
                 (at start (not (not_occupied seg_M_A8d_0_120_934)))
                 (at start (blocked seg_M_A8d_0_120_934 ?a))
                 (at start (not (not_blocked seg_M_A8d_0_120_934 ?a)))
                 (at end (at-segment ?a seg_M_A8d_0_120_934))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_A8_b_1_0_79_7559 ?a)))
                 (at end (not_blocked seg_A8_b_1_0_79_7559 ?a))

                )
)

(:durative-action move_seg_M_A8d_0_120_934_seg_M_A8b_0_60_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 4)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_M_A8d_0_120_934))
                 (at start (not_occupied seg_M_A8b_0_60))
                 (at start (not_blocked seg_M_A8b_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_M_A8b_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_M_A8b_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_M_A8b_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_M_A8b_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_M_A8b_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_M_A8b_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_M_A8b_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_M_A8b_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_M_A8b_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_M_A8b_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_M_A8b_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_M_A8b_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_M_A8b_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_M_A8b_0_60 airplane_CFBE2))

                 (over all (not_occupied seg_M_A8a_0_60))
                 (over all (not_occupied seg_M_A8c_0_60))
              )

 :effect        (and
                 (at end (not (occupied seg_M_A8d_0_120_934)))
                 (at end (not_occupied seg_M_A8d_0_120_934))
                 (at start (not (at-segment ?a seg_M_A8d_0_120_934)))

                 (at start (occupied seg_M_A8b_0_60))
                 (at start (not (not_occupied seg_M_A8b_0_60)))
                 (at start (blocked seg_M_A8b_0_60 ?a))
                 (at start (not (not_blocked seg_M_A8b_0_60 ?a)))
                 (at end (at-segment ?a seg_M_A8b_0_60))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_A8_b_0_80_6226 ?a)))
                 (at end (not_blocked seg_A8_b_0_80_6226 ?a))

                 (at start (blocked seg_M_A8a_0_60 ?a))
                 (at start (not (not_blocked seg_M_A8a_0_60 ?a)))
                 (at start (blocked seg_M_A8c_0_60 ?a))
                 (at start (not (not_blocked seg_M_A8c_0_60 ?a)))
                )
)

(:durative-action move_seg_M_A8b_0_60_seg_N_A8a_0_60_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_M_A8b_0_60))
                 (at start (not_occupied seg_N_A8a_0_60))
                 (at start (not_blocked seg_N_A8a_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_N_A8a_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_N_A8a_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_N_A8a_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_N_A8a_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_N_A8a_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_N_A8a_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_N_A8a_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_N_A8a_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_N_A8a_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_N_A8a_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_N_A8a_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_N_A8a_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_N_A8a_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_N_A8a_0_60 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_M_A8b_0_60)))
                 (at end (not_occupied seg_M_A8b_0_60))
                 (at start (not (at-segment ?a seg_M_A8b_0_60)))

                 (at start (occupied seg_N_A8a_0_60))
                 (at start (not (not_occupied seg_N_A8a_0_60)))
                 (at start (blocked seg_N_A8a_0_60 ?a))
                 (at start (not (not_blocked seg_N_A8a_0_60 ?a)))
                 (at end (at-segment ?a seg_N_A8a_0_60))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_M_A8a_0_60 ?a)))
                 (at end (not_blocked seg_M_A8a_0_60 ?a))
                 (at end (not (blocked seg_M_A8c_0_60 ?a)))
                 (at end (not_blocked seg_M_A8c_0_60 ?a))
                 (at end (not (blocked seg_M_A8d_0_120_934 ?a)))
                 (at end (not_blocked seg_M_A8d_0_120_934 ?a))

                )
)

(:durative-action move_seg_N_A8a_0_60_seg_N_A8c_0_60_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_N_A8a_0_60))
                 (at start (not_occupied seg_N_A8c_0_60))
                 (at start (not_blocked seg_N_A8c_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_N_A8c_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_N_A8c_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_N_A8c_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_N_A8c_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_N_A8c_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_N_A8c_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_N_A8c_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_N_A8c_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_N_A8c_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_N_A8c_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_N_A8c_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_N_A8c_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_N_A8c_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_N_A8c_0_60 airplane_CFBE2))

                 (over all (not_occupied seg_N_A8b_0_60))
              )

 :effect        (and
                 (at end (not (occupied seg_N_A8a_0_60)))
                 (at end (not_occupied seg_N_A8a_0_60))
                 (at start (not (at-segment ?a seg_N_A8a_0_60)))

                 (at start (occupied seg_N_A8c_0_60))
                 (at start (not (not_occupied seg_N_A8c_0_60)))
                 (at start (blocked seg_N_A8c_0_60 ?a))
                 (at start (not (not_blocked seg_N_A8c_0_60 ?a)))
                 (at end (at-segment ?a seg_N_A8c_0_60))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_M_A8b_0_60 ?a)))
                 (at end (not_blocked seg_M_A8b_0_60 ?a))

                 (at start (blocked seg_N_A8b_0_60 ?a))
                 (at start (not (not_blocked seg_N_A8b_0_60 ?a)))
                )
)

(:durative-action move_seg_N_A8c_0_60_seg_N_A6A8f_0_75_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_N_A8c_0_60))
                 (at start (not_occupied seg_N_A6A8f_0_75))
                 (at start (not_blocked seg_N_A6A8f_0_75 airplane_CFBEG))
                 (at start (not_blocked seg_N_A6A8f_0_75 airplane_CFBE1))
                 (at start (not_blocked seg_N_A6A8f_0_75 airplane_CFBE3))
                 (at start (not_blocked seg_N_A6A8f_0_75 airplane_DAEW8))
                 (at start (not_blocked seg_N_A6A8f_0_75 airplane_DAEW9))
                 (at start (not_blocked seg_N_A6A8f_0_75 airplane_DAEW0))
                 (at start (not_blocked seg_N_A6A8f_0_75 airplane_DAEW3))
                 (at start (not_blocked seg_N_A6A8f_0_75 airplane_DAEWH))
                 (at start (not_blocked seg_N_A6A8f_0_75 airplane_DAEW1))
                 (at start (not_blocked seg_N_A6A8f_0_75 airplane_DAEW2))
                 (at start (not_blocked seg_N_A6A8f_0_75 airplane_DAEW4))
                 (at start (not_blocked seg_N_A6A8f_0_75 airplane_DAEW5))
                 (at start (not_blocked seg_N_A6A8f_0_75 airplane_DAEW6))
                 (at start (not_blocked seg_N_A6A8f_0_75 airplane_DAEW7))
                 (at start (not_blocked seg_N_A6A8f_0_75 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_N_A8c_0_60)))
                 (at end (not_occupied seg_N_A8c_0_60))
                 (at start (not (at-segment ?a seg_N_A8c_0_60)))

                 (at start (occupied seg_N_A6A8f_0_75))
                 (at start (not (not_occupied seg_N_A6A8f_0_75)))
                 (at start (blocked seg_N_A6A8f_0_75 ?a))
                 (at start (not (not_blocked seg_N_A6A8f_0_75 ?a)))
                 (at end (at-segment ?a seg_N_A6A8f_0_75))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_N_A8a_0_60 ?a)))
                 (at end (not_blocked seg_N_A8a_0_60 ?a))
                 (at end (not (blocked seg_N_A8b_0_60 ?a)))
                 (at end (not_blocked seg_N_A8b_0_60 ?a))

                )
)

(:durative-action move_seg_N_A6A8f_0_75_seg_N_A6A8e_0_75_north_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_N_A6A8f_0_75))
                 (at start (not_occupied seg_N_A6A8e_0_75))
                 (at start (not_blocked seg_N_A6A8e_0_75 airplane_CFBEG))
                 (at start (not_blocked seg_N_A6A8e_0_75 airplane_CFBE1))
                 (at start (not_blocked seg_N_A6A8e_0_75 airplane_CFBE3))
                 (at start (not_blocked seg_N_A6A8e_0_75 airplane_DAEW8))
                 (at start (not_blocked seg_N_A6A8e_0_75 airplane_DAEW9))
                 (at start (not_blocked seg_N_A6A8e_0_75 airplane_DAEW0))
                 (at start (not_blocked seg_N_A6A8e_0_75 airplane_DAEW3))
                 (at start (not_blocked seg_N_A6A8e_0_75 airplane_DAEWH))
                 (at start (not_blocked seg_N_A6A8e_0_75 airplane_DAEW1))
                 (at start (not_blocked seg_N_A6A8e_0_75 airplane_DAEW2))
                 (at start (not_blocked seg_N_A6A8e_0_75 airplane_DAEW4))
                 (at start (not_blocked seg_N_A6A8e_0_75 airplane_DAEW5))
                 (at start (not_blocked seg_N_A6A8e_0_75 airplane_DAEW6))
                 (at start (not_blocked seg_N_A6A8e_0_75 airplane_DAEW7))
                 (at start (not_blocked seg_N_A6A8e_0_75 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_N_A6A8f_0_75)))
                 (at end (not_occupied seg_N_A6A8f_0_75))
                 (at start (not (at-segment ?a seg_N_A6A8f_0_75)))

                 (at start (occupied seg_N_A6A8e_0_75))
                 (at start (not (not_occupied seg_N_A6A8e_0_75)))
                 (at start (blocked seg_N_A6A8e_0_75 ?a))
                 (at start (not (not_blocked seg_N_A6A8e_0_75 ?a)))
                 (at end (at-segment ?a seg_N_A6A8e_0_75))

                 (at end (not (blocked seg_N_A8c_0_60 ?a)))
                 (at end (not_blocked seg_N_A8c_0_60 ?a))

                )
)

(:durative-action move_seg_N_A6A8e_0_75_seg_N_A6A8d_0_75_north_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_N_A6A8e_0_75))
                 (at start (not_occupied seg_N_A6A8d_0_75))
                 (at start (not_blocked seg_N_A6A8d_0_75 airplane_CFBEG))
                 (at start (not_blocked seg_N_A6A8d_0_75 airplane_CFBE1))
                 (at start (not_blocked seg_N_A6A8d_0_75 airplane_CFBE3))
                 (at start (not_blocked seg_N_A6A8d_0_75 airplane_DAEW8))
                 (at start (not_blocked seg_N_A6A8d_0_75 airplane_DAEW9))
                 (at start (not_blocked seg_N_A6A8d_0_75 airplane_DAEW0))
                 (at start (not_blocked seg_N_A6A8d_0_75 airplane_DAEW3))
                 (at start (not_blocked seg_N_A6A8d_0_75 airplane_DAEWH))
                 (at start (not_blocked seg_N_A6A8d_0_75 airplane_DAEW1))
                 (at start (not_blocked seg_N_A6A8d_0_75 airplane_DAEW2))
                 (at start (not_blocked seg_N_A6A8d_0_75 airplane_DAEW4))
                 (at start (not_blocked seg_N_A6A8d_0_75 airplane_DAEW5))
                 (at start (not_blocked seg_N_A6A8d_0_75 airplane_DAEW6))
                 (at start (not_blocked seg_N_A6A8d_0_75 airplane_DAEW7))
                 (at start (not_blocked seg_N_A6A8d_0_75 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_N_A6A8e_0_75)))
                 (at end (not_occupied seg_N_A6A8e_0_75))
                 (at start (not (at-segment ?a seg_N_A6A8e_0_75)))

                 (at start (occupied seg_N_A6A8d_0_75))
                 (at start (not (not_occupied seg_N_A6A8d_0_75)))
                 (at start (blocked seg_N_A6A8d_0_75 ?a))
                 (at start (not (not_blocked seg_N_A6A8d_0_75 ?a)))
                 (at end (at-segment ?a seg_N_A6A8d_0_75))

                 (at end (not (blocked seg_N_A6A8f_0_75 ?a)))
                 (at end (not_blocked seg_N_A6A8f_0_75 ?a))

                )
)

(:durative-action move_seg_N_A6A8d_0_75_seg_N_A6A8c_0_75_north_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_N_A6A8d_0_75))
                 (at start (not_occupied seg_N_A6A8c_0_75))
                 (at start (not_blocked seg_N_A6A8c_0_75 airplane_CFBEG))
                 (at start (not_blocked seg_N_A6A8c_0_75 airplane_CFBE1))
                 (at start (not_blocked seg_N_A6A8c_0_75 airplane_CFBE3))
                 (at start (not_blocked seg_N_A6A8c_0_75 airplane_DAEW8))
                 (at start (not_blocked seg_N_A6A8c_0_75 airplane_DAEW9))
                 (at start (not_blocked seg_N_A6A8c_0_75 airplane_DAEW0))
                 (at start (not_blocked seg_N_A6A8c_0_75 airplane_DAEW3))
                 (at start (not_blocked seg_N_A6A8c_0_75 airplane_DAEWH))
                 (at start (not_blocked seg_N_A6A8c_0_75 airplane_DAEW1))
                 (at start (not_blocked seg_N_A6A8c_0_75 airplane_DAEW2))
                 (at start (not_blocked seg_N_A6A8c_0_75 airplane_DAEW4))
                 (at start (not_blocked seg_N_A6A8c_0_75 airplane_DAEW5))
                 (at start (not_blocked seg_N_A6A8c_0_75 airplane_DAEW6))
                 (at start (not_blocked seg_N_A6A8c_0_75 airplane_DAEW7))
                 (at start (not_blocked seg_N_A6A8c_0_75 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_N_A6A8d_0_75)))
                 (at end (not_occupied seg_N_A6A8d_0_75))
                 (at start (not (at-segment ?a seg_N_A6A8d_0_75)))

                 (at start (occupied seg_N_A6A8c_0_75))
                 (at start (not (not_occupied seg_N_A6A8c_0_75)))
                 (at start (blocked seg_N_A6A8c_0_75 ?a))
                 (at start (not (not_blocked seg_N_A6A8c_0_75 ?a)))
                 (at end (at-segment ?a seg_N_A6A8c_0_75))

                 (at end (not (blocked seg_N_A6A8e_0_75 ?a)))
                 (at end (not_blocked seg_N_A6A8e_0_75 ?a))

                )
)

(:durative-action move_seg_N_A6A8c_0_75_seg_N_A6A8b_0_75_north_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_N_A6A8c_0_75))
                 (at start (not_occupied seg_N_A6A8b_0_75))
                 (at start (not_blocked seg_N_A6A8b_0_75 airplane_CFBEG))
                 (at start (not_blocked seg_N_A6A8b_0_75 airplane_CFBE1))
                 (at start (not_blocked seg_N_A6A8b_0_75 airplane_CFBE3))
                 (at start (not_blocked seg_N_A6A8b_0_75 airplane_DAEW8))
                 (at start (not_blocked seg_N_A6A8b_0_75 airplane_DAEW9))
                 (at start (not_blocked seg_N_A6A8b_0_75 airplane_DAEW0))
                 (at start (not_blocked seg_N_A6A8b_0_75 airplane_DAEW3))
                 (at start (not_blocked seg_N_A6A8b_0_75 airplane_DAEWH))
                 (at start (not_blocked seg_N_A6A8b_0_75 airplane_DAEW1))
                 (at start (not_blocked seg_N_A6A8b_0_75 airplane_DAEW2))
                 (at start (not_blocked seg_N_A6A8b_0_75 airplane_DAEW4))
                 (at start (not_blocked seg_N_A6A8b_0_75 airplane_DAEW5))
                 (at start (not_blocked seg_N_A6A8b_0_75 airplane_DAEW6))
                 (at start (not_blocked seg_N_A6A8b_0_75 airplane_DAEW7))
                 (at start (not_blocked seg_N_A6A8b_0_75 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_N_A6A8c_0_75)))
                 (at end (not_occupied seg_N_A6A8c_0_75))
                 (at start (not (at-segment ?a seg_N_A6A8c_0_75)))

                 (at start (occupied seg_N_A6A8b_0_75))
                 (at start (not (not_occupied seg_N_A6A8b_0_75)))
                 (at start (blocked seg_N_A6A8b_0_75 ?a))
                 (at start (not (not_blocked seg_N_A6A8b_0_75 ?a)))
                 (at end (at-segment ?a seg_N_A6A8b_0_75))

                 (at end (not (blocked seg_N_A6A8d_0_75 ?a)))
                 (at end (not_blocked seg_N_A6A8d_0_75 ?a))

                )
)

(:durative-action move_seg_N_A6A8b_0_75_seg_N_A6A8a_0_115_north_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_N_A6A8b_0_75))
                 (at start (not_occupied seg_N_A6A8a_0_115))
                 (at start (not_blocked seg_N_A6A8a_0_115 airplane_CFBEG))
                 (at start (not_blocked seg_N_A6A8a_0_115 airplane_CFBE1))
                 (at start (not_blocked seg_N_A6A8a_0_115 airplane_CFBE3))
                 (at start (not_blocked seg_N_A6A8a_0_115 airplane_DAEW8))
                 (at start (not_blocked seg_N_A6A8a_0_115 airplane_DAEW9))
                 (at start (not_blocked seg_N_A6A8a_0_115 airplane_DAEW0))
                 (at start (not_blocked seg_N_A6A8a_0_115 airplane_DAEW3))
                 (at start (not_blocked seg_N_A6A8a_0_115 airplane_DAEWH))
                 (at start (not_blocked seg_N_A6A8a_0_115 airplane_DAEW1))
                 (at start (not_blocked seg_N_A6A8a_0_115 airplane_DAEW2))
                 (at start (not_blocked seg_N_A6A8a_0_115 airplane_DAEW4))
                 (at start (not_blocked seg_N_A6A8a_0_115 airplane_DAEW5))
                 (at start (not_blocked seg_N_A6A8a_0_115 airplane_DAEW6))
                 (at start (not_blocked seg_N_A6A8a_0_115 airplane_DAEW7))
                 (at start (not_blocked seg_N_A6A8a_0_115 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_N_A6A8b_0_75)))
                 (at end (not_occupied seg_N_A6A8b_0_75))
                 (at start (not (at-segment ?a seg_N_A6A8b_0_75)))

                 (at start (occupied seg_N_A6A8a_0_115))
                 (at start (not (not_occupied seg_N_A6A8a_0_115)))
                 (at start (blocked seg_N_A6A8a_0_115 ?a))
                 (at start (not (not_blocked seg_N_A6A8a_0_115 ?a)))
                 (at end (at-segment ?a seg_N_A6A8a_0_115))

                 (at end (not (blocked seg_N_A6A8c_0_75 ?a)))
                 (at end (not_blocked seg_N_A6A8c_0_75 ?a))

                )
)

(:durative-action move_seg_N_A6A8a_0_115_seg_N_A6b_0_60_north_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 3)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_N_A6A8a_0_115))
                 (at start (not_occupied seg_N_A6b_0_60))
                 (at start (not_blocked seg_N_A6b_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_N_A6b_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_N_A6b_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_N_A6b_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_N_A6b_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_N_A6b_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_N_A6b_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_N_A6b_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_N_A6b_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_N_A6b_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_N_A6b_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_N_A6b_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_N_A6b_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_N_A6b_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_N_A6b_0_60 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_N_A6A8a_0_115)))
                 (at end (not_occupied seg_N_A6A8a_0_115))
                 (at start (not (at-segment ?a seg_N_A6A8a_0_115)))

                 (at start (occupied seg_N_A6b_0_60))
                 (at start (not (not_occupied seg_N_A6b_0_60)))
                 (at start (blocked seg_N_A6b_0_60 ?a))
                 (at start (not (not_blocked seg_N_A6b_0_60 ?a)))
                 (at end (at-segment ?a seg_N_A6b_0_60))

                 (at end (not (blocked seg_N_A6A8b_0_75 ?a)))
                 (at end (not_blocked seg_N_A6A8b_0_75 ?a))

                )
)

(:durative-action move_seg_N_A6b_0_60_seg_N_A6c_0_60_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_N_A6b_0_60))
                 (at start (not_occupied seg_N_A6c_0_60))
                 (at start (not_blocked seg_N_A6c_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_N_A6c_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_N_A6c_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_N_A6c_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_N_A6c_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_N_A6c_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_N_A6c_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_N_A6c_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_N_A6c_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_N_A6c_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_N_A6c_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_N_A6c_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_N_A6c_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_N_A6c_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_N_A6c_0_60 airplane_CFBE2))

                 (over all (not_occupied seg_N_A6a_0_60))
              )

 :effect        (and
                 (at end (not (occupied seg_N_A6b_0_60)))
                 (at end (not_occupied seg_N_A6b_0_60))
                 (at start (not (at-segment ?a seg_N_A6b_0_60)))

                 (at start (occupied seg_N_A6c_0_60))
                 (at start (not (not_occupied seg_N_A6c_0_60)))
                 (at start (blocked seg_N_A6c_0_60 ?a))
                 (at start (not (not_blocked seg_N_A6c_0_60 ?a)))
                 (at end (at-segment ?a seg_N_A6c_0_60))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_N_A6A8a_0_115 ?a)))
                 (at end (not_blocked seg_N_A6A8a_0_115 ?a))

                 (at start (blocked seg_N_A6a_0_60 ?a))
                 (at start (not (not_blocked seg_N_A6a_0_60 ?a)))
                )
)

(:durative-action move_seg_N_A6c_0_60_seg_N_A7A6d_0_75_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_N_A6c_0_60))
                 (at start (not_occupied seg_N_A7A6d_0_75))
                 (at start (not_blocked seg_N_A7A6d_0_75 airplane_CFBEG))
                 (at start (not_blocked seg_N_A7A6d_0_75 airplane_CFBE1))
                 (at start (not_blocked seg_N_A7A6d_0_75 airplane_CFBE3))
                 (at start (not_blocked seg_N_A7A6d_0_75 airplane_DAEW8))
                 (at start (not_blocked seg_N_A7A6d_0_75 airplane_DAEW9))
                 (at start (not_blocked seg_N_A7A6d_0_75 airplane_DAEW0))
                 (at start (not_blocked seg_N_A7A6d_0_75 airplane_DAEW3))
                 (at start (not_blocked seg_N_A7A6d_0_75 airplane_DAEWH))
                 (at start (not_blocked seg_N_A7A6d_0_75 airplane_DAEW1))
                 (at start (not_blocked seg_N_A7A6d_0_75 airplane_DAEW2))
                 (at start (not_blocked seg_N_A7A6d_0_75 airplane_DAEW4))
                 (at start (not_blocked seg_N_A7A6d_0_75 airplane_DAEW5))
                 (at start (not_blocked seg_N_A7A6d_0_75 airplane_DAEW6))
                 (at start (not_blocked seg_N_A7A6d_0_75 airplane_DAEW7))
                 (at start (not_blocked seg_N_A7A6d_0_75 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_N_A6c_0_60)))
                 (at end (not_occupied seg_N_A6c_0_60))
                 (at start (not (at-segment ?a seg_N_A6c_0_60)))

                 (at start (occupied seg_N_A7A6d_0_75))
                 (at start (not (not_occupied seg_N_A7A6d_0_75)))
                 (at start (blocked seg_N_A7A6d_0_75 ?a))
                 (at start (not (not_blocked seg_N_A7A6d_0_75 ?a)))
                 (at end (at-segment ?a seg_N_A7A6d_0_75))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_N_A6a_0_60 ?a)))
                 (at end (not_blocked seg_N_A6a_0_60 ?a))
                 (at end (not (blocked seg_N_A6b_0_60 ?a)))
                 (at end (not_blocked seg_N_A6b_0_60 ?a))

                )
)

(:durative-action move_seg_N_A7A6d_0_75_seg_N_A7A6c_0_75_north_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_N_A7A6d_0_75))
                 (at start (not_occupied seg_N_A7A6c_0_75))
                 (at start (not_blocked seg_N_A7A6c_0_75 airplane_CFBEG))
                 (at start (not_blocked seg_N_A7A6c_0_75 airplane_CFBE1))
                 (at start (not_blocked seg_N_A7A6c_0_75 airplane_CFBE3))
                 (at start (not_blocked seg_N_A7A6c_0_75 airplane_DAEW8))
                 (at start (not_blocked seg_N_A7A6c_0_75 airplane_DAEW9))
                 (at start (not_blocked seg_N_A7A6c_0_75 airplane_DAEW0))
                 (at start (not_blocked seg_N_A7A6c_0_75 airplane_DAEW3))
                 (at start (not_blocked seg_N_A7A6c_0_75 airplane_DAEWH))
                 (at start (not_blocked seg_N_A7A6c_0_75 airplane_DAEW1))
                 (at start (not_blocked seg_N_A7A6c_0_75 airplane_DAEW2))
                 (at start (not_blocked seg_N_A7A6c_0_75 airplane_DAEW4))
                 (at start (not_blocked seg_N_A7A6c_0_75 airplane_DAEW5))
                 (at start (not_blocked seg_N_A7A6c_0_75 airplane_DAEW6))
                 (at start (not_blocked seg_N_A7A6c_0_75 airplane_DAEW7))
                 (at start (not_blocked seg_N_A7A6c_0_75 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_N_A7A6d_0_75)))
                 (at end (not_occupied seg_N_A7A6d_0_75))
                 (at start (not (at-segment ?a seg_N_A7A6d_0_75)))

                 (at start (occupied seg_N_A7A6c_0_75))
                 (at start (not (not_occupied seg_N_A7A6c_0_75)))
                 (at start (blocked seg_N_A7A6c_0_75 ?a))
                 (at start (not (not_blocked seg_N_A7A6c_0_75 ?a)))
                 (at end (at-segment ?a seg_N_A7A6c_0_75))

                 (at end (not (blocked seg_N_A6c_0_60 ?a)))
                 (at end (not_blocked seg_N_A6c_0_60 ?a))

                )
)

(:durative-action move_seg_N_A7A6c_0_75_seg_N_A7A6b_0_75_north_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_N_A7A6c_0_75))
                 (at start (not_occupied seg_N_A7A6b_0_75))
                 (at start (not_blocked seg_N_A7A6b_0_75 airplane_CFBEG))
                 (at start (not_blocked seg_N_A7A6b_0_75 airplane_CFBE1))
                 (at start (not_blocked seg_N_A7A6b_0_75 airplane_CFBE3))
                 (at start (not_blocked seg_N_A7A6b_0_75 airplane_DAEW8))
                 (at start (not_blocked seg_N_A7A6b_0_75 airplane_DAEW9))
                 (at start (not_blocked seg_N_A7A6b_0_75 airplane_DAEW0))
                 (at start (not_blocked seg_N_A7A6b_0_75 airplane_DAEW3))
                 (at start (not_blocked seg_N_A7A6b_0_75 airplane_DAEWH))
                 (at start (not_blocked seg_N_A7A6b_0_75 airplane_DAEW1))
                 (at start (not_blocked seg_N_A7A6b_0_75 airplane_DAEW2))
                 (at start (not_blocked seg_N_A7A6b_0_75 airplane_DAEW4))
                 (at start (not_blocked seg_N_A7A6b_0_75 airplane_DAEW5))
                 (at start (not_blocked seg_N_A7A6b_0_75 airplane_DAEW6))
                 (at start (not_blocked seg_N_A7A6b_0_75 airplane_DAEW7))
                 (at start (not_blocked seg_N_A7A6b_0_75 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_N_A7A6c_0_75)))
                 (at end (not_occupied seg_N_A7A6c_0_75))
                 (at start (not (at-segment ?a seg_N_A7A6c_0_75)))

                 (at start (occupied seg_N_A7A6b_0_75))
                 (at start (not (not_occupied seg_N_A7A6b_0_75)))
                 (at start (blocked seg_N_A7A6b_0_75 ?a))
                 (at start (not (not_blocked seg_N_A7A6b_0_75 ?a)))
                 (at end (at-segment ?a seg_N_A7A6b_0_75))

                 (at end (not (blocked seg_N_A7A6d_0_75 ?a)))
                 (at end (not_blocked seg_N_A7A6d_0_75 ?a))

                )
)

(:durative-action move_seg_N_A7A6b_0_75_seg_N_A7A6a_0_85_north_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_N_A7A6b_0_75))
                 (at start (not_occupied seg_N_A7A6a_0_85))
                 (at start (not_blocked seg_N_A7A6a_0_85 airplane_CFBEG))
                 (at start (not_blocked seg_N_A7A6a_0_85 airplane_CFBE1))
                 (at start (not_blocked seg_N_A7A6a_0_85 airplane_CFBE3))
                 (at start (not_blocked seg_N_A7A6a_0_85 airplane_DAEW8))
                 (at start (not_blocked seg_N_A7A6a_0_85 airplane_DAEW9))
                 (at start (not_blocked seg_N_A7A6a_0_85 airplane_DAEW0))
                 (at start (not_blocked seg_N_A7A6a_0_85 airplane_DAEW3))
                 (at start (not_blocked seg_N_A7A6a_0_85 airplane_DAEWH))
                 (at start (not_blocked seg_N_A7A6a_0_85 airplane_DAEW1))
                 (at start (not_blocked seg_N_A7A6a_0_85 airplane_DAEW2))
                 (at start (not_blocked seg_N_A7A6a_0_85 airplane_DAEW4))
                 (at start (not_blocked seg_N_A7A6a_0_85 airplane_DAEW5))
                 (at start (not_blocked seg_N_A7A6a_0_85 airplane_DAEW6))
                 (at start (not_blocked seg_N_A7A6a_0_85 airplane_DAEW7))
                 (at start (not_blocked seg_N_A7A6a_0_85 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_N_A7A6b_0_75)))
                 (at end (not_occupied seg_N_A7A6b_0_75))
                 (at start (not (at-segment ?a seg_N_A7A6b_0_75)))

                 (at start (occupied seg_N_A7A6a_0_85))
                 (at start (not (not_occupied seg_N_A7A6a_0_85)))
                 (at start (blocked seg_N_A7A6a_0_85 ?a))
                 (at start (not (not_blocked seg_N_A7A6a_0_85 ?a)))
                 (at end (at-segment ?a seg_N_A7A6a_0_85))

                 (at end (not (blocked seg_N_A7A6c_0_75 ?a)))
                 (at end (not_blocked seg_N_A7A6c_0_75 ?a))

                )
)

(:durative-action move_seg_N_A7A6a_0_85_seg_N_A7b_0_60_north_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_N_A7A6a_0_85))
                 (at start (not_occupied seg_N_A7b_0_60))
                 (at start (not_blocked seg_N_A7b_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_N_A7b_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_N_A7b_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_N_A7b_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_N_A7b_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_N_A7b_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_N_A7b_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_N_A7b_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_N_A7b_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_N_A7b_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_N_A7b_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_N_A7b_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_N_A7b_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_N_A7b_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_N_A7b_0_60 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_N_A7A6a_0_85)))
                 (at end (not_occupied seg_N_A7A6a_0_85))
                 (at start (not (at-segment ?a seg_N_A7A6a_0_85)))

                 (at start (occupied seg_N_A7b_0_60))
                 (at start (not (not_occupied seg_N_A7b_0_60)))
                 (at start (blocked seg_N_A7b_0_60 ?a))
                 (at start (not (not_blocked seg_N_A7b_0_60 ?a)))
                 (at end (at-segment ?a seg_N_A7b_0_60))

                 (at end (not (blocked seg_N_A7A6b_0_75 ?a)))
                 (at end (not_blocked seg_N_A7A6b_0_75 ?a))

                )
)

(:durative-action move_seg_N_A7b_0_60_seg_N_A7c_0_60_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_N_A7b_0_60))
                 (at start (not_occupied seg_N_A7c_0_60))
                 (at start (not_blocked seg_N_A7c_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_N_A7c_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_N_A7c_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_N_A7c_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_N_A7c_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_N_A7c_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_N_A7c_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_N_A7c_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_N_A7c_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_N_A7c_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_N_A7c_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_N_A7c_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_N_A7c_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_N_A7c_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_N_A7c_0_60 airplane_CFBE2))

                 (over all (not_occupied seg_N_A7a_0_60))
              )

 :effect        (and
                 (at end (not (occupied seg_N_A7b_0_60)))
                 (at end (not_occupied seg_N_A7b_0_60))
                 (at start (not (at-segment ?a seg_N_A7b_0_60)))

                 (at start (occupied seg_N_A7c_0_60))
                 (at start (not (not_occupied seg_N_A7c_0_60)))
                 (at start (blocked seg_N_A7c_0_60 ?a))
                 (at start (not (not_blocked seg_N_A7c_0_60 ?a)))
                 (at end (at-segment ?a seg_N_A7c_0_60))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_N_A7A6a_0_85 ?a)))
                 (at end (not_blocked seg_N_A7A6a_0_85 ?a))

                 (at start (blocked seg_N_A7a_0_60 ?a))
                 (at start (not (not_blocked seg_N_A7a_0_60 ?a)))
                )
)

(:durative-action move_seg_N_A7c_0_60_seg_N_A4A7f_0_75_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_N_A7c_0_60))
                 (at start (not_occupied seg_N_A4A7f_0_75))
                 (at start (not_blocked seg_N_A4A7f_0_75 airplane_CFBEG))
                 (at start (not_blocked seg_N_A4A7f_0_75 airplane_CFBE1))
                 (at start (not_blocked seg_N_A4A7f_0_75 airplane_CFBE3))
                 (at start (not_blocked seg_N_A4A7f_0_75 airplane_DAEW8))
                 (at start (not_blocked seg_N_A4A7f_0_75 airplane_DAEW9))
                 (at start (not_blocked seg_N_A4A7f_0_75 airplane_DAEW0))
                 (at start (not_blocked seg_N_A4A7f_0_75 airplane_DAEW3))
                 (at start (not_blocked seg_N_A4A7f_0_75 airplane_DAEWH))
                 (at start (not_blocked seg_N_A4A7f_0_75 airplane_DAEW1))
                 (at start (not_blocked seg_N_A4A7f_0_75 airplane_DAEW2))
                 (at start (not_blocked seg_N_A4A7f_0_75 airplane_DAEW4))
                 (at start (not_blocked seg_N_A4A7f_0_75 airplane_DAEW5))
                 (at start (not_blocked seg_N_A4A7f_0_75 airplane_DAEW6))
                 (at start (not_blocked seg_N_A4A7f_0_75 airplane_DAEW7))
                 (at start (not_blocked seg_N_A4A7f_0_75 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_N_A7c_0_60)))
                 (at end (not_occupied seg_N_A7c_0_60))
                 (at start (not (at-segment ?a seg_N_A7c_0_60)))

                 (at start (occupied seg_N_A4A7f_0_75))
                 (at start (not (not_occupied seg_N_A4A7f_0_75)))
                 (at start (blocked seg_N_A4A7f_0_75 ?a))
                 (at start (not (not_blocked seg_N_A4A7f_0_75 ?a)))
                 (at end (at-segment ?a seg_N_A4A7f_0_75))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_N_A7a_0_60 ?a)))
                 (at end (not_blocked seg_N_A7a_0_60 ?a))
                 (at end (not (blocked seg_N_A7b_0_60 ?a)))
                 (at end (not_blocked seg_N_A7b_0_60 ?a))

                )
)

(:durative-action move_seg_N_A4A7f_0_75_seg_N_A4A7e_0_75_north_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_N_A4A7f_0_75))
                 (at start (not_occupied seg_N_A4A7e_0_75))
                 (at start (not_blocked seg_N_A4A7e_0_75 airplane_CFBEG))
                 (at start (not_blocked seg_N_A4A7e_0_75 airplane_CFBE1))
                 (at start (not_blocked seg_N_A4A7e_0_75 airplane_CFBE3))
                 (at start (not_blocked seg_N_A4A7e_0_75 airplane_DAEW8))
                 (at start (not_blocked seg_N_A4A7e_0_75 airplane_DAEW9))
                 (at start (not_blocked seg_N_A4A7e_0_75 airplane_DAEW0))
                 (at start (not_blocked seg_N_A4A7e_0_75 airplane_DAEW3))
                 (at start (not_blocked seg_N_A4A7e_0_75 airplane_DAEWH))
                 (at start (not_blocked seg_N_A4A7e_0_75 airplane_DAEW1))
                 (at start (not_blocked seg_N_A4A7e_0_75 airplane_DAEW2))
                 (at start (not_blocked seg_N_A4A7e_0_75 airplane_DAEW4))
                 (at start (not_blocked seg_N_A4A7e_0_75 airplane_DAEW5))
                 (at start (not_blocked seg_N_A4A7e_0_75 airplane_DAEW6))
                 (at start (not_blocked seg_N_A4A7e_0_75 airplane_DAEW7))
                 (at start (not_blocked seg_N_A4A7e_0_75 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_N_A4A7f_0_75)))
                 (at end (not_occupied seg_N_A4A7f_0_75))
                 (at start (not (at-segment ?a seg_N_A4A7f_0_75)))

                 (at start (occupied seg_N_A4A7e_0_75))
                 (at start (not (not_occupied seg_N_A4A7e_0_75)))
                 (at start (blocked seg_N_A4A7e_0_75 ?a))
                 (at start (not (not_blocked seg_N_A4A7e_0_75 ?a)))
                 (at end (at-segment ?a seg_N_A4A7e_0_75))

                 (at end (not (blocked seg_N_A7c_0_60 ?a)))
                 (at end (not_blocked seg_N_A7c_0_60 ?a))

                )
)

(:durative-action move_seg_N_A4A7e_0_75_seg_N_A4A7d_0_75_north_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_N_A4A7e_0_75))
                 (at start (not_occupied seg_N_A4A7d_0_75))
                 (at start (not_blocked seg_N_A4A7d_0_75 airplane_CFBEG))
                 (at start (not_blocked seg_N_A4A7d_0_75 airplane_CFBE1))
                 (at start (not_blocked seg_N_A4A7d_0_75 airplane_CFBE3))
                 (at start (not_blocked seg_N_A4A7d_0_75 airplane_DAEW8))
                 (at start (not_blocked seg_N_A4A7d_0_75 airplane_DAEW9))
                 (at start (not_blocked seg_N_A4A7d_0_75 airplane_DAEW0))
                 (at start (not_blocked seg_N_A4A7d_0_75 airplane_DAEW3))
                 (at start (not_blocked seg_N_A4A7d_0_75 airplane_DAEWH))
                 (at start (not_blocked seg_N_A4A7d_0_75 airplane_DAEW1))
                 (at start (not_blocked seg_N_A4A7d_0_75 airplane_DAEW2))
                 (at start (not_blocked seg_N_A4A7d_0_75 airplane_DAEW4))
                 (at start (not_blocked seg_N_A4A7d_0_75 airplane_DAEW5))
                 (at start (not_blocked seg_N_A4A7d_0_75 airplane_DAEW6))
                 (at start (not_blocked seg_N_A4A7d_0_75 airplane_DAEW7))
                 (at start (not_blocked seg_N_A4A7d_0_75 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_N_A4A7e_0_75)))
                 (at end (not_occupied seg_N_A4A7e_0_75))
                 (at start (not (at-segment ?a seg_N_A4A7e_0_75)))

                 (at start (occupied seg_N_A4A7d_0_75))
                 (at start (not (not_occupied seg_N_A4A7d_0_75)))
                 (at start (blocked seg_N_A4A7d_0_75 ?a))
                 (at start (not (not_blocked seg_N_A4A7d_0_75 ?a)))
                 (at end (at-segment ?a seg_N_A4A7d_0_75))

                 (at end (not (blocked seg_N_A4A7f_0_75 ?a)))
                 (at end (not_blocked seg_N_A4A7f_0_75 ?a))

                )
)

(:durative-action move_seg_N_A4A7d_0_75_seg_N_A4A7c_0_75_north_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_N_A4A7d_0_75))
                 (at start (not_occupied seg_N_A4A7c_0_75))
                 (at start (not_blocked seg_N_A4A7c_0_75 airplane_CFBEG))
                 (at start (not_blocked seg_N_A4A7c_0_75 airplane_CFBE1))
                 (at start (not_blocked seg_N_A4A7c_0_75 airplane_CFBE3))
                 (at start (not_blocked seg_N_A4A7c_0_75 airplane_DAEW8))
                 (at start (not_blocked seg_N_A4A7c_0_75 airplane_DAEW9))
                 (at start (not_blocked seg_N_A4A7c_0_75 airplane_DAEW0))
                 (at start (not_blocked seg_N_A4A7c_0_75 airplane_DAEW3))
                 (at start (not_blocked seg_N_A4A7c_0_75 airplane_DAEWH))
                 (at start (not_blocked seg_N_A4A7c_0_75 airplane_DAEW1))
                 (at start (not_blocked seg_N_A4A7c_0_75 airplane_DAEW2))
                 (at start (not_blocked seg_N_A4A7c_0_75 airplane_DAEW4))
                 (at start (not_blocked seg_N_A4A7c_0_75 airplane_DAEW5))
                 (at start (not_blocked seg_N_A4A7c_0_75 airplane_DAEW6))
                 (at start (not_blocked seg_N_A4A7c_0_75 airplane_DAEW7))
                 (at start (not_blocked seg_N_A4A7c_0_75 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_N_A4A7d_0_75)))
                 (at end (not_occupied seg_N_A4A7d_0_75))
                 (at start (not (at-segment ?a seg_N_A4A7d_0_75)))

                 (at start (occupied seg_N_A4A7c_0_75))
                 (at start (not (not_occupied seg_N_A4A7c_0_75)))
                 (at start (blocked seg_N_A4A7c_0_75 ?a))
                 (at start (not (not_blocked seg_N_A4A7c_0_75 ?a)))
                 (at end (at-segment ?a seg_N_A4A7c_0_75))

                 (at end (not (blocked seg_N_A4A7e_0_75 ?a)))
                 (at end (not_blocked seg_N_A4A7e_0_75 ?a))

                )
)

(:durative-action move_seg_N_A4A7c_0_75_seg_N_A4A7b_0_75_north_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_N_A4A7c_0_75))
                 (at start (not_occupied seg_N_A4A7b_0_75))
                 (at start (not_blocked seg_N_A4A7b_0_75 airplane_CFBEG))
                 (at start (not_blocked seg_N_A4A7b_0_75 airplane_CFBE1))
                 (at start (not_blocked seg_N_A4A7b_0_75 airplane_CFBE3))
                 (at start (not_blocked seg_N_A4A7b_0_75 airplane_DAEW8))
                 (at start (not_blocked seg_N_A4A7b_0_75 airplane_DAEW9))
                 (at start (not_blocked seg_N_A4A7b_0_75 airplane_DAEW0))
                 (at start (not_blocked seg_N_A4A7b_0_75 airplane_DAEW3))
                 (at start (not_blocked seg_N_A4A7b_0_75 airplane_DAEWH))
                 (at start (not_blocked seg_N_A4A7b_0_75 airplane_DAEW1))
                 (at start (not_blocked seg_N_A4A7b_0_75 airplane_DAEW2))
                 (at start (not_blocked seg_N_A4A7b_0_75 airplane_DAEW4))
                 (at start (not_blocked seg_N_A4A7b_0_75 airplane_DAEW5))
                 (at start (not_blocked seg_N_A4A7b_0_75 airplane_DAEW6))
                 (at start (not_blocked seg_N_A4A7b_0_75 airplane_DAEW7))
                 (at start (not_blocked seg_N_A4A7b_0_75 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_N_A4A7c_0_75)))
                 (at end (not_occupied seg_N_A4A7c_0_75))
                 (at start (not (at-segment ?a seg_N_A4A7c_0_75)))

                 (at start (occupied seg_N_A4A7b_0_75))
                 (at start (not (not_occupied seg_N_A4A7b_0_75)))
                 (at start (blocked seg_N_A4A7b_0_75 ?a))
                 (at start (not (not_blocked seg_N_A4A7b_0_75 ?a)))
                 (at end (at-segment ?a seg_N_A4A7b_0_75))

                 (at end (not (blocked seg_N_A4A7d_0_75 ?a)))
                 (at end (not_blocked seg_N_A4A7d_0_75 ?a))

                )
)

(:durative-action move_seg_N_A4A7b_0_75_seg_N_A4A7a_0_115_north_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_N_A4A7b_0_75))
                 (at start (not_occupied seg_N_A4A7a_0_115))
                 (at start (not_blocked seg_N_A4A7a_0_115 airplane_CFBEG))
                 (at start (not_blocked seg_N_A4A7a_0_115 airplane_CFBE1))
                 (at start (not_blocked seg_N_A4A7a_0_115 airplane_CFBE3))
                 (at start (not_blocked seg_N_A4A7a_0_115 airplane_DAEW8))
                 (at start (not_blocked seg_N_A4A7a_0_115 airplane_DAEW9))
                 (at start (not_blocked seg_N_A4A7a_0_115 airplane_DAEW0))
                 (at start (not_blocked seg_N_A4A7a_0_115 airplane_DAEW3))
                 (at start (not_blocked seg_N_A4A7a_0_115 airplane_DAEWH))
                 (at start (not_blocked seg_N_A4A7a_0_115 airplane_DAEW1))
                 (at start (not_blocked seg_N_A4A7a_0_115 airplane_DAEW2))
                 (at start (not_blocked seg_N_A4A7a_0_115 airplane_DAEW4))
                 (at start (not_blocked seg_N_A4A7a_0_115 airplane_DAEW5))
                 (at start (not_blocked seg_N_A4A7a_0_115 airplane_DAEW6))
                 (at start (not_blocked seg_N_A4A7a_0_115 airplane_DAEW7))
                 (at start (not_blocked seg_N_A4A7a_0_115 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_N_A4A7b_0_75)))
                 (at end (not_occupied seg_N_A4A7b_0_75))
                 (at start (not (at-segment ?a seg_N_A4A7b_0_75)))

                 (at start (occupied seg_N_A4A7a_0_115))
                 (at start (not (not_occupied seg_N_A4A7a_0_115)))
                 (at start (blocked seg_N_A4A7a_0_115 ?a))
                 (at start (not (not_blocked seg_N_A4A7a_0_115 ?a)))
                 (at end (at-segment ?a seg_N_A4A7a_0_115))

                 (at end (not (blocked seg_N_A4A7c_0_75 ?a)))
                 (at end (not_blocked seg_N_A4A7c_0_75 ?a))

                )
)

(:durative-action move_seg_N_A4A7a_0_115_seg_N_A4b_0_60_north_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 3)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_N_A4A7a_0_115))
                 (at start (not_occupied seg_N_A4b_0_60))
                 (at start (not_blocked seg_N_A4b_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_N_A4b_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_N_A4b_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_N_A4b_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_N_A4b_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_N_A4b_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_N_A4b_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_N_A4b_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_N_A4b_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_N_A4b_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_N_A4b_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_N_A4b_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_N_A4b_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_N_A4b_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_N_A4b_0_60 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_N_A4A7a_0_115)))
                 (at end (not_occupied seg_N_A4A7a_0_115))
                 (at start (not (at-segment ?a seg_N_A4A7a_0_115)))

                 (at start (occupied seg_N_A4b_0_60))
                 (at start (not (not_occupied seg_N_A4b_0_60)))
                 (at start (blocked seg_N_A4b_0_60 ?a))
                 (at start (not (not_blocked seg_N_A4b_0_60 ?a)))
                 (at end (at-segment ?a seg_N_A4b_0_60))

                 (at end (not (blocked seg_N_A4A7b_0_75 ?a)))
                 (at end (not_blocked seg_N_A4A7b_0_75 ?a))

                )
)

(:durative-action move_seg_N_A4b_0_60_seg_N_A4c_0_60_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_N_A4b_0_60))
                 (at start (not_occupied seg_N_A4c_0_60))
                 (at start (not_blocked seg_N_A4c_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_N_A4c_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_N_A4c_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_N_A4c_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_N_A4c_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_N_A4c_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_N_A4c_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_N_A4c_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_N_A4c_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_N_A4c_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_N_A4c_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_N_A4c_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_N_A4c_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_N_A4c_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_N_A4c_0_60 airplane_CFBE2))

                 (over all (not_occupied seg_N_A4a_0_60))
              )

 :effect        (and
                 (at end (not (occupied seg_N_A4b_0_60)))
                 (at end (not_occupied seg_N_A4b_0_60))
                 (at start (not (at-segment ?a seg_N_A4b_0_60)))

                 (at start (occupied seg_N_A4c_0_60))
                 (at start (not (not_occupied seg_N_A4c_0_60)))
                 (at start (blocked seg_N_A4c_0_60 ?a))
                 (at start (not (not_blocked seg_N_A4c_0_60 ?a)))
                 (at end (at-segment ?a seg_N_A4c_0_60))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_N_A4A7a_0_115 ?a)))
                 (at end (not_blocked seg_N_A4A7a_0_115 ?a))

                 (at start (blocked seg_N_A4a_0_60 ?a))
                 (at start (not (not_blocked seg_N_A4a_0_60 ?a)))
                )
)

(:durative-action move_seg_N_A4c_0_60_seg_N_N2A4e_0_75_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_N_A4c_0_60))
                 (at start (not_occupied seg_N_N2A4e_0_75))
                 (at start (not_blocked seg_N_N2A4e_0_75 airplane_CFBEG))
                 (at start (not_blocked seg_N_N2A4e_0_75 airplane_CFBE1))
                 (at start (not_blocked seg_N_N2A4e_0_75 airplane_CFBE3))
                 (at start (not_blocked seg_N_N2A4e_0_75 airplane_DAEW8))
                 (at start (not_blocked seg_N_N2A4e_0_75 airplane_DAEW9))
                 (at start (not_blocked seg_N_N2A4e_0_75 airplane_DAEW0))
                 (at start (not_blocked seg_N_N2A4e_0_75 airplane_DAEW3))
                 (at start (not_blocked seg_N_N2A4e_0_75 airplane_DAEWH))
                 (at start (not_blocked seg_N_N2A4e_0_75 airplane_DAEW1))
                 (at start (not_blocked seg_N_N2A4e_0_75 airplane_DAEW2))
                 (at start (not_blocked seg_N_N2A4e_0_75 airplane_DAEW4))
                 (at start (not_blocked seg_N_N2A4e_0_75 airplane_DAEW5))
                 (at start (not_blocked seg_N_N2A4e_0_75 airplane_DAEW6))
                 (at start (not_blocked seg_N_N2A4e_0_75 airplane_DAEW7))
                 (at start (not_blocked seg_N_N2A4e_0_75 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_N_A4c_0_60)))
                 (at end (not_occupied seg_N_A4c_0_60))
                 (at start (not (at-segment ?a seg_N_A4c_0_60)))

                 (at start (occupied seg_N_N2A4e_0_75))
                 (at start (not (not_occupied seg_N_N2A4e_0_75)))
                 (at start (blocked seg_N_N2A4e_0_75 ?a))
                 (at start (not (not_blocked seg_N_N2A4e_0_75 ?a)))
                 (at end (at-segment ?a seg_N_N2A4e_0_75))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_N_A4a_0_60 ?a)))
                 (at end (not_blocked seg_N_A4a_0_60 ?a))
                 (at end (not (blocked seg_N_A4b_0_60 ?a)))
                 (at end (not_blocked seg_N_A4b_0_60 ?a))

                )
)

(:durative-action move_seg_N_N2A4e_0_75_seg_N_N2A4d_0_75_north_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_N_N2A4e_0_75))
                 (at start (not_occupied seg_N_N2A4d_0_75))
                 (at start (not_blocked seg_N_N2A4d_0_75 airplane_CFBEG))
                 (at start (not_blocked seg_N_N2A4d_0_75 airplane_CFBE1))
                 (at start (not_blocked seg_N_N2A4d_0_75 airplane_CFBE3))
                 (at start (not_blocked seg_N_N2A4d_0_75 airplane_DAEW8))
                 (at start (not_blocked seg_N_N2A4d_0_75 airplane_DAEW9))
                 (at start (not_blocked seg_N_N2A4d_0_75 airplane_DAEW0))
                 (at start (not_blocked seg_N_N2A4d_0_75 airplane_DAEW3))
                 (at start (not_blocked seg_N_N2A4d_0_75 airplane_DAEWH))
                 (at start (not_blocked seg_N_N2A4d_0_75 airplane_DAEW1))
                 (at start (not_blocked seg_N_N2A4d_0_75 airplane_DAEW2))
                 (at start (not_blocked seg_N_N2A4d_0_75 airplane_DAEW4))
                 (at start (not_blocked seg_N_N2A4d_0_75 airplane_DAEW5))
                 (at start (not_blocked seg_N_N2A4d_0_75 airplane_DAEW6))
                 (at start (not_blocked seg_N_N2A4d_0_75 airplane_DAEW7))
                 (at start (not_blocked seg_N_N2A4d_0_75 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_N_N2A4e_0_75)))
                 (at end (not_occupied seg_N_N2A4e_0_75))
                 (at start (not (at-segment ?a seg_N_N2A4e_0_75)))

                 (at start (occupied seg_N_N2A4d_0_75))
                 (at start (not (not_occupied seg_N_N2A4d_0_75)))
                 (at start (blocked seg_N_N2A4d_0_75 ?a))
                 (at start (not (not_blocked seg_N_N2A4d_0_75 ?a)))
                 (at end (at-segment ?a seg_N_N2A4d_0_75))

                 (at end (not (blocked seg_N_A4c_0_60 ?a)))
                 (at end (not_blocked seg_N_A4c_0_60 ?a))

                )
)

(:durative-action move_seg_N_N2A4d_0_75_seg_N_N2A4c_0_75_north_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_N_N2A4d_0_75))
                 (at start (not_occupied seg_N_N2A4c_0_75))
                 (at start (not_blocked seg_N_N2A4c_0_75 airplane_CFBEG))
                 (at start (not_blocked seg_N_N2A4c_0_75 airplane_CFBE1))
                 (at start (not_blocked seg_N_N2A4c_0_75 airplane_CFBE3))
                 (at start (not_blocked seg_N_N2A4c_0_75 airplane_DAEW8))
                 (at start (not_blocked seg_N_N2A4c_0_75 airplane_DAEW9))
                 (at start (not_blocked seg_N_N2A4c_0_75 airplane_DAEW0))
                 (at start (not_blocked seg_N_N2A4c_0_75 airplane_DAEW3))
                 (at start (not_blocked seg_N_N2A4c_0_75 airplane_DAEWH))
                 (at start (not_blocked seg_N_N2A4c_0_75 airplane_DAEW1))
                 (at start (not_blocked seg_N_N2A4c_0_75 airplane_DAEW2))
                 (at start (not_blocked seg_N_N2A4c_0_75 airplane_DAEW4))
                 (at start (not_blocked seg_N_N2A4c_0_75 airplane_DAEW5))
                 (at start (not_blocked seg_N_N2A4c_0_75 airplane_DAEW6))
                 (at start (not_blocked seg_N_N2A4c_0_75 airplane_DAEW7))
                 (at start (not_blocked seg_N_N2A4c_0_75 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_N_N2A4d_0_75)))
                 (at end (not_occupied seg_N_N2A4d_0_75))
                 (at start (not (at-segment ?a seg_N_N2A4d_0_75)))

                 (at start (occupied seg_N_N2A4c_0_75))
                 (at start (not (not_occupied seg_N_N2A4c_0_75)))
                 (at start (blocked seg_N_N2A4c_0_75 ?a))
                 (at start (not (not_blocked seg_N_N2A4c_0_75 ?a)))
                 (at end (at-segment ?a seg_N_N2A4c_0_75))

                 (at end (not (blocked seg_N_N2A4e_0_75 ?a)))
                 (at end (not_blocked seg_N_N2A4e_0_75 ?a))

                )
)

(:durative-action move_seg_N_N2A4c_0_75_seg_N_N2A4b_0_75_north_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_N_N2A4c_0_75))
                 (at start (not_occupied seg_N_N2A4b_0_75))
                 (at start (not_blocked seg_N_N2A4b_0_75 airplane_CFBEG))
                 (at start (not_blocked seg_N_N2A4b_0_75 airplane_CFBE1))
                 (at start (not_blocked seg_N_N2A4b_0_75 airplane_CFBE3))
                 (at start (not_blocked seg_N_N2A4b_0_75 airplane_DAEW8))
                 (at start (not_blocked seg_N_N2A4b_0_75 airplane_DAEW9))
                 (at start (not_blocked seg_N_N2A4b_0_75 airplane_DAEW0))
                 (at start (not_blocked seg_N_N2A4b_0_75 airplane_DAEW3))
                 (at start (not_blocked seg_N_N2A4b_0_75 airplane_DAEWH))
                 (at start (not_blocked seg_N_N2A4b_0_75 airplane_DAEW1))
                 (at start (not_blocked seg_N_N2A4b_0_75 airplane_DAEW2))
                 (at start (not_blocked seg_N_N2A4b_0_75 airplane_DAEW4))
                 (at start (not_blocked seg_N_N2A4b_0_75 airplane_DAEW5))
                 (at start (not_blocked seg_N_N2A4b_0_75 airplane_DAEW6))
                 (at start (not_blocked seg_N_N2A4b_0_75 airplane_DAEW7))
                 (at start (not_blocked seg_N_N2A4b_0_75 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_N_N2A4c_0_75)))
                 (at end (not_occupied seg_N_N2A4c_0_75))
                 (at start (not (at-segment ?a seg_N_N2A4c_0_75)))

                 (at start (occupied seg_N_N2A4b_0_75))
                 (at start (not (not_occupied seg_N_N2A4b_0_75)))
                 (at start (blocked seg_N_N2A4b_0_75 ?a))
                 (at start (not (not_blocked seg_N_N2A4b_0_75 ?a)))
                 (at end (at-segment ?a seg_N_N2A4b_0_75))

                 (at end (not (blocked seg_N_N2A4d_0_75 ?a)))
                 (at end (not_blocked seg_N_N2A4d_0_75 ?a))

                )
)

(:durative-action move_seg_N_N2A4b_0_75_seg_N_N2A4a_0_70_north_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_N_N2A4b_0_75))
                 (at start (not_occupied seg_N_N2A4a_0_70))
                 (at start (not_blocked seg_N_N2A4a_0_70 airplane_CFBEG))
                 (at start (not_blocked seg_N_N2A4a_0_70 airplane_CFBE1))
                 (at start (not_blocked seg_N_N2A4a_0_70 airplane_CFBE3))
                 (at start (not_blocked seg_N_N2A4a_0_70 airplane_DAEW8))
                 (at start (not_blocked seg_N_N2A4a_0_70 airplane_DAEW9))
                 (at start (not_blocked seg_N_N2A4a_0_70 airplane_DAEW0))
                 (at start (not_blocked seg_N_N2A4a_0_70 airplane_DAEW3))
                 (at start (not_blocked seg_N_N2A4a_0_70 airplane_DAEWH))
                 (at start (not_blocked seg_N_N2A4a_0_70 airplane_DAEW1))
                 (at start (not_blocked seg_N_N2A4a_0_70 airplane_DAEW2))
                 (at start (not_blocked seg_N_N2A4a_0_70 airplane_DAEW4))
                 (at start (not_blocked seg_N_N2A4a_0_70 airplane_DAEW5))
                 (at start (not_blocked seg_N_N2A4a_0_70 airplane_DAEW6))
                 (at start (not_blocked seg_N_N2A4a_0_70 airplane_DAEW7))
                 (at start (not_blocked seg_N_N2A4a_0_70 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_N_N2A4b_0_75)))
                 (at end (not_occupied seg_N_N2A4b_0_75))
                 (at start (not (at-segment ?a seg_N_N2A4b_0_75)))

                 (at start (occupied seg_N_N2A4a_0_70))
                 (at start (not (not_occupied seg_N_N2A4a_0_70)))
                 (at start (blocked seg_N_N2A4a_0_70 ?a))
                 (at start (not (not_blocked seg_N_N2A4a_0_70 ?a)))
                 (at end (at-segment ?a seg_N_N2A4a_0_70))

                 (at end (not (blocked seg_N_N2A4c_0_75 ?a)))
                 (at end (not_blocked seg_N_N2A4c_0_75 ?a))

                )
)

(:durative-action move_seg_N_N2A4a_0_70_seg_N_N2a_0_60_north_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_N_N2A4a_0_70))
                 (at start (not_occupied seg_N_N2a_0_60))
                 (at start (not_blocked seg_N_N2a_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_N_N2a_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_N_N2a_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_N_N2a_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_N_N2a_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_N_N2a_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_N_N2a_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_N_N2a_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_N_N2a_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_N_N2a_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_N_N2a_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_N_N2a_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_N_N2a_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_N_N2a_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_N_N2a_0_60 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_N_N2A4a_0_70)))
                 (at end (not_occupied seg_N_N2A4a_0_70))
                 (at start (not (at-segment ?a seg_N_N2A4a_0_70)))

                 (at start (occupied seg_N_N2a_0_60))
                 (at start (not (not_occupied seg_N_N2a_0_60)))
                 (at start (blocked seg_N_N2a_0_60 ?a))
                 (at start (not (not_blocked seg_N_N2a_0_60 ?a)))
                 (at end (at-segment ?a seg_N_N2a_0_60))

                 (at end (not (blocked seg_N_N2A4b_0_75 ?a)))
                 (at end (not_blocked seg_N_N2A4b_0_75 ?a))

                )
)

(:durative-action move_seg_N_N2a_0_60_seg_N_N2b_0_60_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_N_N2a_0_60))
                 (at start (not_occupied seg_N_N2b_0_60))
                 (at start (not_blocked seg_N_N2b_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_N_N2b_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_N_N2b_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_N_N2b_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_N_N2b_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_N_N2b_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_N_N2b_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_N_N2b_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_N_N2b_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_N_N2b_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_N_N2b_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_N_N2b_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_N_N2b_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_N_N2b_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_N_N2b_0_60 airplane_CFBE2))

                 (over all (not_occupied seg_N_N2c_0_60))
              )

 :effect        (and
                 (at end (not (occupied seg_N_N2a_0_60)))
                 (at end (not_occupied seg_N_N2a_0_60))
                 (at start (not (at-segment ?a seg_N_N2a_0_60)))

                 (at start (occupied seg_N_N2b_0_60))
                 (at start (not (not_occupied seg_N_N2b_0_60)))
                 (at start (blocked seg_N_N2b_0_60 ?a))
                 (at start (not (not_blocked seg_N_N2b_0_60 ?a)))
                 (at end (at-segment ?a seg_N_N2b_0_60))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_N_N2A4a_0_70 ?a)))
                 (at end (not_blocked seg_N_N2A4a_0_70 ?a))

                 (at start (blocked seg_N_N2c_0_60 ?a))
                 (at start (not (not_blocked seg_N_N2c_0_60 ?a)))
                )
)

(:durative-action move_seg_N_N2b_0_60_seg_N2_0_108_south_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_N_N2b_0_60))
                 (at start (not_occupied seg_N2_0_108))
                 (at start (not_blocked seg_N2_0_108 airplane_CFBEG))
                 (at start (not_blocked seg_N2_0_108 airplane_CFBE1))
                 (at start (not_blocked seg_N2_0_108 airplane_CFBE3))
                 (at start (not_blocked seg_N2_0_108 airplane_DAEW8))
                 (at start (not_blocked seg_N2_0_108 airplane_DAEW9))
                 (at start (not_blocked seg_N2_0_108 airplane_DAEW0))
                 (at start (not_blocked seg_N2_0_108 airplane_DAEW3))
                 (at start (not_blocked seg_N2_0_108 airplane_DAEWH))
                 (at start (not_blocked seg_N2_0_108 airplane_DAEW1))
                 (at start (not_blocked seg_N2_0_108 airplane_DAEW2))
                 (at start (not_blocked seg_N2_0_108 airplane_DAEW4))
                 (at start (not_blocked seg_N2_0_108 airplane_DAEW5))
                 (at start (not_blocked seg_N2_0_108 airplane_DAEW6))
                 (at start (not_blocked seg_N2_0_108 airplane_DAEW7))
                 (at start (not_blocked seg_N2_0_108 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_N_N2b_0_60)))
                 (at end (not_occupied seg_N_N2b_0_60))
                 (at start (not (at-segment ?a seg_N_N2b_0_60)))

                 (at start (occupied seg_N2_0_108))
                 (at start (not (not_occupied seg_N2_0_108)))
                 (at start (blocked seg_N2_0_108 ?a))
                 (at start (not (not_blocked seg_N2_0_108 ?a)))
                 (at end (at-segment ?a seg_N2_0_108))

                 (at end (not (blocked seg_N_N2a_0_60 ?a)))
                 (at end (not_blocked seg_N_N2a_0_60 ?a))
                 (at end (not (blocked seg_N_N2c_0_60 ?a)))
                 (at end (not_blocked seg_N_N2c_0_60 ?a))

                )
)

(:durative-action move_seg_N2_0_108_seg_C1_n2a_0_60_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 3)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_N2_0_108))
                 (at start (not_occupied seg_C1_n2a_0_60))
                 (at start (not_blocked seg_C1_n2a_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_C1_n2a_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_C1_n2a_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_C1_n2a_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_C1_n2a_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_C1_n2a_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_C1_n2a_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_C1_n2a_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_C1_n2a_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_C1_n2a_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_C1_n2a_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_C1_n2a_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_C1_n2a_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_C1_n2a_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_C1_n2a_0_60 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_N2_0_108)))
                 (at end (not_occupied seg_N2_0_108))
                 (at start (not (at-segment ?a seg_N2_0_108)))

                 (at start (occupied seg_C1_n2a_0_60))
                 (at start (not (not_occupied seg_C1_n2a_0_60)))
                 (at start (blocked seg_C1_n2a_0_60 ?a))
                 (at start (not (not_blocked seg_C1_n2a_0_60 ?a)))
                 (at end (at-segment ?a seg_C1_n2a_0_60))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_N_N2b_0_60 ?a)))
                 (at end (not_blocked seg_N_N2b_0_60 ?a))

                )
)

(:durative-action move_seg_C1_n2a_0_60_seg_C1_n2c_0_60_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_C1_n2a_0_60))
                 (at start (not_occupied seg_C1_n2c_0_60))
                 (at start (not_blocked seg_C1_n2c_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_C1_n2c_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_C1_n2c_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_C1_n2c_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_C1_n2c_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_C1_n2c_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_C1_n2c_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_C1_n2c_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_C1_n2c_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_C1_n2c_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_C1_n2c_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_C1_n2c_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_C1_n2c_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_C1_n2c_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_C1_n2c_0_60 airplane_CFBE2))

                 (over all (not_occupied seg_C1_n2b_0_80))
              )

 :effect        (and
                 (at end (not (occupied seg_C1_n2a_0_60)))
                 (at end (not_occupied seg_C1_n2a_0_60))
                 (at start (not (at-segment ?a seg_C1_n2a_0_60)))

                 (at start (occupied seg_C1_n2c_0_60))
                 (at start (not (not_occupied seg_C1_n2c_0_60)))
                 (at start (blocked seg_C1_n2c_0_60 ?a))
                 (at start (not (not_blocked seg_C1_n2c_0_60 ?a)))
                 (at end (at-segment ?a seg_C1_n2c_0_60))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_N2_0_108 ?a)))
                 (at end (not_blocked seg_N2_0_108 ?a))

                 (at start (blocked seg_C1_n2b_0_80 ?a))
                 (at start (not (not_blocked seg_C1_n2b_0_80 ?a)))
                )
)

(:durative-action move_seg_C1_n2c_0_60_seg_W1_C1b_0_60_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_C1_n2c_0_60))
                 (at start (not_occupied seg_W1_C1b_0_60))
                 (at start (not_blocked seg_W1_C1b_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_W1_C1b_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_W1_C1b_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_W1_C1b_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_W1_C1b_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_W1_C1b_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_W1_C1b_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_W1_C1b_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_W1_C1b_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_W1_C1b_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_W1_C1b_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_W1_C1b_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_W1_C1b_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_W1_C1b_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_W1_C1b_0_60 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_C1_n2c_0_60)))
                 (at end (not_occupied seg_C1_n2c_0_60))
                 (at start (not (at-segment ?a seg_C1_n2c_0_60)))

                 (at start (occupied seg_W1_C1b_0_60))
                 (at start (not (not_occupied seg_W1_C1b_0_60)))
                 (at start (blocked seg_W1_C1b_0_60 ?a))
                 (at start (not (not_blocked seg_W1_C1b_0_60 ?a)))
                 (at end (at-segment ?a seg_W1_C1b_0_60))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_C1_n2a_0_60 ?a)))
                 (at end (not_blocked seg_C1_n2a_0_60 ?a))
                 (at end (not (blocked seg_C1_n2b_0_80 ?a)))
                 (at end (not_blocked seg_C1_n2b_0_80 ?a))

                )
)

(:durative-action move_seg_W1_C1b_0_60_seg_W1_C1c_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_W1_C1b_0_60))
                 (at start (not_occupied seg_W1_C1c_0_34))
                 (at start (not_blocked seg_W1_C1c_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_W1_C1c_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_W1_C1c_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_W1_C1c_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_W1_C1c_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_W1_C1c_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_W1_C1c_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_W1_C1c_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_W1_C1c_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_W1_C1c_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_W1_C1c_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_W1_C1c_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_W1_C1c_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_W1_C1c_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_W1_C1c_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_W1_C1a_0_60))
              )

 :effect        (and
                 (at end (not (occupied seg_W1_C1b_0_60)))
                 (at end (not_occupied seg_W1_C1b_0_60))
                 (at start (not (at-segment ?a seg_W1_C1b_0_60)))

                 (at start (occupied seg_W1_C1c_0_34))
                 (at start (not (not_occupied seg_W1_C1c_0_34)))
                 (at start (blocked seg_W1_C1c_0_34 ?a))
                 (at start (not (not_blocked seg_W1_C1c_0_34 ?a)))
                 (at end (at-segment ?a seg_W1_C1c_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_C1_n2c_0_60 ?a)))
                 (at end (not_blocked seg_C1_n2c_0_60 ?a))

                 (at start (blocked seg_W1_C1a_0_60 ?a))
                 (at start (not (not_blocked seg_W1_C1a_0_60 ?a)))
                )
)

(:durative-action move_seg_W1_141a_0_34_seg_W1_141b_0_45_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_W1_141a_0_34))
                 (at start (not_occupied seg_W1_141b_0_45))
                 (at start (not_blocked seg_W1_141b_0_45 airplane_CFBEG))
                 (at start (not_blocked seg_W1_141b_0_45 airplane_CFBE1))
                 (at start (not_blocked seg_W1_141b_0_45 airplane_CFBE3))
                 (at start (not_blocked seg_W1_141b_0_45 airplane_DAEW8))
                 (at start (not_blocked seg_W1_141b_0_45 airplane_DAEW9))
                 (at start (not_blocked seg_W1_141b_0_45 airplane_DAEW0))
                 (at start (not_blocked seg_W1_141b_0_45 airplane_DAEW3))
                 (at start (not_blocked seg_W1_141b_0_45 airplane_DAEWH))
                 (at start (not_blocked seg_W1_141b_0_45 airplane_DAEW1))
                 (at start (not_blocked seg_W1_141b_0_45 airplane_DAEW2))
                 (at start (not_blocked seg_W1_141b_0_45 airplane_DAEW4))
                 (at start (not_blocked seg_W1_141b_0_45 airplane_DAEW5))
                 (at start (not_blocked seg_W1_141b_0_45 airplane_DAEW6))
                 (at start (not_blocked seg_W1_141b_0_45 airplane_DAEW7))
                 (at start (not_blocked seg_W1_141b_0_45 airplane_CFBE2))

                 (over all (not_occupied seg_W1_141c_0_34))
              )

 :effect        (and
                 (at end (not (occupied seg_W1_141a_0_34)))
                 (at end (not_occupied seg_W1_141a_0_34))
                 (at start (not (at-segment ?a seg_W1_141a_0_34)))

                 (at start (occupied seg_W1_141b_0_45))
                 (at start (not (not_occupied seg_W1_141b_0_45)))
                 (at start (blocked seg_W1_141b_0_45 ?a))
                 (at start (not (not_blocked seg_W1_141b_0_45 ?a)))
                 (at end (at-segment ?a seg_W1_141b_0_45))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_W1_C1c_0_34 ?a)))
                 (at end (not_blocked seg_W1_C1c_0_34 ?a))

                 (at start (blocked seg_W1_141c_0_34 ?a))
                 (at start (not (not_blocked seg_W1_141c_0_34 ?a)))
                )
)

(:durative-action move_seg_p142_0_75_seg_W1_142b_0_45_north_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_p142_0_75))
                 (at start (not_occupied seg_W1_142b_0_45))
                 (at start (not_blocked seg_W1_142b_0_45 airplane_CFBEG))
                 (at start (not_blocked seg_W1_142b_0_45 airplane_CFBE1))
                 (at start (not_blocked seg_W1_142b_0_45 airplane_CFBE3))
                 (at start (not_blocked seg_W1_142b_0_45 airplane_DAEW8))
                 (at start (not_blocked seg_W1_142b_0_45 airplane_DAEW9))
                 (at start (not_blocked seg_W1_142b_0_45 airplane_DAEW0))
                 (at start (not_blocked seg_W1_142b_0_45 airplane_DAEW3))
                 (at start (not_blocked seg_W1_142b_0_45 airplane_DAEWH))
                 (at start (not_blocked seg_W1_142b_0_45 airplane_DAEW1))
                 (at start (not_blocked seg_W1_142b_0_45 airplane_DAEW2))
                 (at start (not_blocked seg_W1_142b_0_45 airplane_DAEW4))
                 (at start (not_blocked seg_W1_142b_0_45 airplane_DAEW5))
                 (at start (not_blocked seg_W1_142b_0_45 airplane_DAEW6))
                 (at start (not_blocked seg_W1_142b_0_45 airplane_DAEW7))
                 (at start (not_blocked seg_W1_142b_0_45 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_p142_0_75)))
                 (at end (not_occupied seg_p142_0_75))
                 (at start (not (at-segment ?a seg_p142_0_75)))

                 (at start (occupied seg_W1_142b_0_45))
                 (at start (not (not_occupied seg_W1_142b_0_45)))
                 (at start (blocked seg_W1_142b_0_45 ?a))
                 (at start (not (not_blocked seg_W1_142b_0_45 ?a)))
                 (at end (at-segment ?a seg_W1_142b_0_45))


                )
)

(:durative-action move_seg_W1_142b_0_45_seg_W1_142a_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_W1_142b_0_45))
                 (at start (not_occupied seg_W1_142a_0_34))
                 (at start (not_blocked seg_W1_142a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_W1_142a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_W1_142a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_W1_142a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_W1_142a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_W1_142a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_W1_142a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_W1_142a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_W1_142a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_W1_142a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_W1_142a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_W1_142a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_W1_142a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_W1_142a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_W1_142a_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_W1_142c_0_34))
              )

 :effect        (and
                 (at end (not (occupied seg_W1_142b_0_45)))
                 (at end (not_occupied seg_W1_142b_0_45))
                 (at start (not (at-segment ?a seg_W1_142b_0_45)))

                 (at start (occupied seg_W1_142a_0_34))
                 (at start (not (not_occupied seg_W1_142a_0_34)))
                 (at start (blocked seg_W1_142a_0_34 ?a))
                 (at start (not (not_blocked seg_W1_142a_0_34 ?a)))
                 (at end (at-segment ?a seg_W1_142a_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_p142_0_75 ?a)))
                 (at end (not_blocked seg_p142_0_75 ?a))

                 (at start (blocked seg_W1_142c_0_34 ?a))
                 (at start (not (not_blocked seg_W1_142c_0_34 ?a)))
                )
)

(:durative-action move_seg_W1_142b_0_45_seg_W1_142c_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_W1_142b_0_45))
                 (at start (not_occupied seg_W1_142c_0_34))
                 (at start (not_blocked seg_W1_142c_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_W1_142c_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_W1_142c_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_W1_142c_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_W1_142c_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_W1_142c_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_W1_142c_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_W1_142c_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_W1_142c_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_W1_142c_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_W1_142c_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_W1_142c_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_W1_142c_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_W1_142c_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_W1_142c_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_W1_142a_0_34))
              )

 :effect        (and
                 (at end (not (occupied seg_W1_142b_0_45)))
                 (at end (not_occupied seg_W1_142b_0_45))
                 (at start (not (at-segment ?a seg_W1_142b_0_45)))

                 (at start (occupied seg_W1_142c_0_34))
                 (at start (not (not_occupied seg_W1_142c_0_34)))
                 (at start (blocked seg_W1_142c_0_34 ?a))
                 (at start (not (not_blocked seg_W1_142c_0_34 ?a)))
                 (at end (at-segment ?a seg_W1_142c_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_p142_0_75 ?a)))
                 (at end (not_blocked seg_p142_0_75 ?a))

                 (at start (blocked seg_W1_142a_0_34 ?a))
                 (at start (not (not_blocked seg_W1_142a_0_34 ?a)))
                )
)

(:durative-action move_seg_W1_142c_0_34_seg_W1_142b_0_45_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_W1_142c_0_34))
                 (at start (not_occupied seg_W1_142b_0_45))
                 (at start (not_blocked seg_W1_142b_0_45 airplane_CFBEG))
                 (at start (not_blocked seg_W1_142b_0_45 airplane_CFBE1))
                 (at start (not_blocked seg_W1_142b_0_45 airplane_CFBE3))
                 (at start (not_blocked seg_W1_142b_0_45 airplane_DAEW8))
                 (at start (not_blocked seg_W1_142b_0_45 airplane_DAEW9))
                 (at start (not_blocked seg_W1_142b_0_45 airplane_DAEW0))
                 (at start (not_blocked seg_W1_142b_0_45 airplane_DAEW3))
                 (at start (not_blocked seg_W1_142b_0_45 airplane_DAEWH))
                 (at start (not_blocked seg_W1_142b_0_45 airplane_DAEW1))
                 (at start (not_blocked seg_W1_142b_0_45 airplane_DAEW2))
                 (at start (not_blocked seg_W1_142b_0_45 airplane_DAEW4))
                 (at start (not_blocked seg_W1_142b_0_45 airplane_DAEW5))
                 (at start (not_blocked seg_W1_142b_0_45 airplane_DAEW6))
                 (at start (not_blocked seg_W1_142b_0_45 airplane_DAEW7))
                 (at start (not_blocked seg_W1_142b_0_45 airplane_CFBE2))

                 (over all (not_occupied seg_W1_142a_0_34))
              )

 :effect        (and
                 (at end (not (occupied seg_W1_142c_0_34)))
                 (at end (not_occupied seg_W1_142c_0_34))
                 (at start (not (at-segment ?a seg_W1_142c_0_34)))

                 (at start (occupied seg_W1_142b_0_45))
                 (at start (not (not_occupied seg_W1_142b_0_45)))
                 (at start (blocked seg_W1_142b_0_45 ?a))
                 (at start (not (not_blocked seg_W1_142b_0_45 ?a)))
                 (at end (at-segment ?a seg_W1_142b_0_45))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_W1_143a_0_34 ?a)))
                 (at end (not_blocked seg_W1_143a_0_34 ?a))

                 (at start (blocked seg_W1_142a_0_34 ?a))
                 (at start (not (not_blocked seg_W1_142a_0_34 ?a)))
                )
)

(:durative-action move_seg_W1_142b_0_45_seg_p142_0_75_south_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_W1_142b_0_45))
                 (at start (not_occupied seg_p142_0_75))
                 (at start (not_blocked seg_p142_0_75 airplane_CFBEG))
                 (at start (not_blocked seg_p142_0_75 airplane_CFBE1))
                 (at start (not_blocked seg_p142_0_75 airplane_CFBE3))
                 (at start (not_blocked seg_p142_0_75 airplane_DAEW8))
                 (at start (not_blocked seg_p142_0_75 airplane_DAEW9))
                 (at start (not_blocked seg_p142_0_75 airplane_DAEW0))
                 (at start (not_blocked seg_p142_0_75 airplane_DAEW3))
                 (at start (not_blocked seg_p142_0_75 airplane_DAEWH))
                 (at start (not_blocked seg_p142_0_75 airplane_DAEW1))
                 (at start (not_blocked seg_p142_0_75 airplane_DAEW2))
                 (at start (not_blocked seg_p142_0_75 airplane_DAEW4))
                 (at start (not_blocked seg_p142_0_75 airplane_DAEW5))
                 (at start (not_blocked seg_p142_0_75 airplane_DAEW6))
                 (at start (not_blocked seg_p142_0_75 airplane_DAEW7))
                 (at start (not_blocked seg_p142_0_75 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_W1_142b_0_45)))
                 (at end (not_occupied seg_W1_142b_0_45))
                 (at start (not (at-segment ?a seg_W1_142b_0_45)))

                 (at start (occupied seg_p142_0_75))
                 (at start (not (not_occupied seg_p142_0_75)))
                 (at start (blocked seg_p142_0_75 ?a))
                 (at start (not (not_blocked seg_p142_0_75 ?a)))
                 (at end (at-segment ?a seg_p142_0_75))

                 (at end (not (blocked seg_W1_142a_0_34 ?a)))
                 (at end (not_blocked seg_W1_142a_0_34 ?a))
                 (at end (not (blocked seg_W1_142c_0_34 ?a)))
                 (at end (not_blocked seg_W1_142c_0_34 ?a))

                )
)

(:durative-action move_seg_W1_142a_0_34_seg_W1_142b_0_45_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_W1_142a_0_34))
                 (at start (not_occupied seg_W1_142b_0_45))
                 (at start (not_blocked seg_W1_142b_0_45 airplane_CFBEG))
                 (at start (not_blocked seg_W1_142b_0_45 airplane_CFBE1))
                 (at start (not_blocked seg_W1_142b_0_45 airplane_CFBE3))
                 (at start (not_blocked seg_W1_142b_0_45 airplane_DAEW8))
                 (at start (not_blocked seg_W1_142b_0_45 airplane_DAEW9))
                 (at start (not_blocked seg_W1_142b_0_45 airplane_DAEW0))
                 (at start (not_blocked seg_W1_142b_0_45 airplane_DAEW3))
                 (at start (not_blocked seg_W1_142b_0_45 airplane_DAEWH))
                 (at start (not_blocked seg_W1_142b_0_45 airplane_DAEW1))
                 (at start (not_blocked seg_W1_142b_0_45 airplane_DAEW2))
                 (at start (not_blocked seg_W1_142b_0_45 airplane_DAEW4))
                 (at start (not_blocked seg_W1_142b_0_45 airplane_DAEW5))
                 (at start (not_blocked seg_W1_142b_0_45 airplane_DAEW6))
                 (at start (not_blocked seg_W1_142b_0_45 airplane_DAEW7))
                 (at start (not_blocked seg_W1_142b_0_45 airplane_CFBE2))

                 (over all (not_occupied seg_W1_142c_0_34))
              )

 :effect        (and
                 (at end (not (occupied seg_W1_142a_0_34)))
                 (at end (not_occupied seg_W1_142a_0_34))
                 (at start (not (at-segment ?a seg_W1_142a_0_34)))

                 (at start (occupied seg_W1_142b_0_45))
                 (at start (not (not_occupied seg_W1_142b_0_45)))
                 (at start (blocked seg_W1_142b_0_45 ?a))
                 (at start (not (not_blocked seg_W1_142b_0_45 ?a)))
                 (at end (at-segment ?a seg_W1_142b_0_45))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_W1_141c_0_34 ?a)))
                 (at end (not_blocked seg_W1_141c_0_34 ?a))

                 (at start (blocked seg_W1_142c_0_34 ?a))
                 (at start (not (not_blocked seg_W1_142c_0_34 ?a)))
                )
)

(:durative-action move_seg_p143_0_75_seg_W1_143b_0_45_north_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_p143_0_75))
                 (at start (not_occupied seg_W1_143b_0_45))
                 (at start (not_blocked seg_W1_143b_0_45 airplane_CFBEG))
                 (at start (not_blocked seg_W1_143b_0_45 airplane_CFBE1))
                 (at start (not_blocked seg_W1_143b_0_45 airplane_CFBE3))
                 (at start (not_blocked seg_W1_143b_0_45 airplane_DAEW8))
                 (at start (not_blocked seg_W1_143b_0_45 airplane_DAEW9))
                 (at start (not_blocked seg_W1_143b_0_45 airplane_DAEW0))
                 (at start (not_blocked seg_W1_143b_0_45 airplane_DAEW3))
                 (at start (not_blocked seg_W1_143b_0_45 airplane_DAEWH))
                 (at start (not_blocked seg_W1_143b_0_45 airplane_DAEW1))
                 (at start (not_blocked seg_W1_143b_0_45 airplane_DAEW2))
                 (at start (not_blocked seg_W1_143b_0_45 airplane_DAEW4))
                 (at start (not_blocked seg_W1_143b_0_45 airplane_DAEW5))
                 (at start (not_blocked seg_W1_143b_0_45 airplane_DAEW6))
                 (at start (not_blocked seg_W1_143b_0_45 airplane_DAEW7))
                 (at start (not_blocked seg_W1_143b_0_45 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_p143_0_75)))
                 (at end (not_occupied seg_p143_0_75))
                 (at start (not (at-segment ?a seg_p143_0_75)))

                 (at start (occupied seg_W1_143b_0_45))
                 (at start (not (not_occupied seg_W1_143b_0_45)))
                 (at start (blocked seg_W1_143b_0_45 ?a))
                 (at start (not (not_blocked seg_W1_143b_0_45 ?a)))
                 (at end (at-segment ?a seg_W1_143b_0_45))


                )
)

(:durative-action move_seg_W1_143b_0_45_seg_W1_143a_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_W1_143b_0_45))
                 (at start (not_occupied seg_W1_143a_0_34))
                 (at start (not_blocked seg_W1_143a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_W1_143a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_W1_143a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_W1_143a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_W1_143a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_W1_143a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_W1_143a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_W1_143a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_W1_143a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_W1_143a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_W1_143a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_W1_143a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_W1_143a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_W1_143a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_W1_143a_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_W1_143c_0_60))
              )

 :effect        (and
                 (at end (not (occupied seg_W1_143b_0_45)))
                 (at end (not_occupied seg_W1_143b_0_45))
                 (at start (not (at-segment ?a seg_W1_143b_0_45)))

                 (at start (occupied seg_W1_143a_0_34))
                 (at start (not (not_occupied seg_W1_143a_0_34)))
                 (at start (blocked seg_W1_143a_0_34 ?a))
                 (at start (not (not_blocked seg_W1_143a_0_34 ?a)))
                 (at end (at-segment ?a seg_W1_143a_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_p143_0_75 ?a)))
                 (at end (not_blocked seg_p143_0_75 ?a))

                 (at start (blocked seg_W1_143c_0_60 ?a))
                 (at start (not (not_blocked seg_W1_143c_0_60 ?a)))
                )
)

(:durative-action move_seg_W1_143b_0_45_seg_W1_143c_0_60_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_W1_143b_0_45))
                 (at start (not_occupied seg_W1_143c_0_60))
                 (at start (not_blocked seg_W1_143c_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_W1_143c_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_W1_143c_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_W1_143c_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_W1_143c_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_W1_143c_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_W1_143c_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_W1_143c_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_W1_143c_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_W1_143c_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_W1_143c_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_W1_143c_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_W1_143c_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_W1_143c_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_W1_143c_0_60 airplane_CFBE2))

                 (over all (not_occupied seg_W1_143a_0_34))
              )

 :effect        (and
                 (at end (not (occupied seg_W1_143b_0_45)))
                 (at end (not_occupied seg_W1_143b_0_45))
                 (at start (not (at-segment ?a seg_W1_143b_0_45)))

                 (at start (occupied seg_W1_143c_0_60))
                 (at start (not (not_occupied seg_W1_143c_0_60)))
                 (at start (blocked seg_W1_143c_0_60 ?a))
                 (at start (not (not_blocked seg_W1_143c_0_60 ?a)))
                 (at end (at-segment ?a seg_W1_143c_0_60))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_p143_0_75 ?a)))
                 (at end (not_blocked seg_p143_0_75 ?a))

                 (at start (blocked seg_W1_143a_0_34 ?a))
                 (at start (not (not_blocked seg_W1_143a_0_34 ?a)))
                )
)

(:durative-action move_seg_W1_143c_0_60_seg_W1_143b_0_45_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_W1_143c_0_60))
                 (at start (not_occupied seg_W1_143b_0_45))
                 (at start (not_blocked seg_W1_143b_0_45 airplane_CFBEG))
                 (at start (not_blocked seg_W1_143b_0_45 airplane_CFBE1))
                 (at start (not_blocked seg_W1_143b_0_45 airplane_CFBE3))
                 (at start (not_blocked seg_W1_143b_0_45 airplane_DAEW8))
                 (at start (not_blocked seg_W1_143b_0_45 airplane_DAEW9))
                 (at start (not_blocked seg_W1_143b_0_45 airplane_DAEW0))
                 (at start (not_blocked seg_W1_143b_0_45 airplane_DAEW3))
                 (at start (not_blocked seg_W1_143b_0_45 airplane_DAEWH))
                 (at start (not_blocked seg_W1_143b_0_45 airplane_DAEW1))
                 (at start (not_blocked seg_W1_143b_0_45 airplane_DAEW2))
                 (at start (not_blocked seg_W1_143b_0_45 airplane_DAEW4))
                 (at start (not_blocked seg_W1_143b_0_45 airplane_DAEW5))
                 (at start (not_blocked seg_W1_143b_0_45 airplane_DAEW6))
                 (at start (not_blocked seg_W1_143b_0_45 airplane_DAEW7))
                 (at start (not_blocked seg_W1_143b_0_45 airplane_CFBE2))

                 (over all (not_occupied seg_W1_143a_0_34))
              )

 :effect        (and
                 (at end (not (occupied seg_W1_143c_0_60)))
                 (at end (not_occupied seg_W1_143c_0_60))
                 (at start (not (at-segment ?a seg_W1_143c_0_60)))

                 (at start (occupied seg_W1_143b_0_45))
                 (at start (not (not_occupied seg_W1_143b_0_45)))
                 (at start (blocked seg_W1_143b_0_45 ?a))
                 (at start (not (not_blocked seg_W1_143b_0_45 ?a)))
                 (at end (at-segment ?a seg_W1_143b_0_45))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_W1_C2a_0_60 ?a)))
                 (at end (not_blocked seg_W1_C2a_0_60 ?a))

                 (at start (blocked seg_W1_143a_0_34 ?a))
                 (at start (not (not_blocked seg_W1_143a_0_34 ?a)))
                )
)

(:durative-action move_seg_W1_143b_0_45_seg_p143_0_75_south_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_W1_143b_0_45))
                 (at start (not_occupied seg_p143_0_75))
                 (at start (not_blocked seg_p143_0_75 airplane_CFBEG))
                 (at start (not_blocked seg_p143_0_75 airplane_CFBE1))
                 (at start (not_blocked seg_p143_0_75 airplane_CFBE3))
                 (at start (not_blocked seg_p143_0_75 airplane_DAEW8))
                 (at start (not_blocked seg_p143_0_75 airplane_DAEW9))
                 (at start (not_blocked seg_p143_0_75 airplane_DAEW0))
                 (at start (not_blocked seg_p143_0_75 airplane_DAEW3))
                 (at start (not_blocked seg_p143_0_75 airplane_DAEWH))
                 (at start (not_blocked seg_p143_0_75 airplane_DAEW1))
                 (at start (not_blocked seg_p143_0_75 airplane_DAEW2))
                 (at start (not_blocked seg_p143_0_75 airplane_DAEW4))
                 (at start (not_blocked seg_p143_0_75 airplane_DAEW5))
                 (at start (not_blocked seg_p143_0_75 airplane_DAEW6))
                 (at start (not_blocked seg_p143_0_75 airplane_DAEW7))
                 (at start (not_blocked seg_p143_0_75 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_W1_143b_0_45)))
                 (at end (not_occupied seg_W1_143b_0_45))
                 (at start (not (at-segment ?a seg_W1_143b_0_45)))

                 (at start (occupied seg_p143_0_75))
                 (at start (not (not_occupied seg_p143_0_75)))
                 (at start (blocked seg_p143_0_75 ?a))
                 (at start (not (not_blocked seg_p143_0_75 ?a)))
                 (at end (at-segment ?a seg_p143_0_75))

                 (at end (not (blocked seg_W1_143a_0_34 ?a)))
                 (at end (not_blocked seg_W1_143a_0_34 ?a))
                 (at end (not (blocked seg_W1_143c_0_60 ?a)))
                 (at end (not_blocked seg_W1_143c_0_60 ?a))

                )
)

(:durative-action move_seg_W1_143a_0_34_seg_W1_143b_0_45_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_W1_143a_0_34))
                 (at start (not_occupied seg_W1_143b_0_45))
                 (at start (not_blocked seg_W1_143b_0_45 airplane_CFBEG))
                 (at start (not_blocked seg_W1_143b_0_45 airplane_CFBE1))
                 (at start (not_blocked seg_W1_143b_0_45 airplane_CFBE3))
                 (at start (not_blocked seg_W1_143b_0_45 airplane_DAEW8))
                 (at start (not_blocked seg_W1_143b_0_45 airplane_DAEW9))
                 (at start (not_blocked seg_W1_143b_0_45 airplane_DAEW0))
                 (at start (not_blocked seg_W1_143b_0_45 airplane_DAEW3))
                 (at start (not_blocked seg_W1_143b_0_45 airplane_DAEWH))
                 (at start (not_blocked seg_W1_143b_0_45 airplane_DAEW1))
                 (at start (not_blocked seg_W1_143b_0_45 airplane_DAEW2))
                 (at start (not_blocked seg_W1_143b_0_45 airplane_DAEW4))
                 (at start (not_blocked seg_W1_143b_0_45 airplane_DAEW5))
                 (at start (not_blocked seg_W1_143b_0_45 airplane_DAEW6))
                 (at start (not_blocked seg_W1_143b_0_45 airplane_DAEW7))
                 (at start (not_blocked seg_W1_143b_0_45 airplane_CFBE2))

                 (over all (not_occupied seg_W1_143c_0_60))
              )

 :effect        (and
                 (at end (not (occupied seg_W1_143a_0_34)))
                 (at end (not_occupied seg_W1_143a_0_34))
                 (at start (not (at-segment ?a seg_W1_143a_0_34)))

                 (at start (occupied seg_W1_143b_0_45))
                 (at start (not (not_occupied seg_W1_143b_0_45)))
                 (at start (blocked seg_W1_143b_0_45 ?a))
                 (at start (not (not_blocked seg_W1_143b_0_45 ?a)))
                 (at end (at-segment ?a seg_W1_143b_0_45))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_W1_142c_0_34 ?a)))
                 (at end (not_blocked seg_W1_142c_0_34 ?a))

                 (at start (blocked seg_W1_143c_0_60 ?a))
                 (at start (not (not_blocked seg_W1_143c_0_60 ?a)))
                )
)

(:durative-action move_seg_p151_0_75_seg_W1_151b_0_45_north_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_p151_0_75))
                 (at start (not_occupied seg_W1_151b_0_45))
                 (at start (not_blocked seg_W1_151b_0_45 airplane_CFBEG))
                 (at start (not_blocked seg_W1_151b_0_45 airplane_CFBE1))
                 (at start (not_blocked seg_W1_151b_0_45 airplane_CFBE3))
                 (at start (not_blocked seg_W1_151b_0_45 airplane_DAEW8))
                 (at start (not_blocked seg_W1_151b_0_45 airplane_DAEW9))
                 (at start (not_blocked seg_W1_151b_0_45 airplane_DAEW0))
                 (at start (not_blocked seg_W1_151b_0_45 airplane_DAEW3))
                 (at start (not_blocked seg_W1_151b_0_45 airplane_DAEWH))
                 (at start (not_blocked seg_W1_151b_0_45 airplane_DAEW1))
                 (at start (not_blocked seg_W1_151b_0_45 airplane_DAEW2))
                 (at start (not_blocked seg_W1_151b_0_45 airplane_DAEW4))
                 (at start (not_blocked seg_W1_151b_0_45 airplane_DAEW5))
                 (at start (not_blocked seg_W1_151b_0_45 airplane_DAEW6))
                 (at start (not_blocked seg_W1_151b_0_45 airplane_DAEW7))
                 (at start (not_blocked seg_W1_151b_0_45 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_p151_0_75)))
                 (at end (not_occupied seg_p151_0_75))
                 (at start (not (at-segment ?a seg_p151_0_75)))

                 (at start (occupied seg_W1_151b_0_45))
                 (at start (not (not_occupied seg_W1_151b_0_45)))
                 (at start (blocked seg_W1_151b_0_45 ?a))
                 (at start (not (not_blocked seg_W1_151b_0_45 ?a)))
                 (at end (at-segment ?a seg_W1_151b_0_45))


                )
)

(:durative-action move_seg_W1_151b_0_45_seg_W1_151a_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_W1_151b_0_45))
                 (at start (not_occupied seg_W1_151a_0_34))
                 (at start (not_blocked seg_W1_151a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_W1_151a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_W1_151a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_W1_151a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_W1_151a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_W1_151a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_W1_151a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_W1_151a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_W1_151a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_W1_151a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_W1_151a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_W1_151a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_W1_151a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_W1_151a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_W1_151a_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_W1_151c_0_34))
              )

 :effect        (and
                 (at end (not (occupied seg_W1_151b_0_45)))
                 (at end (not_occupied seg_W1_151b_0_45))
                 (at start (not (at-segment ?a seg_W1_151b_0_45)))

                 (at start (occupied seg_W1_151a_0_34))
                 (at start (not (not_occupied seg_W1_151a_0_34)))
                 (at start (blocked seg_W1_151a_0_34 ?a))
                 (at start (not (not_blocked seg_W1_151a_0_34 ?a)))
                 (at end (at-segment ?a seg_W1_151a_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_p151_0_75 ?a)))
                 (at end (not_blocked seg_p151_0_75 ?a))

                 (at start (blocked seg_W1_151c_0_34 ?a))
                 (at start (not (not_blocked seg_W1_151c_0_34 ?a)))
                )
)

(:durative-action move_seg_W1_151b_0_45_seg_W1_151c_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_W1_151b_0_45))
                 (at start (not_occupied seg_W1_151c_0_34))
                 (at start (not_blocked seg_W1_151c_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_W1_151c_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_W1_151c_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_W1_151c_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_W1_151c_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_W1_151c_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_W1_151c_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_W1_151c_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_W1_151c_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_W1_151c_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_W1_151c_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_W1_151c_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_W1_151c_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_W1_151c_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_W1_151c_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_W1_151a_0_34))
              )

 :effect        (and
                 (at end (not (occupied seg_W1_151b_0_45)))
                 (at end (not_occupied seg_W1_151b_0_45))
                 (at start (not (at-segment ?a seg_W1_151b_0_45)))

                 (at start (occupied seg_W1_151c_0_34))
                 (at start (not (not_occupied seg_W1_151c_0_34)))
                 (at start (blocked seg_W1_151c_0_34 ?a))
                 (at start (not (not_blocked seg_W1_151c_0_34 ?a)))
                 (at end (at-segment ?a seg_W1_151c_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_p151_0_75 ?a)))
                 (at end (not_blocked seg_p151_0_75 ?a))

                 (at start (blocked seg_W1_151a_0_34 ?a))
                 (at start (not (not_blocked seg_W1_151a_0_34 ?a)))
                )
)

(:durative-action move_seg_W1_151c_0_34_seg_W1_151b_0_45_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_W1_151c_0_34))
                 (at start (not_occupied seg_W1_151b_0_45))
                 (at start (not_blocked seg_W1_151b_0_45 airplane_CFBEG))
                 (at start (not_blocked seg_W1_151b_0_45 airplane_CFBE1))
                 (at start (not_blocked seg_W1_151b_0_45 airplane_CFBE3))
                 (at start (not_blocked seg_W1_151b_0_45 airplane_DAEW8))
                 (at start (not_blocked seg_W1_151b_0_45 airplane_DAEW9))
                 (at start (not_blocked seg_W1_151b_0_45 airplane_DAEW0))
                 (at start (not_blocked seg_W1_151b_0_45 airplane_DAEW3))
                 (at start (not_blocked seg_W1_151b_0_45 airplane_DAEWH))
                 (at start (not_blocked seg_W1_151b_0_45 airplane_DAEW1))
                 (at start (not_blocked seg_W1_151b_0_45 airplane_DAEW2))
                 (at start (not_blocked seg_W1_151b_0_45 airplane_DAEW4))
                 (at start (not_blocked seg_W1_151b_0_45 airplane_DAEW5))
                 (at start (not_blocked seg_W1_151b_0_45 airplane_DAEW6))
                 (at start (not_blocked seg_W1_151b_0_45 airplane_DAEW7))
                 (at start (not_blocked seg_W1_151b_0_45 airplane_CFBE2))

                 (over all (not_occupied seg_W1_151a_0_34))
              )

 :effect        (and
                 (at end (not (occupied seg_W1_151c_0_34)))
                 (at end (not_occupied seg_W1_151c_0_34))
                 (at start (not (at-segment ?a seg_W1_151c_0_34)))

                 (at start (occupied seg_W1_151b_0_45))
                 (at start (not (not_occupied seg_W1_151b_0_45)))
                 (at start (blocked seg_W1_151b_0_45 ?a))
                 (at start (not (not_blocked seg_W1_151b_0_45 ?a)))
                 (at end (at-segment ?a seg_W1_151b_0_45))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_W1_152a_0_34 ?a)))
                 (at end (not_blocked seg_W1_152a_0_34 ?a))

                 (at start (blocked seg_W1_151a_0_34 ?a))
                 (at start (not (not_blocked seg_W1_151a_0_34 ?a)))
                )
)

(:durative-action move_seg_W1_151b_0_45_seg_p151_0_75_south_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_W1_151b_0_45))
                 (at start (not_occupied seg_p151_0_75))
                 (at start (not_blocked seg_p151_0_75 airplane_CFBEG))
                 (at start (not_blocked seg_p151_0_75 airplane_CFBE1))
                 (at start (not_blocked seg_p151_0_75 airplane_CFBE3))
                 (at start (not_blocked seg_p151_0_75 airplane_DAEW8))
                 (at start (not_blocked seg_p151_0_75 airplane_DAEW9))
                 (at start (not_blocked seg_p151_0_75 airplane_DAEW0))
                 (at start (not_blocked seg_p151_0_75 airplane_DAEW3))
                 (at start (not_blocked seg_p151_0_75 airplane_DAEWH))
                 (at start (not_blocked seg_p151_0_75 airplane_DAEW1))
                 (at start (not_blocked seg_p151_0_75 airplane_DAEW2))
                 (at start (not_blocked seg_p151_0_75 airplane_DAEW4))
                 (at start (not_blocked seg_p151_0_75 airplane_DAEW5))
                 (at start (not_blocked seg_p151_0_75 airplane_DAEW6))
                 (at start (not_blocked seg_p151_0_75 airplane_DAEW7))
                 (at start (not_blocked seg_p151_0_75 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_W1_151b_0_45)))
                 (at end (not_occupied seg_W1_151b_0_45))
                 (at start (not (at-segment ?a seg_W1_151b_0_45)))

                 (at start (occupied seg_p151_0_75))
                 (at start (not (not_occupied seg_p151_0_75)))
                 (at start (blocked seg_p151_0_75 ?a))
                 (at start (not (not_blocked seg_p151_0_75 ?a)))
                 (at end (at-segment ?a seg_p151_0_75))

                 (at end (not (blocked seg_W1_151a_0_34 ?a)))
                 (at end (not_blocked seg_W1_151a_0_34 ?a))
                 (at end (not (blocked seg_W1_151c_0_34 ?a)))
                 (at end (not_blocked seg_W1_151c_0_34 ?a))

                )
)

(:durative-action move_seg_W1_151a_0_34_seg_W1_151b_0_45_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_W1_151a_0_34))
                 (at start (not_occupied seg_W1_151b_0_45))
                 (at start (not_blocked seg_W1_151b_0_45 airplane_CFBEG))
                 (at start (not_blocked seg_W1_151b_0_45 airplane_CFBE1))
                 (at start (not_blocked seg_W1_151b_0_45 airplane_CFBE3))
                 (at start (not_blocked seg_W1_151b_0_45 airplane_DAEW8))
                 (at start (not_blocked seg_W1_151b_0_45 airplane_DAEW9))
                 (at start (not_blocked seg_W1_151b_0_45 airplane_DAEW0))
                 (at start (not_blocked seg_W1_151b_0_45 airplane_DAEW3))
                 (at start (not_blocked seg_W1_151b_0_45 airplane_DAEWH))
                 (at start (not_blocked seg_W1_151b_0_45 airplane_DAEW1))
                 (at start (not_blocked seg_W1_151b_0_45 airplane_DAEW2))
                 (at start (not_blocked seg_W1_151b_0_45 airplane_DAEW4))
                 (at start (not_blocked seg_W1_151b_0_45 airplane_DAEW5))
                 (at start (not_blocked seg_W1_151b_0_45 airplane_DAEW6))
                 (at start (not_blocked seg_W1_151b_0_45 airplane_DAEW7))
                 (at start (not_blocked seg_W1_151b_0_45 airplane_CFBE2))

                 (over all (not_occupied seg_W1_151c_0_34))
              )

 :effect        (and
                 (at end (not (occupied seg_W1_151a_0_34)))
                 (at end (not_occupied seg_W1_151a_0_34))
                 (at start (not (at-segment ?a seg_W1_151a_0_34)))

                 (at start (occupied seg_W1_151b_0_45))
                 (at start (not (not_occupied seg_W1_151b_0_45)))
                 (at start (blocked seg_W1_151b_0_45 ?a))
                 (at start (not (not_blocked seg_W1_151b_0_45 ?a)))
                 (at end (at-segment ?a seg_W1_151b_0_45))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_W1_C2c_0_34 ?a)))
                 (at end (not_blocked seg_W1_C2c_0_34 ?a))

                 (at start (blocked seg_W1_151c_0_34 ?a))
                 (at start (not (not_blocked seg_W1_151c_0_34 ?a)))
                )
)

(:durative-action move_seg_p152_0_75_seg_W1_152b_0_45_north_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_p152_0_75))
                 (at start (not_occupied seg_W1_152b_0_45))
                 (at start (not_blocked seg_W1_152b_0_45 airplane_CFBEG))
                 (at start (not_blocked seg_W1_152b_0_45 airplane_CFBE1))
                 (at start (not_blocked seg_W1_152b_0_45 airplane_CFBE3))
                 (at start (not_blocked seg_W1_152b_0_45 airplane_DAEW8))
                 (at start (not_blocked seg_W1_152b_0_45 airplane_DAEW9))
                 (at start (not_blocked seg_W1_152b_0_45 airplane_DAEW0))
                 (at start (not_blocked seg_W1_152b_0_45 airplane_DAEW3))
                 (at start (not_blocked seg_W1_152b_0_45 airplane_DAEWH))
                 (at start (not_blocked seg_W1_152b_0_45 airplane_DAEW1))
                 (at start (not_blocked seg_W1_152b_0_45 airplane_DAEW2))
                 (at start (not_blocked seg_W1_152b_0_45 airplane_DAEW4))
                 (at start (not_blocked seg_W1_152b_0_45 airplane_DAEW5))
                 (at start (not_blocked seg_W1_152b_0_45 airplane_DAEW6))
                 (at start (not_blocked seg_W1_152b_0_45 airplane_DAEW7))
                 (at start (not_blocked seg_W1_152b_0_45 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_p152_0_75)))
                 (at end (not_occupied seg_p152_0_75))
                 (at start (not (at-segment ?a seg_p152_0_75)))

                 (at start (occupied seg_W1_152b_0_45))
                 (at start (not (not_occupied seg_W1_152b_0_45)))
                 (at start (blocked seg_W1_152b_0_45 ?a))
                 (at start (not (not_blocked seg_W1_152b_0_45 ?a)))
                 (at end (at-segment ?a seg_W1_152b_0_45))


                )
)

(:durative-action move_seg_W1_152b_0_45_seg_W1_152a_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_W1_152b_0_45))
                 (at start (not_occupied seg_W1_152a_0_34))
                 (at start (not_blocked seg_W1_152a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_W1_152a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_W1_152a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_W1_152a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_W1_152a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_W1_152a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_W1_152a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_W1_152a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_W1_152a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_W1_152a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_W1_152a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_W1_152a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_W1_152a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_W1_152a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_W1_152a_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_W1_152c_0_34))
              )

 :effect        (and
                 (at end (not (occupied seg_W1_152b_0_45)))
                 (at end (not_occupied seg_W1_152b_0_45))
                 (at start (not (at-segment ?a seg_W1_152b_0_45)))

                 (at start (occupied seg_W1_152a_0_34))
                 (at start (not (not_occupied seg_W1_152a_0_34)))
                 (at start (blocked seg_W1_152a_0_34 ?a))
                 (at start (not (not_blocked seg_W1_152a_0_34 ?a)))
                 (at end (at-segment ?a seg_W1_152a_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_p152_0_75 ?a)))
                 (at end (not_blocked seg_p152_0_75 ?a))

                 (at start (blocked seg_W1_152c_0_34 ?a))
                 (at start (not (not_blocked seg_W1_152c_0_34 ?a)))
                )
)

(:durative-action move_seg_W1_152b_0_45_seg_W1_152c_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_W1_152b_0_45))
                 (at start (not_occupied seg_W1_152c_0_34))
                 (at start (not_blocked seg_W1_152c_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_W1_152c_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_W1_152c_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_W1_152c_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_W1_152c_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_W1_152c_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_W1_152c_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_W1_152c_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_W1_152c_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_W1_152c_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_W1_152c_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_W1_152c_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_W1_152c_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_W1_152c_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_W1_152c_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_W1_152a_0_34))
              )

 :effect        (and
                 (at end (not (occupied seg_W1_152b_0_45)))
                 (at end (not_occupied seg_W1_152b_0_45))
                 (at start (not (at-segment ?a seg_W1_152b_0_45)))

                 (at start (occupied seg_W1_152c_0_34))
                 (at start (not (not_occupied seg_W1_152c_0_34)))
                 (at start (blocked seg_W1_152c_0_34 ?a))
                 (at start (not (not_blocked seg_W1_152c_0_34 ?a)))
                 (at end (at-segment ?a seg_W1_152c_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_p152_0_75 ?a)))
                 (at end (not_blocked seg_p152_0_75 ?a))

                 (at start (blocked seg_W1_152a_0_34 ?a))
                 (at start (not (not_blocked seg_W1_152a_0_34 ?a)))
                )
)

(:durative-action move_seg_W1_152c_0_34_seg_W1_152b_0_45_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_W1_152c_0_34))
                 (at start (not_occupied seg_W1_152b_0_45))
                 (at start (not_blocked seg_W1_152b_0_45 airplane_CFBEG))
                 (at start (not_blocked seg_W1_152b_0_45 airplane_CFBE1))
                 (at start (not_blocked seg_W1_152b_0_45 airplane_CFBE3))
                 (at start (not_blocked seg_W1_152b_0_45 airplane_DAEW8))
                 (at start (not_blocked seg_W1_152b_0_45 airplane_DAEW9))
                 (at start (not_blocked seg_W1_152b_0_45 airplane_DAEW0))
                 (at start (not_blocked seg_W1_152b_0_45 airplane_DAEW3))
                 (at start (not_blocked seg_W1_152b_0_45 airplane_DAEWH))
                 (at start (not_blocked seg_W1_152b_0_45 airplane_DAEW1))
                 (at start (not_blocked seg_W1_152b_0_45 airplane_DAEW2))
                 (at start (not_blocked seg_W1_152b_0_45 airplane_DAEW4))
                 (at start (not_blocked seg_W1_152b_0_45 airplane_DAEW5))
                 (at start (not_blocked seg_W1_152b_0_45 airplane_DAEW6))
                 (at start (not_blocked seg_W1_152b_0_45 airplane_DAEW7))
                 (at start (not_blocked seg_W1_152b_0_45 airplane_CFBE2))

                 (over all (not_occupied seg_W1_152a_0_34))
              )

 :effect        (and
                 (at end (not (occupied seg_W1_152c_0_34)))
                 (at end (not_occupied seg_W1_152c_0_34))
                 (at start (not (at-segment ?a seg_W1_152c_0_34)))

                 (at start (occupied seg_W1_152b_0_45))
                 (at start (not (not_occupied seg_W1_152b_0_45)))
                 (at start (blocked seg_W1_152b_0_45 ?a))
                 (at start (not (not_blocked seg_W1_152b_0_45 ?a)))
                 (at end (at-segment ?a seg_W1_152b_0_45))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_W1_153a_0_34 ?a)))
                 (at end (not_blocked seg_W1_153a_0_34 ?a))

                 (at start (blocked seg_W1_152a_0_34 ?a))
                 (at start (not (not_blocked seg_W1_152a_0_34 ?a)))
                )
)

(:durative-action move_seg_W1_152b_0_45_seg_p152_0_75_south_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_W1_152b_0_45))
                 (at start (not_occupied seg_p152_0_75))
                 (at start (not_blocked seg_p152_0_75 airplane_CFBEG))
                 (at start (not_blocked seg_p152_0_75 airplane_CFBE1))
                 (at start (not_blocked seg_p152_0_75 airplane_CFBE3))
                 (at start (not_blocked seg_p152_0_75 airplane_DAEW8))
                 (at start (not_blocked seg_p152_0_75 airplane_DAEW9))
                 (at start (not_blocked seg_p152_0_75 airplane_DAEW0))
                 (at start (not_blocked seg_p152_0_75 airplane_DAEW3))
                 (at start (not_blocked seg_p152_0_75 airplane_DAEWH))
                 (at start (not_blocked seg_p152_0_75 airplane_DAEW1))
                 (at start (not_blocked seg_p152_0_75 airplane_DAEW2))
                 (at start (not_blocked seg_p152_0_75 airplane_DAEW4))
                 (at start (not_blocked seg_p152_0_75 airplane_DAEW5))
                 (at start (not_blocked seg_p152_0_75 airplane_DAEW6))
                 (at start (not_blocked seg_p152_0_75 airplane_DAEW7))
                 (at start (not_blocked seg_p152_0_75 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_W1_152b_0_45)))
                 (at end (not_occupied seg_W1_152b_0_45))
                 (at start (not (at-segment ?a seg_W1_152b_0_45)))

                 (at start (occupied seg_p152_0_75))
                 (at start (not (not_occupied seg_p152_0_75)))
                 (at start (blocked seg_p152_0_75 ?a))
                 (at start (not (not_blocked seg_p152_0_75 ?a)))
                 (at end (at-segment ?a seg_p152_0_75))

                 (at end (not (blocked seg_W1_152a_0_34 ?a)))
                 (at end (not_blocked seg_W1_152a_0_34 ?a))
                 (at end (not (blocked seg_W1_152c_0_34 ?a)))
                 (at end (not_blocked seg_W1_152c_0_34 ?a))

                )
)

(:durative-action move_seg_W1_152a_0_34_seg_W1_152b_0_45_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_W1_152a_0_34))
                 (at start (not_occupied seg_W1_152b_0_45))
                 (at start (not_blocked seg_W1_152b_0_45 airplane_CFBEG))
                 (at start (not_blocked seg_W1_152b_0_45 airplane_CFBE1))
                 (at start (not_blocked seg_W1_152b_0_45 airplane_CFBE3))
                 (at start (not_blocked seg_W1_152b_0_45 airplane_DAEW8))
                 (at start (not_blocked seg_W1_152b_0_45 airplane_DAEW9))
                 (at start (not_blocked seg_W1_152b_0_45 airplane_DAEW0))
                 (at start (not_blocked seg_W1_152b_0_45 airplane_DAEW3))
                 (at start (not_blocked seg_W1_152b_0_45 airplane_DAEWH))
                 (at start (not_blocked seg_W1_152b_0_45 airplane_DAEW1))
                 (at start (not_blocked seg_W1_152b_0_45 airplane_DAEW2))
                 (at start (not_blocked seg_W1_152b_0_45 airplane_DAEW4))
                 (at start (not_blocked seg_W1_152b_0_45 airplane_DAEW5))
                 (at start (not_blocked seg_W1_152b_0_45 airplane_DAEW6))
                 (at start (not_blocked seg_W1_152b_0_45 airplane_DAEW7))
                 (at start (not_blocked seg_W1_152b_0_45 airplane_CFBE2))

                 (over all (not_occupied seg_W1_152c_0_34))
              )

 :effect        (and
                 (at end (not (occupied seg_W1_152a_0_34)))
                 (at end (not_occupied seg_W1_152a_0_34))
                 (at start (not (at-segment ?a seg_W1_152a_0_34)))

                 (at start (occupied seg_W1_152b_0_45))
                 (at start (not (not_occupied seg_W1_152b_0_45)))
                 (at start (blocked seg_W1_152b_0_45 ?a))
                 (at start (not (not_blocked seg_W1_152b_0_45 ?a)))
                 (at end (at-segment ?a seg_W1_152b_0_45))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_W1_151c_0_34 ?a)))
                 (at end (not_blocked seg_W1_151c_0_34 ?a))

                 (at start (blocked seg_W1_152c_0_34 ?a))
                 (at start (not (not_blocked seg_W1_152c_0_34 ?a)))
                )
)

(:durative-action move_seg_p153_0_75_seg_W1_153b_0_45_north_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_p153_0_75))
                 (at start (not_occupied seg_W1_153b_0_45))
                 (at start (not_blocked seg_W1_153b_0_45 airplane_CFBEG))
                 (at start (not_blocked seg_W1_153b_0_45 airplane_CFBE1))
                 (at start (not_blocked seg_W1_153b_0_45 airplane_CFBE3))
                 (at start (not_blocked seg_W1_153b_0_45 airplane_DAEW8))
                 (at start (not_blocked seg_W1_153b_0_45 airplane_DAEW9))
                 (at start (not_blocked seg_W1_153b_0_45 airplane_DAEW0))
                 (at start (not_blocked seg_W1_153b_0_45 airplane_DAEW3))
                 (at start (not_blocked seg_W1_153b_0_45 airplane_DAEWH))
                 (at start (not_blocked seg_W1_153b_0_45 airplane_DAEW1))
                 (at start (not_blocked seg_W1_153b_0_45 airplane_DAEW2))
                 (at start (not_blocked seg_W1_153b_0_45 airplane_DAEW4))
                 (at start (not_blocked seg_W1_153b_0_45 airplane_DAEW5))
                 (at start (not_blocked seg_W1_153b_0_45 airplane_DAEW6))
                 (at start (not_blocked seg_W1_153b_0_45 airplane_DAEW7))
                 (at start (not_blocked seg_W1_153b_0_45 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_p153_0_75)))
                 (at end (not_occupied seg_p153_0_75))
                 (at start (not (at-segment ?a seg_p153_0_75)))

                 (at start (occupied seg_W1_153b_0_45))
                 (at start (not (not_occupied seg_W1_153b_0_45)))
                 (at start (blocked seg_W1_153b_0_45 ?a))
                 (at start (not (not_blocked seg_W1_153b_0_45 ?a)))
                 (at end (at-segment ?a seg_W1_153b_0_45))


                )
)

(:durative-action move_seg_W1_153b_0_45_seg_W1_153a_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_W1_153b_0_45))
                 (at start (not_occupied seg_W1_153a_0_34))
                 (at start (not_blocked seg_W1_153a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_W1_153a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_W1_153a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_W1_153a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_W1_153a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_W1_153a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_W1_153a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_W1_153a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_W1_153a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_W1_153a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_W1_153a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_W1_153a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_W1_153a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_W1_153a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_W1_153a_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_W1_153c_0_34))
              )

 :effect        (and
                 (at end (not (occupied seg_W1_153b_0_45)))
                 (at end (not_occupied seg_W1_153b_0_45))
                 (at start (not (at-segment ?a seg_W1_153b_0_45)))

                 (at start (occupied seg_W1_153a_0_34))
                 (at start (not (not_occupied seg_W1_153a_0_34)))
                 (at start (blocked seg_W1_153a_0_34 ?a))
                 (at start (not (not_blocked seg_W1_153a_0_34 ?a)))
                 (at end (at-segment ?a seg_W1_153a_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_p153_0_75 ?a)))
                 (at end (not_blocked seg_p153_0_75 ?a))

                 (at start (blocked seg_W1_153c_0_34 ?a))
                 (at start (not (not_blocked seg_W1_153c_0_34 ?a)))
                )
)

(:durative-action move_seg_W1_153b_0_45_seg_W1_153c_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_W1_153b_0_45))
                 (at start (not_occupied seg_W1_153c_0_34))
                 (at start (not_blocked seg_W1_153c_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_W1_153c_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_W1_153c_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_W1_153c_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_W1_153c_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_W1_153c_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_W1_153c_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_W1_153c_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_W1_153c_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_W1_153c_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_W1_153c_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_W1_153c_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_W1_153c_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_W1_153c_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_W1_153c_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_W1_153a_0_34))
              )

 :effect        (and
                 (at end (not (occupied seg_W1_153b_0_45)))
                 (at end (not_occupied seg_W1_153b_0_45))
                 (at start (not (at-segment ?a seg_W1_153b_0_45)))

                 (at start (occupied seg_W1_153c_0_34))
                 (at start (not (not_occupied seg_W1_153c_0_34)))
                 (at start (blocked seg_W1_153c_0_34 ?a))
                 (at start (not (not_blocked seg_W1_153c_0_34 ?a)))
                 (at end (at-segment ?a seg_W1_153c_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_p153_0_75 ?a)))
                 (at end (not_blocked seg_p153_0_75 ?a))

                 (at start (blocked seg_W1_153a_0_34 ?a))
                 (at start (not (not_blocked seg_W1_153a_0_34 ?a)))
                )
)

(:durative-action move_seg_W1_153c_0_34_seg_W1_153b_0_45_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_W1_153c_0_34))
                 (at start (not_occupied seg_W1_153b_0_45))
                 (at start (not_blocked seg_W1_153b_0_45 airplane_CFBEG))
                 (at start (not_blocked seg_W1_153b_0_45 airplane_CFBE1))
                 (at start (not_blocked seg_W1_153b_0_45 airplane_CFBE3))
                 (at start (not_blocked seg_W1_153b_0_45 airplane_DAEW8))
                 (at start (not_blocked seg_W1_153b_0_45 airplane_DAEW9))
                 (at start (not_blocked seg_W1_153b_0_45 airplane_DAEW0))
                 (at start (not_blocked seg_W1_153b_0_45 airplane_DAEW3))
                 (at start (not_blocked seg_W1_153b_0_45 airplane_DAEWH))
                 (at start (not_blocked seg_W1_153b_0_45 airplane_DAEW1))
                 (at start (not_blocked seg_W1_153b_0_45 airplane_DAEW2))
                 (at start (not_blocked seg_W1_153b_0_45 airplane_DAEW4))
                 (at start (not_blocked seg_W1_153b_0_45 airplane_DAEW5))
                 (at start (not_blocked seg_W1_153b_0_45 airplane_DAEW6))
                 (at start (not_blocked seg_W1_153b_0_45 airplane_DAEW7))
                 (at start (not_blocked seg_W1_153b_0_45 airplane_CFBE2))

                 (over all (not_occupied seg_W1_153a_0_34))
              )

 :effect        (and
                 (at end (not (occupied seg_W1_153c_0_34)))
                 (at end (not_occupied seg_W1_153c_0_34))
                 (at start (not (at-segment ?a seg_W1_153c_0_34)))

                 (at start (occupied seg_W1_153b_0_45))
                 (at start (not (not_occupied seg_W1_153b_0_45)))
                 (at start (blocked seg_W1_153b_0_45 ?a))
                 (at start (not (not_blocked seg_W1_153b_0_45 ?a)))
                 (at end (at-segment ?a seg_W1_153b_0_45))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_W1_154a_0_34 ?a)))
                 (at end (not_blocked seg_W1_154a_0_34 ?a))

                 (at start (blocked seg_W1_153a_0_34 ?a))
                 (at start (not (not_blocked seg_W1_153a_0_34 ?a)))
                )
)

(:durative-action move_seg_W1_153b_0_45_seg_p153_0_75_south_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_W1_153b_0_45))
                 (at start (not_occupied seg_p153_0_75))
                 (at start (not_blocked seg_p153_0_75 airplane_CFBEG))
                 (at start (not_blocked seg_p153_0_75 airplane_CFBE1))
                 (at start (not_blocked seg_p153_0_75 airplane_CFBE3))
                 (at start (not_blocked seg_p153_0_75 airplane_DAEW8))
                 (at start (not_blocked seg_p153_0_75 airplane_DAEW9))
                 (at start (not_blocked seg_p153_0_75 airplane_DAEW0))
                 (at start (not_blocked seg_p153_0_75 airplane_DAEW3))
                 (at start (not_blocked seg_p153_0_75 airplane_DAEWH))
                 (at start (not_blocked seg_p153_0_75 airplane_DAEW1))
                 (at start (not_blocked seg_p153_0_75 airplane_DAEW2))
                 (at start (not_blocked seg_p153_0_75 airplane_DAEW4))
                 (at start (not_blocked seg_p153_0_75 airplane_DAEW5))
                 (at start (not_blocked seg_p153_0_75 airplane_DAEW6))
                 (at start (not_blocked seg_p153_0_75 airplane_DAEW7))
                 (at start (not_blocked seg_p153_0_75 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_W1_153b_0_45)))
                 (at end (not_occupied seg_W1_153b_0_45))
                 (at start (not (at-segment ?a seg_W1_153b_0_45)))

                 (at start (occupied seg_p153_0_75))
                 (at start (not (not_occupied seg_p153_0_75)))
                 (at start (blocked seg_p153_0_75 ?a))
                 (at start (not (not_blocked seg_p153_0_75 ?a)))
                 (at end (at-segment ?a seg_p153_0_75))

                 (at end (not (blocked seg_W1_153a_0_34 ?a)))
                 (at end (not_blocked seg_W1_153a_0_34 ?a))
                 (at end (not (blocked seg_W1_153c_0_34 ?a)))
                 (at end (not_blocked seg_W1_153c_0_34 ?a))

                )
)

(:durative-action move_seg_W1_153a_0_34_seg_W1_153b_0_45_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_W1_153a_0_34))
                 (at start (not_occupied seg_W1_153b_0_45))
                 (at start (not_blocked seg_W1_153b_0_45 airplane_CFBEG))
                 (at start (not_blocked seg_W1_153b_0_45 airplane_CFBE1))
                 (at start (not_blocked seg_W1_153b_0_45 airplane_CFBE3))
                 (at start (not_blocked seg_W1_153b_0_45 airplane_DAEW8))
                 (at start (not_blocked seg_W1_153b_0_45 airplane_DAEW9))
                 (at start (not_blocked seg_W1_153b_0_45 airplane_DAEW0))
                 (at start (not_blocked seg_W1_153b_0_45 airplane_DAEW3))
                 (at start (not_blocked seg_W1_153b_0_45 airplane_DAEWH))
                 (at start (not_blocked seg_W1_153b_0_45 airplane_DAEW1))
                 (at start (not_blocked seg_W1_153b_0_45 airplane_DAEW2))
                 (at start (not_blocked seg_W1_153b_0_45 airplane_DAEW4))
                 (at start (not_blocked seg_W1_153b_0_45 airplane_DAEW5))
                 (at start (not_blocked seg_W1_153b_0_45 airplane_DAEW6))
                 (at start (not_blocked seg_W1_153b_0_45 airplane_DAEW7))
                 (at start (not_blocked seg_W1_153b_0_45 airplane_CFBE2))

                 (over all (not_occupied seg_W1_153c_0_34))
              )

 :effect        (and
                 (at end (not (occupied seg_W1_153a_0_34)))
                 (at end (not_occupied seg_W1_153a_0_34))
                 (at start (not (at-segment ?a seg_W1_153a_0_34)))

                 (at start (occupied seg_W1_153b_0_45))
                 (at start (not (not_occupied seg_W1_153b_0_45)))
                 (at start (blocked seg_W1_153b_0_45 ?a))
                 (at start (not (not_blocked seg_W1_153b_0_45 ?a)))
                 (at end (at-segment ?a seg_W1_153b_0_45))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_W1_152c_0_34 ?a)))
                 (at end (not_blocked seg_W1_152c_0_34 ?a))

                 (at start (blocked seg_W1_153c_0_34 ?a))
                 (at start (not (not_blocked seg_W1_153c_0_34 ?a)))
                )
)

(:durative-action move_seg_p154_0_75_seg_W1_154b_0_45_north_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_p154_0_75))
                 (at start (not_occupied seg_W1_154b_0_45))
                 (at start (not_blocked seg_W1_154b_0_45 airplane_CFBEG))
                 (at start (not_blocked seg_W1_154b_0_45 airplane_CFBE1))
                 (at start (not_blocked seg_W1_154b_0_45 airplane_CFBE3))
                 (at start (not_blocked seg_W1_154b_0_45 airplane_DAEW8))
                 (at start (not_blocked seg_W1_154b_0_45 airplane_DAEW9))
                 (at start (not_blocked seg_W1_154b_0_45 airplane_DAEW0))
                 (at start (not_blocked seg_W1_154b_0_45 airplane_DAEW3))
                 (at start (not_blocked seg_W1_154b_0_45 airplane_DAEWH))
                 (at start (not_blocked seg_W1_154b_0_45 airplane_DAEW1))
                 (at start (not_blocked seg_W1_154b_0_45 airplane_DAEW2))
                 (at start (not_blocked seg_W1_154b_0_45 airplane_DAEW4))
                 (at start (not_blocked seg_W1_154b_0_45 airplane_DAEW5))
                 (at start (not_blocked seg_W1_154b_0_45 airplane_DAEW6))
                 (at start (not_blocked seg_W1_154b_0_45 airplane_DAEW7))
                 (at start (not_blocked seg_W1_154b_0_45 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_p154_0_75)))
                 (at end (not_occupied seg_p154_0_75))
                 (at start (not (at-segment ?a seg_p154_0_75)))

                 (at start (occupied seg_W1_154b_0_45))
                 (at start (not (not_occupied seg_W1_154b_0_45)))
                 (at start (blocked seg_W1_154b_0_45 ?a))
                 (at start (not (not_blocked seg_W1_154b_0_45 ?a)))
                 (at end (at-segment ?a seg_W1_154b_0_45))


                )
)

(:durative-action move_seg_W1_154b_0_45_seg_W1_154a_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_W1_154b_0_45))
                 (at start (not_occupied seg_W1_154a_0_34))
                 (at start (not_blocked seg_W1_154a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_W1_154a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_W1_154a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_W1_154a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_W1_154a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_W1_154a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_W1_154a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_W1_154a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_W1_154a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_W1_154a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_W1_154a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_W1_154a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_W1_154a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_W1_154a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_W1_154a_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_W1_154c_0_34))
              )

 :effect        (and
                 (at end (not (occupied seg_W1_154b_0_45)))
                 (at end (not_occupied seg_W1_154b_0_45))
                 (at start (not (at-segment ?a seg_W1_154b_0_45)))

                 (at start (occupied seg_W1_154a_0_34))
                 (at start (not (not_occupied seg_W1_154a_0_34)))
                 (at start (blocked seg_W1_154a_0_34 ?a))
                 (at start (not (not_blocked seg_W1_154a_0_34 ?a)))
                 (at end (at-segment ?a seg_W1_154a_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_p154_0_75 ?a)))
                 (at end (not_blocked seg_p154_0_75 ?a))

                 (at start (blocked seg_W1_154c_0_34 ?a))
                 (at start (not (not_blocked seg_W1_154c_0_34 ?a)))
                )
)

(:durative-action move_seg_W1_154b_0_45_seg_W1_154c_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_W1_154b_0_45))
                 (at start (not_occupied seg_W1_154c_0_34))
                 (at start (not_blocked seg_W1_154c_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_W1_154c_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_W1_154c_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_W1_154c_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_W1_154c_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_W1_154c_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_W1_154c_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_W1_154c_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_W1_154c_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_W1_154c_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_W1_154c_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_W1_154c_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_W1_154c_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_W1_154c_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_W1_154c_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_W1_154a_0_34))
              )

 :effect        (and
                 (at end (not (occupied seg_W1_154b_0_45)))
                 (at end (not_occupied seg_W1_154b_0_45))
                 (at start (not (at-segment ?a seg_W1_154b_0_45)))

                 (at start (occupied seg_W1_154c_0_34))
                 (at start (not (not_occupied seg_W1_154c_0_34)))
                 (at start (blocked seg_W1_154c_0_34 ?a))
                 (at start (not (not_blocked seg_W1_154c_0_34 ?a)))
                 (at end (at-segment ?a seg_W1_154c_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_p154_0_75 ?a)))
                 (at end (not_blocked seg_p154_0_75 ?a))

                 (at start (blocked seg_W1_154a_0_34 ?a))
                 (at start (not (not_blocked seg_W1_154a_0_34 ?a)))
                )
)

(:durative-action move_seg_W1_154c_0_34_seg_W1_154b_0_45_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_W1_154c_0_34))
                 (at start (not_occupied seg_W1_154b_0_45))
                 (at start (not_blocked seg_W1_154b_0_45 airplane_CFBEG))
                 (at start (not_blocked seg_W1_154b_0_45 airplane_CFBE1))
                 (at start (not_blocked seg_W1_154b_0_45 airplane_CFBE3))
                 (at start (not_blocked seg_W1_154b_0_45 airplane_DAEW8))
                 (at start (not_blocked seg_W1_154b_0_45 airplane_DAEW9))
                 (at start (not_blocked seg_W1_154b_0_45 airplane_DAEW0))
                 (at start (not_blocked seg_W1_154b_0_45 airplane_DAEW3))
                 (at start (not_blocked seg_W1_154b_0_45 airplane_DAEWH))
                 (at start (not_blocked seg_W1_154b_0_45 airplane_DAEW1))
                 (at start (not_blocked seg_W1_154b_0_45 airplane_DAEW2))
                 (at start (not_blocked seg_W1_154b_0_45 airplane_DAEW4))
                 (at start (not_blocked seg_W1_154b_0_45 airplane_DAEW5))
                 (at start (not_blocked seg_W1_154b_0_45 airplane_DAEW6))
                 (at start (not_blocked seg_W1_154b_0_45 airplane_DAEW7))
                 (at start (not_blocked seg_W1_154b_0_45 airplane_CFBE2))

                 (over all (not_occupied seg_W1_154a_0_34))
              )

 :effect        (and
                 (at end (not (occupied seg_W1_154c_0_34)))
                 (at end (not_occupied seg_W1_154c_0_34))
                 (at start (not (at-segment ?a seg_W1_154c_0_34)))

                 (at start (occupied seg_W1_154b_0_45))
                 (at start (not (not_occupied seg_W1_154b_0_45)))
                 (at start (blocked seg_W1_154b_0_45 ?a))
                 (at start (not (not_blocked seg_W1_154b_0_45 ?a)))
                 (at end (at-segment ?a seg_W1_154b_0_45))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_W1_C3a_0_34 ?a)))
                 (at end (not_blocked seg_W1_C3a_0_34 ?a))

                 (at start (blocked seg_W1_154a_0_34 ?a))
                 (at start (not (not_blocked seg_W1_154a_0_34 ?a)))
                )
)

(:durative-action move_seg_W1_154b_0_45_seg_p154_0_75_south_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_W1_154b_0_45))
                 (at start (not_occupied seg_p154_0_75))
                 (at start (not_blocked seg_p154_0_75 airplane_CFBEG))
                 (at start (not_blocked seg_p154_0_75 airplane_CFBE1))
                 (at start (not_blocked seg_p154_0_75 airplane_CFBE3))
                 (at start (not_blocked seg_p154_0_75 airplane_DAEW8))
                 (at start (not_blocked seg_p154_0_75 airplane_DAEW9))
                 (at start (not_blocked seg_p154_0_75 airplane_DAEW0))
                 (at start (not_blocked seg_p154_0_75 airplane_DAEW3))
                 (at start (not_blocked seg_p154_0_75 airplane_DAEWH))
                 (at start (not_blocked seg_p154_0_75 airplane_DAEW1))
                 (at start (not_blocked seg_p154_0_75 airplane_DAEW2))
                 (at start (not_blocked seg_p154_0_75 airplane_DAEW4))
                 (at start (not_blocked seg_p154_0_75 airplane_DAEW5))
                 (at start (not_blocked seg_p154_0_75 airplane_DAEW6))
                 (at start (not_blocked seg_p154_0_75 airplane_DAEW7))
                 (at start (not_blocked seg_p154_0_75 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_W1_154b_0_45)))
                 (at end (not_occupied seg_W1_154b_0_45))
                 (at start (not (at-segment ?a seg_W1_154b_0_45)))

                 (at start (occupied seg_p154_0_75))
                 (at start (not (not_occupied seg_p154_0_75)))
                 (at start (blocked seg_p154_0_75 ?a))
                 (at start (not (not_blocked seg_p154_0_75 ?a)))
                 (at end (at-segment ?a seg_p154_0_75))

                 (at end (not (blocked seg_W1_154a_0_34 ?a)))
                 (at end (not_blocked seg_W1_154a_0_34 ?a))
                 (at end (not (blocked seg_W1_154c_0_34 ?a)))
                 (at end (not_blocked seg_W1_154c_0_34 ?a))

                )
)

(:durative-action move_seg_W1_154a_0_34_seg_W1_154b_0_45_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_W1_154a_0_34))
                 (at start (not_occupied seg_W1_154b_0_45))
                 (at start (not_blocked seg_W1_154b_0_45 airplane_CFBEG))
                 (at start (not_blocked seg_W1_154b_0_45 airplane_CFBE1))
                 (at start (not_blocked seg_W1_154b_0_45 airplane_CFBE3))
                 (at start (not_blocked seg_W1_154b_0_45 airplane_DAEW8))
                 (at start (not_blocked seg_W1_154b_0_45 airplane_DAEW9))
                 (at start (not_blocked seg_W1_154b_0_45 airplane_DAEW0))
                 (at start (not_blocked seg_W1_154b_0_45 airplane_DAEW3))
                 (at start (not_blocked seg_W1_154b_0_45 airplane_DAEWH))
                 (at start (not_blocked seg_W1_154b_0_45 airplane_DAEW1))
                 (at start (not_blocked seg_W1_154b_0_45 airplane_DAEW2))
                 (at start (not_blocked seg_W1_154b_0_45 airplane_DAEW4))
                 (at start (not_blocked seg_W1_154b_0_45 airplane_DAEW5))
                 (at start (not_blocked seg_W1_154b_0_45 airplane_DAEW6))
                 (at start (not_blocked seg_W1_154b_0_45 airplane_DAEW7))
                 (at start (not_blocked seg_W1_154b_0_45 airplane_CFBE2))

                 (over all (not_occupied seg_W1_154c_0_34))
              )

 :effect        (and
                 (at end (not (occupied seg_W1_154a_0_34)))
                 (at end (not_occupied seg_W1_154a_0_34))
                 (at start (not (at-segment ?a seg_W1_154a_0_34)))

                 (at start (occupied seg_W1_154b_0_45))
                 (at start (not (not_occupied seg_W1_154b_0_45)))
                 (at start (blocked seg_W1_154b_0_45 ?a))
                 (at start (not (not_blocked seg_W1_154b_0_45 ?a)))
                 (at end (at-segment ?a seg_W1_154b_0_45))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_W1_153c_0_34 ?a)))
                 (at end (not_blocked seg_W1_153c_0_34 ?a))

                 (at start (blocked seg_W1_154c_0_34 ?a))
                 (at start (not (not_blocked seg_W1_154c_0_34 ?a)))
                )
)

(:durative-action move_seg_p161_0_75_seg_W1_161b_0_45_north_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_p161_0_75))
                 (at start (not_occupied seg_W1_161b_0_45))
                 (at start (not_blocked seg_W1_161b_0_45 airplane_CFBEG))
                 (at start (not_blocked seg_W1_161b_0_45 airplane_CFBE1))
                 (at start (not_blocked seg_W1_161b_0_45 airplane_CFBE3))
                 (at start (not_blocked seg_W1_161b_0_45 airplane_DAEW8))
                 (at start (not_blocked seg_W1_161b_0_45 airplane_DAEW9))
                 (at start (not_blocked seg_W1_161b_0_45 airplane_DAEW0))
                 (at start (not_blocked seg_W1_161b_0_45 airplane_DAEW3))
                 (at start (not_blocked seg_W1_161b_0_45 airplane_DAEWH))
                 (at start (not_blocked seg_W1_161b_0_45 airplane_DAEW1))
                 (at start (not_blocked seg_W1_161b_0_45 airplane_DAEW2))
                 (at start (not_blocked seg_W1_161b_0_45 airplane_DAEW4))
                 (at start (not_blocked seg_W1_161b_0_45 airplane_DAEW5))
                 (at start (not_blocked seg_W1_161b_0_45 airplane_DAEW6))
                 (at start (not_blocked seg_W1_161b_0_45 airplane_DAEW7))
                 (at start (not_blocked seg_W1_161b_0_45 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_p161_0_75)))
                 (at end (not_occupied seg_p161_0_75))
                 (at start (not (at-segment ?a seg_p161_0_75)))

                 (at start (occupied seg_W1_161b_0_45))
                 (at start (not (not_occupied seg_W1_161b_0_45)))
                 (at start (blocked seg_W1_161b_0_45 ?a))
                 (at start (not (not_blocked seg_W1_161b_0_45 ?a)))
                 (at end (at-segment ?a seg_W1_161b_0_45))


                )
)

(:durative-action move_seg_W1_161b_0_45_seg_W1_161a_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_W1_161b_0_45))
                 (at start (not_occupied seg_W1_161a_0_34))
                 (at start (not_blocked seg_W1_161a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_W1_161a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_W1_161a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_W1_161a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_W1_161a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_W1_161a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_W1_161a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_W1_161a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_W1_161a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_W1_161a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_W1_161a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_W1_161a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_W1_161a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_W1_161a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_W1_161a_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_W1_161c_0_34))
              )

 :effect        (and
                 (at end (not (occupied seg_W1_161b_0_45)))
                 (at end (not_occupied seg_W1_161b_0_45))
                 (at start (not (at-segment ?a seg_W1_161b_0_45)))

                 (at start (occupied seg_W1_161a_0_34))
                 (at start (not (not_occupied seg_W1_161a_0_34)))
                 (at start (blocked seg_W1_161a_0_34 ?a))
                 (at start (not (not_blocked seg_W1_161a_0_34 ?a)))
                 (at end (at-segment ?a seg_W1_161a_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_p161_0_75 ?a)))
                 (at end (not_blocked seg_p161_0_75 ?a))

                 (at start (blocked seg_W1_161c_0_34 ?a))
                 (at start (not (not_blocked seg_W1_161c_0_34 ?a)))
                )
)

(:durative-action move_seg_W1_161b_0_45_seg_W1_161c_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_W1_161b_0_45))
                 (at start (not_occupied seg_W1_161c_0_34))
                 (at start (not_blocked seg_W1_161c_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_W1_161c_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_W1_161c_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_W1_161c_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_W1_161c_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_W1_161c_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_W1_161c_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_W1_161c_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_W1_161c_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_W1_161c_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_W1_161c_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_W1_161c_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_W1_161c_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_W1_161c_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_W1_161c_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_W1_161a_0_34))
              )

 :effect        (and
                 (at end (not (occupied seg_W1_161b_0_45)))
                 (at end (not_occupied seg_W1_161b_0_45))
                 (at start (not (at-segment ?a seg_W1_161b_0_45)))

                 (at start (occupied seg_W1_161c_0_34))
                 (at start (not (not_occupied seg_W1_161c_0_34)))
                 (at start (blocked seg_W1_161c_0_34 ?a))
                 (at start (not (not_blocked seg_W1_161c_0_34 ?a)))
                 (at end (at-segment ?a seg_W1_161c_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_p161_0_75 ?a)))
                 (at end (not_blocked seg_p161_0_75 ?a))

                 (at start (blocked seg_W1_161a_0_34 ?a))
                 (at start (not (not_blocked seg_W1_161a_0_34 ?a)))
                )
)

(:durative-action move_seg_W1_161c_0_34_seg_W1_161b_0_45_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_W1_161c_0_34))
                 (at start (not_occupied seg_W1_161b_0_45))
                 (at start (not_blocked seg_W1_161b_0_45 airplane_CFBEG))
                 (at start (not_blocked seg_W1_161b_0_45 airplane_CFBE1))
                 (at start (not_blocked seg_W1_161b_0_45 airplane_CFBE3))
                 (at start (not_blocked seg_W1_161b_0_45 airplane_DAEW8))
                 (at start (not_blocked seg_W1_161b_0_45 airplane_DAEW9))
                 (at start (not_blocked seg_W1_161b_0_45 airplane_DAEW0))
                 (at start (not_blocked seg_W1_161b_0_45 airplane_DAEW3))
                 (at start (not_blocked seg_W1_161b_0_45 airplane_DAEWH))
                 (at start (not_blocked seg_W1_161b_0_45 airplane_DAEW1))
                 (at start (not_blocked seg_W1_161b_0_45 airplane_DAEW2))
                 (at start (not_blocked seg_W1_161b_0_45 airplane_DAEW4))
                 (at start (not_blocked seg_W1_161b_0_45 airplane_DAEW5))
                 (at start (not_blocked seg_W1_161b_0_45 airplane_DAEW6))
                 (at start (not_blocked seg_W1_161b_0_45 airplane_DAEW7))
                 (at start (not_blocked seg_W1_161b_0_45 airplane_CFBE2))

                 (over all (not_occupied seg_W1_161a_0_34))
              )

 :effect        (and
                 (at end (not (occupied seg_W1_161c_0_34)))
                 (at end (not_occupied seg_W1_161c_0_34))
                 (at start (not (at-segment ?a seg_W1_161c_0_34)))

                 (at start (occupied seg_W1_161b_0_45))
                 (at start (not (not_occupied seg_W1_161b_0_45)))
                 (at start (blocked seg_W1_161b_0_45 ?a))
                 (at start (not (not_blocked seg_W1_161b_0_45 ?a)))
                 (at end (at-segment ?a seg_W1_161b_0_45))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_W1_162a_0_34 ?a)))
                 (at end (not_blocked seg_W1_162a_0_34 ?a))

                 (at start (blocked seg_W1_161a_0_34 ?a))
                 (at start (not (not_blocked seg_W1_161a_0_34 ?a)))
                )
)

(:durative-action move_seg_W1_161b_0_45_seg_p161_0_75_south_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_W1_161b_0_45))
                 (at start (not_occupied seg_p161_0_75))
                 (at start (not_blocked seg_p161_0_75 airplane_CFBEG))
                 (at start (not_blocked seg_p161_0_75 airplane_CFBE1))
                 (at start (not_blocked seg_p161_0_75 airplane_CFBE3))
                 (at start (not_blocked seg_p161_0_75 airplane_DAEW8))
                 (at start (not_blocked seg_p161_0_75 airplane_DAEW9))
                 (at start (not_blocked seg_p161_0_75 airplane_DAEW0))
                 (at start (not_blocked seg_p161_0_75 airplane_DAEW3))
                 (at start (not_blocked seg_p161_0_75 airplane_DAEWH))
                 (at start (not_blocked seg_p161_0_75 airplane_DAEW1))
                 (at start (not_blocked seg_p161_0_75 airplane_DAEW2))
                 (at start (not_blocked seg_p161_0_75 airplane_DAEW4))
                 (at start (not_blocked seg_p161_0_75 airplane_DAEW5))
                 (at start (not_blocked seg_p161_0_75 airplane_DAEW6))
                 (at start (not_blocked seg_p161_0_75 airplane_DAEW7))
                 (at start (not_blocked seg_p161_0_75 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_W1_161b_0_45)))
                 (at end (not_occupied seg_W1_161b_0_45))
                 (at start (not (at-segment ?a seg_W1_161b_0_45)))

                 (at start (occupied seg_p161_0_75))
                 (at start (not (not_occupied seg_p161_0_75)))
                 (at start (blocked seg_p161_0_75 ?a))
                 (at start (not (not_blocked seg_p161_0_75 ?a)))
                 (at end (at-segment ?a seg_p161_0_75))

                 (at end (not (blocked seg_W1_161a_0_34 ?a)))
                 (at end (not_blocked seg_W1_161a_0_34 ?a))
                 (at end (not (blocked seg_W1_161c_0_34 ?a)))
                 (at end (not_blocked seg_W1_161c_0_34 ?a))

                )
)

(:durative-action move_seg_W1_161a_0_34_seg_W1_161b_0_45_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_W1_161a_0_34))
                 (at start (not_occupied seg_W1_161b_0_45))
                 (at start (not_blocked seg_W1_161b_0_45 airplane_CFBEG))
                 (at start (not_blocked seg_W1_161b_0_45 airplane_CFBE1))
                 (at start (not_blocked seg_W1_161b_0_45 airplane_CFBE3))
                 (at start (not_blocked seg_W1_161b_0_45 airplane_DAEW8))
                 (at start (not_blocked seg_W1_161b_0_45 airplane_DAEW9))
                 (at start (not_blocked seg_W1_161b_0_45 airplane_DAEW0))
                 (at start (not_blocked seg_W1_161b_0_45 airplane_DAEW3))
                 (at start (not_blocked seg_W1_161b_0_45 airplane_DAEWH))
                 (at start (not_blocked seg_W1_161b_0_45 airplane_DAEW1))
                 (at start (not_blocked seg_W1_161b_0_45 airplane_DAEW2))
                 (at start (not_blocked seg_W1_161b_0_45 airplane_DAEW4))
                 (at start (not_blocked seg_W1_161b_0_45 airplane_DAEW5))
                 (at start (not_blocked seg_W1_161b_0_45 airplane_DAEW6))
                 (at start (not_blocked seg_W1_161b_0_45 airplane_DAEW7))
                 (at start (not_blocked seg_W1_161b_0_45 airplane_CFBE2))

                 (over all (not_occupied seg_W1_161c_0_34))
              )

 :effect        (and
                 (at end (not (occupied seg_W1_161a_0_34)))
                 (at end (not_occupied seg_W1_161a_0_34))
                 (at start (not (at-segment ?a seg_W1_161a_0_34)))

                 (at start (occupied seg_W1_161b_0_45))
                 (at start (not (not_occupied seg_W1_161b_0_45)))
                 (at start (blocked seg_W1_161b_0_45 ?a))
                 (at start (not (not_blocked seg_W1_161b_0_45 ?a)))
                 (at end (at-segment ?a seg_W1_161b_0_45))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_W1_C3c_0_48 ?a)))
                 (at end (not_blocked seg_W1_C3c_0_48 ?a))

                 (at start (blocked seg_W1_161c_0_34 ?a))
                 (at start (not (not_blocked seg_W1_161c_0_34 ?a)))
                )
)

(:durative-action move_seg_p162_0_75_seg_W1_162b_0_45_north_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_p162_0_75))
                 (at start (not_occupied seg_W1_162b_0_45))
                 (at start (not_blocked seg_W1_162b_0_45 airplane_CFBEG))
                 (at start (not_blocked seg_W1_162b_0_45 airplane_CFBE1))
                 (at start (not_blocked seg_W1_162b_0_45 airplane_CFBE3))
                 (at start (not_blocked seg_W1_162b_0_45 airplane_DAEW8))
                 (at start (not_blocked seg_W1_162b_0_45 airplane_DAEW9))
                 (at start (not_blocked seg_W1_162b_0_45 airplane_DAEW0))
                 (at start (not_blocked seg_W1_162b_0_45 airplane_DAEW3))
                 (at start (not_blocked seg_W1_162b_0_45 airplane_DAEWH))
                 (at start (not_blocked seg_W1_162b_0_45 airplane_DAEW1))
                 (at start (not_blocked seg_W1_162b_0_45 airplane_DAEW2))
                 (at start (not_blocked seg_W1_162b_0_45 airplane_DAEW4))
                 (at start (not_blocked seg_W1_162b_0_45 airplane_DAEW5))
                 (at start (not_blocked seg_W1_162b_0_45 airplane_DAEW6))
                 (at start (not_blocked seg_W1_162b_0_45 airplane_DAEW7))
                 (at start (not_blocked seg_W1_162b_0_45 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_p162_0_75)))
                 (at end (not_occupied seg_p162_0_75))
                 (at start (not (at-segment ?a seg_p162_0_75)))

                 (at start (occupied seg_W1_162b_0_45))
                 (at start (not (not_occupied seg_W1_162b_0_45)))
                 (at start (blocked seg_W1_162b_0_45 ?a))
                 (at start (not (not_blocked seg_W1_162b_0_45 ?a)))
                 (at end (at-segment ?a seg_W1_162b_0_45))


                )
)

(:durative-action move_seg_W1_162b_0_45_seg_W1_162a_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_W1_162b_0_45))
                 (at start (not_occupied seg_W1_162a_0_34))
                 (at start (not_blocked seg_W1_162a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_W1_162a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_W1_162a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_W1_162a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_W1_162a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_W1_162a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_W1_162a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_W1_162a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_W1_162a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_W1_162a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_W1_162a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_W1_162a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_W1_162a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_W1_162a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_W1_162a_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_W1_162c_0_34))
              )

 :effect        (and
                 (at end (not (occupied seg_W1_162b_0_45)))
                 (at end (not_occupied seg_W1_162b_0_45))
                 (at start (not (at-segment ?a seg_W1_162b_0_45)))

                 (at start (occupied seg_W1_162a_0_34))
                 (at start (not (not_occupied seg_W1_162a_0_34)))
                 (at start (blocked seg_W1_162a_0_34 ?a))
                 (at start (not (not_blocked seg_W1_162a_0_34 ?a)))
                 (at end (at-segment ?a seg_W1_162a_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_p162_0_75 ?a)))
                 (at end (not_blocked seg_p162_0_75 ?a))

                 (at start (blocked seg_W1_162c_0_34 ?a))
                 (at start (not (not_blocked seg_W1_162c_0_34 ?a)))
                )
)

(:durative-action move_seg_W1_162b_0_45_seg_W1_162c_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_W1_162b_0_45))
                 (at start (not_occupied seg_W1_162c_0_34))
                 (at start (not_blocked seg_W1_162c_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_W1_162c_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_W1_162c_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_W1_162c_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_W1_162c_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_W1_162c_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_W1_162c_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_W1_162c_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_W1_162c_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_W1_162c_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_W1_162c_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_W1_162c_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_W1_162c_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_W1_162c_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_W1_162c_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_W1_162a_0_34))
              )

 :effect        (and
                 (at end (not (occupied seg_W1_162b_0_45)))
                 (at end (not_occupied seg_W1_162b_0_45))
                 (at start (not (at-segment ?a seg_W1_162b_0_45)))

                 (at start (occupied seg_W1_162c_0_34))
                 (at start (not (not_occupied seg_W1_162c_0_34)))
                 (at start (blocked seg_W1_162c_0_34 ?a))
                 (at start (not (not_blocked seg_W1_162c_0_34 ?a)))
                 (at end (at-segment ?a seg_W1_162c_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_p162_0_75 ?a)))
                 (at end (not_blocked seg_p162_0_75 ?a))

                 (at start (blocked seg_W1_162a_0_34 ?a))
                 (at start (not (not_blocked seg_W1_162a_0_34 ?a)))
                )
)

(:durative-action move_seg_W1_162c_0_34_seg_W1_162b_0_45_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_W1_162c_0_34))
                 (at start (not_occupied seg_W1_162b_0_45))
                 (at start (not_blocked seg_W1_162b_0_45 airplane_CFBEG))
                 (at start (not_blocked seg_W1_162b_0_45 airplane_CFBE1))
                 (at start (not_blocked seg_W1_162b_0_45 airplane_CFBE3))
                 (at start (not_blocked seg_W1_162b_0_45 airplane_DAEW8))
                 (at start (not_blocked seg_W1_162b_0_45 airplane_DAEW9))
                 (at start (not_blocked seg_W1_162b_0_45 airplane_DAEW0))
                 (at start (not_blocked seg_W1_162b_0_45 airplane_DAEW3))
                 (at start (not_blocked seg_W1_162b_0_45 airplane_DAEWH))
                 (at start (not_blocked seg_W1_162b_0_45 airplane_DAEW1))
                 (at start (not_blocked seg_W1_162b_0_45 airplane_DAEW2))
                 (at start (not_blocked seg_W1_162b_0_45 airplane_DAEW4))
                 (at start (not_blocked seg_W1_162b_0_45 airplane_DAEW5))
                 (at start (not_blocked seg_W1_162b_0_45 airplane_DAEW6))
                 (at start (not_blocked seg_W1_162b_0_45 airplane_DAEW7))
                 (at start (not_blocked seg_W1_162b_0_45 airplane_CFBE2))

                 (over all (not_occupied seg_W1_162a_0_34))
              )

 :effect        (and
                 (at end (not (occupied seg_W1_162c_0_34)))
                 (at end (not_occupied seg_W1_162c_0_34))
                 (at start (not (at-segment ?a seg_W1_162c_0_34)))

                 (at start (occupied seg_W1_162b_0_45))
                 (at start (not (not_occupied seg_W1_162b_0_45)))
                 (at start (blocked seg_W1_162b_0_45 ?a))
                 (at start (not (not_blocked seg_W1_162b_0_45 ?a)))
                 (at end (at-segment ?a seg_W1_162b_0_45))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_W1_163a_0_34 ?a)))
                 (at end (not_blocked seg_W1_163a_0_34 ?a))

                 (at start (blocked seg_W1_162a_0_34 ?a))
                 (at start (not (not_blocked seg_W1_162a_0_34 ?a)))
                )
)

(:durative-action move_seg_W1_162b_0_45_seg_p162_0_75_south_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_W1_162b_0_45))
                 (at start (not_occupied seg_p162_0_75))
                 (at start (not_blocked seg_p162_0_75 airplane_CFBEG))
                 (at start (not_blocked seg_p162_0_75 airplane_CFBE1))
                 (at start (not_blocked seg_p162_0_75 airplane_CFBE3))
                 (at start (not_blocked seg_p162_0_75 airplane_DAEW8))
                 (at start (not_blocked seg_p162_0_75 airplane_DAEW9))
                 (at start (not_blocked seg_p162_0_75 airplane_DAEW0))
                 (at start (not_blocked seg_p162_0_75 airplane_DAEW3))
                 (at start (not_blocked seg_p162_0_75 airplane_DAEWH))
                 (at start (not_blocked seg_p162_0_75 airplane_DAEW1))
                 (at start (not_blocked seg_p162_0_75 airplane_DAEW2))
                 (at start (not_blocked seg_p162_0_75 airplane_DAEW4))
                 (at start (not_blocked seg_p162_0_75 airplane_DAEW5))
                 (at start (not_blocked seg_p162_0_75 airplane_DAEW6))
                 (at start (not_blocked seg_p162_0_75 airplane_DAEW7))
                 (at start (not_blocked seg_p162_0_75 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_W1_162b_0_45)))
                 (at end (not_occupied seg_W1_162b_0_45))
                 (at start (not (at-segment ?a seg_W1_162b_0_45)))

                 (at start (occupied seg_p162_0_75))
                 (at start (not (not_occupied seg_p162_0_75)))
                 (at start (blocked seg_p162_0_75 ?a))
                 (at start (not (not_blocked seg_p162_0_75 ?a)))
                 (at end (at-segment ?a seg_p162_0_75))

                 (at end (not (blocked seg_W1_162a_0_34 ?a)))
                 (at end (not_blocked seg_W1_162a_0_34 ?a))
                 (at end (not (blocked seg_W1_162c_0_34 ?a)))
                 (at end (not_blocked seg_W1_162c_0_34 ?a))

                )
)

(:durative-action move_seg_W1_162a_0_34_seg_W1_162b_0_45_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_W1_162a_0_34))
                 (at start (not_occupied seg_W1_162b_0_45))
                 (at start (not_blocked seg_W1_162b_0_45 airplane_CFBEG))
                 (at start (not_blocked seg_W1_162b_0_45 airplane_CFBE1))
                 (at start (not_blocked seg_W1_162b_0_45 airplane_CFBE3))
                 (at start (not_blocked seg_W1_162b_0_45 airplane_DAEW8))
                 (at start (not_blocked seg_W1_162b_0_45 airplane_DAEW9))
                 (at start (not_blocked seg_W1_162b_0_45 airplane_DAEW0))
                 (at start (not_blocked seg_W1_162b_0_45 airplane_DAEW3))
                 (at start (not_blocked seg_W1_162b_0_45 airplane_DAEWH))
                 (at start (not_blocked seg_W1_162b_0_45 airplane_DAEW1))
                 (at start (not_blocked seg_W1_162b_0_45 airplane_DAEW2))
                 (at start (not_blocked seg_W1_162b_0_45 airplane_DAEW4))
                 (at start (not_blocked seg_W1_162b_0_45 airplane_DAEW5))
                 (at start (not_blocked seg_W1_162b_0_45 airplane_DAEW6))
                 (at start (not_blocked seg_W1_162b_0_45 airplane_DAEW7))
                 (at start (not_blocked seg_W1_162b_0_45 airplane_CFBE2))

                 (over all (not_occupied seg_W1_162c_0_34))
              )

 :effect        (and
                 (at end (not (occupied seg_W1_162a_0_34)))
                 (at end (not_occupied seg_W1_162a_0_34))
                 (at start (not (at-segment ?a seg_W1_162a_0_34)))

                 (at start (occupied seg_W1_162b_0_45))
                 (at start (not (not_occupied seg_W1_162b_0_45)))
                 (at start (blocked seg_W1_162b_0_45 ?a))
                 (at start (not (not_blocked seg_W1_162b_0_45 ?a)))
                 (at end (at-segment ?a seg_W1_162b_0_45))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_W1_161c_0_34 ?a)))
                 (at end (not_blocked seg_W1_161c_0_34 ?a))

                 (at start (blocked seg_W1_162c_0_34 ?a))
                 (at start (not (not_blocked seg_W1_162c_0_34 ?a)))
                )
)

(:durative-action move_seg_p163_0_75_seg_W1_163b_0_45_north_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_p163_0_75))
                 (at start (not_occupied seg_W1_163b_0_45))
                 (at start (not_blocked seg_W1_163b_0_45 airplane_CFBEG))
                 (at start (not_blocked seg_W1_163b_0_45 airplane_CFBE1))
                 (at start (not_blocked seg_W1_163b_0_45 airplane_CFBE3))
                 (at start (not_blocked seg_W1_163b_0_45 airplane_DAEW8))
                 (at start (not_blocked seg_W1_163b_0_45 airplane_DAEW9))
                 (at start (not_blocked seg_W1_163b_0_45 airplane_DAEW0))
                 (at start (not_blocked seg_W1_163b_0_45 airplane_DAEW3))
                 (at start (not_blocked seg_W1_163b_0_45 airplane_DAEWH))
                 (at start (not_blocked seg_W1_163b_0_45 airplane_DAEW1))
                 (at start (not_blocked seg_W1_163b_0_45 airplane_DAEW2))
                 (at start (not_blocked seg_W1_163b_0_45 airplane_DAEW4))
                 (at start (not_blocked seg_W1_163b_0_45 airplane_DAEW5))
                 (at start (not_blocked seg_W1_163b_0_45 airplane_DAEW6))
                 (at start (not_blocked seg_W1_163b_0_45 airplane_DAEW7))
                 (at start (not_blocked seg_W1_163b_0_45 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_p163_0_75)))
                 (at end (not_occupied seg_p163_0_75))
                 (at start (not (at-segment ?a seg_p163_0_75)))

                 (at start (occupied seg_W1_163b_0_45))
                 (at start (not (not_occupied seg_W1_163b_0_45)))
                 (at start (blocked seg_W1_163b_0_45 ?a))
                 (at start (not (not_blocked seg_W1_163b_0_45 ?a)))
                 (at end (at-segment ?a seg_W1_163b_0_45))


                )
)

(:durative-action move_seg_W1_163b_0_45_seg_W1_163a_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_W1_163b_0_45))
                 (at start (not_occupied seg_W1_163a_0_34))
                 (at start (not_blocked seg_W1_163a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_W1_163a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_W1_163a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_W1_163a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_W1_163a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_W1_163a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_W1_163a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_W1_163a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_W1_163a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_W1_163a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_W1_163a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_W1_163a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_W1_163a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_W1_163a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_W1_163a_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_W1_163c_0_34))
              )

 :effect        (and
                 (at end (not (occupied seg_W1_163b_0_45)))
                 (at end (not_occupied seg_W1_163b_0_45))
                 (at start (not (at-segment ?a seg_W1_163b_0_45)))

                 (at start (occupied seg_W1_163a_0_34))
                 (at start (not (not_occupied seg_W1_163a_0_34)))
                 (at start (blocked seg_W1_163a_0_34 ?a))
                 (at start (not (not_blocked seg_W1_163a_0_34 ?a)))
                 (at end (at-segment ?a seg_W1_163a_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_p163_0_75 ?a)))
                 (at end (not_blocked seg_p163_0_75 ?a))

                 (at start (blocked seg_W1_163c_0_34 ?a))
                 (at start (not (not_blocked seg_W1_163c_0_34 ?a)))
                )
)

(:durative-action move_seg_W1_163b_0_45_seg_W1_163c_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_W1_163b_0_45))
                 (at start (not_occupied seg_W1_163c_0_34))
                 (at start (not_blocked seg_W1_163c_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_W1_163c_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_W1_163c_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_W1_163c_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_W1_163c_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_W1_163c_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_W1_163c_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_W1_163c_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_W1_163c_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_W1_163c_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_W1_163c_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_W1_163c_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_W1_163c_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_W1_163c_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_W1_163c_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_W1_163a_0_34))
              )

 :effect        (and
                 (at end (not (occupied seg_W1_163b_0_45)))
                 (at end (not_occupied seg_W1_163b_0_45))
                 (at start (not (at-segment ?a seg_W1_163b_0_45)))

                 (at start (occupied seg_W1_163c_0_34))
                 (at start (not (not_occupied seg_W1_163c_0_34)))
                 (at start (blocked seg_W1_163c_0_34 ?a))
                 (at start (not (not_blocked seg_W1_163c_0_34 ?a)))
                 (at end (at-segment ?a seg_W1_163c_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_p163_0_75 ?a)))
                 (at end (not_blocked seg_p163_0_75 ?a))

                 (at start (blocked seg_W1_163a_0_34 ?a))
                 (at start (not (not_blocked seg_W1_163a_0_34 ?a)))
                )
)

(:durative-action move_seg_W1_163c_0_34_seg_W1_163b_0_45_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_W1_163c_0_34))
                 (at start (not_occupied seg_W1_163b_0_45))
                 (at start (not_blocked seg_W1_163b_0_45 airplane_CFBEG))
                 (at start (not_blocked seg_W1_163b_0_45 airplane_CFBE1))
                 (at start (not_blocked seg_W1_163b_0_45 airplane_CFBE3))
                 (at start (not_blocked seg_W1_163b_0_45 airplane_DAEW8))
                 (at start (not_blocked seg_W1_163b_0_45 airplane_DAEW9))
                 (at start (not_blocked seg_W1_163b_0_45 airplane_DAEW0))
                 (at start (not_blocked seg_W1_163b_0_45 airplane_DAEW3))
                 (at start (not_blocked seg_W1_163b_0_45 airplane_DAEWH))
                 (at start (not_blocked seg_W1_163b_0_45 airplane_DAEW1))
                 (at start (not_blocked seg_W1_163b_0_45 airplane_DAEW2))
                 (at start (not_blocked seg_W1_163b_0_45 airplane_DAEW4))
                 (at start (not_blocked seg_W1_163b_0_45 airplane_DAEW5))
                 (at start (not_blocked seg_W1_163b_0_45 airplane_DAEW6))
                 (at start (not_blocked seg_W1_163b_0_45 airplane_DAEW7))
                 (at start (not_blocked seg_W1_163b_0_45 airplane_CFBE2))

                 (over all (not_occupied seg_W1_163a_0_34))
              )

 :effect        (and
                 (at end (not (occupied seg_W1_163c_0_34)))
                 (at end (not_occupied seg_W1_163c_0_34))
                 (at start (not (at-segment ?a seg_W1_163c_0_34)))

                 (at start (occupied seg_W1_163b_0_45))
                 (at start (not (not_occupied seg_W1_163b_0_45)))
                 (at start (blocked seg_W1_163b_0_45 ?a))
                 (at start (not (not_blocked seg_W1_163b_0_45 ?a)))
                 (at end (at-segment ?a seg_W1_163b_0_45))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_W1_164a_0_34 ?a)))
                 (at end (not_blocked seg_W1_164a_0_34 ?a))

                 (at start (blocked seg_W1_163a_0_34 ?a))
                 (at start (not (not_blocked seg_W1_163a_0_34 ?a)))
                )
)

(:durative-action move_seg_W1_163b_0_45_seg_p163_0_75_south_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_W1_163b_0_45))
                 (at start (not_occupied seg_p163_0_75))
                 (at start (not_blocked seg_p163_0_75 airplane_CFBEG))
                 (at start (not_blocked seg_p163_0_75 airplane_CFBE1))
                 (at start (not_blocked seg_p163_0_75 airplane_CFBE3))
                 (at start (not_blocked seg_p163_0_75 airplane_DAEW8))
                 (at start (not_blocked seg_p163_0_75 airplane_DAEW9))
                 (at start (not_blocked seg_p163_0_75 airplane_DAEW0))
                 (at start (not_blocked seg_p163_0_75 airplane_DAEW3))
                 (at start (not_blocked seg_p163_0_75 airplane_DAEWH))
                 (at start (not_blocked seg_p163_0_75 airplane_DAEW1))
                 (at start (not_blocked seg_p163_0_75 airplane_DAEW2))
                 (at start (not_blocked seg_p163_0_75 airplane_DAEW4))
                 (at start (not_blocked seg_p163_0_75 airplane_DAEW5))
                 (at start (not_blocked seg_p163_0_75 airplane_DAEW6))
                 (at start (not_blocked seg_p163_0_75 airplane_DAEW7))
                 (at start (not_blocked seg_p163_0_75 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_W1_163b_0_45)))
                 (at end (not_occupied seg_W1_163b_0_45))
                 (at start (not (at-segment ?a seg_W1_163b_0_45)))

                 (at start (occupied seg_p163_0_75))
                 (at start (not (not_occupied seg_p163_0_75)))
                 (at start (blocked seg_p163_0_75 ?a))
                 (at start (not (not_blocked seg_p163_0_75 ?a)))
                 (at end (at-segment ?a seg_p163_0_75))

                 (at end (not (blocked seg_W1_163a_0_34 ?a)))
                 (at end (not_blocked seg_W1_163a_0_34 ?a))
                 (at end (not (blocked seg_W1_163c_0_34 ?a)))
                 (at end (not_blocked seg_W1_163c_0_34 ?a))

                )
)

(:durative-action move_seg_W1_163a_0_34_seg_W1_163b_0_45_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_W1_163a_0_34))
                 (at start (not_occupied seg_W1_163b_0_45))
                 (at start (not_blocked seg_W1_163b_0_45 airplane_CFBEG))
                 (at start (not_blocked seg_W1_163b_0_45 airplane_CFBE1))
                 (at start (not_blocked seg_W1_163b_0_45 airplane_CFBE3))
                 (at start (not_blocked seg_W1_163b_0_45 airplane_DAEW8))
                 (at start (not_blocked seg_W1_163b_0_45 airplane_DAEW9))
                 (at start (not_blocked seg_W1_163b_0_45 airplane_DAEW0))
                 (at start (not_blocked seg_W1_163b_0_45 airplane_DAEW3))
                 (at start (not_blocked seg_W1_163b_0_45 airplane_DAEWH))
                 (at start (not_blocked seg_W1_163b_0_45 airplane_DAEW1))
                 (at start (not_blocked seg_W1_163b_0_45 airplane_DAEW2))
                 (at start (not_blocked seg_W1_163b_0_45 airplane_DAEW4))
                 (at start (not_blocked seg_W1_163b_0_45 airplane_DAEW5))
                 (at start (not_blocked seg_W1_163b_0_45 airplane_DAEW6))
                 (at start (not_blocked seg_W1_163b_0_45 airplane_DAEW7))
                 (at start (not_blocked seg_W1_163b_0_45 airplane_CFBE2))

                 (over all (not_occupied seg_W1_163c_0_34))
              )

 :effect        (and
                 (at end (not (occupied seg_W1_163a_0_34)))
                 (at end (not_occupied seg_W1_163a_0_34))
                 (at start (not (at-segment ?a seg_W1_163a_0_34)))

                 (at start (occupied seg_W1_163b_0_45))
                 (at start (not (not_occupied seg_W1_163b_0_45)))
                 (at start (blocked seg_W1_163b_0_45 ?a))
                 (at start (not (not_blocked seg_W1_163b_0_45 ?a)))
                 (at end (at-segment ?a seg_W1_163b_0_45))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_W1_162c_0_34 ?a)))
                 (at end (not_blocked seg_W1_162c_0_34 ?a))

                 (at start (blocked seg_W1_163c_0_34 ?a))
                 (at start (not (not_blocked seg_W1_163c_0_34 ?a)))
                )
)

(:durative-action move_seg_p164_0_75_seg_W1_164b_0_45_north_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_p164_0_75))
                 (at start (not_occupied seg_W1_164b_0_45))
                 (at start (not_blocked seg_W1_164b_0_45 airplane_CFBEG))
                 (at start (not_blocked seg_W1_164b_0_45 airplane_CFBE1))
                 (at start (not_blocked seg_W1_164b_0_45 airplane_CFBE3))
                 (at start (not_blocked seg_W1_164b_0_45 airplane_DAEW8))
                 (at start (not_blocked seg_W1_164b_0_45 airplane_DAEW9))
                 (at start (not_blocked seg_W1_164b_0_45 airplane_DAEW0))
                 (at start (not_blocked seg_W1_164b_0_45 airplane_DAEW3))
                 (at start (not_blocked seg_W1_164b_0_45 airplane_DAEWH))
                 (at start (not_blocked seg_W1_164b_0_45 airplane_DAEW1))
                 (at start (not_blocked seg_W1_164b_0_45 airplane_DAEW2))
                 (at start (not_blocked seg_W1_164b_0_45 airplane_DAEW4))
                 (at start (not_blocked seg_W1_164b_0_45 airplane_DAEW5))
                 (at start (not_blocked seg_W1_164b_0_45 airplane_DAEW6))
                 (at start (not_blocked seg_W1_164b_0_45 airplane_DAEW7))
                 (at start (not_blocked seg_W1_164b_0_45 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_p164_0_75)))
                 (at end (not_occupied seg_p164_0_75))
                 (at start (not (at-segment ?a seg_p164_0_75)))

                 (at start (occupied seg_W1_164b_0_45))
                 (at start (not (not_occupied seg_W1_164b_0_45)))
                 (at start (blocked seg_W1_164b_0_45 ?a))
                 (at start (not (not_blocked seg_W1_164b_0_45 ?a)))
                 (at end (at-segment ?a seg_W1_164b_0_45))


                )
)

(:durative-action move_seg_W1_164b_0_45_seg_W1_164a_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_W1_164b_0_45))
                 (at start (not_occupied seg_W1_164a_0_34))
                 (at start (not_blocked seg_W1_164a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_W1_164a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_W1_164a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_W1_164a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_W1_164a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_W1_164a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_W1_164a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_W1_164a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_W1_164a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_W1_164a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_W1_164a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_W1_164a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_W1_164a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_W1_164a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_W1_164a_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_W1_164c_0_34))
              )

 :effect        (and
                 (at end (not (occupied seg_W1_164b_0_45)))
                 (at end (not_occupied seg_W1_164b_0_45))
                 (at start (not (at-segment ?a seg_W1_164b_0_45)))

                 (at start (occupied seg_W1_164a_0_34))
                 (at start (not (not_occupied seg_W1_164a_0_34)))
                 (at start (blocked seg_W1_164a_0_34 ?a))
                 (at start (not (not_blocked seg_W1_164a_0_34 ?a)))
                 (at end (at-segment ?a seg_W1_164a_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_p164_0_75 ?a)))
                 (at end (not_blocked seg_p164_0_75 ?a))

                 (at start (blocked seg_W1_164c_0_34 ?a))
                 (at start (not (not_blocked seg_W1_164c_0_34 ?a)))
                )
)

(:durative-action move_seg_W1_164b_0_45_seg_W1_164c_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_W1_164b_0_45))
                 (at start (not_occupied seg_W1_164c_0_34))
                 (at start (not_blocked seg_W1_164c_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_W1_164c_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_W1_164c_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_W1_164c_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_W1_164c_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_W1_164c_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_W1_164c_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_W1_164c_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_W1_164c_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_W1_164c_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_W1_164c_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_W1_164c_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_W1_164c_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_W1_164c_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_W1_164c_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_W1_164a_0_34))
              )

 :effect        (and
                 (at end (not (occupied seg_W1_164b_0_45)))
                 (at end (not_occupied seg_W1_164b_0_45))
                 (at start (not (at-segment ?a seg_W1_164b_0_45)))

                 (at start (occupied seg_W1_164c_0_34))
                 (at start (not (not_occupied seg_W1_164c_0_34)))
                 (at start (blocked seg_W1_164c_0_34 ?a))
                 (at start (not (not_blocked seg_W1_164c_0_34 ?a)))
                 (at end (at-segment ?a seg_W1_164c_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_p164_0_75 ?a)))
                 (at end (not_blocked seg_p164_0_75 ?a))

                 (at start (blocked seg_W1_164a_0_34 ?a))
                 (at start (not (not_blocked seg_W1_164a_0_34 ?a)))
                )
)

(:durative-action move_seg_W1_164c_0_34_seg_W1_164b_0_45_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_W1_164c_0_34))
                 (at start (not_occupied seg_W1_164b_0_45))
                 (at start (not_blocked seg_W1_164b_0_45 airplane_CFBEG))
                 (at start (not_blocked seg_W1_164b_0_45 airplane_CFBE1))
                 (at start (not_blocked seg_W1_164b_0_45 airplane_CFBE3))
                 (at start (not_blocked seg_W1_164b_0_45 airplane_DAEW8))
                 (at start (not_blocked seg_W1_164b_0_45 airplane_DAEW9))
                 (at start (not_blocked seg_W1_164b_0_45 airplane_DAEW0))
                 (at start (not_blocked seg_W1_164b_0_45 airplane_DAEW3))
                 (at start (not_blocked seg_W1_164b_0_45 airplane_DAEWH))
                 (at start (not_blocked seg_W1_164b_0_45 airplane_DAEW1))
                 (at start (not_blocked seg_W1_164b_0_45 airplane_DAEW2))
                 (at start (not_blocked seg_W1_164b_0_45 airplane_DAEW4))
                 (at start (not_blocked seg_W1_164b_0_45 airplane_DAEW5))
                 (at start (not_blocked seg_W1_164b_0_45 airplane_DAEW6))
                 (at start (not_blocked seg_W1_164b_0_45 airplane_DAEW7))
                 (at start (not_blocked seg_W1_164b_0_45 airplane_CFBE2))

                 (over all (not_occupied seg_W1_164a_0_34))
              )

 :effect        (and
                 (at end (not (occupied seg_W1_164c_0_34)))
                 (at end (not_occupied seg_W1_164c_0_34))
                 (at start (not (at-segment ?a seg_W1_164c_0_34)))

                 (at start (occupied seg_W1_164b_0_45))
                 (at start (not (not_occupied seg_W1_164b_0_45)))
                 (at start (blocked seg_W1_164b_0_45 ?a))
                 (at start (not (not_blocked seg_W1_164b_0_45 ?a)))
                 (at end (at-segment ?a seg_W1_164b_0_45))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_W1_C4a_0_34 ?a)))
                 (at end (not_blocked seg_W1_C4a_0_34 ?a))

                 (at start (blocked seg_W1_164a_0_34 ?a))
                 (at start (not (not_blocked seg_W1_164a_0_34 ?a)))
                )
)

(:durative-action move_seg_W1_164b_0_45_seg_p164_0_75_south_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_W1_164b_0_45))
                 (at start (not_occupied seg_p164_0_75))
                 (at start (not_blocked seg_p164_0_75 airplane_CFBEG))
                 (at start (not_blocked seg_p164_0_75 airplane_CFBE1))
                 (at start (not_blocked seg_p164_0_75 airplane_CFBE3))
                 (at start (not_blocked seg_p164_0_75 airplane_DAEW8))
                 (at start (not_blocked seg_p164_0_75 airplane_DAEW9))
                 (at start (not_blocked seg_p164_0_75 airplane_DAEW0))
                 (at start (not_blocked seg_p164_0_75 airplane_DAEW3))
                 (at start (not_blocked seg_p164_0_75 airplane_DAEWH))
                 (at start (not_blocked seg_p164_0_75 airplane_DAEW1))
                 (at start (not_blocked seg_p164_0_75 airplane_DAEW2))
                 (at start (not_blocked seg_p164_0_75 airplane_DAEW4))
                 (at start (not_blocked seg_p164_0_75 airplane_DAEW5))
                 (at start (not_blocked seg_p164_0_75 airplane_DAEW6))
                 (at start (not_blocked seg_p164_0_75 airplane_DAEW7))
                 (at start (not_blocked seg_p164_0_75 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_W1_164b_0_45)))
                 (at end (not_occupied seg_W1_164b_0_45))
                 (at start (not (at-segment ?a seg_W1_164b_0_45)))

                 (at start (occupied seg_p164_0_75))
                 (at start (not (not_occupied seg_p164_0_75)))
                 (at start (blocked seg_p164_0_75 ?a))
                 (at start (not (not_blocked seg_p164_0_75 ?a)))
                 (at end (at-segment ?a seg_p164_0_75))

                 (at end (not (blocked seg_W1_164a_0_34 ?a)))
                 (at end (not_blocked seg_W1_164a_0_34 ?a))
                 (at end (not (blocked seg_W1_164c_0_34 ?a)))
                 (at end (not_blocked seg_W1_164c_0_34 ?a))

                )
)

(:durative-action move_seg_W1_164a_0_34_seg_W1_164b_0_45_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_W1_164a_0_34))
                 (at start (not_occupied seg_W1_164b_0_45))
                 (at start (not_blocked seg_W1_164b_0_45 airplane_CFBEG))
                 (at start (not_blocked seg_W1_164b_0_45 airplane_CFBE1))
                 (at start (not_blocked seg_W1_164b_0_45 airplane_CFBE3))
                 (at start (not_blocked seg_W1_164b_0_45 airplane_DAEW8))
                 (at start (not_blocked seg_W1_164b_0_45 airplane_DAEW9))
                 (at start (not_blocked seg_W1_164b_0_45 airplane_DAEW0))
                 (at start (not_blocked seg_W1_164b_0_45 airplane_DAEW3))
                 (at start (not_blocked seg_W1_164b_0_45 airplane_DAEWH))
                 (at start (not_blocked seg_W1_164b_0_45 airplane_DAEW1))
                 (at start (not_blocked seg_W1_164b_0_45 airplane_DAEW2))
                 (at start (not_blocked seg_W1_164b_0_45 airplane_DAEW4))
                 (at start (not_blocked seg_W1_164b_0_45 airplane_DAEW5))
                 (at start (not_blocked seg_W1_164b_0_45 airplane_DAEW6))
                 (at start (not_blocked seg_W1_164b_0_45 airplane_DAEW7))
                 (at start (not_blocked seg_W1_164b_0_45 airplane_CFBE2))

                 (over all (not_occupied seg_W1_164c_0_34))
              )

 :effect        (and
                 (at end (not (occupied seg_W1_164a_0_34)))
                 (at end (not_occupied seg_W1_164a_0_34))
                 (at start (not (at-segment ?a seg_W1_164a_0_34)))

                 (at start (occupied seg_W1_164b_0_45))
                 (at start (not (not_occupied seg_W1_164b_0_45)))
                 (at start (blocked seg_W1_164b_0_45 ?a))
                 (at start (not (not_blocked seg_W1_164b_0_45 ?a)))
                 (at end (at-segment ?a seg_W1_164b_0_45))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_W1_163c_0_34 ?a)))
                 (at end (not_blocked seg_W1_163c_0_34 ?a))

                 (at start (blocked seg_W1_164c_0_34 ?a))
                 (at start (not (not_blocked seg_W1_164c_0_34 ?a)))
                )
)

(:durative-action move_seg_p101_0_76_seg_O1_C1a_0_60_north_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_p101_0_76))
                 (at start (not_occupied seg_O1_C1a_0_60))
                 (at start (not_blocked seg_O1_C1a_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_O1_C1a_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_O1_C1a_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_O1_C1a_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_O1_C1a_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_O1_C1a_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_O1_C1a_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_O1_C1a_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_O1_C1a_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_O1_C1a_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_O1_C1a_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_O1_C1a_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_O1_C1a_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_O1_C1a_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_O1_C1a_0_60 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_p101_0_76)))
                 (at end (not_occupied seg_p101_0_76))
                 (at start (not (at-segment ?a seg_p101_0_76)))

                 (at start (occupied seg_O1_C1a_0_60))
                 (at start (not (not_occupied seg_O1_C1a_0_60)))
                 (at start (blocked seg_O1_C1a_0_60 ?a))
                 (at start (not (not_blocked seg_O1_C1a_0_60 ?a)))
                 (at end (at-segment ?a seg_O1_C1a_0_60))


                )
)

(:durative-action move_seg_O1_C1a_0_60_seg_O1_C1c_0_80_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_C1a_0_60))
                 (at start (not_occupied seg_O1_C1c_0_80))
                 (at start (not_blocked seg_O1_C1c_0_80 airplane_CFBEG))
                 (at start (not_blocked seg_O1_C1c_0_80 airplane_CFBE1))
                 (at start (not_blocked seg_O1_C1c_0_80 airplane_CFBE3))
                 (at start (not_blocked seg_O1_C1c_0_80 airplane_DAEW8))
                 (at start (not_blocked seg_O1_C1c_0_80 airplane_DAEW9))
                 (at start (not_blocked seg_O1_C1c_0_80 airplane_DAEW0))
                 (at start (not_blocked seg_O1_C1c_0_80 airplane_DAEW3))
                 (at start (not_blocked seg_O1_C1c_0_80 airplane_DAEWH))
                 (at start (not_blocked seg_O1_C1c_0_80 airplane_DAEW1))
                 (at start (not_blocked seg_O1_C1c_0_80 airplane_DAEW2))
                 (at start (not_blocked seg_O1_C1c_0_80 airplane_DAEW4))
                 (at start (not_blocked seg_O1_C1c_0_80 airplane_DAEW5))
                 (at start (not_blocked seg_O1_C1c_0_80 airplane_DAEW6))
                 (at start (not_blocked seg_O1_C1c_0_80 airplane_DAEW7))
                 (at start (not_blocked seg_O1_C1c_0_80 airplane_CFBE2))

                 (over all (not_occupied seg_O1_C1b_0_34))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_C1a_0_60)))
                 (at end (not_occupied seg_O1_C1a_0_60))
                 (at start (not (at-segment ?a seg_O1_C1a_0_60)))

                 (at start (occupied seg_O1_C1c_0_80))
                 (at start (not (not_occupied seg_O1_C1c_0_80)))
                 (at start (blocked seg_O1_C1c_0_80 ?a))
                 (at start (not (not_blocked seg_O1_C1c_0_80 ?a)))
                 (at end (at-segment ?a seg_O1_C1c_0_80))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_p101_0_76 ?a)))
                 (at end (not_blocked seg_p101_0_76 ?a))

                 (at start (blocked seg_O1_C1b_0_34 ?a))
                 (at start (not (not_blocked seg_O1_C1b_0_34 ?a)))
                )
)

(:durative-action move_seg_O1_C1c_0_80_seg_C1_n2b_0_80_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_O1_C1c_0_80))
                 (at start (not_occupied seg_C1_n2b_0_80))
                 (at start (not_blocked seg_C1_n2b_0_80 airplane_CFBEG))
                 (at start (not_blocked seg_C1_n2b_0_80 airplane_CFBE1))
                 (at start (not_blocked seg_C1_n2b_0_80 airplane_CFBE3))
                 (at start (not_blocked seg_C1_n2b_0_80 airplane_DAEW8))
                 (at start (not_blocked seg_C1_n2b_0_80 airplane_DAEW9))
                 (at start (not_blocked seg_C1_n2b_0_80 airplane_DAEW0))
                 (at start (not_blocked seg_C1_n2b_0_80 airplane_DAEW3))
                 (at start (not_blocked seg_C1_n2b_0_80 airplane_DAEWH))
                 (at start (not_blocked seg_C1_n2b_0_80 airplane_DAEW1))
                 (at start (not_blocked seg_C1_n2b_0_80 airplane_DAEW2))
                 (at start (not_blocked seg_C1_n2b_0_80 airplane_DAEW4))
                 (at start (not_blocked seg_C1_n2b_0_80 airplane_DAEW5))
                 (at start (not_blocked seg_C1_n2b_0_80 airplane_DAEW6))
                 (at start (not_blocked seg_C1_n2b_0_80 airplane_DAEW7))
                 (at start (not_blocked seg_C1_n2b_0_80 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_O1_C1c_0_80)))
                 (at end (not_occupied seg_O1_C1c_0_80))
                 (at start (not (at-segment ?a seg_O1_C1c_0_80)))

                 (at start (occupied seg_C1_n2b_0_80))
                 (at start (not (not_occupied seg_C1_n2b_0_80)))
                 (at start (blocked seg_C1_n2b_0_80 ?a))
                 (at start (not (not_blocked seg_C1_n2b_0_80 ?a)))
                 (at end (at-segment ?a seg_C1_n2b_0_80))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_O1_C1a_0_60 ?a)))
                 (at end (not_blocked seg_O1_C1a_0_60 ?a))
                 (at end (not (blocked seg_O1_C1b_0_34 ?a)))
                 (at end (not_blocked seg_O1_C1b_0_34 ?a))

                )
)

(:durative-action move_seg_C1_n2b_0_80_seg_O1_C1c_0_80_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_C1_n2b_0_80))
                 (at start (not_occupied seg_O1_C1c_0_80))
                 (at start (not_blocked seg_O1_C1c_0_80 airplane_CFBEG))
                 (at start (not_blocked seg_O1_C1c_0_80 airplane_CFBE1))
                 (at start (not_blocked seg_O1_C1c_0_80 airplane_CFBE3))
                 (at start (not_blocked seg_O1_C1c_0_80 airplane_DAEW8))
                 (at start (not_blocked seg_O1_C1c_0_80 airplane_DAEW9))
                 (at start (not_blocked seg_O1_C1c_0_80 airplane_DAEW0))
                 (at start (not_blocked seg_O1_C1c_0_80 airplane_DAEW3))
                 (at start (not_blocked seg_O1_C1c_0_80 airplane_DAEWH))
                 (at start (not_blocked seg_O1_C1c_0_80 airplane_DAEW1))
                 (at start (not_blocked seg_O1_C1c_0_80 airplane_DAEW2))
                 (at start (not_blocked seg_O1_C1c_0_80 airplane_DAEW4))
                 (at start (not_blocked seg_O1_C1c_0_80 airplane_DAEW5))
                 (at start (not_blocked seg_O1_C1c_0_80 airplane_DAEW6))
                 (at start (not_blocked seg_O1_C1c_0_80 airplane_DAEW7))
                 (at start (not_blocked seg_O1_C1c_0_80 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_C1_n2b_0_80)))
                 (at end (not_occupied seg_C1_n2b_0_80))
                 (at start (not (at-segment ?a seg_C1_n2b_0_80)))

                 (at start (occupied seg_O1_C1c_0_80))
                 (at start (not (not_occupied seg_O1_C1c_0_80)))
                 (at start (blocked seg_O1_C1c_0_80 ?a))
                 (at start (not (not_blocked seg_O1_C1c_0_80 ?a)))
                 (at end (at-segment ?a seg_O1_C1c_0_80))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_C1_n2a_0_60 ?a)))
                 (at end (not_blocked seg_C1_n2a_0_60 ?a))
                 (at end (not (blocked seg_C1_n2c_0_60 ?a)))
                 (at end (not_blocked seg_C1_n2c_0_60 ?a))

                )
)

(:durative-action move_seg_O1_C1c_0_80_seg_O1_C1b_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_C1c_0_80))
                 (at start (not_occupied seg_O1_C1b_0_34))
                 (at start (not_blocked seg_O1_C1b_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_C1b_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_C1b_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_C1b_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_C1b_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_C1b_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_C1b_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_C1b_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_C1b_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_C1b_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_C1b_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_C1b_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_C1b_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_C1b_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_C1b_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_O1_C1a_0_60))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_C1c_0_80)))
                 (at end (not_occupied seg_O1_C1c_0_80))
                 (at start (not (at-segment ?a seg_O1_C1c_0_80)))

                 (at start (occupied seg_O1_C1b_0_34))
                 (at start (not (not_occupied seg_O1_C1b_0_34)))
                 (at start (blocked seg_O1_C1b_0_34 ?a))
                 (at start (not (not_blocked seg_O1_C1b_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_C1b_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_C1_n2b_0_80 ?a)))
                 (at end (not_blocked seg_C1_n2b_0_80 ?a))

                 (at start (blocked seg_O1_C1a_0_60 ?a))
                 (at start (not (not_blocked seg_O1_C1a_0_60 ?a)))
                )
)

(:durative-action move_seg_O1_C1b_0_34_seg_O1_102a_0_34_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_O1_C1b_0_34))
                 (at start (not_occupied seg_O1_102a_0_34))
                 (at start (not_blocked seg_O1_102a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_102a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_102a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_102a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_102a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_102a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_102a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_102a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_102a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_102a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_102a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_102a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_102a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_102a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_102a_0_34 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_O1_C1b_0_34)))
                 (at end (not_occupied seg_O1_C1b_0_34))
                 (at start (not (at-segment ?a seg_O1_C1b_0_34)))

                 (at start (occupied seg_O1_102a_0_34))
                 (at start (not (not_occupied seg_O1_102a_0_34)))
                 (at start (blocked seg_O1_102a_0_34 ?a))
                 (at start (not (not_blocked seg_O1_102a_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_102a_0_34))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_O1_C1a_0_60 ?a)))
                 (at end (not_blocked seg_O1_C1a_0_60 ?a))
                 (at end (not (blocked seg_O1_C1c_0_80 ?a)))
                 (at end (not_blocked seg_O1_C1c_0_80 ?a))

                )
)

(:durative-action move_seg_O1_102a_0_34_seg_O1_102c_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_102a_0_34))
                 (at start (not_occupied seg_O1_102c_0_34))
                 (at start (not_blocked seg_O1_102c_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_102c_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_102c_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_102c_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_102c_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_102c_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_102c_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_102c_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_102c_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_102c_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_102c_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_102c_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_102c_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_102c_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_102c_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_O1_102b_0_60))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_102a_0_34)))
                 (at end (not_occupied seg_O1_102a_0_34))
                 (at start (not (at-segment ?a seg_O1_102a_0_34)))

                 (at start (occupied seg_O1_102c_0_34))
                 (at start (not (not_occupied seg_O1_102c_0_34)))
                 (at start (blocked seg_O1_102c_0_34 ?a))
                 (at start (not (not_blocked seg_O1_102c_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_102c_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_O1_C1b_0_34 ?a)))
                 (at end (not_blocked seg_O1_C1b_0_34 ?a))

                 (at start (blocked seg_O1_102b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_102b_0_60 ?a)))
                )
)

(:durative-action move_seg_O1_102c_0_34_seg_O1_103a_0_34_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_O1_102c_0_34))
                 (at start (not_occupied seg_O1_103a_0_34))
                 (at start (not_blocked seg_O1_103a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_103a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_103a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_103a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_103a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_103a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_103a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_103a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_103a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_103a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_103a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_103a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_103a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_103a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_103a_0_34 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_O1_102c_0_34)))
                 (at end (not_occupied seg_O1_102c_0_34))
                 (at start (not (at-segment ?a seg_O1_102c_0_34)))

                 (at start (occupied seg_O1_103a_0_34))
                 (at start (not (not_occupied seg_O1_103a_0_34)))
                 (at start (blocked seg_O1_103a_0_34 ?a))
                 (at start (not (not_blocked seg_O1_103a_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_103a_0_34))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_O1_102a_0_34 ?a)))
                 (at end (not_blocked seg_O1_102a_0_34 ?a))
                 (at end (not (blocked seg_O1_102b_0_60 ?a)))
                 (at end (not_blocked seg_O1_102b_0_60 ?a))

                )
)

(:durative-action move_seg_O1_103a_0_34_seg_O1_103c_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_103a_0_34))
                 (at start (not_occupied seg_O1_103c_0_34))
                 (at start (not_blocked seg_O1_103c_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_103c_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_103c_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_103c_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_103c_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_103c_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_103c_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_103c_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_103c_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_103c_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_103c_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_103c_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_103c_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_103c_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_103c_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_O1_103b_0_60))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_103a_0_34)))
                 (at end (not_occupied seg_O1_103a_0_34))
                 (at start (not (at-segment ?a seg_O1_103a_0_34)))

                 (at start (occupied seg_O1_103c_0_34))
                 (at start (not (not_occupied seg_O1_103c_0_34)))
                 (at start (blocked seg_O1_103c_0_34 ?a))
                 (at start (not (not_blocked seg_O1_103c_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_103c_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_O1_102c_0_34 ?a)))
                 (at end (not_blocked seg_O1_102c_0_34 ?a))

                 (at start (blocked seg_O1_103b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_103b_0_60 ?a)))
                )
)

(:durative-action move_seg_O1_103c_0_34_seg_O1_104a_0_34_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_O1_103c_0_34))
                 (at start (not_occupied seg_O1_104a_0_34))
                 (at start (not_blocked seg_O1_104a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_104a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_104a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_104a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_104a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_104a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_104a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_104a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_104a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_104a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_104a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_104a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_104a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_104a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_104a_0_34 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_O1_103c_0_34)))
                 (at end (not_occupied seg_O1_103c_0_34))
                 (at start (not (at-segment ?a seg_O1_103c_0_34)))

                 (at start (occupied seg_O1_104a_0_34))
                 (at start (not (not_occupied seg_O1_104a_0_34)))
                 (at start (blocked seg_O1_104a_0_34 ?a))
                 (at start (not (not_blocked seg_O1_104a_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_104a_0_34))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_O1_103a_0_34 ?a)))
                 (at end (not_blocked seg_O1_103a_0_34 ?a))
                 (at end (not (blocked seg_O1_103b_0_60 ?a)))
                 (at end (not_blocked seg_O1_103b_0_60 ?a))

                )
)

(:durative-action move_seg_O1_104a_0_34_seg_O1_104c_0_60_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_104a_0_34))
                 (at start (not_occupied seg_O1_104c_0_60))
                 (at start (not_blocked seg_O1_104c_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_O1_104c_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_O1_104c_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_O1_104c_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_O1_104c_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_O1_104c_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_O1_104c_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_O1_104c_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_O1_104c_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_O1_104c_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_O1_104c_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_O1_104c_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_O1_104c_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_O1_104c_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_O1_104c_0_60 airplane_CFBE2))

                 (over all (not_occupied seg_O1_104b_0_60))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_104a_0_34)))
                 (at end (not_occupied seg_O1_104a_0_34))
                 (at start (not (at-segment ?a seg_O1_104a_0_34)))

                 (at start (occupied seg_O1_104c_0_60))
                 (at start (not (not_occupied seg_O1_104c_0_60)))
                 (at start (blocked seg_O1_104c_0_60 ?a))
                 (at start (not (not_blocked seg_O1_104c_0_60 ?a)))
                 (at end (at-segment ?a seg_O1_104c_0_60))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_O1_103c_0_34 ?a)))
                 (at end (not_blocked seg_O1_103c_0_34 ?a))

                 (at start (blocked seg_O1_104b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_104b_0_60 ?a)))
                )
)

(:durative-action move_seg_O1_104c_0_60_seg_O1_C2a_0_60_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_O1_104c_0_60))
                 (at start (not_occupied seg_O1_C2a_0_60))
                 (at start (not_blocked seg_O1_C2a_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_O1_C2a_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_O1_C2a_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_O1_C2a_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_O1_C2a_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_O1_C2a_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_O1_C2a_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_O1_C2a_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_O1_C2a_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_O1_C2a_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_O1_C2a_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_O1_C2a_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_O1_C2a_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_O1_C2a_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_O1_C2a_0_60 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_O1_104c_0_60)))
                 (at end (not_occupied seg_O1_104c_0_60))
                 (at start (not (at-segment ?a seg_O1_104c_0_60)))

                 (at start (occupied seg_O1_C2a_0_60))
                 (at start (not (not_occupied seg_O1_C2a_0_60)))
                 (at start (blocked seg_O1_C2a_0_60 ?a))
                 (at start (not (not_blocked seg_O1_C2a_0_60 ?a)))
                 (at end (at-segment ?a seg_O1_C2a_0_60))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_O1_104a_0_34 ?a)))
                 (at end (not_blocked seg_O1_104a_0_34 ?a))
                 (at end (not (blocked seg_O1_104b_0_60 ?a)))
                 (at end (not_blocked seg_O1_104b_0_60 ?a))

                )
)

(:durative-action move_seg_O1_C2a_0_60_seg_O1_C2c_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_C2a_0_60))
                 (at start (not_occupied seg_O1_C2c_0_34))
                 (at start (not_blocked seg_O1_C2c_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_C2c_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_C2c_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_C2c_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_C2c_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_C2c_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_C2c_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_C2c_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_C2c_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_C2c_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_C2c_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_C2c_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_C2c_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_C2c_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_C2c_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_O1_C2b_0_60))
                 (over all (not_occupied seg_O1_C2d_0_60))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_C2a_0_60)))
                 (at end (not_occupied seg_O1_C2a_0_60))
                 (at start (not (at-segment ?a seg_O1_C2a_0_60)))

                 (at start (occupied seg_O1_C2c_0_34))
                 (at start (not (not_occupied seg_O1_C2c_0_34)))
                 (at start (blocked seg_O1_C2c_0_34 ?a))
                 (at start (not (not_blocked seg_O1_C2c_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_C2c_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_O1_104c_0_60 ?a)))
                 (at end (not_blocked seg_O1_104c_0_60 ?a))

                 (at start (blocked seg_O1_C2b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_C2b_0_60 ?a)))
                 (at start (blocked seg_O1_C2d_0_60 ?a))
                 (at start (not (not_blocked seg_O1_C2d_0_60 ?a)))
                )
)

(:durative-action move_seg_O1_C2c_0_34_seg_O1_108a_0_34_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_O1_C2c_0_34))
                 (at start (not_occupied seg_O1_108a_0_34))
                 (at start (not_blocked seg_O1_108a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_108a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_108a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_108a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_108a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_108a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_108a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_108a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_108a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_108a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_108a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_108a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_108a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_108a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_108a_0_34 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_O1_C2c_0_34)))
                 (at end (not_occupied seg_O1_C2c_0_34))
                 (at start (not (at-segment ?a seg_O1_C2c_0_34)))

                 (at start (occupied seg_O1_108a_0_34))
                 (at start (not (not_occupied seg_O1_108a_0_34)))
                 (at start (blocked seg_O1_108a_0_34 ?a))
                 (at start (not (not_blocked seg_O1_108a_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_108a_0_34))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_O1_C2a_0_60 ?a)))
                 (at end (not_blocked seg_O1_C2a_0_60 ?a))
                 (at end (not (blocked seg_O1_C2b_0_60 ?a)))
                 (at end (not_blocked seg_O1_C2b_0_60 ?a))
                 (at end (not (blocked seg_O1_C2d_0_60 ?a)))
                 (at end (not_blocked seg_O1_C2d_0_60 ?a))

                )
)

(:durative-action move_seg_O1_108a_0_34_seg_O1_108c_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_108a_0_34))
                 (at start (not_occupied seg_O1_108c_0_34))
                 (at start (not_blocked seg_O1_108c_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_108c_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_108c_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_108c_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_108c_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_108c_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_108c_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_108c_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_108c_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_108c_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_108c_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_108c_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_108c_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_108c_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_108c_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_O1_108b_0_60))
                 (over all (not_occupied seg_O1_108d_0_45))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_108a_0_34)))
                 (at end (not_occupied seg_O1_108a_0_34))
                 (at start (not (at-segment ?a seg_O1_108a_0_34)))

                 (at start (occupied seg_O1_108c_0_34))
                 (at start (not (not_occupied seg_O1_108c_0_34)))
                 (at start (blocked seg_O1_108c_0_34 ?a))
                 (at start (not (not_blocked seg_O1_108c_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_108c_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_O1_C2c_0_34 ?a)))
                 (at end (not_blocked seg_O1_C2c_0_34 ?a))

                 (at start (blocked seg_O1_108b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_108b_0_60 ?a)))
                 (at start (blocked seg_O1_108d_0_45 ?a))
                 (at start (not (not_blocked seg_O1_108d_0_45 ?a)))
                )
)

(:durative-action move_seg_O1_108c_0_34_seg_O1_109a_0_34_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_O1_108c_0_34))
                 (at start (not_occupied seg_O1_109a_0_34))
                 (at start (not_blocked seg_O1_109a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_109a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_109a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_109a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_109a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_109a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_109a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_109a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_109a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_109a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_109a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_109a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_109a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_109a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_109a_0_34 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_O1_108c_0_34)))
                 (at end (not_occupied seg_O1_108c_0_34))
                 (at start (not (at-segment ?a seg_O1_108c_0_34)))

                 (at start (occupied seg_O1_109a_0_34))
                 (at start (not (not_occupied seg_O1_109a_0_34)))
                 (at start (blocked seg_O1_109a_0_34 ?a))
                 (at start (not (not_blocked seg_O1_109a_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_109a_0_34))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_O1_108a_0_34 ?a)))
                 (at end (not_blocked seg_O1_108a_0_34 ?a))
                 (at end (not (blocked seg_O1_108b_0_60 ?a)))
                 (at end (not_blocked seg_O1_108b_0_60 ?a))
                 (at end (not (blocked seg_O1_108d_0_45 ?a)))
                 (at end (not_blocked seg_O1_108d_0_45 ?a))

                )
)

(:durative-action move_seg_O1_109a_0_34_seg_O1_109c_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_109a_0_34))
                 (at start (not_occupied seg_O1_109c_0_34))
                 (at start (not_blocked seg_O1_109c_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_109c_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_109c_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_109c_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_109c_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_109c_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_109c_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_109c_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_109c_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_109c_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_109c_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_109c_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_109c_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_109c_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_109c_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_O1_109b_0_60))
                 (over all (not_occupied seg_O1_109d_0_45))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_109a_0_34)))
                 (at end (not_occupied seg_O1_109a_0_34))
                 (at start (not (at-segment ?a seg_O1_109a_0_34)))

                 (at start (occupied seg_O1_109c_0_34))
                 (at start (not (not_occupied seg_O1_109c_0_34)))
                 (at start (blocked seg_O1_109c_0_34 ?a))
                 (at start (not (not_blocked seg_O1_109c_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_109c_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_O1_108c_0_34 ?a)))
                 (at end (not_blocked seg_O1_108c_0_34 ?a))

                 (at start (blocked seg_O1_109b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_109b_0_60 ?a)))
                 (at start (blocked seg_O1_109d_0_45 ?a))
                 (at start (not (not_blocked seg_O1_109d_0_45 ?a)))
                )
)

(:durative-action move_seg_O1_109c_0_34_seg_O1_110a_0_34_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_O1_109c_0_34))
                 (at start (not_occupied seg_O1_110a_0_34))
                 (at start (not_blocked seg_O1_110a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_110a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_110a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_110a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_110a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_110a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_110a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_110a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_110a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_110a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_110a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_110a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_110a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_110a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_110a_0_34 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_O1_109c_0_34)))
                 (at end (not_occupied seg_O1_109c_0_34))
                 (at start (not (at-segment ?a seg_O1_109c_0_34)))

                 (at start (occupied seg_O1_110a_0_34))
                 (at start (not (not_occupied seg_O1_110a_0_34)))
                 (at start (blocked seg_O1_110a_0_34 ?a))
                 (at start (not (not_blocked seg_O1_110a_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_110a_0_34))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_O1_109a_0_34 ?a)))
                 (at end (not_blocked seg_O1_109a_0_34 ?a))
                 (at end (not (blocked seg_O1_109b_0_60 ?a)))
                 (at end (not_blocked seg_O1_109b_0_60 ?a))
                 (at end (not (blocked seg_O1_109d_0_45 ?a)))
                 (at end (not_blocked seg_O1_109d_0_45 ?a))

                )
)

(:durative-action move_seg_O1_110a_0_34_seg_O1_110c_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_110a_0_34))
                 (at start (not_occupied seg_O1_110c_0_34))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_O1_110b_0_60))
                 (over all (not_occupied seg_O1_110d_0_45))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_110a_0_34)))
                 (at end (not_occupied seg_O1_110a_0_34))
                 (at start (not (at-segment ?a seg_O1_110a_0_34)))

                 (at start (occupied seg_O1_110c_0_34))
                 (at start (not (not_occupied seg_O1_110c_0_34)))
                 (at start (blocked seg_O1_110c_0_34 ?a))
                 (at start (not (not_blocked seg_O1_110c_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_110c_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_O1_109c_0_34 ?a)))
                 (at end (not_blocked seg_O1_109c_0_34 ?a))

                 (at start (blocked seg_O1_110b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_110b_0_60 ?a)))
                 (at start (blocked seg_O1_110d_0_45 ?a))
                 (at start (not (not_blocked seg_O1_110d_0_45 ?a)))
                )
)

(:durative-action move_seg_O1_110c_0_34_seg_O1_111a_0_34_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_O1_110c_0_34))
                 (at start (not_occupied seg_O1_111a_0_34))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_O1_110c_0_34)))
                 (at end (not_occupied seg_O1_110c_0_34))
                 (at start (not (at-segment ?a seg_O1_110c_0_34)))

                 (at start (occupied seg_O1_111a_0_34))
                 (at start (not (not_occupied seg_O1_111a_0_34)))
                 (at start (blocked seg_O1_111a_0_34 ?a))
                 (at start (not (not_blocked seg_O1_111a_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_111a_0_34))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_O1_110a_0_34 ?a)))
                 (at end (not_blocked seg_O1_110a_0_34 ?a))
                 (at end (not (blocked seg_O1_110b_0_60 ?a)))
                 (at end (not_blocked seg_O1_110b_0_60 ?a))
                 (at end (not (blocked seg_O1_110d_0_45 ?a)))
                 (at end (not_blocked seg_O1_110d_0_45 ?a))

                )
)

(:durative-action move_seg_O1_111a_0_34_seg_O1_111c_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_111a_0_34))
                 (at start (not_occupied seg_O1_111c_0_34))
                 (at start (not_blocked seg_O1_111c_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_111c_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_111c_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_111c_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_111c_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_111c_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_111c_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_111c_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_111c_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_111c_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_111c_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_111c_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_111c_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_111c_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_111c_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_O1_111b_0_60))
                 (over all (not_occupied seg_O1_111d_0_45))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_111a_0_34)))
                 (at end (not_occupied seg_O1_111a_0_34))
                 (at start (not (at-segment ?a seg_O1_111a_0_34)))

                 (at start (occupied seg_O1_111c_0_34))
                 (at start (not (not_occupied seg_O1_111c_0_34)))
                 (at start (blocked seg_O1_111c_0_34 ?a))
                 (at start (not (not_blocked seg_O1_111c_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_111c_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_O1_110c_0_34 ?a)))
                 (at end (not_blocked seg_O1_110c_0_34 ?a))

                 (at start (blocked seg_O1_111b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_111b_0_60 ?a)))
                 (at start (blocked seg_O1_111d_0_45 ?a))
                 (at start (not (not_blocked seg_O1_111d_0_45 ?a)))
                )
)

(:durative-action move_seg_O1_111c_0_34_seg_O1_C3a_0_34_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_O1_111c_0_34))
                 (at start (not_occupied seg_O1_C3a_0_34))
                 (at start (not_blocked seg_O1_C3a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_C3a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_C3a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_C3a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_C3a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_C3a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_C3a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_C3a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_C3a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_C3a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_C3a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_C3a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_C3a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_C3a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_C3a_0_34 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_O1_111c_0_34)))
                 (at end (not_occupied seg_O1_111c_0_34))
                 (at start (not (at-segment ?a seg_O1_111c_0_34)))

                 (at start (occupied seg_O1_C3a_0_34))
                 (at start (not (not_occupied seg_O1_C3a_0_34)))
                 (at start (blocked seg_O1_C3a_0_34 ?a))
                 (at start (not (not_blocked seg_O1_C3a_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_C3a_0_34))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_O1_111a_0_34 ?a)))
                 (at end (not_blocked seg_O1_111a_0_34 ?a))
                 (at end (not (blocked seg_O1_111b_0_60 ?a)))
                 (at end (not_blocked seg_O1_111b_0_60 ?a))
                 (at end (not (blocked seg_O1_111d_0_45 ?a)))
                 (at end (not_blocked seg_O1_111d_0_45 ?a))

                )
)

(:durative-action move_seg_O1_C3a_0_34_seg_O1_C3c_0_48_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_C3a_0_34))
                 (at start (not_occupied seg_O1_C3c_0_48))
                 (at start (not_blocked seg_O1_C3c_0_48 airplane_CFBEG))
                 (at start (not_blocked seg_O1_C3c_0_48 airplane_CFBE1))
                 (at start (not_blocked seg_O1_C3c_0_48 airplane_CFBE3))
                 (at start (not_blocked seg_O1_C3c_0_48 airplane_DAEW8))
                 (at start (not_blocked seg_O1_C3c_0_48 airplane_DAEW9))
                 (at start (not_blocked seg_O1_C3c_0_48 airplane_DAEW0))
                 (at start (not_blocked seg_O1_C3c_0_48 airplane_DAEW3))
                 (at start (not_blocked seg_O1_C3c_0_48 airplane_DAEWH))
                 (at start (not_blocked seg_O1_C3c_0_48 airplane_DAEW1))
                 (at start (not_blocked seg_O1_C3c_0_48 airplane_DAEW2))
                 (at start (not_blocked seg_O1_C3c_0_48 airplane_DAEW4))
                 (at start (not_blocked seg_O1_C3c_0_48 airplane_DAEW5))
                 (at start (not_blocked seg_O1_C3c_0_48 airplane_DAEW6))
                 (at start (not_blocked seg_O1_C3c_0_48 airplane_DAEW7))
                 (at start (not_blocked seg_O1_C3c_0_48 airplane_CFBE2))

                 (over all (not_occupied seg_O1_C3b_0_60))
                 (over all (not_occupied seg_O1_C3d_0_60))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_C3a_0_34)))
                 (at end (not_occupied seg_O1_C3a_0_34))
                 (at start (not (at-segment ?a seg_O1_C3a_0_34)))

                 (at start (occupied seg_O1_C3c_0_48))
                 (at start (not (not_occupied seg_O1_C3c_0_48)))
                 (at start (blocked seg_O1_C3c_0_48 ?a))
                 (at start (not (not_blocked seg_O1_C3c_0_48 ?a)))
                 (at end (at-segment ?a seg_O1_C3c_0_48))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_O1_111c_0_34 ?a)))
                 (at end (not_blocked seg_O1_111c_0_34 ?a))

                 (at start (blocked seg_O1_C3b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_C3b_0_60 ?a)))
                 (at start (blocked seg_O1_C3d_0_60 ?a))
                 (at start (not (not_blocked seg_O1_C3d_0_60 ?a)))
                )
)

(:durative-action move_seg_O1_C3c_0_48_seg_O1_115a_0_34_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_O1_C3c_0_48))
                 (at start (not_occupied seg_O1_115a_0_34))
                 (at start (not_blocked seg_O1_115a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_115a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_115a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_115a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_115a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_115a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_115a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_115a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_115a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_115a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_115a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_115a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_115a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_115a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_115a_0_34 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_O1_C3c_0_48)))
                 (at end (not_occupied seg_O1_C3c_0_48))
                 (at start (not (at-segment ?a seg_O1_C3c_0_48)))

                 (at start (occupied seg_O1_115a_0_34))
                 (at start (not (not_occupied seg_O1_115a_0_34)))
                 (at start (blocked seg_O1_115a_0_34 ?a))
                 (at start (not (not_blocked seg_O1_115a_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_115a_0_34))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_O1_C3a_0_34 ?a)))
                 (at end (not_blocked seg_O1_C3a_0_34 ?a))
                 (at end (not (blocked seg_O1_C3b_0_60 ?a)))
                 (at end (not_blocked seg_O1_C3b_0_60 ?a))
                 (at end (not (blocked seg_O1_C3d_0_60 ?a)))
                 (at end (not_blocked seg_O1_C3d_0_60 ?a))

                )
)

(:durative-action move_seg_O1_115a_0_34_seg_O1_115c_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_115a_0_34))
                 (at start (not_occupied seg_O1_115c_0_34))
                 (at start (not_blocked seg_O1_115c_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_115c_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_115c_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_115c_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_115c_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_115c_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_115c_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_115c_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_115c_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_115c_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_115c_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_115c_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_115c_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_115c_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_115c_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_O1_115b_0_60))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_115a_0_34)))
                 (at end (not_occupied seg_O1_115a_0_34))
                 (at start (not (at-segment ?a seg_O1_115a_0_34)))

                 (at start (occupied seg_O1_115c_0_34))
                 (at start (not (not_occupied seg_O1_115c_0_34)))
                 (at start (blocked seg_O1_115c_0_34 ?a))
                 (at start (not (not_blocked seg_O1_115c_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_115c_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_O1_C3c_0_48 ?a)))
                 (at end (not_blocked seg_O1_C3c_0_48 ?a))

                 (at start (blocked seg_O1_115b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_115b_0_60 ?a)))
                )
)

(:durative-action move_seg_O1_115c_0_34_seg_O1_116a_0_34_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_O1_115c_0_34))
                 (at start (not_occupied seg_O1_116a_0_34))
                 (at start (not_blocked seg_O1_116a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_116a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_116a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_116a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_116a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_116a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_116a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_116a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_116a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_116a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_116a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_116a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_116a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_116a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_116a_0_34 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_O1_115c_0_34)))
                 (at end (not_occupied seg_O1_115c_0_34))
                 (at start (not (at-segment ?a seg_O1_115c_0_34)))

                 (at start (occupied seg_O1_116a_0_34))
                 (at start (not (not_occupied seg_O1_116a_0_34)))
                 (at start (blocked seg_O1_116a_0_34 ?a))
                 (at start (not (not_blocked seg_O1_116a_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_116a_0_34))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_O1_115a_0_34 ?a)))
                 (at end (not_blocked seg_O1_115a_0_34 ?a))
                 (at end (not (blocked seg_O1_115b_0_60 ?a)))
                 (at end (not_blocked seg_O1_115b_0_60 ?a))

                )
)

(:durative-action move_seg_O1_116a_0_34_seg_O1_116c_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_116a_0_34))
                 (at start (not_occupied seg_O1_116c_0_34))
                 (at start (not_blocked seg_O1_116c_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_116c_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_116c_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_116c_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_116c_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_116c_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_116c_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_116c_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_116c_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_116c_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_116c_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_116c_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_116c_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_116c_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_116c_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_O1_116b_0_60))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_116a_0_34)))
                 (at end (not_occupied seg_O1_116a_0_34))
                 (at start (not (at-segment ?a seg_O1_116a_0_34)))

                 (at start (occupied seg_O1_116c_0_34))
                 (at start (not (not_occupied seg_O1_116c_0_34)))
                 (at start (blocked seg_O1_116c_0_34 ?a))
                 (at start (not (not_blocked seg_O1_116c_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_116c_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_O1_115c_0_34 ?a)))
                 (at end (not_blocked seg_O1_115c_0_34 ?a))

                 (at start (blocked seg_O1_116b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_116b_0_60 ?a)))
                )
)

(:durative-action move_seg_O1_116c_0_34_seg_O1_117a_0_34_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_O1_116c_0_34))
                 (at start (not_occupied seg_O1_117a_0_34))
                 (at start (not_blocked seg_O1_117a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_117a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_117a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_117a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_117a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_117a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_117a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_117a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_117a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_117a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_117a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_117a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_117a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_117a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_117a_0_34 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_O1_116c_0_34)))
                 (at end (not_occupied seg_O1_116c_0_34))
                 (at start (not (at-segment ?a seg_O1_116c_0_34)))

                 (at start (occupied seg_O1_117a_0_34))
                 (at start (not (not_occupied seg_O1_117a_0_34)))
                 (at start (blocked seg_O1_117a_0_34 ?a))
                 (at start (not (not_blocked seg_O1_117a_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_117a_0_34))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_O1_116a_0_34 ?a)))
                 (at end (not_blocked seg_O1_116a_0_34 ?a))
                 (at end (not (blocked seg_O1_116b_0_60 ?a)))
                 (at end (not_blocked seg_O1_116b_0_60 ?a))

                )
)

(:durative-action move_seg_O1_117a_0_34_seg_O1_117c_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_117a_0_34))
                 (at start (not_occupied seg_O1_117c_0_34))
                 (at start (not_blocked seg_O1_117c_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_117c_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_117c_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_117c_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_117c_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_117c_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_117c_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_117c_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_117c_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_117c_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_117c_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_117c_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_117c_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_117c_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_117c_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_O1_117b_0_60))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_117a_0_34)))
                 (at end (not_occupied seg_O1_117a_0_34))
                 (at start (not (at-segment ?a seg_O1_117a_0_34)))

                 (at start (occupied seg_O1_117c_0_34))
                 (at start (not (not_occupied seg_O1_117c_0_34)))
                 (at start (blocked seg_O1_117c_0_34 ?a))
                 (at start (not (not_blocked seg_O1_117c_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_117c_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_O1_116c_0_34 ?a)))
                 (at end (not_blocked seg_O1_116c_0_34 ?a))

                 (at start (blocked seg_O1_117b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_117b_0_60 ?a)))
                )
)

(:durative-action move_seg_O1_117c_0_34_seg_O1_118a_0_34_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_O1_117c_0_34))
                 (at start (not_occupied seg_O1_118a_0_34))
                 (at start (not_blocked seg_O1_118a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_118a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_118a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_118a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_118a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_118a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_118a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_118a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_118a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_118a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_118a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_118a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_118a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_118a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_118a_0_34 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_O1_117c_0_34)))
                 (at end (not_occupied seg_O1_117c_0_34))
                 (at start (not (at-segment ?a seg_O1_117c_0_34)))

                 (at start (occupied seg_O1_118a_0_34))
                 (at start (not (not_occupied seg_O1_118a_0_34)))
                 (at start (blocked seg_O1_118a_0_34 ?a))
                 (at start (not (not_blocked seg_O1_118a_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_118a_0_34))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_O1_117a_0_34 ?a)))
                 (at end (not_blocked seg_O1_117a_0_34 ?a))
                 (at end (not (blocked seg_O1_117b_0_60 ?a)))
                 (at end (not_blocked seg_O1_117b_0_60 ?a))

                )
)

(:durative-action move_seg_O1_118a_0_34_seg_O1_118c_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_118a_0_34))
                 (at start (not_occupied seg_O1_118c_0_34))
                 (at start (not_blocked seg_O1_118c_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_118c_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_118c_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_118c_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_118c_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_118c_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_118c_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_118c_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_118c_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_118c_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_118c_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_118c_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_118c_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_118c_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_118c_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_O1_118b_0_60))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_118a_0_34)))
                 (at end (not_occupied seg_O1_118a_0_34))
                 (at start (not (at-segment ?a seg_O1_118a_0_34)))

                 (at start (occupied seg_O1_118c_0_34))
                 (at start (not (not_occupied seg_O1_118c_0_34)))
                 (at start (blocked seg_O1_118c_0_34 ?a))
                 (at start (not (not_blocked seg_O1_118c_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_118c_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_O1_117c_0_34 ?a)))
                 (at end (not_blocked seg_O1_117c_0_34 ?a))

                 (at start (blocked seg_O1_118b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_118b_0_60 ?a)))
                )
)

(:durative-action move_seg_O1_118c_0_34_seg_O1_C4a_0_34_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_O1_118c_0_34))
                 (at start (not_occupied seg_O1_C4a_0_34))
                 (at start (not_blocked seg_O1_C4a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_C4a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_C4a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_C4a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_C4a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_C4a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_C4a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_C4a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_C4a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_C4a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_C4a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_C4a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_C4a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_C4a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_C4a_0_34 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_O1_118c_0_34)))
                 (at end (not_occupied seg_O1_118c_0_34))
                 (at start (not (at-segment ?a seg_O1_118c_0_34)))

                 (at start (occupied seg_O1_C4a_0_34))
                 (at start (not (not_occupied seg_O1_C4a_0_34)))
                 (at start (blocked seg_O1_C4a_0_34 ?a))
                 (at start (not (not_blocked seg_O1_C4a_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_C4a_0_34))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_O1_118a_0_34 ?a)))
                 (at end (not_blocked seg_O1_118a_0_34 ?a))
                 (at end (not (blocked seg_O1_118b_0_60 ?a)))
                 (at end (not_blocked seg_O1_118b_0_60 ?a))

                )
)

(:durative-action move_seg_O1_C4a_0_34_seg_O1_C4c_0_80_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_C4a_0_34))
                 (at start (not_occupied seg_O1_C4c_0_80))
                 (at start (not_blocked seg_O1_C4c_0_80 airplane_CFBEG))
                 (at start (not_blocked seg_O1_C4c_0_80 airplane_CFBE1))
                 (at start (not_blocked seg_O1_C4c_0_80 airplane_CFBE3))
                 (at start (not_blocked seg_O1_C4c_0_80 airplane_DAEW8))
                 (at start (not_blocked seg_O1_C4c_0_80 airplane_DAEW9))
                 (at start (not_blocked seg_O1_C4c_0_80 airplane_DAEW0))
                 (at start (not_blocked seg_O1_C4c_0_80 airplane_DAEW3))
                 (at start (not_blocked seg_O1_C4c_0_80 airplane_DAEWH))
                 (at start (not_blocked seg_O1_C4c_0_80 airplane_DAEW1))
                 (at start (not_blocked seg_O1_C4c_0_80 airplane_DAEW2))
                 (at start (not_blocked seg_O1_C4c_0_80 airplane_DAEW4))
                 (at start (not_blocked seg_O1_C4c_0_80 airplane_DAEW5))
                 (at start (not_blocked seg_O1_C4c_0_80 airplane_DAEW6))
                 (at start (not_blocked seg_O1_C4c_0_80 airplane_DAEW7))
                 (at start (not_blocked seg_O1_C4c_0_80 airplane_CFBE2))

                 (over all (not_occupied seg_O1_C4b_0_60))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_C4a_0_34)))
                 (at end (not_occupied seg_O1_C4a_0_34))
                 (at start (not (at-segment ?a seg_O1_C4a_0_34)))

                 (at start (occupied seg_O1_C4c_0_80))
                 (at start (not (not_occupied seg_O1_C4c_0_80)))
                 (at start (blocked seg_O1_C4c_0_80 ?a))
                 (at start (not (not_blocked seg_O1_C4c_0_80 ?a)))
                 (at end (at-segment ?a seg_O1_C4c_0_80))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_O1_118c_0_34 ?a)))
                 (at end (not_blocked seg_O1_118c_0_34 ?a))

                 (at start (blocked seg_O1_C4b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_C4b_0_60 ?a)))
                )
)

(:durative-action move_seg_O1_C4c_0_80_seg_C4_S6a_0_80_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_O1_C4c_0_80))
                 (at start (not_occupied seg_C4_S6a_0_80))
                 (at start (not_blocked seg_C4_S6a_0_80 airplane_CFBEG))
                 (at start (not_blocked seg_C4_S6a_0_80 airplane_CFBE1))
                 (at start (not_blocked seg_C4_S6a_0_80 airplane_CFBE3))
                 (at start (not_blocked seg_C4_S6a_0_80 airplane_DAEW8))
                 (at start (not_blocked seg_C4_S6a_0_80 airplane_DAEW9))
                 (at start (not_blocked seg_C4_S6a_0_80 airplane_DAEW0))
                 (at start (not_blocked seg_C4_S6a_0_80 airplane_DAEW3))
                 (at start (not_blocked seg_C4_S6a_0_80 airplane_DAEWH))
                 (at start (not_blocked seg_C4_S6a_0_80 airplane_DAEW1))
                 (at start (not_blocked seg_C4_S6a_0_80 airplane_DAEW2))
                 (at start (not_blocked seg_C4_S6a_0_80 airplane_DAEW4))
                 (at start (not_blocked seg_C4_S6a_0_80 airplane_DAEW5))
                 (at start (not_blocked seg_C4_S6a_0_80 airplane_DAEW6))
                 (at start (not_blocked seg_C4_S6a_0_80 airplane_DAEW7))
                 (at start (not_blocked seg_C4_S6a_0_80 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_O1_C4c_0_80)))
                 (at end (not_occupied seg_O1_C4c_0_80))
                 (at start (not (at-segment ?a seg_O1_C4c_0_80)))

                 (at start (occupied seg_C4_S6a_0_80))
                 (at start (not (not_occupied seg_C4_S6a_0_80)))
                 (at start (blocked seg_C4_S6a_0_80 ?a))
                 (at start (not (not_blocked seg_C4_S6a_0_80 ?a)))
                 (at end (at-segment ?a seg_C4_S6a_0_80))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_O1_C4a_0_34 ?a)))
                 (at end (not_blocked seg_O1_C4a_0_34 ?a))
                 (at end (not (blocked seg_O1_C4b_0_60 ?a)))
                 (at end (not_blocked seg_O1_C4b_0_60 ?a))

                )
)

(:durative-action move_seg_C4_S6a_0_80_seg_C4_S6c_0_60_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_C4_S6a_0_80))
                 (at start (not_occupied seg_C4_S6c_0_60))
                 (at start (not_blocked seg_C4_S6c_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_C4_S6c_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_C4_S6c_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_C4_S6c_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_C4_S6c_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_C4_S6c_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_C4_S6c_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_C4_S6c_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_C4_S6c_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_C4_S6c_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_C4_S6c_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_C4_S6c_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_C4_S6c_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_C4_S6c_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_C4_S6c_0_60 airplane_CFBE2))

                 (over all (not_occupied seg_C4_S6b_0_60))
              )

 :effect        (and
                 (at end (not (occupied seg_C4_S6a_0_80)))
                 (at end (not_occupied seg_C4_S6a_0_80))
                 (at start (not (at-segment ?a seg_C4_S6a_0_80)))

                 (at start (occupied seg_C4_S6c_0_60))
                 (at start (not (not_occupied seg_C4_S6c_0_60)))
                 (at start (blocked seg_C4_S6c_0_60 ?a))
                 (at start (not (not_blocked seg_C4_S6c_0_60 ?a)))
                 (at end (at-segment ?a seg_C4_S6c_0_60))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_O1_C4c_0_80 ?a)))
                 (at end (not_blocked seg_O1_C4c_0_80 ?a))

                 (at start (blocked seg_C4_S6b_0_60 ?a))
                 (at start (not (not_blocked seg_C4_S6b_0_60 ?a)))
                )
)

(:durative-action move_seg_W1_C4b_0_60_seg_W1_C4c_0_60_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_W1_C4b_0_60))
                 (at start (not_occupied seg_W1_C4c_0_60))
                 (at start (not_blocked seg_W1_C4c_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_W1_C4c_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_W1_C4c_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_W1_C4c_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_W1_C4c_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_W1_C4c_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_W1_C4c_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_W1_C4c_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_W1_C4c_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_W1_C4c_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_W1_C4c_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_W1_C4c_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_W1_C4c_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_W1_C4c_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_W1_C4c_0_60 airplane_CFBE2))

                 (over all (not_occupied seg_W1_C4a_0_34))
              )

 :effect        (and
                 (at end (not (occupied seg_W1_C4b_0_60)))
                 (at end (not_occupied seg_W1_C4b_0_60))
                 (at start (not (at-segment ?a seg_W1_C4b_0_60)))

                 (at start (occupied seg_W1_C4c_0_60))
                 (at start (not (not_occupied seg_W1_C4c_0_60)))
                 (at start (blocked seg_W1_C4c_0_60 ?a))
                 (at start (not (not_blocked seg_W1_C4c_0_60 ?a)))
                 (at end (at-segment ?a seg_W1_C4c_0_60))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_C4_S6c_0_60 ?a)))
                 (at end (not_blocked seg_C4_S6c_0_60 ?a))

                 (at start (blocked seg_W1_C4a_0_34 ?a))
                 (at start (not (not_blocked seg_W1_C4a_0_34 ?a)))
                )
)

(:durative-action move_seg_O1_C1a_0_60_seg_O1_C1b_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_C1a_0_60))
                 (at start (not_occupied seg_O1_C1b_0_34))
                 (at start (not_blocked seg_O1_C1b_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_C1b_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_C1b_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_C1b_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_C1b_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_C1b_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_C1b_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_C1b_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_C1b_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_C1b_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_C1b_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_C1b_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_C1b_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_C1b_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_C1b_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_O1_C1c_0_80))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_C1a_0_60)))
                 (at end (not_occupied seg_O1_C1a_0_60))
                 (at start (not (at-segment ?a seg_O1_C1a_0_60)))

                 (at start (occupied seg_O1_C1b_0_34))
                 (at start (not (not_occupied seg_O1_C1b_0_34)))
                 (at start (blocked seg_O1_C1b_0_34 ?a))
                 (at start (not (not_blocked seg_O1_C1b_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_C1b_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_p101_0_76 ?a)))
                 (at end (not_blocked seg_p101_0_76 ?a))

                 (at start (blocked seg_O1_C1c_0_80 ?a))
                 (at start (not (not_blocked seg_O1_C1c_0_80 ?a)))
                )
)

(:durative-action move_seg_O1_102a_0_34_seg_O1_C1b_0_34_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_O1_102a_0_34))
                 (at start (not_occupied seg_O1_C1b_0_34))
                 (at start (not_blocked seg_O1_C1b_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_C1b_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_C1b_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_C1b_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_C1b_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_C1b_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_C1b_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_C1b_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_C1b_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_C1b_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_C1b_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_C1b_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_C1b_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_C1b_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_C1b_0_34 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_O1_102a_0_34)))
                 (at end (not_occupied seg_O1_102a_0_34))
                 (at start (not (at-segment ?a seg_O1_102a_0_34)))

                 (at start (occupied seg_O1_C1b_0_34))
                 (at start (not (not_occupied seg_O1_C1b_0_34)))
                 (at start (blocked seg_O1_C1b_0_34 ?a))
                 (at start (not (not_blocked seg_O1_C1b_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_C1b_0_34))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_O1_102b_0_60 ?a)))
                 (at end (not_blocked seg_O1_102b_0_60 ?a))
                 (at end (not (blocked seg_O1_102c_0_34 ?a)))
                 (at end (not_blocked seg_O1_102c_0_34 ?a))

                )
)

(:durative-action move_seg_O1_C1b_0_34_seg_O1_C1c_0_80_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_C1b_0_34))
                 (at start (not_occupied seg_O1_C1c_0_80))
                 (at start (not_blocked seg_O1_C1c_0_80 airplane_CFBEG))
                 (at start (not_blocked seg_O1_C1c_0_80 airplane_CFBE1))
                 (at start (not_blocked seg_O1_C1c_0_80 airplane_CFBE3))
                 (at start (not_blocked seg_O1_C1c_0_80 airplane_DAEW8))
                 (at start (not_blocked seg_O1_C1c_0_80 airplane_DAEW9))
                 (at start (not_blocked seg_O1_C1c_0_80 airplane_DAEW0))
                 (at start (not_blocked seg_O1_C1c_0_80 airplane_DAEW3))
                 (at start (not_blocked seg_O1_C1c_0_80 airplane_DAEWH))
                 (at start (not_blocked seg_O1_C1c_0_80 airplane_DAEW1))
                 (at start (not_blocked seg_O1_C1c_0_80 airplane_DAEW2))
                 (at start (not_blocked seg_O1_C1c_0_80 airplane_DAEW4))
                 (at start (not_blocked seg_O1_C1c_0_80 airplane_DAEW5))
                 (at start (not_blocked seg_O1_C1c_0_80 airplane_DAEW6))
                 (at start (not_blocked seg_O1_C1c_0_80 airplane_DAEW7))
                 (at start (not_blocked seg_O1_C1c_0_80 airplane_CFBE2))

                 (over all (not_occupied seg_O1_C1a_0_60))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_C1b_0_34)))
                 (at end (not_occupied seg_O1_C1b_0_34))
                 (at start (not (at-segment ?a seg_O1_C1b_0_34)))

                 (at start (occupied seg_O1_C1c_0_80))
                 (at start (not (not_occupied seg_O1_C1c_0_80)))
                 (at start (blocked seg_O1_C1c_0_80 ?a))
                 (at start (not (not_blocked seg_O1_C1c_0_80 ?a)))
                 (at end (at-segment ?a seg_O1_C1c_0_80))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_O1_102a_0_34 ?a)))
                 (at end (not_blocked seg_O1_102a_0_34 ?a))

                 (at start (blocked seg_O1_C1a_0_60 ?a))
                 (at start (not (not_blocked seg_O1_C1a_0_60 ?a)))
                )
)

(:durative-action move_seg_C1_n2b_0_80_seg_C1_n2c_0_60_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_C1_n2b_0_80))
                 (at start (not_occupied seg_C1_n2c_0_60))
                 (at start (not_blocked seg_C1_n2c_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_C1_n2c_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_C1_n2c_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_C1_n2c_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_C1_n2c_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_C1_n2c_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_C1_n2c_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_C1_n2c_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_C1_n2c_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_C1_n2c_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_C1_n2c_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_C1_n2c_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_C1_n2c_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_C1_n2c_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_C1_n2c_0_60 airplane_CFBE2))

                 (over all (not_occupied seg_C1_n2a_0_60))
              )

 :effect        (and
                 (at end (not (occupied seg_C1_n2b_0_80)))
                 (at end (not_occupied seg_C1_n2b_0_80))
                 (at start (not (at-segment ?a seg_C1_n2b_0_80)))

                 (at start (occupied seg_C1_n2c_0_60))
                 (at start (not (not_occupied seg_C1_n2c_0_60)))
                 (at start (blocked seg_C1_n2c_0_60 ?a))
                 (at start (not (not_blocked seg_C1_n2c_0_60 ?a)))
                 (at end (at-segment ?a seg_C1_n2c_0_60))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_O1_C1c_0_80 ?a)))
                 (at end (not_blocked seg_O1_C1c_0_80 ?a))

                 (at start (blocked seg_C1_n2a_0_60 ?a))
                 (at start (not (not_blocked seg_C1_n2a_0_60 ?a)))
                )
)

(:durative-action move_seg_W1_C1b_0_60_seg_W1_C1a_0_60_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_W1_C1b_0_60))
                 (at start (not_occupied seg_W1_C1a_0_60))
                 (at start (not_blocked seg_W1_C1a_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_W1_C1a_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_W1_C1a_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_W1_C1a_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_W1_C1a_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_W1_C1a_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_W1_C1a_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_W1_C1a_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_W1_C1a_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_W1_C1a_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_W1_C1a_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_W1_C1a_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_W1_C1a_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_W1_C1a_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_W1_C1a_0_60 airplane_CFBE2))

                 (over all (not_occupied seg_W1_C1c_0_34))
              )

 :effect        (and
                 (at end (not (occupied seg_W1_C1b_0_60)))
                 (at end (not_occupied seg_W1_C1b_0_60))
                 (at start (not (at-segment ?a seg_W1_C1b_0_60)))

                 (at start (occupied seg_W1_C1a_0_60))
                 (at start (not (not_occupied seg_W1_C1a_0_60)))
                 (at start (blocked seg_W1_C1a_0_60 ?a))
                 (at start (not (not_blocked seg_W1_C1a_0_60 ?a)))
                 (at end (at-segment ?a seg_W1_C1a_0_60))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_C1_n2c_0_60 ?a)))
                 (at end (not_blocked seg_C1_n2c_0_60 ?a))

                 (at start (blocked seg_W1_C1c_0_34 ?a))
                 (at start (not (not_blocked seg_W1_C1c_0_34 ?a)))
                )
)

(:durative-action move_seg_C4_S6b_0_60_seg_C4_S6a_0_80_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_C4_S6b_0_60))
                 (at start (not_occupied seg_C4_S6a_0_80))
                 (at start (not_blocked seg_C4_S6a_0_80 airplane_CFBEG))
                 (at start (not_blocked seg_C4_S6a_0_80 airplane_CFBE1))
                 (at start (not_blocked seg_C4_S6a_0_80 airplane_CFBE3))
                 (at start (not_blocked seg_C4_S6a_0_80 airplane_DAEW8))
                 (at start (not_blocked seg_C4_S6a_0_80 airplane_DAEW9))
                 (at start (not_blocked seg_C4_S6a_0_80 airplane_DAEW0))
                 (at start (not_blocked seg_C4_S6a_0_80 airplane_DAEW3))
                 (at start (not_blocked seg_C4_S6a_0_80 airplane_DAEWH))
                 (at start (not_blocked seg_C4_S6a_0_80 airplane_DAEW1))
                 (at start (not_blocked seg_C4_S6a_0_80 airplane_DAEW2))
                 (at start (not_blocked seg_C4_S6a_0_80 airplane_DAEW4))
                 (at start (not_blocked seg_C4_S6a_0_80 airplane_DAEW5))
                 (at start (not_blocked seg_C4_S6a_0_80 airplane_DAEW6))
                 (at start (not_blocked seg_C4_S6a_0_80 airplane_DAEW7))
                 (at start (not_blocked seg_C4_S6a_0_80 airplane_CFBE2))

                 (over all (not_occupied seg_C4_S6c_0_60))
              )

 :effect        (and
                 (at end (not (occupied seg_C4_S6b_0_60)))
                 (at end (not_occupied seg_C4_S6b_0_60))
                 (at start (not (at-segment ?a seg_C4_S6b_0_60)))

                 (at start (occupied seg_C4_S6a_0_80))
                 (at start (not (not_occupied seg_C4_S6a_0_80)))
                 (at start (blocked seg_C4_S6a_0_80 ?a))
                 (at start (not (not_blocked seg_C4_S6a_0_80 ?a)))
                 (at end (at-segment ?a seg_C4_S6a_0_80))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_S6_0_94 ?a)))
                 (at end (not_blocked seg_S6_0_94 ?a))

                 (at start (blocked seg_C4_S6c_0_60 ?a))
                 (at start (not (not_blocked seg_C4_S6c_0_60 ?a)))
                )
)

(:durative-action move_seg_C4_S6a_0_80_seg_O1_C4c_0_80_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_C4_S6a_0_80))
                 (at start (not_occupied seg_O1_C4c_0_80))
                 (at start (not_blocked seg_O1_C4c_0_80 airplane_CFBEG))
                 (at start (not_blocked seg_O1_C4c_0_80 airplane_CFBE1))
                 (at start (not_blocked seg_O1_C4c_0_80 airplane_CFBE3))
                 (at start (not_blocked seg_O1_C4c_0_80 airplane_DAEW8))
                 (at start (not_blocked seg_O1_C4c_0_80 airplane_DAEW9))
                 (at start (not_blocked seg_O1_C4c_0_80 airplane_DAEW0))
                 (at start (not_blocked seg_O1_C4c_0_80 airplane_DAEW3))
                 (at start (not_blocked seg_O1_C4c_0_80 airplane_DAEWH))
                 (at start (not_blocked seg_O1_C4c_0_80 airplane_DAEW1))
                 (at start (not_blocked seg_O1_C4c_0_80 airplane_DAEW2))
                 (at start (not_blocked seg_O1_C4c_0_80 airplane_DAEW4))
                 (at start (not_blocked seg_O1_C4c_0_80 airplane_DAEW5))
                 (at start (not_blocked seg_O1_C4c_0_80 airplane_DAEW6))
                 (at start (not_blocked seg_O1_C4c_0_80 airplane_DAEW7))
                 (at start (not_blocked seg_O1_C4c_0_80 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_C4_S6a_0_80)))
                 (at end (not_occupied seg_C4_S6a_0_80))
                 (at start (not (at-segment ?a seg_C4_S6a_0_80)))

                 (at start (occupied seg_O1_C4c_0_80))
                 (at start (not (not_occupied seg_O1_C4c_0_80)))
                 (at start (blocked seg_O1_C4c_0_80 ?a))
                 (at start (not (not_blocked seg_O1_C4c_0_80 ?a)))
                 (at end (at-segment ?a seg_O1_C4c_0_80))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_C4_S6b_0_60 ?a)))
                 (at end (not_blocked seg_C4_S6b_0_60 ?a))
                 (at end (not (blocked seg_C4_S6c_0_60 ?a)))
                 (at end (not_blocked seg_C4_S6c_0_60 ?a))

                )
)

(:durative-action move_seg_O1_C4c_0_80_seg_O1_C4a_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_C4c_0_80))
                 (at start (not_occupied seg_O1_C4a_0_34))
                 (at start (not_blocked seg_O1_C4a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_C4a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_C4a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_C4a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_C4a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_C4a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_C4a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_C4a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_C4a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_C4a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_C4a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_C4a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_C4a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_C4a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_C4a_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_O1_C4b_0_60))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_C4c_0_80)))
                 (at end (not_occupied seg_O1_C4c_0_80))
                 (at start (not (at-segment ?a seg_O1_C4c_0_80)))

                 (at start (occupied seg_O1_C4a_0_34))
                 (at start (not (not_occupied seg_O1_C4a_0_34)))
                 (at start (blocked seg_O1_C4a_0_34 ?a))
                 (at start (not (not_blocked seg_O1_C4a_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_C4a_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_C4_S6a_0_80 ?a)))
                 (at end (not_blocked seg_C4_S6a_0_80 ?a))

                 (at start (blocked seg_O1_C4b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_C4b_0_60 ?a)))
                )
)

(:durative-action move_seg_O1_C4a_0_34_seg_O1_118c_0_34_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_O1_C4a_0_34))
                 (at start (not_occupied seg_O1_118c_0_34))
                 (at start (not_blocked seg_O1_118c_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_118c_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_118c_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_118c_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_118c_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_118c_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_118c_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_118c_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_118c_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_118c_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_118c_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_118c_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_118c_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_118c_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_118c_0_34 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_O1_C4a_0_34)))
                 (at end (not_occupied seg_O1_C4a_0_34))
                 (at start (not (at-segment ?a seg_O1_C4a_0_34)))

                 (at start (occupied seg_O1_118c_0_34))
                 (at start (not (not_occupied seg_O1_118c_0_34)))
                 (at start (blocked seg_O1_118c_0_34 ?a))
                 (at start (not (not_blocked seg_O1_118c_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_118c_0_34))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_O1_C4b_0_60 ?a)))
                 (at end (not_blocked seg_O1_C4b_0_60 ?a))
                 (at end (not (blocked seg_O1_C4c_0_80 ?a)))
                 (at end (not_blocked seg_O1_C4c_0_80 ?a))

                )
)

(:durative-action move_seg_O1_118c_0_34_seg_O1_118a_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_118c_0_34))
                 (at start (not_occupied seg_O1_118a_0_34))
                 (at start (not_blocked seg_O1_118a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_118a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_118a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_118a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_118a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_118a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_118a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_118a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_118a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_118a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_118a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_118a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_118a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_118a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_118a_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_O1_118b_0_60))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_118c_0_34)))
                 (at end (not_occupied seg_O1_118c_0_34))
                 (at start (not (at-segment ?a seg_O1_118c_0_34)))

                 (at start (occupied seg_O1_118a_0_34))
                 (at start (not (not_occupied seg_O1_118a_0_34)))
                 (at start (blocked seg_O1_118a_0_34 ?a))
                 (at start (not (not_blocked seg_O1_118a_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_118a_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_O1_C4a_0_34 ?a)))
                 (at end (not_blocked seg_O1_C4a_0_34 ?a))

                 (at start (blocked seg_O1_118b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_118b_0_60 ?a)))
                )
)

(:durative-action move_seg_O1_118a_0_34_seg_O1_117c_0_34_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_O1_118a_0_34))
                 (at start (not_occupied seg_O1_117c_0_34))
                 (at start (not_blocked seg_O1_117c_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_117c_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_117c_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_117c_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_117c_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_117c_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_117c_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_117c_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_117c_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_117c_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_117c_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_117c_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_117c_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_117c_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_117c_0_34 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_O1_118a_0_34)))
                 (at end (not_occupied seg_O1_118a_0_34))
                 (at start (not (at-segment ?a seg_O1_118a_0_34)))

                 (at start (occupied seg_O1_117c_0_34))
                 (at start (not (not_occupied seg_O1_117c_0_34)))
                 (at start (blocked seg_O1_117c_0_34 ?a))
                 (at start (not (not_blocked seg_O1_117c_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_117c_0_34))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_O1_118b_0_60 ?a)))
                 (at end (not_blocked seg_O1_118b_0_60 ?a))
                 (at end (not (blocked seg_O1_118c_0_34 ?a)))
                 (at end (not_blocked seg_O1_118c_0_34 ?a))

                )
)

(:durative-action move_seg_O1_117c_0_34_seg_O1_117a_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_117c_0_34))
                 (at start (not_occupied seg_O1_117a_0_34))
                 (at start (not_blocked seg_O1_117a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_117a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_117a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_117a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_117a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_117a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_117a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_117a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_117a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_117a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_117a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_117a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_117a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_117a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_117a_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_O1_117b_0_60))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_117c_0_34)))
                 (at end (not_occupied seg_O1_117c_0_34))
                 (at start (not (at-segment ?a seg_O1_117c_0_34)))

                 (at start (occupied seg_O1_117a_0_34))
                 (at start (not (not_occupied seg_O1_117a_0_34)))
                 (at start (blocked seg_O1_117a_0_34 ?a))
                 (at start (not (not_blocked seg_O1_117a_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_117a_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_O1_118a_0_34 ?a)))
                 (at end (not_blocked seg_O1_118a_0_34 ?a))

                 (at start (blocked seg_O1_117b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_117b_0_60 ?a)))
                )
)

(:durative-action move_seg_O1_117a_0_34_seg_O1_116c_0_34_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_O1_117a_0_34))
                 (at start (not_occupied seg_O1_116c_0_34))
                 (at start (not_blocked seg_O1_116c_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_116c_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_116c_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_116c_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_116c_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_116c_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_116c_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_116c_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_116c_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_116c_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_116c_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_116c_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_116c_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_116c_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_116c_0_34 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_O1_117a_0_34)))
                 (at end (not_occupied seg_O1_117a_0_34))
                 (at start (not (at-segment ?a seg_O1_117a_0_34)))

                 (at start (occupied seg_O1_116c_0_34))
                 (at start (not (not_occupied seg_O1_116c_0_34)))
                 (at start (blocked seg_O1_116c_0_34 ?a))
                 (at start (not (not_blocked seg_O1_116c_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_116c_0_34))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_O1_117b_0_60 ?a)))
                 (at end (not_blocked seg_O1_117b_0_60 ?a))
                 (at end (not (blocked seg_O1_117c_0_34 ?a)))
                 (at end (not_blocked seg_O1_117c_0_34 ?a))

                )
)

(:durative-action move_seg_O1_116c_0_34_seg_O1_116a_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_116c_0_34))
                 (at start (not_occupied seg_O1_116a_0_34))
                 (at start (not_blocked seg_O1_116a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_116a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_116a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_116a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_116a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_116a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_116a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_116a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_116a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_116a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_116a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_116a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_116a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_116a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_116a_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_O1_116b_0_60))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_116c_0_34)))
                 (at end (not_occupied seg_O1_116c_0_34))
                 (at start (not (at-segment ?a seg_O1_116c_0_34)))

                 (at start (occupied seg_O1_116a_0_34))
                 (at start (not (not_occupied seg_O1_116a_0_34)))
                 (at start (blocked seg_O1_116a_0_34 ?a))
                 (at start (not (not_blocked seg_O1_116a_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_116a_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_O1_117a_0_34 ?a)))
                 (at end (not_blocked seg_O1_117a_0_34 ?a))

                 (at start (blocked seg_O1_116b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_116b_0_60 ?a)))
                )
)

(:durative-action move_seg_O1_116a_0_34_seg_O1_115c_0_34_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_O1_116a_0_34))
                 (at start (not_occupied seg_O1_115c_0_34))
                 (at start (not_blocked seg_O1_115c_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_115c_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_115c_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_115c_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_115c_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_115c_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_115c_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_115c_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_115c_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_115c_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_115c_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_115c_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_115c_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_115c_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_115c_0_34 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_O1_116a_0_34)))
                 (at end (not_occupied seg_O1_116a_0_34))
                 (at start (not (at-segment ?a seg_O1_116a_0_34)))

                 (at start (occupied seg_O1_115c_0_34))
                 (at start (not (not_occupied seg_O1_115c_0_34)))
                 (at start (blocked seg_O1_115c_0_34 ?a))
                 (at start (not (not_blocked seg_O1_115c_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_115c_0_34))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_O1_116b_0_60 ?a)))
                 (at end (not_blocked seg_O1_116b_0_60 ?a))
                 (at end (not (blocked seg_O1_116c_0_34 ?a)))
                 (at end (not_blocked seg_O1_116c_0_34 ?a))

                )
)

(:durative-action move_seg_O1_115c_0_34_seg_O1_115a_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_115c_0_34))
                 (at start (not_occupied seg_O1_115a_0_34))
                 (at start (not_blocked seg_O1_115a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_115a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_115a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_115a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_115a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_115a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_115a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_115a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_115a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_115a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_115a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_115a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_115a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_115a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_115a_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_O1_115b_0_60))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_115c_0_34)))
                 (at end (not_occupied seg_O1_115c_0_34))
                 (at start (not (at-segment ?a seg_O1_115c_0_34)))

                 (at start (occupied seg_O1_115a_0_34))
                 (at start (not (not_occupied seg_O1_115a_0_34)))
                 (at start (blocked seg_O1_115a_0_34 ?a))
                 (at start (not (not_blocked seg_O1_115a_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_115a_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_O1_116a_0_34 ?a)))
                 (at end (not_blocked seg_O1_116a_0_34 ?a))

                 (at start (blocked seg_O1_115b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_115b_0_60 ?a)))
                )
)

(:durative-action move_seg_O1_115a_0_34_seg_O1_C3c_0_48_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_O1_115a_0_34))
                 (at start (not_occupied seg_O1_C3c_0_48))
                 (at start (not_blocked seg_O1_C3c_0_48 airplane_CFBEG))
                 (at start (not_blocked seg_O1_C3c_0_48 airplane_CFBE1))
                 (at start (not_blocked seg_O1_C3c_0_48 airplane_CFBE3))
                 (at start (not_blocked seg_O1_C3c_0_48 airplane_DAEW8))
                 (at start (not_blocked seg_O1_C3c_0_48 airplane_DAEW9))
                 (at start (not_blocked seg_O1_C3c_0_48 airplane_DAEW0))
                 (at start (not_blocked seg_O1_C3c_0_48 airplane_DAEW3))
                 (at start (not_blocked seg_O1_C3c_0_48 airplane_DAEWH))
                 (at start (not_blocked seg_O1_C3c_0_48 airplane_DAEW1))
                 (at start (not_blocked seg_O1_C3c_0_48 airplane_DAEW2))
                 (at start (not_blocked seg_O1_C3c_0_48 airplane_DAEW4))
                 (at start (not_blocked seg_O1_C3c_0_48 airplane_DAEW5))
                 (at start (not_blocked seg_O1_C3c_0_48 airplane_DAEW6))
                 (at start (not_blocked seg_O1_C3c_0_48 airplane_DAEW7))
                 (at start (not_blocked seg_O1_C3c_0_48 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_O1_115a_0_34)))
                 (at end (not_occupied seg_O1_115a_0_34))
                 (at start (not (at-segment ?a seg_O1_115a_0_34)))

                 (at start (occupied seg_O1_C3c_0_48))
                 (at start (not (not_occupied seg_O1_C3c_0_48)))
                 (at start (blocked seg_O1_C3c_0_48 ?a))
                 (at start (not (not_blocked seg_O1_C3c_0_48 ?a)))
                 (at end (at-segment ?a seg_O1_C3c_0_48))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_O1_115b_0_60 ?a)))
                 (at end (not_blocked seg_O1_115b_0_60 ?a))
                 (at end (not (blocked seg_O1_115c_0_34 ?a)))
                 (at end (not_blocked seg_O1_115c_0_34 ?a))

                )
)

(:durative-action move_seg_O1_C3c_0_48_seg_O1_C3a_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_C3c_0_48))
                 (at start (not_occupied seg_O1_C3a_0_34))
                 (at start (not_blocked seg_O1_C3a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_C3a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_C3a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_C3a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_C3a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_C3a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_C3a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_C3a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_C3a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_C3a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_C3a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_C3a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_C3a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_C3a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_C3a_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_O1_C3b_0_60))
                 (over all (not_occupied seg_O1_C3d_0_60))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_C3c_0_48)))
                 (at end (not_occupied seg_O1_C3c_0_48))
                 (at start (not (at-segment ?a seg_O1_C3c_0_48)))

                 (at start (occupied seg_O1_C3a_0_34))
                 (at start (not (not_occupied seg_O1_C3a_0_34)))
                 (at start (blocked seg_O1_C3a_0_34 ?a))
                 (at start (not (not_blocked seg_O1_C3a_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_C3a_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_O1_115a_0_34 ?a)))
                 (at end (not_blocked seg_O1_115a_0_34 ?a))

                 (at start (blocked seg_O1_C3b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_C3b_0_60 ?a)))
                 (at start (blocked seg_O1_C3d_0_60 ?a))
                 (at start (not (not_blocked seg_O1_C3d_0_60 ?a)))
                )
)

(:durative-action move_seg_O1_C3a_0_34_seg_O1_111c_0_34_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_O1_C3a_0_34))
                 (at start (not_occupied seg_O1_111c_0_34))
                 (at start (not_blocked seg_O1_111c_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_111c_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_111c_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_111c_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_111c_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_111c_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_111c_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_111c_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_111c_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_111c_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_111c_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_111c_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_111c_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_111c_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_111c_0_34 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_O1_C3a_0_34)))
                 (at end (not_occupied seg_O1_C3a_0_34))
                 (at start (not (at-segment ?a seg_O1_C3a_0_34)))

                 (at start (occupied seg_O1_111c_0_34))
                 (at start (not (not_occupied seg_O1_111c_0_34)))
                 (at start (blocked seg_O1_111c_0_34 ?a))
                 (at start (not (not_blocked seg_O1_111c_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_111c_0_34))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_O1_C3b_0_60 ?a)))
                 (at end (not_blocked seg_O1_C3b_0_60 ?a))
                 (at end (not (blocked seg_O1_C3c_0_48 ?a)))
                 (at end (not_blocked seg_O1_C3c_0_48 ?a))
                 (at end (not (blocked seg_O1_C3d_0_60 ?a)))
                 (at end (not_blocked seg_O1_C3d_0_60 ?a))

                )
)

(:durative-action move_seg_O1_111c_0_34_seg_O1_111a_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_111c_0_34))
                 (at start (not_occupied seg_O1_111a_0_34))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_O1_111b_0_60))
                 (over all (not_occupied seg_O1_111d_0_45))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_111c_0_34)))
                 (at end (not_occupied seg_O1_111c_0_34))
                 (at start (not (at-segment ?a seg_O1_111c_0_34)))

                 (at start (occupied seg_O1_111a_0_34))
                 (at start (not (not_occupied seg_O1_111a_0_34)))
                 (at start (blocked seg_O1_111a_0_34 ?a))
                 (at start (not (not_blocked seg_O1_111a_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_111a_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_O1_C3a_0_34 ?a)))
                 (at end (not_blocked seg_O1_C3a_0_34 ?a))

                 (at start (blocked seg_O1_111b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_111b_0_60 ?a)))
                 (at start (blocked seg_O1_111d_0_45 ?a))
                 (at start (not (not_blocked seg_O1_111d_0_45 ?a)))
                )
)

(:durative-action move_seg_O1_111a_0_34_seg_O1_110c_0_34_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_O1_111a_0_34))
                 (at start (not_occupied seg_O1_110c_0_34))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_O1_111a_0_34)))
                 (at end (not_occupied seg_O1_111a_0_34))
                 (at start (not (at-segment ?a seg_O1_111a_0_34)))

                 (at start (occupied seg_O1_110c_0_34))
                 (at start (not (not_occupied seg_O1_110c_0_34)))
                 (at start (blocked seg_O1_110c_0_34 ?a))
                 (at start (not (not_blocked seg_O1_110c_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_110c_0_34))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_O1_111b_0_60 ?a)))
                 (at end (not_blocked seg_O1_111b_0_60 ?a))
                 (at end (not (blocked seg_O1_111c_0_34 ?a)))
                 (at end (not_blocked seg_O1_111c_0_34 ?a))
                 (at end (not (blocked seg_O1_111d_0_45 ?a)))
                 (at end (not_blocked seg_O1_111d_0_45 ?a))

                )
)

(:durative-action move_seg_O1_110c_0_34_seg_O1_110a_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_110c_0_34))
                 (at start (not_occupied seg_O1_110a_0_34))
                 (at start (not_blocked seg_O1_110a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_110a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_110a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_110a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_110a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_110a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_110a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_110a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_110a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_110a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_110a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_110a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_110a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_110a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_110a_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_O1_110b_0_60))
                 (over all (not_occupied seg_O1_110d_0_45))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_110c_0_34)))
                 (at end (not_occupied seg_O1_110c_0_34))
                 (at start (not (at-segment ?a seg_O1_110c_0_34)))

                 (at start (occupied seg_O1_110a_0_34))
                 (at start (not (not_occupied seg_O1_110a_0_34)))
                 (at start (blocked seg_O1_110a_0_34 ?a))
                 (at start (not (not_blocked seg_O1_110a_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_110a_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_O1_111a_0_34 ?a)))
                 (at end (not_blocked seg_O1_111a_0_34 ?a))

                 (at start (blocked seg_O1_110b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_110b_0_60 ?a)))
                 (at start (blocked seg_O1_110d_0_45 ?a))
                 (at start (not (not_blocked seg_O1_110d_0_45 ?a)))
                )
)

(:durative-action move_seg_O1_110a_0_34_seg_O1_109c_0_34_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_O1_110a_0_34))
                 (at start (not_occupied seg_O1_109c_0_34))
                 (at start (not_blocked seg_O1_109c_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_109c_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_109c_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_109c_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_109c_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_109c_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_109c_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_109c_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_109c_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_109c_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_109c_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_109c_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_109c_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_109c_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_109c_0_34 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_O1_110a_0_34)))
                 (at end (not_occupied seg_O1_110a_0_34))
                 (at start (not (at-segment ?a seg_O1_110a_0_34)))

                 (at start (occupied seg_O1_109c_0_34))
                 (at start (not (not_occupied seg_O1_109c_0_34)))
                 (at start (blocked seg_O1_109c_0_34 ?a))
                 (at start (not (not_blocked seg_O1_109c_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_109c_0_34))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_O1_110b_0_60 ?a)))
                 (at end (not_blocked seg_O1_110b_0_60 ?a))
                 (at end (not (blocked seg_O1_110c_0_34 ?a)))
                 (at end (not_blocked seg_O1_110c_0_34 ?a))
                 (at end (not (blocked seg_O1_110d_0_45 ?a)))
                 (at end (not_blocked seg_O1_110d_0_45 ?a))

                )
)

(:durative-action move_seg_O1_109c_0_34_seg_O1_109a_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_109c_0_34))
                 (at start (not_occupied seg_O1_109a_0_34))
                 (at start (not_blocked seg_O1_109a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_109a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_109a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_109a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_109a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_109a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_109a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_109a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_109a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_109a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_109a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_109a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_109a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_109a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_109a_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_O1_109b_0_60))
                 (over all (not_occupied seg_O1_109d_0_45))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_109c_0_34)))
                 (at end (not_occupied seg_O1_109c_0_34))
                 (at start (not (at-segment ?a seg_O1_109c_0_34)))

                 (at start (occupied seg_O1_109a_0_34))
                 (at start (not (not_occupied seg_O1_109a_0_34)))
                 (at start (blocked seg_O1_109a_0_34 ?a))
                 (at start (not (not_blocked seg_O1_109a_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_109a_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_O1_110a_0_34 ?a)))
                 (at end (not_blocked seg_O1_110a_0_34 ?a))

                 (at start (blocked seg_O1_109b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_109b_0_60 ?a)))
                 (at start (blocked seg_O1_109d_0_45 ?a))
                 (at start (not (not_blocked seg_O1_109d_0_45 ?a)))
                )
)

(:durative-action move_seg_O1_109a_0_34_seg_O1_108c_0_34_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_O1_109a_0_34))
                 (at start (not_occupied seg_O1_108c_0_34))
                 (at start (not_blocked seg_O1_108c_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_108c_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_108c_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_108c_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_108c_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_108c_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_108c_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_108c_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_108c_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_108c_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_108c_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_108c_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_108c_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_108c_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_108c_0_34 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_O1_109a_0_34)))
                 (at end (not_occupied seg_O1_109a_0_34))
                 (at start (not (at-segment ?a seg_O1_109a_0_34)))

                 (at start (occupied seg_O1_108c_0_34))
                 (at start (not (not_occupied seg_O1_108c_0_34)))
                 (at start (blocked seg_O1_108c_0_34 ?a))
                 (at start (not (not_blocked seg_O1_108c_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_108c_0_34))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_O1_109b_0_60 ?a)))
                 (at end (not_blocked seg_O1_109b_0_60 ?a))
                 (at end (not (blocked seg_O1_109c_0_34 ?a)))
                 (at end (not_blocked seg_O1_109c_0_34 ?a))
                 (at end (not (blocked seg_O1_109d_0_45 ?a)))
                 (at end (not_blocked seg_O1_109d_0_45 ?a))

                )
)

(:durative-action move_seg_O1_108c_0_34_seg_O1_108a_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_108c_0_34))
                 (at start (not_occupied seg_O1_108a_0_34))
                 (at start (not_blocked seg_O1_108a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_108a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_108a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_108a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_108a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_108a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_108a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_108a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_108a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_108a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_108a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_108a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_108a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_108a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_108a_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_O1_108b_0_60))
                 (over all (not_occupied seg_O1_108d_0_45))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_108c_0_34)))
                 (at end (not_occupied seg_O1_108c_0_34))
                 (at start (not (at-segment ?a seg_O1_108c_0_34)))

                 (at start (occupied seg_O1_108a_0_34))
                 (at start (not (not_occupied seg_O1_108a_0_34)))
                 (at start (blocked seg_O1_108a_0_34 ?a))
                 (at start (not (not_blocked seg_O1_108a_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_108a_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_O1_109a_0_34 ?a)))
                 (at end (not_blocked seg_O1_109a_0_34 ?a))

                 (at start (blocked seg_O1_108b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_108b_0_60 ?a)))
                 (at start (blocked seg_O1_108d_0_45 ?a))
                 (at start (not (not_blocked seg_O1_108d_0_45 ?a)))
                )
)

(:durative-action move_seg_O1_108a_0_34_seg_O1_C2c_0_34_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_O1_108a_0_34))
                 (at start (not_occupied seg_O1_C2c_0_34))
                 (at start (not_blocked seg_O1_C2c_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_C2c_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_C2c_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_C2c_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_C2c_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_C2c_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_C2c_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_C2c_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_C2c_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_C2c_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_C2c_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_C2c_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_C2c_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_C2c_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_C2c_0_34 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_O1_108a_0_34)))
                 (at end (not_occupied seg_O1_108a_0_34))
                 (at start (not (at-segment ?a seg_O1_108a_0_34)))

                 (at start (occupied seg_O1_C2c_0_34))
                 (at start (not (not_occupied seg_O1_C2c_0_34)))
                 (at start (blocked seg_O1_C2c_0_34 ?a))
                 (at start (not (not_blocked seg_O1_C2c_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_C2c_0_34))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_O1_108b_0_60 ?a)))
                 (at end (not_blocked seg_O1_108b_0_60 ?a))
                 (at end (not (blocked seg_O1_108c_0_34 ?a)))
                 (at end (not_blocked seg_O1_108c_0_34 ?a))
                 (at end (not (blocked seg_O1_108d_0_45 ?a)))
                 (at end (not_blocked seg_O1_108d_0_45 ?a))

                )
)

(:durative-action move_seg_O1_C2c_0_34_seg_O1_C2a_0_60_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_C2c_0_34))
                 (at start (not_occupied seg_O1_C2a_0_60))
                 (at start (not_blocked seg_O1_C2a_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_O1_C2a_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_O1_C2a_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_O1_C2a_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_O1_C2a_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_O1_C2a_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_O1_C2a_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_O1_C2a_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_O1_C2a_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_O1_C2a_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_O1_C2a_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_O1_C2a_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_O1_C2a_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_O1_C2a_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_O1_C2a_0_60 airplane_CFBE2))

                 (over all (not_occupied seg_O1_C2b_0_60))
                 (over all (not_occupied seg_O1_C2d_0_60))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_C2c_0_34)))
                 (at end (not_occupied seg_O1_C2c_0_34))
                 (at start (not (at-segment ?a seg_O1_C2c_0_34)))

                 (at start (occupied seg_O1_C2a_0_60))
                 (at start (not (not_occupied seg_O1_C2a_0_60)))
                 (at start (blocked seg_O1_C2a_0_60 ?a))
                 (at start (not (not_blocked seg_O1_C2a_0_60 ?a)))
                 (at end (at-segment ?a seg_O1_C2a_0_60))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_O1_108a_0_34 ?a)))
                 (at end (not_blocked seg_O1_108a_0_34 ?a))

                 (at start (blocked seg_O1_C2b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_C2b_0_60 ?a)))
                 (at start (blocked seg_O1_C2d_0_60 ?a))
                 (at start (not (not_blocked seg_O1_C2d_0_60 ?a)))
                )
)

(:durative-action move_seg_O1_C2a_0_60_seg_O1_104c_0_60_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_O1_C2a_0_60))
                 (at start (not_occupied seg_O1_104c_0_60))
                 (at start (not_blocked seg_O1_104c_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_O1_104c_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_O1_104c_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_O1_104c_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_O1_104c_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_O1_104c_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_O1_104c_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_O1_104c_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_O1_104c_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_O1_104c_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_O1_104c_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_O1_104c_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_O1_104c_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_O1_104c_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_O1_104c_0_60 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_O1_C2a_0_60)))
                 (at end (not_occupied seg_O1_C2a_0_60))
                 (at start (not (at-segment ?a seg_O1_C2a_0_60)))

                 (at start (occupied seg_O1_104c_0_60))
                 (at start (not (not_occupied seg_O1_104c_0_60)))
                 (at start (blocked seg_O1_104c_0_60 ?a))
                 (at start (not (not_blocked seg_O1_104c_0_60 ?a)))
                 (at end (at-segment ?a seg_O1_104c_0_60))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_O1_C2b_0_60 ?a)))
                 (at end (not_blocked seg_O1_C2b_0_60 ?a))
                 (at end (not (blocked seg_O1_C2c_0_34 ?a)))
                 (at end (not_blocked seg_O1_C2c_0_34 ?a))
                 (at end (not (blocked seg_O1_C2d_0_60 ?a)))
                 (at end (not_blocked seg_O1_C2d_0_60 ?a))

                )
)

(:durative-action move_seg_O1_104c_0_60_seg_O1_104a_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_104c_0_60))
                 (at start (not_occupied seg_O1_104a_0_34))
                 (at start (not_blocked seg_O1_104a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_104a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_104a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_104a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_104a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_104a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_104a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_104a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_104a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_104a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_104a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_104a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_104a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_104a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_104a_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_O1_104b_0_60))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_104c_0_60)))
                 (at end (not_occupied seg_O1_104c_0_60))
                 (at start (not (at-segment ?a seg_O1_104c_0_60)))

                 (at start (occupied seg_O1_104a_0_34))
                 (at start (not (not_occupied seg_O1_104a_0_34)))
                 (at start (blocked seg_O1_104a_0_34 ?a))
                 (at start (not (not_blocked seg_O1_104a_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_104a_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_O1_C2a_0_60 ?a)))
                 (at end (not_blocked seg_O1_C2a_0_60 ?a))

                 (at start (blocked seg_O1_104b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_104b_0_60 ?a)))
                )
)

(:durative-action move_seg_O1_104a_0_34_seg_O1_103c_0_34_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_O1_104a_0_34))
                 (at start (not_occupied seg_O1_103c_0_34))
                 (at start (not_blocked seg_O1_103c_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_103c_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_103c_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_103c_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_103c_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_103c_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_103c_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_103c_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_103c_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_103c_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_103c_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_103c_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_103c_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_103c_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_103c_0_34 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_O1_104a_0_34)))
                 (at end (not_occupied seg_O1_104a_0_34))
                 (at start (not (at-segment ?a seg_O1_104a_0_34)))

                 (at start (occupied seg_O1_103c_0_34))
                 (at start (not (not_occupied seg_O1_103c_0_34)))
                 (at start (blocked seg_O1_103c_0_34 ?a))
                 (at start (not (not_blocked seg_O1_103c_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_103c_0_34))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_O1_104b_0_60 ?a)))
                 (at end (not_blocked seg_O1_104b_0_60 ?a))
                 (at end (not (blocked seg_O1_104c_0_60 ?a)))
                 (at end (not_blocked seg_O1_104c_0_60 ?a))

                )
)

(:durative-action move_seg_O1_103c_0_34_seg_O1_103a_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_103c_0_34))
                 (at start (not_occupied seg_O1_103a_0_34))
                 (at start (not_blocked seg_O1_103a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_103a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_103a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_103a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_103a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_103a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_103a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_103a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_103a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_103a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_103a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_103a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_103a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_103a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_103a_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_O1_103b_0_60))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_103c_0_34)))
                 (at end (not_occupied seg_O1_103c_0_34))
                 (at start (not (at-segment ?a seg_O1_103c_0_34)))

                 (at start (occupied seg_O1_103a_0_34))
                 (at start (not (not_occupied seg_O1_103a_0_34)))
                 (at start (blocked seg_O1_103a_0_34 ?a))
                 (at start (not (not_blocked seg_O1_103a_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_103a_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_O1_104a_0_34 ?a)))
                 (at end (not_blocked seg_O1_104a_0_34 ?a))

                 (at start (blocked seg_O1_103b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_103b_0_60 ?a)))
                )
)

(:durative-action move_seg_O1_103a_0_34_seg_O1_102c_0_34_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_O1_103a_0_34))
                 (at start (not_occupied seg_O1_102c_0_34))
                 (at start (not_blocked seg_O1_102c_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_102c_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_102c_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_102c_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_102c_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_102c_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_102c_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_102c_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_102c_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_102c_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_102c_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_102c_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_102c_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_102c_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_102c_0_34 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_O1_103a_0_34)))
                 (at end (not_occupied seg_O1_103a_0_34))
                 (at start (not (at-segment ?a seg_O1_103a_0_34)))

                 (at start (occupied seg_O1_102c_0_34))
                 (at start (not (not_occupied seg_O1_102c_0_34)))
                 (at start (blocked seg_O1_102c_0_34 ?a))
                 (at start (not (not_blocked seg_O1_102c_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_102c_0_34))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_O1_103b_0_60 ?a)))
                 (at end (not_blocked seg_O1_103b_0_60 ?a))
                 (at end (not (blocked seg_O1_103c_0_34 ?a)))
                 (at end (not_blocked seg_O1_103c_0_34 ?a))

                )
)

(:durative-action move_seg_O1_102c_0_34_seg_O1_102a_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_102c_0_34))
                 (at start (not_occupied seg_O1_102a_0_34))
                 (at start (not_blocked seg_O1_102a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_102a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_102a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_102a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_102a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_102a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_102a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_102a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_102a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_102a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_102a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_102a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_102a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_102a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_102a_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_O1_102b_0_60))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_102c_0_34)))
                 (at end (not_occupied seg_O1_102c_0_34))
                 (at start (not (at-segment ?a seg_O1_102c_0_34)))

                 (at start (occupied seg_O1_102a_0_34))
                 (at start (not (not_occupied seg_O1_102a_0_34)))
                 (at start (blocked seg_O1_102a_0_34 ?a))
                 (at start (not (not_blocked seg_O1_102a_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_102a_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_O1_103a_0_34 ?a)))
                 (at end (not_blocked seg_O1_103a_0_34 ?a))

                 (at start (blocked seg_O1_102b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_102b_0_60 ?a)))
                )
)

(:durative-action move_seg_O1_C1b_0_34_seg_O1_C1a_0_60_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_C1b_0_34))
                 (at start (not_occupied seg_O1_C1a_0_60))
                 (at start (not_blocked seg_O1_C1a_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_O1_C1a_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_O1_C1a_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_O1_C1a_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_O1_C1a_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_O1_C1a_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_O1_C1a_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_O1_C1a_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_O1_C1a_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_O1_C1a_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_O1_C1a_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_O1_C1a_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_O1_C1a_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_O1_C1a_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_O1_C1a_0_60 airplane_CFBE2))

                 (over all (not_occupied seg_O1_C1c_0_80))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_C1b_0_34)))
                 (at end (not_occupied seg_O1_C1b_0_34))
                 (at start (not (at-segment ?a seg_O1_C1b_0_34)))

                 (at start (occupied seg_O1_C1a_0_60))
                 (at start (not (not_occupied seg_O1_C1a_0_60)))
                 (at start (blocked seg_O1_C1a_0_60 ?a))
                 (at start (not (not_blocked seg_O1_C1a_0_60 ?a)))
                 (at end (at-segment ?a seg_O1_C1a_0_60))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_O1_102a_0_34 ?a)))
                 (at end (not_blocked seg_O1_102a_0_34 ?a))

                 (at start (blocked seg_O1_C1c_0_80 ?a))
                 (at start (not (not_blocked seg_O1_C1c_0_80 ?a)))
                )
)

(:durative-action move_seg_O1_C1a_0_60_seg_p101_0_76_south_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_O1_C1a_0_60))
                 (at start (not_occupied seg_p101_0_76))
                 (at start (not_blocked seg_p101_0_76 airplane_CFBEG))
                 (at start (not_blocked seg_p101_0_76 airplane_CFBE1))
                 (at start (not_blocked seg_p101_0_76 airplane_CFBE3))
                 (at start (not_blocked seg_p101_0_76 airplane_DAEW8))
                 (at start (not_blocked seg_p101_0_76 airplane_DAEW9))
                 (at start (not_blocked seg_p101_0_76 airplane_DAEW0))
                 (at start (not_blocked seg_p101_0_76 airplane_DAEW3))
                 (at start (not_blocked seg_p101_0_76 airplane_DAEWH))
                 (at start (not_blocked seg_p101_0_76 airplane_DAEW1))
                 (at start (not_blocked seg_p101_0_76 airplane_DAEW2))
                 (at start (not_blocked seg_p101_0_76 airplane_DAEW4))
                 (at start (not_blocked seg_p101_0_76 airplane_DAEW5))
                 (at start (not_blocked seg_p101_0_76 airplane_DAEW6))
                 (at start (not_blocked seg_p101_0_76 airplane_DAEW7))
                 (at start (not_blocked seg_p101_0_76 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_O1_C1a_0_60)))
                 (at end (not_occupied seg_O1_C1a_0_60))
                 (at start (not (at-segment ?a seg_O1_C1a_0_60)))

                 (at start (occupied seg_p101_0_76))
                 (at start (not (not_occupied seg_p101_0_76)))
                 (at start (blocked seg_p101_0_76 ?a))
                 (at start (not (not_blocked seg_p101_0_76 ?a)))
                 (at end (at-segment ?a seg_p101_0_76))

                 (at end (not (blocked seg_O1_C1b_0_34 ?a)))
                 (at end (not_blocked seg_O1_C1b_0_34 ?a))
                 (at end (not (blocked seg_O1_C1c_0_80 ?a)))
                 (at end (not_blocked seg_O1_C1c_0_80 ?a))

                )
)

(:durative-action move_seg_C1_n2a_0_60_seg_C1_n2b_0_80_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_C1_n2a_0_60))
                 (at start (not_occupied seg_C1_n2b_0_80))
                 (at start (not_blocked seg_C1_n2b_0_80 airplane_CFBEG))
                 (at start (not_blocked seg_C1_n2b_0_80 airplane_CFBE1))
                 (at start (not_blocked seg_C1_n2b_0_80 airplane_CFBE3))
                 (at start (not_blocked seg_C1_n2b_0_80 airplane_DAEW8))
                 (at start (not_blocked seg_C1_n2b_0_80 airplane_DAEW9))
                 (at start (not_blocked seg_C1_n2b_0_80 airplane_DAEW0))
                 (at start (not_blocked seg_C1_n2b_0_80 airplane_DAEW3))
                 (at start (not_blocked seg_C1_n2b_0_80 airplane_DAEWH))
                 (at start (not_blocked seg_C1_n2b_0_80 airplane_DAEW1))
                 (at start (not_blocked seg_C1_n2b_0_80 airplane_DAEW2))
                 (at start (not_blocked seg_C1_n2b_0_80 airplane_DAEW4))
                 (at start (not_blocked seg_C1_n2b_0_80 airplane_DAEW5))
                 (at start (not_blocked seg_C1_n2b_0_80 airplane_DAEW6))
                 (at start (not_blocked seg_C1_n2b_0_80 airplane_DAEW7))
                 (at start (not_blocked seg_C1_n2b_0_80 airplane_CFBE2))

                 (over all (not_occupied seg_C1_n2c_0_60))
              )

 :effect        (and
                 (at end (not (occupied seg_C1_n2a_0_60)))
                 (at end (not_occupied seg_C1_n2a_0_60))
                 (at start (not (at-segment ?a seg_C1_n2a_0_60)))

                 (at start (occupied seg_C1_n2b_0_80))
                 (at start (not (not_occupied seg_C1_n2b_0_80)))
                 (at start (blocked seg_C1_n2b_0_80 ?a))
                 (at start (not (not_blocked seg_C1_n2b_0_80 ?a)))
                 (at end (at-segment ?a seg_C1_n2b_0_80))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_N2_0_108 ?a)))
                 (at end (not_blocked seg_N2_0_108 ?a))

                 (at start (blocked seg_C1_n2c_0_60 ?a))
                 (at start (not (not_blocked seg_C1_n2c_0_60 ?a)))
                )
)

(:durative-action move_seg_O1_C1c_0_80_seg_O1_C1a_0_60_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_C1c_0_80))
                 (at start (not_occupied seg_O1_C1a_0_60))
                 (at start (not_blocked seg_O1_C1a_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_O1_C1a_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_O1_C1a_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_O1_C1a_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_O1_C1a_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_O1_C1a_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_O1_C1a_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_O1_C1a_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_O1_C1a_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_O1_C1a_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_O1_C1a_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_O1_C1a_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_O1_C1a_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_O1_C1a_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_O1_C1a_0_60 airplane_CFBE2))

                 (over all (not_occupied seg_O1_C1b_0_34))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_C1c_0_80)))
                 (at end (not_occupied seg_O1_C1c_0_80))
                 (at start (not (at-segment ?a seg_O1_C1c_0_80)))

                 (at start (occupied seg_O1_C1a_0_60))
                 (at start (not (not_occupied seg_O1_C1a_0_60)))
                 (at start (blocked seg_O1_C1a_0_60 ?a))
                 (at start (not (not_blocked seg_O1_C1a_0_60 ?a)))
                 (at end (at-segment ?a seg_O1_C1a_0_60))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_C1_n2b_0_80 ?a)))
                 (at end (not_blocked seg_C1_n2b_0_80 ?a))

                 (at start (blocked seg_O1_C1b_0_34 ?a))
                 (at start (not (not_blocked seg_O1_C1b_0_34 ?a)))
                )
)

(:durative-action move_seg_p102_0_76_seg_O1_102b_0_60_north_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_p102_0_76))
                 (at start (not_occupied seg_O1_102b_0_60))
                 (at start (not_blocked seg_O1_102b_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_O1_102b_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_O1_102b_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_O1_102b_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_O1_102b_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_O1_102b_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_O1_102b_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_O1_102b_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_O1_102b_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_O1_102b_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_O1_102b_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_O1_102b_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_O1_102b_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_O1_102b_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_O1_102b_0_60 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_p102_0_76)))
                 (at end (not_occupied seg_p102_0_76))
                 (at start (not (at-segment ?a seg_p102_0_76)))

                 (at start (occupied seg_O1_102b_0_60))
                 (at start (not (not_occupied seg_O1_102b_0_60)))
                 (at start (blocked seg_O1_102b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_102b_0_60 ?a)))
                 (at end (at-segment ?a seg_O1_102b_0_60))


                )
)

(:durative-action move_seg_O1_102b_0_60_seg_O1_102a_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_102b_0_60))
                 (at start (not_occupied seg_O1_102a_0_34))
                 (at start (not_blocked seg_O1_102a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_102a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_102a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_102a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_102a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_102a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_102a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_102a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_102a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_102a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_102a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_102a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_102a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_102a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_102a_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_O1_102c_0_34))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_102b_0_60)))
                 (at end (not_occupied seg_O1_102b_0_60))
                 (at start (not (at-segment ?a seg_O1_102b_0_60)))

                 (at start (occupied seg_O1_102a_0_34))
                 (at start (not (not_occupied seg_O1_102a_0_34)))
                 (at start (blocked seg_O1_102a_0_34 ?a))
                 (at start (not (not_blocked seg_O1_102a_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_102a_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_p102_0_76 ?a)))
                 (at end (not_blocked seg_p102_0_76 ?a))

                 (at start (blocked seg_O1_102c_0_34 ?a))
                 (at start (not (not_blocked seg_O1_102c_0_34 ?a)))
                )
)

(:durative-action move_seg_O1_102b_0_60_seg_O1_102c_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_102b_0_60))
                 (at start (not_occupied seg_O1_102c_0_34))
                 (at start (not_blocked seg_O1_102c_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_102c_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_102c_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_102c_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_102c_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_102c_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_102c_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_102c_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_102c_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_102c_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_102c_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_102c_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_102c_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_102c_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_102c_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_O1_102a_0_34))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_102b_0_60)))
                 (at end (not_occupied seg_O1_102b_0_60))
                 (at start (not (at-segment ?a seg_O1_102b_0_60)))

                 (at start (occupied seg_O1_102c_0_34))
                 (at start (not (not_occupied seg_O1_102c_0_34)))
                 (at start (blocked seg_O1_102c_0_34 ?a))
                 (at start (not (not_blocked seg_O1_102c_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_102c_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_p102_0_76 ?a)))
                 (at end (not_blocked seg_p102_0_76 ?a))

                 (at start (blocked seg_O1_102a_0_34 ?a))
                 (at start (not (not_blocked seg_O1_102a_0_34 ?a)))
                )
)

(:durative-action move_seg_O1_102c_0_34_seg_O1_102b_0_60_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_102c_0_34))
                 (at start (not_occupied seg_O1_102b_0_60))
                 (at start (not_blocked seg_O1_102b_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_O1_102b_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_O1_102b_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_O1_102b_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_O1_102b_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_O1_102b_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_O1_102b_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_O1_102b_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_O1_102b_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_O1_102b_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_O1_102b_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_O1_102b_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_O1_102b_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_O1_102b_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_O1_102b_0_60 airplane_CFBE2))

                 (over all (not_occupied seg_O1_102a_0_34))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_102c_0_34)))
                 (at end (not_occupied seg_O1_102c_0_34))
                 (at start (not (at-segment ?a seg_O1_102c_0_34)))

                 (at start (occupied seg_O1_102b_0_60))
                 (at start (not (not_occupied seg_O1_102b_0_60)))
                 (at start (blocked seg_O1_102b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_102b_0_60 ?a)))
                 (at end (at-segment ?a seg_O1_102b_0_60))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_O1_103a_0_34 ?a)))
                 (at end (not_blocked seg_O1_103a_0_34 ?a))

                 (at start (blocked seg_O1_102a_0_34 ?a))
                 (at start (not (not_blocked seg_O1_102a_0_34 ?a)))
                )
)

(:durative-action move_seg_O1_102b_0_60_seg_p102_0_76_south_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_O1_102b_0_60))
                 (at start (not_occupied seg_p102_0_76))
                 (at start (not_blocked seg_p102_0_76 airplane_CFBEG))
                 (at start (not_blocked seg_p102_0_76 airplane_CFBE1))
                 (at start (not_blocked seg_p102_0_76 airplane_CFBE3))
                 (at start (not_blocked seg_p102_0_76 airplane_DAEW8))
                 (at start (not_blocked seg_p102_0_76 airplane_DAEW9))
                 (at start (not_blocked seg_p102_0_76 airplane_DAEW0))
                 (at start (not_blocked seg_p102_0_76 airplane_DAEW3))
                 (at start (not_blocked seg_p102_0_76 airplane_DAEWH))
                 (at start (not_blocked seg_p102_0_76 airplane_DAEW1))
                 (at start (not_blocked seg_p102_0_76 airplane_DAEW2))
                 (at start (not_blocked seg_p102_0_76 airplane_DAEW4))
                 (at start (not_blocked seg_p102_0_76 airplane_DAEW5))
                 (at start (not_blocked seg_p102_0_76 airplane_DAEW6))
                 (at start (not_blocked seg_p102_0_76 airplane_DAEW7))
                 (at start (not_blocked seg_p102_0_76 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_O1_102b_0_60)))
                 (at end (not_occupied seg_O1_102b_0_60))
                 (at start (not (at-segment ?a seg_O1_102b_0_60)))

                 (at start (occupied seg_p102_0_76))
                 (at start (not (not_occupied seg_p102_0_76)))
                 (at start (blocked seg_p102_0_76 ?a))
                 (at start (not (not_blocked seg_p102_0_76 ?a)))
                 (at end (at-segment ?a seg_p102_0_76))

                 (at end (not (blocked seg_O1_102a_0_34 ?a)))
                 (at end (not_blocked seg_O1_102a_0_34 ?a))
                 (at end (not (blocked seg_O1_102c_0_34 ?a)))
                 (at end (not_blocked seg_O1_102c_0_34 ?a))

                )
)

(:durative-action move_seg_O1_102a_0_34_seg_O1_102b_0_60_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_102a_0_34))
                 (at start (not_occupied seg_O1_102b_0_60))
                 (at start (not_blocked seg_O1_102b_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_O1_102b_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_O1_102b_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_O1_102b_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_O1_102b_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_O1_102b_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_O1_102b_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_O1_102b_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_O1_102b_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_O1_102b_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_O1_102b_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_O1_102b_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_O1_102b_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_O1_102b_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_O1_102b_0_60 airplane_CFBE2))

                 (over all (not_occupied seg_O1_102c_0_34))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_102a_0_34)))
                 (at end (not_occupied seg_O1_102a_0_34))
                 (at start (not (at-segment ?a seg_O1_102a_0_34)))

                 (at start (occupied seg_O1_102b_0_60))
                 (at start (not (not_occupied seg_O1_102b_0_60)))
                 (at start (blocked seg_O1_102b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_102b_0_60 ?a)))
                 (at end (at-segment ?a seg_O1_102b_0_60))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_O1_C1b_0_34 ?a)))
                 (at end (not_blocked seg_O1_C1b_0_34 ?a))

                 (at start (blocked seg_O1_102c_0_34 ?a))
                 (at start (not (not_blocked seg_O1_102c_0_34 ?a)))
                )
)

(:durative-action move_seg_p103_0_76_seg_O1_103b_0_60_north_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_p103_0_76))
                 (at start (not_occupied seg_O1_103b_0_60))
                 (at start (not_blocked seg_O1_103b_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_O1_103b_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_O1_103b_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_O1_103b_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_O1_103b_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_O1_103b_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_O1_103b_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_O1_103b_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_O1_103b_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_O1_103b_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_O1_103b_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_O1_103b_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_O1_103b_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_O1_103b_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_O1_103b_0_60 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_p103_0_76)))
                 (at end (not_occupied seg_p103_0_76))
                 (at start (not (at-segment ?a seg_p103_0_76)))

                 (at start (occupied seg_O1_103b_0_60))
                 (at start (not (not_occupied seg_O1_103b_0_60)))
                 (at start (blocked seg_O1_103b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_103b_0_60 ?a)))
                 (at end (at-segment ?a seg_O1_103b_0_60))


                )
)

(:durative-action move_seg_O1_103b_0_60_seg_O1_103a_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_103b_0_60))
                 (at start (not_occupied seg_O1_103a_0_34))
                 (at start (not_blocked seg_O1_103a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_103a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_103a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_103a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_103a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_103a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_103a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_103a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_103a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_103a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_103a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_103a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_103a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_103a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_103a_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_O1_103c_0_34))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_103b_0_60)))
                 (at end (not_occupied seg_O1_103b_0_60))
                 (at start (not (at-segment ?a seg_O1_103b_0_60)))

                 (at start (occupied seg_O1_103a_0_34))
                 (at start (not (not_occupied seg_O1_103a_0_34)))
                 (at start (blocked seg_O1_103a_0_34 ?a))
                 (at start (not (not_blocked seg_O1_103a_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_103a_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_p103_0_76 ?a)))
                 (at end (not_blocked seg_p103_0_76 ?a))

                 (at start (blocked seg_O1_103c_0_34 ?a))
                 (at start (not (not_blocked seg_O1_103c_0_34 ?a)))
                )
)

(:durative-action move_seg_O1_103b_0_60_seg_O1_103c_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_103b_0_60))
                 (at start (not_occupied seg_O1_103c_0_34))
                 (at start (not_blocked seg_O1_103c_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_103c_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_103c_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_103c_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_103c_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_103c_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_103c_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_103c_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_103c_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_103c_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_103c_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_103c_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_103c_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_103c_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_103c_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_O1_103a_0_34))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_103b_0_60)))
                 (at end (not_occupied seg_O1_103b_0_60))
                 (at start (not (at-segment ?a seg_O1_103b_0_60)))

                 (at start (occupied seg_O1_103c_0_34))
                 (at start (not (not_occupied seg_O1_103c_0_34)))
                 (at start (blocked seg_O1_103c_0_34 ?a))
                 (at start (not (not_blocked seg_O1_103c_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_103c_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_p103_0_76 ?a)))
                 (at end (not_blocked seg_p103_0_76 ?a))

                 (at start (blocked seg_O1_103a_0_34 ?a))
                 (at start (not (not_blocked seg_O1_103a_0_34 ?a)))
                )
)

(:durative-action move_seg_O1_103c_0_34_seg_O1_103b_0_60_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_103c_0_34))
                 (at start (not_occupied seg_O1_103b_0_60))
                 (at start (not_blocked seg_O1_103b_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_O1_103b_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_O1_103b_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_O1_103b_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_O1_103b_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_O1_103b_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_O1_103b_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_O1_103b_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_O1_103b_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_O1_103b_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_O1_103b_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_O1_103b_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_O1_103b_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_O1_103b_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_O1_103b_0_60 airplane_CFBE2))

                 (over all (not_occupied seg_O1_103a_0_34))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_103c_0_34)))
                 (at end (not_occupied seg_O1_103c_0_34))
                 (at start (not (at-segment ?a seg_O1_103c_0_34)))

                 (at start (occupied seg_O1_103b_0_60))
                 (at start (not (not_occupied seg_O1_103b_0_60)))
                 (at start (blocked seg_O1_103b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_103b_0_60 ?a)))
                 (at end (at-segment ?a seg_O1_103b_0_60))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_O1_104a_0_34 ?a)))
                 (at end (not_blocked seg_O1_104a_0_34 ?a))

                 (at start (blocked seg_O1_103a_0_34 ?a))
                 (at start (not (not_blocked seg_O1_103a_0_34 ?a)))
                )
)

(:durative-action move_seg_O1_103b_0_60_seg_p103_0_76_south_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_O1_103b_0_60))
                 (at start (not_occupied seg_p103_0_76))
                 (at start (not_blocked seg_p103_0_76 airplane_CFBEG))
                 (at start (not_blocked seg_p103_0_76 airplane_CFBE1))
                 (at start (not_blocked seg_p103_0_76 airplane_CFBE3))
                 (at start (not_blocked seg_p103_0_76 airplane_DAEW8))
                 (at start (not_blocked seg_p103_0_76 airplane_DAEW9))
                 (at start (not_blocked seg_p103_0_76 airplane_DAEW0))
                 (at start (not_blocked seg_p103_0_76 airplane_DAEW3))
                 (at start (not_blocked seg_p103_0_76 airplane_DAEWH))
                 (at start (not_blocked seg_p103_0_76 airplane_DAEW1))
                 (at start (not_blocked seg_p103_0_76 airplane_DAEW2))
                 (at start (not_blocked seg_p103_0_76 airplane_DAEW4))
                 (at start (not_blocked seg_p103_0_76 airplane_DAEW5))
                 (at start (not_blocked seg_p103_0_76 airplane_DAEW6))
                 (at start (not_blocked seg_p103_0_76 airplane_DAEW7))
                 (at start (not_blocked seg_p103_0_76 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_O1_103b_0_60)))
                 (at end (not_occupied seg_O1_103b_0_60))
                 (at start (not (at-segment ?a seg_O1_103b_0_60)))

                 (at start (occupied seg_p103_0_76))
                 (at start (not (not_occupied seg_p103_0_76)))
                 (at start (blocked seg_p103_0_76 ?a))
                 (at start (not (not_blocked seg_p103_0_76 ?a)))
                 (at end (at-segment ?a seg_p103_0_76))

                 (at end (not (blocked seg_O1_103a_0_34 ?a)))
                 (at end (not_blocked seg_O1_103a_0_34 ?a))
                 (at end (not (blocked seg_O1_103c_0_34 ?a)))
                 (at end (not_blocked seg_O1_103c_0_34 ?a))

                )
)

(:durative-action move_seg_O1_103a_0_34_seg_O1_103b_0_60_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_103a_0_34))
                 (at start (not_occupied seg_O1_103b_0_60))
                 (at start (not_blocked seg_O1_103b_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_O1_103b_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_O1_103b_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_O1_103b_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_O1_103b_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_O1_103b_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_O1_103b_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_O1_103b_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_O1_103b_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_O1_103b_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_O1_103b_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_O1_103b_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_O1_103b_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_O1_103b_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_O1_103b_0_60 airplane_CFBE2))

                 (over all (not_occupied seg_O1_103c_0_34))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_103a_0_34)))
                 (at end (not_occupied seg_O1_103a_0_34))
                 (at start (not (at-segment ?a seg_O1_103a_0_34)))

                 (at start (occupied seg_O1_103b_0_60))
                 (at start (not (not_occupied seg_O1_103b_0_60)))
                 (at start (blocked seg_O1_103b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_103b_0_60 ?a)))
                 (at end (at-segment ?a seg_O1_103b_0_60))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_O1_102c_0_34 ?a)))
                 (at end (not_blocked seg_O1_102c_0_34 ?a))

                 (at start (blocked seg_O1_103c_0_34 ?a))
                 (at start (not (not_blocked seg_O1_103c_0_34 ?a)))
                )
)

(:durative-action move_seg_p104_0_76_seg_O1_104b_0_60_north_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_p104_0_76))
                 (at start (not_occupied seg_O1_104b_0_60))
                 (at start (not_blocked seg_O1_104b_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_O1_104b_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_O1_104b_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_O1_104b_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_O1_104b_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_O1_104b_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_O1_104b_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_O1_104b_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_O1_104b_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_O1_104b_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_O1_104b_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_O1_104b_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_O1_104b_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_O1_104b_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_O1_104b_0_60 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_p104_0_76)))
                 (at end (not_occupied seg_p104_0_76))
                 (at start (not (at-segment ?a seg_p104_0_76)))

                 (at start (occupied seg_O1_104b_0_60))
                 (at start (not (not_occupied seg_O1_104b_0_60)))
                 (at start (blocked seg_O1_104b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_104b_0_60 ?a)))
                 (at end (at-segment ?a seg_O1_104b_0_60))


                )
)

(:durative-action move_seg_O1_104b_0_60_seg_O1_104a_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_104b_0_60))
                 (at start (not_occupied seg_O1_104a_0_34))
                 (at start (not_blocked seg_O1_104a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_104a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_104a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_104a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_104a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_104a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_104a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_104a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_104a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_104a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_104a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_104a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_104a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_104a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_104a_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_O1_104c_0_60))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_104b_0_60)))
                 (at end (not_occupied seg_O1_104b_0_60))
                 (at start (not (at-segment ?a seg_O1_104b_0_60)))

                 (at start (occupied seg_O1_104a_0_34))
                 (at start (not (not_occupied seg_O1_104a_0_34)))
                 (at start (blocked seg_O1_104a_0_34 ?a))
                 (at start (not (not_blocked seg_O1_104a_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_104a_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_p104_0_76 ?a)))
                 (at end (not_blocked seg_p104_0_76 ?a))

                 (at start (blocked seg_O1_104c_0_60 ?a))
                 (at start (not (not_blocked seg_O1_104c_0_60 ?a)))
                )
)

(:durative-action move_seg_O1_104b_0_60_seg_O1_104c_0_60_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_104b_0_60))
                 (at start (not_occupied seg_O1_104c_0_60))
                 (at start (not_blocked seg_O1_104c_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_O1_104c_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_O1_104c_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_O1_104c_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_O1_104c_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_O1_104c_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_O1_104c_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_O1_104c_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_O1_104c_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_O1_104c_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_O1_104c_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_O1_104c_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_O1_104c_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_O1_104c_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_O1_104c_0_60 airplane_CFBE2))

                 (over all (not_occupied seg_O1_104a_0_34))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_104b_0_60)))
                 (at end (not_occupied seg_O1_104b_0_60))
                 (at start (not (at-segment ?a seg_O1_104b_0_60)))

                 (at start (occupied seg_O1_104c_0_60))
                 (at start (not (not_occupied seg_O1_104c_0_60)))
                 (at start (blocked seg_O1_104c_0_60 ?a))
                 (at start (not (not_blocked seg_O1_104c_0_60 ?a)))
                 (at end (at-segment ?a seg_O1_104c_0_60))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_p104_0_76 ?a)))
                 (at end (not_blocked seg_p104_0_76 ?a))

                 (at start (blocked seg_O1_104a_0_34 ?a))
                 (at start (not (not_blocked seg_O1_104a_0_34 ?a)))
                )
)

(:durative-action move_seg_O1_104c_0_60_seg_O1_104b_0_60_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_104c_0_60))
                 (at start (not_occupied seg_O1_104b_0_60))
                 (at start (not_blocked seg_O1_104b_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_O1_104b_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_O1_104b_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_O1_104b_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_O1_104b_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_O1_104b_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_O1_104b_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_O1_104b_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_O1_104b_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_O1_104b_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_O1_104b_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_O1_104b_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_O1_104b_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_O1_104b_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_O1_104b_0_60 airplane_CFBE2))

                 (over all (not_occupied seg_O1_104a_0_34))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_104c_0_60)))
                 (at end (not_occupied seg_O1_104c_0_60))
                 (at start (not (at-segment ?a seg_O1_104c_0_60)))

                 (at start (occupied seg_O1_104b_0_60))
                 (at start (not (not_occupied seg_O1_104b_0_60)))
                 (at start (blocked seg_O1_104b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_104b_0_60 ?a)))
                 (at end (at-segment ?a seg_O1_104b_0_60))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_O1_C2a_0_60 ?a)))
                 (at end (not_blocked seg_O1_C2a_0_60 ?a))

                 (at start (blocked seg_O1_104a_0_34 ?a))
                 (at start (not (not_blocked seg_O1_104a_0_34 ?a)))
                )
)

(:durative-action move_seg_O1_104b_0_60_seg_p104_0_76_south_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_O1_104b_0_60))
                 (at start (not_occupied seg_p104_0_76))
                 (at start (not_blocked seg_p104_0_76 airplane_CFBEG))
                 (at start (not_blocked seg_p104_0_76 airplane_CFBE1))
                 (at start (not_blocked seg_p104_0_76 airplane_CFBE3))
                 (at start (not_blocked seg_p104_0_76 airplane_DAEW8))
                 (at start (not_blocked seg_p104_0_76 airplane_DAEW9))
                 (at start (not_blocked seg_p104_0_76 airplane_DAEW0))
                 (at start (not_blocked seg_p104_0_76 airplane_DAEW3))
                 (at start (not_blocked seg_p104_0_76 airplane_DAEWH))
                 (at start (not_blocked seg_p104_0_76 airplane_DAEW1))
                 (at start (not_blocked seg_p104_0_76 airplane_DAEW2))
                 (at start (not_blocked seg_p104_0_76 airplane_DAEW4))
                 (at start (not_blocked seg_p104_0_76 airplane_DAEW5))
                 (at start (not_blocked seg_p104_0_76 airplane_DAEW6))
                 (at start (not_blocked seg_p104_0_76 airplane_DAEW7))
                 (at start (not_blocked seg_p104_0_76 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_O1_104b_0_60)))
                 (at end (not_occupied seg_O1_104b_0_60))
                 (at start (not (at-segment ?a seg_O1_104b_0_60)))

                 (at start (occupied seg_p104_0_76))
                 (at start (not (not_occupied seg_p104_0_76)))
                 (at start (blocked seg_p104_0_76 ?a))
                 (at start (not (not_blocked seg_p104_0_76 ?a)))
                 (at end (at-segment ?a seg_p104_0_76))

                 (at end (not (blocked seg_O1_104a_0_34 ?a)))
                 (at end (not_blocked seg_O1_104a_0_34 ?a))
                 (at end (not (blocked seg_O1_104c_0_60 ?a)))
                 (at end (not_blocked seg_O1_104c_0_60 ?a))

                )
)

(:durative-action move_seg_O1_104a_0_34_seg_O1_104b_0_60_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_104a_0_34))
                 (at start (not_occupied seg_O1_104b_0_60))
                 (at start (not_blocked seg_O1_104b_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_O1_104b_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_O1_104b_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_O1_104b_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_O1_104b_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_O1_104b_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_O1_104b_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_O1_104b_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_O1_104b_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_O1_104b_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_O1_104b_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_O1_104b_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_O1_104b_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_O1_104b_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_O1_104b_0_60 airplane_CFBE2))

                 (over all (not_occupied seg_O1_104c_0_60))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_104a_0_34)))
                 (at end (not_occupied seg_O1_104a_0_34))
                 (at start (not (at-segment ?a seg_O1_104a_0_34)))

                 (at start (occupied seg_O1_104b_0_60))
                 (at start (not (not_occupied seg_O1_104b_0_60)))
                 (at start (blocked seg_O1_104b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_104b_0_60 ?a)))
                 (at end (at-segment ?a seg_O1_104b_0_60))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_O1_103c_0_34 ?a)))
                 (at end (not_blocked seg_O1_103c_0_34 ?a))

                 (at start (blocked seg_O1_104c_0_60 ?a))
                 (at start (not (not_blocked seg_O1_104c_0_60 ?a)))
                )
)

(:durative-action move_seg_p107_0_76_seg_O1_C2b_0_60_north_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_p107_0_76))
                 (at start (not_occupied seg_O1_C2b_0_60))
                 (at start (not_blocked seg_O1_C2b_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_O1_C2b_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_O1_C2b_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_O1_C2b_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_O1_C2b_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_O1_C2b_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_O1_C2b_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_O1_C2b_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_O1_C2b_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_O1_C2b_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_O1_C2b_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_O1_C2b_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_O1_C2b_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_O1_C2b_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_O1_C2b_0_60 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_p107_0_76)))
                 (at end (not_occupied seg_p107_0_76))
                 (at start (not (at-segment ?a seg_p107_0_76)))

                 (at start (occupied seg_O1_C2b_0_60))
                 (at start (not (not_occupied seg_O1_C2b_0_60)))
                 (at start (blocked seg_O1_C2b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_C2b_0_60 ?a)))
                 (at end (at-segment ?a seg_O1_C2b_0_60))


                )
)

(:durative-action move_seg_O1_C2b_0_60_seg_O1_C2d_0_60_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_C2b_0_60))
                 (at start (not_occupied seg_O1_C2d_0_60))
                 (at start (not_blocked seg_O1_C2d_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_O1_C2d_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_O1_C2d_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_O1_C2d_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_O1_C2d_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_O1_C2d_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_O1_C2d_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_O1_C2d_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_O1_C2d_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_O1_C2d_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_O1_C2d_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_O1_C2d_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_O1_C2d_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_O1_C2d_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_O1_C2d_0_60 airplane_CFBE2))

                 (over all (not_occupied seg_O1_C2a_0_60))
                 (over all (not_occupied seg_O1_C2c_0_34))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_C2b_0_60)))
                 (at end (not_occupied seg_O1_C2b_0_60))
                 (at start (not (at-segment ?a seg_O1_C2b_0_60)))

                 (at start (occupied seg_O1_C2d_0_60))
                 (at start (not (not_occupied seg_O1_C2d_0_60)))
                 (at start (blocked seg_O1_C2d_0_60 ?a))
                 (at start (not (not_blocked seg_O1_C2d_0_60 ?a)))
                 (at end (at-segment ?a seg_O1_C2d_0_60))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_p107_0_76 ?a)))
                 (at end (not_blocked seg_p107_0_76 ?a))

                 (at start (blocked seg_O1_C2a_0_60 ?a))
                 (at start (not (not_blocked seg_O1_C2a_0_60 ?a)))
                 (at start (blocked seg_O1_C2c_0_34 ?a))
                 (at start (not (not_blocked seg_O1_C2c_0_34 ?a)))
                )
)

(:durative-action move_seg_O1_C2d_0_60_seg_C2_b_0_80_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_O1_C2d_0_60))
                 (at start (not_occupied seg_C2_b_0_80))
                 (at start (not_blocked seg_C2_b_0_80 airplane_CFBEG))
                 (at start (not_blocked seg_C2_b_0_80 airplane_CFBE1))
                 (at start (not_blocked seg_C2_b_0_80 airplane_CFBE3))
                 (at start (not_blocked seg_C2_b_0_80 airplane_DAEW8))
                 (at start (not_blocked seg_C2_b_0_80 airplane_DAEW9))
                 (at start (not_blocked seg_C2_b_0_80 airplane_DAEW0))
                 (at start (not_blocked seg_C2_b_0_80 airplane_DAEW3))
                 (at start (not_blocked seg_C2_b_0_80 airplane_DAEWH))
                 (at start (not_blocked seg_C2_b_0_80 airplane_DAEW1))
                 (at start (not_blocked seg_C2_b_0_80 airplane_DAEW2))
                 (at start (not_blocked seg_C2_b_0_80 airplane_DAEW4))
                 (at start (not_blocked seg_C2_b_0_80 airplane_DAEW5))
                 (at start (not_blocked seg_C2_b_0_80 airplane_DAEW6))
                 (at start (not_blocked seg_C2_b_0_80 airplane_DAEW7))
                 (at start (not_blocked seg_C2_b_0_80 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_O1_C2d_0_60)))
                 (at end (not_occupied seg_O1_C2d_0_60))
                 (at start (not (at-segment ?a seg_O1_C2d_0_60)))

                 (at start (occupied seg_C2_b_0_80))
                 (at start (not (not_occupied seg_C2_b_0_80)))
                 (at start (blocked seg_C2_b_0_80 ?a))
                 (at start (not (not_blocked seg_C2_b_0_80 ?a)))
                 (at end (at-segment ?a seg_C2_b_0_80))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_O1_C2a_0_60 ?a)))
                 (at end (not_blocked seg_O1_C2a_0_60 ?a))
                 (at end (not (blocked seg_O1_C2b_0_60 ?a)))
                 (at end (not_blocked seg_O1_C2b_0_60 ?a))
                 (at end (not (blocked seg_O1_C2c_0_34 ?a)))
                 (at end (not_blocked seg_O1_C2c_0_34 ?a))

                )
)

(:durative-action move_seg_C2_b_0_80_seg_O1_C2d_0_60_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_C2_b_0_80))
                 (at start (not_occupied seg_O1_C2d_0_60))
                 (at start (not_blocked seg_O1_C2d_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_O1_C2d_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_O1_C2d_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_O1_C2d_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_O1_C2d_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_O1_C2d_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_O1_C2d_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_O1_C2d_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_O1_C2d_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_O1_C2d_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_O1_C2d_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_O1_C2d_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_O1_C2d_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_O1_C2d_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_O1_C2d_0_60 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_C2_b_0_80)))
                 (at end (not_occupied seg_C2_b_0_80))
                 (at start (not (at-segment ?a seg_C2_b_0_80)))

                 (at start (occupied seg_O1_C2d_0_60))
                 (at start (not (not_occupied seg_O1_C2d_0_60)))
                 (at start (blocked seg_O1_C2d_0_60 ?a))
                 (at start (not (not_blocked seg_O1_C2d_0_60 ?a)))
                 (at end (at-segment ?a seg_O1_C2d_0_60))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_C2_a_0_80 ?a)))
                 (at end (not_blocked seg_C2_a_0_80 ?a))

                )
)

(:durative-action move_seg_O1_C2d_0_60_seg_O1_C2c_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_C2d_0_60))
                 (at start (not_occupied seg_O1_C2c_0_34))
                 (at start (not_blocked seg_O1_C2c_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_C2c_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_C2c_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_C2c_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_C2c_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_C2c_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_C2c_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_C2c_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_C2c_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_C2c_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_C2c_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_C2c_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_C2c_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_C2c_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_C2c_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_O1_C2a_0_60))
                 (over all (not_occupied seg_O1_C2b_0_60))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_C2d_0_60)))
                 (at end (not_occupied seg_O1_C2d_0_60))
                 (at start (not (at-segment ?a seg_O1_C2d_0_60)))

                 (at start (occupied seg_O1_C2c_0_34))
                 (at start (not (not_occupied seg_O1_C2c_0_34)))
                 (at start (blocked seg_O1_C2c_0_34 ?a))
                 (at start (not (not_blocked seg_O1_C2c_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_C2c_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_C2_b_0_80 ?a)))
                 (at end (not_blocked seg_C2_b_0_80 ?a))

                 (at start (blocked seg_O1_C2a_0_60 ?a))
                 (at start (not (not_blocked seg_O1_C2a_0_60 ?a)))
                 (at start (blocked seg_O1_C2b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_C2b_0_60 ?a)))
                )
)

(:durative-action move_seg_O1_C2d_0_60_seg_O1_C2a_0_60_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_C2d_0_60))
                 (at start (not_occupied seg_O1_C2a_0_60))
                 (at start (not_blocked seg_O1_C2a_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_O1_C2a_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_O1_C2a_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_O1_C2a_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_O1_C2a_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_O1_C2a_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_O1_C2a_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_O1_C2a_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_O1_C2a_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_O1_C2a_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_O1_C2a_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_O1_C2a_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_O1_C2a_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_O1_C2a_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_O1_C2a_0_60 airplane_CFBE2))

                 (over all (not_occupied seg_O1_C2b_0_60))
                 (over all (not_occupied seg_O1_C2c_0_34))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_C2d_0_60)))
                 (at end (not_occupied seg_O1_C2d_0_60))
                 (at start (not (at-segment ?a seg_O1_C2d_0_60)))

                 (at start (occupied seg_O1_C2a_0_60))
                 (at start (not (not_occupied seg_O1_C2a_0_60)))
                 (at start (blocked seg_O1_C2a_0_60 ?a))
                 (at start (not (not_blocked seg_O1_C2a_0_60 ?a)))
                 (at end (at-segment ?a seg_O1_C2a_0_60))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_C2_b_0_80 ?a)))
                 (at end (not_blocked seg_C2_b_0_80 ?a))

                 (at start (blocked seg_O1_C2b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_C2b_0_60 ?a)))
                 (at start (blocked seg_O1_C2c_0_34 ?a))
                 (at start (not (not_blocked seg_O1_C2c_0_34 ?a)))
                )
)

(:durative-action move_seg_O1_C2c_0_34_seg_O1_C2b_0_60_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_C2c_0_34))
                 (at start (not_occupied seg_O1_C2b_0_60))
                 (at start (not_blocked seg_O1_C2b_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_O1_C2b_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_O1_C2b_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_O1_C2b_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_O1_C2b_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_O1_C2b_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_O1_C2b_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_O1_C2b_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_O1_C2b_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_O1_C2b_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_O1_C2b_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_O1_C2b_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_O1_C2b_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_O1_C2b_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_O1_C2b_0_60 airplane_CFBE2))

                 (over all (not_occupied seg_O1_C2a_0_60))
                 (over all (not_occupied seg_O1_C2d_0_60))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_C2c_0_34)))
                 (at end (not_occupied seg_O1_C2c_0_34))
                 (at start (not (at-segment ?a seg_O1_C2c_0_34)))

                 (at start (occupied seg_O1_C2b_0_60))
                 (at start (not (not_occupied seg_O1_C2b_0_60)))
                 (at start (blocked seg_O1_C2b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_C2b_0_60 ?a)))
                 (at end (at-segment ?a seg_O1_C2b_0_60))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_O1_108a_0_34 ?a)))
                 (at end (not_blocked seg_O1_108a_0_34 ?a))

                 (at start (blocked seg_O1_C2a_0_60 ?a))
                 (at start (not (not_blocked seg_O1_C2a_0_60 ?a)))
                 (at start (blocked seg_O1_C2d_0_60 ?a))
                 (at start (not (not_blocked seg_O1_C2d_0_60 ?a)))
                )
)

(:durative-action move_seg_O1_C2b_0_60_seg_p107_0_76_south_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_O1_C2b_0_60))
                 (at start (not_occupied seg_p107_0_76))
                 (at start (not_blocked seg_p107_0_76 airplane_CFBEG))
                 (at start (not_blocked seg_p107_0_76 airplane_CFBE1))
                 (at start (not_blocked seg_p107_0_76 airplane_CFBE3))
                 (at start (not_blocked seg_p107_0_76 airplane_DAEW8))
                 (at start (not_blocked seg_p107_0_76 airplane_DAEW9))
                 (at start (not_blocked seg_p107_0_76 airplane_DAEW0))
                 (at start (not_blocked seg_p107_0_76 airplane_DAEW3))
                 (at start (not_blocked seg_p107_0_76 airplane_DAEWH))
                 (at start (not_blocked seg_p107_0_76 airplane_DAEW1))
                 (at start (not_blocked seg_p107_0_76 airplane_DAEW2))
                 (at start (not_blocked seg_p107_0_76 airplane_DAEW4))
                 (at start (not_blocked seg_p107_0_76 airplane_DAEW5))
                 (at start (not_blocked seg_p107_0_76 airplane_DAEW6))
                 (at start (not_blocked seg_p107_0_76 airplane_DAEW7))
                 (at start (not_blocked seg_p107_0_76 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_O1_C2b_0_60)))
                 (at end (not_occupied seg_O1_C2b_0_60))
                 (at start (not (at-segment ?a seg_O1_C2b_0_60)))

                 (at start (occupied seg_p107_0_76))
                 (at start (not (not_occupied seg_p107_0_76)))
                 (at start (blocked seg_p107_0_76 ?a))
                 (at start (not (not_blocked seg_p107_0_76 ?a)))
                 (at end (at-segment ?a seg_p107_0_76))

                 (at end (not (blocked seg_O1_C2a_0_60 ?a)))
                 (at end (not_blocked seg_O1_C2a_0_60 ?a))
                 (at end (not (blocked seg_O1_C2c_0_34 ?a)))
                 (at end (not_blocked seg_O1_C2c_0_34 ?a))
                 (at end (not (blocked seg_O1_C2d_0_60 ?a)))
                 (at end (not_blocked seg_O1_C2d_0_60 ?a))

                )
)

(:durative-action move_seg_O1_C2a_0_60_seg_O1_C2b_0_60_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_C2a_0_60))
                 (at start (not_occupied seg_O1_C2b_0_60))
                 (at start (not_blocked seg_O1_C2b_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_O1_C2b_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_O1_C2b_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_O1_C2b_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_O1_C2b_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_O1_C2b_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_O1_C2b_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_O1_C2b_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_O1_C2b_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_O1_C2b_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_O1_C2b_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_O1_C2b_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_O1_C2b_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_O1_C2b_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_O1_C2b_0_60 airplane_CFBE2))

                 (over all (not_occupied seg_O1_C2c_0_34))
                 (over all (not_occupied seg_O1_C2d_0_60))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_C2a_0_60)))
                 (at end (not_occupied seg_O1_C2a_0_60))
                 (at start (not (at-segment ?a seg_O1_C2a_0_60)))

                 (at start (occupied seg_O1_C2b_0_60))
                 (at start (not (not_occupied seg_O1_C2b_0_60)))
                 (at start (blocked seg_O1_C2b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_C2b_0_60 ?a)))
                 (at end (at-segment ?a seg_O1_C2b_0_60))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_O1_104c_0_60 ?a)))
                 (at end (not_blocked seg_O1_104c_0_60 ?a))

                 (at start (blocked seg_O1_C2c_0_34 ?a))
                 (at start (not (not_blocked seg_O1_C2c_0_34 ?a)))
                 (at start (blocked seg_O1_C2d_0_60 ?a))
                 (at start (not (not_blocked seg_O1_C2d_0_60 ?a)))
                )
)

(:durative-action move_seg_p108_0_76_seg_O1_108b_0_60_north_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_p108_0_76))
                 (at start (not_occupied seg_O1_108b_0_60))
                 (at start (not_blocked seg_O1_108b_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_O1_108b_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_O1_108b_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_O1_108b_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_O1_108b_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_O1_108b_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_O1_108b_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_O1_108b_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_O1_108b_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_O1_108b_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_O1_108b_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_O1_108b_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_O1_108b_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_O1_108b_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_O1_108b_0_60 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_p108_0_76)))
                 (at end (not_occupied seg_p108_0_76))
                 (at start (not (at-segment ?a seg_p108_0_76)))

                 (at start (occupied seg_O1_108b_0_60))
                 (at start (not (not_occupied seg_O1_108b_0_60)))
                 (at start (blocked seg_O1_108b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_108b_0_60 ?a)))
                 (at end (at-segment ?a seg_O1_108b_0_60))


                )
)

(:durative-action move_seg_O1_108b_0_60_seg_O1_108a_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_108b_0_60))
                 (at start (not_occupied seg_O1_108a_0_34))
                 (at start (not_blocked seg_O1_108a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_108a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_108a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_108a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_108a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_108a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_108a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_108a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_108a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_108a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_108a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_108a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_108a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_108a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_108a_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_O1_108c_0_34))
                 (over all (not_occupied seg_O1_108d_0_45))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_108b_0_60)))
                 (at end (not_occupied seg_O1_108b_0_60))
                 (at start (not (at-segment ?a seg_O1_108b_0_60)))

                 (at start (occupied seg_O1_108a_0_34))
                 (at start (not (not_occupied seg_O1_108a_0_34)))
                 (at start (blocked seg_O1_108a_0_34 ?a))
                 (at start (not (not_blocked seg_O1_108a_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_108a_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_p108_0_76 ?a)))
                 (at end (not_blocked seg_p108_0_76 ?a))

                 (at start (blocked seg_O1_108c_0_34 ?a))
                 (at start (not (not_blocked seg_O1_108c_0_34 ?a)))
                 (at start (blocked seg_O1_108d_0_45 ?a))
                 (at start (not (not_blocked seg_O1_108d_0_45 ?a)))
                )
)

(:durative-action move_seg_O1_108b_0_60_seg_O1_108c_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_108b_0_60))
                 (at start (not_occupied seg_O1_108c_0_34))
                 (at start (not_blocked seg_O1_108c_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_108c_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_108c_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_108c_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_108c_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_108c_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_108c_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_108c_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_108c_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_108c_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_108c_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_108c_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_108c_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_108c_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_108c_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_O1_108a_0_34))
                 (over all (not_occupied seg_O1_108d_0_45))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_108b_0_60)))
                 (at end (not_occupied seg_O1_108b_0_60))
                 (at start (not (at-segment ?a seg_O1_108b_0_60)))

                 (at start (occupied seg_O1_108c_0_34))
                 (at start (not (not_occupied seg_O1_108c_0_34)))
                 (at start (blocked seg_O1_108c_0_34 ?a))
                 (at start (not (not_blocked seg_O1_108c_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_108c_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_p108_0_76 ?a)))
                 (at end (not_blocked seg_p108_0_76 ?a))

                 (at start (blocked seg_O1_108a_0_34 ?a))
                 (at start (not (not_blocked seg_O1_108a_0_34 ?a)))
                 (at start (blocked seg_O1_108d_0_45 ?a))
                 (at start (not (not_blocked seg_O1_108d_0_45 ?a)))
                )
)

(:durative-action move_seg_O1_108c_0_34_seg_O1_108b_0_60_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_108c_0_34))
                 (at start (not_occupied seg_O1_108b_0_60))
                 (at start (not_blocked seg_O1_108b_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_O1_108b_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_O1_108b_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_O1_108b_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_O1_108b_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_O1_108b_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_O1_108b_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_O1_108b_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_O1_108b_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_O1_108b_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_O1_108b_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_O1_108b_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_O1_108b_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_O1_108b_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_O1_108b_0_60 airplane_CFBE2))

                 (over all (not_occupied seg_O1_108a_0_34))
                 (over all (not_occupied seg_O1_108d_0_45))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_108c_0_34)))
                 (at end (not_occupied seg_O1_108c_0_34))
                 (at start (not (at-segment ?a seg_O1_108c_0_34)))

                 (at start (occupied seg_O1_108b_0_60))
                 (at start (not (not_occupied seg_O1_108b_0_60)))
                 (at start (blocked seg_O1_108b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_108b_0_60 ?a)))
                 (at end (at-segment ?a seg_O1_108b_0_60))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_O1_109a_0_34 ?a)))
                 (at end (not_blocked seg_O1_109a_0_34 ?a))

                 (at start (blocked seg_O1_108a_0_34 ?a))
                 (at start (not (not_blocked seg_O1_108a_0_34 ?a)))
                 (at start (blocked seg_O1_108d_0_45 ?a))
                 (at start (not (not_blocked seg_O1_108d_0_45 ?a)))
                )
)

(:durative-action move_seg_O1_108b_0_60_seg_p108_0_76_south_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_O1_108b_0_60))
                 (at start (not_occupied seg_p108_0_76))
                 (at start (not_blocked seg_p108_0_76 airplane_CFBEG))
                 (at start (not_blocked seg_p108_0_76 airplane_CFBE1))
                 (at start (not_blocked seg_p108_0_76 airplane_CFBE3))
                 (at start (not_blocked seg_p108_0_76 airplane_DAEW8))
                 (at start (not_blocked seg_p108_0_76 airplane_DAEW9))
                 (at start (not_blocked seg_p108_0_76 airplane_DAEW0))
                 (at start (not_blocked seg_p108_0_76 airplane_DAEW3))
                 (at start (not_blocked seg_p108_0_76 airplane_DAEWH))
                 (at start (not_blocked seg_p108_0_76 airplane_DAEW1))
                 (at start (not_blocked seg_p108_0_76 airplane_DAEW2))
                 (at start (not_blocked seg_p108_0_76 airplane_DAEW4))
                 (at start (not_blocked seg_p108_0_76 airplane_DAEW5))
                 (at start (not_blocked seg_p108_0_76 airplane_DAEW6))
                 (at start (not_blocked seg_p108_0_76 airplane_DAEW7))
                 (at start (not_blocked seg_p108_0_76 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_O1_108b_0_60)))
                 (at end (not_occupied seg_O1_108b_0_60))
                 (at start (not (at-segment ?a seg_O1_108b_0_60)))

                 (at start (occupied seg_p108_0_76))
                 (at start (not (not_occupied seg_p108_0_76)))
                 (at start (blocked seg_p108_0_76 ?a))
                 (at start (not (not_blocked seg_p108_0_76 ?a)))
                 (at end (at-segment ?a seg_p108_0_76))

                 (at end (not (blocked seg_O1_108a_0_34 ?a)))
                 (at end (not_blocked seg_O1_108a_0_34 ?a))
                 (at end (not (blocked seg_O1_108c_0_34 ?a)))
                 (at end (not_blocked seg_O1_108c_0_34 ?a))
                 (at end (not (blocked seg_O1_108d_0_45 ?a)))
                 (at end (not_blocked seg_O1_108d_0_45 ?a))

                )
)

(:durative-action move_seg_O1_108a_0_34_seg_O1_108b_0_60_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_108a_0_34))
                 (at start (not_occupied seg_O1_108b_0_60))
                 (at start (not_blocked seg_O1_108b_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_O1_108b_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_O1_108b_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_O1_108b_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_O1_108b_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_O1_108b_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_O1_108b_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_O1_108b_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_O1_108b_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_O1_108b_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_O1_108b_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_O1_108b_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_O1_108b_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_O1_108b_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_O1_108b_0_60 airplane_CFBE2))

                 (over all (not_occupied seg_O1_108c_0_34))
                 (over all (not_occupied seg_O1_108d_0_45))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_108a_0_34)))
                 (at end (not_occupied seg_O1_108a_0_34))
                 (at start (not (at-segment ?a seg_O1_108a_0_34)))

                 (at start (occupied seg_O1_108b_0_60))
                 (at start (not (not_occupied seg_O1_108b_0_60)))
                 (at start (blocked seg_O1_108b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_108b_0_60 ?a)))
                 (at end (at-segment ?a seg_O1_108b_0_60))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_O1_C2c_0_34 ?a)))
                 (at end (not_blocked seg_O1_C2c_0_34 ?a))

                 (at start (blocked seg_O1_108c_0_34 ?a))
                 (at start (not (not_blocked seg_O1_108c_0_34 ?a)))
                 (at start (blocked seg_O1_108d_0_45 ?a))
                 (at start (not (not_blocked seg_O1_108d_0_45 ?a)))
                )
)

(:durative-action move_seg_p131_0_75_seg_O1_108d_0_45_north_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_p131_0_75))
                 (at start (not_occupied seg_O1_108d_0_45))
                 (at start (not_blocked seg_O1_108d_0_45 airplane_CFBEG))
                 (at start (not_blocked seg_O1_108d_0_45 airplane_CFBE1))
                 (at start (not_blocked seg_O1_108d_0_45 airplane_CFBE3))
                 (at start (not_blocked seg_O1_108d_0_45 airplane_DAEW8))
                 (at start (not_blocked seg_O1_108d_0_45 airplane_DAEW9))
                 (at start (not_blocked seg_O1_108d_0_45 airplane_DAEW0))
                 (at start (not_blocked seg_O1_108d_0_45 airplane_DAEW3))
                 (at start (not_blocked seg_O1_108d_0_45 airplane_DAEWH))
                 (at start (not_blocked seg_O1_108d_0_45 airplane_DAEW1))
                 (at start (not_blocked seg_O1_108d_0_45 airplane_DAEW2))
                 (at start (not_blocked seg_O1_108d_0_45 airplane_DAEW4))
                 (at start (not_blocked seg_O1_108d_0_45 airplane_DAEW5))
                 (at start (not_blocked seg_O1_108d_0_45 airplane_DAEW6))
                 (at start (not_blocked seg_O1_108d_0_45 airplane_DAEW7))
                 (at start (not_blocked seg_O1_108d_0_45 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_p131_0_75)))
                 (at end (not_occupied seg_p131_0_75))
                 (at start (not (at-segment ?a seg_p131_0_75)))

                 (at start (occupied seg_O1_108d_0_45))
                 (at start (not (not_occupied seg_O1_108d_0_45)))
                 (at start (blocked seg_O1_108d_0_45 ?a))
                 (at start (not (not_blocked seg_O1_108d_0_45 ?a)))
                 (at end (at-segment ?a seg_O1_108d_0_45))


                )
)

(:durative-action move_seg_O1_108d_0_45_seg_O1_108a_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_108d_0_45))
                 (at start (not_occupied seg_O1_108a_0_34))
                 (at start (not_blocked seg_O1_108a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_108a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_108a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_108a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_108a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_108a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_108a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_108a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_108a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_108a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_108a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_108a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_108a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_108a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_108a_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_O1_108b_0_60))
                 (over all (not_occupied seg_O1_108c_0_34))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_108d_0_45)))
                 (at end (not_occupied seg_O1_108d_0_45))
                 (at start (not (at-segment ?a seg_O1_108d_0_45)))

                 (at start (occupied seg_O1_108a_0_34))
                 (at start (not (not_occupied seg_O1_108a_0_34)))
                 (at start (blocked seg_O1_108a_0_34 ?a))
                 (at start (not (not_blocked seg_O1_108a_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_108a_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_p131_0_75 ?a)))
                 (at end (not_blocked seg_p131_0_75 ?a))

                 (at start (blocked seg_O1_108b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_108b_0_60 ?a)))
                 (at start (blocked seg_O1_108c_0_34 ?a))
                 (at start (not (not_blocked seg_O1_108c_0_34 ?a)))
                )
)

(:durative-action move_seg_O1_108d_0_45_seg_O1_108c_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_108d_0_45))
                 (at start (not_occupied seg_O1_108c_0_34))
                 (at start (not_blocked seg_O1_108c_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_108c_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_108c_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_108c_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_108c_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_108c_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_108c_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_108c_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_108c_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_108c_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_108c_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_108c_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_108c_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_108c_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_108c_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_O1_108a_0_34))
                 (over all (not_occupied seg_O1_108b_0_60))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_108d_0_45)))
                 (at end (not_occupied seg_O1_108d_0_45))
                 (at start (not (at-segment ?a seg_O1_108d_0_45)))

                 (at start (occupied seg_O1_108c_0_34))
                 (at start (not (not_occupied seg_O1_108c_0_34)))
                 (at start (blocked seg_O1_108c_0_34 ?a))
                 (at start (not (not_blocked seg_O1_108c_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_108c_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_p131_0_75 ?a)))
                 (at end (not_blocked seg_p131_0_75 ?a))

                 (at start (blocked seg_O1_108a_0_34 ?a))
                 (at start (not (not_blocked seg_O1_108a_0_34 ?a)))
                 (at start (blocked seg_O1_108b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_108b_0_60 ?a)))
                )
)

(:durative-action move_seg_O1_108c_0_34_seg_O1_108d_0_45_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_108c_0_34))
                 (at start (not_occupied seg_O1_108d_0_45))
                 (at start (not_blocked seg_O1_108d_0_45 airplane_CFBEG))
                 (at start (not_blocked seg_O1_108d_0_45 airplane_CFBE1))
                 (at start (not_blocked seg_O1_108d_0_45 airplane_CFBE3))
                 (at start (not_blocked seg_O1_108d_0_45 airplane_DAEW8))
                 (at start (not_blocked seg_O1_108d_0_45 airplane_DAEW9))
                 (at start (not_blocked seg_O1_108d_0_45 airplane_DAEW0))
                 (at start (not_blocked seg_O1_108d_0_45 airplane_DAEW3))
                 (at start (not_blocked seg_O1_108d_0_45 airplane_DAEWH))
                 (at start (not_blocked seg_O1_108d_0_45 airplane_DAEW1))
                 (at start (not_blocked seg_O1_108d_0_45 airplane_DAEW2))
                 (at start (not_blocked seg_O1_108d_0_45 airplane_DAEW4))
                 (at start (not_blocked seg_O1_108d_0_45 airplane_DAEW5))
                 (at start (not_blocked seg_O1_108d_0_45 airplane_DAEW6))
                 (at start (not_blocked seg_O1_108d_0_45 airplane_DAEW7))
                 (at start (not_blocked seg_O1_108d_0_45 airplane_CFBE2))

                 (over all (not_occupied seg_O1_108a_0_34))
                 (over all (not_occupied seg_O1_108b_0_60))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_108c_0_34)))
                 (at end (not_occupied seg_O1_108c_0_34))
                 (at start (not (at-segment ?a seg_O1_108c_0_34)))

                 (at start (occupied seg_O1_108d_0_45))
                 (at start (not (not_occupied seg_O1_108d_0_45)))
                 (at start (blocked seg_O1_108d_0_45 ?a))
                 (at start (not (not_blocked seg_O1_108d_0_45 ?a)))
                 (at end (at-segment ?a seg_O1_108d_0_45))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_O1_109a_0_34 ?a)))
                 (at end (not_blocked seg_O1_109a_0_34 ?a))

                 (at start (blocked seg_O1_108a_0_34 ?a))
                 (at start (not (not_blocked seg_O1_108a_0_34 ?a)))
                 (at start (blocked seg_O1_108b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_108b_0_60 ?a)))
                )
)

(:durative-action move_seg_O1_108d_0_45_seg_p131_0_75_south_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_O1_108d_0_45))
                 (at start (not_occupied seg_p131_0_75))
                 (at start (not_blocked seg_p131_0_75 airplane_CFBEG))
                 (at start (not_blocked seg_p131_0_75 airplane_CFBE1))
                 (at start (not_blocked seg_p131_0_75 airplane_CFBE3))
                 (at start (not_blocked seg_p131_0_75 airplane_DAEW8))
                 (at start (not_blocked seg_p131_0_75 airplane_DAEW9))
                 (at start (not_blocked seg_p131_0_75 airplane_DAEW0))
                 (at start (not_blocked seg_p131_0_75 airplane_DAEW3))
                 (at start (not_blocked seg_p131_0_75 airplane_DAEWH))
                 (at start (not_blocked seg_p131_0_75 airplane_DAEW1))
                 (at start (not_blocked seg_p131_0_75 airplane_DAEW2))
                 (at start (not_blocked seg_p131_0_75 airplane_DAEW4))
                 (at start (not_blocked seg_p131_0_75 airplane_DAEW5))
                 (at start (not_blocked seg_p131_0_75 airplane_DAEW6))
                 (at start (not_blocked seg_p131_0_75 airplane_DAEW7))
                 (at start (not_blocked seg_p131_0_75 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_O1_108d_0_45)))
                 (at end (not_occupied seg_O1_108d_0_45))
                 (at start (not (at-segment ?a seg_O1_108d_0_45)))

                 (at start (occupied seg_p131_0_75))
                 (at start (not (not_occupied seg_p131_0_75)))
                 (at start (blocked seg_p131_0_75 ?a))
                 (at start (not (not_blocked seg_p131_0_75 ?a)))
                 (at end (at-segment ?a seg_p131_0_75))

                 (at end (not (blocked seg_O1_108a_0_34 ?a)))
                 (at end (not_blocked seg_O1_108a_0_34 ?a))
                 (at end (not (blocked seg_O1_108b_0_60 ?a)))
                 (at end (not_blocked seg_O1_108b_0_60 ?a))
                 (at end (not (blocked seg_O1_108c_0_34 ?a)))
                 (at end (not_blocked seg_O1_108c_0_34 ?a))

                )
)

(:durative-action move_seg_O1_108a_0_34_seg_O1_108d_0_45_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_108a_0_34))
                 (at start (not_occupied seg_O1_108d_0_45))
                 (at start (not_blocked seg_O1_108d_0_45 airplane_CFBEG))
                 (at start (not_blocked seg_O1_108d_0_45 airplane_CFBE1))
                 (at start (not_blocked seg_O1_108d_0_45 airplane_CFBE3))
                 (at start (not_blocked seg_O1_108d_0_45 airplane_DAEW8))
                 (at start (not_blocked seg_O1_108d_0_45 airplane_DAEW9))
                 (at start (not_blocked seg_O1_108d_0_45 airplane_DAEW0))
                 (at start (not_blocked seg_O1_108d_0_45 airplane_DAEW3))
                 (at start (not_blocked seg_O1_108d_0_45 airplane_DAEWH))
                 (at start (not_blocked seg_O1_108d_0_45 airplane_DAEW1))
                 (at start (not_blocked seg_O1_108d_0_45 airplane_DAEW2))
                 (at start (not_blocked seg_O1_108d_0_45 airplane_DAEW4))
                 (at start (not_blocked seg_O1_108d_0_45 airplane_DAEW5))
                 (at start (not_blocked seg_O1_108d_0_45 airplane_DAEW6))
                 (at start (not_blocked seg_O1_108d_0_45 airplane_DAEW7))
                 (at start (not_blocked seg_O1_108d_0_45 airplane_CFBE2))

                 (over all (not_occupied seg_O1_108b_0_60))
                 (over all (not_occupied seg_O1_108c_0_34))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_108a_0_34)))
                 (at end (not_occupied seg_O1_108a_0_34))
                 (at start (not (at-segment ?a seg_O1_108a_0_34)))

                 (at start (occupied seg_O1_108d_0_45))
                 (at start (not (not_occupied seg_O1_108d_0_45)))
                 (at start (blocked seg_O1_108d_0_45 ?a))
                 (at start (not (not_blocked seg_O1_108d_0_45 ?a)))
                 (at end (at-segment ?a seg_O1_108d_0_45))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_O1_C2c_0_34 ?a)))
                 (at end (not_blocked seg_O1_C2c_0_34 ?a))

                 (at start (blocked seg_O1_108b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_108b_0_60 ?a)))
                 (at start (blocked seg_O1_108c_0_34 ?a))
                 (at start (not (not_blocked seg_O1_108c_0_34 ?a)))
                )
)

(:durative-action move_seg_p109_0_76_seg_O1_109b_0_60_north_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_p109_0_76))
                 (at start (not_occupied seg_O1_109b_0_60))
                 (at start (not_blocked seg_O1_109b_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_O1_109b_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_O1_109b_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_O1_109b_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_O1_109b_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_O1_109b_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_O1_109b_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_O1_109b_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_O1_109b_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_O1_109b_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_O1_109b_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_O1_109b_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_O1_109b_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_O1_109b_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_O1_109b_0_60 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_p109_0_76)))
                 (at end (not_occupied seg_p109_0_76))
                 (at start (not (at-segment ?a seg_p109_0_76)))

                 (at start (occupied seg_O1_109b_0_60))
                 (at start (not (not_occupied seg_O1_109b_0_60)))
                 (at start (blocked seg_O1_109b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_109b_0_60 ?a)))
                 (at end (at-segment ?a seg_O1_109b_0_60))


                )
)

(:durative-action move_seg_O1_109b_0_60_seg_O1_109a_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_109b_0_60))
                 (at start (not_occupied seg_O1_109a_0_34))
                 (at start (not_blocked seg_O1_109a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_109a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_109a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_109a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_109a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_109a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_109a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_109a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_109a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_109a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_109a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_109a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_109a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_109a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_109a_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_O1_109c_0_34))
                 (over all (not_occupied seg_O1_109d_0_45))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_109b_0_60)))
                 (at end (not_occupied seg_O1_109b_0_60))
                 (at start (not (at-segment ?a seg_O1_109b_0_60)))

                 (at start (occupied seg_O1_109a_0_34))
                 (at start (not (not_occupied seg_O1_109a_0_34)))
                 (at start (blocked seg_O1_109a_0_34 ?a))
                 (at start (not (not_blocked seg_O1_109a_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_109a_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_p109_0_76 ?a)))
                 (at end (not_blocked seg_p109_0_76 ?a))

                 (at start (blocked seg_O1_109c_0_34 ?a))
                 (at start (not (not_blocked seg_O1_109c_0_34 ?a)))
                 (at start (blocked seg_O1_109d_0_45 ?a))
                 (at start (not (not_blocked seg_O1_109d_0_45 ?a)))
                )
)

(:durative-action move_seg_O1_109b_0_60_seg_O1_109c_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_109b_0_60))
                 (at start (not_occupied seg_O1_109c_0_34))
                 (at start (not_blocked seg_O1_109c_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_109c_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_109c_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_109c_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_109c_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_109c_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_109c_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_109c_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_109c_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_109c_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_109c_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_109c_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_109c_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_109c_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_109c_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_O1_109a_0_34))
                 (over all (not_occupied seg_O1_109d_0_45))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_109b_0_60)))
                 (at end (not_occupied seg_O1_109b_0_60))
                 (at start (not (at-segment ?a seg_O1_109b_0_60)))

                 (at start (occupied seg_O1_109c_0_34))
                 (at start (not (not_occupied seg_O1_109c_0_34)))
                 (at start (blocked seg_O1_109c_0_34 ?a))
                 (at start (not (not_blocked seg_O1_109c_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_109c_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_p109_0_76 ?a)))
                 (at end (not_blocked seg_p109_0_76 ?a))

                 (at start (blocked seg_O1_109a_0_34 ?a))
                 (at start (not (not_blocked seg_O1_109a_0_34 ?a)))
                 (at start (blocked seg_O1_109d_0_45 ?a))
                 (at start (not (not_blocked seg_O1_109d_0_45 ?a)))
                )
)

(:durative-action move_seg_O1_109c_0_34_seg_O1_109b_0_60_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_109c_0_34))
                 (at start (not_occupied seg_O1_109b_0_60))
                 (at start (not_blocked seg_O1_109b_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_O1_109b_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_O1_109b_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_O1_109b_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_O1_109b_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_O1_109b_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_O1_109b_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_O1_109b_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_O1_109b_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_O1_109b_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_O1_109b_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_O1_109b_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_O1_109b_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_O1_109b_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_O1_109b_0_60 airplane_CFBE2))

                 (over all (not_occupied seg_O1_109a_0_34))
                 (over all (not_occupied seg_O1_109d_0_45))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_109c_0_34)))
                 (at end (not_occupied seg_O1_109c_0_34))
                 (at start (not (at-segment ?a seg_O1_109c_0_34)))

                 (at start (occupied seg_O1_109b_0_60))
                 (at start (not (not_occupied seg_O1_109b_0_60)))
                 (at start (blocked seg_O1_109b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_109b_0_60 ?a)))
                 (at end (at-segment ?a seg_O1_109b_0_60))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_O1_110a_0_34 ?a)))
                 (at end (not_blocked seg_O1_110a_0_34 ?a))

                 (at start (blocked seg_O1_109a_0_34 ?a))
                 (at start (not (not_blocked seg_O1_109a_0_34 ?a)))
                 (at start (blocked seg_O1_109d_0_45 ?a))
                 (at start (not (not_blocked seg_O1_109d_0_45 ?a)))
                )
)

(:durative-action move_seg_O1_109b_0_60_seg_p109_0_76_south_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_O1_109b_0_60))
                 (at start (not_occupied seg_p109_0_76))
                 (at start (not_blocked seg_p109_0_76 airplane_CFBEG))
                 (at start (not_blocked seg_p109_0_76 airplane_CFBE1))
                 (at start (not_blocked seg_p109_0_76 airplane_CFBE3))
                 (at start (not_blocked seg_p109_0_76 airplane_DAEW8))
                 (at start (not_blocked seg_p109_0_76 airplane_DAEW9))
                 (at start (not_blocked seg_p109_0_76 airplane_DAEW0))
                 (at start (not_blocked seg_p109_0_76 airplane_DAEW3))
                 (at start (not_blocked seg_p109_0_76 airplane_DAEWH))
                 (at start (not_blocked seg_p109_0_76 airplane_DAEW1))
                 (at start (not_blocked seg_p109_0_76 airplane_DAEW2))
                 (at start (not_blocked seg_p109_0_76 airplane_DAEW4))
                 (at start (not_blocked seg_p109_0_76 airplane_DAEW5))
                 (at start (not_blocked seg_p109_0_76 airplane_DAEW6))
                 (at start (not_blocked seg_p109_0_76 airplane_DAEW7))
                 (at start (not_blocked seg_p109_0_76 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_O1_109b_0_60)))
                 (at end (not_occupied seg_O1_109b_0_60))
                 (at start (not (at-segment ?a seg_O1_109b_0_60)))

                 (at start (occupied seg_p109_0_76))
                 (at start (not (not_occupied seg_p109_0_76)))
                 (at start (blocked seg_p109_0_76 ?a))
                 (at start (not (not_blocked seg_p109_0_76 ?a)))
                 (at end (at-segment ?a seg_p109_0_76))

                 (at end (not (blocked seg_O1_109a_0_34 ?a)))
                 (at end (not_blocked seg_O1_109a_0_34 ?a))
                 (at end (not (blocked seg_O1_109c_0_34 ?a)))
                 (at end (not_blocked seg_O1_109c_0_34 ?a))
                 (at end (not (blocked seg_O1_109d_0_45 ?a)))
                 (at end (not_blocked seg_O1_109d_0_45 ?a))

                )
)

(:durative-action move_seg_O1_109a_0_34_seg_O1_109b_0_60_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_109a_0_34))
                 (at start (not_occupied seg_O1_109b_0_60))
                 (at start (not_blocked seg_O1_109b_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_O1_109b_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_O1_109b_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_O1_109b_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_O1_109b_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_O1_109b_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_O1_109b_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_O1_109b_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_O1_109b_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_O1_109b_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_O1_109b_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_O1_109b_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_O1_109b_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_O1_109b_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_O1_109b_0_60 airplane_CFBE2))

                 (over all (not_occupied seg_O1_109c_0_34))
                 (over all (not_occupied seg_O1_109d_0_45))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_109a_0_34)))
                 (at end (not_occupied seg_O1_109a_0_34))
                 (at start (not (at-segment ?a seg_O1_109a_0_34)))

                 (at start (occupied seg_O1_109b_0_60))
                 (at start (not (not_occupied seg_O1_109b_0_60)))
                 (at start (blocked seg_O1_109b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_109b_0_60 ?a)))
                 (at end (at-segment ?a seg_O1_109b_0_60))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_O1_108c_0_34 ?a)))
                 (at end (not_blocked seg_O1_108c_0_34 ?a))

                 (at start (blocked seg_O1_109c_0_34 ?a))
                 (at start (not (not_blocked seg_O1_109c_0_34 ?a)))
                 (at start (blocked seg_O1_109d_0_45 ?a))
                 (at start (not (not_blocked seg_O1_109d_0_45 ?a)))
                )
)

(:durative-action move_seg_p132_0_75_seg_O1_109d_0_45_north_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_p132_0_75))
                 (at start (not_occupied seg_O1_109d_0_45))
                 (at start (not_blocked seg_O1_109d_0_45 airplane_CFBEG))
                 (at start (not_blocked seg_O1_109d_0_45 airplane_CFBE1))
                 (at start (not_blocked seg_O1_109d_0_45 airplane_CFBE3))
                 (at start (not_blocked seg_O1_109d_0_45 airplane_DAEW8))
                 (at start (not_blocked seg_O1_109d_0_45 airplane_DAEW9))
                 (at start (not_blocked seg_O1_109d_0_45 airplane_DAEW0))
                 (at start (not_blocked seg_O1_109d_0_45 airplane_DAEW3))
                 (at start (not_blocked seg_O1_109d_0_45 airplane_DAEWH))
                 (at start (not_blocked seg_O1_109d_0_45 airplane_DAEW1))
                 (at start (not_blocked seg_O1_109d_0_45 airplane_DAEW2))
                 (at start (not_blocked seg_O1_109d_0_45 airplane_DAEW4))
                 (at start (not_blocked seg_O1_109d_0_45 airplane_DAEW5))
                 (at start (not_blocked seg_O1_109d_0_45 airplane_DAEW6))
                 (at start (not_blocked seg_O1_109d_0_45 airplane_DAEW7))
                 (at start (not_blocked seg_O1_109d_0_45 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_p132_0_75)))
                 (at end (not_occupied seg_p132_0_75))
                 (at start (not (at-segment ?a seg_p132_0_75)))

                 (at start (occupied seg_O1_109d_0_45))
                 (at start (not (not_occupied seg_O1_109d_0_45)))
                 (at start (blocked seg_O1_109d_0_45 ?a))
                 (at start (not (not_blocked seg_O1_109d_0_45 ?a)))
                 (at end (at-segment ?a seg_O1_109d_0_45))


                )
)

(:durative-action move_seg_O1_109d_0_45_seg_O1_109a_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_109d_0_45))
                 (at start (not_occupied seg_O1_109a_0_34))
                 (at start (not_blocked seg_O1_109a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_109a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_109a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_109a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_109a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_109a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_109a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_109a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_109a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_109a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_109a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_109a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_109a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_109a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_109a_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_O1_109b_0_60))
                 (over all (not_occupied seg_O1_109c_0_34))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_109d_0_45)))
                 (at end (not_occupied seg_O1_109d_0_45))
                 (at start (not (at-segment ?a seg_O1_109d_0_45)))

                 (at start (occupied seg_O1_109a_0_34))
                 (at start (not (not_occupied seg_O1_109a_0_34)))
                 (at start (blocked seg_O1_109a_0_34 ?a))
                 (at start (not (not_blocked seg_O1_109a_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_109a_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_p132_0_75 ?a)))
                 (at end (not_blocked seg_p132_0_75 ?a))

                 (at start (blocked seg_O1_109b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_109b_0_60 ?a)))
                 (at start (blocked seg_O1_109c_0_34 ?a))
                 (at start (not (not_blocked seg_O1_109c_0_34 ?a)))
                )
)

(:durative-action move_seg_O1_109d_0_45_seg_O1_109c_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_109d_0_45))
                 (at start (not_occupied seg_O1_109c_0_34))
                 (at start (not_blocked seg_O1_109c_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_109c_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_109c_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_109c_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_109c_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_109c_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_109c_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_109c_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_109c_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_109c_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_109c_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_109c_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_109c_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_109c_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_109c_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_O1_109a_0_34))
                 (over all (not_occupied seg_O1_109b_0_60))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_109d_0_45)))
                 (at end (not_occupied seg_O1_109d_0_45))
                 (at start (not (at-segment ?a seg_O1_109d_0_45)))

                 (at start (occupied seg_O1_109c_0_34))
                 (at start (not (not_occupied seg_O1_109c_0_34)))
                 (at start (blocked seg_O1_109c_0_34 ?a))
                 (at start (not (not_blocked seg_O1_109c_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_109c_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_p132_0_75 ?a)))
                 (at end (not_blocked seg_p132_0_75 ?a))

                 (at start (blocked seg_O1_109a_0_34 ?a))
                 (at start (not (not_blocked seg_O1_109a_0_34 ?a)))
                 (at start (blocked seg_O1_109b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_109b_0_60 ?a)))
                )
)

(:durative-action move_seg_O1_109c_0_34_seg_O1_109d_0_45_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_109c_0_34))
                 (at start (not_occupied seg_O1_109d_0_45))
                 (at start (not_blocked seg_O1_109d_0_45 airplane_CFBEG))
                 (at start (not_blocked seg_O1_109d_0_45 airplane_CFBE1))
                 (at start (not_blocked seg_O1_109d_0_45 airplane_CFBE3))
                 (at start (not_blocked seg_O1_109d_0_45 airplane_DAEW8))
                 (at start (not_blocked seg_O1_109d_0_45 airplane_DAEW9))
                 (at start (not_blocked seg_O1_109d_0_45 airplane_DAEW0))
                 (at start (not_blocked seg_O1_109d_0_45 airplane_DAEW3))
                 (at start (not_blocked seg_O1_109d_0_45 airplane_DAEWH))
                 (at start (not_blocked seg_O1_109d_0_45 airplane_DAEW1))
                 (at start (not_blocked seg_O1_109d_0_45 airplane_DAEW2))
                 (at start (not_blocked seg_O1_109d_0_45 airplane_DAEW4))
                 (at start (not_blocked seg_O1_109d_0_45 airplane_DAEW5))
                 (at start (not_blocked seg_O1_109d_0_45 airplane_DAEW6))
                 (at start (not_blocked seg_O1_109d_0_45 airplane_DAEW7))
                 (at start (not_blocked seg_O1_109d_0_45 airplane_CFBE2))

                 (over all (not_occupied seg_O1_109a_0_34))
                 (over all (not_occupied seg_O1_109b_0_60))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_109c_0_34)))
                 (at end (not_occupied seg_O1_109c_0_34))
                 (at start (not (at-segment ?a seg_O1_109c_0_34)))

                 (at start (occupied seg_O1_109d_0_45))
                 (at start (not (not_occupied seg_O1_109d_0_45)))
                 (at start (blocked seg_O1_109d_0_45 ?a))
                 (at start (not (not_blocked seg_O1_109d_0_45 ?a)))
                 (at end (at-segment ?a seg_O1_109d_0_45))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_O1_110a_0_34 ?a)))
                 (at end (not_blocked seg_O1_110a_0_34 ?a))

                 (at start (blocked seg_O1_109a_0_34 ?a))
                 (at start (not (not_blocked seg_O1_109a_0_34 ?a)))
                 (at start (blocked seg_O1_109b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_109b_0_60 ?a)))
                )
)

(:durative-action move_seg_O1_109d_0_45_seg_p132_0_75_south_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_O1_109d_0_45))
                 (at start (not_occupied seg_p132_0_75))
                 (at start (not_blocked seg_p132_0_75 airplane_CFBEG))
                 (at start (not_blocked seg_p132_0_75 airplane_CFBE1))
                 (at start (not_blocked seg_p132_0_75 airplane_CFBE3))
                 (at start (not_blocked seg_p132_0_75 airplane_DAEW8))
                 (at start (not_blocked seg_p132_0_75 airplane_DAEW9))
                 (at start (not_blocked seg_p132_0_75 airplane_DAEW0))
                 (at start (not_blocked seg_p132_0_75 airplane_DAEW3))
                 (at start (not_blocked seg_p132_0_75 airplane_DAEWH))
                 (at start (not_blocked seg_p132_0_75 airplane_DAEW1))
                 (at start (not_blocked seg_p132_0_75 airplane_DAEW2))
                 (at start (not_blocked seg_p132_0_75 airplane_DAEW4))
                 (at start (not_blocked seg_p132_0_75 airplane_DAEW5))
                 (at start (not_blocked seg_p132_0_75 airplane_DAEW6))
                 (at start (not_blocked seg_p132_0_75 airplane_DAEW7))
                 (at start (not_blocked seg_p132_0_75 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_O1_109d_0_45)))
                 (at end (not_occupied seg_O1_109d_0_45))
                 (at start (not (at-segment ?a seg_O1_109d_0_45)))

                 (at start (occupied seg_p132_0_75))
                 (at start (not (not_occupied seg_p132_0_75)))
                 (at start (blocked seg_p132_0_75 ?a))
                 (at start (not (not_blocked seg_p132_0_75 ?a)))
                 (at end (at-segment ?a seg_p132_0_75))

                 (at end (not (blocked seg_O1_109a_0_34 ?a)))
                 (at end (not_blocked seg_O1_109a_0_34 ?a))
                 (at end (not (blocked seg_O1_109b_0_60 ?a)))
                 (at end (not_blocked seg_O1_109b_0_60 ?a))
                 (at end (not (blocked seg_O1_109c_0_34 ?a)))
                 (at end (not_blocked seg_O1_109c_0_34 ?a))

                )
)

(:durative-action move_seg_O1_109a_0_34_seg_O1_109d_0_45_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_109a_0_34))
                 (at start (not_occupied seg_O1_109d_0_45))
                 (at start (not_blocked seg_O1_109d_0_45 airplane_CFBEG))
                 (at start (not_blocked seg_O1_109d_0_45 airplane_CFBE1))
                 (at start (not_blocked seg_O1_109d_0_45 airplane_CFBE3))
                 (at start (not_blocked seg_O1_109d_0_45 airplane_DAEW8))
                 (at start (not_blocked seg_O1_109d_0_45 airplane_DAEW9))
                 (at start (not_blocked seg_O1_109d_0_45 airplane_DAEW0))
                 (at start (not_blocked seg_O1_109d_0_45 airplane_DAEW3))
                 (at start (not_blocked seg_O1_109d_0_45 airplane_DAEWH))
                 (at start (not_blocked seg_O1_109d_0_45 airplane_DAEW1))
                 (at start (not_blocked seg_O1_109d_0_45 airplane_DAEW2))
                 (at start (not_blocked seg_O1_109d_0_45 airplane_DAEW4))
                 (at start (not_blocked seg_O1_109d_0_45 airplane_DAEW5))
                 (at start (not_blocked seg_O1_109d_0_45 airplane_DAEW6))
                 (at start (not_blocked seg_O1_109d_0_45 airplane_DAEW7))
                 (at start (not_blocked seg_O1_109d_0_45 airplane_CFBE2))

                 (over all (not_occupied seg_O1_109b_0_60))
                 (over all (not_occupied seg_O1_109c_0_34))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_109a_0_34)))
                 (at end (not_occupied seg_O1_109a_0_34))
                 (at start (not (at-segment ?a seg_O1_109a_0_34)))

                 (at start (occupied seg_O1_109d_0_45))
                 (at start (not (not_occupied seg_O1_109d_0_45)))
                 (at start (blocked seg_O1_109d_0_45 ?a))
                 (at start (not (not_blocked seg_O1_109d_0_45 ?a)))
                 (at end (at-segment ?a seg_O1_109d_0_45))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_O1_108c_0_34 ?a)))
                 (at end (not_blocked seg_O1_108c_0_34 ?a))

                 (at start (blocked seg_O1_109b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_109b_0_60 ?a)))
                 (at start (blocked seg_O1_109c_0_34 ?a))
                 (at start (not (not_blocked seg_O1_109c_0_34 ?a)))
                )
)

(:durative-action move_seg_p110_0_76_seg_O1_110b_0_60_north_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_p110_0_76))
                 (at start (not_occupied seg_O1_110b_0_60))
                 (at start (not_blocked seg_O1_110b_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_O1_110b_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_O1_110b_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_O1_110b_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_O1_110b_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_O1_110b_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_O1_110b_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_O1_110b_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_O1_110b_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_O1_110b_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_O1_110b_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_O1_110b_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_O1_110b_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_O1_110b_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_O1_110b_0_60 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_p110_0_76)))
                 (at end (not_occupied seg_p110_0_76))
                 (at start (not (at-segment ?a seg_p110_0_76)))

                 (at start (occupied seg_O1_110b_0_60))
                 (at start (not (not_occupied seg_O1_110b_0_60)))
                 (at start (blocked seg_O1_110b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_110b_0_60 ?a)))
                 (at end (at-segment ?a seg_O1_110b_0_60))


                )
)

(:durative-action move_seg_O1_110b_0_60_seg_O1_110a_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_110b_0_60))
                 (at start (not_occupied seg_O1_110a_0_34))
                 (at start (not_blocked seg_O1_110a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_110a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_110a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_110a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_110a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_110a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_110a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_110a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_110a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_110a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_110a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_110a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_110a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_110a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_110a_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_O1_110c_0_34))
                 (over all (not_occupied seg_O1_110d_0_45))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_110b_0_60)))
                 (at end (not_occupied seg_O1_110b_0_60))
                 (at start (not (at-segment ?a seg_O1_110b_0_60)))

                 (at start (occupied seg_O1_110a_0_34))
                 (at start (not (not_occupied seg_O1_110a_0_34)))
                 (at start (blocked seg_O1_110a_0_34 ?a))
                 (at start (not (not_blocked seg_O1_110a_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_110a_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_p110_0_76 ?a)))
                 (at end (not_blocked seg_p110_0_76 ?a))

                 (at start (blocked seg_O1_110c_0_34 ?a))
                 (at start (not (not_blocked seg_O1_110c_0_34 ?a)))
                 (at start (blocked seg_O1_110d_0_45 ?a))
                 (at start (not (not_blocked seg_O1_110d_0_45 ?a)))
                )
)

(:durative-action move_seg_O1_110b_0_60_seg_O1_110c_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_110b_0_60))
                 (at start (not_occupied seg_O1_110c_0_34))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_O1_110a_0_34))
                 (over all (not_occupied seg_O1_110d_0_45))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_110b_0_60)))
                 (at end (not_occupied seg_O1_110b_0_60))
                 (at start (not (at-segment ?a seg_O1_110b_0_60)))

                 (at start (occupied seg_O1_110c_0_34))
                 (at start (not (not_occupied seg_O1_110c_0_34)))
                 (at start (blocked seg_O1_110c_0_34 ?a))
                 (at start (not (not_blocked seg_O1_110c_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_110c_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_p110_0_76 ?a)))
                 (at end (not_blocked seg_p110_0_76 ?a))

                 (at start (blocked seg_O1_110a_0_34 ?a))
                 (at start (not (not_blocked seg_O1_110a_0_34 ?a)))
                 (at start (blocked seg_O1_110d_0_45 ?a))
                 (at start (not (not_blocked seg_O1_110d_0_45 ?a)))
                )
)

(:durative-action move_seg_O1_110c_0_34_seg_O1_110b_0_60_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_110c_0_34))
                 (at start (not_occupied seg_O1_110b_0_60))
                 (at start (not_blocked seg_O1_110b_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_O1_110b_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_O1_110b_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_O1_110b_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_O1_110b_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_O1_110b_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_O1_110b_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_O1_110b_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_O1_110b_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_O1_110b_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_O1_110b_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_O1_110b_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_O1_110b_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_O1_110b_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_O1_110b_0_60 airplane_CFBE2))

                 (over all (not_occupied seg_O1_110a_0_34))
                 (over all (not_occupied seg_O1_110d_0_45))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_110c_0_34)))
                 (at end (not_occupied seg_O1_110c_0_34))
                 (at start (not (at-segment ?a seg_O1_110c_0_34)))

                 (at start (occupied seg_O1_110b_0_60))
                 (at start (not (not_occupied seg_O1_110b_0_60)))
                 (at start (blocked seg_O1_110b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_110b_0_60 ?a)))
                 (at end (at-segment ?a seg_O1_110b_0_60))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_O1_111a_0_34 ?a)))
                 (at end (not_blocked seg_O1_111a_0_34 ?a))

                 (at start (blocked seg_O1_110a_0_34 ?a))
                 (at start (not (not_blocked seg_O1_110a_0_34 ?a)))
                 (at start (blocked seg_O1_110d_0_45 ?a))
                 (at start (not (not_blocked seg_O1_110d_0_45 ?a)))
                )
)

(:durative-action move_seg_O1_110b_0_60_seg_p110_0_76_south_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_O1_110b_0_60))
                 (at start (not_occupied seg_p110_0_76))
                 (at start (not_blocked seg_p110_0_76 airplane_CFBEG))
                 (at start (not_blocked seg_p110_0_76 airplane_CFBE1))
                 (at start (not_blocked seg_p110_0_76 airplane_CFBE3))
                 (at start (not_blocked seg_p110_0_76 airplane_DAEW8))
                 (at start (not_blocked seg_p110_0_76 airplane_DAEW9))
                 (at start (not_blocked seg_p110_0_76 airplane_DAEW0))
                 (at start (not_blocked seg_p110_0_76 airplane_DAEW3))
                 (at start (not_blocked seg_p110_0_76 airplane_DAEWH))
                 (at start (not_blocked seg_p110_0_76 airplane_DAEW1))
                 (at start (not_blocked seg_p110_0_76 airplane_DAEW2))
                 (at start (not_blocked seg_p110_0_76 airplane_DAEW4))
                 (at start (not_blocked seg_p110_0_76 airplane_DAEW5))
                 (at start (not_blocked seg_p110_0_76 airplane_DAEW6))
                 (at start (not_blocked seg_p110_0_76 airplane_DAEW7))
                 (at start (not_blocked seg_p110_0_76 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_O1_110b_0_60)))
                 (at end (not_occupied seg_O1_110b_0_60))
                 (at start (not (at-segment ?a seg_O1_110b_0_60)))

                 (at start (occupied seg_p110_0_76))
                 (at start (not (not_occupied seg_p110_0_76)))
                 (at start (blocked seg_p110_0_76 ?a))
                 (at start (not (not_blocked seg_p110_0_76 ?a)))
                 (at end (at-segment ?a seg_p110_0_76))

                 (at end (not (blocked seg_O1_110a_0_34 ?a)))
                 (at end (not_blocked seg_O1_110a_0_34 ?a))
                 (at end (not (blocked seg_O1_110c_0_34 ?a)))
                 (at end (not_blocked seg_O1_110c_0_34 ?a))
                 (at end (not (blocked seg_O1_110d_0_45 ?a)))
                 (at end (not_blocked seg_O1_110d_0_45 ?a))

                )
)

(:durative-action move_seg_O1_110a_0_34_seg_O1_110b_0_60_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_110a_0_34))
                 (at start (not_occupied seg_O1_110b_0_60))
                 (at start (not_blocked seg_O1_110b_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_O1_110b_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_O1_110b_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_O1_110b_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_O1_110b_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_O1_110b_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_O1_110b_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_O1_110b_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_O1_110b_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_O1_110b_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_O1_110b_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_O1_110b_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_O1_110b_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_O1_110b_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_O1_110b_0_60 airplane_CFBE2))

                 (over all (not_occupied seg_O1_110c_0_34))
                 (over all (not_occupied seg_O1_110d_0_45))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_110a_0_34)))
                 (at end (not_occupied seg_O1_110a_0_34))
                 (at start (not (at-segment ?a seg_O1_110a_0_34)))

                 (at start (occupied seg_O1_110b_0_60))
                 (at start (not (not_occupied seg_O1_110b_0_60)))
                 (at start (blocked seg_O1_110b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_110b_0_60 ?a)))
                 (at end (at-segment ?a seg_O1_110b_0_60))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_O1_109c_0_34 ?a)))
                 (at end (not_blocked seg_O1_109c_0_34 ?a))

                 (at start (blocked seg_O1_110c_0_34 ?a))
                 (at start (not (not_blocked seg_O1_110c_0_34 ?a)))
                 (at start (blocked seg_O1_110d_0_45 ?a))
                 (at start (not (not_blocked seg_O1_110d_0_45 ?a)))
                )
)

(:durative-action move_seg_p133_0_75_seg_O1_110d_0_45_north_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_p133_0_75))
                 (at start (not_occupied seg_O1_110d_0_45))
                 (at start (not_blocked seg_O1_110d_0_45 airplane_CFBEG))
                 (at start (not_blocked seg_O1_110d_0_45 airplane_CFBE1))
                 (at start (not_blocked seg_O1_110d_0_45 airplane_CFBE3))
                 (at start (not_blocked seg_O1_110d_0_45 airplane_DAEW8))
                 (at start (not_blocked seg_O1_110d_0_45 airplane_DAEW9))
                 (at start (not_blocked seg_O1_110d_0_45 airplane_DAEW0))
                 (at start (not_blocked seg_O1_110d_0_45 airplane_DAEW3))
                 (at start (not_blocked seg_O1_110d_0_45 airplane_DAEWH))
                 (at start (not_blocked seg_O1_110d_0_45 airplane_DAEW1))
                 (at start (not_blocked seg_O1_110d_0_45 airplane_DAEW2))
                 (at start (not_blocked seg_O1_110d_0_45 airplane_DAEW4))
                 (at start (not_blocked seg_O1_110d_0_45 airplane_DAEW5))
                 (at start (not_blocked seg_O1_110d_0_45 airplane_DAEW6))
                 (at start (not_blocked seg_O1_110d_0_45 airplane_DAEW7))
                 (at start (not_blocked seg_O1_110d_0_45 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_p133_0_75)))
                 (at end (not_occupied seg_p133_0_75))
                 (at start (not (at-segment ?a seg_p133_0_75)))

                 (at start (occupied seg_O1_110d_0_45))
                 (at start (not (not_occupied seg_O1_110d_0_45)))
                 (at start (blocked seg_O1_110d_0_45 ?a))
                 (at start (not (not_blocked seg_O1_110d_0_45 ?a)))
                 (at end (at-segment ?a seg_O1_110d_0_45))


                )
)

(:durative-action move_seg_O1_110d_0_45_seg_O1_110a_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_110d_0_45))
                 (at start (not_occupied seg_O1_110a_0_34))
                 (at start (not_blocked seg_O1_110a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_110a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_110a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_110a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_110a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_110a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_110a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_110a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_110a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_110a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_110a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_110a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_110a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_110a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_110a_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_O1_110b_0_60))
                 (over all (not_occupied seg_O1_110c_0_34))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_110d_0_45)))
                 (at end (not_occupied seg_O1_110d_0_45))
                 (at start (not (at-segment ?a seg_O1_110d_0_45)))

                 (at start (occupied seg_O1_110a_0_34))
                 (at start (not (not_occupied seg_O1_110a_0_34)))
                 (at start (blocked seg_O1_110a_0_34 ?a))
                 (at start (not (not_blocked seg_O1_110a_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_110a_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_p133_0_75 ?a)))
                 (at end (not_blocked seg_p133_0_75 ?a))

                 (at start (blocked seg_O1_110b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_110b_0_60 ?a)))
                 (at start (blocked seg_O1_110c_0_34 ?a))
                 (at start (not (not_blocked seg_O1_110c_0_34 ?a)))
                )
)

(:durative-action move_seg_O1_110d_0_45_seg_O1_110c_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_110d_0_45))
                 (at start (not_occupied seg_O1_110c_0_34))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_O1_110a_0_34))
                 (over all (not_occupied seg_O1_110b_0_60))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_110d_0_45)))
                 (at end (not_occupied seg_O1_110d_0_45))
                 (at start (not (at-segment ?a seg_O1_110d_0_45)))

                 (at start (occupied seg_O1_110c_0_34))
                 (at start (not (not_occupied seg_O1_110c_0_34)))
                 (at start (blocked seg_O1_110c_0_34 ?a))
                 (at start (not (not_blocked seg_O1_110c_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_110c_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_p133_0_75 ?a)))
                 (at end (not_blocked seg_p133_0_75 ?a))

                 (at start (blocked seg_O1_110a_0_34 ?a))
                 (at start (not (not_blocked seg_O1_110a_0_34 ?a)))
                 (at start (blocked seg_O1_110b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_110b_0_60 ?a)))
                )
)

(:durative-action move_seg_O1_110c_0_34_seg_O1_110d_0_45_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_110c_0_34))
                 (at start (not_occupied seg_O1_110d_0_45))
                 (at start (not_blocked seg_O1_110d_0_45 airplane_CFBEG))
                 (at start (not_blocked seg_O1_110d_0_45 airplane_CFBE1))
                 (at start (not_blocked seg_O1_110d_0_45 airplane_CFBE3))
                 (at start (not_blocked seg_O1_110d_0_45 airplane_DAEW8))
                 (at start (not_blocked seg_O1_110d_0_45 airplane_DAEW9))
                 (at start (not_blocked seg_O1_110d_0_45 airplane_DAEW0))
                 (at start (not_blocked seg_O1_110d_0_45 airplane_DAEW3))
                 (at start (not_blocked seg_O1_110d_0_45 airplane_DAEWH))
                 (at start (not_blocked seg_O1_110d_0_45 airplane_DAEW1))
                 (at start (not_blocked seg_O1_110d_0_45 airplane_DAEW2))
                 (at start (not_blocked seg_O1_110d_0_45 airplane_DAEW4))
                 (at start (not_blocked seg_O1_110d_0_45 airplane_DAEW5))
                 (at start (not_blocked seg_O1_110d_0_45 airplane_DAEW6))
                 (at start (not_blocked seg_O1_110d_0_45 airplane_DAEW7))
                 (at start (not_blocked seg_O1_110d_0_45 airplane_CFBE2))

                 (over all (not_occupied seg_O1_110a_0_34))
                 (over all (not_occupied seg_O1_110b_0_60))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_110c_0_34)))
                 (at end (not_occupied seg_O1_110c_0_34))
                 (at start (not (at-segment ?a seg_O1_110c_0_34)))

                 (at start (occupied seg_O1_110d_0_45))
                 (at start (not (not_occupied seg_O1_110d_0_45)))
                 (at start (blocked seg_O1_110d_0_45 ?a))
                 (at start (not (not_blocked seg_O1_110d_0_45 ?a)))
                 (at end (at-segment ?a seg_O1_110d_0_45))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_O1_111a_0_34 ?a)))
                 (at end (not_blocked seg_O1_111a_0_34 ?a))

                 (at start (blocked seg_O1_110a_0_34 ?a))
                 (at start (not (not_blocked seg_O1_110a_0_34 ?a)))
                 (at start (blocked seg_O1_110b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_110b_0_60 ?a)))
                )
)

(:durative-action move_seg_O1_110d_0_45_seg_p133_0_75_south_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_O1_110d_0_45))
                 (at start (not_occupied seg_p133_0_75))
                 (at start (not_blocked seg_p133_0_75 airplane_CFBEG))
                 (at start (not_blocked seg_p133_0_75 airplane_CFBE1))
                 (at start (not_blocked seg_p133_0_75 airplane_CFBE3))
                 (at start (not_blocked seg_p133_0_75 airplane_DAEW8))
                 (at start (not_blocked seg_p133_0_75 airplane_DAEW9))
                 (at start (not_blocked seg_p133_0_75 airplane_DAEW0))
                 (at start (not_blocked seg_p133_0_75 airplane_DAEW3))
                 (at start (not_blocked seg_p133_0_75 airplane_DAEWH))
                 (at start (not_blocked seg_p133_0_75 airplane_DAEW1))
                 (at start (not_blocked seg_p133_0_75 airplane_DAEW2))
                 (at start (not_blocked seg_p133_0_75 airplane_DAEW4))
                 (at start (not_blocked seg_p133_0_75 airplane_DAEW5))
                 (at start (not_blocked seg_p133_0_75 airplane_DAEW6))
                 (at start (not_blocked seg_p133_0_75 airplane_DAEW7))
                 (at start (not_blocked seg_p133_0_75 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_O1_110d_0_45)))
                 (at end (not_occupied seg_O1_110d_0_45))
                 (at start (not (at-segment ?a seg_O1_110d_0_45)))

                 (at start (occupied seg_p133_0_75))
                 (at start (not (not_occupied seg_p133_0_75)))
                 (at start (blocked seg_p133_0_75 ?a))
                 (at start (not (not_blocked seg_p133_0_75 ?a)))
                 (at end (at-segment ?a seg_p133_0_75))

                 (at end (not (blocked seg_O1_110a_0_34 ?a)))
                 (at end (not_blocked seg_O1_110a_0_34 ?a))
                 (at end (not (blocked seg_O1_110b_0_60 ?a)))
                 (at end (not_blocked seg_O1_110b_0_60 ?a))
                 (at end (not (blocked seg_O1_110c_0_34 ?a)))
                 (at end (not_blocked seg_O1_110c_0_34 ?a))

                )
)

(:durative-action move_seg_O1_110a_0_34_seg_O1_110d_0_45_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_110a_0_34))
                 (at start (not_occupied seg_O1_110d_0_45))
                 (at start (not_blocked seg_O1_110d_0_45 airplane_CFBEG))
                 (at start (not_blocked seg_O1_110d_0_45 airplane_CFBE1))
                 (at start (not_blocked seg_O1_110d_0_45 airplane_CFBE3))
                 (at start (not_blocked seg_O1_110d_0_45 airplane_DAEW8))
                 (at start (not_blocked seg_O1_110d_0_45 airplane_DAEW9))
                 (at start (not_blocked seg_O1_110d_0_45 airplane_DAEW0))
                 (at start (not_blocked seg_O1_110d_0_45 airplane_DAEW3))
                 (at start (not_blocked seg_O1_110d_0_45 airplane_DAEWH))
                 (at start (not_blocked seg_O1_110d_0_45 airplane_DAEW1))
                 (at start (not_blocked seg_O1_110d_0_45 airplane_DAEW2))
                 (at start (not_blocked seg_O1_110d_0_45 airplane_DAEW4))
                 (at start (not_blocked seg_O1_110d_0_45 airplane_DAEW5))
                 (at start (not_blocked seg_O1_110d_0_45 airplane_DAEW6))
                 (at start (not_blocked seg_O1_110d_0_45 airplane_DAEW7))
                 (at start (not_blocked seg_O1_110d_0_45 airplane_CFBE2))

                 (over all (not_occupied seg_O1_110b_0_60))
                 (over all (not_occupied seg_O1_110c_0_34))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_110a_0_34)))
                 (at end (not_occupied seg_O1_110a_0_34))
                 (at start (not (at-segment ?a seg_O1_110a_0_34)))

                 (at start (occupied seg_O1_110d_0_45))
                 (at start (not (not_occupied seg_O1_110d_0_45)))
                 (at start (blocked seg_O1_110d_0_45 ?a))
                 (at start (not (not_blocked seg_O1_110d_0_45 ?a)))
                 (at end (at-segment ?a seg_O1_110d_0_45))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_O1_109c_0_34 ?a)))
                 (at end (not_blocked seg_O1_109c_0_34 ?a))

                 (at start (blocked seg_O1_110b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_110b_0_60 ?a)))
                 (at start (blocked seg_O1_110c_0_34 ?a))
                 (at start (not (not_blocked seg_O1_110c_0_34 ?a)))
                )
)

(:durative-action move_seg_p111_0_76_seg_O1_111b_0_60_north_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_p111_0_76))
                 (at start (not_occupied seg_O1_111b_0_60))
                 (at start (not_blocked seg_O1_111b_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_O1_111b_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_O1_111b_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_O1_111b_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_O1_111b_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_O1_111b_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_O1_111b_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_O1_111b_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_O1_111b_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_O1_111b_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_O1_111b_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_O1_111b_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_O1_111b_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_O1_111b_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_O1_111b_0_60 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_p111_0_76)))
                 (at end (not_occupied seg_p111_0_76))
                 (at start (not (at-segment ?a seg_p111_0_76)))

                 (at start (occupied seg_O1_111b_0_60))
                 (at start (not (not_occupied seg_O1_111b_0_60)))
                 (at start (blocked seg_O1_111b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_111b_0_60 ?a)))
                 (at end (at-segment ?a seg_O1_111b_0_60))


                )
)

(:durative-action move_seg_O1_111b_0_60_seg_O1_111a_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_111b_0_60))
                 (at start (not_occupied seg_O1_111a_0_34))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_O1_111c_0_34))
                 (over all (not_occupied seg_O1_111d_0_45))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_111b_0_60)))
                 (at end (not_occupied seg_O1_111b_0_60))
                 (at start (not (at-segment ?a seg_O1_111b_0_60)))

                 (at start (occupied seg_O1_111a_0_34))
                 (at start (not (not_occupied seg_O1_111a_0_34)))
                 (at start (blocked seg_O1_111a_0_34 ?a))
                 (at start (not (not_blocked seg_O1_111a_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_111a_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_p111_0_76 ?a)))
                 (at end (not_blocked seg_p111_0_76 ?a))

                 (at start (blocked seg_O1_111c_0_34 ?a))
                 (at start (not (not_blocked seg_O1_111c_0_34 ?a)))
                 (at start (blocked seg_O1_111d_0_45 ?a))
                 (at start (not (not_blocked seg_O1_111d_0_45 ?a)))
                )
)

(:durative-action move_seg_O1_111b_0_60_seg_O1_111c_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_111b_0_60))
                 (at start (not_occupied seg_O1_111c_0_34))
                 (at start (not_blocked seg_O1_111c_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_111c_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_111c_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_111c_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_111c_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_111c_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_111c_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_111c_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_111c_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_111c_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_111c_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_111c_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_111c_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_111c_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_111c_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_O1_111a_0_34))
                 (over all (not_occupied seg_O1_111d_0_45))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_111b_0_60)))
                 (at end (not_occupied seg_O1_111b_0_60))
                 (at start (not (at-segment ?a seg_O1_111b_0_60)))

                 (at start (occupied seg_O1_111c_0_34))
                 (at start (not (not_occupied seg_O1_111c_0_34)))
                 (at start (blocked seg_O1_111c_0_34 ?a))
                 (at start (not (not_blocked seg_O1_111c_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_111c_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_p111_0_76 ?a)))
                 (at end (not_blocked seg_p111_0_76 ?a))

                 (at start (blocked seg_O1_111a_0_34 ?a))
                 (at start (not (not_blocked seg_O1_111a_0_34 ?a)))
                 (at start (blocked seg_O1_111d_0_45 ?a))
                 (at start (not (not_blocked seg_O1_111d_0_45 ?a)))
                )
)

(:durative-action move_seg_O1_111c_0_34_seg_O1_111b_0_60_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_111c_0_34))
                 (at start (not_occupied seg_O1_111b_0_60))
                 (at start (not_blocked seg_O1_111b_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_O1_111b_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_O1_111b_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_O1_111b_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_O1_111b_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_O1_111b_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_O1_111b_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_O1_111b_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_O1_111b_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_O1_111b_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_O1_111b_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_O1_111b_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_O1_111b_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_O1_111b_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_O1_111b_0_60 airplane_CFBE2))

                 (over all (not_occupied seg_O1_111a_0_34))
                 (over all (not_occupied seg_O1_111d_0_45))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_111c_0_34)))
                 (at end (not_occupied seg_O1_111c_0_34))
                 (at start (not (at-segment ?a seg_O1_111c_0_34)))

                 (at start (occupied seg_O1_111b_0_60))
                 (at start (not (not_occupied seg_O1_111b_0_60)))
                 (at start (blocked seg_O1_111b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_111b_0_60 ?a)))
                 (at end (at-segment ?a seg_O1_111b_0_60))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_O1_C3a_0_34 ?a)))
                 (at end (not_blocked seg_O1_C3a_0_34 ?a))

                 (at start (blocked seg_O1_111a_0_34 ?a))
                 (at start (not (not_blocked seg_O1_111a_0_34 ?a)))
                 (at start (blocked seg_O1_111d_0_45 ?a))
                 (at start (not (not_blocked seg_O1_111d_0_45 ?a)))
                )
)

(:durative-action move_seg_O1_111b_0_60_seg_p111_0_76_south_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_O1_111b_0_60))
                 (at start (not_occupied seg_p111_0_76))
                 (at start (not_blocked seg_p111_0_76 airplane_CFBEG))
                 (at start (not_blocked seg_p111_0_76 airplane_CFBE1))
                 (at start (not_blocked seg_p111_0_76 airplane_CFBE3))
                 (at start (not_blocked seg_p111_0_76 airplane_DAEW8))
                 (at start (not_blocked seg_p111_0_76 airplane_DAEW9))
                 (at start (not_blocked seg_p111_0_76 airplane_DAEW0))
                 (at start (not_blocked seg_p111_0_76 airplane_DAEW3))
                 (at start (not_blocked seg_p111_0_76 airplane_DAEWH))
                 (at start (not_blocked seg_p111_0_76 airplane_DAEW1))
                 (at start (not_blocked seg_p111_0_76 airplane_DAEW2))
                 (at start (not_blocked seg_p111_0_76 airplane_DAEW4))
                 (at start (not_blocked seg_p111_0_76 airplane_DAEW5))
                 (at start (not_blocked seg_p111_0_76 airplane_DAEW6))
                 (at start (not_blocked seg_p111_0_76 airplane_DAEW7))
                 (at start (not_blocked seg_p111_0_76 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_O1_111b_0_60)))
                 (at end (not_occupied seg_O1_111b_0_60))
                 (at start (not (at-segment ?a seg_O1_111b_0_60)))

                 (at start (occupied seg_p111_0_76))
                 (at start (not (not_occupied seg_p111_0_76)))
                 (at start (blocked seg_p111_0_76 ?a))
                 (at start (not (not_blocked seg_p111_0_76 ?a)))
                 (at end (at-segment ?a seg_p111_0_76))

                 (at end (not (blocked seg_O1_111a_0_34 ?a)))
                 (at end (not_blocked seg_O1_111a_0_34 ?a))
                 (at end (not (blocked seg_O1_111c_0_34 ?a)))
                 (at end (not_blocked seg_O1_111c_0_34 ?a))
                 (at end (not (blocked seg_O1_111d_0_45 ?a)))
                 (at end (not_blocked seg_O1_111d_0_45 ?a))

                )
)

(:durative-action move_seg_O1_111a_0_34_seg_O1_111b_0_60_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_111a_0_34))
                 (at start (not_occupied seg_O1_111b_0_60))
                 (at start (not_blocked seg_O1_111b_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_O1_111b_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_O1_111b_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_O1_111b_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_O1_111b_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_O1_111b_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_O1_111b_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_O1_111b_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_O1_111b_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_O1_111b_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_O1_111b_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_O1_111b_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_O1_111b_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_O1_111b_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_O1_111b_0_60 airplane_CFBE2))

                 (over all (not_occupied seg_O1_111c_0_34))
                 (over all (not_occupied seg_O1_111d_0_45))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_111a_0_34)))
                 (at end (not_occupied seg_O1_111a_0_34))
                 (at start (not (at-segment ?a seg_O1_111a_0_34)))

                 (at start (occupied seg_O1_111b_0_60))
                 (at start (not (not_occupied seg_O1_111b_0_60)))
                 (at start (blocked seg_O1_111b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_111b_0_60 ?a)))
                 (at end (at-segment ?a seg_O1_111b_0_60))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_O1_110c_0_34 ?a)))
                 (at end (not_blocked seg_O1_110c_0_34 ?a))

                 (at start (blocked seg_O1_111c_0_34 ?a))
                 (at start (not (not_blocked seg_O1_111c_0_34 ?a)))
                 (at start (blocked seg_O1_111d_0_45 ?a))
                 (at start (not (not_blocked seg_O1_111d_0_45 ?a)))
                )
)

(:durative-action move_seg_p134_0_75_seg_O1_111d_0_45_north_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_p134_0_75))
                 (at start (not_occupied seg_O1_111d_0_45))
                 (at start (not_blocked seg_O1_111d_0_45 airplane_CFBEG))
                 (at start (not_blocked seg_O1_111d_0_45 airplane_CFBE1))
                 (at start (not_blocked seg_O1_111d_0_45 airplane_CFBE3))
                 (at start (not_blocked seg_O1_111d_0_45 airplane_DAEW8))
                 (at start (not_blocked seg_O1_111d_0_45 airplane_DAEW9))
                 (at start (not_blocked seg_O1_111d_0_45 airplane_DAEW0))
                 (at start (not_blocked seg_O1_111d_0_45 airplane_DAEW3))
                 (at start (not_blocked seg_O1_111d_0_45 airplane_DAEWH))
                 (at start (not_blocked seg_O1_111d_0_45 airplane_DAEW1))
                 (at start (not_blocked seg_O1_111d_0_45 airplane_DAEW2))
                 (at start (not_blocked seg_O1_111d_0_45 airplane_DAEW4))
                 (at start (not_blocked seg_O1_111d_0_45 airplane_DAEW5))
                 (at start (not_blocked seg_O1_111d_0_45 airplane_DAEW6))
                 (at start (not_blocked seg_O1_111d_0_45 airplane_DAEW7))
                 (at start (not_blocked seg_O1_111d_0_45 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_p134_0_75)))
                 (at end (not_occupied seg_p134_0_75))
                 (at start (not (at-segment ?a seg_p134_0_75)))

                 (at start (occupied seg_O1_111d_0_45))
                 (at start (not (not_occupied seg_O1_111d_0_45)))
                 (at start (blocked seg_O1_111d_0_45 ?a))
                 (at start (not (not_blocked seg_O1_111d_0_45 ?a)))
                 (at end (at-segment ?a seg_O1_111d_0_45))


                )
)

(:durative-action move_seg_O1_111d_0_45_seg_O1_111a_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_111d_0_45))
                 (at start (not_occupied seg_O1_111a_0_34))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_O1_111b_0_60))
                 (over all (not_occupied seg_O1_111c_0_34))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_111d_0_45)))
                 (at end (not_occupied seg_O1_111d_0_45))
                 (at start (not (at-segment ?a seg_O1_111d_0_45)))

                 (at start (occupied seg_O1_111a_0_34))
                 (at start (not (not_occupied seg_O1_111a_0_34)))
                 (at start (blocked seg_O1_111a_0_34 ?a))
                 (at start (not (not_blocked seg_O1_111a_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_111a_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_p134_0_75 ?a)))
                 (at end (not_blocked seg_p134_0_75 ?a))

                 (at start (blocked seg_O1_111b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_111b_0_60 ?a)))
                 (at start (blocked seg_O1_111c_0_34 ?a))
                 (at start (not (not_blocked seg_O1_111c_0_34 ?a)))
                )
)

(:durative-action move_seg_O1_111d_0_45_seg_O1_111c_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_111d_0_45))
                 (at start (not_occupied seg_O1_111c_0_34))
                 (at start (not_blocked seg_O1_111c_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_111c_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_111c_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_111c_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_111c_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_111c_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_111c_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_111c_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_111c_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_111c_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_111c_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_111c_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_111c_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_111c_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_111c_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_O1_111a_0_34))
                 (over all (not_occupied seg_O1_111b_0_60))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_111d_0_45)))
                 (at end (not_occupied seg_O1_111d_0_45))
                 (at start (not (at-segment ?a seg_O1_111d_0_45)))

                 (at start (occupied seg_O1_111c_0_34))
                 (at start (not (not_occupied seg_O1_111c_0_34)))
                 (at start (blocked seg_O1_111c_0_34 ?a))
                 (at start (not (not_blocked seg_O1_111c_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_111c_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_p134_0_75 ?a)))
                 (at end (not_blocked seg_p134_0_75 ?a))

                 (at start (blocked seg_O1_111a_0_34 ?a))
                 (at start (not (not_blocked seg_O1_111a_0_34 ?a)))
                 (at start (blocked seg_O1_111b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_111b_0_60 ?a)))
                )
)

(:durative-action move_seg_O1_111c_0_34_seg_O1_111d_0_45_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_111c_0_34))
                 (at start (not_occupied seg_O1_111d_0_45))
                 (at start (not_blocked seg_O1_111d_0_45 airplane_CFBEG))
                 (at start (not_blocked seg_O1_111d_0_45 airplane_CFBE1))
                 (at start (not_blocked seg_O1_111d_0_45 airplane_CFBE3))
                 (at start (not_blocked seg_O1_111d_0_45 airplane_DAEW8))
                 (at start (not_blocked seg_O1_111d_0_45 airplane_DAEW9))
                 (at start (not_blocked seg_O1_111d_0_45 airplane_DAEW0))
                 (at start (not_blocked seg_O1_111d_0_45 airplane_DAEW3))
                 (at start (not_blocked seg_O1_111d_0_45 airplane_DAEWH))
                 (at start (not_blocked seg_O1_111d_0_45 airplane_DAEW1))
                 (at start (not_blocked seg_O1_111d_0_45 airplane_DAEW2))
                 (at start (not_blocked seg_O1_111d_0_45 airplane_DAEW4))
                 (at start (not_blocked seg_O1_111d_0_45 airplane_DAEW5))
                 (at start (not_blocked seg_O1_111d_0_45 airplane_DAEW6))
                 (at start (not_blocked seg_O1_111d_0_45 airplane_DAEW7))
                 (at start (not_blocked seg_O1_111d_0_45 airplane_CFBE2))

                 (over all (not_occupied seg_O1_111a_0_34))
                 (over all (not_occupied seg_O1_111b_0_60))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_111c_0_34)))
                 (at end (not_occupied seg_O1_111c_0_34))
                 (at start (not (at-segment ?a seg_O1_111c_0_34)))

                 (at start (occupied seg_O1_111d_0_45))
                 (at start (not (not_occupied seg_O1_111d_0_45)))
                 (at start (blocked seg_O1_111d_0_45 ?a))
                 (at start (not (not_blocked seg_O1_111d_0_45 ?a)))
                 (at end (at-segment ?a seg_O1_111d_0_45))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_O1_C3a_0_34 ?a)))
                 (at end (not_blocked seg_O1_C3a_0_34 ?a))

                 (at start (blocked seg_O1_111a_0_34 ?a))
                 (at start (not (not_blocked seg_O1_111a_0_34 ?a)))
                 (at start (blocked seg_O1_111b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_111b_0_60 ?a)))
                )
)

(:durative-action move_seg_O1_111d_0_45_seg_p134_0_75_south_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_O1_111d_0_45))
                 (at start (not_occupied seg_p134_0_75))
                 (at start (not_blocked seg_p134_0_75 airplane_CFBEG))
                 (at start (not_blocked seg_p134_0_75 airplane_CFBE1))
                 (at start (not_blocked seg_p134_0_75 airplane_CFBE3))
                 (at start (not_blocked seg_p134_0_75 airplane_DAEW8))
                 (at start (not_blocked seg_p134_0_75 airplane_DAEW9))
                 (at start (not_blocked seg_p134_0_75 airplane_DAEW0))
                 (at start (not_blocked seg_p134_0_75 airplane_DAEW3))
                 (at start (not_blocked seg_p134_0_75 airplane_DAEWH))
                 (at start (not_blocked seg_p134_0_75 airplane_DAEW1))
                 (at start (not_blocked seg_p134_0_75 airplane_DAEW2))
                 (at start (not_blocked seg_p134_0_75 airplane_DAEW4))
                 (at start (not_blocked seg_p134_0_75 airplane_DAEW5))
                 (at start (not_blocked seg_p134_0_75 airplane_DAEW6))
                 (at start (not_blocked seg_p134_0_75 airplane_DAEW7))
                 (at start (not_blocked seg_p134_0_75 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_O1_111d_0_45)))
                 (at end (not_occupied seg_O1_111d_0_45))
                 (at start (not (at-segment ?a seg_O1_111d_0_45)))

                 (at start (occupied seg_p134_0_75))
                 (at start (not (not_occupied seg_p134_0_75)))
                 (at start (blocked seg_p134_0_75 ?a))
                 (at start (not (not_blocked seg_p134_0_75 ?a)))
                 (at end (at-segment ?a seg_p134_0_75))

                 (at end (not (blocked seg_O1_111a_0_34 ?a)))
                 (at end (not_blocked seg_O1_111a_0_34 ?a))
                 (at end (not (blocked seg_O1_111b_0_60 ?a)))
                 (at end (not_blocked seg_O1_111b_0_60 ?a))
                 (at end (not (blocked seg_O1_111c_0_34 ?a)))
                 (at end (not_blocked seg_O1_111c_0_34 ?a))

                )
)

(:durative-action move_seg_O1_111a_0_34_seg_O1_111d_0_45_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_111a_0_34))
                 (at start (not_occupied seg_O1_111d_0_45))
                 (at start (not_blocked seg_O1_111d_0_45 airplane_CFBEG))
                 (at start (not_blocked seg_O1_111d_0_45 airplane_CFBE1))
                 (at start (not_blocked seg_O1_111d_0_45 airplane_CFBE3))
                 (at start (not_blocked seg_O1_111d_0_45 airplane_DAEW8))
                 (at start (not_blocked seg_O1_111d_0_45 airplane_DAEW9))
                 (at start (not_blocked seg_O1_111d_0_45 airplane_DAEW0))
                 (at start (not_blocked seg_O1_111d_0_45 airplane_DAEW3))
                 (at start (not_blocked seg_O1_111d_0_45 airplane_DAEWH))
                 (at start (not_blocked seg_O1_111d_0_45 airplane_DAEW1))
                 (at start (not_blocked seg_O1_111d_0_45 airplane_DAEW2))
                 (at start (not_blocked seg_O1_111d_0_45 airplane_DAEW4))
                 (at start (not_blocked seg_O1_111d_0_45 airplane_DAEW5))
                 (at start (not_blocked seg_O1_111d_0_45 airplane_DAEW6))
                 (at start (not_blocked seg_O1_111d_0_45 airplane_DAEW7))
                 (at start (not_blocked seg_O1_111d_0_45 airplane_CFBE2))

                 (over all (not_occupied seg_O1_111b_0_60))
                 (over all (not_occupied seg_O1_111c_0_34))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_111a_0_34)))
                 (at end (not_occupied seg_O1_111a_0_34))
                 (at start (not (at-segment ?a seg_O1_111a_0_34)))

                 (at start (occupied seg_O1_111d_0_45))
                 (at start (not (not_occupied seg_O1_111d_0_45)))
                 (at start (blocked seg_O1_111d_0_45 ?a))
                 (at start (not (not_blocked seg_O1_111d_0_45 ?a)))
                 (at end (at-segment ?a seg_O1_111d_0_45))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_O1_110c_0_34 ?a)))
                 (at end (not_blocked seg_O1_110c_0_34 ?a))

                 (at start (blocked seg_O1_111b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_111b_0_60 ?a)))
                 (at start (blocked seg_O1_111c_0_34 ?a))
                 (at start (not (not_blocked seg_O1_111c_0_34 ?a)))
                )
)

(:durative-action move_seg_p112_0_76_seg_O1_C3b_0_60_north_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_p112_0_76))
                 (at start (not_occupied seg_O1_C3b_0_60))
                 (at start (not_blocked seg_O1_C3b_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_O1_C3b_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_O1_C3b_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_O1_C3b_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_O1_C3b_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_O1_C3b_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_O1_C3b_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_O1_C3b_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_O1_C3b_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_O1_C3b_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_O1_C3b_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_O1_C3b_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_O1_C3b_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_O1_C3b_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_O1_C3b_0_60 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_p112_0_76)))
                 (at end (not_occupied seg_p112_0_76))
                 (at start (not (at-segment ?a seg_p112_0_76)))

                 (at start (occupied seg_O1_C3b_0_60))
                 (at start (not (not_occupied seg_O1_C3b_0_60)))
                 (at start (blocked seg_O1_C3b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_C3b_0_60 ?a)))
                 (at end (at-segment ?a seg_O1_C3b_0_60))


                )
)

(:durative-action move_seg_O1_C3b_0_60_seg_O1_C3d_0_60_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_C3b_0_60))
                 (at start (not_occupied seg_O1_C3d_0_60))
                 (at start (not_blocked seg_O1_C3d_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_O1_C3d_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_O1_C3d_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_O1_C3d_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_O1_C3d_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_O1_C3d_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_O1_C3d_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_O1_C3d_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_O1_C3d_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_O1_C3d_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_O1_C3d_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_O1_C3d_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_O1_C3d_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_O1_C3d_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_O1_C3d_0_60 airplane_CFBE2))

                 (over all (not_occupied seg_O1_C3a_0_34))
                 (over all (not_occupied seg_O1_C3c_0_48))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_C3b_0_60)))
                 (at end (not_occupied seg_O1_C3b_0_60))
                 (at start (not (at-segment ?a seg_O1_C3b_0_60)))

                 (at start (occupied seg_O1_C3d_0_60))
                 (at start (not (not_occupied seg_O1_C3d_0_60)))
                 (at start (blocked seg_O1_C3d_0_60 ?a))
                 (at start (not (not_blocked seg_O1_C3d_0_60 ?a)))
                 (at end (at-segment ?a seg_O1_C3d_0_60))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_p112_0_76 ?a)))
                 (at end (not_blocked seg_p112_0_76 ?a))

                 (at start (blocked seg_O1_C3a_0_34 ?a))
                 (at start (not (not_blocked seg_O1_C3a_0_34 ?a)))
                 (at start (blocked seg_O1_C3c_0_48 ?a))
                 (at start (not (not_blocked seg_O1_C3c_0_48 ?a)))
                )
)

(:durative-action move_seg_O1_C3d_0_60_seg_C3_b_0_80_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_O1_C3d_0_60))
                 (at start (not_occupied seg_C3_b_0_80))
                 (at start (not_blocked seg_C3_b_0_80 airplane_CFBEG))
                 (at start (not_blocked seg_C3_b_0_80 airplane_CFBE1))
                 (at start (not_blocked seg_C3_b_0_80 airplane_CFBE3))
                 (at start (not_blocked seg_C3_b_0_80 airplane_DAEW8))
                 (at start (not_blocked seg_C3_b_0_80 airplane_DAEW9))
                 (at start (not_blocked seg_C3_b_0_80 airplane_DAEW0))
                 (at start (not_blocked seg_C3_b_0_80 airplane_DAEW3))
                 (at start (not_blocked seg_C3_b_0_80 airplane_DAEWH))
                 (at start (not_blocked seg_C3_b_0_80 airplane_DAEW1))
                 (at start (not_blocked seg_C3_b_0_80 airplane_DAEW2))
                 (at start (not_blocked seg_C3_b_0_80 airplane_DAEW4))
                 (at start (not_blocked seg_C3_b_0_80 airplane_DAEW5))
                 (at start (not_blocked seg_C3_b_0_80 airplane_DAEW6))
                 (at start (not_blocked seg_C3_b_0_80 airplane_DAEW7))
                 (at start (not_blocked seg_C3_b_0_80 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_O1_C3d_0_60)))
                 (at end (not_occupied seg_O1_C3d_0_60))
                 (at start (not (at-segment ?a seg_O1_C3d_0_60)))

                 (at start (occupied seg_C3_b_0_80))
                 (at start (not (not_occupied seg_C3_b_0_80)))
                 (at start (blocked seg_C3_b_0_80 ?a))
                 (at start (not (not_blocked seg_C3_b_0_80 ?a)))
                 (at end (at-segment ?a seg_C3_b_0_80))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_O1_C3a_0_34 ?a)))
                 (at end (not_blocked seg_O1_C3a_0_34 ?a))
                 (at end (not (blocked seg_O1_C3b_0_60 ?a)))
                 (at end (not_blocked seg_O1_C3b_0_60 ?a))
                 (at end (not (blocked seg_O1_C3c_0_48 ?a)))
                 (at end (not_blocked seg_O1_C3c_0_48 ?a))

                )
)

(:durative-action move_seg_C3_b_0_80_seg_O1_C3d_0_60_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_C3_b_0_80))
                 (at start (not_occupied seg_O1_C3d_0_60))
                 (at start (not_blocked seg_O1_C3d_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_O1_C3d_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_O1_C3d_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_O1_C3d_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_O1_C3d_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_O1_C3d_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_O1_C3d_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_O1_C3d_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_O1_C3d_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_O1_C3d_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_O1_C3d_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_O1_C3d_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_O1_C3d_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_O1_C3d_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_O1_C3d_0_60 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_C3_b_0_80)))
                 (at end (not_occupied seg_C3_b_0_80))
                 (at start (not (at-segment ?a seg_C3_b_0_80)))

                 (at start (occupied seg_O1_C3d_0_60))
                 (at start (not (not_occupied seg_O1_C3d_0_60)))
                 (at start (blocked seg_O1_C3d_0_60 ?a))
                 (at start (not (not_blocked seg_O1_C3d_0_60 ?a)))
                 (at end (at-segment ?a seg_O1_C3d_0_60))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                 (at end (not (blocked seg_C3_a_0_80 ?a)))
                 (at end (not_blocked seg_C3_a_0_80 ?a))

                )
)

(:durative-action move_seg_O1_C3d_0_60_seg_O1_C3c_0_48_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_C3d_0_60))
                 (at start (not_occupied seg_O1_C3c_0_48))
                 (at start (not_blocked seg_O1_C3c_0_48 airplane_CFBEG))
                 (at start (not_blocked seg_O1_C3c_0_48 airplane_CFBE1))
                 (at start (not_blocked seg_O1_C3c_0_48 airplane_CFBE3))
                 (at start (not_blocked seg_O1_C3c_0_48 airplane_DAEW8))
                 (at start (not_blocked seg_O1_C3c_0_48 airplane_DAEW9))
                 (at start (not_blocked seg_O1_C3c_0_48 airplane_DAEW0))
                 (at start (not_blocked seg_O1_C3c_0_48 airplane_DAEW3))
                 (at start (not_blocked seg_O1_C3c_0_48 airplane_DAEWH))
                 (at start (not_blocked seg_O1_C3c_0_48 airplane_DAEW1))
                 (at start (not_blocked seg_O1_C3c_0_48 airplane_DAEW2))
                 (at start (not_blocked seg_O1_C3c_0_48 airplane_DAEW4))
                 (at start (not_blocked seg_O1_C3c_0_48 airplane_DAEW5))
                 (at start (not_blocked seg_O1_C3c_0_48 airplane_DAEW6))
                 (at start (not_blocked seg_O1_C3c_0_48 airplane_DAEW7))
                 (at start (not_blocked seg_O1_C3c_0_48 airplane_CFBE2))

                 (over all (not_occupied seg_O1_C3a_0_34))
                 (over all (not_occupied seg_O1_C3b_0_60))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_C3d_0_60)))
                 (at end (not_occupied seg_O1_C3d_0_60))
                 (at start (not (at-segment ?a seg_O1_C3d_0_60)))

                 (at start (occupied seg_O1_C3c_0_48))
                 (at start (not (not_occupied seg_O1_C3c_0_48)))
                 (at start (blocked seg_O1_C3c_0_48 ?a))
                 (at start (not (not_blocked seg_O1_C3c_0_48 ?a)))
                 (at end (at-segment ?a seg_O1_C3c_0_48))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_C3_b_0_80 ?a)))
                 (at end (not_blocked seg_C3_b_0_80 ?a))

                 (at start (blocked seg_O1_C3a_0_34 ?a))
                 (at start (not (not_blocked seg_O1_C3a_0_34 ?a)))
                 (at start (blocked seg_O1_C3b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_C3b_0_60 ?a)))
                )
)

(:durative-action move_seg_O1_C3d_0_60_seg_O1_C3a_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_C3d_0_60))
                 (at start (not_occupied seg_O1_C3a_0_34))
                 (at start (not_blocked seg_O1_C3a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_C3a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_C3a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_C3a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_C3a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_C3a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_C3a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_C3a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_C3a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_C3a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_C3a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_C3a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_C3a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_C3a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_C3a_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_O1_C3b_0_60))
                 (over all (not_occupied seg_O1_C3c_0_48))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_C3d_0_60)))
                 (at end (not_occupied seg_O1_C3d_0_60))
                 (at start (not (at-segment ?a seg_O1_C3d_0_60)))

                 (at start (occupied seg_O1_C3a_0_34))
                 (at start (not (not_occupied seg_O1_C3a_0_34)))
                 (at start (blocked seg_O1_C3a_0_34 ?a))
                 (at start (not (not_blocked seg_O1_C3a_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_C3a_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_C3_b_0_80 ?a)))
                 (at end (not_blocked seg_C3_b_0_80 ?a))

                 (at start (blocked seg_O1_C3b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_C3b_0_60 ?a)))
                 (at start (blocked seg_O1_C3c_0_48 ?a))
                 (at start (not (not_blocked seg_O1_C3c_0_48 ?a)))
                )
)

(:durative-action move_seg_O1_C3c_0_48_seg_O1_C3b_0_60_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_C3c_0_48))
                 (at start (not_occupied seg_O1_C3b_0_60))
                 (at start (not_blocked seg_O1_C3b_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_O1_C3b_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_O1_C3b_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_O1_C3b_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_O1_C3b_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_O1_C3b_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_O1_C3b_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_O1_C3b_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_O1_C3b_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_O1_C3b_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_O1_C3b_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_O1_C3b_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_O1_C3b_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_O1_C3b_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_O1_C3b_0_60 airplane_CFBE2))

                 (over all (not_occupied seg_O1_C3a_0_34))
                 (over all (not_occupied seg_O1_C3d_0_60))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_C3c_0_48)))
                 (at end (not_occupied seg_O1_C3c_0_48))
                 (at start (not (at-segment ?a seg_O1_C3c_0_48)))

                 (at start (occupied seg_O1_C3b_0_60))
                 (at start (not (not_occupied seg_O1_C3b_0_60)))
                 (at start (blocked seg_O1_C3b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_C3b_0_60 ?a)))
                 (at end (at-segment ?a seg_O1_C3b_0_60))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_O1_115a_0_34 ?a)))
                 (at end (not_blocked seg_O1_115a_0_34 ?a))

                 (at start (blocked seg_O1_C3a_0_34 ?a))
                 (at start (not (not_blocked seg_O1_C3a_0_34 ?a)))
                 (at start (blocked seg_O1_C3d_0_60 ?a))
                 (at start (not (not_blocked seg_O1_C3d_0_60 ?a)))
                )
)

(:durative-action move_seg_O1_C3b_0_60_seg_p112_0_76_south_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_O1_C3b_0_60))
                 (at start (not_occupied seg_p112_0_76))
                 (at start (not_blocked seg_p112_0_76 airplane_CFBEG))
                 (at start (not_blocked seg_p112_0_76 airplane_CFBE1))
                 (at start (not_blocked seg_p112_0_76 airplane_CFBE3))
                 (at start (not_blocked seg_p112_0_76 airplane_DAEW8))
                 (at start (not_blocked seg_p112_0_76 airplane_DAEW9))
                 (at start (not_blocked seg_p112_0_76 airplane_DAEW0))
                 (at start (not_blocked seg_p112_0_76 airplane_DAEW3))
                 (at start (not_blocked seg_p112_0_76 airplane_DAEWH))
                 (at start (not_blocked seg_p112_0_76 airplane_DAEW1))
                 (at start (not_blocked seg_p112_0_76 airplane_DAEW2))
                 (at start (not_blocked seg_p112_0_76 airplane_DAEW4))
                 (at start (not_blocked seg_p112_0_76 airplane_DAEW5))
                 (at start (not_blocked seg_p112_0_76 airplane_DAEW6))
                 (at start (not_blocked seg_p112_0_76 airplane_DAEW7))
                 (at start (not_blocked seg_p112_0_76 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_O1_C3b_0_60)))
                 (at end (not_occupied seg_O1_C3b_0_60))
                 (at start (not (at-segment ?a seg_O1_C3b_0_60)))

                 (at start (occupied seg_p112_0_76))
                 (at start (not (not_occupied seg_p112_0_76)))
                 (at start (blocked seg_p112_0_76 ?a))
                 (at start (not (not_blocked seg_p112_0_76 ?a)))
                 (at end (at-segment ?a seg_p112_0_76))

                 (at end (not (blocked seg_O1_C3a_0_34 ?a)))
                 (at end (not_blocked seg_O1_C3a_0_34 ?a))
                 (at end (not (blocked seg_O1_C3c_0_48 ?a)))
                 (at end (not_blocked seg_O1_C3c_0_48 ?a))
                 (at end (not (blocked seg_O1_C3d_0_60 ?a)))
                 (at end (not_blocked seg_O1_C3d_0_60 ?a))

                )
)

(:durative-action move_seg_O1_C3a_0_34_seg_O1_C3b_0_60_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_C3a_0_34))
                 (at start (not_occupied seg_O1_C3b_0_60))
                 (at start (not_blocked seg_O1_C3b_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_O1_C3b_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_O1_C3b_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_O1_C3b_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_O1_C3b_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_O1_C3b_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_O1_C3b_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_O1_C3b_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_O1_C3b_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_O1_C3b_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_O1_C3b_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_O1_C3b_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_O1_C3b_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_O1_C3b_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_O1_C3b_0_60 airplane_CFBE2))

                 (over all (not_occupied seg_O1_C3c_0_48))
                 (over all (not_occupied seg_O1_C3d_0_60))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_C3a_0_34)))
                 (at end (not_occupied seg_O1_C3a_0_34))
                 (at start (not (at-segment ?a seg_O1_C3a_0_34)))

                 (at start (occupied seg_O1_C3b_0_60))
                 (at start (not (not_occupied seg_O1_C3b_0_60)))
                 (at start (blocked seg_O1_C3b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_C3b_0_60 ?a)))
                 (at end (at-segment ?a seg_O1_C3b_0_60))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_O1_111c_0_34 ?a)))
                 (at end (not_blocked seg_O1_111c_0_34 ?a))

                 (at start (blocked seg_O1_C3c_0_48 ?a))
                 (at start (not (not_blocked seg_O1_C3c_0_48 ?a)))
                 (at start (blocked seg_O1_C3d_0_60 ?a))
                 (at start (not (not_blocked seg_O1_C3d_0_60 ?a)))
                )
)

(:durative-action move_seg_p115_0_76_seg_O1_115b_0_60_north_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_p115_0_76))
                 (at start (not_occupied seg_O1_115b_0_60))
                 (at start (not_blocked seg_O1_115b_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_O1_115b_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_O1_115b_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_O1_115b_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_O1_115b_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_O1_115b_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_O1_115b_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_O1_115b_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_O1_115b_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_O1_115b_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_O1_115b_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_O1_115b_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_O1_115b_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_O1_115b_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_O1_115b_0_60 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_p115_0_76)))
                 (at end (not_occupied seg_p115_0_76))
                 (at start (not (at-segment ?a seg_p115_0_76)))

                 (at start (occupied seg_O1_115b_0_60))
                 (at start (not (not_occupied seg_O1_115b_0_60)))
                 (at start (blocked seg_O1_115b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_115b_0_60 ?a)))
                 (at end (at-segment ?a seg_O1_115b_0_60))


                )
)

(:durative-action move_seg_O1_115b_0_60_seg_O1_115a_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_115b_0_60))
                 (at start (not_occupied seg_O1_115a_0_34))
                 (at start (not_blocked seg_O1_115a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_115a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_115a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_115a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_115a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_115a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_115a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_115a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_115a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_115a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_115a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_115a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_115a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_115a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_115a_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_O1_115c_0_34))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_115b_0_60)))
                 (at end (not_occupied seg_O1_115b_0_60))
                 (at start (not (at-segment ?a seg_O1_115b_0_60)))

                 (at start (occupied seg_O1_115a_0_34))
                 (at start (not (not_occupied seg_O1_115a_0_34)))
                 (at start (blocked seg_O1_115a_0_34 ?a))
                 (at start (not (not_blocked seg_O1_115a_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_115a_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_p115_0_76 ?a)))
                 (at end (not_blocked seg_p115_0_76 ?a))

                 (at start (blocked seg_O1_115c_0_34 ?a))
                 (at start (not (not_blocked seg_O1_115c_0_34 ?a)))
                )
)

(:durative-action move_seg_O1_115b_0_60_seg_O1_115c_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_115b_0_60))
                 (at start (not_occupied seg_O1_115c_0_34))
                 (at start (not_blocked seg_O1_115c_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_115c_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_115c_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_115c_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_115c_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_115c_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_115c_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_115c_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_115c_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_115c_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_115c_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_115c_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_115c_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_115c_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_115c_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_O1_115a_0_34))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_115b_0_60)))
                 (at end (not_occupied seg_O1_115b_0_60))
                 (at start (not (at-segment ?a seg_O1_115b_0_60)))

                 (at start (occupied seg_O1_115c_0_34))
                 (at start (not (not_occupied seg_O1_115c_0_34)))
                 (at start (blocked seg_O1_115c_0_34 ?a))
                 (at start (not (not_blocked seg_O1_115c_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_115c_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_p115_0_76 ?a)))
                 (at end (not_blocked seg_p115_0_76 ?a))

                 (at start (blocked seg_O1_115a_0_34 ?a))
                 (at start (not (not_blocked seg_O1_115a_0_34 ?a)))
                )
)

(:durative-action move_seg_O1_115c_0_34_seg_O1_115b_0_60_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_115c_0_34))
                 (at start (not_occupied seg_O1_115b_0_60))
                 (at start (not_blocked seg_O1_115b_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_O1_115b_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_O1_115b_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_O1_115b_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_O1_115b_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_O1_115b_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_O1_115b_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_O1_115b_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_O1_115b_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_O1_115b_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_O1_115b_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_O1_115b_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_O1_115b_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_O1_115b_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_O1_115b_0_60 airplane_CFBE2))

                 (over all (not_occupied seg_O1_115a_0_34))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_115c_0_34)))
                 (at end (not_occupied seg_O1_115c_0_34))
                 (at start (not (at-segment ?a seg_O1_115c_0_34)))

                 (at start (occupied seg_O1_115b_0_60))
                 (at start (not (not_occupied seg_O1_115b_0_60)))
                 (at start (blocked seg_O1_115b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_115b_0_60 ?a)))
                 (at end (at-segment ?a seg_O1_115b_0_60))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_O1_116a_0_34 ?a)))
                 (at end (not_blocked seg_O1_116a_0_34 ?a))

                 (at start (blocked seg_O1_115a_0_34 ?a))
                 (at start (not (not_blocked seg_O1_115a_0_34 ?a)))
                )
)

(:durative-action move_seg_O1_115b_0_60_seg_p115_0_76_south_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_O1_115b_0_60))
                 (at start (not_occupied seg_p115_0_76))
                 (at start (not_blocked seg_p115_0_76 airplane_CFBEG))
                 (at start (not_blocked seg_p115_0_76 airplane_CFBE1))
                 (at start (not_blocked seg_p115_0_76 airplane_CFBE3))
                 (at start (not_blocked seg_p115_0_76 airplane_DAEW8))
                 (at start (not_blocked seg_p115_0_76 airplane_DAEW9))
                 (at start (not_blocked seg_p115_0_76 airplane_DAEW0))
                 (at start (not_blocked seg_p115_0_76 airplane_DAEW3))
                 (at start (not_blocked seg_p115_0_76 airplane_DAEWH))
                 (at start (not_blocked seg_p115_0_76 airplane_DAEW1))
                 (at start (not_blocked seg_p115_0_76 airplane_DAEW2))
                 (at start (not_blocked seg_p115_0_76 airplane_DAEW4))
                 (at start (not_blocked seg_p115_0_76 airplane_DAEW5))
                 (at start (not_blocked seg_p115_0_76 airplane_DAEW6))
                 (at start (not_blocked seg_p115_0_76 airplane_DAEW7))
                 (at start (not_blocked seg_p115_0_76 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_O1_115b_0_60)))
                 (at end (not_occupied seg_O1_115b_0_60))
                 (at start (not (at-segment ?a seg_O1_115b_0_60)))

                 (at start (occupied seg_p115_0_76))
                 (at start (not (not_occupied seg_p115_0_76)))
                 (at start (blocked seg_p115_0_76 ?a))
                 (at start (not (not_blocked seg_p115_0_76 ?a)))
                 (at end (at-segment ?a seg_p115_0_76))

                 (at end (not (blocked seg_O1_115a_0_34 ?a)))
                 (at end (not_blocked seg_O1_115a_0_34 ?a))
                 (at end (not (blocked seg_O1_115c_0_34 ?a)))
                 (at end (not_blocked seg_O1_115c_0_34 ?a))

                )
)

(:durative-action move_seg_O1_115a_0_34_seg_O1_115b_0_60_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_115a_0_34))
                 (at start (not_occupied seg_O1_115b_0_60))
                 (at start (not_blocked seg_O1_115b_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_O1_115b_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_O1_115b_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_O1_115b_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_O1_115b_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_O1_115b_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_O1_115b_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_O1_115b_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_O1_115b_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_O1_115b_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_O1_115b_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_O1_115b_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_O1_115b_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_O1_115b_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_O1_115b_0_60 airplane_CFBE2))

                 (over all (not_occupied seg_O1_115c_0_34))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_115a_0_34)))
                 (at end (not_occupied seg_O1_115a_0_34))
                 (at start (not (at-segment ?a seg_O1_115a_0_34)))

                 (at start (occupied seg_O1_115b_0_60))
                 (at start (not (not_occupied seg_O1_115b_0_60)))
                 (at start (blocked seg_O1_115b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_115b_0_60 ?a)))
                 (at end (at-segment ?a seg_O1_115b_0_60))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_O1_C3c_0_48 ?a)))
                 (at end (not_blocked seg_O1_C3c_0_48 ?a))

                 (at start (blocked seg_O1_115c_0_34 ?a))
                 (at start (not (not_blocked seg_O1_115c_0_34 ?a)))
                )
)

(:durative-action move_seg_p116_0_76_seg_O1_116b_0_60_north_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_p116_0_76))
                 (at start (not_occupied seg_O1_116b_0_60))
                 (at start (not_blocked seg_O1_116b_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_O1_116b_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_O1_116b_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_O1_116b_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_O1_116b_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_O1_116b_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_O1_116b_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_O1_116b_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_O1_116b_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_O1_116b_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_O1_116b_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_O1_116b_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_O1_116b_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_O1_116b_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_O1_116b_0_60 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_p116_0_76)))
                 (at end (not_occupied seg_p116_0_76))
                 (at start (not (at-segment ?a seg_p116_0_76)))

                 (at start (occupied seg_O1_116b_0_60))
                 (at start (not (not_occupied seg_O1_116b_0_60)))
                 (at start (blocked seg_O1_116b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_116b_0_60 ?a)))
                 (at end (at-segment ?a seg_O1_116b_0_60))


                )
)

(:durative-action move_seg_O1_116b_0_60_seg_O1_116a_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_116b_0_60))
                 (at start (not_occupied seg_O1_116a_0_34))
                 (at start (not_blocked seg_O1_116a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_116a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_116a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_116a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_116a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_116a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_116a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_116a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_116a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_116a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_116a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_116a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_116a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_116a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_116a_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_O1_116c_0_34))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_116b_0_60)))
                 (at end (not_occupied seg_O1_116b_0_60))
                 (at start (not (at-segment ?a seg_O1_116b_0_60)))

                 (at start (occupied seg_O1_116a_0_34))
                 (at start (not (not_occupied seg_O1_116a_0_34)))
                 (at start (blocked seg_O1_116a_0_34 ?a))
                 (at start (not (not_blocked seg_O1_116a_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_116a_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_p116_0_76 ?a)))
                 (at end (not_blocked seg_p116_0_76 ?a))

                 (at start (blocked seg_O1_116c_0_34 ?a))
                 (at start (not (not_blocked seg_O1_116c_0_34 ?a)))
                )
)

(:durative-action move_seg_O1_116b_0_60_seg_O1_116c_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_116b_0_60))
                 (at start (not_occupied seg_O1_116c_0_34))
                 (at start (not_blocked seg_O1_116c_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_116c_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_116c_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_116c_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_116c_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_116c_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_116c_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_116c_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_116c_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_116c_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_116c_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_116c_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_116c_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_116c_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_116c_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_O1_116a_0_34))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_116b_0_60)))
                 (at end (not_occupied seg_O1_116b_0_60))
                 (at start (not (at-segment ?a seg_O1_116b_0_60)))

                 (at start (occupied seg_O1_116c_0_34))
                 (at start (not (not_occupied seg_O1_116c_0_34)))
                 (at start (blocked seg_O1_116c_0_34 ?a))
                 (at start (not (not_blocked seg_O1_116c_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_116c_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_p116_0_76 ?a)))
                 (at end (not_blocked seg_p116_0_76 ?a))

                 (at start (blocked seg_O1_116a_0_34 ?a))
                 (at start (not (not_blocked seg_O1_116a_0_34 ?a)))
                )
)

(:durative-action move_seg_O1_116c_0_34_seg_O1_116b_0_60_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_116c_0_34))
                 (at start (not_occupied seg_O1_116b_0_60))
                 (at start (not_blocked seg_O1_116b_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_O1_116b_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_O1_116b_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_O1_116b_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_O1_116b_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_O1_116b_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_O1_116b_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_O1_116b_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_O1_116b_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_O1_116b_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_O1_116b_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_O1_116b_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_O1_116b_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_O1_116b_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_O1_116b_0_60 airplane_CFBE2))

                 (over all (not_occupied seg_O1_116a_0_34))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_116c_0_34)))
                 (at end (not_occupied seg_O1_116c_0_34))
                 (at start (not (at-segment ?a seg_O1_116c_0_34)))

                 (at start (occupied seg_O1_116b_0_60))
                 (at start (not (not_occupied seg_O1_116b_0_60)))
                 (at start (blocked seg_O1_116b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_116b_0_60 ?a)))
                 (at end (at-segment ?a seg_O1_116b_0_60))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_O1_117a_0_34 ?a)))
                 (at end (not_blocked seg_O1_117a_0_34 ?a))

                 (at start (blocked seg_O1_116a_0_34 ?a))
                 (at start (not (not_blocked seg_O1_116a_0_34 ?a)))
                )
)

(:durative-action move_seg_O1_116b_0_60_seg_p116_0_76_south_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_O1_116b_0_60))
                 (at start (not_occupied seg_p116_0_76))
                 (at start (not_blocked seg_p116_0_76 airplane_CFBEG))
                 (at start (not_blocked seg_p116_0_76 airplane_CFBE1))
                 (at start (not_blocked seg_p116_0_76 airplane_CFBE3))
                 (at start (not_blocked seg_p116_0_76 airplane_DAEW8))
                 (at start (not_blocked seg_p116_0_76 airplane_DAEW9))
                 (at start (not_blocked seg_p116_0_76 airplane_DAEW0))
                 (at start (not_blocked seg_p116_0_76 airplane_DAEW3))
                 (at start (not_blocked seg_p116_0_76 airplane_DAEWH))
                 (at start (not_blocked seg_p116_0_76 airplane_DAEW1))
                 (at start (not_blocked seg_p116_0_76 airplane_DAEW2))
                 (at start (not_blocked seg_p116_0_76 airplane_DAEW4))
                 (at start (not_blocked seg_p116_0_76 airplane_DAEW5))
                 (at start (not_blocked seg_p116_0_76 airplane_DAEW6))
                 (at start (not_blocked seg_p116_0_76 airplane_DAEW7))
                 (at start (not_blocked seg_p116_0_76 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_O1_116b_0_60)))
                 (at end (not_occupied seg_O1_116b_0_60))
                 (at start (not (at-segment ?a seg_O1_116b_0_60)))

                 (at start (occupied seg_p116_0_76))
                 (at start (not (not_occupied seg_p116_0_76)))
                 (at start (blocked seg_p116_0_76 ?a))
                 (at start (not (not_blocked seg_p116_0_76 ?a)))
                 (at end (at-segment ?a seg_p116_0_76))

                 (at end (not (blocked seg_O1_116a_0_34 ?a)))
                 (at end (not_blocked seg_O1_116a_0_34 ?a))
                 (at end (not (blocked seg_O1_116c_0_34 ?a)))
                 (at end (not_blocked seg_O1_116c_0_34 ?a))

                )
)

(:durative-action move_seg_O1_116a_0_34_seg_O1_116b_0_60_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_116a_0_34))
                 (at start (not_occupied seg_O1_116b_0_60))
                 (at start (not_blocked seg_O1_116b_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_O1_116b_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_O1_116b_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_O1_116b_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_O1_116b_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_O1_116b_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_O1_116b_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_O1_116b_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_O1_116b_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_O1_116b_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_O1_116b_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_O1_116b_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_O1_116b_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_O1_116b_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_O1_116b_0_60 airplane_CFBE2))

                 (over all (not_occupied seg_O1_116c_0_34))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_116a_0_34)))
                 (at end (not_occupied seg_O1_116a_0_34))
                 (at start (not (at-segment ?a seg_O1_116a_0_34)))

                 (at start (occupied seg_O1_116b_0_60))
                 (at start (not (not_occupied seg_O1_116b_0_60)))
                 (at start (blocked seg_O1_116b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_116b_0_60 ?a)))
                 (at end (at-segment ?a seg_O1_116b_0_60))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_O1_115c_0_34 ?a)))
                 (at end (not_blocked seg_O1_115c_0_34 ?a))

                 (at start (blocked seg_O1_116c_0_34 ?a))
                 (at start (not (not_blocked seg_O1_116c_0_34 ?a)))
                )
)

(:durative-action move_seg_p117_0_76_seg_O1_117b_0_60_north_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_p117_0_76))
                 (at start (not_occupied seg_O1_117b_0_60))
                 (at start (not_blocked seg_O1_117b_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_O1_117b_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_O1_117b_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_O1_117b_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_O1_117b_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_O1_117b_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_O1_117b_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_O1_117b_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_O1_117b_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_O1_117b_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_O1_117b_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_O1_117b_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_O1_117b_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_O1_117b_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_O1_117b_0_60 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_p117_0_76)))
                 (at end (not_occupied seg_p117_0_76))
                 (at start (not (at-segment ?a seg_p117_0_76)))

                 (at start (occupied seg_O1_117b_0_60))
                 (at start (not (not_occupied seg_O1_117b_0_60)))
                 (at start (blocked seg_O1_117b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_117b_0_60 ?a)))
                 (at end (at-segment ?a seg_O1_117b_0_60))


                )
)

(:durative-action move_seg_O1_117b_0_60_seg_O1_117a_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_117b_0_60))
                 (at start (not_occupied seg_O1_117a_0_34))
                 (at start (not_blocked seg_O1_117a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_117a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_117a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_117a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_117a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_117a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_117a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_117a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_117a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_117a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_117a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_117a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_117a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_117a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_117a_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_O1_117c_0_34))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_117b_0_60)))
                 (at end (not_occupied seg_O1_117b_0_60))
                 (at start (not (at-segment ?a seg_O1_117b_0_60)))

                 (at start (occupied seg_O1_117a_0_34))
                 (at start (not (not_occupied seg_O1_117a_0_34)))
                 (at start (blocked seg_O1_117a_0_34 ?a))
                 (at start (not (not_blocked seg_O1_117a_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_117a_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_p117_0_76 ?a)))
                 (at end (not_blocked seg_p117_0_76 ?a))

                 (at start (blocked seg_O1_117c_0_34 ?a))
                 (at start (not (not_blocked seg_O1_117c_0_34 ?a)))
                )
)

(:durative-action move_seg_O1_117b_0_60_seg_O1_117c_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_117b_0_60))
                 (at start (not_occupied seg_O1_117c_0_34))
                 (at start (not_blocked seg_O1_117c_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_117c_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_117c_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_117c_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_117c_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_117c_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_117c_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_117c_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_117c_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_117c_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_117c_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_117c_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_117c_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_117c_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_117c_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_O1_117a_0_34))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_117b_0_60)))
                 (at end (not_occupied seg_O1_117b_0_60))
                 (at start (not (at-segment ?a seg_O1_117b_0_60)))

                 (at start (occupied seg_O1_117c_0_34))
                 (at start (not (not_occupied seg_O1_117c_0_34)))
                 (at start (blocked seg_O1_117c_0_34 ?a))
                 (at start (not (not_blocked seg_O1_117c_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_117c_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_p117_0_76 ?a)))
                 (at end (not_blocked seg_p117_0_76 ?a))

                 (at start (blocked seg_O1_117a_0_34 ?a))
                 (at start (not (not_blocked seg_O1_117a_0_34 ?a)))
                )
)

(:durative-action move_seg_O1_117c_0_34_seg_O1_117b_0_60_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_117c_0_34))
                 (at start (not_occupied seg_O1_117b_0_60))
                 (at start (not_blocked seg_O1_117b_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_O1_117b_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_O1_117b_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_O1_117b_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_O1_117b_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_O1_117b_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_O1_117b_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_O1_117b_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_O1_117b_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_O1_117b_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_O1_117b_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_O1_117b_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_O1_117b_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_O1_117b_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_O1_117b_0_60 airplane_CFBE2))

                 (over all (not_occupied seg_O1_117a_0_34))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_117c_0_34)))
                 (at end (not_occupied seg_O1_117c_0_34))
                 (at start (not (at-segment ?a seg_O1_117c_0_34)))

                 (at start (occupied seg_O1_117b_0_60))
                 (at start (not (not_occupied seg_O1_117b_0_60)))
                 (at start (blocked seg_O1_117b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_117b_0_60 ?a)))
                 (at end (at-segment ?a seg_O1_117b_0_60))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_O1_118a_0_34 ?a)))
                 (at end (not_blocked seg_O1_118a_0_34 ?a))

                 (at start (blocked seg_O1_117a_0_34 ?a))
                 (at start (not (not_blocked seg_O1_117a_0_34 ?a)))
                )
)

(:durative-action move_seg_O1_117b_0_60_seg_p117_0_76_south_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_O1_117b_0_60))
                 (at start (not_occupied seg_p117_0_76))
                 (at start (not_blocked seg_p117_0_76 airplane_CFBEG))
                 (at start (not_blocked seg_p117_0_76 airplane_CFBE1))
                 (at start (not_blocked seg_p117_0_76 airplane_CFBE3))
                 (at start (not_blocked seg_p117_0_76 airplane_DAEW8))
                 (at start (not_blocked seg_p117_0_76 airplane_DAEW9))
                 (at start (not_blocked seg_p117_0_76 airplane_DAEW0))
                 (at start (not_blocked seg_p117_0_76 airplane_DAEW3))
                 (at start (not_blocked seg_p117_0_76 airplane_DAEWH))
                 (at start (not_blocked seg_p117_0_76 airplane_DAEW1))
                 (at start (not_blocked seg_p117_0_76 airplane_DAEW2))
                 (at start (not_blocked seg_p117_0_76 airplane_DAEW4))
                 (at start (not_blocked seg_p117_0_76 airplane_DAEW5))
                 (at start (not_blocked seg_p117_0_76 airplane_DAEW6))
                 (at start (not_blocked seg_p117_0_76 airplane_DAEW7))
                 (at start (not_blocked seg_p117_0_76 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_O1_117b_0_60)))
                 (at end (not_occupied seg_O1_117b_0_60))
                 (at start (not (at-segment ?a seg_O1_117b_0_60)))

                 (at start (occupied seg_p117_0_76))
                 (at start (not (not_occupied seg_p117_0_76)))
                 (at start (blocked seg_p117_0_76 ?a))
                 (at start (not (not_blocked seg_p117_0_76 ?a)))
                 (at end (at-segment ?a seg_p117_0_76))

                 (at end (not (blocked seg_O1_117a_0_34 ?a)))
                 (at end (not_blocked seg_O1_117a_0_34 ?a))
                 (at end (not (blocked seg_O1_117c_0_34 ?a)))
                 (at end (not_blocked seg_O1_117c_0_34 ?a))

                )
)

(:durative-action move_seg_O1_117a_0_34_seg_O1_117b_0_60_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_117a_0_34))
                 (at start (not_occupied seg_O1_117b_0_60))
                 (at start (not_blocked seg_O1_117b_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_O1_117b_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_O1_117b_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_O1_117b_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_O1_117b_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_O1_117b_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_O1_117b_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_O1_117b_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_O1_117b_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_O1_117b_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_O1_117b_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_O1_117b_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_O1_117b_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_O1_117b_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_O1_117b_0_60 airplane_CFBE2))

                 (over all (not_occupied seg_O1_117c_0_34))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_117a_0_34)))
                 (at end (not_occupied seg_O1_117a_0_34))
                 (at start (not (at-segment ?a seg_O1_117a_0_34)))

                 (at start (occupied seg_O1_117b_0_60))
                 (at start (not (not_occupied seg_O1_117b_0_60)))
                 (at start (blocked seg_O1_117b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_117b_0_60 ?a)))
                 (at end (at-segment ?a seg_O1_117b_0_60))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_O1_116c_0_34 ?a)))
                 (at end (not_blocked seg_O1_116c_0_34 ?a))

                 (at start (blocked seg_O1_117c_0_34 ?a))
                 (at start (not (not_blocked seg_O1_117c_0_34 ?a)))
                )
)

(:durative-action move_seg_p118_0_76_seg_O1_118b_0_60_north_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_p118_0_76))
                 (at start (not_occupied seg_O1_118b_0_60))
                 (at start (not_blocked seg_O1_118b_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_O1_118b_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_O1_118b_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_O1_118b_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_O1_118b_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_O1_118b_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_O1_118b_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_O1_118b_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_O1_118b_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_O1_118b_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_O1_118b_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_O1_118b_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_O1_118b_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_O1_118b_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_O1_118b_0_60 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_p118_0_76)))
                 (at end (not_occupied seg_p118_0_76))
                 (at start (not (at-segment ?a seg_p118_0_76)))

                 (at start (occupied seg_O1_118b_0_60))
                 (at start (not (not_occupied seg_O1_118b_0_60)))
                 (at start (blocked seg_O1_118b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_118b_0_60 ?a)))
                 (at end (at-segment ?a seg_O1_118b_0_60))


                )
)

(:durative-action move_seg_O1_118b_0_60_seg_O1_118a_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_118b_0_60))
                 (at start (not_occupied seg_O1_118a_0_34))
                 (at start (not_blocked seg_O1_118a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_118a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_118a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_118a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_118a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_118a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_118a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_118a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_118a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_118a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_118a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_118a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_118a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_118a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_118a_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_O1_118c_0_34))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_118b_0_60)))
                 (at end (not_occupied seg_O1_118b_0_60))
                 (at start (not (at-segment ?a seg_O1_118b_0_60)))

                 (at start (occupied seg_O1_118a_0_34))
                 (at start (not (not_occupied seg_O1_118a_0_34)))
                 (at start (blocked seg_O1_118a_0_34 ?a))
                 (at start (not (not_blocked seg_O1_118a_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_118a_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_p118_0_76 ?a)))
                 (at end (not_blocked seg_p118_0_76 ?a))

                 (at start (blocked seg_O1_118c_0_34 ?a))
                 (at start (not (not_blocked seg_O1_118c_0_34 ?a)))
                )
)

(:durative-action move_seg_O1_118b_0_60_seg_O1_118c_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_118b_0_60))
                 (at start (not_occupied seg_O1_118c_0_34))
                 (at start (not_blocked seg_O1_118c_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_118c_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_118c_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_118c_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_118c_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_118c_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_118c_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_118c_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_118c_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_118c_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_118c_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_118c_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_118c_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_118c_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_118c_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_O1_118a_0_34))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_118b_0_60)))
                 (at end (not_occupied seg_O1_118b_0_60))
                 (at start (not (at-segment ?a seg_O1_118b_0_60)))

                 (at start (occupied seg_O1_118c_0_34))
                 (at start (not (not_occupied seg_O1_118c_0_34)))
                 (at start (blocked seg_O1_118c_0_34 ?a))
                 (at start (not (not_blocked seg_O1_118c_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_118c_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_p118_0_76 ?a)))
                 (at end (not_blocked seg_p118_0_76 ?a))

                 (at start (blocked seg_O1_118a_0_34 ?a))
                 (at start (not (not_blocked seg_O1_118a_0_34 ?a)))
                )
)

(:durative-action move_seg_O1_118c_0_34_seg_O1_118b_0_60_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_118c_0_34))
                 (at start (not_occupied seg_O1_118b_0_60))
                 (at start (not_blocked seg_O1_118b_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_O1_118b_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_O1_118b_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_O1_118b_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_O1_118b_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_O1_118b_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_O1_118b_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_O1_118b_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_O1_118b_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_O1_118b_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_O1_118b_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_O1_118b_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_O1_118b_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_O1_118b_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_O1_118b_0_60 airplane_CFBE2))

                 (over all (not_occupied seg_O1_118a_0_34))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_118c_0_34)))
                 (at end (not_occupied seg_O1_118c_0_34))
                 (at start (not (at-segment ?a seg_O1_118c_0_34)))

                 (at start (occupied seg_O1_118b_0_60))
                 (at start (not (not_occupied seg_O1_118b_0_60)))
                 (at start (blocked seg_O1_118b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_118b_0_60 ?a)))
                 (at end (at-segment ?a seg_O1_118b_0_60))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_O1_C4a_0_34 ?a)))
                 (at end (not_blocked seg_O1_C4a_0_34 ?a))

                 (at start (blocked seg_O1_118a_0_34 ?a))
                 (at start (not (not_blocked seg_O1_118a_0_34 ?a)))
                )
)

(:durative-action move_seg_O1_118b_0_60_seg_p118_0_76_south_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_O1_118b_0_60))
                 (at start (not_occupied seg_p118_0_76))
                 (at start (not_blocked seg_p118_0_76 airplane_CFBEG))
                 (at start (not_blocked seg_p118_0_76 airplane_CFBE1))
                 (at start (not_blocked seg_p118_0_76 airplane_CFBE3))
                 (at start (not_blocked seg_p118_0_76 airplane_DAEW8))
                 (at start (not_blocked seg_p118_0_76 airplane_DAEW9))
                 (at start (not_blocked seg_p118_0_76 airplane_DAEW0))
                 (at start (not_blocked seg_p118_0_76 airplane_DAEW3))
                 (at start (not_blocked seg_p118_0_76 airplane_DAEWH))
                 (at start (not_blocked seg_p118_0_76 airplane_DAEW1))
                 (at start (not_blocked seg_p118_0_76 airplane_DAEW2))
                 (at start (not_blocked seg_p118_0_76 airplane_DAEW4))
                 (at start (not_blocked seg_p118_0_76 airplane_DAEW5))
                 (at start (not_blocked seg_p118_0_76 airplane_DAEW6))
                 (at start (not_blocked seg_p118_0_76 airplane_DAEW7))
                 (at start (not_blocked seg_p118_0_76 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_O1_118b_0_60)))
                 (at end (not_occupied seg_O1_118b_0_60))
                 (at start (not (at-segment ?a seg_O1_118b_0_60)))

                 (at start (occupied seg_p118_0_76))
                 (at start (not (not_occupied seg_p118_0_76)))
                 (at start (blocked seg_p118_0_76 ?a))
                 (at start (not (not_blocked seg_p118_0_76 ?a)))
                 (at end (at-segment ?a seg_p118_0_76))

                 (at end (not (blocked seg_O1_118a_0_34 ?a)))
                 (at end (not_blocked seg_O1_118a_0_34 ?a))
                 (at end (not (blocked seg_O1_118c_0_34 ?a)))
                 (at end (not_blocked seg_O1_118c_0_34 ?a))

                )
)

(:durative-action move_seg_O1_118a_0_34_seg_O1_118b_0_60_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_118a_0_34))
                 (at start (not_occupied seg_O1_118b_0_60))
                 (at start (not_blocked seg_O1_118b_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_O1_118b_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_O1_118b_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_O1_118b_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_O1_118b_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_O1_118b_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_O1_118b_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_O1_118b_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_O1_118b_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_O1_118b_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_O1_118b_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_O1_118b_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_O1_118b_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_O1_118b_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_O1_118b_0_60 airplane_CFBE2))

                 (over all (not_occupied seg_O1_118c_0_34))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_118a_0_34)))
                 (at end (not_occupied seg_O1_118a_0_34))
                 (at start (not (at-segment ?a seg_O1_118a_0_34)))

                 (at start (occupied seg_O1_118b_0_60))
                 (at start (not (not_occupied seg_O1_118b_0_60)))
                 (at start (blocked seg_O1_118b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_118b_0_60 ?a)))
                 (at end (at-segment ?a seg_O1_118b_0_60))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_O1_117c_0_34 ?a)))
                 (at end (not_blocked seg_O1_117c_0_34 ?a))

                 (at start (blocked seg_O1_118c_0_34 ?a))
                 (at start (not (not_blocked seg_O1_118c_0_34 ?a)))
                )
)

(:durative-action move_seg_p119_0_76_seg_O1_C4b_0_60_north_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_p119_0_76))
                 (at start (not_occupied seg_O1_C4b_0_60))
                 (at start (not_blocked seg_O1_C4b_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_O1_C4b_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_O1_C4b_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_O1_C4b_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_O1_C4b_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_O1_C4b_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_O1_C4b_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_O1_C4b_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_O1_C4b_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_O1_C4b_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_O1_C4b_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_O1_C4b_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_O1_C4b_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_O1_C4b_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_O1_C4b_0_60 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_p119_0_76)))
                 (at end (not_occupied seg_p119_0_76))
                 (at start (not (at-segment ?a seg_p119_0_76)))

                 (at start (occupied seg_O1_C4b_0_60))
                 (at start (not (not_occupied seg_O1_C4b_0_60)))
                 (at start (blocked seg_O1_C4b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_C4b_0_60 ?a)))
                 (at end (at-segment ?a seg_O1_C4b_0_60))


                )
)

(:durative-action move_seg_O1_C4b_0_60_seg_O1_C4a_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_C4b_0_60))
                 (at start (not_occupied seg_O1_C4a_0_34))
                 (at start (not_blocked seg_O1_C4a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_C4a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_C4a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_C4a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_C4a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_C4a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_C4a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_C4a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_C4a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_C4a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_C4a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_C4a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_C4a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_C4a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_C4a_0_34 airplane_CFBE2))

                 (over all (not_occupied seg_O1_C4c_0_80))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_C4b_0_60)))
                 (at end (not_occupied seg_O1_C4b_0_60))
                 (at start (not (at-segment ?a seg_O1_C4b_0_60)))

                 (at start (occupied seg_O1_C4a_0_34))
                 (at start (not (not_occupied seg_O1_C4a_0_34)))
                 (at start (blocked seg_O1_C4a_0_34 ?a))
                 (at start (not (not_blocked seg_O1_C4a_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_C4a_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_p119_0_76 ?a)))
                 (at end (not_blocked seg_p119_0_76 ?a))

                 (at start (blocked seg_O1_C4c_0_80 ?a))
                 (at start (not (not_blocked seg_O1_C4c_0_80 ?a)))
                )
)

(:durative-action move_seg_O1_C4b_0_60_seg_O1_C4c_0_80_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_C4b_0_60))
                 (at start (not_occupied seg_O1_C4c_0_80))
                 (at start (not_blocked seg_O1_C4c_0_80 airplane_CFBEG))
                 (at start (not_blocked seg_O1_C4c_0_80 airplane_CFBE1))
                 (at start (not_blocked seg_O1_C4c_0_80 airplane_CFBE3))
                 (at start (not_blocked seg_O1_C4c_0_80 airplane_DAEW8))
                 (at start (not_blocked seg_O1_C4c_0_80 airplane_DAEW9))
                 (at start (not_blocked seg_O1_C4c_0_80 airplane_DAEW0))
                 (at start (not_blocked seg_O1_C4c_0_80 airplane_DAEW3))
                 (at start (not_blocked seg_O1_C4c_0_80 airplane_DAEWH))
                 (at start (not_blocked seg_O1_C4c_0_80 airplane_DAEW1))
                 (at start (not_blocked seg_O1_C4c_0_80 airplane_DAEW2))
                 (at start (not_blocked seg_O1_C4c_0_80 airplane_DAEW4))
                 (at start (not_blocked seg_O1_C4c_0_80 airplane_DAEW5))
                 (at start (not_blocked seg_O1_C4c_0_80 airplane_DAEW6))
                 (at start (not_blocked seg_O1_C4c_0_80 airplane_DAEW7))
                 (at start (not_blocked seg_O1_C4c_0_80 airplane_CFBE2))

                 (over all (not_occupied seg_O1_C4a_0_34))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_C4b_0_60)))
                 (at end (not_occupied seg_O1_C4b_0_60))
                 (at start (not (at-segment ?a seg_O1_C4b_0_60)))

                 (at start (occupied seg_O1_C4c_0_80))
                 (at start (not (not_occupied seg_O1_C4c_0_80)))
                 (at start (blocked seg_O1_C4c_0_80 ?a))
                 (at start (not (not_blocked seg_O1_C4c_0_80 ?a)))
                 (at end (at-segment ?a seg_O1_C4c_0_80))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_p119_0_76 ?a)))
                 (at end (not_blocked seg_p119_0_76 ?a))

                 (at start (blocked seg_O1_C4a_0_34 ?a))
                 (at start (not (not_blocked seg_O1_C4a_0_34 ?a)))
                )
)

(:durative-action move_seg_O1_C4c_0_80_seg_O1_C4b_0_60_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_C4c_0_80))
                 (at start (not_occupied seg_O1_C4b_0_60))
                 (at start (not_blocked seg_O1_C4b_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_O1_C4b_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_O1_C4b_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_O1_C4b_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_O1_C4b_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_O1_C4b_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_O1_C4b_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_O1_C4b_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_O1_C4b_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_O1_C4b_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_O1_C4b_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_O1_C4b_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_O1_C4b_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_O1_C4b_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_O1_C4b_0_60 airplane_CFBE2))

                 (over all (not_occupied seg_O1_C4a_0_34))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_C4c_0_80)))
                 (at end (not_occupied seg_O1_C4c_0_80))
                 (at start (not (at-segment ?a seg_O1_C4c_0_80)))

                 (at start (occupied seg_O1_C4b_0_60))
                 (at start (not (not_occupied seg_O1_C4b_0_60)))
                 (at start (blocked seg_O1_C4b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_C4b_0_60 ?a)))
                 (at end (at-segment ?a seg_O1_C4b_0_60))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_C4_S6a_0_80 ?a)))
                 (at end (not_blocked seg_C4_S6a_0_80 ?a))

                 (at start (blocked seg_O1_C4a_0_34 ?a))
                 (at start (not (not_blocked seg_O1_C4a_0_34 ?a)))
                )
)

(:durative-action move_seg_O1_C4b_0_60_seg_p119_0_76_south_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 2)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_O1_C4b_0_60))
                 (at start (not_occupied seg_p119_0_76))
                 (at start (not_blocked seg_p119_0_76 airplane_CFBEG))
                 (at start (not_blocked seg_p119_0_76 airplane_CFBE1))
                 (at start (not_blocked seg_p119_0_76 airplane_CFBE3))
                 (at start (not_blocked seg_p119_0_76 airplane_DAEW8))
                 (at start (not_blocked seg_p119_0_76 airplane_DAEW9))
                 (at start (not_blocked seg_p119_0_76 airplane_DAEW0))
                 (at start (not_blocked seg_p119_0_76 airplane_DAEW3))
                 (at start (not_blocked seg_p119_0_76 airplane_DAEWH))
                 (at start (not_blocked seg_p119_0_76 airplane_DAEW1))
                 (at start (not_blocked seg_p119_0_76 airplane_DAEW2))
                 (at start (not_blocked seg_p119_0_76 airplane_DAEW4))
                 (at start (not_blocked seg_p119_0_76 airplane_DAEW5))
                 (at start (not_blocked seg_p119_0_76 airplane_DAEW6))
                 (at start (not_blocked seg_p119_0_76 airplane_DAEW7))
                 (at start (not_blocked seg_p119_0_76 airplane_CFBE2))

              )

 :effect        (and
                 (at end (not (occupied seg_O1_C4b_0_60)))
                 (at end (not_occupied seg_O1_C4b_0_60))
                 (at start (not (at-segment ?a seg_O1_C4b_0_60)))

                 (at start (occupied seg_p119_0_76))
                 (at start (not (not_occupied seg_p119_0_76)))
                 (at start (blocked seg_p119_0_76 ?a))
                 (at start (not (not_blocked seg_p119_0_76 ?a)))
                 (at end (at-segment ?a seg_p119_0_76))

                 (at end (not (blocked seg_O1_C4a_0_34 ?a)))
                 (at end (not_blocked seg_O1_C4a_0_34 ?a))
                 (at end (not (blocked seg_O1_C4c_0_80 ?a)))
                 (at end (not_blocked seg_O1_C4c_0_80 ?a))

                )
)

(:durative-action move_seg_O1_C4a_0_34_seg_O1_C4b_0_60_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the speed of an airplane (fixed 30 m/s)
             (= ?duration 1)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-moving ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_C4a_0_34))
                 (at start (not_occupied seg_O1_C4b_0_60))
                 (at start (not_blocked seg_O1_C4b_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_O1_C4b_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_O1_C4b_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_O1_C4b_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_O1_C4b_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_O1_C4b_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_O1_C4b_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_O1_C4b_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_O1_C4b_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_O1_C4b_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_O1_C4b_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_O1_C4b_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_O1_C4b_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_O1_C4b_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_O1_C4b_0_60 airplane_CFBE2))

                 (over all (not_occupied seg_O1_C4c_0_80))
              )

 :effect        (and
                 (at end (not (occupied seg_O1_C4a_0_34)))
                 (at end (not_occupied seg_O1_C4a_0_34))
                 (at start (not (at-segment ?a seg_O1_C4a_0_34)))

                 (at start (occupied seg_O1_C4b_0_60))
                 (at start (not (not_occupied seg_O1_C4b_0_60)))
                 (at start (blocked seg_O1_C4b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_C4b_0_60 ?a)))
                 (at end (at-segment ?a seg_O1_C4b_0_60))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                 (at end (not (blocked seg_O1_118c_0_34 ?a)))
                 (at end (not_blocked seg_O1_118c_0_34 ?a))

                 (at start (blocked seg_O1_C4c_0_80 ?a))
                 (at start (not (not_blocked seg_O1_C4c_0_80 ?a)))
                )
)

(:durative-action pushback_seg_p141_0_75_seg_W1_141b_0_45_south_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the pushbackspeed of an airplane (fixed 5 m/s)
             (= ?duration 15)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-pushing ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_p141_0_75))
                 (at start (not_occupied seg_W1_141b_0_45))
                 (at start (not_blocked seg_W1_141b_0_45 airplane_CFBEG))
                 (at start (not_blocked seg_W1_141b_0_45 airplane_CFBE1))
                 (at start (not_blocked seg_W1_141b_0_45 airplane_CFBE3))
                 (at start (not_blocked seg_W1_141b_0_45 airplane_DAEW8))
                 (at start (not_blocked seg_W1_141b_0_45 airplane_DAEW9))
                 (at start (not_blocked seg_W1_141b_0_45 airplane_DAEW0))
                 (at start (not_blocked seg_W1_141b_0_45 airplane_DAEW3))
                 (at start (not_blocked seg_W1_141b_0_45 airplane_DAEWH))
                 (at start (not_blocked seg_W1_141b_0_45 airplane_DAEW1))
                 (at start (not_blocked seg_W1_141b_0_45 airplane_DAEW2))
                 (at start (not_blocked seg_W1_141b_0_45 airplane_DAEW4))
                 (at start (not_blocked seg_W1_141b_0_45 airplane_DAEW5))
                 (at start (not_blocked seg_W1_141b_0_45 airplane_DAEW6))
                 (at start (not_blocked seg_W1_141b_0_45 airplane_DAEW7))
                 (at start (not_blocked seg_W1_141b_0_45 airplane_CFBE2))
                )

 :effect        (and
                 (at end (not (occupied seg_p141_0_75)))
                 (at end (not_occupied seg_p141_0_75))
                 (at end (not (blocked seg_p141_0_75 ?a)))
                 (at end (not_blocked seg_p141_0_75 ?a))
                 (at start (not (at-segment ?a seg_p141_0_75)))

                 (at start (occupied seg_W1_141b_0_45))
                 (at start (not (not_occupied seg_W1_141b_0_45)))
                 (at start (blocked seg_W1_141b_0_45 ?a))
                 (at start (not (not_blocked seg_W1_141b_0_45 ?a)))
                 (at end (at-segment ?a seg_W1_141b_0_45))

                )
)

(:durative-action pushback_seg_W1_141b_0_45_seg_W1_141a_0_34_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the pushbackspeed of an airplane (fixed 5 m/s)
             (= ?duration 9)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-pushing ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_W1_141b_0_45))
                 (at start (not_occupied seg_W1_141a_0_34))
                 (at start (not_blocked seg_W1_141a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_W1_141a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_W1_141a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_W1_141a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_W1_141a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_W1_141a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_W1_141a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_W1_141a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_W1_141a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_W1_141a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_W1_141a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_W1_141a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_W1_141a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_W1_141a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_W1_141a_0_34 airplane_CFBE2))
                )

 :effect        (and
                 (at end (not (occupied seg_W1_141b_0_45)))
                 (at end (not_occupied seg_W1_141b_0_45))
                 (at end (not (blocked seg_W1_141b_0_45 ?a)))
                 (at end (not_blocked seg_W1_141b_0_45 ?a))
                 (at start (not (at-segment ?a seg_W1_141b_0_45)))

                 (at start (occupied seg_W1_141a_0_34))
                 (at start (not (not_occupied seg_W1_141a_0_34)))
                 (at start (blocked seg_W1_141a_0_34 ?a))
                 (at start (not (not_blocked seg_W1_141a_0_34 ?a)))
                 (at end (at-segment ?a seg_W1_141a_0_34))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                )
)

(:durative-action pushback_seg_W1_141a_0_34_seg_W1_C1c_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the pushbackspeed of an airplane (fixed 5 m/s)
             (= ?duration 6)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-pushing ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_W1_141a_0_34))
                 (at start (not_occupied seg_W1_C1c_0_34))
                 (at start (not_blocked seg_W1_C1c_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_W1_C1c_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_W1_C1c_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_W1_C1c_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_W1_C1c_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_W1_C1c_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_W1_C1c_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_W1_C1c_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_W1_C1c_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_W1_C1c_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_W1_C1c_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_W1_C1c_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_W1_C1c_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_W1_C1c_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_W1_C1c_0_34 airplane_CFBE2))
                )

 :effect        (and
                 (at end (not (occupied seg_W1_141a_0_34)))
                 (at end (not_occupied seg_W1_141a_0_34))
                 (at end (not (blocked seg_W1_141a_0_34 ?a)))
                 (at end (not_blocked seg_W1_141a_0_34 ?a))
                 (at start (not (at-segment ?a seg_W1_141a_0_34)))

                 (at start (occupied seg_W1_C1c_0_34))
                 (at start (not (not_occupied seg_W1_C1c_0_34)))
                 (at start (blocked seg_W1_C1c_0_34 ?a))
                 (at start (not (not_blocked seg_W1_C1c_0_34 ?a)))
                 (at end (at-segment ?a seg_W1_C1c_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                )
)



(:durative-action pushback_seg_W1_141b_0_45_seg_W1_141c_0_34_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the pushbackspeed of an airplane (fixed 5 m/s)
             (= ?duration 9)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-pushing ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_W1_141b_0_45))
                 (at start (not_occupied seg_W1_141c_0_34))
                 (at start (not_blocked seg_W1_141c_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_W1_141c_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_W1_141c_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_W1_141c_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_W1_141c_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_W1_141c_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_W1_141c_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_W1_141c_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_W1_141c_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_W1_141c_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_W1_141c_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_W1_141c_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_W1_141c_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_W1_141c_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_W1_141c_0_34 airplane_CFBE2))
                )

 :effect        (and
                 (at end (not (occupied seg_W1_141b_0_45)))
                 (at end (not_occupied seg_W1_141b_0_45))
                 (at end (not (blocked seg_W1_141b_0_45 ?a)))
                 (at end (not_blocked seg_W1_141b_0_45 ?a))
                 (at start (not (at-segment ?a seg_W1_141b_0_45)))

                 (at start (occupied seg_W1_141c_0_34))
                 (at start (not (not_occupied seg_W1_141c_0_34)))
                 (at start (blocked seg_W1_141c_0_34 ?a))
                 (at start (not (not_blocked seg_W1_141c_0_34 ?a)))
                 (at end (at-segment ?a seg_W1_141c_0_34))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                )
)

(:durative-action pushback_seg_W1_141c_0_34_seg_W1_142a_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the pushbackspeed of an airplane (fixed 5 m/s)
             (= ?duration 6)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-pushing ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_W1_141c_0_34))
                 (at start (not_occupied seg_W1_142a_0_34))
                 (at start (not_blocked seg_W1_142a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_W1_142a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_W1_142a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_W1_142a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_W1_142a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_W1_142a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_W1_142a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_W1_142a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_W1_142a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_W1_142a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_W1_142a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_W1_142a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_W1_142a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_W1_142a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_W1_142a_0_34 airplane_CFBE2))
                )

 :effect        (and
                 (at end (not (occupied seg_W1_141c_0_34)))
                 (at end (not_occupied seg_W1_141c_0_34))
                 (at end (not (blocked seg_W1_141c_0_34 ?a)))
                 (at end (not_blocked seg_W1_141c_0_34 ?a))
                 (at start (not (at-segment ?a seg_W1_141c_0_34)))

                 (at start (occupied seg_W1_142a_0_34))
                 (at start (not (not_occupied seg_W1_142a_0_34)))
                 (at start (blocked seg_W1_142a_0_34 ?a))
                 (at start (not (not_blocked seg_W1_142a_0_34 ?a)))
                 (at end (at-segment ?a seg_W1_142a_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                )
)

(:durative-action pushback_seg_p153_0_75_seg_W1_153b_0_45_south_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the pushbackspeed of an airplane (fixed 5 m/s)
             (= ?duration 15)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-pushing ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_p153_0_75))
                 (at start (not_occupied seg_W1_153b_0_45))
                 (at start (not_blocked seg_W1_153b_0_45 airplane_CFBEG))
                 (at start (not_blocked seg_W1_153b_0_45 airplane_CFBE1))
                 (at start (not_blocked seg_W1_153b_0_45 airplane_CFBE3))
                 (at start (not_blocked seg_W1_153b_0_45 airplane_DAEW8))
                 (at start (not_blocked seg_W1_153b_0_45 airplane_DAEW9))
                 (at start (not_blocked seg_W1_153b_0_45 airplane_DAEW0))
                 (at start (not_blocked seg_W1_153b_0_45 airplane_DAEW3))
                 (at start (not_blocked seg_W1_153b_0_45 airplane_DAEWH))
                 (at start (not_blocked seg_W1_153b_0_45 airplane_DAEW1))
                 (at start (not_blocked seg_W1_153b_0_45 airplane_DAEW2))
                 (at start (not_blocked seg_W1_153b_0_45 airplane_DAEW4))
                 (at start (not_blocked seg_W1_153b_0_45 airplane_DAEW5))
                 (at start (not_blocked seg_W1_153b_0_45 airplane_DAEW6))
                 (at start (not_blocked seg_W1_153b_0_45 airplane_DAEW7))
                 (at start (not_blocked seg_W1_153b_0_45 airplane_CFBE2))
                )

 :effect        (and
                 (at end (not (occupied seg_p153_0_75)))
                 (at end (not_occupied seg_p153_0_75))
                 (at end (not (blocked seg_p153_0_75 ?a)))
                 (at end (not_blocked seg_p153_0_75 ?a))
                 (at start (not (at-segment ?a seg_p153_0_75)))

                 (at start (occupied seg_W1_153b_0_45))
                 (at start (not (not_occupied seg_W1_153b_0_45)))
                 (at start (blocked seg_W1_153b_0_45 ?a))
                 (at start (not (not_blocked seg_W1_153b_0_45 ?a)))
                 (at end (at-segment ?a seg_W1_153b_0_45))

                )
)

(:durative-action pushback_seg_W1_153b_0_45_seg_W1_153a_0_34_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the pushbackspeed of an airplane (fixed 5 m/s)
             (= ?duration 9)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-pushing ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_W1_153b_0_45))
                 (at start (not_occupied seg_W1_153a_0_34))
                 (at start (not_blocked seg_W1_153a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_W1_153a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_W1_153a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_W1_153a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_W1_153a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_W1_153a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_W1_153a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_W1_153a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_W1_153a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_W1_153a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_W1_153a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_W1_153a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_W1_153a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_W1_153a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_W1_153a_0_34 airplane_CFBE2))
                )

 :effect        (and
                 (at end (not (occupied seg_W1_153b_0_45)))
                 (at end (not_occupied seg_W1_153b_0_45))
                 (at end (not (blocked seg_W1_153b_0_45 ?a)))
                 (at end (not_blocked seg_W1_153b_0_45 ?a))
                 (at start (not (at-segment ?a seg_W1_153b_0_45)))

                 (at start (occupied seg_W1_153a_0_34))
                 (at start (not (not_occupied seg_W1_153a_0_34)))
                 (at start (blocked seg_W1_153a_0_34 ?a))
                 (at start (not (not_blocked seg_W1_153a_0_34 ?a)))
                 (at end (at-segment ?a seg_W1_153a_0_34))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                )
)

(:durative-action pushback_seg_W1_153a_0_34_seg_W1_152c_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the pushbackspeed of an airplane (fixed 5 m/s)
             (= ?duration 6)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-pushing ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_W1_153a_0_34))
                 (at start (not_occupied seg_W1_152c_0_34))
                 (at start (not_blocked seg_W1_152c_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_W1_152c_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_W1_152c_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_W1_152c_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_W1_152c_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_W1_152c_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_W1_152c_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_W1_152c_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_W1_152c_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_W1_152c_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_W1_152c_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_W1_152c_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_W1_152c_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_W1_152c_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_W1_152c_0_34 airplane_CFBE2))
                )

 :effect        (and
                 (at end (not (occupied seg_W1_153a_0_34)))
                 (at end (not_occupied seg_W1_153a_0_34))
                 (at end (not (blocked seg_W1_153a_0_34 ?a)))
                 (at end (not_blocked seg_W1_153a_0_34 ?a))
                 (at start (not (at-segment ?a seg_W1_153a_0_34)))

                 (at start (occupied seg_W1_152c_0_34))
                 (at start (not (not_occupied seg_W1_152c_0_34)))
                 (at start (blocked seg_W1_152c_0_34 ?a))
                 (at start (not (not_blocked seg_W1_152c_0_34 ?a)))
                 (at end (at-segment ?a seg_W1_152c_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                )
)



(:durative-action pushback_seg_W1_153b_0_45_seg_W1_153c_0_34_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the pushbackspeed of an airplane (fixed 5 m/s)
             (= ?duration 9)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-pushing ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_W1_153b_0_45))
                 (at start (not_occupied seg_W1_153c_0_34))
                 (at start (not_blocked seg_W1_153c_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_W1_153c_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_W1_153c_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_W1_153c_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_W1_153c_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_W1_153c_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_W1_153c_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_W1_153c_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_W1_153c_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_W1_153c_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_W1_153c_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_W1_153c_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_W1_153c_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_W1_153c_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_W1_153c_0_34 airplane_CFBE2))
                )

 :effect        (and
                 (at end (not (occupied seg_W1_153b_0_45)))
                 (at end (not_occupied seg_W1_153b_0_45))
                 (at end (not (blocked seg_W1_153b_0_45 ?a)))
                 (at end (not_blocked seg_W1_153b_0_45 ?a))
                 (at start (not (at-segment ?a seg_W1_153b_0_45)))

                 (at start (occupied seg_W1_153c_0_34))
                 (at start (not (not_occupied seg_W1_153c_0_34)))
                 (at start (blocked seg_W1_153c_0_34 ?a))
                 (at start (not (not_blocked seg_W1_153c_0_34 ?a)))
                 (at end (at-segment ?a seg_W1_153c_0_34))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                )
)

(:durative-action pushback_seg_W1_153c_0_34_seg_W1_154a_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the pushbackspeed of an airplane (fixed 5 m/s)
             (= ?duration 6)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-pushing ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_W1_153c_0_34))
                 (at start (not_occupied seg_W1_154a_0_34))
                 (at start (not_blocked seg_W1_154a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_W1_154a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_W1_154a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_W1_154a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_W1_154a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_W1_154a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_W1_154a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_W1_154a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_W1_154a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_W1_154a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_W1_154a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_W1_154a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_W1_154a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_W1_154a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_W1_154a_0_34 airplane_CFBE2))
                )

 :effect        (and
                 (at end (not (occupied seg_W1_153c_0_34)))
                 (at end (not_occupied seg_W1_153c_0_34))
                 (at end (not (blocked seg_W1_153c_0_34 ?a)))
                 (at end (not_blocked seg_W1_153c_0_34 ?a))
                 (at start (not (at-segment ?a seg_W1_153c_0_34)))

                 (at start (occupied seg_W1_154a_0_34))
                 (at start (not (not_occupied seg_W1_154a_0_34)))
                 (at start (blocked seg_W1_154a_0_34 ?a))
                 (at start (not (not_blocked seg_W1_154a_0_34 ?a)))
                 (at end (at-segment ?a seg_W1_154a_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                )
)

(:durative-action pushback_seg_p154_0_75_seg_W1_154b_0_45_south_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the pushbackspeed of an airplane (fixed 5 m/s)
             (= ?duration 15)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-pushing ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_p154_0_75))
                 (at start (not_occupied seg_W1_154b_0_45))
                 (at start (not_blocked seg_W1_154b_0_45 airplane_CFBEG))
                 (at start (not_blocked seg_W1_154b_0_45 airplane_CFBE1))
                 (at start (not_blocked seg_W1_154b_0_45 airplane_CFBE3))
                 (at start (not_blocked seg_W1_154b_0_45 airplane_DAEW8))
                 (at start (not_blocked seg_W1_154b_0_45 airplane_DAEW9))
                 (at start (not_blocked seg_W1_154b_0_45 airplane_DAEW0))
                 (at start (not_blocked seg_W1_154b_0_45 airplane_DAEW3))
                 (at start (not_blocked seg_W1_154b_0_45 airplane_DAEWH))
                 (at start (not_blocked seg_W1_154b_0_45 airplane_DAEW1))
                 (at start (not_blocked seg_W1_154b_0_45 airplane_DAEW2))
                 (at start (not_blocked seg_W1_154b_0_45 airplane_DAEW4))
                 (at start (not_blocked seg_W1_154b_0_45 airplane_DAEW5))
                 (at start (not_blocked seg_W1_154b_0_45 airplane_DAEW6))
                 (at start (not_blocked seg_W1_154b_0_45 airplane_DAEW7))
                 (at start (not_blocked seg_W1_154b_0_45 airplane_CFBE2))
                )

 :effect        (and
                 (at end (not (occupied seg_p154_0_75)))
                 (at end (not_occupied seg_p154_0_75))
                 (at end (not (blocked seg_p154_0_75 ?a)))
                 (at end (not_blocked seg_p154_0_75 ?a))
                 (at start (not (at-segment ?a seg_p154_0_75)))

                 (at start (occupied seg_W1_154b_0_45))
                 (at start (not (not_occupied seg_W1_154b_0_45)))
                 (at start (blocked seg_W1_154b_0_45 ?a))
                 (at start (not (not_blocked seg_W1_154b_0_45 ?a)))
                 (at end (at-segment ?a seg_W1_154b_0_45))

                )
)

(:durative-action pushback_seg_W1_154b_0_45_seg_W1_154a_0_34_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the pushbackspeed of an airplane (fixed 5 m/s)
             (= ?duration 9)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-pushing ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_W1_154b_0_45))
                 (at start (not_occupied seg_W1_154a_0_34))
                 (at start (not_blocked seg_W1_154a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_W1_154a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_W1_154a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_W1_154a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_W1_154a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_W1_154a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_W1_154a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_W1_154a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_W1_154a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_W1_154a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_W1_154a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_W1_154a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_W1_154a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_W1_154a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_W1_154a_0_34 airplane_CFBE2))
                )

 :effect        (and
                 (at end (not (occupied seg_W1_154b_0_45)))
                 (at end (not_occupied seg_W1_154b_0_45))
                 (at end (not (blocked seg_W1_154b_0_45 ?a)))
                 (at end (not_blocked seg_W1_154b_0_45 ?a))
                 (at start (not (at-segment ?a seg_W1_154b_0_45)))

                 (at start (occupied seg_W1_154a_0_34))
                 (at start (not (not_occupied seg_W1_154a_0_34)))
                 (at start (blocked seg_W1_154a_0_34 ?a))
                 (at start (not (not_blocked seg_W1_154a_0_34 ?a)))
                 (at end (at-segment ?a seg_W1_154a_0_34))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                )
)

(:durative-action pushback_seg_W1_154a_0_34_seg_W1_153c_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the pushbackspeed of an airplane (fixed 5 m/s)
             (= ?duration 6)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-pushing ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_W1_154a_0_34))
                 (at start (not_occupied seg_W1_153c_0_34))
                 (at start (not_blocked seg_W1_153c_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_W1_153c_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_W1_153c_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_W1_153c_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_W1_153c_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_W1_153c_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_W1_153c_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_W1_153c_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_W1_153c_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_W1_153c_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_W1_153c_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_W1_153c_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_W1_153c_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_W1_153c_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_W1_153c_0_34 airplane_CFBE2))
                )

 :effect        (and
                 (at end (not (occupied seg_W1_154a_0_34)))
                 (at end (not_occupied seg_W1_154a_0_34))
                 (at end (not (blocked seg_W1_154a_0_34 ?a)))
                 (at end (not_blocked seg_W1_154a_0_34 ?a))
                 (at start (not (at-segment ?a seg_W1_154a_0_34)))

                 (at start (occupied seg_W1_153c_0_34))
                 (at start (not (not_occupied seg_W1_153c_0_34)))
                 (at start (blocked seg_W1_153c_0_34 ?a))
                 (at start (not (not_blocked seg_W1_153c_0_34 ?a)))
                 (at end (at-segment ?a seg_W1_153c_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                )
)



(:durative-action pushback_seg_W1_154b_0_45_seg_W1_154c_0_34_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the pushbackspeed of an airplane (fixed 5 m/s)
             (= ?duration 9)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-pushing ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_W1_154b_0_45))
                 (at start (not_occupied seg_W1_154c_0_34))
                 (at start (not_blocked seg_W1_154c_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_W1_154c_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_W1_154c_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_W1_154c_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_W1_154c_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_W1_154c_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_W1_154c_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_W1_154c_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_W1_154c_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_W1_154c_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_W1_154c_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_W1_154c_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_W1_154c_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_W1_154c_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_W1_154c_0_34 airplane_CFBE2))
                )

 :effect        (and
                 (at end (not (occupied seg_W1_154b_0_45)))
                 (at end (not_occupied seg_W1_154b_0_45))
                 (at end (not (blocked seg_W1_154b_0_45 ?a)))
                 (at end (not_blocked seg_W1_154b_0_45 ?a))
                 (at start (not (at-segment ?a seg_W1_154b_0_45)))

                 (at start (occupied seg_W1_154c_0_34))
                 (at start (not (not_occupied seg_W1_154c_0_34)))
                 (at start (blocked seg_W1_154c_0_34 ?a))
                 (at start (not (not_blocked seg_W1_154c_0_34 ?a)))
                 (at end (at-segment ?a seg_W1_154c_0_34))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                )
)

(:durative-action pushback_seg_W1_154c_0_34_seg_W1_C3a_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the pushbackspeed of an airplane (fixed 5 m/s)
             (= ?duration 6)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-pushing ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_W1_154c_0_34))
                 (at start (not_occupied seg_W1_C3a_0_34))
                 (at start (not_blocked seg_W1_C3a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_W1_C3a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_W1_C3a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_W1_C3a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_W1_C3a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_W1_C3a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_W1_C3a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_W1_C3a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_W1_C3a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_W1_C3a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_W1_C3a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_W1_C3a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_W1_C3a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_W1_C3a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_W1_C3a_0_34 airplane_CFBE2))
                )

 :effect        (and
                 (at end (not (occupied seg_W1_154c_0_34)))
                 (at end (not_occupied seg_W1_154c_0_34))
                 (at end (not (blocked seg_W1_154c_0_34 ?a)))
                 (at end (not_blocked seg_W1_154c_0_34 ?a))
                 (at start (not (at-segment ?a seg_W1_154c_0_34)))

                 (at start (occupied seg_W1_C3a_0_34))
                 (at start (not (not_occupied seg_W1_C3a_0_34)))
                 (at start (blocked seg_W1_C3a_0_34 ?a))
                 (at start (not (not_blocked seg_W1_C3a_0_34 ?a)))
                 (at end (at-segment ?a seg_W1_C3a_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                )
)

(:durative-action pushback_seg_p163_0_75_seg_W1_163b_0_45_south_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the pushbackspeed of an airplane (fixed 5 m/s)
             (= ?duration 15)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-pushing ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_p163_0_75))
                 (at start (not_occupied seg_W1_163b_0_45))
                 (at start (not_blocked seg_W1_163b_0_45 airplane_CFBEG))
                 (at start (not_blocked seg_W1_163b_0_45 airplane_CFBE1))
                 (at start (not_blocked seg_W1_163b_0_45 airplane_CFBE3))
                 (at start (not_blocked seg_W1_163b_0_45 airplane_DAEW8))
                 (at start (not_blocked seg_W1_163b_0_45 airplane_DAEW9))
                 (at start (not_blocked seg_W1_163b_0_45 airplane_DAEW0))
                 (at start (not_blocked seg_W1_163b_0_45 airplane_DAEW3))
                 (at start (not_blocked seg_W1_163b_0_45 airplane_DAEWH))
                 (at start (not_blocked seg_W1_163b_0_45 airplane_DAEW1))
                 (at start (not_blocked seg_W1_163b_0_45 airplane_DAEW2))
                 (at start (not_blocked seg_W1_163b_0_45 airplane_DAEW4))
                 (at start (not_blocked seg_W1_163b_0_45 airplane_DAEW5))
                 (at start (not_blocked seg_W1_163b_0_45 airplane_DAEW6))
                 (at start (not_blocked seg_W1_163b_0_45 airplane_DAEW7))
                 (at start (not_blocked seg_W1_163b_0_45 airplane_CFBE2))
                )

 :effect        (and
                 (at end (not (occupied seg_p163_0_75)))
                 (at end (not_occupied seg_p163_0_75))
                 (at end (not (blocked seg_p163_0_75 ?a)))
                 (at end (not_blocked seg_p163_0_75 ?a))
                 (at start (not (at-segment ?a seg_p163_0_75)))

                 (at start (occupied seg_W1_163b_0_45))
                 (at start (not (not_occupied seg_W1_163b_0_45)))
                 (at start (blocked seg_W1_163b_0_45 ?a))
                 (at start (not (not_blocked seg_W1_163b_0_45 ?a)))
                 (at end (at-segment ?a seg_W1_163b_0_45))

                )
)

(:durative-action pushback_seg_W1_163b_0_45_seg_W1_163a_0_34_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the pushbackspeed of an airplane (fixed 5 m/s)
             (= ?duration 9)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-pushing ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_W1_163b_0_45))
                 (at start (not_occupied seg_W1_163a_0_34))
                 (at start (not_blocked seg_W1_163a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_W1_163a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_W1_163a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_W1_163a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_W1_163a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_W1_163a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_W1_163a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_W1_163a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_W1_163a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_W1_163a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_W1_163a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_W1_163a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_W1_163a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_W1_163a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_W1_163a_0_34 airplane_CFBE2))
                )

 :effect        (and
                 (at end (not (occupied seg_W1_163b_0_45)))
                 (at end (not_occupied seg_W1_163b_0_45))
                 (at end (not (blocked seg_W1_163b_0_45 ?a)))
                 (at end (not_blocked seg_W1_163b_0_45 ?a))
                 (at start (not (at-segment ?a seg_W1_163b_0_45)))

                 (at start (occupied seg_W1_163a_0_34))
                 (at start (not (not_occupied seg_W1_163a_0_34)))
                 (at start (blocked seg_W1_163a_0_34 ?a))
                 (at start (not (not_blocked seg_W1_163a_0_34 ?a)))
                 (at end (at-segment ?a seg_W1_163a_0_34))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                )
)

(:durative-action pushback_seg_W1_163a_0_34_seg_W1_162c_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the pushbackspeed of an airplane (fixed 5 m/s)
             (= ?duration 6)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-pushing ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_W1_163a_0_34))
                 (at start (not_occupied seg_W1_162c_0_34))
                 (at start (not_blocked seg_W1_162c_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_W1_162c_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_W1_162c_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_W1_162c_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_W1_162c_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_W1_162c_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_W1_162c_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_W1_162c_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_W1_162c_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_W1_162c_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_W1_162c_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_W1_162c_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_W1_162c_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_W1_162c_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_W1_162c_0_34 airplane_CFBE2))
                )

 :effect        (and
                 (at end (not (occupied seg_W1_163a_0_34)))
                 (at end (not_occupied seg_W1_163a_0_34))
                 (at end (not (blocked seg_W1_163a_0_34 ?a)))
                 (at end (not_blocked seg_W1_163a_0_34 ?a))
                 (at start (not (at-segment ?a seg_W1_163a_0_34)))

                 (at start (occupied seg_W1_162c_0_34))
                 (at start (not (not_occupied seg_W1_162c_0_34)))
                 (at start (blocked seg_W1_162c_0_34 ?a))
                 (at start (not (not_blocked seg_W1_162c_0_34 ?a)))
                 (at end (at-segment ?a seg_W1_162c_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                )
)



(:durative-action pushback_seg_W1_163b_0_45_seg_W1_163c_0_34_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the pushbackspeed of an airplane (fixed 5 m/s)
             (= ?duration 9)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-pushing ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_W1_163b_0_45))
                 (at start (not_occupied seg_W1_163c_0_34))
                 (at start (not_blocked seg_W1_163c_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_W1_163c_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_W1_163c_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_W1_163c_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_W1_163c_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_W1_163c_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_W1_163c_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_W1_163c_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_W1_163c_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_W1_163c_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_W1_163c_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_W1_163c_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_W1_163c_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_W1_163c_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_W1_163c_0_34 airplane_CFBE2))
                )

 :effect        (and
                 (at end (not (occupied seg_W1_163b_0_45)))
                 (at end (not_occupied seg_W1_163b_0_45))
                 (at end (not (blocked seg_W1_163b_0_45 ?a)))
                 (at end (not_blocked seg_W1_163b_0_45 ?a))
                 (at start (not (at-segment ?a seg_W1_163b_0_45)))

                 (at start (occupied seg_W1_163c_0_34))
                 (at start (not (not_occupied seg_W1_163c_0_34)))
                 (at start (blocked seg_W1_163c_0_34 ?a))
                 (at start (not (not_blocked seg_W1_163c_0_34 ?a)))
                 (at end (at-segment ?a seg_W1_163c_0_34))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                )
)

(:durative-action pushback_seg_W1_163c_0_34_seg_W1_164a_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the pushbackspeed of an airplane (fixed 5 m/s)
             (= ?duration 6)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-pushing ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_W1_163c_0_34))
                 (at start (not_occupied seg_W1_164a_0_34))
                 (at start (not_blocked seg_W1_164a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_W1_164a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_W1_164a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_W1_164a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_W1_164a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_W1_164a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_W1_164a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_W1_164a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_W1_164a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_W1_164a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_W1_164a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_W1_164a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_W1_164a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_W1_164a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_W1_164a_0_34 airplane_CFBE2))
                )

 :effect        (and
                 (at end (not (occupied seg_W1_163c_0_34)))
                 (at end (not_occupied seg_W1_163c_0_34))
                 (at end (not (blocked seg_W1_163c_0_34 ?a)))
                 (at end (not_blocked seg_W1_163c_0_34 ?a))
                 (at start (not (at-segment ?a seg_W1_163c_0_34)))

                 (at start (occupied seg_W1_164a_0_34))
                 (at start (not (not_occupied seg_W1_164a_0_34)))
                 (at start (blocked seg_W1_164a_0_34 ?a))
                 (at start (not (not_blocked seg_W1_164a_0_34 ?a)))
                 (at end (at-segment ?a seg_W1_164a_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                )
)

(:durative-action pushback_seg_p101_0_76_seg_O1_C1a_0_60_south_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the pushbackspeed of an airplane (fixed 5 m/s)
             (= ?duration 15)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-pushing ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_p101_0_76))
                 (at start (not_occupied seg_O1_C1a_0_60))
                 (at start (not_blocked seg_O1_C1a_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_O1_C1a_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_O1_C1a_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_O1_C1a_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_O1_C1a_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_O1_C1a_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_O1_C1a_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_O1_C1a_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_O1_C1a_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_O1_C1a_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_O1_C1a_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_O1_C1a_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_O1_C1a_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_O1_C1a_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_O1_C1a_0_60 airplane_CFBE2))
                )

 :effect        (and
                 (at end (not (occupied seg_p101_0_76)))
                 (at end (not_occupied seg_p101_0_76))
                 (at end (not (blocked seg_p101_0_76 ?a)))
                 (at end (not_blocked seg_p101_0_76 ?a))
                 (at start (not (at-segment ?a seg_p101_0_76)))

                 (at start (occupied seg_O1_C1a_0_60))
                 (at start (not (not_occupied seg_O1_C1a_0_60)))
                 (at start (blocked seg_O1_C1a_0_60 ?a))
                 (at start (not (not_blocked seg_O1_C1a_0_60 ?a)))
                 (at end (at-segment ?a seg_O1_C1a_0_60))

                )
)

(:durative-action pushback_seg_O1_C1a_0_60_seg_O1_C1c_0_80_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the pushbackspeed of an airplane (fixed 5 m/s)
             (= ?duration 12)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-pushing ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_O1_C1a_0_60))
                 (at start (not_occupied seg_O1_C1c_0_80))
                 (at start (not_blocked seg_O1_C1c_0_80 airplane_CFBEG))
                 (at start (not_blocked seg_O1_C1c_0_80 airplane_CFBE1))
                 (at start (not_blocked seg_O1_C1c_0_80 airplane_CFBE3))
                 (at start (not_blocked seg_O1_C1c_0_80 airplane_DAEW8))
                 (at start (not_blocked seg_O1_C1c_0_80 airplane_DAEW9))
                 (at start (not_blocked seg_O1_C1c_0_80 airplane_DAEW0))
                 (at start (not_blocked seg_O1_C1c_0_80 airplane_DAEW3))
                 (at start (not_blocked seg_O1_C1c_0_80 airplane_DAEWH))
                 (at start (not_blocked seg_O1_C1c_0_80 airplane_DAEW1))
                 (at start (not_blocked seg_O1_C1c_0_80 airplane_DAEW2))
                 (at start (not_blocked seg_O1_C1c_0_80 airplane_DAEW4))
                 (at start (not_blocked seg_O1_C1c_0_80 airplane_DAEW5))
                 (at start (not_blocked seg_O1_C1c_0_80 airplane_DAEW6))
                 (at start (not_blocked seg_O1_C1c_0_80 airplane_DAEW7))
                 (at start (not_blocked seg_O1_C1c_0_80 airplane_CFBE2))
                )

 :effect        (and
                 (at end (not (occupied seg_O1_C1a_0_60)))
                 (at end (not_occupied seg_O1_C1a_0_60))
                 (at end (not (blocked seg_O1_C1a_0_60 ?a)))
                 (at end (not_blocked seg_O1_C1a_0_60 ?a))
                 (at start (not (at-segment ?a seg_O1_C1a_0_60)))

                 (at start (occupied seg_O1_C1c_0_80))
                 (at start (not (not_occupied seg_O1_C1c_0_80)))
                 (at start (blocked seg_O1_C1c_0_80 ?a))
                 (at start (not (not_blocked seg_O1_C1c_0_80 ?a)))
                 (at end (at-segment ?a seg_O1_C1c_0_80))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                )
)

(:durative-action pushback_seg_O1_C1c_0_80_seg_C1_n2b_0_80_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the pushbackspeed of an airplane (fixed 5 m/s)
             (= ?duration 16)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-pushing ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_C1c_0_80))
                 (at start (not_occupied seg_C1_n2b_0_80))
                 (at start (not_blocked seg_C1_n2b_0_80 airplane_CFBEG))
                 (at start (not_blocked seg_C1_n2b_0_80 airplane_CFBE1))
                 (at start (not_blocked seg_C1_n2b_0_80 airplane_CFBE3))
                 (at start (not_blocked seg_C1_n2b_0_80 airplane_DAEW8))
                 (at start (not_blocked seg_C1_n2b_0_80 airplane_DAEW9))
                 (at start (not_blocked seg_C1_n2b_0_80 airplane_DAEW0))
                 (at start (not_blocked seg_C1_n2b_0_80 airplane_DAEW3))
                 (at start (not_blocked seg_C1_n2b_0_80 airplane_DAEWH))
                 (at start (not_blocked seg_C1_n2b_0_80 airplane_DAEW1))
                 (at start (not_blocked seg_C1_n2b_0_80 airplane_DAEW2))
                 (at start (not_blocked seg_C1_n2b_0_80 airplane_DAEW4))
                 (at start (not_blocked seg_C1_n2b_0_80 airplane_DAEW5))
                 (at start (not_blocked seg_C1_n2b_0_80 airplane_DAEW6))
                 (at start (not_blocked seg_C1_n2b_0_80 airplane_DAEW7))
                 (at start (not_blocked seg_C1_n2b_0_80 airplane_CFBE2))
                )

 :effect        (and
                 (at end (not (occupied seg_O1_C1c_0_80)))
                 (at end (not_occupied seg_O1_C1c_0_80))
                 (at end (not (blocked seg_O1_C1c_0_80 ?a)))
                 (at end (not_blocked seg_O1_C1c_0_80 ?a))
                 (at start (not (at-segment ?a seg_O1_C1c_0_80)))

                 (at start (occupied seg_C1_n2b_0_80))
                 (at start (not (not_occupied seg_C1_n2b_0_80)))
                 (at start (blocked seg_C1_n2b_0_80 ?a))
                 (at start (not (not_blocked seg_C1_n2b_0_80 ?a)))
                 (at end (at-segment ?a seg_C1_n2b_0_80))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                )
)



(:durative-action pushback_seg_O1_C1a_0_60_seg_O1_C1b_0_34_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the pushbackspeed of an airplane (fixed 5 m/s)
             (= ?duration 12)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-pushing ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_O1_C1a_0_60))
                 (at start (not_occupied seg_O1_C1b_0_34))
                 (at start (not_blocked seg_O1_C1b_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_C1b_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_C1b_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_C1b_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_C1b_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_C1b_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_C1b_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_C1b_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_C1b_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_C1b_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_C1b_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_C1b_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_C1b_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_C1b_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_C1b_0_34 airplane_CFBE2))
                )

 :effect        (and
                 (at end (not (occupied seg_O1_C1a_0_60)))
                 (at end (not_occupied seg_O1_C1a_0_60))
                 (at end (not (blocked seg_O1_C1a_0_60 ?a)))
                 (at end (not_blocked seg_O1_C1a_0_60 ?a))
                 (at start (not (at-segment ?a seg_O1_C1a_0_60)))

                 (at start (occupied seg_O1_C1b_0_34))
                 (at start (not (not_occupied seg_O1_C1b_0_34)))
                 (at start (blocked seg_O1_C1b_0_34 ?a))
                 (at start (not (not_blocked seg_O1_C1b_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_C1b_0_34))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                )
)

(:durative-action pushback_seg_O1_C1b_0_34_seg_O1_102a_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the pushbackspeed of an airplane (fixed 5 m/s)
             (= ?duration 6)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-pushing ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_C1b_0_34))
                 (at start (not_occupied seg_O1_102a_0_34))
                 (at start (not_blocked seg_O1_102a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_102a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_102a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_102a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_102a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_102a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_102a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_102a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_102a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_102a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_102a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_102a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_102a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_102a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_102a_0_34 airplane_CFBE2))
                )

 :effect        (and
                 (at end (not (occupied seg_O1_C1b_0_34)))
                 (at end (not_occupied seg_O1_C1b_0_34))
                 (at end (not (blocked seg_O1_C1b_0_34 ?a)))
                 (at end (not_blocked seg_O1_C1b_0_34 ?a))
                 (at start (not (at-segment ?a seg_O1_C1b_0_34)))

                 (at start (occupied seg_O1_102a_0_34))
                 (at start (not (not_occupied seg_O1_102a_0_34)))
                 (at start (blocked seg_O1_102a_0_34 ?a))
                 (at start (not (not_blocked seg_O1_102a_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_102a_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                )
)

(:durative-action pushback_seg_p107_0_76_seg_O1_C2b_0_60_south_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the pushbackspeed of an airplane (fixed 5 m/s)
             (= ?duration 15)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-pushing ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_p107_0_76))
                 (at start (not_occupied seg_O1_C2b_0_60))
                 (at start (not_blocked seg_O1_C2b_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_O1_C2b_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_O1_C2b_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_O1_C2b_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_O1_C2b_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_O1_C2b_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_O1_C2b_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_O1_C2b_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_O1_C2b_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_O1_C2b_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_O1_C2b_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_O1_C2b_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_O1_C2b_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_O1_C2b_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_O1_C2b_0_60 airplane_CFBE2))
                )

 :effect        (and
                 (at end (not (occupied seg_p107_0_76)))
                 (at end (not_occupied seg_p107_0_76))
                 (at end (not (blocked seg_p107_0_76 ?a)))
                 (at end (not_blocked seg_p107_0_76 ?a))
                 (at start (not (at-segment ?a seg_p107_0_76)))

                 (at start (occupied seg_O1_C2b_0_60))
                 (at start (not (not_occupied seg_O1_C2b_0_60)))
                 (at start (blocked seg_O1_C2b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_C2b_0_60 ?a)))
                 (at end (at-segment ?a seg_O1_C2b_0_60))

                )
)

(:durative-action pushback_seg_O1_C2b_0_60_seg_O1_C2d_0_60_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the pushbackspeed of an airplane (fixed 5 m/s)
             (= ?duration 12)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-pushing ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_O1_C2b_0_60))
                 (at start (not_occupied seg_O1_C2d_0_60))
                 (at start (not_blocked seg_O1_C2d_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_O1_C2d_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_O1_C2d_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_O1_C2d_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_O1_C2d_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_O1_C2d_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_O1_C2d_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_O1_C2d_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_O1_C2d_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_O1_C2d_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_O1_C2d_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_O1_C2d_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_O1_C2d_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_O1_C2d_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_O1_C2d_0_60 airplane_CFBE2))
                )

 :effect        (and
                 (at end (not (occupied seg_O1_C2b_0_60)))
                 (at end (not_occupied seg_O1_C2b_0_60))
                 (at end (not (blocked seg_O1_C2b_0_60 ?a)))
                 (at end (not_blocked seg_O1_C2b_0_60 ?a))
                 (at start (not (at-segment ?a seg_O1_C2b_0_60)))

                 (at start (occupied seg_O1_C2d_0_60))
                 (at start (not (not_occupied seg_O1_C2d_0_60)))
                 (at start (blocked seg_O1_C2d_0_60 ?a))
                 (at start (not (not_blocked seg_O1_C2d_0_60 ?a)))
                 (at end (at-segment ?a seg_O1_C2d_0_60))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                )
)

(:durative-action pushback_seg_O1_C2d_0_60_seg_C2_b_0_80_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the pushbackspeed of an airplane (fixed 5 m/s)
             (= ?duration 12)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-pushing ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_C2d_0_60))
                 (at start (not_occupied seg_C2_b_0_80))
                 (at start (not_blocked seg_C2_b_0_80 airplane_CFBEG))
                 (at start (not_blocked seg_C2_b_0_80 airplane_CFBE1))
                 (at start (not_blocked seg_C2_b_0_80 airplane_CFBE3))
                 (at start (not_blocked seg_C2_b_0_80 airplane_DAEW8))
                 (at start (not_blocked seg_C2_b_0_80 airplane_DAEW9))
                 (at start (not_blocked seg_C2_b_0_80 airplane_DAEW0))
                 (at start (not_blocked seg_C2_b_0_80 airplane_DAEW3))
                 (at start (not_blocked seg_C2_b_0_80 airplane_DAEWH))
                 (at start (not_blocked seg_C2_b_0_80 airplane_DAEW1))
                 (at start (not_blocked seg_C2_b_0_80 airplane_DAEW2))
                 (at start (not_blocked seg_C2_b_0_80 airplane_DAEW4))
                 (at start (not_blocked seg_C2_b_0_80 airplane_DAEW5))
                 (at start (not_blocked seg_C2_b_0_80 airplane_DAEW6))
                 (at start (not_blocked seg_C2_b_0_80 airplane_DAEW7))
                 (at start (not_blocked seg_C2_b_0_80 airplane_CFBE2))
                )

 :effect        (and
                 (at end (not (occupied seg_O1_C2d_0_60)))
                 (at end (not_occupied seg_O1_C2d_0_60))
                 (at end (not (blocked seg_O1_C2d_0_60 ?a)))
                 (at end (not_blocked seg_O1_C2d_0_60 ?a))
                 (at start (not (at-segment ?a seg_O1_C2d_0_60)))

                 (at start (occupied seg_C2_b_0_80))
                 (at start (not (not_occupied seg_C2_b_0_80)))
                 (at start (blocked seg_C2_b_0_80 ?a))
                 (at start (not (not_blocked seg_C2_b_0_80 ?a)))
                 (at end (at-segment ?a seg_C2_b_0_80))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                )
)







(:durative-action pushback_seg_p131_0_75_seg_O1_108d_0_45_south_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the pushbackspeed of an airplane (fixed 5 m/s)
             (= ?duration 15)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-pushing ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_p131_0_75))
                 (at start (not_occupied seg_O1_108d_0_45))
                 (at start (not_blocked seg_O1_108d_0_45 airplane_CFBEG))
                 (at start (not_blocked seg_O1_108d_0_45 airplane_CFBE1))
                 (at start (not_blocked seg_O1_108d_0_45 airplane_CFBE3))
                 (at start (not_blocked seg_O1_108d_0_45 airplane_DAEW8))
                 (at start (not_blocked seg_O1_108d_0_45 airplane_DAEW9))
                 (at start (not_blocked seg_O1_108d_0_45 airplane_DAEW0))
                 (at start (not_blocked seg_O1_108d_0_45 airplane_DAEW3))
                 (at start (not_blocked seg_O1_108d_0_45 airplane_DAEWH))
                 (at start (not_blocked seg_O1_108d_0_45 airplane_DAEW1))
                 (at start (not_blocked seg_O1_108d_0_45 airplane_DAEW2))
                 (at start (not_blocked seg_O1_108d_0_45 airplane_DAEW4))
                 (at start (not_blocked seg_O1_108d_0_45 airplane_DAEW5))
                 (at start (not_blocked seg_O1_108d_0_45 airplane_DAEW6))
                 (at start (not_blocked seg_O1_108d_0_45 airplane_DAEW7))
                 (at start (not_blocked seg_O1_108d_0_45 airplane_CFBE2))
                )

 :effect        (and
                 (at end (not (occupied seg_p131_0_75)))
                 (at end (not_occupied seg_p131_0_75))
                 (at end (not (blocked seg_p131_0_75 ?a)))
                 (at end (not_blocked seg_p131_0_75 ?a))
                 (at start (not (at-segment ?a seg_p131_0_75)))

                 (at start (occupied seg_O1_108d_0_45))
                 (at start (not (not_occupied seg_O1_108d_0_45)))
                 (at start (blocked seg_O1_108d_0_45 ?a))
                 (at start (not (not_blocked seg_O1_108d_0_45 ?a)))
                 (at end (at-segment ?a seg_O1_108d_0_45))

                )
)

(:durative-action pushback_seg_O1_108d_0_45_seg_O1_108a_0_34_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the pushbackspeed of an airplane (fixed 5 m/s)
             (= ?duration 9)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-pushing ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_O1_108d_0_45))
                 (at start (not_occupied seg_O1_108a_0_34))
                 (at start (not_blocked seg_O1_108a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_108a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_108a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_108a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_108a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_108a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_108a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_108a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_108a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_108a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_108a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_108a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_108a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_108a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_108a_0_34 airplane_CFBE2))
                )

 :effect        (and
                 (at end (not (occupied seg_O1_108d_0_45)))
                 (at end (not_occupied seg_O1_108d_0_45))
                 (at end (not (blocked seg_O1_108d_0_45 ?a)))
                 (at end (not_blocked seg_O1_108d_0_45 ?a))
                 (at start (not (at-segment ?a seg_O1_108d_0_45)))

                 (at start (occupied seg_O1_108a_0_34))
                 (at start (not (not_occupied seg_O1_108a_0_34)))
                 (at start (blocked seg_O1_108a_0_34 ?a))
                 (at start (not (not_blocked seg_O1_108a_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_108a_0_34))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                )
)

(:durative-action pushback_seg_O1_108a_0_34_seg_O1_C2c_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the pushbackspeed of an airplane (fixed 5 m/s)
             (= ?duration 6)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-pushing ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_108a_0_34))
                 (at start (not_occupied seg_O1_C2c_0_34))
                 (at start (not_blocked seg_O1_C2c_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_C2c_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_C2c_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_C2c_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_C2c_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_C2c_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_C2c_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_C2c_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_C2c_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_C2c_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_C2c_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_C2c_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_C2c_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_C2c_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_C2c_0_34 airplane_CFBE2))
                )

 :effect        (and
                 (at end (not (occupied seg_O1_108a_0_34)))
                 (at end (not_occupied seg_O1_108a_0_34))
                 (at end (not (blocked seg_O1_108a_0_34 ?a)))
                 (at end (not_blocked seg_O1_108a_0_34 ?a))
                 (at start (not (at-segment ?a seg_O1_108a_0_34)))

                 (at start (occupied seg_O1_C2c_0_34))
                 (at start (not (not_occupied seg_O1_C2c_0_34)))
                 (at start (blocked seg_O1_C2c_0_34 ?a))
                 (at start (not (not_blocked seg_O1_C2c_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_C2c_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                )
)



(:durative-action pushback_seg_O1_108d_0_45_seg_O1_108c_0_34_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the pushbackspeed of an airplane (fixed 5 m/s)
             (= ?duration 9)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-pushing ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_O1_108d_0_45))
                 (at start (not_occupied seg_O1_108c_0_34))
                 (at start (not_blocked seg_O1_108c_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_108c_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_108c_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_108c_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_108c_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_108c_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_108c_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_108c_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_108c_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_108c_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_108c_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_108c_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_108c_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_108c_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_108c_0_34 airplane_CFBE2))
                )

 :effect        (and
                 (at end (not (occupied seg_O1_108d_0_45)))
                 (at end (not_occupied seg_O1_108d_0_45))
                 (at end (not (blocked seg_O1_108d_0_45 ?a)))
                 (at end (not_blocked seg_O1_108d_0_45 ?a))
                 (at start (not (at-segment ?a seg_O1_108d_0_45)))

                 (at start (occupied seg_O1_108c_0_34))
                 (at start (not (not_occupied seg_O1_108c_0_34)))
                 (at start (blocked seg_O1_108c_0_34 ?a))
                 (at start (not (not_blocked seg_O1_108c_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_108c_0_34))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                )
)

(:durative-action pushback_seg_O1_108c_0_34_seg_O1_109a_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the pushbackspeed of an airplane (fixed 5 m/s)
             (= ?duration 6)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-pushing ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_108c_0_34))
                 (at start (not_occupied seg_O1_109a_0_34))
                 (at start (not_blocked seg_O1_109a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_109a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_109a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_109a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_109a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_109a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_109a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_109a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_109a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_109a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_109a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_109a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_109a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_109a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_109a_0_34 airplane_CFBE2))
                )

 :effect        (and
                 (at end (not (occupied seg_O1_108c_0_34)))
                 (at end (not_occupied seg_O1_108c_0_34))
                 (at end (not (blocked seg_O1_108c_0_34 ?a)))
                 (at end (not_blocked seg_O1_108c_0_34 ?a))
                 (at start (not (at-segment ?a seg_O1_108c_0_34)))

                 (at start (occupied seg_O1_109a_0_34))
                 (at start (not (not_occupied seg_O1_109a_0_34)))
                 (at start (blocked seg_O1_109a_0_34 ?a))
                 (at start (not (not_blocked seg_O1_109a_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_109a_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                )
)

(:durative-action pushback_seg_p133_0_75_seg_O1_110d_0_45_south_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the pushbackspeed of an airplane (fixed 5 m/s)
             (= ?duration 15)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-pushing ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_p133_0_75))
                 (at start (not_occupied seg_O1_110d_0_45))
                 (at start (not_blocked seg_O1_110d_0_45 airplane_CFBEG))
                 (at start (not_blocked seg_O1_110d_0_45 airplane_CFBE1))
                 (at start (not_blocked seg_O1_110d_0_45 airplane_CFBE3))
                 (at start (not_blocked seg_O1_110d_0_45 airplane_DAEW8))
                 (at start (not_blocked seg_O1_110d_0_45 airplane_DAEW9))
                 (at start (not_blocked seg_O1_110d_0_45 airplane_DAEW0))
                 (at start (not_blocked seg_O1_110d_0_45 airplane_DAEW3))
                 (at start (not_blocked seg_O1_110d_0_45 airplane_DAEWH))
                 (at start (not_blocked seg_O1_110d_0_45 airplane_DAEW1))
                 (at start (not_blocked seg_O1_110d_0_45 airplane_DAEW2))
                 (at start (not_blocked seg_O1_110d_0_45 airplane_DAEW4))
                 (at start (not_blocked seg_O1_110d_0_45 airplane_DAEW5))
                 (at start (not_blocked seg_O1_110d_0_45 airplane_DAEW6))
                 (at start (not_blocked seg_O1_110d_0_45 airplane_DAEW7))
                 (at start (not_blocked seg_O1_110d_0_45 airplane_CFBE2))
                )

 :effect        (and
                 (at end (not (occupied seg_p133_0_75)))
                 (at end (not_occupied seg_p133_0_75))
                 (at end (not (blocked seg_p133_0_75 ?a)))
                 (at end (not_blocked seg_p133_0_75 ?a))
                 (at start (not (at-segment ?a seg_p133_0_75)))

                 (at start (occupied seg_O1_110d_0_45))
                 (at start (not (not_occupied seg_O1_110d_0_45)))
                 (at start (blocked seg_O1_110d_0_45 ?a))
                 (at start (not (not_blocked seg_O1_110d_0_45 ?a)))
                 (at end (at-segment ?a seg_O1_110d_0_45))

                )
)

(:durative-action pushback_seg_O1_110d_0_45_seg_O1_110a_0_34_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the pushbackspeed of an airplane (fixed 5 m/s)
             (= ?duration 9)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-pushing ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_O1_110d_0_45))
                 (at start (not_occupied seg_O1_110a_0_34))
                 (at start (not_blocked seg_O1_110a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_110a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_110a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_110a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_110a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_110a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_110a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_110a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_110a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_110a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_110a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_110a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_110a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_110a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_110a_0_34 airplane_CFBE2))
                )

 :effect        (and
                 (at end (not (occupied seg_O1_110d_0_45)))
                 (at end (not_occupied seg_O1_110d_0_45))
                 (at end (not (blocked seg_O1_110d_0_45 ?a)))
                 (at end (not_blocked seg_O1_110d_0_45 ?a))
                 (at start (not (at-segment ?a seg_O1_110d_0_45)))

                 (at start (occupied seg_O1_110a_0_34))
                 (at start (not (not_occupied seg_O1_110a_0_34)))
                 (at start (blocked seg_O1_110a_0_34 ?a))
                 (at start (not (not_blocked seg_O1_110a_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_110a_0_34))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                )
)

(:durative-action pushback_seg_O1_110a_0_34_seg_O1_109c_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the pushbackspeed of an airplane (fixed 5 m/s)
             (= ?duration 6)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-pushing ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_110a_0_34))
                 (at start (not_occupied seg_O1_109c_0_34))
                 (at start (not_blocked seg_O1_109c_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_109c_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_109c_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_109c_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_109c_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_109c_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_109c_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_109c_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_109c_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_109c_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_109c_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_109c_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_109c_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_109c_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_109c_0_34 airplane_CFBE2))
                )

 :effect        (and
                 (at end (not (occupied seg_O1_110a_0_34)))
                 (at end (not_occupied seg_O1_110a_0_34))
                 (at end (not (blocked seg_O1_110a_0_34 ?a)))
                 (at end (not_blocked seg_O1_110a_0_34 ?a))
                 (at start (not (at-segment ?a seg_O1_110a_0_34)))

                 (at start (occupied seg_O1_109c_0_34))
                 (at start (not (not_occupied seg_O1_109c_0_34)))
                 (at start (blocked seg_O1_109c_0_34 ?a))
                 (at start (not (not_blocked seg_O1_109c_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_109c_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                )
)



(:durative-action pushback_seg_O1_110d_0_45_seg_O1_110c_0_34_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the pushbackspeed of an airplane (fixed 5 m/s)
             (= ?duration 9)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-pushing ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_O1_110d_0_45))
                 (at start (not_occupied seg_O1_110c_0_34))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_CFBE2))
                )

 :effect        (and
                 (at end (not (occupied seg_O1_110d_0_45)))
                 (at end (not_occupied seg_O1_110d_0_45))
                 (at end (not (blocked seg_O1_110d_0_45 ?a)))
                 (at end (not_blocked seg_O1_110d_0_45 ?a))
                 (at start (not (at-segment ?a seg_O1_110d_0_45)))

                 (at start (occupied seg_O1_110c_0_34))
                 (at start (not (not_occupied seg_O1_110c_0_34)))
                 (at start (blocked seg_O1_110c_0_34 ?a))
                 (at start (not (not_blocked seg_O1_110c_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_110c_0_34))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                )
)

(:durative-action pushback_seg_O1_110c_0_34_seg_O1_111a_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the pushbackspeed of an airplane (fixed 5 m/s)
             (= ?duration 6)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-pushing ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_110c_0_34))
                 (at start (not_occupied seg_O1_111a_0_34))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_CFBE2))
                )

 :effect        (and
                 (at end (not (occupied seg_O1_110c_0_34)))
                 (at end (not_occupied seg_O1_110c_0_34))
                 (at end (not (blocked seg_O1_110c_0_34 ?a)))
                 (at end (not_blocked seg_O1_110c_0_34 ?a))
                 (at start (not (at-segment ?a seg_O1_110c_0_34)))

                 (at start (occupied seg_O1_111a_0_34))
                 (at start (not (not_occupied seg_O1_111a_0_34)))
                 (at start (blocked seg_O1_111a_0_34 ?a))
                 (at start (not (not_blocked seg_O1_111a_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_111a_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                )
)

(:durative-action pushback_seg_p111_0_76_seg_O1_111b_0_60_south_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the pushbackspeed of an airplane (fixed 5 m/s)
             (= ?duration 15)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-pushing ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_p111_0_76))
                 (at start (not_occupied seg_O1_111b_0_60))
                 (at start (not_blocked seg_O1_111b_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_O1_111b_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_O1_111b_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_O1_111b_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_O1_111b_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_O1_111b_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_O1_111b_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_O1_111b_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_O1_111b_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_O1_111b_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_O1_111b_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_O1_111b_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_O1_111b_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_O1_111b_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_O1_111b_0_60 airplane_CFBE2))
                )

 :effect        (and
                 (at end (not (occupied seg_p111_0_76)))
                 (at end (not_occupied seg_p111_0_76))
                 (at end (not (blocked seg_p111_0_76 ?a)))
                 (at end (not_blocked seg_p111_0_76 ?a))
                 (at start (not (at-segment ?a seg_p111_0_76)))

                 (at start (occupied seg_O1_111b_0_60))
                 (at start (not (not_occupied seg_O1_111b_0_60)))
                 (at start (blocked seg_O1_111b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_111b_0_60 ?a)))
                 (at end (at-segment ?a seg_O1_111b_0_60))

                )
)

(:durative-action pushback_seg_O1_111b_0_60_seg_O1_111a_0_34_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the pushbackspeed of an airplane (fixed 5 m/s)
             (= ?duration 12)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-pushing ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_O1_111b_0_60))
                 (at start (not_occupied seg_O1_111a_0_34))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_111a_0_34 airplane_CFBE2))
                )

 :effect        (and
                 (at end (not (occupied seg_O1_111b_0_60)))
                 (at end (not_occupied seg_O1_111b_0_60))
                 (at end (not (blocked seg_O1_111b_0_60 ?a)))
                 (at end (not_blocked seg_O1_111b_0_60 ?a))
                 (at start (not (at-segment ?a seg_O1_111b_0_60)))

                 (at start (occupied seg_O1_111a_0_34))
                 (at start (not (not_occupied seg_O1_111a_0_34)))
                 (at start (blocked seg_O1_111a_0_34 ?a))
                 (at start (not (not_blocked seg_O1_111a_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_111a_0_34))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                )
)

(:durative-action pushback_seg_O1_111a_0_34_seg_O1_110c_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the pushbackspeed of an airplane (fixed 5 m/s)
             (= ?duration 6)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-pushing ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_111a_0_34))
                 (at start (not_occupied seg_O1_110c_0_34))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_110c_0_34 airplane_CFBE2))
                )

 :effect        (and
                 (at end (not (occupied seg_O1_111a_0_34)))
                 (at end (not_occupied seg_O1_111a_0_34))
                 (at end (not (blocked seg_O1_111a_0_34 ?a)))
                 (at end (not_blocked seg_O1_111a_0_34 ?a))
                 (at start (not (at-segment ?a seg_O1_111a_0_34)))

                 (at start (occupied seg_O1_110c_0_34))
                 (at start (not (not_occupied seg_O1_110c_0_34)))
                 (at start (blocked seg_O1_110c_0_34 ?a))
                 (at start (not (not_blocked seg_O1_110c_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_110c_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                )
)



(:durative-action pushback_seg_O1_111b_0_60_seg_O1_111c_0_34_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the pushbackspeed of an airplane (fixed 5 m/s)
             (= ?duration 12)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-pushing ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_O1_111b_0_60))
                 (at start (not_occupied seg_O1_111c_0_34))
                 (at start (not_blocked seg_O1_111c_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_111c_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_111c_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_111c_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_111c_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_111c_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_111c_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_111c_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_111c_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_111c_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_111c_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_111c_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_111c_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_111c_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_111c_0_34 airplane_CFBE2))
                )

 :effect        (and
                 (at end (not (occupied seg_O1_111b_0_60)))
                 (at end (not_occupied seg_O1_111b_0_60))
                 (at end (not (blocked seg_O1_111b_0_60 ?a)))
                 (at end (not_blocked seg_O1_111b_0_60 ?a))
                 (at start (not (at-segment ?a seg_O1_111b_0_60)))

                 (at start (occupied seg_O1_111c_0_34))
                 (at start (not (not_occupied seg_O1_111c_0_34)))
                 (at start (blocked seg_O1_111c_0_34 ?a))
                 (at start (not (not_blocked seg_O1_111c_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_111c_0_34))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                )
)

(:durative-action pushback_seg_O1_111c_0_34_seg_O1_C3a_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the pushbackspeed of an airplane (fixed 5 m/s)
             (= ?duration 6)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-pushing ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_111c_0_34))
                 (at start (not_occupied seg_O1_C3a_0_34))
                 (at start (not_blocked seg_O1_C3a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_C3a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_C3a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_C3a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_C3a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_C3a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_C3a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_C3a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_C3a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_C3a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_C3a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_C3a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_C3a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_C3a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_C3a_0_34 airplane_CFBE2))
                )

 :effect        (and
                 (at end (not (occupied seg_O1_111c_0_34)))
                 (at end (not_occupied seg_O1_111c_0_34))
                 (at end (not (blocked seg_O1_111c_0_34 ?a)))
                 (at end (not_blocked seg_O1_111c_0_34 ?a))
                 (at start (not (at-segment ?a seg_O1_111c_0_34)))

                 (at start (occupied seg_O1_C3a_0_34))
                 (at start (not (not_occupied seg_O1_C3a_0_34)))
                 (at start (blocked seg_O1_C3a_0_34 ?a))
                 (at start (not (not_blocked seg_O1_C3a_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_C3a_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                )
)

(:durative-action pushback_seg_p112_0_76_seg_O1_C3b_0_60_south_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the pushbackspeed of an airplane (fixed 5 m/s)
             (= ?duration 15)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-pushing ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_p112_0_76))
                 (at start (not_occupied seg_O1_C3b_0_60))
                 (at start (not_blocked seg_O1_C3b_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_O1_C3b_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_O1_C3b_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_O1_C3b_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_O1_C3b_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_O1_C3b_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_O1_C3b_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_O1_C3b_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_O1_C3b_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_O1_C3b_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_O1_C3b_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_O1_C3b_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_O1_C3b_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_O1_C3b_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_O1_C3b_0_60 airplane_CFBE2))
                )

 :effect        (and
                 (at end (not (occupied seg_p112_0_76)))
                 (at end (not_occupied seg_p112_0_76))
                 (at end (not (blocked seg_p112_0_76 ?a)))
                 (at end (not_blocked seg_p112_0_76 ?a))
                 (at start (not (at-segment ?a seg_p112_0_76)))

                 (at start (occupied seg_O1_C3b_0_60))
                 (at start (not (not_occupied seg_O1_C3b_0_60)))
                 (at start (blocked seg_O1_C3b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_C3b_0_60 ?a)))
                 (at end (at-segment ?a seg_O1_C3b_0_60))

                )
)

(:durative-action pushback_seg_O1_C3b_0_60_seg_O1_C3d_0_60_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the pushbackspeed of an airplane (fixed 5 m/s)
             (= ?duration 12)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-pushing ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_O1_C3b_0_60))
                 (at start (not_occupied seg_O1_C3d_0_60))
                 (at start (not_blocked seg_O1_C3d_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_O1_C3d_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_O1_C3d_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_O1_C3d_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_O1_C3d_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_O1_C3d_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_O1_C3d_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_O1_C3d_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_O1_C3d_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_O1_C3d_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_O1_C3d_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_O1_C3d_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_O1_C3d_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_O1_C3d_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_O1_C3d_0_60 airplane_CFBE2))
                )

 :effect        (and
                 (at end (not (occupied seg_O1_C3b_0_60)))
                 (at end (not_occupied seg_O1_C3b_0_60))
                 (at end (not (blocked seg_O1_C3b_0_60 ?a)))
                 (at end (not_blocked seg_O1_C3b_0_60 ?a))
                 (at start (not (at-segment ?a seg_O1_C3b_0_60)))

                 (at start (occupied seg_O1_C3d_0_60))
                 (at start (not (not_occupied seg_O1_C3d_0_60)))
                 (at start (blocked seg_O1_C3d_0_60 ?a))
                 (at start (not (not_blocked seg_O1_C3d_0_60 ?a)))
                 (at end (at-segment ?a seg_O1_C3d_0_60))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                )
)

(:durative-action pushback_seg_O1_C3d_0_60_seg_C3_b_0_80_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the pushbackspeed of an airplane (fixed 5 m/s)
             (= ?duration 12)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-pushing ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_C3d_0_60))
                 (at start (not_occupied seg_C3_b_0_80))
                 (at start (not_blocked seg_C3_b_0_80 airplane_CFBEG))
                 (at start (not_blocked seg_C3_b_0_80 airplane_CFBE1))
                 (at start (not_blocked seg_C3_b_0_80 airplane_CFBE3))
                 (at start (not_blocked seg_C3_b_0_80 airplane_DAEW8))
                 (at start (not_blocked seg_C3_b_0_80 airplane_DAEW9))
                 (at start (not_blocked seg_C3_b_0_80 airplane_DAEW0))
                 (at start (not_blocked seg_C3_b_0_80 airplane_DAEW3))
                 (at start (not_blocked seg_C3_b_0_80 airplane_DAEWH))
                 (at start (not_blocked seg_C3_b_0_80 airplane_DAEW1))
                 (at start (not_blocked seg_C3_b_0_80 airplane_DAEW2))
                 (at start (not_blocked seg_C3_b_0_80 airplane_DAEW4))
                 (at start (not_blocked seg_C3_b_0_80 airplane_DAEW5))
                 (at start (not_blocked seg_C3_b_0_80 airplane_DAEW6))
                 (at start (not_blocked seg_C3_b_0_80 airplane_DAEW7))
                 (at start (not_blocked seg_C3_b_0_80 airplane_CFBE2))
                )

 :effect        (and
                 (at end (not (occupied seg_O1_C3d_0_60)))
                 (at end (not_occupied seg_O1_C3d_0_60))
                 (at end (not (blocked seg_O1_C3d_0_60 ?a)))
                 (at end (not_blocked seg_O1_C3d_0_60 ?a))
                 (at start (not (at-segment ?a seg_O1_C3d_0_60)))

                 (at start (occupied seg_C3_b_0_80))
                 (at start (not (not_occupied seg_C3_b_0_80)))
                 (at start (blocked seg_C3_b_0_80 ?a))
                 (at start (not (not_blocked seg_C3_b_0_80 ?a)))
                 (at end (at-segment ?a seg_C3_b_0_80))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                )
)







(:durative-action pushback_seg_p118_0_76_seg_O1_118b_0_60_south_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the pushbackspeed of an airplane (fixed 5 m/s)
             (= ?duration 15)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-pushing ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_p118_0_76))
                 (at start (not_occupied seg_O1_118b_0_60))
                 (at start (not_blocked seg_O1_118b_0_60 airplane_CFBEG))
                 (at start (not_blocked seg_O1_118b_0_60 airplane_CFBE1))
                 (at start (not_blocked seg_O1_118b_0_60 airplane_CFBE3))
                 (at start (not_blocked seg_O1_118b_0_60 airplane_DAEW8))
                 (at start (not_blocked seg_O1_118b_0_60 airplane_DAEW9))
                 (at start (not_blocked seg_O1_118b_0_60 airplane_DAEW0))
                 (at start (not_blocked seg_O1_118b_0_60 airplane_DAEW3))
                 (at start (not_blocked seg_O1_118b_0_60 airplane_DAEWH))
                 (at start (not_blocked seg_O1_118b_0_60 airplane_DAEW1))
                 (at start (not_blocked seg_O1_118b_0_60 airplane_DAEW2))
                 (at start (not_blocked seg_O1_118b_0_60 airplane_DAEW4))
                 (at start (not_blocked seg_O1_118b_0_60 airplane_DAEW5))
                 (at start (not_blocked seg_O1_118b_0_60 airplane_DAEW6))
                 (at start (not_blocked seg_O1_118b_0_60 airplane_DAEW7))
                 (at start (not_blocked seg_O1_118b_0_60 airplane_CFBE2))
                )

 :effect        (and
                 (at end (not (occupied seg_p118_0_76)))
                 (at end (not_occupied seg_p118_0_76))
                 (at end (not (blocked seg_p118_0_76 ?a)))
                 (at end (not_blocked seg_p118_0_76 ?a))
                 (at start (not (at-segment ?a seg_p118_0_76)))

                 (at start (occupied seg_O1_118b_0_60))
                 (at start (not (not_occupied seg_O1_118b_0_60)))
                 (at start (blocked seg_O1_118b_0_60 ?a))
                 (at start (not (not_blocked seg_O1_118b_0_60 ?a)))
                 (at end (at-segment ?a seg_O1_118b_0_60))

                )
)

(:durative-action pushback_seg_O1_118b_0_60_seg_O1_118a_0_34_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the pushbackspeed of an airplane (fixed 5 m/s)
             (= ?duration 12)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-pushing ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_O1_118b_0_60))
                 (at start (not_occupied seg_O1_118a_0_34))
                 (at start (not_blocked seg_O1_118a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_118a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_118a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_118a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_118a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_118a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_118a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_118a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_118a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_118a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_118a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_118a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_118a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_118a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_118a_0_34 airplane_CFBE2))
                )

 :effect        (and
                 (at end (not (occupied seg_O1_118b_0_60)))
                 (at end (not_occupied seg_O1_118b_0_60))
                 (at end (not (blocked seg_O1_118b_0_60 ?a)))
                 (at end (not_blocked seg_O1_118b_0_60 ?a))
                 (at start (not (at-segment ?a seg_O1_118b_0_60)))

                 (at start (occupied seg_O1_118a_0_34))
                 (at start (not (not_occupied seg_O1_118a_0_34)))
                 (at start (blocked seg_O1_118a_0_34 ?a))
                 (at start (not (not_blocked seg_O1_118a_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_118a_0_34))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                )
)

(:durative-action pushback_seg_O1_118a_0_34_seg_O1_117c_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the pushbackspeed of an airplane (fixed 5 m/s)
             (= ?duration 6)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-pushing ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_118a_0_34))
                 (at start (not_occupied seg_O1_117c_0_34))
                 (at start (not_blocked seg_O1_117c_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_117c_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_117c_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_117c_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_117c_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_117c_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_117c_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_117c_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_117c_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_117c_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_117c_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_117c_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_117c_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_117c_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_117c_0_34 airplane_CFBE2))
                )

 :effect        (and
                 (at end (not (occupied seg_O1_118a_0_34)))
                 (at end (not_occupied seg_O1_118a_0_34))
                 (at end (not (blocked seg_O1_118a_0_34 ?a)))
                 (at end (not_blocked seg_O1_118a_0_34 ?a))
                 (at start (not (at-segment ?a seg_O1_118a_0_34)))

                 (at start (occupied seg_O1_117c_0_34))
                 (at start (not (not_occupied seg_O1_117c_0_34)))
                 (at start (blocked seg_O1_117c_0_34 ?a))
                 (at start (not (not_blocked seg_O1_117c_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_117c_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                )
)



(:durative-action pushback_seg_O1_118b_0_60_seg_O1_118c_0_34_south_north_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the pushbackspeed of an airplane (fixed 5 m/s)
             (= ?duration 12)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-pushing ?a))
                 (at start (facing ?a south))
                 (at start (at-segment ?a seg_O1_118b_0_60))
                 (at start (not_occupied seg_O1_118c_0_34))
                 (at start (not_blocked seg_O1_118c_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_118c_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_118c_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_118c_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_118c_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_118c_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_118c_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_118c_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_118c_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_118c_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_118c_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_118c_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_118c_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_118c_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_118c_0_34 airplane_CFBE2))
                )

 :effect        (and
                 (at end (not (occupied seg_O1_118b_0_60)))
                 (at end (not_occupied seg_O1_118b_0_60))
                 (at end (not (blocked seg_O1_118b_0_60 ?a)))
                 (at end (not_blocked seg_O1_118b_0_60 ?a))
                 (at start (not (at-segment ?a seg_O1_118b_0_60)))

                 (at start (occupied seg_O1_118c_0_34))
                 (at start (not (not_occupied seg_O1_118c_0_34)))
                 (at start (blocked seg_O1_118c_0_34 ?a))
                 (at start (not (not_blocked seg_O1_118c_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_118c_0_34))
                 (at start (not (facing ?a south)))
                 (at end (facing ?a north))

                )
)

(:durative-action pushback_seg_O1_118c_0_34_seg_O1_C4a_0_34_north_south_medium

 :parameters    (?a - airplane)

 :duration
             ;; length of the segment divided through the pushbackspeed of an airplane (fixed 5 m/s)
             (= ?duration 6)

 :condition  (and
		(at start (candostuff))
                 (over all (has-type ?a medium))
                 (over all (is-pushing ?a))
                 (at start (facing ?a north))
                 (at start (at-segment ?a seg_O1_118c_0_34))
                 (at start (not_occupied seg_O1_C4a_0_34))
                 (at start (not_blocked seg_O1_C4a_0_34 airplane_CFBEG))
                 (at start (not_blocked seg_O1_C4a_0_34 airplane_CFBE1))
                 (at start (not_blocked seg_O1_C4a_0_34 airplane_CFBE3))
                 (at start (not_blocked seg_O1_C4a_0_34 airplane_DAEW8))
                 (at start (not_blocked seg_O1_C4a_0_34 airplane_DAEW9))
                 (at start (not_blocked seg_O1_C4a_0_34 airplane_DAEW0))
                 (at start (not_blocked seg_O1_C4a_0_34 airplane_DAEW3))
                 (at start (not_blocked seg_O1_C4a_0_34 airplane_DAEWH))
                 (at start (not_blocked seg_O1_C4a_0_34 airplane_DAEW1))
                 (at start (not_blocked seg_O1_C4a_0_34 airplane_DAEW2))
                 (at start (not_blocked seg_O1_C4a_0_34 airplane_DAEW4))
                 (at start (not_blocked seg_O1_C4a_0_34 airplane_DAEW5))
                 (at start (not_blocked seg_O1_C4a_0_34 airplane_DAEW6))
                 (at start (not_blocked seg_O1_C4a_0_34 airplane_DAEW7))
                 (at start (not_blocked seg_O1_C4a_0_34 airplane_CFBE2))
                )

 :effect        (and
                 (at end (not (occupied seg_O1_118c_0_34)))
                 (at end (not_occupied seg_O1_118c_0_34))
                 (at end (not (blocked seg_O1_118c_0_34 ?a)))
                 (at end (not_blocked seg_O1_118c_0_34 ?a))
                 (at start (not (at-segment ?a seg_O1_118c_0_34)))

                 (at start (occupied seg_O1_C4a_0_34))
                 (at start (not (not_occupied seg_O1_C4a_0_34)))
                 (at start (blocked seg_O1_C4a_0_34 ?a))
                 (at start (not (not_blocked seg_O1_C4a_0_34 ?a)))
                 (at end (at-segment ?a seg_O1_C4a_0_34))
                 (at start (not (facing ?a north)))
                 (at end (facing ?a south))

                )
)


(:durative-action takeoff_seg_09r_0_80_north

 :parameters (?a - airplane)

 :duration  (= ?duration 30 )

 :condition    (and (at start (at-segment ?a seg_09r_0_80))
		(at start (candostuff))
                    (at start (facing ?a north))
                    (at start (is-moving ?a))
               )

 :effect (and (at end (not (occupied seg_09r_0_80)))
              (at end (not_occupied seg_09r_0_80))
              (at end (not (blocked seg_09r_0_80 ?a)))
              (at end (not_blocked seg_09r_0_80 ?a))
              (at start (not (at-segment ?a seg_09r_0_80)))
              (at end (airborne ?a seg_09r_0_80))
		(at start(taken-off ?a))
(at end (in-air ?a))              (at start (not (is-moving ?a )))
              (at end (not (blocked seg_08R_B9B10_0_980 ?a)))
              (at end (not_blocked seg_08R_B9B10_0_980 ?a))
         )
)

(:durative-action takeoff_seg_08r_0_80_north

 :parameters (?a - airplane)

 :duration  (= ?duration 30 )

 :condition    (and (at start (at-segment ?a seg_08r_0_80))
		(at start (candostuff))
                    (at start (facing ?a north))
                    (at start (is-moving ?a))
               )

 :effect (and (at end (not (occupied seg_08r_0_80)))
              (at end (not_occupied seg_08r_0_80))
              (at end (not (blocked seg_08r_0_80 ?a)))
              (at end (not_blocked seg_08r_0_80 ?a))
              (at start (not (at-segment ?a seg_08r_0_80)))
              (at end (airborne ?a seg_08r_0_80))
		(at start(taken-off ?a))
(at end (in-air ?a))              (at start (not (is-moving ?a )))
              (at end (not (blocked seg_08R_B2B3_0_900 ?a)))
              (at end (not_blocked seg_08R_B2B3_0_900 ?a))
         )
)

(:durative-action takeoff_seg_09l_0_80_north

 :parameters (?a - airplane)

 :duration  (= ?duration 30 )

 :condition    (and (at start (at-segment ?a seg_09l_0_80))
		(at start (candostuff))
                    (at start (facing ?a north))
                    (at start (is-moving ?a))
               )

 :effect (and (at end (not (occupied seg_09l_0_80)))
              (at end (not_occupied seg_09l_0_80))
              (at end (not (blocked seg_09l_0_80 ?a)))
              (at end (not_blocked seg_09l_0_80 ?a))
              (at start (not (at-segment ?a seg_09l_0_80)))
              (at end (airborne ?a seg_09l_0_80))
		(at start(taken-off ?a))
(at end (in-air ?a))              (at start (not (is-moving ?a )))
              (at end (not (blocked seg_08L_A9A10_0_1010 ?a)))
              (at end (not_blocked seg_08L_A9A10_0_1010 ?a))
         )
)

(:durative-action takeoff_seg_08l_0_80_north

 :parameters (?a - airplane)

 :duration  (= ?duration 30 )

 :condition    (and (at start (at-segment ?a seg_08l_0_80))
		(at start (candostuff))
                    (at start (facing ?a north))
                    (at start (is-moving ?a))
               )

 :effect (and (at end (not (occupied seg_08l_0_80)))
              (at end (not_occupied seg_08l_0_80))
              (at end (not (blocked seg_08l_0_80 ?a)))
              (at end (not_blocked seg_08l_0_80 ?a))
              (at start (not (at-segment ?a seg_08l_0_80)))
              (at end (airborne ?a seg_08l_0_80))
		(at start(taken-off ?a))
(at end (in-air ?a))              (at start (not (is-moving ?a )))
              (at end (not (blocked seg_08L_A2A3_0_970 ?a)))
              (at end (not_blocked seg_08L_A2A3_0_970 ?a))
         )
)


(:durative-action startup_seg_08R_B2a_0_80_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_08R_B2a_0_80))
                    (over all (not_occupied seg_B2_1_0_80))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_B2_1_0_80 ?a))
                    (at start (not (not_blocked seg_B2_1_0_80 ?a)))
         )
)
(:durative-action startup_seg_08R_B2a_0_80_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_08R_B2a_0_80))
                    (over all (not_occupied seg_08R_B2b_0_80))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_08R_B2b_0_80 ?a))
                    (at start (not (not_blocked seg_08R_B2b_0_80 ?a)))
         )
)
(:durative-action startup_seg_B2_1_0_80_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_B2_1_0_80))
                    (over all (not_occupied seg_B2_0_80))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_B2_0_80 ?a))
                    (at start (not (not_blocked seg_B2_0_80 ?a)))
         )
)
(:durative-action startup_seg_B2_1_0_80_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_B2_1_0_80))
                    (over all (not_occupied seg_08R_B2a_0_80))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_08R_B2a_0_80 ?a))
                    (at start (not (not_blocked seg_08R_B2a_0_80 ?a)))
         )
)
(:durative-action startup_seg_08R_B3c_0_161_245_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_08R_B3c_0_161_245))
                    (over all (not_occupied seg_B3_a_0_156_924))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_B3_a_0_156_924 ?a))
                    (at start (not (not_blocked seg_B3_a_0_156_924 ?a)))
         )
)
(:durative-action startup_seg_08R_B3c_0_161_245_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_08R_B3c_0_161_245))
                    (over all (not_occupied seg_08r_0_80))
                    (over all (not_occupied seg_08R_B3a_0_80))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_08r_0_80 ?a))
                    (at start (not (not_blocked seg_08r_0_80 ?a)))
                    (at start (blocked seg_08R_B3a_0_80 ?a))
                    (at start (not (not_blocked seg_08R_B3a_0_80 ?a)))
         )
)
(:durative-action startup_seg_B3_a_0_156_924_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_B3_a_0_156_924))
                    (over all (not_occupied seg_B3_b_1_0_80_6226))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_B3_b_1_0_80_6226 ?a))
                    (at start (not (not_blocked seg_B3_b_1_0_80_6226 ?a)))
         )
)
(:durative-action startup_seg_B3_a_0_156_924_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_B3_a_0_156_924))
                    (over all (not_occupied seg_08R_B3c_0_161_245))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_08R_B3c_0_161_245 ?a))
                    (at start (not (not_blocked seg_08R_B3c_0_161_245 ?a)))
         )
)
(:durative-action startup_seg_08R_B4a_0_161_245_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_08R_B4a_0_161_245))
                    (over all (not_occupied seg_B5_a_0_158_647))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_B5_a_0_158_647 ?a))
                    (at start (not (not_blocked seg_B5_a_0_158_647 ?a)))
         )
)
(:durative-action startup_seg_08R_B4a_0_161_245_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_08R_B4a_0_161_245))
                    (over all (not_occupied seg_08R_B4c_0_80))
                    (over all (not_occupied seg_08R_B4b_0_80))
                    (over all (not_occupied seg_08R_B4d_0_161_245))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_08R_B4c_0_80 ?a))
                    (at start (not (not_blocked seg_08R_B4c_0_80 ?a)))
                    (at start (blocked seg_08R_B4b_0_80 ?a))
                    (at start (not (not_blocked seg_08R_B4b_0_80 ?a)))
                    (at start (blocked seg_08R_B4d_0_161_245 ?a))
                    (at start (not (not_blocked seg_08R_B4d_0_161_245 ?a)))
         )
)
(:durative-action startup_seg_08R_B4d_0_161_245_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_08R_B4d_0_161_245))
                    (over all (not_occupied seg_B4_a_0_156_924))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_B4_a_0_156_924 ?a))
                    (at start (not (not_blocked seg_B4_a_0_156_924 ?a)))
         )
)
(:durative-action startup_seg_08R_B4d_0_161_245_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_08R_B4d_0_161_245))
                    (over all (not_occupied seg_08R_B4a_0_161_245))
                    (over all (not_occupied seg_08R_B4c_0_80))
                    (over all (not_occupied seg_08R_B4b_0_80))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_08R_B4a_0_161_245 ?a))
                    (at start (not (not_blocked seg_08R_B4a_0_161_245 ?a)))
                    (at start (blocked seg_08R_B4c_0_80 ?a))
                    (at start (not (not_blocked seg_08R_B4c_0_80 ?a)))
                    (at start (blocked seg_08R_B4b_0_80 ?a))
                    (at start (not (not_blocked seg_08R_B4b_0_80 ?a)))
         )
)
(:durative-action startup_seg_B5_a_0_158_647_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_B5_a_0_158_647))
                    (over all (not_occupied seg_B5_b_0_159_512))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_B5_b_0_159_512 ?a))
                    (at start (not (not_blocked seg_B5_b_0_159_512 ?a)))
         )
)
(:durative-action startup_seg_B5_a_0_158_647_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_B5_a_0_158_647))
                    (over all (not_occupied seg_08R_B4a_0_161_245))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_08R_B4a_0_161_245 ?a))
                    (at start (not (not_blocked seg_08R_B4a_0_161_245 ?a)))
         )
)
(:durative-action startup_seg_B4_a_0_156_924_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_B4_a_0_156_924))
                    (over all (not_occupied seg_B4_b_1_0_80_6226))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_B4_b_1_0_80_6226 ?a))
                    (at start (not (not_blocked seg_B4_b_1_0_80_6226 ?a)))
         )
)
(:durative-action startup_seg_B4_a_0_156_924_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_B4_a_0_156_924))
                    (over all (not_occupied seg_08R_B4d_0_161_245))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_08R_B4d_0_161_245 ?a))
                    (at start (not (not_blocked seg_08R_B4d_0_161_245 ?a)))
         )
)
(:durative-action startup_seg_08R_B6a_0_161_245_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_08R_B6a_0_161_245))
                    (over all (not_occupied seg_B8_a_0_156_924))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_B8_a_0_156_924 ?a))
                    (at start (not (not_blocked seg_B8_a_0_156_924 ?a)))
         )
)
(:durative-action startup_seg_08R_B6a_0_161_245_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_08R_B6a_0_161_245))
                    (over all (not_occupied seg_08R_B6c_0_80))
                    (over all (not_occupied seg_08R_B6b_0_80))
                    (over all (not_occupied seg_08R_B6d_0_161_245))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_08R_B6c_0_80 ?a))
                    (at start (not (not_blocked seg_08R_B6c_0_80 ?a)))
                    (at start (blocked seg_08R_B6b_0_80 ?a))
                    (at start (not (not_blocked seg_08R_B6b_0_80 ?a)))
                    (at start (blocked seg_08R_B6d_0_161_245 ?a))
                    (at start (not (not_blocked seg_08R_B6d_0_161_245 ?a)))
         )
)
(:durative-action startup_seg_08R_B6d_0_161_245_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_08R_B6d_0_161_245))
                    (over all (not_occupied seg_B6_a_0_158_647))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_B6_a_0_158_647 ?a))
                    (at start (not (not_blocked seg_B6_a_0_158_647 ?a)))
         )
)
(:durative-action startup_seg_08R_B6d_0_161_245_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_08R_B6d_0_161_245))
                    (over all (not_occupied seg_08R_B6a_0_161_245))
                    (over all (not_occupied seg_08R_B6c_0_80))
                    (over all (not_occupied seg_08R_B6b_0_80))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_08R_B6a_0_161_245 ?a))
                    (at start (not (not_blocked seg_08R_B6a_0_161_245 ?a)))
                    (at start (blocked seg_08R_B6c_0_80 ?a))
                    (at start (not (not_blocked seg_08R_B6c_0_80 ?a)))
                    (at start (blocked seg_08R_B6b_0_80 ?a))
                    (at start (not (not_blocked seg_08R_B6b_0_80 ?a)))
         )
)
(:durative-action startup_seg_B8_a_0_156_924_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_B8_a_0_156_924))
                    (over all (not_occupied seg_B8_b_1_0_80_6226))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_B8_b_1_0_80_6226 ?a))
                    (at start (not (not_blocked seg_B8_b_1_0_80_6226 ?a)))
         )
)
(:durative-action startup_seg_B8_a_0_156_924_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_B8_a_0_156_924))
                    (over all (not_occupied seg_08R_B6a_0_161_245))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_08R_B6a_0_161_245 ?a))
                    (at start (not (not_blocked seg_08R_B6a_0_161_245 ?a)))
         )
)
(:durative-action startup_seg_B6_a_0_158_647_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_B6_a_0_158_647))
                    (over all (not_occupied seg_B6_b_0_159_512))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_B6_b_0_159_512 ?a))
                    (at start (not (not_blocked seg_B6_b_0_159_512 ?a)))
         )
)
(:durative-action startup_seg_B6_a_0_158_647_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_B6_a_0_158_647))
                    (over all (not_occupied seg_08R_B6d_0_161_245))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_08R_B6d_0_161_245 ?a))
                    (at start (not (not_blocked seg_08R_B6d_0_161_245 ?a)))
         )
)
(:durative-action startup_seg_08R_B9a_0_161_245_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_08R_B9a_0_161_245))
                    (over all (not_occupied seg_B9_a_0_156_924))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_B9_a_0_156_924 ?a))
                    (at start (not (not_blocked seg_B9_a_0_156_924 ?a)))
         )
)
(:durative-action startup_seg_08R_B9a_0_161_245_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_08R_B9a_0_161_245))
                    (over all (not_occupied seg_08R_B9c_0_80))
                    (over all (not_occupied seg_09r_0_80))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_08R_B9c_0_80 ?a))
                    (at start (not (not_blocked seg_08R_B9c_0_80 ?a)))
                    (at start (blocked seg_09r_0_80 ?a))
                    (at start (not (not_blocked seg_09r_0_80 ?a)))
         )
)
(:durative-action startup_seg_B9_a_0_156_924_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_B9_a_0_156_924))
                    (over all (not_occupied seg_B9_b_1_0_80_6226))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_B9_b_1_0_80_6226 ?a))
                    (at start (not (not_blocked seg_B9_b_1_0_80_6226 ?a)))
         )
)
(:durative-action startup_seg_B9_a_0_156_924_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_B9_a_0_156_924))
                    (over all (not_occupied seg_08R_B9a_0_161_245))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_08R_B9a_0_161_245 ?a))
                    (at start (not (not_blocked seg_08R_B9a_0_161_245 ?a)))
         )
)
(:durative-action startup_seg_08R_B10a_0_80_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_08R_B10a_0_80))
                    (over all (not_occupied seg_B10_1_0_80))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_B10_1_0_80 ?a))
                    (at start (not (not_blocked seg_B10_1_0_80 ?a)))
         )
)
(:durative-action startup_seg_08R_B10a_0_80_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_08R_B10a_0_80))
                    (over all (not_occupied seg_08R_B10b_0_80))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_08R_B10b_0_80 ?a))
                    (at start (not (not_blocked seg_08R_B10b_0_80 ?a)))
         )
)
(:durative-action startup_seg_B10_1_0_80_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_B10_1_0_80))
                    (over all (not_occupied seg_B10_0_80))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_B10_0_80 ?a))
                    (at start (not (not_blocked seg_B10_0_80 ?a)))
         )
)
(:durative-action startup_seg_B10_1_0_80_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_B10_1_0_80))
                    (over all (not_occupied seg_08R_B10a_0_80))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_08R_B10a_0_80 ?a))
                    (at start (not (not_blocked seg_08R_B10a_0_80 ?a)))
         )
)
(:durative-action startup_seg_T_B2a_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B2a_0_60))
                    (over all (not_occupied seg_S_B2b_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B2b_0_60 ?a))
                    (at start (not (not_blocked seg_S_B2b_0_60 ?a)))
         )
)
(:durative-action startup_seg_T_B2a_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B2a_0_60))
                    (over all (not_occupied seg_T_B2b_0_60))
                    (over all (not_occupied seg_T_B2c_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B2b_0_60 ?a))
                    (at start (not (not_blocked seg_T_B2b_0_60 ?a)))
                    (at start (blocked seg_T_B2c_0_60 ?a))
                    (at start (not (not_blocked seg_T_B2c_0_60 ?a)))
         )
)
(:durative-action startup_seg_T_B2b_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B2b_0_60))
                    (over all (not_occupied seg_T_B2B3a_0_140))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B2B3a_0_140 ?a))
                    (at start (not (not_blocked seg_T_B2B3a_0_140 ?a)))
         )
)
(:durative-action startup_seg_T_B2b_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B2b_0_60))
                    (over all (not_occupied seg_T_B2a_0_60))
                    (over all (not_occupied seg_T_B2c_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B2a_0_60 ?a))
                    (at start (not (not_blocked seg_T_B2a_0_60 ?a)))
                    (at start (blocked seg_T_B2c_0_60 ?a))
                    (at start (not (not_blocked seg_T_B2c_0_60 ?a)))
         )
)
(:durative-action startup_seg_T_B2c_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B2c_0_60))
                    (over all (not_occupied seg_B2_0_80))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_B2_0_80 ?a))
                    (at start (not (not_blocked seg_B2_0_80 ?a)))
         )
)
(:durative-action startup_seg_T_B2c_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B2c_0_60))
                    (over all (not_occupied seg_T_B2a_0_60))
                    (over all (not_occupied seg_T_B2b_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B2a_0_60 ?a))
                    (at start (not (not_blocked seg_T_B2a_0_60 ?a)))
                    (at start (blocked seg_T_B2b_0_60 ?a))
                    (at start (not (not_blocked seg_T_B2b_0_60 ?a)))
         )
)
(:durative-action startup_seg_S_B2b_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B2b_0_60))
                    (over all (not_occupied seg_T_B2a_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B2a_0_60 ?a))
                    (at start (not (not_blocked seg_T_B2a_0_60 ?a)))
         )
)
(:durative-action startup_seg_S_B2b_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B2b_0_60))
                    (over all (not_occupied seg_S_B2a_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B2a_0_60 ?a))
                    (at start (not (not_blocked seg_S_B2a_0_60 ?a)))
         )
)
(:durative-action startup_seg_T_B2B3a_0_140_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B2B3a_0_140))
                    (over all (not_occupied seg_T_B2B3b_0_140))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B2B3b_0_140 ?a))
                    (at start (not (not_blocked seg_T_B2B3b_0_140 ?a)))
         )
)
(:durative-action startup_seg_T_B2B3a_0_140_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B2B3a_0_140))
                    (over all (not_occupied seg_T_B2b_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B2b_0_60 ?a))
                    (at start (not (not_blocked seg_T_B2b_0_60 ?a)))
         )
)
(:durative-action startup_seg_B2_0_80_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_B2_0_80))
                    (over all (not_occupied seg_T_B2c_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B2c_0_60 ?a))
                    (at start (not (not_blocked seg_T_B2c_0_60 ?a)))
         )
)
(:durative-action startup_seg_B2_0_80_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_B2_0_80))
                    (over all (not_occupied seg_B2_1_0_80))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_B2_1_0_80 ?a))
                    (at start (not (not_blocked seg_B2_1_0_80 ?a)))
         )
)
(:durative-action startup_seg_T_B2B3b_0_140_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B2B3b_0_140))
                    (over all (not_occupied seg_T_B2B3c_0_140))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B2B3c_0_140 ?a))
                    (at start (not (not_blocked seg_T_B2B3c_0_140 ?a)))
         )
)
(:durative-action startup_seg_T_B2B3b_0_140_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B2B3b_0_140))
                    (over all (not_occupied seg_T_B2B3a_0_140))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B2B3a_0_140 ?a))
                    (at start (not (not_blocked seg_T_B2B3a_0_140 ?a)))
         )
)
(:durative-action startup_seg_T_B2B3c_0_140_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B2B3c_0_140))
                    (over all (not_occupied seg_T_B3d_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B3d_0_60 ?a))
                    (at start (not (not_blocked seg_T_B3d_0_60 ?a)))
         )
)
(:durative-action startup_seg_T_B2B3c_0_140_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B2B3c_0_140))
                    (over all (not_occupied seg_T_B2B3b_0_140))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B2B3b_0_140 ?a))
                    (at start (not (not_blocked seg_T_B2B3b_0_140 ?a)))
         )
)
(:durative-action startup_seg_T_B3a_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B3a_0_60))
                    (over all (not_occupied seg_S_B3b_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B3b_0_60 ?a))
                    (at start (not (not_blocked seg_S_B3b_0_60 ?a)))
         )
)
(:durative-action startup_seg_T_B3a_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B3a_0_60))
                    (over all (not_occupied seg_T_B3b_0_60))
                    (over all (not_occupied seg_T_B3c_0_120_934))
                    (over all (not_occupied seg_T_B3d_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B3b_0_60 ?a))
                    (at start (not (not_blocked seg_T_B3b_0_60 ?a)))
                    (at start (blocked seg_T_B3c_0_120_934 ?a))
                    (at start (not (not_blocked seg_T_B3c_0_120_934 ?a)))
                    (at start (blocked seg_T_B3d_0_60 ?a))
                    (at start (not (not_blocked seg_T_B3d_0_60 ?a)))
         )
)
(:durative-action startup_seg_T_B3b_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B3b_0_60))
                    (over all (not_occupied seg_T_B3B4a_0_140))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B3B4a_0_140 ?a))
                    (at start (not (not_blocked seg_T_B3B4a_0_140 ?a)))
         )
)
(:durative-action startup_seg_T_B3b_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B3b_0_60))
                    (over all (not_occupied seg_T_B3a_0_60))
                    (over all (not_occupied seg_T_B3c_0_120_934))
                    (over all (not_occupied seg_T_B3d_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B3a_0_60 ?a))
                    (at start (not (not_blocked seg_T_B3a_0_60 ?a)))
                    (at start (blocked seg_T_B3c_0_120_934 ?a))
                    (at start (not (not_blocked seg_T_B3c_0_120_934 ?a)))
                    (at start (blocked seg_T_B3d_0_60 ?a))
                    (at start (not (not_blocked seg_T_B3d_0_60 ?a)))
         )
)
(:durative-action startup_seg_T_B3c_0_120_934_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B3c_0_120_934))
                    (over all (not_occupied seg_B3_b_0_80_6226))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_B3_b_0_80_6226 ?a))
                    (at start (not (not_blocked seg_B3_b_0_80_6226 ?a)))
         )
)
(:durative-action startup_seg_T_B3c_0_120_934_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B3c_0_120_934))
                    (over all (not_occupied seg_T_B3a_0_60))
                    (over all (not_occupied seg_T_B3b_0_60))
                    (over all (not_occupied seg_T_B3d_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B3a_0_60 ?a))
                    (at start (not (not_blocked seg_T_B3a_0_60 ?a)))
                    (at start (blocked seg_T_B3b_0_60 ?a))
                    (at start (not (not_blocked seg_T_B3b_0_60 ?a)))
                    (at start (blocked seg_T_B3d_0_60 ?a))
                    (at start (not (not_blocked seg_T_B3d_0_60 ?a)))
         )
)
(:durative-action startup_seg_T_B3d_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B3d_0_60))
                    (over all (not_occupied seg_T_B2B3c_0_140))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B2B3c_0_140 ?a))
                    (at start (not (not_blocked seg_T_B2B3c_0_140 ?a)))
         )
)
(:durative-action startup_seg_T_B3d_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B3d_0_60))
                    (over all (not_occupied seg_T_B3a_0_60))
                    (over all (not_occupied seg_T_B3b_0_60))
                    (over all (not_occupied seg_T_B3c_0_120_934))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B3a_0_60 ?a))
                    (at start (not (not_blocked seg_T_B3a_0_60 ?a)))
                    (at start (blocked seg_T_B3b_0_60 ?a))
                    (at start (not (not_blocked seg_T_B3b_0_60 ?a)))
                    (at start (blocked seg_T_B3c_0_120_934 ?a))
                    (at start (not (not_blocked seg_T_B3c_0_120_934 ?a)))
         )
)
(:durative-action startup_seg_S_B3b_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B3b_0_60))
                    (over all (not_occupied seg_T_B3a_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B3a_0_60 ?a))
                    (at start (not (not_blocked seg_T_B3a_0_60 ?a)))
         )
)
(:durative-action startup_seg_S_B3b_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B3b_0_60))
                    (over all (not_occupied seg_S_B3a_0_60))
                    (over all (not_occupied seg_S_B3c_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B3a_0_60 ?a))
                    (at start (not (not_blocked seg_S_B3a_0_60 ?a)))
                    (at start (blocked seg_S_B3c_0_60 ?a))
                    (at start (not (not_blocked seg_S_B3c_0_60 ?a)))
         )
)
(:durative-action startup_seg_T_B3B4a_0_140_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B3B4a_0_140))
                    (over all (not_occupied seg_T_B3B4b_0_140))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B3B4b_0_140 ?a))
                    (at start (not (not_blocked seg_T_B3B4b_0_140 ?a)))
         )
)
(:durative-action startup_seg_T_B3B4a_0_140_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B3B4a_0_140))
                    (over all (not_occupied seg_T_B3b_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B3b_0_60 ?a))
                    (at start (not (not_blocked seg_T_B3b_0_60 ?a)))
         )
)
(:durative-action startup_seg_B3_b_0_80_6226_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_B3_b_0_80_6226))
                    (over all (not_occupied seg_T_B3c_0_120_934))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B3c_0_120_934 ?a))
                    (at start (not (not_blocked seg_T_B3c_0_120_934 ?a)))
         )
)
(:durative-action startup_seg_B3_b_0_80_6226_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_B3_b_0_80_6226))
                    (over all (not_occupied seg_B3_b_1_0_80_6226))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_B3_b_1_0_80_6226 ?a))
                    (at start (not (not_blocked seg_B3_b_1_0_80_6226 ?a)))
         )
)
(:durative-action startup_seg_T_B3B4b_0_140_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B3B4b_0_140))
                    (over all (not_occupied seg_T_B3B4c_0_140))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B3B4c_0_140 ?a))
                    (at start (not (not_blocked seg_T_B3B4c_0_140 ?a)))
         )
)
(:durative-action startup_seg_T_B3B4b_0_140_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B3B4b_0_140))
                    (over all (not_occupied seg_T_B3B4a_0_140))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B3B4a_0_140 ?a))
                    (at start (not (not_blocked seg_T_B3B4a_0_140 ?a)))
         )
)
(:durative-action startup_seg_T_B3B4c_0_140_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B3B4c_0_140))
                    (over all (not_occupied seg_T_B3B4d_0_140))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B3B4d_0_140 ?a))
                    (at start (not (not_blocked seg_T_B3B4d_0_140 ?a)))
         )
)
(:durative-action startup_seg_T_B3B4c_0_140_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B3B4c_0_140))
                    (over all (not_occupied seg_T_B3B4b_0_140))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B3B4b_0_140 ?a))
                    (at start (not (not_blocked seg_T_B3B4b_0_140 ?a)))
         )
)
(:durative-action startup_seg_T_B3B4d_0_140_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B3B4d_0_140))
                    (over all (not_occupied seg_T_B4d_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B4d_0_60 ?a))
                    (at start (not (not_blocked seg_T_B4d_0_60 ?a)))
         )
)
(:durative-action startup_seg_T_B3B4d_0_140_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B3B4d_0_140))
                    (over all (not_occupied seg_T_B3B4c_0_140))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B3B4c_0_140 ?a))
                    (at start (not (not_blocked seg_T_B3B4c_0_140 ?a)))
         )
)
(:durative-action startup_seg_T_B4a_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B4a_0_60))
                    (over all (not_occupied seg_S_B4b_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B4b_0_60 ?a))
                    (at start (not (not_blocked seg_S_B4b_0_60 ?a)))
         )
)
(:durative-action startup_seg_T_B4a_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B4a_0_60))
                    (over all (not_occupied seg_T_B4b_0_60))
                    (over all (not_occupied seg_T_B4c_0_120_934))
                    (over all (not_occupied seg_T_B4d_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B4b_0_60 ?a))
                    (at start (not (not_blocked seg_T_B4b_0_60 ?a)))
                    (at start (blocked seg_T_B4c_0_120_934 ?a))
                    (at start (not (not_blocked seg_T_B4c_0_120_934 ?a)))
                    (at start (blocked seg_T_B4d_0_60 ?a))
                    (at start (not (not_blocked seg_T_B4d_0_60 ?a)))
         )
)
(:durative-action startup_seg_T_B4b_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B4b_0_60))
                    (over all (not_occupied seg_T_B4B6a_0_135))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B4B6a_0_135 ?a))
                    (at start (not (not_blocked seg_T_B4B6a_0_135 ?a)))
         )
)
(:durative-action startup_seg_T_B4b_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B4b_0_60))
                    (over all (not_occupied seg_T_B4a_0_60))
                    (over all (not_occupied seg_T_B4c_0_120_934))
                    (over all (not_occupied seg_T_B4d_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B4a_0_60 ?a))
                    (at start (not (not_blocked seg_T_B4a_0_60 ?a)))
                    (at start (blocked seg_T_B4c_0_120_934 ?a))
                    (at start (not (not_blocked seg_T_B4c_0_120_934 ?a)))
                    (at start (blocked seg_T_B4d_0_60 ?a))
                    (at start (not (not_blocked seg_T_B4d_0_60 ?a)))
         )
)
(:durative-action startup_seg_T_B4c_0_120_934_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B4c_0_120_934))
                    (over all (not_occupied seg_B4_b_0_80_6226))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_B4_b_0_80_6226 ?a))
                    (at start (not (not_blocked seg_B4_b_0_80_6226 ?a)))
         )
)
(:durative-action startup_seg_T_B4c_0_120_934_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B4c_0_120_934))
                    (over all (not_occupied seg_T_B4a_0_60))
                    (over all (not_occupied seg_T_B4b_0_60))
                    (over all (not_occupied seg_T_B4d_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B4a_0_60 ?a))
                    (at start (not (not_blocked seg_T_B4a_0_60 ?a)))
                    (at start (blocked seg_T_B4b_0_60 ?a))
                    (at start (not (not_blocked seg_T_B4b_0_60 ?a)))
                    (at start (blocked seg_T_B4d_0_60 ?a))
                    (at start (not (not_blocked seg_T_B4d_0_60 ?a)))
         )
)
(:durative-action startup_seg_T_B4d_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B4d_0_60))
                    (over all (not_occupied seg_T_B3B4d_0_140))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B3B4d_0_140 ?a))
                    (at start (not (not_blocked seg_T_B3B4d_0_140 ?a)))
         )
)
(:durative-action startup_seg_T_B4d_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B4d_0_60))
                    (over all (not_occupied seg_T_B4a_0_60))
                    (over all (not_occupied seg_T_B4b_0_60))
                    (over all (not_occupied seg_T_B4c_0_120_934))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B4a_0_60 ?a))
                    (at start (not (not_blocked seg_T_B4a_0_60 ?a)))
                    (at start (blocked seg_T_B4b_0_60 ?a))
                    (at start (not (not_blocked seg_T_B4b_0_60 ?a)))
                    (at start (blocked seg_T_B4c_0_120_934 ?a))
                    (at start (not (not_blocked seg_T_B4c_0_120_934 ?a)))
         )
)
(:durative-action startup_seg_S_B4b_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B4b_0_60))
                    (over all (not_occupied seg_T_B4a_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B4a_0_60 ?a))
                    (at start (not (not_blocked seg_T_B4a_0_60 ?a)))
         )
)
(:durative-action startup_seg_S_B4b_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B4b_0_60))
                    (over all (not_occupied seg_S_B4a_0_60))
                    (over all (not_occupied seg_S_B4c_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B4a_0_60 ?a))
                    (at start (not (not_blocked seg_S_B4a_0_60 ?a)))
                    (at start (blocked seg_S_B4c_0_60 ?a))
                    (at start (not (not_blocked seg_S_B4c_0_60 ?a)))
         )
)
(:durative-action startup_seg_T_B4B6a_0_135_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B4B6a_0_135))
                    (over all (not_occupied seg_T_B4B6b_0_135))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B4B6b_0_135 ?a))
                    (at start (not (not_blocked seg_T_B4B6b_0_135 ?a)))
         )
)
(:durative-action startup_seg_T_B4B6a_0_135_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B4B6a_0_135))
                    (over all (not_occupied seg_T_B4b_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B4b_0_60 ?a))
                    (at start (not (not_blocked seg_T_B4b_0_60 ?a)))
         )
)
(:durative-action startup_seg_B4_b_0_80_6226_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_B4_b_0_80_6226))
                    (over all (not_occupied seg_T_B4c_0_120_934))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B4c_0_120_934 ?a))
                    (at start (not (not_blocked seg_T_B4c_0_120_934 ?a)))
         )
)
(:durative-action startup_seg_B4_b_0_80_6226_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_B4_b_0_80_6226))
                    (over all (not_occupied seg_B4_b_1_0_80_6226))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_B4_b_1_0_80_6226 ?a))
                    (at start (not (not_blocked seg_B4_b_1_0_80_6226 ?a)))
         )
)
(:durative-action startup_seg_T_B4B6b_0_135_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B4B6b_0_135))
                    (over all (not_occupied seg_T_B4B6c_0_130))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B4B6c_0_130 ?a))
                    (at start (not (not_blocked seg_T_B4B6c_0_130 ?a)))
         )
)
(:durative-action startup_seg_T_B4B6b_0_135_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B4B6b_0_135))
                    (over all (not_occupied seg_T_B4B6a_0_135))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B4B6a_0_135 ?a))
                    (at start (not (not_blocked seg_T_B4B6a_0_135 ?a)))
         )
)
(:durative-action startup_seg_T_B4B6c_0_130_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B4B6c_0_130))
                    (over all (not_occupied seg_T_B6d_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B6d_0_60 ?a))
                    (at start (not (not_blocked seg_T_B6d_0_60 ?a)))
         )
)
(:durative-action startup_seg_T_B4B6c_0_130_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B4B6c_0_130))
                    (over all (not_occupied seg_T_B4B6b_0_135))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B4B6b_0_135 ?a))
                    (at start (not (not_blocked seg_T_B4B6b_0_135 ?a)))
         )
)
(:durative-action startup_seg_T_B6a_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B6a_0_60))
                    (over all (not_occupied seg_S_B6b_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B6b_0_60 ?a))
                    (at start (not (not_blocked seg_S_B6b_0_60 ?a)))
         )
)
(:durative-action startup_seg_T_B6a_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B6a_0_60))
                    (over all (not_occupied seg_T_B6b_0_60))
                    (over all (not_occupied seg_T_B6c_0_120_934))
                    (over all (not_occupied seg_T_B6d_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B6b_0_60 ?a))
                    (at start (not (not_blocked seg_T_B6b_0_60 ?a)))
                    (at start (blocked seg_T_B6c_0_120_934 ?a))
                    (at start (not (not_blocked seg_T_B6c_0_120_934 ?a)))
                    (at start (blocked seg_T_B6d_0_60 ?a))
                    (at start (not (not_blocked seg_T_B6d_0_60 ?a)))
         )
)
(:durative-action startup_seg_T_B6b_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B6b_0_60))
                    (over all (not_occupied seg_T_B6B7a_0_140))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B6B7a_0_140 ?a))
                    (at start (not (not_blocked seg_T_B6B7a_0_140 ?a)))
         )
)
(:durative-action startup_seg_T_B6b_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B6b_0_60))
                    (over all (not_occupied seg_T_B6a_0_60))
                    (over all (not_occupied seg_T_B6c_0_120_934))
                    (over all (not_occupied seg_T_B6d_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B6a_0_60 ?a))
                    (at start (not (not_blocked seg_T_B6a_0_60 ?a)))
                    (at start (blocked seg_T_B6c_0_120_934 ?a))
                    (at start (not (not_blocked seg_T_B6c_0_120_934 ?a)))
                    (at start (blocked seg_T_B6d_0_60 ?a))
                    (at start (not (not_blocked seg_T_B6d_0_60 ?a)))
         )
)
(:durative-action startup_seg_T_B6c_0_120_934_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B6c_0_120_934))
                    (over all (not_occupied seg_B6_b_0_159_512))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_B6_b_0_159_512 ?a))
                    (at start (not (not_blocked seg_B6_b_0_159_512 ?a)))
         )
)
(:durative-action startup_seg_T_B6c_0_120_934_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B6c_0_120_934))
                    (over all (not_occupied seg_T_B6a_0_60))
                    (over all (not_occupied seg_T_B6b_0_60))
                    (over all (not_occupied seg_T_B6d_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B6a_0_60 ?a))
                    (at start (not (not_blocked seg_T_B6a_0_60 ?a)))
                    (at start (blocked seg_T_B6b_0_60 ?a))
                    (at start (not (not_blocked seg_T_B6b_0_60 ?a)))
                    (at start (blocked seg_T_B6d_0_60 ?a))
                    (at start (not (not_blocked seg_T_B6d_0_60 ?a)))
         )
)
(:durative-action startup_seg_T_B6d_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B6d_0_60))
                    (over all (not_occupied seg_T_B4B6c_0_130))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B4B6c_0_130 ?a))
                    (at start (not (not_blocked seg_T_B4B6c_0_130 ?a)))
         )
)
(:durative-action startup_seg_T_B6d_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B6d_0_60))
                    (over all (not_occupied seg_T_B6a_0_60))
                    (over all (not_occupied seg_T_B6b_0_60))
                    (over all (not_occupied seg_T_B6c_0_120_934))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B6a_0_60 ?a))
                    (at start (not (not_blocked seg_T_B6a_0_60 ?a)))
                    (at start (blocked seg_T_B6b_0_60 ?a))
                    (at start (not (not_blocked seg_T_B6b_0_60 ?a)))
                    (at start (blocked seg_T_B6c_0_120_934 ?a))
                    (at start (not (not_blocked seg_T_B6c_0_120_934 ?a)))
         )
)
(:durative-action startup_seg_S_B6b_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B6b_0_60))
                    (over all (not_occupied seg_T_B6a_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B6a_0_60 ?a))
                    (at start (not (not_blocked seg_T_B6a_0_60 ?a)))
         )
)
(:durative-action startup_seg_S_B6b_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B6b_0_60))
                    (over all (not_occupied seg_S_B6a_0_60))
                    (over all (not_occupied seg_S_B6c_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B6a_0_60 ?a))
                    (at start (not (not_blocked seg_S_B6a_0_60 ?a)))
                    (at start (blocked seg_S_B6c_0_60 ?a))
                    (at start (not (not_blocked seg_S_B6c_0_60 ?a)))
         )
)
(:durative-action startup_seg_T_B6B7a_0_140_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B6B7a_0_140))
                    (over all (not_occupied seg_T_B6B7b_0_140))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B6B7b_0_140 ?a))
                    (at start (not (not_blocked seg_T_B6B7b_0_140 ?a)))
         )
)
(:durative-action startup_seg_T_B6B7a_0_140_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B6B7a_0_140))
                    (over all (not_occupied seg_T_B6b_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B6b_0_60 ?a))
                    (at start (not (not_blocked seg_T_B6b_0_60 ?a)))
         )
)
(:durative-action startup_seg_B6_b_0_159_512_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_B6_b_0_159_512))
                    (over all (not_occupied seg_T_B6c_0_120_934))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B6c_0_120_934 ?a))
                    (at start (not (not_blocked seg_T_B6c_0_120_934 ?a)))
         )
)
(:durative-action startup_seg_B6_b_0_159_512_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_B6_b_0_159_512))
                    (over all (not_occupied seg_B6_a_0_158_647))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_B6_a_0_158_647 ?a))
                    (at start (not (not_blocked seg_B6_a_0_158_647 ?a)))
         )
)
(:durative-action startup_seg_T_B6B7b_0_140_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B6B7b_0_140))
                    (over all (not_occupied seg_T_B7c_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B7c_0_60 ?a))
                    (at start (not (not_blocked seg_T_B7c_0_60 ?a)))
         )
)
(:durative-action startup_seg_T_B6B7b_0_140_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B6B7b_0_140))
                    (over all (not_occupied seg_T_B6B7a_0_140))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B6B7a_0_140 ?a))
                    (at start (not (not_blocked seg_T_B6B7a_0_140 ?a)))
         )
)
(:durative-action startup_seg_T_B7a_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B7a_0_60))
                    (over all (not_occupied seg_S_B7c_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B7c_0_60 ?a))
                    (at start (not (not_blocked seg_S_B7c_0_60 ?a)))
         )
)
(:durative-action startup_seg_T_B7a_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B7a_0_60))
                    (over all (not_occupied seg_T_B7b_0_60))
                    (over all (not_occupied seg_T_B7c_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B7b_0_60 ?a))
                    (at start (not (not_blocked seg_T_B7b_0_60 ?a)))
                    (at start (blocked seg_T_B7c_0_60 ?a))
                    (at start (not (not_blocked seg_T_B7c_0_60 ?a)))
         )
)
(:durative-action startup_seg_T_B7b_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B7b_0_60))
                    (over all (not_occupied seg_T_B5d_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B5d_0_60 ?a))
                    (at start (not (not_blocked seg_T_B5d_0_60 ?a)))
         )
)
(:durative-action startup_seg_T_B7b_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B7b_0_60))
                    (over all (not_occupied seg_T_B7a_0_60))
                    (over all (not_occupied seg_T_B7c_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B7a_0_60 ?a))
                    (at start (not (not_blocked seg_T_B7a_0_60 ?a)))
                    (at start (blocked seg_T_B7c_0_60 ?a))
                    (at start (not (not_blocked seg_T_B7c_0_60 ?a)))
         )
)
(:durative-action startup_seg_T_B7c_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B7c_0_60))
                    (over all (not_occupied seg_T_B6B7b_0_140))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B6B7b_0_140 ?a))
                    (at start (not (not_blocked seg_T_B6B7b_0_140 ?a)))
         )
)
(:durative-action startup_seg_T_B7c_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B7c_0_60))
                    (over all (not_occupied seg_T_B7a_0_60))
                    (over all (not_occupied seg_T_B7b_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B7a_0_60 ?a))
                    (at start (not (not_blocked seg_T_B7a_0_60 ?a)))
                    (at start (blocked seg_T_B7b_0_60 ?a))
                    (at start (not (not_blocked seg_T_B7b_0_60 ?a)))
         )
)
(:durative-action startup_seg_S_B7c_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B7c_0_60))
                    (over all (not_occupied seg_T_B7a_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B7a_0_60 ?a))
                    (at start (not (not_blocked seg_T_B7a_0_60 ?a)))
         )
)
(:durative-action startup_seg_S_B7c_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B7c_0_60))
                    (over all (not_occupied seg_S_B7a_0_60))
                    (over all (not_occupied seg_S_B7b_0_60))
                    (over all (not_occupied seg_S_B7d_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B7a_0_60 ?a))
                    (at start (not (not_blocked seg_S_B7a_0_60 ?a)))
                    (at start (blocked seg_S_B7b_0_60 ?a))
                    (at start (not (not_blocked seg_S_B7b_0_60 ?a)))
                    (at start (blocked seg_S_B7d_0_60 ?a))
                    (at start (not (not_blocked seg_S_B7d_0_60 ?a)))
         )
)
(:durative-action startup_seg_T_B5d_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B5d_0_60))
                    (over all (not_occupied seg_T_B7b_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B7b_0_60 ?a))
                    (at start (not (not_blocked seg_T_B7b_0_60 ?a)))
         )
)
(:durative-action startup_seg_T_B5d_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B5d_0_60))
                    (over all (not_occupied seg_T_B5a_0_60))
                    (over all (not_occupied seg_T_B5b_0_60))
                    (over all (not_occupied seg_T_B5c_0_120_934))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B5a_0_60 ?a))
                    (at start (not (not_blocked seg_T_B5a_0_60 ?a)))
                    (at start (blocked seg_T_B5b_0_60 ?a))
                    (at start (not (not_blocked seg_T_B5b_0_60 ?a)))
                    (at start (blocked seg_T_B5c_0_120_934 ?a))
                    (at start (not (not_blocked seg_T_B5c_0_120_934 ?a)))
         )
)
(:durative-action startup_seg_T_B5a_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B5a_0_60))
                    (over all (not_occupied seg_S_B5c_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B5c_0_60 ?a))
                    (at start (not (not_blocked seg_S_B5c_0_60 ?a)))
         )
)
(:durative-action startup_seg_T_B5a_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B5a_0_60))
                    (over all (not_occupied seg_T_B5b_0_60))
                    (over all (not_occupied seg_T_B5c_0_120_934))
                    (over all (not_occupied seg_T_B5d_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B5b_0_60 ?a))
                    (at start (not (not_blocked seg_T_B5b_0_60 ?a)))
                    (at start (blocked seg_T_B5c_0_120_934 ?a))
                    (at start (not (not_blocked seg_T_B5c_0_120_934 ?a)))
                    (at start (blocked seg_T_B5d_0_60 ?a))
                    (at start (not (not_blocked seg_T_B5d_0_60 ?a)))
         )
)
(:durative-action startup_seg_T_B5b_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B5b_0_60))
                    (over all (not_occupied seg_T_B5B8a_0_135))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B5B8a_0_135 ?a))
                    (at start (not (not_blocked seg_T_B5B8a_0_135 ?a)))
         )
)
(:durative-action startup_seg_T_B5b_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B5b_0_60))
                    (over all (not_occupied seg_T_B5a_0_60))
                    (over all (not_occupied seg_T_B5c_0_120_934))
                    (over all (not_occupied seg_T_B5d_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B5a_0_60 ?a))
                    (at start (not (not_blocked seg_T_B5a_0_60 ?a)))
                    (at start (blocked seg_T_B5c_0_120_934 ?a))
                    (at start (not (not_blocked seg_T_B5c_0_120_934 ?a)))
                    (at start (blocked seg_T_B5d_0_60 ?a))
                    (at start (not (not_blocked seg_T_B5d_0_60 ?a)))
         )
)
(:durative-action startup_seg_T_B5c_0_120_934_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B5c_0_120_934))
                    (over all (not_occupied seg_B5_b_0_159_512))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_B5_b_0_159_512 ?a))
                    (at start (not (not_blocked seg_B5_b_0_159_512 ?a)))
         )
)
(:durative-action startup_seg_T_B5c_0_120_934_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B5c_0_120_934))
                    (over all (not_occupied seg_T_B5a_0_60))
                    (over all (not_occupied seg_T_B5b_0_60))
                    (over all (not_occupied seg_T_B5d_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B5a_0_60 ?a))
                    (at start (not (not_blocked seg_T_B5a_0_60 ?a)))
                    (at start (blocked seg_T_B5b_0_60 ?a))
                    (at start (not (not_blocked seg_T_B5b_0_60 ?a)))
                    (at start (blocked seg_T_B5d_0_60 ?a))
                    (at start (not (not_blocked seg_T_B5d_0_60 ?a)))
         )
)
(:durative-action startup_seg_S_B5c_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B5c_0_60))
                    (over all (not_occupied seg_T_B5a_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B5a_0_60 ?a))
                    (at start (not (not_blocked seg_T_B5a_0_60 ?a)))
         )
)
(:durative-action startup_seg_S_B5c_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B5c_0_60))
                    (over all (not_occupied seg_S_B5a_0_60))
                    (over all (not_occupied seg_S_B5b_0_60))
                    (over all (not_occupied seg_S_B5d_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B5a_0_60 ?a))
                    (at start (not (not_blocked seg_S_B5a_0_60 ?a)))
                    (at start (blocked seg_S_B5b_0_60 ?a))
                    (at start (not (not_blocked seg_S_B5b_0_60 ?a)))
                    (at start (blocked seg_S_B5d_0_60 ?a))
                    (at start (not (not_blocked seg_S_B5d_0_60 ?a)))
         )
)
(:durative-action startup_seg_T_B5B8a_0_135_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B5B8a_0_135))
                    (over all (not_occupied seg_T_B5B8b_0_135))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B5B8b_0_135 ?a))
                    (at start (not (not_blocked seg_T_B5B8b_0_135 ?a)))
         )
)
(:durative-action startup_seg_T_B5B8a_0_135_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B5B8a_0_135))
                    (over all (not_occupied seg_T_B5b_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B5b_0_60 ?a))
                    (at start (not (not_blocked seg_T_B5b_0_60 ?a)))
         )
)
(:durative-action startup_seg_B5_b_0_159_512_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_B5_b_0_159_512))
                    (over all (not_occupied seg_T_B5c_0_120_934))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B5c_0_120_934 ?a))
                    (at start (not (not_blocked seg_T_B5c_0_120_934 ?a)))
         )
)
(:durative-action startup_seg_B5_b_0_159_512_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_B5_b_0_159_512))
                    (over all (not_occupied seg_B5_a_0_158_647))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_B5_a_0_158_647 ?a))
                    (at start (not (not_blocked seg_B5_a_0_158_647 ?a)))
         )
)
(:durative-action startup_seg_T_B5B8b_0_135_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B5B8b_0_135))
                    (over all (not_occupied seg_T_B5B8c_0_130))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B5B8c_0_130 ?a))
                    (at start (not (not_blocked seg_T_B5B8c_0_130 ?a)))
         )
)
(:durative-action startup_seg_T_B5B8b_0_135_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B5B8b_0_135))
                    (over all (not_occupied seg_T_B5B8a_0_135))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B5B8a_0_135 ?a))
                    (at start (not (not_blocked seg_T_B5B8a_0_135 ?a)))
         )
)
(:durative-action startup_seg_T_B5B8c_0_130_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B5B8c_0_130))
                    (over all (not_occupied seg_T_B8d_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B8d_0_60 ?a))
                    (at start (not (not_blocked seg_T_B8d_0_60 ?a)))
         )
)
(:durative-action startup_seg_T_B5B8c_0_130_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B5B8c_0_130))
                    (over all (not_occupied seg_T_B5B8b_0_135))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B5B8b_0_135 ?a))
                    (at start (not (not_blocked seg_T_B5B8b_0_135 ?a)))
         )
)
(:durative-action startup_seg_T_B8a_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B8a_0_60))
                    (over all (not_occupied seg_S_B8b_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B8b_0_60 ?a))
                    (at start (not (not_blocked seg_S_B8b_0_60 ?a)))
         )
)
(:durative-action startup_seg_T_B8a_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B8a_0_60))
                    (over all (not_occupied seg_T_B8b_0_60))
                    (over all (not_occupied seg_T_B8c_0_120_934))
                    (over all (not_occupied seg_T_B8d_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B8b_0_60 ?a))
                    (at start (not (not_blocked seg_T_B8b_0_60 ?a)))
                    (at start (blocked seg_T_B8c_0_120_934 ?a))
                    (at start (not (not_blocked seg_T_B8c_0_120_934 ?a)))
                    (at start (blocked seg_T_B8d_0_60 ?a))
                    (at start (not (not_blocked seg_T_B8d_0_60 ?a)))
         )
)
(:durative-action startup_seg_T_B8b_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B8b_0_60))
                    (over all (not_occupied seg_T_B8B9a_0_115))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B8B9a_0_115 ?a))
                    (at start (not (not_blocked seg_T_B8B9a_0_115 ?a)))
         )
)
(:durative-action startup_seg_T_B8b_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B8b_0_60))
                    (over all (not_occupied seg_T_B8a_0_60))
                    (over all (not_occupied seg_T_B8c_0_120_934))
                    (over all (not_occupied seg_T_B8d_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B8a_0_60 ?a))
                    (at start (not (not_blocked seg_T_B8a_0_60 ?a)))
                    (at start (blocked seg_T_B8c_0_120_934 ?a))
                    (at start (not (not_blocked seg_T_B8c_0_120_934 ?a)))
                    (at start (blocked seg_T_B8d_0_60 ?a))
                    (at start (not (not_blocked seg_T_B8d_0_60 ?a)))
         )
)
(:durative-action startup_seg_T_B8c_0_120_934_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B8c_0_120_934))
                    (over all (not_occupied seg_B8_b_0_80_6226))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_B8_b_0_80_6226 ?a))
                    (at start (not (not_blocked seg_B8_b_0_80_6226 ?a)))
         )
)
(:durative-action startup_seg_T_B8c_0_120_934_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B8c_0_120_934))
                    (over all (not_occupied seg_T_B8a_0_60))
                    (over all (not_occupied seg_T_B8b_0_60))
                    (over all (not_occupied seg_T_B8d_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B8a_0_60 ?a))
                    (at start (not (not_blocked seg_T_B8a_0_60 ?a)))
                    (at start (blocked seg_T_B8b_0_60 ?a))
                    (at start (not (not_blocked seg_T_B8b_0_60 ?a)))
                    (at start (blocked seg_T_B8d_0_60 ?a))
                    (at start (not (not_blocked seg_T_B8d_0_60 ?a)))
         )
)
(:durative-action startup_seg_T_B8d_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B8d_0_60))
                    (over all (not_occupied seg_T_B5B8c_0_130))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B5B8c_0_130 ?a))
                    (at start (not (not_blocked seg_T_B5B8c_0_130 ?a)))
         )
)
(:durative-action startup_seg_T_B8d_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B8d_0_60))
                    (over all (not_occupied seg_T_B8a_0_60))
                    (over all (not_occupied seg_T_B8b_0_60))
                    (over all (not_occupied seg_T_B8c_0_120_934))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B8a_0_60 ?a))
                    (at start (not (not_blocked seg_T_B8a_0_60 ?a)))
                    (at start (blocked seg_T_B8b_0_60 ?a))
                    (at start (not (not_blocked seg_T_B8b_0_60 ?a)))
                    (at start (blocked seg_T_B8c_0_120_934 ?a))
                    (at start (not (not_blocked seg_T_B8c_0_120_934 ?a)))
         )
)
(:durative-action startup_seg_S_B8b_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B8b_0_60))
                    (over all (not_occupied seg_T_B8a_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B8a_0_60 ?a))
                    (at start (not (not_blocked seg_T_B8a_0_60 ?a)))
         )
)
(:durative-action startup_seg_S_B8b_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B8b_0_60))
                    (over all (not_occupied seg_S_B8a_0_60))
                    (over all (not_occupied seg_S_B8c_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B8a_0_60 ?a))
                    (at start (not (not_blocked seg_S_B8a_0_60 ?a)))
                    (at start (blocked seg_S_B8c_0_60 ?a))
                    (at start (not (not_blocked seg_S_B8c_0_60 ?a)))
         )
)
(:durative-action startup_seg_T_B8B9a_0_115_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B8B9a_0_115))
                    (over all (not_occupied seg_T_B8B9b_0_115))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B8B9b_0_115 ?a))
                    (at start (not (not_blocked seg_T_B8B9b_0_115 ?a)))
         )
)
(:durative-action startup_seg_T_B8B9a_0_115_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B8B9a_0_115))
                    (over all (not_occupied seg_T_B8b_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B8b_0_60 ?a))
                    (at start (not (not_blocked seg_T_B8b_0_60 ?a)))
         )
)
(:durative-action startup_seg_B8_b_0_80_6226_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_B8_b_0_80_6226))
                    (over all (not_occupied seg_T_B8c_0_120_934))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B8c_0_120_934 ?a))
                    (at start (not (not_blocked seg_T_B8c_0_120_934 ?a)))
         )
)
(:durative-action startup_seg_B8_b_0_80_6226_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_B8_b_0_80_6226))
                    (over all (not_occupied seg_B8_b_1_0_80_6226))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_B8_b_1_0_80_6226 ?a))
                    (at start (not (not_blocked seg_B8_b_1_0_80_6226 ?a)))
         )
)
(:durative-action startup_seg_T_B8B9b_0_115_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B8B9b_0_115))
                    (over all (not_occupied seg_T_B8B9c_1_0_115))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B8B9c_1_0_115 ?a))
                    (at start (not (not_blocked seg_T_B8B9c_1_0_115 ?a)))
         )
)
(:durative-action startup_seg_T_B8B9b_0_115_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B8B9b_0_115))
                    (over all (not_occupied seg_T_B8B9a_0_115))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B8B9a_0_115 ?a))
                    (at start (not (not_blocked seg_T_B8B9a_0_115 ?a)))
         )
)
(:durative-action startup_seg_T_B8B9c_1_0_115_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B8B9c_1_0_115))
                    (over all (not_occupied seg_T_B8B9c_0_115))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B8B9c_0_115 ?a))
                    (at start (not (not_blocked seg_T_B8B9c_0_115 ?a)))
         )
)
(:durative-action startup_seg_T_B8B9c_1_0_115_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B8B9c_1_0_115))
                    (over all (not_occupied seg_T_B8B9b_0_115))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B8B9b_0_115 ?a))
                    (at start (not (not_blocked seg_T_B8B9b_0_115 ?a)))
         )
)
(:durative-action startup_seg_T_B9a_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B9a_0_60))
                    (over all (not_occupied seg_S_B9b_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B9b_0_60 ?a))
                    (at start (not (not_blocked seg_S_B9b_0_60 ?a)))
         )
)
(:durative-action startup_seg_T_B9a_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B9a_0_60))
                    (over all (not_occupied seg_T_B9b_0_60))
                    (over all (not_occupied seg_T_B9c_0_120_934))
                    (over all (not_occupied seg_T_B9d_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B9b_0_60 ?a))
                    (at start (not (not_blocked seg_T_B9b_0_60 ?a)))
                    (at start (blocked seg_T_B9c_0_120_934 ?a))
                    (at start (not (not_blocked seg_T_B9c_0_120_934 ?a)))
                    (at start (blocked seg_T_B9d_0_60 ?a))
                    (at start (not (not_blocked seg_T_B9d_0_60 ?a)))
         )
)
(:durative-action startup_seg_T_B9b_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B9b_0_60))
                    (over all (not_occupied seg_T_B9B10a_0_125))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B9B10a_0_125 ?a))
                    (at start (not (not_blocked seg_T_B9B10a_0_125 ?a)))
         )
)
(:durative-action startup_seg_T_B9b_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B9b_0_60))
                    (over all (not_occupied seg_T_B9a_0_60))
                    (over all (not_occupied seg_T_B9c_0_120_934))
                    (over all (not_occupied seg_T_B9d_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B9a_0_60 ?a))
                    (at start (not (not_blocked seg_T_B9a_0_60 ?a)))
                    (at start (blocked seg_T_B9c_0_120_934 ?a))
                    (at start (not (not_blocked seg_T_B9c_0_120_934 ?a)))
                    (at start (blocked seg_T_B9d_0_60 ?a))
                    (at start (not (not_blocked seg_T_B9d_0_60 ?a)))
         )
)
(:durative-action startup_seg_T_B9c_0_120_934_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B9c_0_120_934))
                    (over all (not_occupied seg_B9_b_0_80_6226))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_B9_b_0_80_6226 ?a))
                    (at start (not (not_blocked seg_B9_b_0_80_6226 ?a)))
         )
)
(:durative-action startup_seg_T_B9c_0_120_934_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B9c_0_120_934))
                    (over all (not_occupied seg_T_B9a_0_60))
                    (over all (not_occupied seg_T_B9b_0_60))
                    (over all (not_occupied seg_T_B9d_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B9a_0_60 ?a))
                    (at start (not (not_blocked seg_T_B9a_0_60 ?a)))
                    (at start (blocked seg_T_B9b_0_60 ?a))
                    (at start (not (not_blocked seg_T_B9b_0_60 ?a)))
                    (at start (blocked seg_T_B9d_0_60 ?a))
                    (at start (not (not_blocked seg_T_B9d_0_60 ?a)))
         )
)
(:durative-action startup_seg_T_B9d_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B9d_0_60))
                    (over all (not_occupied seg_T_B8B9c_0_115))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B8B9c_0_115 ?a))
                    (at start (not (not_blocked seg_T_B8B9c_0_115 ?a)))
         )
)
(:durative-action startup_seg_T_B9d_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B9d_0_60))
                    (over all (not_occupied seg_T_B9a_0_60))
                    (over all (not_occupied seg_T_B9b_0_60))
                    (over all (not_occupied seg_T_B9c_0_120_934))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B9a_0_60 ?a))
                    (at start (not (not_blocked seg_T_B9a_0_60 ?a)))
                    (at start (blocked seg_T_B9b_0_60 ?a))
                    (at start (not (not_blocked seg_T_B9b_0_60 ?a)))
                    (at start (blocked seg_T_B9c_0_120_934 ?a))
                    (at start (not (not_blocked seg_T_B9c_0_120_934 ?a)))
         )
)
(:durative-action startup_seg_S_B9b_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B9b_0_60))
                    (over all (not_occupied seg_T_B9a_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B9a_0_60 ?a))
                    (at start (not (not_blocked seg_T_B9a_0_60 ?a)))
         )
)
(:durative-action startup_seg_S_B9b_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B9b_0_60))
                    (over all (not_occupied seg_S_B9a_0_60))
                    (over all (not_occupied seg_S_B9c_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B9a_0_60 ?a))
                    (at start (not (not_blocked seg_S_B9a_0_60 ?a)))
                    (at start (blocked seg_S_B9c_0_60 ?a))
                    (at start (not (not_blocked seg_S_B9c_0_60 ?a)))
         )
)
(:durative-action startup_seg_T_B9B10a_0_125_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B9B10a_0_125))
                    (over all (not_occupied seg_T_B9B10b_0_125))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B9B10b_0_125 ?a))
                    (at start (not (not_blocked seg_T_B9B10b_0_125 ?a)))
         )
)
(:durative-action startup_seg_T_B9B10a_0_125_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B9B10a_0_125))
                    (over all (not_occupied seg_T_B9b_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B9b_0_60 ?a))
                    (at start (not (not_blocked seg_T_B9b_0_60 ?a)))
         )
)
(:durative-action startup_seg_B9_b_0_80_6226_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_B9_b_0_80_6226))
                    (over all (not_occupied seg_T_B9c_0_120_934))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B9c_0_120_934 ?a))
                    (at start (not (not_blocked seg_T_B9c_0_120_934 ?a)))
         )
)
(:durative-action startup_seg_B9_b_0_80_6226_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_B9_b_0_80_6226))
                    (over all (not_occupied seg_B9_b_1_0_80_6226))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_B9_b_1_0_80_6226 ?a))
                    (at start (not (not_blocked seg_B9_b_1_0_80_6226 ?a)))
         )
)
(:durative-action startup_seg_T_B8B9c_0_115_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B8B9c_0_115))
                    (over all (not_occupied seg_T_B9d_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B9d_0_60 ?a))
                    (at start (not (not_blocked seg_T_B9d_0_60 ?a)))
         )
)
(:durative-action startup_seg_T_B8B9c_0_115_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B8B9c_0_115))
                    (over all (not_occupied seg_T_B8B9c_1_0_115))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B8B9c_1_0_115 ?a))
                    (at start (not (not_blocked seg_T_B8B9c_1_0_115 ?a)))
         )
)
(:durative-action startup_seg_T_B9B10b_0_125_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B9B10b_0_125))
                    (over all (not_occupied seg_T_B9B10c_1_0_83))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B9B10c_1_0_83 ?a))
                    (at start (not (not_blocked seg_T_B9B10c_1_0_83 ?a)))
         )
)
(:durative-action startup_seg_T_B9B10b_0_125_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B9B10b_0_125))
                    (over all (not_occupied seg_T_B9B10a_0_125))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B9B10a_0_125 ?a))
                    (at start (not (not_blocked seg_T_B9B10a_0_125 ?a)))
         )
)
(:durative-action startup_seg_T_B9B10c_1_0_83_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B9B10c_1_0_83))
                    (over all (not_occupied seg_T_B9B10c_2_0_83))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B9B10c_2_0_83 ?a))
                    (at start (not (not_blocked seg_T_B9B10c_2_0_83 ?a)))
         )
)
(:durative-action startup_seg_T_B9B10c_1_0_83_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B9B10c_1_0_83))
                    (over all (not_occupied seg_T_B9B10b_0_125))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B9B10b_0_125 ?a))
                    (at start (not (not_blocked seg_T_B9B10b_0_125 ?a)))
         )
)
(:durative-action startup_seg_T_B10a_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B10a_0_60))
                    (over all (not_occupied seg_S_B10a_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B10a_0_60 ?a))
                    (at start (not (not_blocked seg_S_B10a_0_60 ?a)))
         )
)
(:durative-action startup_seg_T_B10a_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B10a_0_60))
                    (over all (not_occupied seg_T_B10b_0_60))
                    (over all (not_occupied seg_T_B10c_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B10b_0_60 ?a))
                    (at start (not (not_blocked seg_T_B10b_0_60 ?a)))
                    (at start (blocked seg_T_B10c_0_60 ?a))
                    (at start (not (not_blocked seg_T_B10c_0_60 ?a)))
         )
)
(:durative-action startup_seg_T_B10b_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B10b_0_60))
                    (over all (not_occupied seg_B10_0_80))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_B10_0_80 ?a))
                    (at start (not (not_blocked seg_B10_0_80 ?a)))
         )
)
(:durative-action startup_seg_T_B10b_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B10b_0_60))
                    (over all (not_occupied seg_T_B10a_0_60))
                    (over all (not_occupied seg_T_B10c_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B10a_0_60 ?a))
                    (at start (not (not_blocked seg_T_B10a_0_60 ?a)))
                    (at start (blocked seg_T_B10c_0_60 ?a))
                    (at start (not (not_blocked seg_T_B10c_0_60 ?a)))
         )
)
(:durative-action startup_seg_T_B10c_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B10c_0_60))
                    (over all (not_occupied seg_T_B9B10c_0_84))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B9B10c_0_84 ?a))
                    (at start (not (not_blocked seg_T_B9B10c_0_84 ?a)))
         )
)
(:durative-action startup_seg_T_B10c_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B10c_0_60))
                    (over all (not_occupied seg_T_B10a_0_60))
                    (over all (not_occupied seg_T_B10b_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B10a_0_60 ?a))
                    (at start (not (not_blocked seg_T_B10a_0_60 ?a)))
                    (at start (blocked seg_T_B10b_0_60 ?a))
                    (at start (not (not_blocked seg_T_B10b_0_60 ?a)))
         )
)
(:durative-action startup_seg_S_B10a_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B10a_0_60))
                    (over all (not_occupied seg_T_B10a_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B10a_0_60 ?a))
                    (at start (not (not_blocked seg_T_B10a_0_60 ?a)))
         )
)
(:durative-action startup_seg_S_B10a_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B10a_0_60))
                    (over all (not_occupied seg_S_B10b_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B10b_0_60 ?a))
                    (at start (not (not_blocked seg_S_B10b_0_60 ?a)))
         )
)
(:durative-action startup_seg_B10_0_80_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_B10_0_80))
                    (over all (not_occupied seg_T_B10b_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B10b_0_60 ?a))
                    (at start (not (not_blocked seg_T_B10b_0_60 ?a)))
         )
)
(:durative-action startup_seg_B10_0_80_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_B10_0_80))
                    (over all (not_occupied seg_B10_1_0_80))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_B10_1_0_80 ?a))
                    (at start (not (not_blocked seg_B10_1_0_80 ?a)))
         )
)
(:durative-action startup_seg_T_B9B10c_0_84_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B9B10c_0_84))
                    (over all (not_occupied seg_T_B10c_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B10c_0_60 ?a))
                    (at start (not (not_blocked seg_T_B10c_0_60 ?a)))
         )
)
(:durative-action startup_seg_T_B9B10c_0_84_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B9B10c_0_84))
                    (over all (not_occupied seg_T_B9B10c_2_0_83))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B9B10c_2_0_83 ?a))
                    (at start (not (not_blocked seg_T_B9B10c_2_0_83 ?a)))
         )
)
(:durative-action startup_seg_S_B2a_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B2a_0_60))
                    (over all (not_occupied seg_S_B2B3a_0_140))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B2B3a_0_140 ?a))
                    (at start (not (not_blocked seg_S_B2B3a_0_140 ?a)))
         )
)
(:durative-action startup_seg_S_B2a_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B2a_0_60))
                    (over all (not_occupied seg_S_B2b_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B2b_0_60 ?a))
                    (at start (not (not_blocked seg_S_B2b_0_60 ?a)))
         )
)
(:durative-action startup_seg_S_B2B3a_0_140_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B2B3a_0_140))
                    (over all (not_occupied seg_S_B2B3b_0_140))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B2B3b_0_140 ?a))
                    (at start (not (not_blocked seg_S_B2B3b_0_140 ?a)))
         )
)
(:durative-action startup_seg_S_B2B3a_0_140_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B2B3a_0_140))
                    (over all (not_occupied seg_S_B2a_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B2a_0_60 ?a))
                    (at start (not (not_blocked seg_S_B2a_0_60 ?a)))
         )
)
(:durative-action startup_seg_S_B2B3b_0_140_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B2B3b_0_140))
                    (over all (not_occupied seg_S_B2B3c_0_140))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B2B3c_0_140 ?a))
                    (at start (not (not_blocked seg_S_B2B3c_0_140 ?a)))
         )
)
(:durative-action startup_seg_S_B2B3b_0_140_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B2B3b_0_140))
                    (over all (not_occupied seg_S_B2B3a_0_140))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B2B3a_0_140 ?a))
                    (at start (not (not_blocked seg_S_B2B3a_0_140 ?a)))
         )
)
(:durative-action startup_seg_S_B2B3c_0_140_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B2B3c_0_140))
                    (over all (not_occupied seg_S_B3c_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B3c_0_60 ?a))
                    (at start (not (not_blocked seg_S_B3c_0_60 ?a)))
         )
)
(:durative-action startup_seg_S_B2B3c_0_140_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B2B3c_0_140))
                    (over all (not_occupied seg_S_B2B3b_0_140))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B2B3b_0_140 ?a))
                    (at start (not (not_blocked seg_S_B2B3b_0_140 ?a)))
         )
)
(:durative-action startup_seg_S_B3a_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B3a_0_60))
                    (over all (not_occupied seg_S_B3B4a_0_140))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B3B4a_0_140 ?a))
                    (at start (not (not_blocked seg_S_B3B4a_0_140 ?a)))
         )
)
(:durative-action startup_seg_S_B3a_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B3a_0_60))
                    (over all (not_occupied seg_S_B3b_0_60))
                    (over all (not_occupied seg_S_B3c_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B3b_0_60 ?a))
                    (at start (not (not_blocked seg_S_B3b_0_60 ?a)))
                    (at start (blocked seg_S_B3c_0_60 ?a))
                    (at start (not (not_blocked seg_S_B3c_0_60 ?a)))
         )
)
(:durative-action startup_seg_S_B3c_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B3c_0_60))
                    (over all (not_occupied seg_S_B2B3c_0_140))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B2B3c_0_140 ?a))
                    (at start (not (not_blocked seg_S_B2B3c_0_140 ?a)))
         )
)
(:durative-action startup_seg_S_B3c_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B3c_0_60))
                    (over all (not_occupied seg_S_B3a_0_60))
                    (over all (not_occupied seg_S_B3b_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B3a_0_60 ?a))
                    (at start (not (not_blocked seg_S_B3a_0_60 ?a)))
                    (at start (blocked seg_S_B3b_0_60 ?a))
                    (at start (not (not_blocked seg_S_B3b_0_60 ?a)))
         )
)
(:durative-action startup_seg_S_B3B4a_0_140_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B3B4a_0_140))
                    (over all (not_occupied seg_S_B3B4b_0_140))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B3B4b_0_140 ?a))
                    (at start (not (not_blocked seg_S_B3B4b_0_140 ?a)))
         )
)
(:durative-action startup_seg_S_B3B4a_0_140_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B3B4a_0_140))
                    (over all (not_occupied seg_S_B3a_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B3a_0_60 ?a))
                    (at start (not (not_blocked seg_S_B3a_0_60 ?a)))
         )
)
(:durative-action startup_seg_S_B3B4b_0_140_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B3B4b_0_140))
                    (over all (not_occupied seg_S_B3B4c_0_140))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B3B4c_0_140 ?a))
                    (at start (not (not_blocked seg_S_B3B4c_0_140 ?a)))
         )
)
(:durative-action startup_seg_S_B3B4b_0_140_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B3B4b_0_140))
                    (over all (not_occupied seg_S_B3B4a_0_140))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B3B4a_0_140 ?a))
                    (at start (not (not_blocked seg_S_B3B4a_0_140 ?a)))
         )
)
(:durative-action startup_seg_S_B3B4c_0_140_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B3B4c_0_140))
                    (over all (not_occupied seg_S_B3B4d_0_140))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B3B4d_0_140 ?a))
                    (at start (not (not_blocked seg_S_B3B4d_0_140 ?a)))
         )
)
(:durative-action startup_seg_S_B3B4c_0_140_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B3B4c_0_140))
                    (over all (not_occupied seg_S_B3B4b_0_140))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B3B4b_0_140 ?a))
                    (at start (not (not_blocked seg_S_B3B4b_0_140 ?a)))
         )
)
(:durative-action startup_seg_S_B3B4d_0_140_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B3B4d_0_140))
                    (over all (not_occupied seg_S_B4c_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B4c_0_60 ?a))
                    (at start (not (not_blocked seg_S_B4c_0_60 ?a)))
         )
)
(:durative-action startup_seg_S_B3B4d_0_140_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B3B4d_0_140))
                    (over all (not_occupied seg_S_B3B4c_0_140))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B3B4c_0_140 ?a))
                    (at start (not (not_blocked seg_S_B3B4c_0_140 ?a)))
         )
)
(:durative-action startup_seg_S_B4a_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B4a_0_60))
                    (over all (not_occupied seg_S_B4B6a_0_135))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B4B6a_0_135 ?a))
                    (at start (not (not_blocked seg_S_B4B6a_0_135 ?a)))
         )
)
(:durative-action startup_seg_S_B4a_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B4a_0_60))
                    (over all (not_occupied seg_S_B4b_0_60))
                    (over all (not_occupied seg_S_B4c_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B4b_0_60 ?a))
                    (at start (not (not_blocked seg_S_B4b_0_60 ?a)))
                    (at start (blocked seg_S_B4c_0_60 ?a))
                    (at start (not (not_blocked seg_S_B4c_0_60 ?a)))
         )
)
(:durative-action startup_seg_S_B4c_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B4c_0_60))
                    (over all (not_occupied seg_S_B3B4d_0_140))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B3B4d_0_140 ?a))
                    (at start (not (not_blocked seg_S_B3B4d_0_140 ?a)))
         )
)
(:durative-action startup_seg_S_B4c_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B4c_0_60))
                    (over all (not_occupied seg_S_B4a_0_60))
                    (over all (not_occupied seg_S_B4b_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B4a_0_60 ?a))
                    (at start (not (not_blocked seg_S_B4a_0_60 ?a)))
                    (at start (blocked seg_S_B4b_0_60 ?a))
                    (at start (not (not_blocked seg_S_B4b_0_60 ?a)))
         )
)
(:durative-action startup_seg_S_B4B6a_0_135_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B4B6a_0_135))
                    (over all (not_occupied seg_S_B4B6b_0_135))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B4B6b_0_135 ?a))
                    (at start (not (not_blocked seg_S_B4B6b_0_135 ?a)))
         )
)
(:durative-action startup_seg_S_B4B6a_0_135_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B4B6a_0_135))
                    (over all (not_occupied seg_S_B4a_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B4a_0_60 ?a))
                    (at start (not (not_blocked seg_S_B4a_0_60 ?a)))
         )
)
(:durative-action startup_seg_S_B4B6b_0_135_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B4B6b_0_135))
                    (over all (not_occupied seg_S_B4B6c_0_130))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B4B6c_0_130 ?a))
                    (at start (not (not_blocked seg_S_B4B6c_0_130 ?a)))
         )
)
(:durative-action startup_seg_S_B4B6b_0_135_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B4B6b_0_135))
                    (over all (not_occupied seg_S_B4B6a_0_135))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B4B6a_0_135 ?a))
                    (at start (not (not_blocked seg_S_B4B6a_0_135 ?a)))
         )
)
(:durative-action startup_seg_S_B4B6c_0_130_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B4B6c_0_130))
                    (over all (not_occupied seg_S_B6c_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B6c_0_60 ?a))
                    (at start (not (not_blocked seg_S_B6c_0_60 ?a)))
         )
)
(:durative-action startup_seg_S_B4B6c_0_130_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B4B6c_0_130))
                    (over all (not_occupied seg_S_B4B6b_0_135))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B4B6b_0_135 ?a))
                    (at start (not (not_blocked seg_S_B4B6b_0_135 ?a)))
         )
)
(:durative-action startup_seg_S_B6a_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B6a_0_60))
                    (over all (not_occupied seg_S_B6B7a_0_140))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B6B7a_0_140 ?a))
                    (at start (not (not_blocked seg_S_B6B7a_0_140 ?a)))
         )
)
(:durative-action startup_seg_S_B6a_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B6a_0_60))
                    (over all (not_occupied seg_S_B6b_0_60))
                    (over all (not_occupied seg_S_B6c_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B6b_0_60 ?a))
                    (at start (not (not_blocked seg_S_B6b_0_60 ?a)))
                    (at start (blocked seg_S_B6c_0_60 ?a))
                    (at start (not (not_blocked seg_S_B6c_0_60 ?a)))
         )
)
(:durative-action startup_seg_S_B6c_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B6c_0_60))
                    (over all (not_occupied seg_S_B4B6c_0_130))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B4B6c_0_130 ?a))
                    (at start (not (not_blocked seg_S_B4B6c_0_130 ?a)))
         )
)
(:durative-action startup_seg_S_B6c_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B6c_0_60))
                    (over all (not_occupied seg_S_B6a_0_60))
                    (over all (not_occupied seg_S_B6b_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B6a_0_60 ?a))
                    (at start (not (not_blocked seg_S_B6a_0_60 ?a)))
                    (at start (blocked seg_S_B6b_0_60 ?a))
                    (at start (not (not_blocked seg_S_B6b_0_60 ?a)))
         )
)
(:durative-action startup_seg_S_B6B7a_0_140_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B6B7a_0_140))
                    (over all (not_occupied seg_S_B6B7b_0_140))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B6B7b_0_140 ?a))
                    (at start (not (not_blocked seg_S_B6B7b_0_140 ?a)))
         )
)
(:durative-action startup_seg_S_B6B7a_0_140_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B6B7a_0_140))
                    (over all (not_occupied seg_S_B6a_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B6a_0_60 ?a))
                    (at start (not (not_blocked seg_S_B6a_0_60 ?a)))
         )
)
(:durative-action startup_seg_S_B6B7b_0_140_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B6B7b_0_140))
                    (over all (not_occupied seg_S_B7d_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B7d_0_60 ?a))
                    (at start (not (not_blocked seg_S_B7d_0_60 ?a)))
         )
)
(:durative-action startup_seg_S_B6B7b_0_140_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B6B7b_0_140))
                    (over all (not_occupied seg_S_B6B7a_0_140))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B6B7a_0_140 ?a))
                    (at start (not (not_blocked seg_S_B6B7a_0_140 ?a)))
         )
)
(:durative-action startup_seg_S_B7a_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B7a_0_60))
                    (over all (not_occupied seg_S5_0_94))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S5_0_94 ?a))
                    (at start (not (not_blocked seg_S5_0_94 ?a)))
         )
)
(:durative-action startup_seg_S_B7a_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B7a_0_60))
                    (over all (not_occupied seg_S_B7b_0_60))
                    (over all (not_occupied seg_S_B7c_0_60))
                    (over all (not_occupied seg_S_B7d_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B7b_0_60 ?a))
                    (at start (not (not_blocked seg_S_B7b_0_60 ?a)))
                    (at start (blocked seg_S_B7c_0_60 ?a))
                    (at start (not (not_blocked seg_S_B7c_0_60 ?a)))
                    (at start (blocked seg_S_B7d_0_60 ?a))
                    (at start (not (not_blocked seg_S_B7d_0_60 ?a)))
         )
)
(:durative-action startup_seg_S_B7b_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B7b_0_60))
                    (over all (not_occupied seg_S_B5d_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B5d_0_60 ?a))
                    (at start (not (not_blocked seg_S_B5d_0_60 ?a)))
         )
)
(:durative-action startup_seg_S_B7b_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B7b_0_60))
                    (over all (not_occupied seg_S_B7a_0_60))
                    (over all (not_occupied seg_S_B7c_0_60))
                    (over all (not_occupied seg_S_B7d_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B7a_0_60 ?a))
                    (at start (not (not_blocked seg_S_B7a_0_60 ?a)))
                    (at start (blocked seg_S_B7c_0_60 ?a))
                    (at start (not (not_blocked seg_S_B7c_0_60 ?a)))
                    (at start (blocked seg_S_B7d_0_60 ?a))
                    (at start (not (not_blocked seg_S_B7d_0_60 ?a)))
         )
)
(:durative-action startup_seg_S_B7d_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B7d_0_60))
                    (over all (not_occupied seg_S_B6B7b_0_140))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B6B7b_0_140 ?a))
                    (at start (not (not_blocked seg_S_B6B7b_0_140 ?a)))
         )
)
(:durative-action startup_seg_S_B7d_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B7d_0_60))
                    (over all (not_occupied seg_S_B7a_0_60))
                    (over all (not_occupied seg_S_B7b_0_60))
                    (over all (not_occupied seg_S_B7c_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B7a_0_60 ?a))
                    (at start (not (not_blocked seg_S_B7a_0_60 ?a)))
                    (at start (blocked seg_S_B7b_0_60 ?a))
                    (at start (not (not_blocked seg_S_B7b_0_60 ?a)))
                    (at start (blocked seg_S_B7c_0_60 ?a))
                    (at start (not (not_blocked seg_S_B7c_0_60 ?a)))
         )
)
(:durative-action startup_seg_S5_0_94_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S5_0_94))
                    (over all (not_occupied seg_S_B7a_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B7a_0_60 ?a))
                    (at start (not (not_blocked seg_S_B7a_0_60 ?a)))
         )
)
(:durative-action startup_seg_S5_0_94_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S5_0_94))
                    (over all (not_occupied seg_W1_C4c_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_C4c_0_60 ?a))
                    (at start (not (not_blocked seg_W1_C4c_0_60 ?a)))
         )
)
(:durative-action startup_seg_S_B5d_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B5d_0_60))
                    (over all (not_occupied seg_S_B7b_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B7b_0_60 ?a))
                    (at start (not (not_blocked seg_S_B7b_0_60 ?a)))
         )
)
(:durative-action startup_seg_S_B5d_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B5d_0_60))
                    (over all (not_occupied seg_S_B5a_0_60))
                    (over all (not_occupied seg_S_B5b_0_60))
                    (over all (not_occupied seg_S_B5c_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B5a_0_60 ?a))
                    (at start (not (not_blocked seg_S_B5a_0_60 ?a)))
                    (at start (blocked seg_S_B5b_0_60 ?a))
                    (at start (not (not_blocked seg_S_B5b_0_60 ?a)))
                    (at start (blocked seg_S_B5c_0_60 ?a))
                    (at start (not (not_blocked seg_S_B5c_0_60 ?a)))
         )
)
(:durative-action startup_seg_S_B5a_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B5a_0_60))
                    (over all (not_occupied seg_S6_0_94))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S6_0_94 ?a))
                    (at start (not (not_blocked seg_S6_0_94 ?a)))
         )
)
(:durative-action startup_seg_S_B5a_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B5a_0_60))
                    (over all (not_occupied seg_S_B5b_0_60))
                    (over all (not_occupied seg_S_B5c_0_60))
                    (over all (not_occupied seg_S_B5d_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B5b_0_60 ?a))
                    (at start (not (not_blocked seg_S_B5b_0_60 ?a)))
                    (at start (blocked seg_S_B5c_0_60 ?a))
                    (at start (not (not_blocked seg_S_B5c_0_60 ?a)))
                    (at start (blocked seg_S_B5d_0_60 ?a))
                    (at start (not (not_blocked seg_S_B5d_0_60 ?a)))
         )
)
(:durative-action startup_seg_S_B5b_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B5b_0_60))
                    (over all (not_occupied seg_S_B5B8a_0_135))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B5B8a_0_135 ?a))
                    (at start (not (not_blocked seg_S_B5B8a_0_135 ?a)))
         )
)
(:durative-action startup_seg_S_B5b_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B5b_0_60))
                    (over all (not_occupied seg_S_B5a_0_60))
                    (over all (not_occupied seg_S_B5c_0_60))
                    (over all (not_occupied seg_S_B5d_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B5a_0_60 ?a))
                    (at start (not (not_blocked seg_S_B5a_0_60 ?a)))
                    (at start (blocked seg_S_B5c_0_60 ?a))
                    (at start (not (not_blocked seg_S_B5c_0_60 ?a)))
                    (at start (blocked seg_S_B5d_0_60 ?a))
                    (at start (not (not_blocked seg_S_B5d_0_60 ?a)))
         )
)
(:durative-action startup_seg_S6_0_94_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S6_0_94))
                    (over all (not_occupied seg_S_B5a_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B5a_0_60 ?a))
                    (at start (not (not_blocked seg_S_B5a_0_60 ?a)))
         )
)
(:durative-action startup_seg_S6_0_94_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S6_0_94))
                    (over all (not_occupied seg_C4_S6b_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_C4_S6b_0_60 ?a))
                    (at start (not (not_blocked seg_C4_S6b_0_60 ?a)))
         )
)
(:durative-action startup_seg_S_B5B8a_0_135_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B5B8a_0_135))
                    (over all (not_occupied seg_S_B5B8b_0_135))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B5B8b_0_135 ?a))
                    (at start (not (not_blocked seg_S_B5B8b_0_135 ?a)))
         )
)
(:durative-action startup_seg_S_B5B8a_0_135_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B5B8a_0_135))
                    (over all (not_occupied seg_S_B5b_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B5b_0_60 ?a))
                    (at start (not (not_blocked seg_S_B5b_0_60 ?a)))
         )
)
(:durative-action startup_seg_S_B5B8b_0_135_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B5B8b_0_135))
                    (over all (not_occupied seg_S_B5B8c_0_130))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B5B8c_0_130 ?a))
                    (at start (not (not_blocked seg_S_B5B8c_0_130 ?a)))
         )
)
(:durative-action startup_seg_S_B5B8b_0_135_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B5B8b_0_135))
                    (over all (not_occupied seg_S_B5B8a_0_135))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B5B8a_0_135 ?a))
                    (at start (not (not_blocked seg_S_B5B8a_0_135 ?a)))
         )
)
(:durative-action startup_seg_S_B5B8c_0_130_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B5B8c_0_130))
                    (over all (not_occupied seg_S_B8c_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B8c_0_60 ?a))
                    (at start (not (not_blocked seg_S_B8c_0_60 ?a)))
         )
)
(:durative-action startup_seg_S_B5B8c_0_130_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B5B8c_0_130))
                    (over all (not_occupied seg_S_B5B8b_0_135))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B5B8b_0_135 ?a))
                    (at start (not (not_blocked seg_S_B5B8b_0_135 ?a)))
         )
)
(:durative-action startup_seg_S_B8a_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B8a_0_60))
                    (over all (not_occupied seg_S_B8B9a_0_115))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B8B9a_0_115 ?a))
                    (at start (not (not_blocked seg_S_B8B9a_0_115 ?a)))
         )
)
(:durative-action startup_seg_S_B8a_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B8a_0_60))
                    (over all (not_occupied seg_S_B8b_0_60))
                    (over all (not_occupied seg_S_B8c_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B8b_0_60 ?a))
                    (at start (not (not_blocked seg_S_B8b_0_60 ?a)))
                    (at start (blocked seg_S_B8c_0_60 ?a))
                    (at start (not (not_blocked seg_S_B8c_0_60 ?a)))
         )
)
(:durative-action startup_seg_S_B8c_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B8c_0_60))
                    (over all (not_occupied seg_S_B5B8c_0_130))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B5B8c_0_130 ?a))
                    (at start (not (not_blocked seg_S_B5B8c_0_130 ?a)))
         )
)
(:durative-action startup_seg_S_B8c_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B8c_0_60))
                    (over all (not_occupied seg_S_B8a_0_60))
                    (over all (not_occupied seg_S_B8b_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B8a_0_60 ?a))
                    (at start (not (not_blocked seg_S_B8a_0_60 ?a)))
                    (at start (blocked seg_S_B8b_0_60 ?a))
                    (at start (not (not_blocked seg_S_B8b_0_60 ?a)))
         )
)
(:durative-action startup_seg_S_B8B9a_0_115_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B8B9a_0_115))
                    (over all (not_occupied seg_S_B8B9b_0_115))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B8B9b_0_115 ?a))
                    (at start (not (not_blocked seg_S_B8B9b_0_115 ?a)))
         )
)
(:durative-action startup_seg_S_B8B9a_0_115_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B8B9a_0_115))
                    (over all (not_occupied seg_S_B8a_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B8a_0_60 ?a))
                    (at start (not (not_blocked seg_S_B8a_0_60 ?a)))
         )
)
(:durative-action startup_seg_S_B8B9b_0_115_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B8B9b_0_115))
                    (over all (not_occupied seg_S_B8B9c_1_0_115))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B8B9c_1_0_115 ?a))
                    (at start (not (not_blocked seg_S_B8B9c_1_0_115 ?a)))
         )
)
(:durative-action startup_seg_S_B8B9b_0_115_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B8B9b_0_115))
                    (over all (not_occupied seg_S_B8B9a_0_115))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B8B9a_0_115 ?a))
                    (at start (not (not_blocked seg_S_B8B9a_0_115 ?a)))
         )
)
(:durative-action startup_seg_S_B8B9c_1_0_115_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B8B9c_1_0_115))
                    (over all (not_occupied seg_S_B8B9c_0_115))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B8B9c_0_115 ?a))
                    (at start (not (not_blocked seg_S_B8B9c_0_115 ?a)))
         )
)
(:durative-action startup_seg_S_B8B9c_1_0_115_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B8B9c_1_0_115))
                    (over all (not_occupied seg_S_B8B9b_0_115))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B8B9b_0_115 ?a))
                    (at start (not (not_blocked seg_S_B8B9b_0_115 ?a)))
         )
)
(:durative-action startup_seg_S_B9a_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B9a_0_60))
                    (over all (not_occupied seg_S_B9B10a_0_125))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B9B10a_0_125 ?a))
                    (at start (not (not_blocked seg_S_B9B10a_0_125 ?a)))
         )
)
(:durative-action startup_seg_S_B9a_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B9a_0_60))
                    (over all (not_occupied seg_S_B9b_0_60))
                    (over all (not_occupied seg_S_B9c_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B9b_0_60 ?a))
                    (at start (not (not_blocked seg_S_B9b_0_60 ?a)))
                    (at start (blocked seg_S_B9c_0_60 ?a))
                    (at start (not (not_blocked seg_S_B9c_0_60 ?a)))
         )
)
(:durative-action startup_seg_S_B9c_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B9c_0_60))
                    (over all (not_occupied seg_S_B8B9c_0_115))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B8B9c_0_115 ?a))
                    (at start (not (not_blocked seg_S_B8B9c_0_115 ?a)))
         )
)
(:durative-action startup_seg_S_B9c_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B9c_0_60))
                    (over all (not_occupied seg_S_B9a_0_60))
                    (over all (not_occupied seg_S_B9b_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B9a_0_60 ?a))
                    (at start (not (not_blocked seg_S_B9a_0_60 ?a)))
                    (at start (blocked seg_S_B9b_0_60 ?a))
                    (at start (not (not_blocked seg_S_B9b_0_60 ?a)))
         )
)
(:durative-action startup_seg_S_B9B10a_0_125_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B9B10a_0_125))
                    (over all (not_occupied seg_S_B9B10b_0_125))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B9B10b_0_125 ?a))
                    (at start (not (not_blocked seg_S_B9B10b_0_125 ?a)))
         )
)
(:durative-action startup_seg_S_B9B10a_0_125_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B9B10a_0_125))
                    (over all (not_occupied seg_S_B9a_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B9a_0_60 ?a))
                    (at start (not (not_blocked seg_S_B9a_0_60 ?a)))
         )
)
(:durative-action startup_seg_S_B8B9c_0_115_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B8B9c_0_115))
                    (over all (not_occupied seg_S_B9c_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B9c_0_60 ?a))
                    (at start (not (not_blocked seg_S_B9c_0_60 ?a)))
         )
)
(:durative-action startup_seg_S_B8B9c_0_115_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B8B9c_0_115))
                    (over all (not_occupied seg_S_B8B9c_1_0_115))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B8B9c_1_0_115 ?a))
                    (at start (not (not_blocked seg_S_B8B9c_1_0_115 ?a)))
         )
)
(:durative-action startup_seg_S_B9B10b_0_125_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B9B10b_0_125))
                    (over all (not_occupied seg_S_B9B10c_1_0_83))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B9B10c_1_0_83 ?a))
                    (at start (not (not_blocked seg_S_B9B10c_1_0_83 ?a)))
         )
)
(:durative-action startup_seg_S_B9B10b_0_125_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B9B10b_0_125))
                    (over all (not_occupied seg_S_B9B10a_0_125))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B9B10a_0_125 ?a))
                    (at start (not (not_blocked seg_S_B9B10a_0_125 ?a)))
         )
)
(:durative-action startup_seg_S_B9B10c_1_0_83_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B9B10c_1_0_83))
                    (over all (not_occupied seg_S_B9B10c_2_0_83))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B9B10c_2_0_83 ?a))
                    (at start (not (not_blocked seg_S_B9B10c_2_0_83 ?a)))
         )
)
(:durative-action startup_seg_S_B9B10c_1_0_83_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B9B10c_1_0_83))
                    (over all (not_occupied seg_S_B9B10b_0_125))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B9B10b_0_125 ?a))
                    (at start (not (not_blocked seg_S_B9B10b_0_125 ?a)))
         )
)
(:durative-action startup_seg_S_B10b_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B10b_0_60))
                    (over all (not_occupied seg_S_B9B10c_0_84))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B9B10c_0_84 ?a))
                    (at start (not (not_blocked seg_S_B9B10c_0_84 ?a)))
         )
)
(:durative-action startup_seg_S_B10b_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B10b_0_60))
                    (over all (not_occupied seg_S_B10a_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B10a_0_60 ?a))
                    (at start (not (not_blocked seg_S_B10a_0_60 ?a)))
         )
)
(:durative-action startup_seg_S_B9B10c_0_84_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B9B10c_0_84))
                    (over all (not_occupied seg_S_B10b_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B10b_0_60 ?a))
                    (at start (not (not_blocked seg_S_B10b_0_60 ?a)))
         )
)
(:durative-action startup_seg_S_B9B10c_0_84_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B9B10c_0_84))
                    (over all (not_occupied seg_S_B9B10c_2_0_83))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B9B10c_2_0_83 ?a))
                    (at start (not (not_blocked seg_S_B9B10c_2_0_83 ?a)))
         )
)
(:durative-action startup_seg_B3_b_1_0_80_6226_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_B3_b_1_0_80_6226))
                    (over all (not_occupied seg_B3_b_0_80_6226))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_B3_b_0_80_6226 ?a))
                    (at start (not (not_blocked seg_B3_b_0_80_6226 ?a)))
         )
)
(:durative-action startup_seg_B3_b_1_0_80_6226_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_B3_b_1_0_80_6226))
                    (over all (not_occupied seg_B3_a_0_156_924))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_B3_a_0_156_924 ?a))
                    (at start (not (not_blocked seg_B3_a_0_156_924 ?a)))
         )
)
(:durative-action startup_seg_B4_b_1_0_80_6226_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_B4_b_1_0_80_6226))
                    (over all (not_occupied seg_B4_b_0_80_6226))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_B4_b_0_80_6226 ?a))
                    (at start (not (not_blocked seg_B4_b_0_80_6226 ?a)))
         )
)
(:durative-action startup_seg_B4_b_1_0_80_6226_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_B4_b_1_0_80_6226))
                    (over all (not_occupied seg_B4_a_0_156_924))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_B4_a_0_156_924 ?a))
                    (at start (not (not_blocked seg_B4_a_0_156_924 ?a)))
         )
)
(:durative-action startup_seg_B8_b_1_0_80_6226_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_B8_b_1_0_80_6226))
                    (over all (not_occupied seg_B8_b_0_80_6226))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_B8_b_0_80_6226 ?a))
                    (at start (not (not_blocked seg_B8_b_0_80_6226 ?a)))
         )
)
(:durative-action startup_seg_B8_b_1_0_80_6226_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_B8_b_1_0_80_6226))
                    (over all (not_occupied seg_B8_a_0_156_924))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_B8_a_0_156_924 ?a))
                    (at start (not (not_blocked seg_B8_a_0_156_924 ?a)))
         )
)
(:durative-action startup_seg_B9_b_1_0_80_6226_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_B9_b_1_0_80_6226))
                    (over all (not_occupied seg_B9_b_0_80_6226))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_B9_b_0_80_6226 ?a))
                    (at start (not (not_blocked seg_B9_b_0_80_6226 ?a)))
         )
)
(:durative-action startup_seg_B9_b_1_0_80_6226_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_B9_b_1_0_80_6226))
                    (over all (not_occupied seg_B9_a_0_156_924))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_B9_a_0_156_924 ?a))
                    (at start (not (not_blocked seg_B9_a_0_156_924 ?a)))
         )
)
(:durative-action startup_seg_W1_C1a_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_C1a_0_60))
                    (over all (not_occupied seg_N1_0_108))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N1_0_108 ?a))
                    (at start (not (not_blocked seg_N1_0_108 ?a)))
         )
)
(:durative-action startup_seg_W1_C1a_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_C1a_0_60))
                    (over all (not_occupied seg_W1_C1b_0_60))
                    (over all (not_occupied seg_W1_C1c_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_C1b_0_60 ?a))
                    (at start (not (not_blocked seg_W1_C1b_0_60 ?a)))
                    (at start (blocked seg_W1_C1c_0_34 ?a))
                    (at start (not (not_blocked seg_W1_C1c_0_34 ?a)))
         )
)
(:durative-action startup_seg_W1_C1b_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_C1b_0_60))
                    (over all (not_occupied seg_C1_n2c_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_C1_n2c_0_60 ?a))
                    (at start (not (not_blocked seg_C1_n2c_0_60 ?a)))
         )
)
(:durative-action startup_seg_W1_C1b_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_C1b_0_60))
                    (over all (not_occupied seg_W1_C1a_0_60))
                    (over all (not_occupied seg_W1_C1c_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_C1a_0_60 ?a))
                    (at start (not (not_blocked seg_W1_C1a_0_60 ?a)))
                    (at start (blocked seg_W1_C1c_0_34 ?a))
                    (at start (not (not_blocked seg_W1_C1c_0_34 ?a)))
         )
)
(:durative-action startup_seg_W1_C1c_0_34_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_C1c_0_34))
                    (over all (not_occupied seg_W1_141a_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_141a_0_34 ?a))
                    (at start (not (not_blocked seg_W1_141a_0_34 ?a)))
         )
)
(:durative-action startup_seg_W1_C1c_0_34_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_C1c_0_34))
                    (over all (not_occupied seg_W1_C1a_0_60))
                    (over all (not_occupied seg_W1_C1b_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_C1a_0_60 ?a))
                    (at start (not (not_blocked seg_W1_C1a_0_60 ?a)))
                    (at start (blocked seg_W1_C1b_0_60 ?a))
                    (at start (not (not_blocked seg_W1_C1b_0_60 ?a)))
         )
)
(:durative-action startup_seg_N1_0_108_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N1_0_108))
                    (over all (not_occupied seg_W1_C1a_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_C1a_0_60 ?a))
                    (at start (not (not_blocked seg_W1_C1a_0_60 ?a)))
         )
)
(:durative-action startup_seg_N1_0_108_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N1_0_108))
                    (over all (not_occupied seg_N_A3c_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A3c_0_60 ?a))
                    (at start (not (not_blocked seg_N_A3c_0_60 ?a)))
         )
)
(:durative-action startup_seg_C1_n2c_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_C1_n2c_0_60))
                    (over all (not_occupied seg_W1_C1b_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_C1b_0_60 ?a))
                    (at start (not (not_blocked seg_W1_C1b_0_60 ?a)))
         )
)
(:durative-action startup_seg_C1_n2c_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_C1_n2c_0_60))
                    (over all (not_occupied seg_C1_n2a_0_60))
                    (over all (not_occupied seg_C1_n2b_0_80))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_C1_n2a_0_60 ?a))
                    (at start (not (not_blocked seg_C1_n2a_0_60 ?a)))
                    (at start (blocked seg_C1_n2b_0_80 ?a))
                    (at start (not (not_blocked seg_C1_n2b_0_80 ?a)))
         )
)
(:durative-action startup_seg_W1_141a_0_34_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_141a_0_34))
                    (over all (not_occupied seg_W1_C1c_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_C1c_0_34 ?a))
                    (at start (not (not_blocked seg_W1_C1c_0_34 ?a)))
         )
)
(:durative-action startup_seg_W1_141a_0_34_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_141a_0_34))
                    (over all (not_occupied seg_W1_141b_0_45))
                    (over all (not_occupied seg_W1_141c_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_141b_0_45 ?a))
                    (at start (not (not_blocked seg_W1_141b_0_45 ?a)))
                    (at start (blocked seg_W1_141c_0_34 ?a))
                    (at start (not (not_blocked seg_W1_141c_0_34 ?a)))
         )
)
(:durative-action startup_seg_W1_141b_0_45_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_141b_0_45))
                    (over all (not_occupied seg_p141_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_p141_0_75 ?a))
                    (at start (not (not_blocked seg_p141_0_75 ?a)))
         )
)
(:durative-action startup_seg_W1_141b_0_45_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_141b_0_45))
                    (over all (not_occupied seg_W1_141a_0_34))
                    (over all (not_occupied seg_W1_141c_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_141a_0_34 ?a))
                    (at start (not (not_blocked seg_W1_141a_0_34 ?a)))
                    (at start (blocked seg_W1_141c_0_34 ?a))
                    (at start (not (not_blocked seg_W1_141c_0_34 ?a)))
         )
)
(:durative-action startup_seg_W1_141c_0_34_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_141c_0_34))
                    (over all (not_occupied seg_W1_142a_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_142a_0_34 ?a))
                    (at start (not (not_blocked seg_W1_142a_0_34 ?a)))
         )
)
(:durative-action startup_seg_W1_141c_0_34_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_141c_0_34))
                    (over all (not_occupied seg_W1_141a_0_34))
                    (over all (not_occupied seg_W1_141b_0_45))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_141a_0_34 ?a))
                    (at start (not (not_blocked seg_W1_141a_0_34 ?a)))
                    (at start (blocked seg_W1_141b_0_45 ?a))
                    (at start (not (not_blocked seg_W1_141b_0_45 ?a)))
         )
)
(:durative-action park_seg_p141_0_75_north
 :parameters (?a - airplane)
 :duration (= ?duration 40)
 :condition (and    (over all (at-segment ?a seg_p141_0_75))
		(at start (candostuff))
                    (over all (facing ?a north))
                    (at start (is-moving ?a))
            )
 :effect (and (at end (is-parked ?a seg_p141_0_75))
              (at start (not (is-moving ?a)))
         )
)
(:durative-action park_seg_p141_0_75_south
 :parameters (?a - airplane)
 :duration (= ?duration 40)
 :condition (and    (over all (at-segment ?a seg_p141_0_75))
		(at start (candostuff))
                    (over all (facing ?a south))
                    (at start (is-moving ?a))
            )
 :effect (and (at end (is-parked ?a seg_p141_0_75))
              (at start (not (is-moving ?a)))
              (at end (not (blocked seg_W1_141b_0_45 ?a)))
              (at end (not_blocked seg_W1_141b_0_45 ?a))
         )
)
(:durative-action startup_seg_p141_0_75_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_p141_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
         )
)
(:durative-action startup_seg_p141_0_75_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_p141_0_75))
                    (over all (not_occupied seg_W1_141b_0_45))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_141b_0_45 ?a))
                    (at start (not (not_blocked seg_W1_141b_0_45 ?a)))
         )
)
(:durative-action startup_seg_W1_142a_0_34_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_142a_0_34))
                    (over all (not_occupied seg_W1_141c_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_141c_0_34 ?a))
                    (at start (not (not_blocked seg_W1_141c_0_34 ?a)))
         )
)
(:durative-action startup_seg_W1_142a_0_34_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_142a_0_34))
                    (over all (not_occupied seg_W1_142b_0_45))
                    (over all (not_occupied seg_W1_142c_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_142b_0_45 ?a))
                    (at start (not (not_blocked seg_W1_142b_0_45 ?a)))
                    (at start (blocked seg_W1_142c_0_34 ?a))
                    (at start (not (not_blocked seg_W1_142c_0_34 ?a)))
         )
)
(:durative-action startup_seg_W1_142b_0_45_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_142b_0_45))
                    (over all (not_occupied seg_p142_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_p142_0_75 ?a))
                    (at start (not (not_blocked seg_p142_0_75 ?a)))
         )
)
(:durative-action startup_seg_W1_142b_0_45_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_142b_0_45))
                    (over all (not_occupied seg_W1_142a_0_34))
                    (over all (not_occupied seg_W1_142c_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_142a_0_34 ?a))
                    (at start (not (not_blocked seg_W1_142a_0_34 ?a)))
                    (at start (blocked seg_W1_142c_0_34 ?a))
                    (at start (not (not_blocked seg_W1_142c_0_34 ?a)))
         )
)
(:durative-action startup_seg_W1_142c_0_34_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_142c_0_34))
                    (over all (not_occupied seg_W1_143a_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_143a_0_34 ?a))
                    (at start (not (not_blocked seg_W1_143a_0_34 ?a)))
         )
)
(:durative-action startup_seg_W1_142c_0_34_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_142c_0_34))
                    (over all (not_occupied seg_W1_142a_0_34))
                    (over all (not_occupied seg_W1_142b_0_45))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_142a_0_34 ?a))
                    (at start (not (not_blocked seg_W1_142a_0_34 ?a)))
                    (at start (blocked seg_W1_142b_0_45 ?a))
                    (at start (not (not_blocked seg_W1_142b_0_45 ?a)))
         )
)
(:durative-action park_seg_p142_0_75_north
 :parameters (?a - airplane)
 :duration (= ?duration 40)
 :condition (and    (over all (at-segment ?a seg_p142_0_75))
		(at start (candostuff))
                    (over all (facing ?a north))
                    (at start (is-moving ?a))
            )
 :effect (and (at end (is-parked ?a seg_p142_0_75))
              (at start (not (is-moving ?a)))
         )
)
(:durative-action park_seg_p142_0_75_south
 :parameters (?a - airplane)
 :duration (= ?duration 40)
 :condition (and    (over all (at-segment ?a seg_p142_0_75))
		(at start (candostuff))
                    (over all (facing ?a south))
                    (at start (is-moving ?a))
            )
 :effect (and (at end (is-parked ?a seg_p142_0_75))
              (at start (not (is-moving ?a)))
              (at end (not (blocked seg_W1_142b_0_45 ?a)))
              (at end (not_blocked seg_W1_142b_0_45 ?a))
         )
)
(:durative-action startup_seg_p142_0_75_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_p142_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
         )
)
(:durative-action startup_seg_p142_0_75_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_p142_0_75))
                    (over all (not_occupied seg_W1_142b_0_45))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_142b_0_45 ?a))
                    (at start (not (not_blocked seg_W1_142b_0_45 ?a)))
         )
)
(:durative-action startup_seg_W1_143a_0_34_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_143a_0_34))
                    (over all (not_occupied seg_W1_142c_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_142c_0_34 ?a))
                    (at start (not (not_blocked seg_W1_142c_0_34 ?a)))
         )
)
(:durative-action startup_seg_W1_143a_0_34_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_143a_0_34))
                    (over all (not_occupied seg_W1_143b_0_45))
                    (over all (not_occupied seg_W1_143c_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_143b_0_45 ?a))
                    (at start (not (not_blocked seg_W1_143b_0_45 ?a)))
                    (at start (blocked seg_W1_143c_0_60 ?a))
                    (at start (not (not_blocked seg_W1_143c_0_60 ?a)))
         )
)
(:durative-action startup_seg_W1_143b_0_45_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_143b_0_45))
                    (over all (not_occupied seg_p143_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_p143_0_75 ?a))
                    (at start (not (not_blocked seg_p143_0_75 ?a)))
         )
)
(:durative-action startup_seg_W1_143b_0_45_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_143b_0_45))
                    (over all (not_occupied seg_W1_143a_0_34))
                    (over all (not_occupied seg_W1_143c_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_143a_0_34 ?a))
                    (at start (not (not_blocked seg_W1_143a_0_34 ?a)))
                    (at start (blocked seg_W1_143c_0_60 ?a))
                    (at start (not (not_blocked seg_W1_143c_0_60 ?a)))
         )
)
(:durative-action startup_seg_W1_143c_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_143c_0_60))
                    (over all (not_occupied seg_W1_C2a_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_C2a_0_60 ?a))
                    (at start (not (not_blocked seg_W1_C2a_0_60 ?a)))
         )
)
(:durative-action startup_seg_W1_143c_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_143c_0_60))
                    (over all (not_occupied seg_W1_143a_0_34))
                    (over all (not_occupied seg_W1_143b_0_45))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_143a_0_34 ?a))
                    (at start (not (not_blocked seg_W1_143a_0_34 ?a)))
                    (at start (blocked seg_W1_143b_0_45 ?a))
                    (at start (not (not_blocked seg_W1_143b_0_45 ?a)))
         )
)
(:durative-action park_seg_p143_0_75_north
 :parameters (?a - airplane)
 :duration (= ?duration 40)
 :condition (and    (over all (at-segment ?a seg_p143_0_75))
		(at start (candostuff))
                    (over all (facing ?a north))
                    (at start (is-moving ?a))
            )
 :effect (and (at end (is-parked ?a seg_p143_0_75))
              (at start (not (is-moving ?a)))
         )
)
(:durative-action park_seg_p143_0_75_south
 :parameters (?a - airplane)
 :duration (= ?duration 40)
 :condition (and    (over all (at-segment ?a seg_p143_0_75))
		(at start (candostuff))
                    (over all (facing ?a south))
                    (at start (is-moving ?a))
            )
 :effect (and (at end (is-parked ?a seg_p143_0_75))
              (at start (not (is-moving ?a)))
              (at end (not (blocked seg_W1_143b_0_45 ?a)))
              (at end (not_blocked seg_W1_143b_0_45 ?a))
         )
)
(:durative-action startup_seg_p143_0_75_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_p143_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
         )
)
(:durative-action startup_seg_p143_0_75_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_p143_0_75))
                    (over all (not_occupied seg_W1_143b_0_45))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_143b_0_45 ?a))
                    (at start (not (not_blocked seg_W1_143b_0_45 ?a)))
         )
)
(:durative-action startup_seg_W1_C2a_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_C2a_0_60))
                    (over all (not_occupied seg_W1_143c_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_143c_0_60 ?a))
                    (at start (not (not_blocked seg_W1_143c_0_60 ?a)))
         )
)
(:durative-action startup_seg_W1_C2a_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_C2a_0_60))
                    (over all (not_occupied seg_W1_C2b_0_60))
                    (over all (not_occupied seg_W1_C2c_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_C2b_0_60 ?a))
                    (at start (not (not_blocked seg_W1_C2b_0_60 ?a)))
                    (at start (blocked seg_W1_C2c_0_34 ?a))
                    (at start (not (not_blocked seg_W1_C2c_0_34 ?a)))
         )
)
(:durative-action startup_seg_W1_C2b_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_C2b_0_60))
                    (over all (not_occupied seg_C2_a_0_80))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_C2_a_0_80 ?a))
                    (at start (not (not_blocked seg_C2_a_0_80 ?a)))
         )
)
(:durative-action startup_seg_W1_C2b_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_C2b_0_60))
                    (over all (not_occupied seg_W1_C2a_0_60))
                    (over all (not_occupied seg_W1_C2c_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_C2a_0_60 ?a))
                    (at start (not (not_blocked seg_W1_C2a_0_60 ?a)))
                    (at start (blocked seg_W1_C2c_0_34 ?a))
                    (at start (not (not_blocked seg_W1_C2c_0_34 ?a)))
         )
)
(:durative-action startup_seg_W1_C2c_0_34_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_C2c_0_34))
                    (over all (not_occupied seg_W1_151a_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_151a_0_34 ?a))
                    (at start (not (not_blocked seg_W1_151a_0_34 ?a)))
         )
)
(:durative-action startup_seg_W1_C2c_0_34_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_C2c_0_34))
                    (over all (not_occupied seg_W1_C2a_0_60))
                    (over all (not_occupied seg_W1_C2b_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_C2a_0_60 ?a))
                    (at start (not (not_blocked seg_W1_C2a_0_60 ?a)))
                    (at start (blocked seg_W1_C2b_0_60 ?a))
                    (at start (not (not_blocked seg_W1_C2b_0_60 ?a)))
         )
)
(:durative-action startup_seg_C2_a_0_80_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_C2_a_0_80))
                    (over all (not_occupied seg_C2_b_0_80))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_C2_b_0_80 ?a))
                    (at start (not (not_blocked seg_C2_b_0_80 ?a)))
         )
)
(:durative-action startup_seg_C2_a_0_80_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_C2_a_0_80))
                    (over all (not_occupied seg_W1_C2b_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_C2b_0_60 ?a))
                    (at start (not (not_blocked seg_W1_C2b_0_60 ?a)))
         )
)
(:durative-action startup_seg_W1_151a_0_34_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_151a_0_34))
                    (over all (not_occupied seg_W1_C2c_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_C2c_0_34 ?a))
                    (at start (not (not_blocked seg_W1_C2c_0_34 ?a)))
         )
)
(:durative-action startup_seg_W1_151a_0_34_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_151a_0_34))
                    (over all (not_occupied seg_W1_151b_0_45))
                    (over all (not_occupied seg_W1_151c_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_151b_0_45 ?a))
                    (at start (not (not_blocked seg_W1_151b_0_45 ?a)))
                    (at start (blocked seg_W1_151c_0_34 ?a))
                    (at start (not (not_blocked seg_W1_151c_0_34 ?a)))
         )
)
(:durative-action startup_seg_W1_151b_0_45_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_151b_0_45))
                    (over all (not_occupied seg_p151_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_p151_0_75 ?a))
                    (at start (not (not_blocked seg_p151_0_75 ?a)))
         )
)
(:durative-action startup_seg_W1_151b_0_45_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_151b_0_45))
                    (over all (not_occupied seg_W1_151a_0_34))
                    (over all (not_occupied seg_W1_151c_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_151a_0_34 ?a))
                    (at start (not (not_blocked seg_W1_151a_0_34 ?a)))
                    (at start (blocked seg_W1_151c_0_34 ?a))
                    (at start (not (not_blocked seg_W1_151c_0_34 ?a)))
         )
)
(:durative-action startup_seg_W1_151c_0_34_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_151c_0_34))
                    (over all (not_occupied seg_W1_152a_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_152a_0_34 ?a))
                    (at start (not (not_blocked seg_W1_152a_0_34 ?a)))
         )
)
(:durative-action startup_seg_W1_151c_0_34_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_151c_0_34))
                    (over all (not_occupied seg_W1_151a_0_34))
                    (over all (not_occupied seg_W1_151b_0_45))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_151a_0_34 ?a))
                    (at start (not (not_blocked seg_W1_151a_0_34 ?a)))
                    (at start (blocked seg_W1_151b_0_45 ?a))
                    (at start (not (not_blocked seg_W1_151b_0_45 ?a)))
         )
)
(:durative-action park_seg_p151_0_75_north
 :parameters (?a - airplane)
 :duration (= ?duration 40)
 :condition (and    (over all (at-segment ?a seg_p151_0_75))
		(at start (candostuff))
                    (over all (facing ?a north))
                    (at start (is-moving ?a))
            )
 :effect (and (at end (is-parked ?a seg_p151_0_75))
              (at start (not (is-moving ?a)))
         )
)
(:durative-action park_seg_p151_0_75_south
 :parameters (?a - airplane)
 :duration (= ?duration 40)
 :condition (and    (over all (at-segment ?a seg_p151_0_75))
		(at start (candostuff))
                    (over all (facing ?a south))
                    (at start (is-moving ?a))
            )
 :effect (and (at end (is-parked ?a seg_p151_0_75))
              (at start (not (is-moving ?a)))
              (at end (not (blocked seg_W1_151b_0_45 ?a)))
              (at end (not_blocked seg_W1_151b_0_45 ?a))
         )
)
(:durative-action startup_seg_p151_0_75_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_p151_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
         )
)
(:durative-action startup_seg_p151_0_75_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_p151_0_75))
                    (over all (not_occupied seg_W1_151b_0_45))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_151b_0_45 ?a))
                    (at start (not (not_blocked seg_W1_151b_0_45 ?a)))
         )
)
(:durative-action startup_seg_W1_152a_0_34_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_152a_0_34))
                    (over all (not_occupied seg_W1_151c_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_151c_0_34 ?a))
                    (at start (not (not_blocked seg_W1_151c_0_34 ?a)))
         )
)
(:durative-action startup_seg_W1_152a_0_34_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_152a_0_34))
                    (over all (not_occupied seg_W1_152b_0_45))
                    (over all (not_occupied seg_W1_152c_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_152b_0_45 ?a))
                    (at start (not (not_blocked seg_W1_152b_0_45 ?a)))
                    (at start (blocked seg_W1_152c_0_34 ?a))
                    (at start (not (not_blocked seg_W1_152c_0_34 ?a)))
         )
)
(:durative-action startup_seg_W1_152b_0_45_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_152b_0_45))
                    (over all (not_occupied seg_p152_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_p152_0_75 ?a))
                    (at start (not (not_blocked seg_p152_0_75 ?a)))
         )
)
(:durative-action startup_seg_W1_152b_0_45_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_152b_0_45))
                    (over all (not_occupied seg_W1_152a_0_34))
                    (over all (not_occupied seg_W1_152c_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_152a_0_34 ?a))
                    (at start (not (not_blocked seg_W1_152a_0_34 ?a)))
                    (at start (blocked seg_W1_152c_0_34 ?a))
                    (at start (not (not_blocked seg_W1_152c_0_34 ?a)))
         )
)
(:durative-action startup_seg_W1_152c_0_34_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_152c_0_34))
                    (over all (not_occupied seg_W1_153a_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_153a_0_34 ?a))
                    (at start (not (not_blocked seg_W1_153a_0_34 ?a)))
         )
)
(:durative-action startup_seg_W1_152c_0_34_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_152c_0_34))
                    (over all (not_occupied seg_W1_152a_0_34))
                    (over all (not_occupied seg_W1_152b_0_45))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_152a_0_34 ?a))
                    (at start (not (not_blocked seg_W1_152a_0_34 ?a)))
                    (at start (blocked seg_W1_152b_0_45 ?a))
                    (at start (not (not_blocked seg_W1_152b_0_45 ?a)))
         )
)
(:durative-action park_seg_p152_0_75_north
 :parameters (?a - airplane)
 :duration (= ?duration 40)
 :condition (and    (over all (at-segment ?a seg_p152_0_75))
		(at start (candostuff))
                    (over all (facing ?a north))
                    (at start (is-moving ?a))
            )
 :effect (and (at end (is-parked ?a seg_p152_0_75))
              (at start (not (is-moving ?a)))
         )
)
(:durative-action park_seg_p152_0_75_south
 :parameters (?a - airplane)
 :duration (= ?duration 40)
 :condition (and    (over all (at-segment ?a seg_p152_0_75))
		(at start (candostuff))
                    (over all (facing ?a south))
                    (at start (is-moving ?a))
            )
 :effect (and (at end (is-parked ?a seg_p152_0_75))
              (at start (not (is-moving ?a)))
              (at end (not (blocked seg_W1_152b_0_45 ?a)))
              (at end (not_blocked seg_W1_152b_0_45 ?a))
         )
)
(:durative-action startup_seg_p152_0_75_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_p152_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
         )
)
(:durative-action startup_seg_p152_0_75_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_p152_0_75))
                    (over all (not_occupied seg_W1_152b_0_45))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_152b_0_45 ?a))
                    (at start (not (not_blocked seg_W1_152b_0_45 ?a)))
         )
)
(:durative-action startup_seg_W1_153a_0_34_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_153a_0_34))
                    (over all (not_occupied seg_W1_152c_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_152c_0_34 ?a))
                    (at start (not (not_blocked seg_W1_152c_0_34 ?a)))
         )
)
(:durative-action startup_seg_W1_153a_0_34_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_153a_0_34))
                    (over all (not_occupied seg_W1_153b_0_45))
                    (over all (not_occupied seg_W1_153c_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_153b_0_45 ?a))
                    (at start (not (not_blocked seg_W1_153b_0_45 ?a)))
                    (at start (blocked seg_W1_153c_0_34 ?a))
                    (at start (not (not_blocked seg_W1_153c_0_34 ?a)))
         )
)
(:durative-action startup_seg_W1_153b_0_45_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_153b_0_45))
                    (over all (not_occupied seg_p153_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_p153_0_75 ?a))
                    (at start (not (not_blocked seg_p153_0_75 ?a)))
         )
)
(:durative-action startup_seg_W1_153b_0_45_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_153b_0_45))
                    (over all (not_occupied seg_W1_153a_0_34))
                    (over all (not_occupied seg_W1_153c_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_153a_0_34 ?a))
                    (at start (not (not_blocked seg_W1_153a_0_34 ?a)))
                    (at start (blocked seg_W1_153c_0_34 ?a))
                    (at start (not (not_blocked seg_W1_153c_0_34 ?a)))
         )
)
(:durative-action startup_seg_W1_153c_0_34_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_153c_0_34))
                    (over all (not_occupied seg_W1_154a_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_154a_0_34 ?a))
                    (at start (not (not_blocked seg_W1_154a_0_34 ?a)))
         )
)
(:durative-action startup_seg_W1_153c_0_34_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_153c_0_34))
                    (over all (not_occupied seg_W1_153a_0_34))
                    (over all (not_occupied seg_W1_153b_0_45))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_153a_0_34 ?a))
                    (at start (not (not_blocked seg_W1_153a_0_34 ?a)))
                    (at start (blocked seg_W1_153b_0_45 ?a))
                    (at start (not (not_blocked seg_W1_153b_0_45 ?a)))
         )
)
(:durative-action park_seg_p153_0_75_north
 :parameters (?a - airplane)
 :duration (= ?duration 40)
 :condition (and    (over all (at-segment ?a seg_p153_0_75))
		(at start (candostuff))
                    (over all (facing ?a north))
                    (at start (is-moving ?a))
            )
 :effect (and (at end (is-parked ?a seg_p153_0_75))
              (at start (not (is-moving ?a)))
         )
)
(:durative-action park_seg_p153_0_75_south
 :parameters (?a - airplane)
 :duration (= ?duration 40)
 :condition (and    (over all (at-segment ?a seg_p153_0_75))
		(at start (candostuff))
                    (over all (facing ?a south))
                    (at start (is-moving ?a))
            )
 :effect (and (at end (is-parked ?a seg_p153_0_75))
              (at start (not (is-moving ?a)))
              (at end (not (blocked seg_W1_153b_0_45 ?a)))
              (at end (not_blocked seg_W1_153b_0_45 ?a))
         )
)
(:durative-action startup_seg_p153_0_75_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_p153_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
         )
)
(:durative-action startup_seg_p153_0_75_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_p153_0_75))
                    (over all (not_occupied seg_W1_153b_0_45))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_153b_0_45 ?a))
                    (at start (not (not_blocked seg_W1_153b_0_45 ?a)))
         )
)
(:durative-action startup_seg_W1_154a_0_34_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_154a_0_34))
                    (over all (not_occupied seg_W1_153c_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_153c_0_34 ?a))
                    (at start (not (not_blocked seg_W1_153c_0_34 ?a)))
         )
)
(:durative-action startup_seg_W1_154a_0_34_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_154a_0_34))
                    (over all (not_occupied seg_W1_154b_0_45))
                    (over all (not_occupied seg_W1_154c_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_154b_0_45 ?a))
                    (at start (not (not_blocked seg_W1_154b_0_45 ?a)))
                    (at start (blocked seg_W1_154c_0_34 ?a))
                    (at start (not (not_blocked seg_W1_154c_0_34 ?a)))
         )
)
(:durative-action startup_seg_W1_154b_0_45_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_154b_0_45))
                    (over all (not_occupied seg_p154_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_p154_0_75 ?a))
                    (at start (not (not_blocked seg_p154_0_75 ?a)))
         )
)
(:durative-action startup_seg_W1_154b_0_45_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_154b_0_45))
                    (over all (not_occupied seg_W1_154a_0_34))
                    (over all (not_occupied seg_W1_154c_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_154a_0_34 ?a))
                    (at start (not (not_blocked seg_W1_154a_0_34 ?a)))
                    (at start (blocked seg_W1_154c_0_34 ?a))
                    (at start (not (not_blocked seg_W1_154c_0_34 ?a)))
         )
)
(:durative-action startup_seg_W1_154c_0_34_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_154c_0_34))
                    (over all (not_occupied seg_W1_C3a_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_C3a_0_34 ?a))
                    (at start (not (not_blocked seg_W1_C3a_0_34 ?a)))
         )
)
(:durative-action startup_seg_W1_154c_0_34_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_154c_0_34))
                    (over all (not_occupied seg_W1_154a_0_34))
                    (over all (not_occupied seg_W1_154b_0_45))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_154a_0_34 ?a))
                    (at start (not (not_blocked seg_W1_154a_0_34 ?a)))
                    (at start (blocked seg_W1_154b_0_45 ?a))
                    (at start (not (not_blocked seg_W1_154b_0_45 ?a)))
         )
)
(:durative-action park_seg_p154_0_75_north
 :parameters (?a - airplane)
 :duration (= ?duration 40)
 :condition (and    (over all (at-segment ?a seg_p154_0_75))
		(at start (candostuff))
                    (over all (facing ?a north))
                    (at start (is-moving ?a))
            )
 :effect (and (at end (is-parked ?a seg_p154_0_75))
              (at start (not (is-moving ?a)))
         )
)
(:durative-action park_seg_p154_0_75_south
 :parameters (?a - airplane)
 :duration (= ?duration 40)
 :condition (and    (over all (at-segment ?a seg_p154_0_75))
		(at start (candostuff))
                    (over all (facing ?a south))
                    (at start (is-moving ?a))
            )
 :effect (and (at end (is-parked ?a seg_p154_0_75))
              (at start (not (is-moving ?a)))
              (at end (not (blocked seg_W1_154b_0_45 ?a)))
              (at end (not_blocked seg_W1_154b_0_45 ?a))
         )
)
(:durative-action startup_seg_p154_0_75_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_p154_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
         )
)
(:durative-action startup_seg_p154_0_75_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_p154_0_75))
                    (over all (not_occupied seg_W1_154b_0_45))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_154b_0_45 ?a))
                    (at start (not (not_blocked seg_W1_154b_0_45 ?a)))
         )
)
(:durative-action startup_seg_W1_C3a_0_34_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_C3a_0_34))
                    (over all (not_occupied seg_W1_154c_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_154c_0_34 ?a))
                    (at start (not (not_blocked seg_W1_154c_0_34 ?a)))
         )
)
(:durative-action startup_seg_W1_C3a_0_34_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_C3a_0_34))
                    (over all (not_occupied seg_W1_C3b_0_60))
                    (over all (not_occupied seg_W1_C3c_0_48))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_C3b_0_60 ?a))
                    (at start (not (not_blocked seg_W1_C3b_0_60 ?a)))
                    (at start (blocked seg_W1_C3c_0_48 ?a))
                    (at start (not (not_blocked seg_W1_C3c_0_48 ?a)))
         )
)
(:durative-action startup_seg_W1_C3b_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_C3b_0_60))
                    (over all (not_occupied seg_C3_a_0_80))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_C3_a_0_80 ?a))
                    (at start (not (not_blocked seg_C3_a_0_80 ?a)))
         )
)
(:durative-action startup_seg_W1_C3b_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_C3b_0_60))
                    (over all (not_occupied seg_W1_C3a_0_34))
                    (over all (not_occupied seg_W1_C3c_0_48))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_C3a_0_34 ?a))
                    (at start (not (not_blocked seg_W1_C3a_0_34 ?a)))
                    (at start (blocked seg_W1_C3c_0_48 ?a))
                    (at start (not (not_blocked seg_W1_C3c_0_48 ?a)))
         )
)
(:durative-action startup_seg_W1_C3c_0_48_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_C3c_0_48))
                    (over all (not_occupied seg_W1_161a_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_161a_0_34 ?a))
                    (at start (not (not_blocked seg_W1_161a_0_34 ?a)))
         )
)
(:durative-action startup_seg_W1_C3c_0_48_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_C3c_0_48))
                    (over all (not_occupied seg_W1_C3a_0_34))
                    (over all (not_occupied seg_W1_C3b_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_C3a_0_34 ?a))
                    (at start (not (not_blocked seg_W1_C3a_0_34 ?a)))
                    (at start (blocked seg_W1_C3b_0_60 ?a))
                    (at start (not (not_blocked seg_W1_C3b_0_60 ?a)))
         )
)
(:durative-action startup_seg_C3_a_0_80_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_C3_a_0_80))
                    (over all (not_occupied seg_C3_b_0_80))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_C3_b_0_80 ?a))
                    (at start (not (not_blocked seg_C3_b_0_80 ?a)))
         )
)
(:durative-action startup_seg_C3_a_0_80_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_C3_a_0_80))
                    (over all (not_occupied seg_W1_C3b_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_C3b_0_60 ?a))
                    (at start (not (not_blocked seg_W1_C3b_0_60 ?a)))
         )
)
(:durative-action startup_seg_W1_161a_0_34_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_161a_0_34))
                    (over all (not_occupied seg_W1_C3c_0_48))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_C3c_0_48 ?a))
                    (at start (not (not_blocked seg_W1_C3c_0_48 ?a)))
         )
)
(:durative-action startup_seg_W1_161a_0_34_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_161a_0_34))
                    (over all (not_occupied seg_W1_161b_0_45))
                    (over all (not_occupied seg_W1_161c_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_161b_0_45 ?a))
                    (at start (not (not_blocked seg_W1_161b_0_45 ?a)))
                    (at start (blocked seg_W1_161c_0_34 ?a))
                    (at start (not (not_blocked seg_W1_161c_0_34 ?a)))
         )
)
(:durative-action startup_seg_W1_161b_0_45_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_161b_0_45))
                    (over all (not_occupied seg_p161_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_p161_0_75 ?a))
                    (at start (not (not_blocked seg_p161_0_75 ?a)))
         )
)
(:durative-action startup_seg_W1_161b_0_45_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_161b_0_45))
                    (over all (not_occupied seg_W1_161a_0_34))
                    (over all (not_occupied seg_W1_161c_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_161a_0_34 ?a))
                    (at start (not (not_blocked seg_W1_161a_0_34 ?a)))
                    (at start (blocked seg_W1_161c_0_34 ?a))
                    (at start (not (not_blocked seg_W1_161c_0_34 ?a)))
         )
)
(:durative-action startup_seg_W1_161c_0_34_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_161c_0_34))
                    (over all (not_occupied seg_W1_162a_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_162a_0_34 ?a))
                    (at start (not (not_blocked seg_W1_162a_0_34 ?a)))
         )
)
(:durative-action startup_seg_W1_161c_0_34_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_161c_0_34))
                    (over all (not_occupied seg_W1_161a_0_34))
                    (over all (not_occupied seg_W1_161b_0_45))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_161a_0_34 ?a))
                    (at start (not (not_blocked seg_W1_161a_0_34 ?a)))
                    (at start (blocked seg_W1_161b_0_45 ?a))
                    (at start (not (not_blocked seg_W1_161b_0_45 ?a)))
         )
)
(:durative-action park_seg_p161_0_75_north
 :parameters (?a - airplane)
 :duration (= ?duration 40)
 :condition (and    (over all (at-segment ?a seg_p161_0_75))
		(at start (candostuff))
                    (over all (facing ?a north))
                    (at start (is-moving ?a))
            )
 :effect (and (at end (is-parked ?a seg_p161_0_75))
              (at start (not (is-moving ?a)))
         )
)
(:durative-action park_seg_p161_0_75_south
 :parameters (?a - airplane)
 :duration (= ?duration 40)
 :condition (and    (over all (at-segment ?a seg_p161_0_75))
		(at start (candostuff))
                    (over all (facing ?a south))
                    (at start (is-moving ?a))
            )
 :effect (and (at end (is-parked ?a seg_p161_0_75))
              (at start (not (is-moving ?a)))
              (at end (not (blocked seg_W1_161b_0_45 ?a)))
              (at end (not_blocked seg_W1_161b_0_45 ?a))
         )
)
(:durative-action startup_seg_p161_0_75_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_p161_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
         )
)
(:durative-action startup_seg_p161_0_75_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_p161_0_75))
                    (over all (not_occupied seg_W1_161b_0_45))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_161b_0_45 ?a))
                    (at start (not (not_blocked seg_W1_161b_0_45 ?a)))
         )
)
(:durative-action startup_seg_W1_162a_0_34_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_162a_0_34))
                    (over all (not_occupied seg_W1_161c_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_161c_0_34 ?a))
                    (at start (not (not_blocked seg_W1_161c_0_34 ?a)))
         )
)
(:durative-action startup_seg_W1_162a_0_34_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_162a_0_34))
                    (over all (not_occupied seg_W1_162b_0_45))
                    (over all (not_occupied seg_W1_162c_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_162b_0_45 ?a))
                    (at start (not (not_blocked seg_W1_162b_0_45 ?a)))
                    (at start (blocked seg_W1_162c_0_34 ?a))
                    (at start (not (not_blocked seg_W1_162c_0_34 ?a)))
         )
)
(:durative-action startup_seg_W1_162b_0_45_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_162b_0_45))
                    (over all (not_occupied seg_p162_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_p162_0_75 ?a))
                    (at start (not (not_blocked seg_p162_0_75 ?a)))
         )
)
(:durative-action startup_seg_W1_162b_0_45_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_162b_0_45))
                    (over all (not_occupied seg_W1_162a_0_34))
                    (over all (not_occupied seg_W1_162c_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_162a_0_34 ?a))
                    (at start (not (not_blocked seg_W1_162a_0_34 ?a)))
                    (at start (blocked seg_W1_162c_0_34 ?a))
                    (at start (not (not_blocked seg_W1_162c_0_34 ?a)))
         )
)
(:durative-action startup_seg_W1_162c_0_34_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_162c_0_34))
                    (over all (not_occupied seg_W1_163a_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_163a_0_34 ?a))
                    (at start (not (not_blocked seg_W1_163a_0_34 ?a)))
         )
)
(:durative-action startup_seg_W1_162c_0_34_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_162c_0_34))
                    (over all (not_occupied seg_W1_162a_0_34))
                    (over all (not_occupied seg_W1_162b_0_45))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_162a_0_34 ?a))
                    (at start (not (not_blocked seg_W1_162a_0_34 ?a)))
                    (at start (blocked seg_W1_162b_0_45 ?a))
                    (at start (not (not_blocked seg_W1_162b_0_45 ?a)))
         )
)
(:durative-action park_seg_p162_0_75_north
 :parameters (?a - airplane)
 :duration (= ?duration 40)
 :condition (and    (over all (at-segment ?a seg_p162_0_75))
		(at start (candostuff))
                    (over all (facing ?a north))
                    (at start (is-moving ?a))
            )
 :effect (and (at end (is-parked ?a seg_p162_0_75))
              (at start (not (is-moving ?a)))
         )
)
(:durative-action park_seg_p162_0_75_south
 :parameters (?a - airplane)
 :duration (= ?duration 40)
 :condition (and    (over all (at-segment ?a seg_p162_0_75))
		(at start (candostuff))
                    (over all (facing ?a south))
                    (at start (is-moving ?a))
            )
 :effect (and (at end (is-parked ?a seg_p162_0_75))
              (at start (not (is-moving ?a)))
              (at end (not (blocked seg_W1_162b_0_45 ?a)))
              (at end (not_blocked seg_W1_162b_0_45 ?a))
         )
)
(:durative-action startup_seg_p162_0_75_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_p162_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
         )
)
(:durative-action startup_seg_p162_0_75_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_p162_0_75))
                    (over all (not_occupied seg_W1_162b_0_45))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_162b_0_45 ?a))
                    (at start (not (not_blocked seg_W1_162b_0_45 ?a)))
         )
)
(:durative-action startup_seg_W1_163a_0_34_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_163a_0_34))
                    (over all (not_occupied seg_W1_162c_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_162c_0_34 ?a))
                    (at start (not (not_blocked seg_W1_162c_0_34 ?a)))
         )
)
(:durative-action startup_seg_W1_163a_0_34_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_163a_0_34))
                    (over all (not_occupied seg_W1_163b_0_45))
                    (over all (not_occupied seg_W1_163c_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_163b_0_45 ?a))
                    (at start (not (not_blocked seg_W1_163b_0_45 ?a)))
                    (at start (blocked seg_W1_163c_0_34 ?a))
                    (at start (not (not_blocked seg_W1_163c_0_34 ?a)))
         )
)
(:durative-action startup_seg_W1_163b_0_45_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_163b_0_45))
                    (over all (not_occupied seg_p163_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_p163_0_75 ?a))
                    (at start (not (not_blocked seg_p163_0_75 ?a)))
         )
)
(:durative-action startup_seg_W1_163b_0_45_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_163b_0_45))
                    (over all (not_occupied seg_W1_163a_0_34))
                    (over all (not_occupied seg_W1_163c_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_163a_0_34 ?a))
                    (at start (not (not_blocked seg_W1_163a_0_34 ?a)))
                    (at start (blocked seg_W1_163c_0_34 ?a))
                    (at start (not (not_blocked seg_W1_163c_0_34 ?a)))
         )
)
(:durative-action startup_seg_W1_163c_0_34_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_163c_0_34))
                    (over all (not_occupied seg_W1_164a_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_164a_0_34 ?a))
                    (at start (not (not_blocked seg_W1_164a_0_34 ?a)))
         )
)
(:durative-action startup_seg_W1_163c_0_34_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_163c_0_34))
                    (over all (not_occupied seg_W1_163a_0_34))
                    (over all (not_occupied seg_W1_163b_0_45))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_163a_0_34 ?a))
                    (at start (not (not_blocked seg_W1_163a_0_34 ?a)))
                    (at start (blocked seg_W1_163b_0_45 ?a))
                    (at start (not (not_blocked seg_W1_163b_0_45 ?a)))
         )
)
(:durative-action park_seg_p163_0_75_north
 :parameters (?a - airplane)
 :duration (= ?duration 40)
 :condition (and    (over all (at-segment ?a seg_p163_0_75))
		(at start (candostuff))
                    (over all (facing ?a north))
                    (at start (is-moving ?a))
            )
 :effect (and (at end (is-parked ?a seg_p163_0_75))
              (at start (not (is-moving ?a)))
         )
)
(:durative-action park_seg_p163_0_75_south
 :parameters (?a - airplane)
 :duration (= ?duration 40)
 :condition (and    (over all (at-segment ?a seg_p163_0_75))
		(at start (candostuff))
                    (over all (facing ?a south))
                    (at start (is-moving ?a))
            )
 :effect (and (at end (is-parked ?a seg_p163_0_75))
              (at start (not (is-moving ?a)))
              (at end (not (blocked seg_W1_163b_0_45 ?a)))
              (at end (not_blocked seg_W1_163b_0_45 ?a))
         )
)
(:durative-action startup_seg_p163_0_75_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_p163_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
         )
)
(:durative-action startup_seg_p163_0_75_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_p163_0_75))
                    (over all (not_occupied seg_W1_163b_0_45))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_163b_0_45 ?a))
                    (at start (not (not_blocked seg_W1_163b_0_45 ?a)))
         )
)
(:durative-action startup_seg_W1_164a_0_34_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_164a_0_34))
                    (over all (not_occupied seg_W1_163c_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_163c_0_34 ?a))
                    (at start (not (not_blocked seg_W1_163c_0_34 ?a)))
         )
)
(:durative-action startup_seg_W1_164a_0_34_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_164a_0_34))
                    (over all (not_occupied seg_W1_164b_0_45))
                    (over all (not_occupied seg_W1_164c_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_164b_0_45 ?a))
                    (at start (not (not_blocked seg_W1_164b_0_45 ?a)))
                    (at start (blocked seg_W1_164c_0_34 ?a))
                    (at start (not (not_blocked seg_W1_164c_0_34 ?a)))
         )
)
(:durative-action startup_seg_W1_164b_0_45_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_164b_0_45))
                    (over all (not_occupied seg_p164_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_p164_0_75 ?a))
                    (at start (not (not_blocked seg_p164_0_75 ?a)))
         )
)
(:durative-action startup_seg_W1_164b_0_45_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_164b_0_45))
                    (over all (not_occupied seg_W1_164a_0_34))
                    (over all (not_occupied seg_W1_164c_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_164a_0_34 ?a))
                    (at start (not (not_blocked seg_W1_164a_0_34 ?a)))
                    (at start (blocked seg_W1_164c_0_34 ?a))
                    (at start (not (not_blocked seg_W1_164c_0_34 ?a)))
         )
)
(:durative-action startup_seg_W1_164c_0_34_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_164c_0_34))
                    (over all (not_occupied seg_W1_C4a_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_C4a_0_34 ?a))
                    (at start (not (not_blocked seg_W1_C4a_0_34 ?a)))
         )
)
(:durative-action startup_seg_W1_164c_0_34_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_164c_0_34))
                    (over all (not_occupied seg_W1_164a_0_34))
                    (over all (not_occupied seg_W1_164b_0_45))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_164a_0_34 ?a))
                    (at start (not (not_blocked seg_W1_164a_0_34 ?a)))
                    (at start (blocked seg_W1_164b_0_45 ?a))
                    (at start (not (not_blocked seg_W1_164b_0_45 ?a)))
         )
)
(:durative-action park_seg_p164_0_75_north
 :parameters (?a - airplane)
 :duration (= ?duration 40)
 :condition (and    (over all (at-segment ?a seg_p164_0_75))
		(at start (candostuff))
                    (over all (facing ?a north))
                    (at start (is-moving ?a))
            )
 :effect (and (at end (is-parked ?a seg_p164_0_75))
              (at start (not (is-moving ?a)))
         )
)
(:durative-action park_seg_p164_0_75_south
 :parameters (?a - airplane)
 :duration (= ?duration 40)
 :condition (and    (over all (at-segment ?a seg_p164_0_75))
		(at start (candostuff))
                    (over all (facing ?a south))
                    (at start (is-moving ?a))
            )
 :effect (and (at end (is-parked ?a seg_p164_0_75))
              (at start (not (is-moving ?a)))
              (at end (not (blocked seg_W1_164b_0_45 ?a)))
              (at end (not_blocked seg_W1_164b_0_45 ?a))
         )
)
(:durative-action startup_seg_p164_0_75_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_p164_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
         )
)
(:durative-action startup_seg_p164_0_75_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_p164_0_75))
                    (over all (not_occupied seg_W1_164b_0_45))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_164b_0_45 ?a))
                    (at start (not (not_blocked seg_W1_164b_0_45 ?a)))
         )
)
(:durative-action startup_seg_W1_C4a_0_34_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_C4a_0_34))
                    (over all (not_occupied seg_W1_164c_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_164c_0_34 ?a))
                    (at start (not (not_blocked seg_W1_164c_0_34 ?a)))
         )
)
(:durative-action startup_seg_W1_C4a_0_34_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_C4a_0_34))
                    (over all (not_occupied seg_W1_C4b_0_60))
                    (over all (not_occupied seg_W1_C4c_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_C4b_0_60 ?a))
                    (at start (not (not_blocked seg_W1_C4b_0_60 ?a)))
                    (at start (blocked seg_W1_C4c_0_60 ?a))
                    (at start (not (not_blocked seg_W1_C4c_0_60 ?a)))
         )
)
(:durative-action startup_seg_W1_C4b_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_C4b_0_60))
                    (over all (not_occupied seg_C4_S6c_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_C4_S6c_0_60 ?a))
                    (at start (not (not_blocked seg_C4_S6c_0_60 ?a)))
         )
)
(:durative-action startup_seg_W1_C4b_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_C4b_0_60))
                    (over all (not_occupied seg_W1_C4a_0_34))
                    (over all (not_occupied seg_W1_C4c_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_C4a_0_34 ?a))
                    (at start (not (not_blocked seg_W1_C4a_0_34 ?a)))
                    (at start (blocked seg_W1_C4c_0_60 ?a))
                    (at start (not (not_blocked seg_W1_C4c_0_60 ?a)))
         )
)
(:durative-action startup_seg_W1_C4c_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_C4c_0_60))
                    (over all (not_occupied seg_S5_0_94))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S5_0_94 ?a))
                    (at start (not (not_blocked seg_S5_0_94 ?a)))
         )
)
(:durative-action startup_seg_W1_C4c_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_W1_C4c_0_60))
                    (over all (not_occupied seg_W1_C4a_0_34))
                    (over all (not_occupied seg_W1_C4b_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_C4a_0_34 ?a))
                    (at start (not (not_blocked seg_W1_C4a_0_34 ?a)))
                    (at start (blocked seg_W1_C4b_0_60 ?a))
                    (at start (not (not_blocked seg_W1_C4b_0_60 ?a)))
         )
)
(:durative-action startup_seg_C4_S6c_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_C4_S6c_0_60))
                    (over all (not_occupied seg_W1_C4b_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_W1_C4b_0_60 ?a))
                    (at start (not (not_blocked seg_W1_C4b_0_60 ?a)))
         )
)
(:durative-action startup_seg_C4_S6c_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_C4_S6c_0_60))
                    (over all (not_occupied seg_C4_S6a_0_80))
                    (over all (not_occupied seg_C4_S6b_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_C4_S6a_0_80 ?a))
                    (at start (not (not_blocked seg_C4_S6a_0_80 ?a)))
                    (at start (blocked seg_C4_S6b_0_60 ?a))
                    (at start (not (not_blocked seg_C4_S6b_0_60 ?a)))
         )
)
(:durative-action startup_seg_O1_C1a_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_C1a_0_60))
                    (over all (not_occupied seg_p101_0_76))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_p101_0_76 ?a))
                    (at start (not (not_blocked seg_p101_0_76 ?a)))
         )
)
(:durative-action startup_seg_O1_C1a_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_C1a_0_60))
                    (over all (not_occupied seg_O1_C1b_0_34))
                    (over all (not_occupied seg_O1_C1c_0_80))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_C1b_0_34 ?a))
                    (at start (not (not_blocked seg_O1_C1b_0_34 ?a)))
                    (at start (blocked seg_O1_C1c_0_80 ?a))
                    (at start (not (not_blocked seg_O1_C1c_0_80 ?a)))
         )
)
(:durative-action startup_seg_O1_C1b_0_34_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_C1b_0_34))
                    (over all (not_occupied seg_O1_102a_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_102a_0_34 ?a))
                    (at start (not (not_blocked seg_O1_102a_0_34 ?a)))
         )
)
(:durative-action startup_seg_O1_C1b_0_34_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_C1b_0_34))
                    (over all (not_occupied seg_O1_C1a_0_60))
                    (over all (not_occupied seg_O1_C1c_0_80))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_C1a_0_60 ?a))
                    (at start (not (not_blocked seg_O1_C1a_0_60 ?a)))
                    (at start (blocked seg_O1_C1c_0_80 ?a))
                    (at start (not (not_blocked seg_O1_C1c_0_80 ?a)))
         )
)
(:durative-action startup_seg_O1_C1c_0_80_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_C1c_0_80))
                    (over all (not_occupied seg_C1_n2b_0_80))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_C1_n2b_0_80 ?a))
                    (at start (not (not_blocked seg_C1_n2b_0_80 ?a)))
         )
)
(:durative-action startup_seg_O1_C1c_0_80_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_C1c_0_80))
                    (over all (not_occupied seg_O1_C1a_0_60))
                    (over all (not_occupied seg_O1_C1b_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_C1a_0_60 ?a))
                    (at start (not (not_blocked seg_O1_C1a_0_60 ?a)))
                    (at start (blocked seg_O1_C1b_0_34 ?a))
                    (at start (not (not_blocked seg_O1_C1b_0_34 ?a)))
         )
)
(:durative-action park_seg_p101_0_76_north
 :parameters (?a - airplane)
 :duration (= ?duration 40)
 :condition (and    (over all (at-segment ?a seg_p101_0_76))
		(at start (candostuff))
                    (over all (facing ?a north))
                    (at start (is-moving ?a))
            )
 :effect (and (at end (is-parked ?a seg_p101_0_76))
              (at start (not (is-moving ?a)))
         )
)
(:durative-action park_seg_p101_0_76_south
 :parameters (?a - airplane)
 :duration (= ?duration 40)
 :condition (and    (over all (at-segment ?a seg_p101_0_76))
		(at start (candostuff))
                    (over all (facing ?a south))
                    (at start (is-moving ?a))
            )
 :effect (and (at end (is-parked ?a seg_p101_0_76))
              (at start (not (is-moving ?a)))
              (at end (not (blocked seg_O1_C1a_0_60 ?a)))
              (at end (not_blocked seg_O1_C1a_0_60 ?a))
         )
)
(:durative-action startup_seg_p101_0_76_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_p101_0_76))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
         )
)
(:durative-action startup_seg_p101_0_76_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_p101_0_76))
                    (over all (not_occupied seg_O1_C1a_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_C1a_0_60 ?a))
                    (at start (not (not_blocked seg_O1_C1a_0_60 ?a)))
         )
)
(:durative-action startup_seg_O1_102a_0_34_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_102a_0_34))
                    (over all (not_occupied seg_O1_C1b_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_C1b_0_34 ?a))
                    (at start (not (not_blocked seg_O1_C1b_0_34 ?a)))
         )
)
(:durative-action startup_seg_O1_102a_0_34_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_102a_0_34))
                    (over all (not_occupied seg_O1_102b_0_60))
                    (over all (not_occupied seg_O1_102c_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_102b_0_60 ?a))
                    (at start (not (not_blocked seg_O1_102b_0_60 ?a)))
                    (at start (blocked seg_O1_102c_0_34 ?a))
                    (at start (not (not_blocked seg_O1_102c_0_34 ?a)))
         )
)
(:durative-action startup_seg_C1_n2b_0_80_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_C1_n2b_0_80))
                    (over all (not_occupied seg_O1_C1c_0_80))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_C1c_0_80 ?a))
                    (at start (not (not_blocked seg_O1_C1c_0_80 ?a)))
         )
)
(:durative-action startup_seg_C1_n2b_0_80_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_C1_n2b_0_80))
                    (over all (not_occupied seg_C1_n2a_0_60))
                    (over all (not_occupied seg_C1_n2c_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_C1_n2a_0_60 ?a))
                    (at start (not (not_blocked seg_C1_n2a_0_60 ?a)))
                    (at start (blocked seg_C1_n2c_0_60 ?a))
                    (at start (not (not_blocked seg_C1_n2c_0_60 ?a)))
         )
)
(:durative-action startup_seg_O1_102b_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_102b_0_60))
                    (over all (not_occupied seg_p102_0_76))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_p102_0_76 ?a))
                    (at start (not (not_blocked seg_p102_0_76 ?a)))
         )
)
(:durative-action startup_seg_O1_102b_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_102b_0_60))
                    (over all (not_occupied seg_O1_102a_0_34))
                    (over all (not_occupied seg_O1_102c_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_102a_0_34 ?a))
                    (at start (not (not_blocked seg_O1_102a_0_34 ?a)))
                    (at start (blocked seg_O1_102c_0_34 ?a))
                    (at start (not (not_blocked seg_O1_102c_0_34 ?a)))
         )
)
(:durative-action startup_seg_O1_102c_0_34_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_102c_0_34))
                    (over all (not_occupied seg_O1_103a_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_103a_0_34 ?a))
                    (at start (not (not_blocked seg_O1_103a_0_34 ?a)))
         )
)
(:durative-action startup_seg_O1_102c_0_34_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_102c_0_34))
                    (over all (not_occupied seg_O1_102a_0_34))
                    (over all (not_occupied seg_O1_102b_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_102a_0_34 ?a))
                    (at start (not (not_blocked seg_O1_102a_0_34 ?a)))
                    (at start (blocked seg_O1_102b_0_60 ?a))
                    (at start (not (not_blocked seg_O1_102b_0_60 ?a)))
         )
)
(:durative-action park_seg_p102_0_76_north
 :parameters (?a - airplane)
 :duration (= ?duration 40)
 :condition (and    (over all (at-segment ?a seg_p102_0_76))
		(at start (candostuff))
                    (over all (facing ?a north))
                    (at start (is-moving ?a))
            )
 :effect (and (at end (is-parked ?a seg_p102_0_76))
              (at start (not (is-moving ?a)))
         )
)
(:durative-action park_seg_p102_0_76_south
 :parameters (?a - airplane)
 :duration (= ?duration 40)
 :condition (and    (over all (at-segment ?a seg_p102_0_76))
		(at start (candostuff))
                    (over all (facing ?a south))
                    (at start (is-moving ?a))
            )
 :effect (and (at end (is-parked ?a seg_p102_0_76))
              (at start (not (is-moving ?a)))
              (at end (not (blocked seg_O1_102b_0_60 ?a)))
              (at end (not_blocked seg_O1_102b_0_60 ?a))
         )
)
(:durative-action startup_seg_p102_0_76_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_p102_0_76))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
         )
)
(:durative-action startup_seg_p102_0_76_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_p102_0_76))
                    (over all (not_occupied seg_O1_102b_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_102b_0_60 ?a))
                    (at start (not (not_blocked seg_O1_102b_0_60 ?a)))
         )
)
(:durative-action startup_seg_O1_103a_0_34_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_103a_0_34))
                    (over all (not_occupied seg_O1_102c_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_102c_0_34 ?a))
                    (at start (not (not_blocked seg_O1_102c_0_34 ?a)))
         )
)
(:durative-action startup_seg_O1_103a_0_34_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_103a_0_34))
                    (over all (not_occupied seg_O1_103b_0_60))
                    (over all (not_occupied seg_O1_103c_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_103b_0_60 ?a))
                    (at start (not (not_blocked seg_O1_103b_0_60 ?a)))
                    (at start (blocked seg_O1_103c_0_34 ?a))
                    (at start (not (not_blocked seg_O1_103c_0_34 ?a)))
         )
)
(:durative-action startup_seg_O1_103b_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_103b_0_60))
                    (over all (not_occupied seg_p103_0_76))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_p103_0_76 ?a))
                    (at start (not (not_blocked seg_p103_0_76 ?a)))
         )
)
(:durative-action startup_seg_O1_103b_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_103b_0_60))
                    (over all (not_occupied seg_O1_103a_0_34))
                    (over all (not_occupied seg_O1_103c_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_103a_0_34 ?a))
                    (at start (not (not_blocked seg_O1_103a_0_34 ?a)))
                    (at start (blocked seg_O1_103c_0_34 ?a))
                    (at start (not (not_blocked seg_O1_103c_0_34 ?a)))
         )
)
(:durative-action startup_seg_O1_103c_0_34_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_103c_0_34))
                    (over all (not_occupied seg_O1_104a_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_104a_0_34 ?a))
                    (at start (not (not_blocked seg_O1_104a_0_34 ?a)))
         )
)
(:durative-action startup_seg_O1_103c_0_34_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_103c_0_34))
                    (over all (not_occupied seg_O1_103a_0_34))
                    (over all (not_occupied seg_O1_103b_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_103a_0_34 ?a))
                    (at start (not (not_blocked seg_O1_103a_0_34 ?a)))
                    (at start (blocked seg_O1_103b_0_60 ?a))
                    (at start (not (not_blocked seg_O1_103b_0_60 ?a)))
         )
)
(:durative-action park_seg_p103_0_76_north
 :parameters (?a - airplane)
 :duration (= ?duration 40)
 :condition (and    (over all (at-segment ?a seg_p103_0_76))
		(at start (candostuff))
                    (over all (facing ?a north))
                    (at start (is-moving ?a))
            )
 :effect (and (at end (is-parked ?a seg_p103_0_76))
              (at start (not (is-moving ?a)))
         )
)
(:durative-action park_seg_p103_0_76_south
 :parameters (?a - airplane)
 :duration (= ?duration 40)
 :condition (and    (over all (at-segment ?a seg_p103_0_76))
		(at start (candostuff))
                    (over all (facing ?a south))
                    (at start (is-moving ?a))
            )
 :effect (and (at end (is-parked ?a seg_p103_0_76))
              (at start (not (is-moving ?a)))
              (at end (not (blocked seg_O1_103b_0_60 ?a)))
              (at end (not_blocked seg_O1_103b_0_60 ?a))
         )
)
(:durative-action startup_seg_p103_0_76_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_p103_0_76))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
         )
)
(:durative-action startup_seg_p103_0_76_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_p103_0_76))
                    (over all (not_occupied seg_O1_103b_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_103b_0_60 ?a))
                    (at start (not (not_blocked seg_O1_103b_0_60 ?a)))
         )
)
(:durative-action startup_seg_O1_104a_0_34_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_104a_0_34))
                    (over all (not_occupied seg_O1_103c_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_103c_0_34 ?a))
                    (at start (not (not_blocked seg_O1_103c_0_34 ?a)))
         )
)
(:durative-action startup_seg_O1_104a_0_34_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_104a_0_34))
                    (over all (not_occupied seg_O1_104b_0_60))
                    (over all (not_occupied seg_O1_104c_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_104b_0_60 ?a))
                    (at start (not (not_blocked seg_O1_104b_0_60 ?a)))
                    (at start (blocked seg_O1_104c_0_60 ?a))
                    (at start (not (not_blocked seg_O1_104c_0_60 ?a)))
         )
)
(:durative-action startup_seg_O1_104b_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_104b_0_60))
                    (over all (not_occupied seg_p104_0_76))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_p104_0_76 ?a))
                    (at start (not (not_blocked seg_p104_0_76 ?a)))
         )
)
(:durative-action startup_seg_O1_104b_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_104b_0_60))
                    (over all (not_occupied seg_O1_104a_0_34))
                    (over all (not_occupied seg_O1_104c_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_104a_0_34 ?a))
                    (at start (not (not_blocked seg_O1_104a_0_34 ?a)))
                    (at start (blocked seg_O1_104c_0_60 ?a))
                    (at start (not (not_blocked seg_O1_104c_0_60 ?a)))
         )
)
(:durative-action startup_seg_O1_104c_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_104c_0_60))
                    (over all (not_occupied seg_O1_C2a_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_C2a_0_60 ?a))
                    (at start (not (not_blocked seg_O1_C2a_0_60 ?a)))
         )
)
(:durative-action startup_seg_O1_104c_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_104c_0_60))
                    (over all (not_occupied seg_O1_104a_0_34))
                    (over all (not_occupied seg_O1_104b_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_104a_0_34 ?a))
                    (at start (not (not_blocked seg_O1_104a_0_34 ?a)))
                    (at start (blocked seg_O1_104b_0_60 ?a))
                    (at start (not (not_blocked seg_O1_104b_0_60 ?a)))
         )
)
(:durative-action park_seg_p104_0_76_north
 :parameters (?a - airplane)
 :duration (= ?duration 40)
 :condition (and    (over all (at-segment ?a seg_p104_0_76))
		(at start (candostuff))
                    (over all (facing ?a north))
                    (at start (is-moving ?a))
            )
 :effect (and (at end (is-parked ?a seg_p104_0_76))
              (at start (not (is-moving ?a)))
         )
)
(:durative-action park_seg_p104_0_76_south
 :parameters (?a - airplane)
 :duration (= ?duration 40)
 :condition (and    (over all (at-segment ?a seg_p104_0_76))
		(at start (candostuff))
                    (over all (facing ?a south))
                    (at start (is-moving ?a))
            )
 :effect (and (at end (is-parked ?a seg_p104_0_76))
              (at start (not (is-moving ?a)))
              (at end (not (blocked seg_O1_104b_0_60 ?a)))
              (at end (not_blocked seg_O1_104b_0_60 ?a))
         )
)
(:durative-action startup_seg_p104_0_76_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_p104_0_76))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
         )
)
(:durative-action startup_seg_p104_0_76_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_p104_0_76))
                    (over all (not_occupied seg_O1_104b_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_104b_0_60 ?a))
                    (at start (not (not_blocked seg_O1_104b_0_60 ?a)))
         )
)
(:durative-action startup_seg_O1_C2a_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_C2a_0_60))
                    (over all (not_occupied seg_O1_104c_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_104c_0_60 ?a))
                    (at start (not (not_blocked seg_O1_104c_0_60 ?a)))
         )
)
(:durative-action startup_seg_O1_C2a_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_C2a_0_60))
                    (over all (not_occupied seg_O1_C2b_0_60))
                    (over all (not_occupied seg_O1_C2c_0_34))
                    (over all (not_occupied seg_O1_C2d_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_C2b_0_60 ?a))
                    (at start (not (not_blocked seg_O1_C2b_0_60 ?a)))
                    (at start (blocked seg_O1_C2c_0_34 ?a))
                    (at start (not (not_blocked seg_O1_C2c_0_34 ?a)))
                    (at start (blocked seg_O1_C2d_0_60 ?a))
                    (at start (not (not_blocked seg_O1_C2d_0_60 ?a)))
         )
)
(:durative-action startup_seg_O1_C2b_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_C2b_0_60))
                    (over all (not_occupied seg_p107_0_76))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_p107_0_76 ?a))
                    (at start (not (not_blocked seg_p107_0_76 ?a)))
         )
)
(:durative-action startup_seg_O1_C2b_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_C2b_0_60))
                    (over all (not_occupied seg_O1_C2a_0_60))
                    (over all (not_occupied seg_O1_C2c_0_34))
                    (over all (not_occupied seg_O1_C2d_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_C2a_0_60 ?a))
                    (at start (not (not_blocked seg_O1_C2a_0_60 ?a)))
                    (at start (blocked seg_O1_C2c_0_34 ?a))
                    (at start (not (not_blocked seg_O1_C2c_0_34 ?a)))
                    (at start (blocked seg_O1_C2d_0_60 ?a))
                    (at start (not (not_blocked seg_O1_C2d_0_60 ?a)))
         )
)
(:durative-action startup_seg_O1_C2c_0_34_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_C2c_0_34))
                    (over all (not_occupied seg_O1_108a_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_108a_0_34 ?a))
                    (at start (not (not_blocked seg_O1_108a_0_34 ?a)))
         )
)
(:durative-action startup_seg_O1_C2c_0_34_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_C2c_0_34))
                    (over all (not_occupied seg_O1_C2a_0_60))
                    (over all (not_occupied seg_O1_C2b_0_60))
                    (over all (not_occupied seg_O1_C2d_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_C2a_0_60 ?a))
                    (at start (not (not_blocked seg_O1_C2a_0_60 ?a)))
                    (at start (blocked seg_O1_C2b_0_60 ?a))
                    (at start (not (not_blocked seg_O1_C2b_0_60 ?a)))
                    (at start (blocked seg_O1_C2d_0_60 ?a))
                    (at start (not (not_blocked seg_O1_C2d_0_60 ?a)))
         )
)
(:durative-action startup_seg_O1_C2d_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_C2d_0_60))
                    (over all (not_occupied seg_C2_b_0_80))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_C2_b_0_80 ?a))
                    (at start (not (not_blocked seg_C2_b_0_80 ?a)))
         )
)
(:durative-action startup_seg_O1_C2d_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_C2d_0_60))
                    (over all (not_occupied seg_O1_C2a_0_60))
                    (over all (not_occupied seg_O1_C2b_0_60))
                    (over all (not_occupied seg_O1_C2c_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_C2a_0_60 ?a))
                    (at start (not (not_blocked seg_O1_C2a_0_60 ?a)))
                    (at start (blocked seg_O1_C2b_0_60 ?a))
                    (at start (not (not_blocked seg_O1_C2b_0_60 ?a)))
                    (at start (blocked seg_O1_C2c_0_34 ?a))
                    (at start (not (not_blocked seg_O1_C2c_0_34 ?a)))
         )
)
(:durative-action park_seg_p107_0_76_north
 :parameters (?a - airplane)
 :duration (= ?duration 40)
 :condition (and    (over all (at-segment ?a seg_p107_0_76))
		(at start (candostuff))
                    (over all (facing ?a north))
                    (at start (is-moving ?a))
            )
 :effect (and (at end (is-parked ?a seg_p107_0_76))
              (at start (not (is-moving ?a)))
         )
)
(:durative-action park_seg_p107_0_76_south
 :parameters (?a - airplane)
 :duration (= ?duration 40)
 :condition (and    (over all (at-segment ?a seg_p107_0_76))
		(at start (candostuff))
                    (over all (facing ?a south))
                    (at start (is-moving ?a))
            )
 :effect (and (at end (is-parked ?a seg_p107_0_76))
              (at start (not (is-moving ?a)))
              (at end (not (blocked seg_O1_C2b_0_60 ?a)))
              (at end (not_blocked seg_O1_C2b_0_60 ?a))
         )
)
(:durative-action startup_seg_p107_0_76_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_p107_0_76))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
         )
)
(:durative-action startup_seg_p107_0_76_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_p107_0_76))
                    (over all (not_occupied seg_O1_C2b_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_C2b_0_60 ?a))
                    (at start (not (not_blocked seg_O1_C2b_0_60 ?a)))
         )
)
(:durative-action startup_seg_O1_108a_0_34_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_108a_0_34))
                    (over all (not_occupied seg_O1_C2c_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_C2c_0_34 ?a))
                    (at start (not (not_blocked seg_O1_C2c_0_34 ?a)))
         )
)
(:durative-action startup_seg_O1_108a_0_34_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_108a_0_34))
                    (over all (not_occupied seg_O1_108b_0_60))
                    (over all (not_occupied seg_O1_108c_0_34))
                    (over all (not_occupied seg_O1_108d_0_45))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_108b_0_60 ?a))
                    (at start (not (not_blocked seg_O1_108b_0_60 ?a)))
                    (at start (blocked seg_O1_108c_0_34 ?a))
                    (at start (not (not_blocked seg_O1_108c_0_34 ?a)))
                    (at start (blocked seg_O1_108d_0_45 ?a))
                    (at start (not (not_blocked seg_O1_108d_0_45 ?a)))
         )
)
(:durative-action startup_seg_C2_b_0_80_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_C2_b_0_80))
                    (over all (not_occupied seg_O1_C2d_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_C2d_0_60 ?a))
                    (at start (not (not_blocked seg_O1_C2d_0_60 ?a)))
         )
)
(:durative-action startup_seg_C2_b_0_80_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_C2_b_0_80))
                    (over all (not_occupied seg_C2_a_0_80))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_C2_a_0_80 ?a))
                    (at start (not (not_blocked seg_C2_a_0_80 ?a)))
         )
)
(:durative-action startup_seg_O1_108b_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_108b_0_60))
                    (over all (not_occupied seg_p108_0_76))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_p108_0_76 ?a))
                    (at start (not (not_blocked seg_p108_0_76 ?a)))
         )
)
(:durative-action startup_seg_O1_108b_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_108b_0_60))
                    (over all (not_occupied seg_O1_108a_0_34))
                    (over all (not_occupied seg_O1_108c_0_34))
                    (over all (not_occupied seg_O1_108d_0_45))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_108a_0_34 ?a))
                    (at start (not (not_blocked seg_O1_108a_0_34 ?a)))
                    (at start (blocked seg_O1_108c_0_34 ?a))
                    (at start (not (not_blocked seg_O1_108c_0_34 ?a)))
                    (at start (blocked seg_O1_108d_0_45 ?a))
                    (at start (not (not_blocked seg_O1_108d_0_45 ?a)))
         )
)
(:durative-action startup_seg_O1_108c_0_34_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_108c_0_34))
                    (over all (not_occupied seg_O1_109a_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_109a_0_34 ?a))
                    (at start (not (not_blocked seg_O1_109a_0_34 ?a)))
         )
)
(:durative-action startup_seg_O1_108c_0_34_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_108c_0_34))
                    (over all (not_occupied seg_O1_108a_0_34))
                    (over all (not_occupied seg_O1_108b_0_60))
                    (over all (not_occupied seg_O1_108d_0_45))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_108a_0_34 ?a))
                    (at start (not (not_blocked seg_O1_108a_0_34 ?a)))
                    (at start (blocked seg_O1_108b_0_60 ?a))
                    (at start (not (not_blocked seg_O1_108b_0_60 ?a)))
                    (at start (blocked seg_O1_108d_0_45 ?a))
                    (at start (not (not_blocked seg_O1_108d_0_45 ?a)))
         )
)
(:durative-action startup_seg_O1_108d_0_45_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_108d_0_45))
                    (over all (not_occupied seg_p131_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_p131_0_75 ?a))
                    (at start (not (not_blocked seg_p131_0_75 ?a)))
         )
)
(:durative-action startup_seg_O1_108d_0_45_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_108d_0_45))
                    (over all (not_occupied seg_O1_108a_0_34))
                    (over all (not_occupied seg_O1_108b_0_60))
                    (over all (not_occupied seg_O1_108c_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_108a_0_34 ?a))
                    (at start (not (not_blocked seg_O1_108a_0_34 ?a)))
                    (at start (blocked seg_O1_108b_0_60 ?a))
                    (at start (not (not_blocked seg_O1_108b_0_60 ?a)))
                    (at start (blocked seg_O1_108c_0_34 ?a))
                    (at start (not (not_blocked seg_O1_108c_0_34 ?a)))
         )
)
(:durative-action park_seg_p108_0_76_north
 :parameters (?a - airplane)
 :duration (= ?duration 40)
 :condition (and    (over all (at-segment ?a seg_p108_0_76))
		(at start (candostuff))
                    (over all (facing ?a north))
                    (at start (is-moving ?a))
            )
 :effect (and (at end (is-parked ?a seg_p108_0_76))
              (at start (not (is-moving ?a)))
         )
)
(:durative-action park_seg_p108_0_76_south
 :parameters (?a - airplane)
 :duration (= ?duration 40)
 :condition (and    (over all (at-segment ?a seg_p108_0_76))
		(at start (candostuff))
                    (over all (facing ?a south))
                    (at start (is-moving ?a))
            )
 :effect (and (at end (is-parked ?a seg_p108_0_76))
              (at start (not (is-moving ?a)))
              (at end (not (blocked seg_O1_108b_0_60 ?a)))
              (at end (not_blocked seg_O1_108b_0_60 ?a))
         )
)
(:durative-action startup_seg_p108_0_76_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_p108_0_76))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
         )
)
(:durative-action startup_seg_p108_0_76_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_p108_0_76))
                    (over all (not_occupied seg_O1_108b_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_108b_0_60 ?a))
                    (at start (not (not_blocked seg_O1_108b_0_60 ?a)))
         )
)
(:durative-action startup_seg_O1_109a_0_34_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_109a_0_34))
                    (over all (not_occupied seg_O1_108c_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_108c_0_34 ?a))
                    (at start (not (not_blocked seg_O1_108c_0_34 ?a)))
         )
)
(:durative-action startup_seg_O1_109a_0_34_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_109a_0_34))
                    (over all (not_occupied seg_O1_109b_0_60))
                    (over all (not_occupied seg_O1_109c_0_34))
                    (over all (not_occupied seg_O1_109d_0_45))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_109b_0_60 ?a))
                    (at start (not (not_blocked seg_O1_109b_0_60 ?a)))
                    (at start (blocked seg_O1_109c_0_34 ?a))
                    (at start (not (not_blocked seg_O1_109c_0_34 ?a)))
                    (at start (blocked seg_O1_109d_0_45 ?a))
                    (at start (not (not_blocked seg_O1_109d_0_45 ?a)))
         )
)
(:durative-action park_seg_p131_0_75_north
 :parameters (?a - airplane)
 :duration (= ?duration 40)
 :condition (and    (over all (at-segment ?a seg_p131_0_75))
		(at start (candostuff))
                    (over all (facing ?a north))
                    (at start (is-moving ?a))
            )
 :effect (and (at end (is-parked ?a seg_p131_0_75))
              (at start (not (is-moving ?a)))
         )
)
(:durative-action park_seg_p131_0_75_south
 :parameters (?a - airplane)
 :duration (= ?duration 40)
 :condition (and    (over all (at-segment ?a seg_p131_0_75))
		(at start (candostuff))
                    (over all (facing ?a south))
                    (at start (is-moving ?a))
            )
 :effect (and (at end (is-parked ?a seg_p131_0_75))
              (at start (not (is-moving ?a)))
              (at end (not (blocked seg_O1_108d_0_45 ?a)))
              (at end (not_blocked seg_O1_108d_0_45 ?a))
         )
)
(:durative-action startup_seg_p131_0_75_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_p131_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
         )
)
(:durative-action startup_seg_p131_0_75_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_p131_0_75))
                    (over all (not_occupied seg_O1_108d_0_45))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_108d_0_45 ?a))
                    (at start (not (not_blocked seg_O1_108d_0_45 ?a)))
         )
)
(:durative-action startup_seg_O1_109b_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_109b_0_60))
                    (over all (not_occupied seg_p109_0_76))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_p109_0_76 ?a))
                    (at start (not (not_blocked seg_p109_0_76 ?a)))
         )
)
(:durative-action startup_seg_O1_109b_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_109b_0_60))
                    (over all (not_occupied seg_O1_109a_0_34))
                    (over all (not_occupied seg_O1_109c_0_34))
                    (over all (not_occupied seg_O1_109d_0_45))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_109a_0_34 ?a))
                    (at start (not (not_blocked seg_O1_109a_0_34 ?a)))
                    (at start (blocked seg_O1_109c_0_34 ?a))
                    (at start (not (not_blocked seg_O1_109c_0_34 ?a)))
                    (at start (blocked seg_O1_109d_0_45 ?a))
                    (at start (not (not_blocked seg_O1_109d_0_45 ?a)))
         )
)
(:durative-action startup_seg_O1_109c_0_34_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_109c_0_34))
                    (over all (not_occupied seg_O1_110a_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_110a_0_34 ?a))
                    (at start (not (not_blocked seg_O1_110a_0_34 ?a)))
         )
)
(:durative-action startup_seg_O1_109c_0_34_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_109c_0_34))
                    (over all (not_occupied seg_O1_109a_0_34))
                    (over all (not_occupied seg_O1_109b_0_60))
                    (over all (not_occupied seg_O1_109d_0_45))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_109a_0_34 ?a))
                    (at start (not (not_blocked seg_O1_109a_0_34 ?a)))
                    (at start (blocked seg_O1_109b_0_60 ?a))
                    (at start (not (not_blocked seg_O1_109b_0_60 ?a)))
                    (at start (blocked seg_O1_109d_0_45 ?a))
                    (at start (not (not_blocked seg_O1_109d_0_45 ?a)))
         )
)
(:durative-action startup_seg_O1_109d_0_45_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_109d_0_45))
                    (over all (not_occupied seg_p132_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_p132_0_75 ?a))
                    (at start (not (not_blocked seg_p132_0_75 ?a)))
         )
)
(:durative-action startup_seg_O1_109d_0_45_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_109d_0_45))
                    (over all (not_occupied seg_O1_109a_0_34))
                    (over all (not_occupied seg_O1_109b_0_60))
                    (over all (not_occupied seg_O1_109c_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_109a_0_34 ?a))
                    (at start (not (not_blocked seg_O1_109a_0_34 ?a)))
                    (at start (blocked seg_O1_109b_0_60 ?a))
                    (at start (not (not_blocked seg_O1_109b_0_60 ?a)))
                    (at start (blocked seg_O1_109c_0_34 ?a))
                    (at start (not (not_blocked seg_O1_109c_0_34 ?a)))
         )
)
(:durative-action park_seg_p109_0_76_north
 :parameters (?a - airplane)
 :duration (= ?duration 40)
 :condition (and    (over all (at-segment ?a seg_p109_0_76))
		(at start (candostuff))
                    (over all (facing ?a north))
                    (at start (is-moving ?a))
            )
 :effect (and (at end (is-parked ?a seg_p109_0_76))
              (at start (not (is-moving ?a)))
         )
)
(:durative-action park_seg_p109_0_76_south
 :parameters (?a - airplane)
 :duration (= ?duration 40)
 :condition (and    (over all (at-segment ?a seg_p109_0_76))
		(at start (candostuff))
                    (over all (facing ?a south))
                    (at start (is-moving ?a))
            )
 :effect (and (at end (is-parked ?a seg_p109_0_76))
              (at start (not (is-moving ?a)))
              (at end (not (blocked seg_O1_109b_0_60 ?a)))
              (at end (not_blocked seg_O1_109b_0_60 ?a))
         )
)
(:durative-action startup_seg_p109_0_76_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_p109_0_76))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
         )
)
(:durative-action startup_seg_p109_0_76_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_p109_0_76))
                    (over all (not_occupied seg_O1_109b_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_109b_0_60 ?a))
                    (at start (not (not_blocked seg_O1_109b_0_60 ?a)))
         )
)
(:durative-action startup_seg_O1_110a_0_34_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_110a_0_34))
                    (over all (not_occupied seg_O1_109c_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_109c_0_34 ?a))
                    (at start (not (not_blocked seg_O1_109c_0_34 ?a)))
         )
)
(:durative-action startup_seg_O1_110a_0_34_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_110a_0_34))
                    (over all (not_occupied seg_O1_110b_0_60))
                    (over all (not_occupied seg_O1_110c_0_34))
                    (over all (not_occupied seg_O1_110d_0_45))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_110b_0_60 ?a))
                    (at start (not (not_blocked seg_O1_110b_0_60 ?a)))
                    (at start (blocked seg_O1_110c_0_34 ?a))
                    (at start (not (not_blocked seg_O1_110c_0_34 ?a)))
                    (at start (blocked seg_O1_110d_0_45 ?a))
                    (at start (not (not_blocked seg_O1_110d_0_45 ?a)))
         )
)
(:durative-action park_seg_p132_0_75_north
 :parameters (?a - airplane)
 :duration (= ?duration 40)
 :condition (and    (over all (at-segment ?a seg_p132_0_75))
		(at start (candostuff))
                    (over all (facing ?a north))
                    (at start (is-moving ?a))
            )
 :effect (and (at end (is-parked ?a seg_p132_0_75))
              (at start (not (is-moving ?a)))
         )
)
(:durative-action park_seg_p132_0_75_south
 :parameters (?a - airplane)
 :duration (= ?duration 40)
 :condition (and    (over all (at-segment ?a seg_p132_0_75))
		(at start (candostuff))
                    (over all (facing ?a south))
                    (at start (is-moving ?a))
            )
 :effect (and (at end (is-parked ?a seg_p132_0_75))
              (at start (not (is-moving ?a)))
              (at end (not (blocked seg_O1_109d_0_45 ?a)))
              (at end (not_blocked seg_O1_109d_0_45 ?a))
         )
)
(:durative-action startup_seg_p132_0_75_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_p132_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
         )
)
(:durative-action startup_seg_p132_0_75_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_p132_0_75))
                    (over all (not_occupied seg_O1_109d_0_45))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_109d_0_45 ?a))
                    (at start (not (not_blocked seg_O1_109d_0_45 ?a)))
         )
)
(:durative-action startup_seg_O1_110b_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_110b_0_60))
                    (over all (not_occupied seg_p110_0_76))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_p110_0_76 ?a))
                    (at start (not (not_blocked seg_p110_0_76 ?a)))
         )
)
(:durative-action startup_seg_O1_110b_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_110b_0_60))
                    (over all (not_occupied seg_O1_110a_0_34))
                    (over all (not_occupied seg_O1_110c_0_34))
                    (over all (not_occupied seg_O1_110d_0_45))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_110a_0_34 ?a))
                    (at start (not (not_blocked seg_O1_110a_0_34 ?a)))
                    (at start (blocked seg_O1_110c_0_34 ?a))
                    (at start (not (not_blocked seg_O1_110c_0_34 ?a)))
                    (at start (blocked seg_O1_110d_0_45 ?a))
                    (at start (not (not_blocked seg_O1_110d_0_45 ?a)))
         )
)
(:durative-action startup_seg_O1_110c_0_34_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_110c_0_34))
                    (over all (not_occupied seg_O1_111a_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_111a_0_34 ?a))
                    (at start (not (not_blocked seg_O1_111a_0_34 ?a)))
         )
)
(:durative-action startup_seg_O1_110c_0_34_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_110c_0_34))
                    (over all (not_occupied seg_O1_110a_0_34))
                    (over all (not_occupied seg_O1_110b_0_60))
                    (over all (not_occupied seg_O1_110d_0_45))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_110a_0_34 ?a))
                    (at start (not (not_blocked seg_O1_110a_0_34 ?a)))
                    (at start (blocked seg_O1_110b_0_60 ?a))
                    (at start (not (not_blocked seg_O1_110b_0_60 ?a)))
                    (at start (blocked seg_O1_110d_0_45 ?a))
                    (at start (not (not_blocked seg_O1_110d_0_45 ?a)))
         )
)
(:durative-action startup_seg_O1_110d_0_45_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_110d_0_45))
                    (over all (not_occupied seg_p133_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_p133_0_75 ?a))
                    (at start (not (not_blocked seg_p133_0_75 ?a)))
         )
)
(:durative-action startup_seg_O1_110d_0_45_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_110d_0_45))
                    (over all (not_occupied seg_O1_110a_0_34))
                    (over all (not_occupied seg_O1_110b_0_60))
                    (over all (not_occupied seg_O1_110c_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_110a_0_34 ?a))
                    (at start (not (not_blocked seg_O1_110a_0_34 ?a)))
                    (at start (blocked seg_O1_110b_0_60 ?a))
                    (at start (not (not_blocked seg_O1_110b_0_60 ?a)))
                    (at start (blocked seg_O1_110c_0_34 ?a))
                    (at start (not (not_blocked seg_O1_110c_0_34 ?a)))
         )
)
(:durative-action park_seg_p110_0_76_north
 :parameters (?a - airplane)
 :duration (= ?duration 40)
 :condition (and    (over all (at-segment ?a seg_p110_0_76))
		(at start (candostuff))
                    (over all (facing ?a north))
                    (at start (is-moving ?a))
            )
 :effect (and (at end (is-parked ?a seg_p110_0_76))
              (at start (not (is-moving ?a)))
         )
)
(:durative-action park_seg_p110_0_76_south
 :parameters (?a - airplane)
 :duration (= ?duration 40)
 :condition (and    (over all (at-segment ?a seg_p110_0_76))
		(at start (candostuff))
                    (over all (facing ?a south))
                    (at start (is-moving ?a))
            )
 :effect (and (at end (is-parked ?a seg_p110_0_76))
              (at start (not (is-moving ?a)))
              (at end (not (blocked seg_O1_110b_0_60 ?a)))
              (at end (not_blocked seg_O1_110b_0_60 ?a))
         )
)
(:durative-action startup_seg_p110_0_76_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_p110_0_76))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
         )
)
(:durative-action startup_seg_p110_0_76_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_p110_0_76))
                    (over all (not_occupied seg_O1_110b_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_110b_0_60 ?a))
                    (at start (not (not_blocked seg_O1_110b_0_60 ?a)))
         )
)
(:durative-action startup_seg_O1_111a_0_34_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_111a_0_34))
                    (over all (not_occupied seg_O1_110c_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_110c_0_34 ?a))
                    (at start (not (not_blocked seg_O1_110c_0_34 ?a)))
         )
)
(:durative-action startup_seg_O1_111a_0_34_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_111a_0_34))
                    (over all (not_occupied seg_O1_111b_0_60))
                    (over all (not_occupied seg_O1_111c_0_34))
                    (over all (not_occupied seg_O1_111d_0_45))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_111b_0_60 ?a))
                    (at start (not (not_blocked seg_O1_111b_0_60 ?a)))
                    (at start (blocked seg_O1_111c_0_34 ?a))
                    (at start (not (not_blocked seg_O1_111c_0_34 ?a)))
                    (at start (blocked seg_O1_111d_0_45 ?a))
                    (at start (not (not_blocked seg_O1_111d_0_45 ?a)))
         )
)
(:durative-action park_seg_p133_0_75_north
 :parameters (?a - airplane)
 :duration (= ?duration 40)
 :condition (and    (over all (at-segment ?a seg_p133_0_75))
		(at start (candostuff))
                    (over all (facing ?a north))
                    (at start (is-moving ?a))
            )
 :effect (and (at end (is-parked ?a seg_p133_0_75))
              (at start (not (is-moving ?a)))
         )
)
(:durative-action park_seg_p133_0_75_south
 :parameters (?a - airplane)
 :duration (= ?duration 40)
 :condition (and    (over all (at-segment ?a seg_p133_0_75))
		(at start (candostuff))
                    (over all (facing ?a south))
                    (at start (is-moving ?a))
            )
 :effect (and (at end (is-parked ?a seg_p133_0_75))
              (at start (not (is-moving ?a)))
              (at end (not (blocked seg_O1_110d_0_45 ?a)))
              (at end (not_blocked seg_O1_110d_0_45 ?a))
         )
)
(:durative-action startup_seg_p133_0_75_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_p133_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
         )
)
(:durative-action startup_seg_p133_0_75_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_p133_0_75))
                    (over all (not_occupied seg_O1_110d_0_45))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_110d_0_45 ?a))
                    (at start (not (not_blocked seg_O1_110d_0_45 ?a)))
         )
)
(:durative-action startup_seg_O1_111b_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_111b_0_60))
                    (over all (not_occupied seg_p111_0_76))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_p111_0_76 ?a))
                    (at start (not (not_blocked seg_p111_0_76 ?a)))
         )
)
(:durative-action startup_seg_O1_111b_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_111b_0_60))
                    (over all (not_occupied seg_O1_111a_0_34))
                    (over all (not_occupied seg_O1_111c_0_34))
                    (over all (not_occupied seg_O1_111d_0_45))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_111a_0_34 ?a))
                    (at start (not (not_blocked seg_O1_111a_0_34 ?a)))
                    (at start (blocked seg_O1_111c_0_34 ?a))
                    (at start (not (not_blocked seg_O1_111c_0_34 ?a)))
                    (at start (blocked seg_O1_111d_0_45 ?a))
                    (at start (not (not_blocked seg_O1_111d_0_45 ?a)))
         )
)
(:durative-action startup_seg_O1_111c_0_34_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_111c_0_34))
                    (over all (not_occupied seg_O1_C3a_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_C3a_0_34 ?a))
                    (at start (not (not_blocked seg_O1_C3a_0_34 ?a)))
         )
)
(:durative-action startup_seg_O1_111c_0_34_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_111c_0_34))
                    (over all (not_occupied seg_O1_111a_0_34))
                    (over all (not_occupied seg_O1_111b_0_60))
                    (over all (not_occupied seg_O1_111d_0_45))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_111a_0_34 ?a))
                    (at start (not (not_blocked seg_O1_111a_0_34 ?a)))
                    (at start (blocked seg_O1_111b_0_60 ?a))
                    (at start (not (not_blocked seg_O1_111b_0_60 ?a)))
                    (at start (blocked seg_O1_111d_0_45 ?a))
                    (at start (not (not_blocked seg_O1_111d_0_45 ?a)))
         )
)
(:durative-action startup_seg_O1_111d_0_45_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_111d_0_45))
                    (over all (not_occupied seg_p134_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_p134_0_75 ?a))
                    (at start (not (not_blocked seg_p134_0_75 ?a)))
         )
)
(:durative-action startup_seg_O1_111d_0_45_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_111d_0_45))
                    (over all (not_occupied seg_O1_111a_0_34))
                    (over all (not_occupied seg_O1_111b_0_60))
                    (over all (not_occupied seg_O1_111c_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_111a_0_34 ?a))
                    (at start (not (not_blocked seg_O1_111a_0_34 ?a)))
                    (at start (blocked seg_O1_111b_0_60 ?a))
                    (at start (not (not_blocked seg_O1_111b_0_60 ?a)))
                    (at start (blocked seg_O1_111c_0_34 ?a))
                    (at start (not (not_blocked seg_O1_111c_0_34 ?a)))
         )
)
(:durative-action park_seg_p111_0_76_north
 :parameters (?a - airplane)
 :duration (= ?duration 40)
 :condition (and    (over all (at-segment ?a seg_p111_0_76))
		(at start (candostuff))
                    (over all (facing ?a north))
                    (at start (is-moving ?a))
            )
 :effect (and (at end (is-parked ?a seg_p111_0_76))
              (at start (not (is-moving ?a)))
         )
)
(:durative-action park_seg_p111_0_76_south
 :parameters (?a - airplane)
 :duration (= ?duration 40)
 :condition (and    (over all (at-segment ?a seg_p111_0_76))
		(at start (candostuff))
                    (over all (facing ?a south))
                    (at start (is-moving ?a))
            )
 :effect (and (at end (is-parked ?a seg_p111_0_76))
              (at start (not (is-moving ?a)))
              (at end (not (blocked seg_O1_111b_0_60 ?a)))
              (at end (not_blocked seg_O1_111b_0_60 ?a))
         )
)
(:durative-action startup_seg_p111_0_76_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_p111_0_76))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
         )
)
(:durative-action startup_seg_p111_0_76_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_p111_0_76))
                    (over all (not_occupied seg_O1_111b_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_111b_0_60 ?a))
                    (at start (not (not_blocked seg_O1_111b_0_60 ?a)))
         )
)
(:durative-action park_seg_p134_0_75_north
 :parameters (?a - airplane)
 :duration (= ?duration 40)
 :condition (and    (over all (at-segment ?a seg_p134_0_75))
		(at start (candostuff))
                    (over all (facing ?a north))
                    (at start (is-moving ?a))
            )
 :effect (and (at end (is-parked ?a seg_p134_0_75))
              (at start (not (is-moving ?a)))
         )
)
(:durative-action park_seg_p134_0_75_south
 :parameters (?a - airplane)
 :duration (= ?duration 40)
 :condition (and    (over all (at-segment ?a seg_p134_0_75))
		(at start (candostuff))
                    (over all (facing ?a south))
                    (at start (is-moving ?a))
            )
 :effect (and (at end (is-parked ?a seg_p134_0_75))
              (at start (not (is-moving ?a)))
              (at end (not (blocked seg_O1_111d_0_45 ?a)))
              (at end (not_blocked seg_O1_111d_0_45 ?a))
         )
)
(:durative-action startup_seg_p134_0_75_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_p134_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
         )
)
(:durative-action startup_seg_p134_0_75_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_p134_0_75))
                    (over all (not_occupied seg_O1_111d_0_45))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_111d_0_45 ?a))
                    (at start (not (not_blocked seg_O1_111d_0_45 ?a)))
         )
)
(:durative-action startup_seg_O1_C3a_0_34_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_C3a_0_34))
                    (over all (not_occupied seg_O1_111c_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_111c_0_34 ?a))
                    (at start (not (not_blocked seg_O1_111c_0_34 ?a)))
         )
)
(:durative-action startup_seg_O1_C3a_0_34_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_C3a_0_34))
                    (over all (not_occupied seg_O1_C3b_0_60))
                    (over all (not_occupied seg_O1_C3c_0_48))
                    (over all (not_occupied seg_O1_C3d_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_C3b_0_60 ?a))
                    (at start (not (not_blocked seg_O1_C3b_0_60 ?a)))
                    (at start (blocked seg_O1_C3c_0_48 ?a))
                    (at start (not (not_blocked seg_O1_C3c_0_48 ?a)))
                    (at start (blocked seg_O1_C3d_0_60 ?a))
                    (at start (not (not_blocked seg_O1_C3d_0_60 ?a)))
         )
)
(:durative-action startup_seg_O1_C3b_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_C3b_0_60))
                    (over all (not_occupied seg_p112_0_76))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_p112_0_76 ?a))
                    (at start (not (not_blocked seg_p112_0_76 ?a)))
         )
)
(:durative-action startup_seg_O1_C3b_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_C3b_0_60))
                    (over all (not_occupied seg_O1_C3a_0_34))
                    (over all (not_occupied seg_O1_C3c_0_48))
                    (over all (not_occupied seg_O1_C3d_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_C3a_0_34 ?a))
                    (at start (not (not_blocked seg_O1_C3a_0_34 ?a)))
                    (at start (blocked seg_O1_C3c_0_48 ?a))
                    (at start (not (not_blocked seg_O1_C3c_0_48 ?a)))
                    (at start (blocked seg_O1_C3d_0_60 ?a))
                    (at start (not (not_blocked seg_O1_C3d_0_60 ?a)))
         )
)
(:durative-action startup_seg_O1_C3c_0_48_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_C3c_0_48))
                    (over all (not_occupied seg_O1_115a_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_115a_0_34 ?a))
                    (at start (not (not_blocked seg_O1_115a_0_34 ?a)))
         )
)
(:durative-action startup_seg_O1_C3c_0_48_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_C3c_0_48))
                    (over all (not_occupied seg_O1_C3a_0_34))
                    (over all (not_occupied seg_O1_C3b_0_60))
                    (over all (not_occupied seg_O1_C3d_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_C3a_0_34 ?a))
                    (at start (not (not_blocked seg_O1_C3a_0_34 ?a)))
                    (at start (blocked seg_O1_C3b_0_60 ?a))
                    (at start (not (not_blocked seg_O1_C3b_0_60 ?a)))
                    (at start (blocked seg_O1_C3d_0_60 ?a))
                    (at start (not (not_blocked seg_O1_C3d_0_60 ?a)))
         )
)
(:durative-action startup_seg_O1_C3d_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_C3d_0_60))
                    (over all (not_occupied seg_C3_b_0_80))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_C3_b_0_80 ?a))
                    (at start (not (not_blocked seg_C3_b_0_80 ?a)))
         )
)
(:durative-action startup_seg_O1_C3d_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_C3d_0_60))
                    (over all (not_occupied seg_O1_C3a_0_34))
                    (over all (not_occupied seg_O1_C3b_0_60))
                    (over all (not_occupied seg_O1_C3c_0_48))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_C3a_0_34 ?a))
                    (at start (not (not_blocked seg_O1_C3a_0_34 ?a)))
                    (at start (blocked seg_O1_C3b_0_60 ?a))
                    (at start (not (not_blocked seg_O1_C3b_0_60 ?a)))
                    (at start (blocked seg_O1_C3c_0_48 ?a))
                    (at start (not (not_blocked seg_O1_C3c_0_48 ?a)))
         )
)
(:durative-action park_seg_p112_0_76_north
 :parameters (?a - airplane)
 :duration (= ?duration 40)
 :condition (and    (over all (at-segment ?a seg_p112_0_76))
		(at start (candostuff))
                    (over all (facing ?a north))
                    (at start (is-moving ?a))
            )
 :effect (and (at end (is-parked ?a seg_p112_0_76))
              (at start (not (is-moving ?a)))
         )
)
(:durative-action park_seg_p112_0_76_south
 :parameters (?a - airplane)
 :duration (= ?duration 40)
 :condition (and    (over all (at-segment ?a seg_p112_0_76))
		(at start (candostuff))
                    (over all (facing ?a south))
                    (at start (is-moving ?a))
            )
 :effect (and (at end (is-parked ?a seg_p112_0_76))
              (at start (not (is-moving ?a)))
              (at end (not (blocked seg_O1_C3b_0_60 ?a)))
              (at end (not_blocked seg_O1_C3b_0_60 ?a))
         )
)
(:durative-action startup_seg_p112_0_76_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_p112_0_76))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
         )
)
(:durative-action startup_seg_p112_0_76_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_p112_0_76))
                    (over all (not_occupied seg_O1_C3b_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_C3b_0_60 ?a))
                    (at start (not (not_blocked seg_O1_C3b_0_60 ?a)))
         )
)
(:durative-action startup_seg_O1_115a_0_34_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_115a_0_34))
                    (over all (not_occupied seg_O1_C3c_0_48))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_C3c_0_48 ?a))
                    (at start (not (not_blocked seg_O1_C3c_0_48 ?a)))
         )
)
(:durative-action startup_seg_O1_115a_0_34_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_115a_0_34))
                    (over all (not_occupied seg_O1_115b_0_60))
                    (over all (not_occupied seg_O1_115c_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_115b_0_60 ?a))
                    (at start (not (not_blocked seg_O1_115b_0_60 ?a)))
                    (at start (blocked seg_O1_115c_0_34 ?a))
                    (at start (not (not_blocked seg_O1_115c_0_34 ?a)))
         )
)
(:durative-action startup_seg_C3_b_0_80_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_C3_b_0_80))
                    (over all (not_occupied seg_O1_C3d_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_C3d_0_60 ?a))
                    (at start (not (not_blocked seg_O1_C3d_0_60 ?a)))
         )
)
(:durative-action startup_seg_C3_b_0_80_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_C3_b_0_80))
                    (over all (not_occupied seg_C3_a_0_80))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_C3_a_0_80 ?a))
                    (at start (not (not_blocked seg_C3_a_0_80 ?a)))
         )
)
(:durative-action startup_seg_O1_115b_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_115b_0_60))
                    (over all (not_occupied seg_p115_0_76))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_p115_0_76 ?a))
                    (at start (not (not_blocked seg_p115_0_76 ?a)))
         )
)
(:durative-action startup_seg_O1_115b_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_115b_0_60))
                    (over all (not_occupied seg_O1_115a_0_34))
                    (over all (not_occupied seg_O1_115c_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_115a_0_34 ?a))
                    (at start (not (not_blocked seg_O1_115a_0_34 ?a)))
                    (at start (blocked seg_O1_115c_0_34 ?a))
                    (at start (not (not_blocked seg_O1_115c_0_34 ?a)))
         )
)
(:durative-action startup_seg_O1_115c_0_34_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_115c_0_34))
                    (over all (not_occupied seg_O1_116a_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_116a_0_34 ?a))
                    (at start (not (not_blocked seg_O1_116a_0_34 ?a)))
         )
)
(:durative-action startup_seg_O1_115c_0_34_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_115c_0_34))
                    (over all (not_occupied seg_O1_115a_0_34))
                    (over all (not_occupied seg_O1_115b_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_115a_0_34 ?a))
                    (at start (not (not_blocked seg_O1_115a_0_34 ?a)))
                    (at start (blocked seg_O1_115b_0_60 ?a))
                    (at start (not (not_blocked seg_O1_115b_0_60 ?a)))
         )
)
(:durative-action park_seg_p115_0_76_north
 :parameters (?a - airplane)
 :duration (= ?duration 40)
 :condition (and    (over all (at-segment ?a seg_p115_0_76))
		(at start (candostuff))
                    (over all (facing ?a north))
                    (at start (is-moving ?a))
            )
 :effect (and (at end (is-parked ?a seg_p115_0_76))
              (at start (not (is-moving ?a)))
         )
)
(:durative-action park_seg_p115_0_76_south
 :parameters (?a - airplane)
 :duration (= ?duration 40)
 :condition (and    (over all (at-segment ?a seg_p115_0_76))
		(at start (candostuff))
                    (over all (facing ?a south))
                    (at start (is-moving ?a))
            )
 :effect (and (at end (is-parked ?a seg_p115_0_76))
              (at start (not (is-moving ?a)))
              (at end (not (blocked seg_O1_115b_0_60 ?a)))
              (at end (not_blocked seg_O1_115b_0_60 ?a))
         )
)
(:durative-action startup_seg_p115_0_76_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_p115_0_76))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
         )
)
(:durative-action startup_seg_p115_0_76_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_p115_0_76))
                    (over all (not_occupied seg_O1_115b_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_115b_0_60 ?a))
                    (at start (not (not_blocked seg_O1_115b_0_60 ?a)))
         )
)
(:durative-action startup_seg_O1_116a_0_34_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_116a_0_34))
                    (over all (not_occupied seg_O1_115c_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_115c_0_34 ?a))
                    (at start (not (not_blocked seg_O1_115c_0_34 ?a)))
         )
)
(:durative-action startup_seg_O1_116a_0_34_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_116a_0_34))
                    (over all (not_occupied seg_O1_116b_0_60))
                    (over all (not_occupied seg_O1_116c_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_116b_0_60 ?a))
                    (at start (not (not_blocked seg_O1_116b_0_60 ?a)))
                    (at start (blocked seg_O1_116c_0_34 ?a))
                    (at start (not (not_blocked seg_O1_116c_0_34 ?a)))
         )
)
(:durative-action startup_seg_O1_116b_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_116b_0_60))
                    (over all (not_occupied seg_p116_0_76))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_p116_0_76 ?a))
                    (at start (not (not_blocked seg_p116_0_76 ?a)))
         )
)
(:durative-action startup_seg_O1_116b_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_116b_0_60))
                    (over all (not_occupied seg_O1_116a_0_34))
                    (over all (not_occupied seg_O1_116c_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_116a_0_34 ?a))
                    (at start (not (not_blocked seg_O1_116a_0_34 ?a)))
                    (at start (blocked seg_O1_116c_0_34 ?a))
                    (at start (not (not_blocked seg_O1_116c_0_34 ?a)))
         )
)
(:durative-action startup_seg_O1_116c_0_34_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_116c_0_34))
                    (over all (not_occupied seg_O1_117a_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_117a_0_34 ?a))
                    (at start (not (not_blocked seg_O1_117a_0_34 ?a)))
         )
)
(:durative-action startup_seg_O1_116c_0_34_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_116c_0_34))
                    (over all (not_occupied seg_O1_116a_0_34))
                    (over all (not_occupied seg_O1_116b_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_116a_0_34 ?a))
                    (at start (not (not_blocked seg_O1_116a_0_34 ?a)))
                    (at start (blocked seg_O1_116b_0_60 ?a))
                    (at start (not (not_blocked seg_O1_116b_0_60 ?a)))
         )
)
(:durative-action park_seg_p116_0_76_north
 :parameters (?a - airplane)
 :duration (= ?duration 40)
 :condition (and    (over all (at-segment ?a seg_p116_0_76))
		(at start (candostuff))
                    (over all (facing ?a north))
                    (at start (is-moving ?a))
            )
 :effect (and (at end (is-parked ?a seg_p116_0_76))
              (at start (not (is-moving ?a)))
         )
)
(:durative-action park_seg_p116_0_76_south
 :parameters (?a - airplane)
 :duration (= ?duration 40)
 :condition (and    (over all (at-segment ?a seg_p116_0_76))
		(at start (candostuff))
                    (over all (facing ?a south))
                    (at start (is-moving ?a))
            )
 :effect (and (at end (is-parked ?a seg_p116_0_76))
              (at start (not (is-moving ?a)))
              (at end (not (blocked seg_O1_116b_0_60 ?a)))
              (at end (not_blocked seg_O1_116b_0_60 ?a))
         )
)
(:durative-action startup_seg_p116_0_76_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_p116_0_76))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
         )
)
(:durative-action startup_seg_p116_0_76_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_p116_0_76))
                    (over all (not_occupied seg_O1_116b_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_116b_0_60 ?a))
                    (at start (not (not_blocked seg_O1_116b_0_60 ?a)))
         )
)
(:durative-action startup_seg_O1_117a_0_34_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_117a_0_34))
                    (over all (not_occupied seg_O1_116c_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_116c_0_34 ?a))
                    (at start (not (not_blocked seg_O1_116c_0_34 ?a)))
         )
)
(:durative-action startup_seg_O1_117a_0_34_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_117a_0_34))
                    (over all (not_occupied seg_O1_117b_0_60))
                    (over all (not_occupied seg_O1_117c_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_117b_0_60 ?a))
                    (at start (not (not_blocked seg_O1_117b_0_60 ?a)))
                    (at start (blocked seg_O1_117c_0_34 ?a))
                    (at start (not (not_blocked seg_O1_117c_0_34 ?a)))
         )
)
(:durative-action startup_seg_O1_117b_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_117b_0_60))
                    (over all (not_occupied seg_p117_0_76))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_p117_0_76 ?a))
                    (at start (not (not_blocked seg_p117_0_76 ?a)))
         )
)
(:durative-action startup_seg_O1_117b_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_117b_0_60))
                    (over all (not_occupied seg_O1_117a_0_34))
                    (over all (not_occupied seg_O1_117c_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_117a_0_34 ?a))
                    (at start (not (not_blocked seg_O1_117a_0_34 ?a)))
                    (at start (blocked seg_O1_117c_0_34 ?a))
                    (at start (not (not_blocked seg_O1_117c_0_34 ?a)))
         )
)
(:durative-action startup_seg_O1_117c_0_34_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_117c_0_34))
                    (over all (not_occupied seg_O1_118a_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_118a_0_34 ?a))
                    (at start (not (not_blocked seg_O1_118a_0_34 ?a)))
         )
)
(:durative-action startup_seg_O1_117c_0_34_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_117c_0_34))
                    (over all (not_occupied seg_O1_117a_0_34))
                    (over all (not_occupied seg_O1_117b_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_117a_0_34 ?a))
                    (at start (not (not_blocked seg_O1_117a_0_34 ?a)))
                    (at start (blocked seg_O1_117b_0_60 ?a))
                    (at start (not (not_blocked seg_O1_117b_0_60 ?a)))
         )
)
(:durative-action park_seg_p117_0_76_north
 :parameters (?a - airplane)
 :duration (= ?duration 40)
 :condition (and    (over all (at-segment ?a seg_p117_0_76))
		(at start (candostuff))
                    (over all (facing ?a north))
                    (at start (is-moving ?a))
            )
 :effect (and (at end (is-parked ?a seg_p117_0_76))
              (at start (not (is-moving ?a)))
         )
)
(:durative-action park_seg_p117_0_76_south
 :parameters (?a - airplane)
 :duration (= ?duration 40)
 :condition (and    (over all (at-segment ?a seg_p117_0_76))
		(at start (candostuff))
                    (over all (facing ?a south))
                    (at start (is-moving ?a))
            )
 :effect (and (at end (is-parked ?a seg_p117_0_76))
              (at start (not (is-moving ?a)))
              (at end (not (blocked seg_O1_117b_0_60 ?a)))
              (at end (not_blocked seg_O1_117b_0_60 ?a))
         )
)
(:durative-action startup_seg_p117_0_76_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_p117_0_76))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
         )
)
(:durative-action startup_seg_p117_0_76_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_p117_0_76))
                    (over all (not_occupied seg_O1_117b_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_117b_0_60 ?a))
                    (at start (not (not_blocked seg_O1_117b_0_60 ?a)))
         )
)
(:durative-action startup_seg_O1_118a_0_34_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_118a_0_34))
                    (over all (not_occupied seg_O1_117c_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_117c_0_34 ?a))
                    (at start (not (not_blocked seg_O1_117c_0_34 ?a)))
         )
)
(:durative-action startup_seg_O1_118a_0_34_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_118a_0_34))
                    (over all (not_occupied seg_O1_118b_0_60))
                    (over all (not_occupied seg_O1_118c_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_118b_0_60 ?a))
                    (at start (not (not_blocked seg_O1_118b_0_60 ?a)))
                    (at start (blocked seg_O1_118c_0_34 ?a))
                    (at start (not (not_blocked seg_O1_118c_0_34 ?a)))
         )
)
(:durative-action startup_seg_O1_118b_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_118b_0_60))
                    (over all (not_occupied seg_p118_0_76))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_p118_0_76 ?a))
                    (at start (not (not_blocked seg_p118_0_76 ?a)))
         )
)
(:durative-action startup_seg_O1_118b_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_118b_0_60))
                    (over all (not_occupied seg_O1_118a_0_34))
                    (over all (not_occupied seg_O1_118c_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_118a_0_34 ?a))
                    (at start (not (not_blocked seg_O1_118a_0_34 ?a)))
                    (at start (blocked seg_O1_118c_0_34 ?a))
                    (at start (not (not_blocked seg_O1_118c_0_34 ?a)))
         )
)
(:durative-action startup_seg_O1_118c_0_34_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_118c_0_34))
                    (over all (not_occupied seg_O1_C4a_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_C4a_0_34 ?a))
                    (at start (not (not_blocked seg_O1_C4a_0_34 ?a)))
         )
)
(:durative-action startup_seg_O1_118c_0_34_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_118c_0_34))
                    (over all (not_occupied seg_O1_118a_0_34))
                    (over all (not_occupied seg_O1_118b_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_118a_0_34 ?a))
                    (at start (not (not_blocked seg_O1_118a_0_34 ?a)))
                    (at start (blocked seg_O1_118b_0_60 ?a))
                    (at start (not (not_blocked seg_O1_118b_0_60 ?a)))
         )
)
(:durative-action park_seg_p118_0_76_north
 :parameters (?a - airplane)
 :duration (= ?duration 40)
 :condition (and    (over all (at-segment ?a seg_p118_0_76))
		(at start (candostuff))
                    (over all (facing ?a north))
                    (at start (is-moving ?a))
            )
 :effect (and (at end (is-parked ?a seg_p118_0_76))
              (at start (not (is-moving ?a)))
         )
)
(:durative-action park_seg_p118_0_76_south
 :parameters (?a - airplane)
 :duration (= ?duration 40)
 :condition (and    (over all (at-segment ?a seg_p118_0_76))
		(at start (candostuff))
                    (over all (facing ?a south))
                    (at start (is-moving ?a))
            )
 :effect (and (at end (is-parked ?a seg_p118_0_76))
              (at start (not (is-moving ?a)))
              (at end (not (blocked seg_O1_118b_0_60 ?a)))
              (at end (not_blocked seg_O1_118b_0_60 ?a))
         )
)
(:durative-action startup_seg_p118_0_76_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_p118_0_76))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
         )
)
(:durative-action startup_seg_p118_0_76_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_p118_0_76))
                    (over all (not_occupied seg_O1_118b_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_118b_0_60 ?a))
                    (at start (not (not_blocked seg_O1_118b_0_60 ?a)))
         )
)
(:durative-action startup_seg_O1_C4a_0_34_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_C4a_0_34))
                    (over all (not_occupied seg_O1_118c_0_34))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_118c_0_34 ?a))
                    (at start (not (not_blocked seg_O1_118c_0_34 ?a)))
         )
)
(:durative-action startup_seg_O1_C4a_0_34_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_C4a_0_34))
                    (over all (not_occupied seg_O1_C4b_0_60))
                    (over all (not_occupied seg_O1_C4c_0_80))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_C4b_0_60 ?a))
                    (at start (not (not_blocked seg_O1_C4b_0_60 ?a)))
                    (at start (blocked seg_O1_C4c_0_80 ?a))
                    (at start (not (not_blocked seg_O1_C4c_0_80 ?a)))
         )
)
(:durative-action startup_seg_O1_C4b_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_C4b_0_60))
                    (over all (not_occupied seg_p119_0_76))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_p119_0_76 ?a))
                    (at start (not (not_blocked seg_p119_0_76 ?a)))
         )
)
(:durative-action startup_seg_O1_C4b_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_C4b_0_60))
                    (over all (not_occupied seg_O1_C4a_0_34))
                    (over all (not_occupied seg_O1_C4c_0_80))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_C4a_0_34 ?a))
                    (at start (not (not_blocked seg_O1_C4a_0_34 ?a)))
                    (at start (blocked seg_O1_C4c_0_80 ?a))
                    (at start (not (not_blocked seg_O1_C4c_0_80 ?a)))
         )
)
(:durative-action startup_seg_O1_C4c_0_80_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_C4c_0_80))
                    (over all (not_occupied seg_C4_S6a_0_80))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_C4_S6a_0_80 ?a))
                    (at start (not (not_blocked seg_C4_S6a_0_80 ?a)))
         )
)
(:durative-action startup_seg_O1_C4c_0_80_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_O1_C4c_0_80))
                    (over all (not_occupied seg_O1_C4a_0_34))
                    (over all (not_occupied seg_O1_C4b_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_C4a_0_34 ?a))
                    (at start (not (not_blocked seg_O1_C4a_0_34 ?a)))
                    (at start (blocked seg_O1_C4b_0_60 ?a))
                    (at start (not (not_blocked seg_O1_C4b_0_60 ?a)))
         )
)
(:durative-action park_seg_p119_0_76_north
 :parameters (?a - airplane)
 :duration (= ?duration 40)
 :condition (and    (over all (at-segment ?a seg_p119_0_76))
		(at start (candostuff))
                    (over all (facing ?a north))
                    (at start (is-moving ?a))
            )
 :effect (and (at end (is-parked ?a seg_p119_0_76))
              (at start (not (is-moving ?a)))
         )
)
(:durative-action park_seg_p119_0_76_south
 :parameters (?a - airplane)
 :duration (= ?duration 40)
 :condition (and    (over all (at-segment ?a seg_p119_0_76))
		(at start (candostuff))
                    (over all (facing ?a south))
                    (at start (is-moving ?a))
            )
 :effect (and (at end (is-parked ?a seg_p119_0_76))
              (at start (not (is-moving ?a)))
              (at end (not (blocked seg_O1_C4b_0_60 ?a)))
              (at end (not_blocked seg_O1_C4b_0_60 ?a))
         )
)
(:durative-action startup_seg_p119_0_76_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_p119_0_76))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
         )
)
(:durative-action startup_seg_p119_0_76_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_p119_0_76))
                    (over all (not_occupied seg_O1_C4b_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_C4b_0_60 ?a))
                    (at start (not (not_blocked seg_O1_C4b_0_60 ?a)))
         )
)
(:durative-action startup_seg_C4_S6a_0_80_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_C4_S6a_0_80))
                    (over all (not_occupied seg_O1_C4c_0_80))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_O1_C4c_0_80 ?a))
                    (at start (not (not_blocked seg_O1_C4c_0_80 ?a)))
         )
)
(:durative-action startup_seg_C4_S6a_0_80_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_C4_S6a_0_80))
                    (over all (not_occupied seg_C4_S6b_0_60))
                    (over all (not_occupied seg_C4_S6c_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_C4_S6b_0_60 ?a))
                    (at start (not (not_blocked seg_C4_S6b_0_60 ?a)))
                    (at start (blocked seg_C4_S6c_0_60 ?a))
                    (at start (not (not_blocked seg_C4_S6c_0_60 ?a)))
         )
)
(:durative-action startup_seg_C1_n2a_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_C1_n2a_0_60))
                    (over all (not_occupied seg_N2_0_108))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N2_0_108 ?a))
                    (at start (not (not_blocked seg_N2_0_108 ?a)))
         )
)
(:durative-action startup_seg_C1_n2a_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_C1_n2a_0_60))
                    (over all (not_occupied seg_C1_n2b_0_80))
                    (over all (not_occupied seg_C1_n2c_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_C1_n2b_0_80 ?a))
                    (at start (not (not_blocked seg_C1_n2b_0_80 ?a)))
                    (at start (blocked seg_C1_n2c_0_60 ?a))
                    (at start (not (not_blocked seg_C1_n2c_0_60 ?a)))
         )
)
(:durative-action startup_seg_N2_0_108_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N2_0_108))
                    (over all (not_occupied seg_C1_n2a_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_C1_n2a_0_60 ?a))
                    (at start (not (not_blocked seg_C1_n2a_0_60 ?a)))
         )
)
(:durative-action startup_seg_N2_0_108_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N2_0_108))
                    (over all (not_occupied seg_N_N2b_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_N2b_0_60 ?a))
                    (at start (not (not_blocked seg_N_N2b_0_60 ?a)))
         )
)
(:durative-action startup_seg_C4_S6b_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_C4_S6b_0_60))
                    (over all (not_occupied seg_S6_0_94))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S6_0_94 ?a))
                    (at start (not (not_blocked seg_S6_0_94 ?a)))
         )
)
(:durative-action startup_seg_C4_S6b_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_C4_S6b_0_60))
                    (over all (not_occupied seg_C4_S6a_0_80))
                    (over all (not_occupied seg_C4_S6c_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_C4_S6a_0_80 ?a))
                    (at start (not (not_blocked seg_C4_S6a_0_80 ?a)))
                    (at start (blocked seg_C4_S6c_0_60 ?a))
                    (at start (not (not_blocked seg_C4_S6c_0_60 ?a)))
         )
)
(:durative-action startup_seg_08L_A2b_0_80_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_08L_A2b_0_80))
                    (over all (not_occupied seg_A2_a_0_90))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_A2_a_0_90 ?a))
                    (at start (not (not_blocked seg_A2_a_0_90 ?a)))
         )
)
(:durative-action startup_seg_08L_A2b_0_80_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_08L_A2b_0_80))
                    (over all (not_occupied seg_08L_A2a_0_80))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_08L_A2a_0_80 ?a))
                    (at start (not (not_blocked seg_08L_A2a_0_80 ?a)))
         )
)
(:durative-action startup_seg_A2_a_0_90_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_A2_a_0_90))
                    (over all (not_occupied seg_A2_b_0_90))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_A2_b_0_90 ?a))
                    (at start (not (not_blocked seg_A2_b_0_90 ?a)))
         )
)
(:durative-action startup_seg_A2_a_0_90_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_A2_a_0_90))
                    (over all (not_occupied seg_08L_A2b_0_80))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_08L_A2b_0_80 ?a))
                    (at start (not (not_blocked seg_08L_A2b_0_80 ?a)))
         )
)
(:durative-action startup_seg_08L_A3b_0_161_245_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_08L_A3b_0_161_245))
                    (over all (not_occupied seg_A3_a_0_158_647))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_A3_a_0_158_647 ?a))
                    (at start (not (not_blocked seg_A3_a_0_158_647 ?a)))
         )
)
(:durative-action startup_seg_08L_A3b_0_161_245_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_08L_A3b_0_161_245))
                    (over all (not_occupied seg_08L_A3a_0_80))
                    (over all (not_occupied seg_08l_0_80))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_08L_A3a_0_80 ?a))
                    (at start (not (not_blocked seg_08L_A3a_0_80 ?a)))
                    (at start (blocked seg_08l_0_80 ?a))
                    (at start (not (not_blocked seg_08l_0_80 ?a)))
         )
)
(:durative-action startup_seg_A3_a_0_158_647_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_A3_a_0_158_647))
                    (over all (not_occupied seg_A3_b_0_159_512))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_A3_b_0_159_512 ?a))
                    (at start (not (not_blocked seg_A3_b_0_159_512 ?a)))
         )
)
(:durative-action startup_seg_A3_a_0_158_647_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_A3_a_0_158_647))
                    (over all (not_occupied seg_08L_A3b_0_161_245))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_08L_A3b_0_161_245 ?a))
                    (at start (not (not_blocked seg_08L_A3b_0_161_245 ?a)))
         )
)
(:durative-action startup_seg_08L_A4b_0_161_245_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_08L_A4b_0_161_245))
                    (over all (not_occupied seg_A6_a_0_158_647))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_A6_a_0_158_647 ?a))
                    (at start (not (not_blocked seg_A6_a_0_158_647 ?a)))
         )
)
(:durative-action startup_seg_08L_A4b_0_161_245_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_08L_A4b_0_161_245))
                    (over all (not_occupied seg_08L_A4a_0_80))
                    (over all (not_occupied seg_08L_A4c_0_161_245))
                    (over all (not_occupied seg_08L_A4d_0_80))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_08L_A4a_0_80 ?a))
                    (at start (not (not_blocked seg_08L_A4a_0_80 ?a)))
                    (at start (blocked seg_08L_A4c_0_161_245 ?a))
                    (at start (not (not_blocked seg_08L_A4c_0_161_245 ?a)))
                    (at start (blocked seg_08L_A4d_0_80 ?a))
                    (at start (not (not_blocked seg_08L_A4d_0_80 ?a)))
         )
)
(:durative-action startup_seg_08L_A4c_0_161_245_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_08L_A4c_0_161_245))
                    (over all (not_occupied seg_A4_a_0_157_785))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_A4_a_0_157_785 ?a))
                    (at start (not (not_blocked seg_A4_a_0_157_785 ?a)))
         )
)
(:durative-action startup_seg_08L_A4c_0_161_245_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_08L_A4c_0_161_245))
                    (over all (not_occupied seg_08L_A4a_0_80))
                    (over all (not_occupied seg_08L_A4b_0_161_245))
                    (over all (not_occupied seg_08L_A4d_0_80))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_08L_A4a_0_80 ?a))
                    (at start (not (not_blocked seg_08L_A4a_0_80 ?a)))
                    (at start (blocked seg_08L_A4b_0_161_245 ?a))
                    (at start (not (not_blocked seg_08L_A4b_0_161_245 ?a)))
                    (at start (blocked seg_08L_A4d_0_80 ?a))
                    (at start (not (not_blocked seg_08L_A4d_0_80 ?a)))
         )
)
(:durative-action startup_seg_A6_a_0_158_647_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_A6_a_0_158_647))
                    (over all (not_occupied seg_A6_b_0_159_512))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_A6_b_0_159_512 ?a))
                    (at start (not (not_blocked seg_A6_b_0_159_512 ?a)))
         )
)
(:durative-action startup_seg_A6_a_0_158_647_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_A6_a_0_158_647))
                    (over all (not_occupied seg_08L_A4b_0_161_245))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_08L_A4b_0_161_245 ?a))
                    (at start (not (not_blocked seg_08L_A4b_0_161_245 ?a)))
         )
)
(:durative-action startup_seg_A4_a_0_157_785_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_A4_a_0_157_785))
                    (over all (not_occupied seg_A4_b_1_0_80_6226))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_A4_b_1_0_80_6226 ?a))
                    (at start (not (not_blocked seg_A4_b_1_0_80_6226 ?a)))
         )
)
(:durative-action startup_seg_A4_a_0_157_785_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_A4_a_0_157_785))
                    (over all (not_occupied seg_08L_A4c_0_161_245))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_08L_A4c_0_161_245 ?a))
                    (at start (not (not_blocked seg_08L_A4c_0_161_245 ?a)))
         )
)
(:durative-action startup_seg_08L_A7b_0_161_245_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_08L_A7b_0_161_245))
                    (over all (not_occupied seg_A8_a_0_157_785))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_A8_a_0_157_785 ?a))
                    (at start (not (not_blocked seg_A8_a_0_157_785 ?a)))
         )
)
(:durative-action startup_seg_08L_A7b_0_161_245_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_08L_A7b_0_161_245))
                    (over all (not_occupied seg_08L_A7a_0_80))
                    (over all (not_occupied seg_08L_A7c_0_161_245))
                    (over all (not_occupied seg_08L_A7d_0_80))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_08L_A7a_0_80 ?a))
                    (at start (not (not_blocked seg_08L_A7a_0_80 ?a)))
                    (at start (blocked seg_08L_A7c_0_161_245 ?a))
                    (at start (not (not_blocked seg_08L_A7c_0_161_245 ?a)))
                    (at start (blocked seg_08L_A7d_0_80 ?a))
                    (at start (not (not_blocked seg_08L_A7d_0_80 ?a)))
         )
)
(:durative-action startup_seg_08L_A7c_0_161_245_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_08L_A7c_0_161_245))
                    (over all (not_occupied seg_A7_a_0_156_924))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_A7_a_0_156_924 ?a))
                    (at start (not (not_blocked seg_A7_a_0_156_924 ?a)))
         )
)
(:durative-action startup_seg_08L_A7c_0_161_245_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_08L_A7c_0_161_245))
                    (over all (not_occupied seg_08L_A7a_0_80))
                    (over all (not_occupied seg_08L_A7b_0_161_245))
                    (over all (not_occupied seg_08L_A7d_0_80))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_08L_A7a_0_80 ?a))
                    (at start (not (not_blocked seg_08L_A7a_0_80 ?a)))
                    (at start (blocked seg_08L_A7b_0_161_245 ?a))
                    (at start (not (not_blocked seg_08L_A7b_0_161_245 ?a)))
                    (at start (blocked seg_08L_A7d_0_80 ?a))
                    (at start (not (not_blocked seg_08L_A7d_0_80 ?a)))
         )
)
(:durative-action startup_seg_A8_a_0_157_785_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_A8_a_0_157_785))
                    (over all (not_occupied seg_A8_b_1_0_79_7559))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_A8_b_1_0_79_7559 ?a))
                    (at start (not (not_blocked seg_A8_b_1_0_79_7559 ?a)))
         )
)
(:durative-action startup_seg_A8_a_0_157_785_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_A8_a_0_157_785))
                    (over all (not_occupied seg_08L_A7b_0_161_245))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_08L_A7b_0_161_245 ?a))
                    (at start (not (not_blocked seg_08L_A7b_0_161_245 ?a)))
         )
)
(:durative-action startup_seg_A7_a_0_156_924_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_A7_a_0_156_924))
                    (over all (not_occupied seg_A7_b_1_0_80_6226))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_A7_b_1_0_80_6226 ?a))
                    (at start (not (not_blocked seg_A7_b_1_0_80_6226 ?a)))
         )
)
(:durative-action startup_seg_A7_a_0_156_924_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_A7_a_0_156_924))
                    (over all (not_occupied seg_08L_A7c_0_161_245))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_08L_A7c_0_161_245 ?a))
                    (at start (not (not_blocked seg_08L_A7c_0_161_245 ?a)))
         )
)
(:durative-action startup_seg_08L_A9b_0_161_245_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_08L_A9b_0_161_245))
                    (over all (not_occupied seg_A9_a_0_158_647))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_A9_a_0_158_647 ?a))
                    (at start (not (not_blocked seg_A9_a_0_158_647 ?a)))
         )
)
(:durative-action startup_seg_08L_A9b_0_161_245_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_08L_A9b_0_161_245))
                    (over all (not_occupied seg_09l_0_80))
                    (over all (not_occupied seg_08L_A9c_0_80))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_09l_0_80 ?a))
                    (at start (not (not_blocked seg_09l_0_80 ?a)))
                    (at start (blocked seg_08L_A9c_0_80 ?a))
                    (at start (not (not_blocked seg_08L_A9c_0_80 ?a)))
         )
)
(:durative-action startup_seg_A9_a_0_158_647_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_A9_a_0_158_647))
                    (over all (not_occupied seg_A9_b_0_159_512))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_A9_b_0_159_512 ?a))
                    (at start (not (not_blocked seg_A9_b_0_159_512 ?a)))
         )
)
(:durative-action startup_seg_A9_a_0_158_647_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_A9_a_0_158_647))
                    (over all (not_occupied seg_08L_A9b_0_161_245))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_08L_A9b_0_161_245 ?a))
                    (at start (not (not_blocked seg_08L_A9b_0_161_245 ?a)))
         )
)
(:durative-action startup_seg_08L_A10a_0_80_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_08L_A10a_0_80))
                    (over all (not_occupied seg_A10_1_0_80))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_A10_1_0_80 ?a))
                    (at start (not (not_blocked seg_A10_1_0_80 ?a)))
         )
)
(:durative-action startup_seg_08L_A10a_0_80_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_08L_A10a_0_80))
                    (over all (not_occupied seg_08L_A10b_0_80))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_08L_A10b_0_80 ?a))
                    (at start (not (not_blocked seg_08L_A10b_0_80 ?a)))
         )
)
(:durative-action startup_seg_A10_1_0_80_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_A10_1_0_80))
                    (over all (not_occupied seg_A10_0_80))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_A10_0_80 ?a))
                    (at start (not (not_blocked seg_A10_0_80 ?a)))
         )
)
(:durative-action startup_seg_A10_1_0_80_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_A10_1_0_80))
                    (over all (not_occupied seg_08L_A10a_0_80))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_08L_A10a_0_80 ?a))
                    (at start (not (not_blocked seg_08L_A10a_0_80 ?a)))
         )
)
(:durative-action startup_seg_M_A3a_0_120_934_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A3a_0_120_934))
                    (over all (not_occupied seg_A3_b_0_159_512))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_A3_b_0_159_512 ?a))
                    (at start (not (not_blocked seg_A3_b_0_159_512 ?a)))
         )
)
(:durative-action startup_seg_M_A3a_0_120_934_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A3a_0_120_934))
                    (over all (not_occupied seg_M_A3b_0_60))
                    (over all (not_occupied seg_M_A3c_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A3b_0_60 ?a))
                    (at start (not (not_blocked seg_M_A3b_0_60 ?a)))
                    (at start (blocked seg_M_A3c_0_60 ?a))
                    (at start (not (not_blocked seg_M_A3c_0_60 ?a)))
         )
)
(:durative-action startup_seg_M_A3b_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A3b_0_60))
                    (over all (not_occupied seg_M_A3A4a_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A3A4a_0_75 ?a))
                    (at start (not (not_blocked seg_M_A3A4a_0_75 ?a)))
         )
)
(:durative-action startup_seg_M_A3b_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A3b_0_60))
                    (over all (not_occupied seg_M_A3a_0_120_934))
                    (over all (not_occupied seg_M_A3c_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A3a_0_120_934 ?a))
                    (at start (not (not_blocked seg_M_A3a_0_120_934 ?a)))
                    (at start (blocked seg_M_A3c_0_60 ?a))
                    (at start (not (not_blocked seg_M_A3c_0_60 ?a)))
         )
)
(:durative-action startup_seg_M_A3c_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A3c_0_60))
                    (over all (not_occupied seg_N_A3a_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A3a_0_60 ?a))
                    (at start (not (not_blocked seg_N_A3a_0_60 ?a)))
         )
)
(:durative-action startup_seg_M_A3c_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A3c_0_60))
                    (over all (not_occupied seg_M_A3a_0_120_934))
                    (over all (not_occupied seg_M_A3b_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A3a_0_120_934 ?a))
                    (at start (not (not_blocked seg_M_A3a_0_120_934 ?a)))
                    (at start (blocked seg_M_A3b_0_60 ?a))
                    (at start (not (not_blocked seg_M_A3b_0_60 ?a)))
         )
)
(:durative-action startup_seg_A3_b_0_159_512_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_A3_b_0_159_512))
                    (over all (not_occupied seg_M_A3a_0_120_934))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A3a_0_120_934 ?a))
                    (at start (not (not_blocked seg_M_A3a_0_120_934 ?a)))
         )
)
(:durative-action startup_seg_A3_b_0_159_512_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_A3_b_0_159_512))
                    (over all (not_occupied seg_A3_a_0_158_647))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_A3_a_0_158_647 ?a))
                    (at start (not (not_blocked seg_A3_a_0_158_647 ?a)))
         )
)
(:durative-action startup_seg_M_A3A4a_0_75_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A3A4a_0_75))
                    (over all (not_occupied seg_M_A3A4b_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A3A4b_0_75 ?a))
                    (at start (not (not_blocked seg_M_A3A4b_0_75 ?a)))
         )
)
(:durative-action startup_seg_M_A3A4a_0_75_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A3A4a_0_75))
                    (over all (not_occupied seg_M_A3b_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A3b_0_60 ?a))
                    (at start (not (not_blocked seg_M_A3b_0_60 ?a)))
         )
)
(:durative-action startup_seg_N_A3a_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A3a_0_60))
                    (over all (not_occupied seg_M_A3c_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A3c_0_60 ?a))
                    (at start (not (not_blocked seg_M_A3c_0_60 ?a)))
         )
)
(:durative-action startup_seg_N_A3a_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A3a_0_60))
                    (over all (not_occupied seg_N_A3b_0_60))
                    (over all (not_occupied seg_N_A3c_0_60))
                    (over all (not_occupied seg_N_A3d_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A3b_0_60 ?a))
                    (at start (not (not_blocked seg_N_A3b_0_60 ?a)))
                    (at start (blocked seg_N_A3c_0_60 ?a))
                    (at start (not (not_blocked seg_N_A3c_0_60 ?a)))
                    (at start (blocked seg_N_A3d_0_60 ?a))
                    (at start (not (not_blocked seg_N_A3d_0_60 ?a)))
         )
)
(:durative-action startup_seg_M_A3A4b_0_75_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A3A4b_0_75))
                    (over all (not_occupied seg_M_A3A4c_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A3A4c_0_75 ?a))
                    (at start (not (not_blocked seg_M_A3A4c_0_75 ?a)))
         )
)
(:durative-action startup_seg_M_A3A4b_0_75_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A3A4b_0_75))
                    (over all (not_occupied seg_M_A3A4a_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A3A4a_0_75 ?a))
                    (at start (not (not_blocked seg_M_A3A4a_0_75 ?a)))
         )
)
(:durative-action startup_seg_M_A3A4c_0_75_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A3A4c_0_75))
                    (over all (not_occupied seg_M_A3A4d_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A3A4d_0_75 ?a))
                    (at start (not (not_blocked seg_M_A3A4d_0_75 ?a)))
         )
)
(:durative-action startup_seg_M_A3A4c_0_75_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A3A4c_0_75))
                    (over all (not_occupied seg_M_A3A4b_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A3A4b_0_75 ?a))
                    (at start (not (not_blocked seg_M_A3A4b_0_75 ?a)))
         )
)
(:durative-action startup_seg_M_A3A4d_0_75_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A3A4d_0_75))
                    (over all (not_occupied seg_M_A3A4e_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A3A4e_0_75 ?a))
                    (at start (not (not_blocked seg_M_A3A4e_0_75 ?a)))
         )
)
(:durative-action startup_seg_M_A3A4d_0_75_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A3A4d_0_75))
                    (over all (not_occupied seg_M_A3A4c_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A3A4c_0_75 ?a))
                    (at start (not (not_blocked seg_M_A3A4c_0_75 ?a)))
         )
)
(:durative-action startup_seg_M_A3A4e_0_75_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A3A4e_0_75))
                    (over all (not_occupied seg_M_A3A4f_0_115))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A3A4f_0_115 ?a))
                    (at start (not (not_blocked seg_M_A3A4f_0_115 ?a)))
         )
)
(:durative-action startup_seg_M_A3A4e_0_75_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A3A4e_0_75))
                    (over all (not_occupied seg_M_A3A4d_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A3A4d_0_75 ?a))
                    (at start (not (not_blocked seg_M_A3A4d_0_75 ?a)))
         )
)
(:durative-action startup_seg_M_A3A4f_0_115_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A3A4f_0_115))
                    (over all (not_occupied seg_M_A4d_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A4d_0_60 ?a))
                    (at start (not (not_blocked seg_M_A4d_0_60 ?a)))
         )
)
(:durative-action startup_seg_M_A3A4f_0_115_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A3A4f_0_115))
                    (over all (not_occupied seg_M_A3A4e_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A3A4e_0_75 ?a))
                    (at start (not (not_blocked seg_M_A3A4e_0_75 ?a)))
         )
)
(:durative-action startup_seg_M_A4a_0_120_934_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A4a_0_120_934))
                    (over all (not_occupied seg_A4_b_0_79_7559))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_A4_b_0_79_7559 ?a))
                    (at start (not (not_blocked seg_A4_b_0_79_7559 ?a)))
         )
)
(:durative-action startup_seg_M_A4a_0_120_934_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A4a_0_120_934))
                    (over all (not_occupied seg_M_A4b_0_60))
                    (over all (not_occupied seg_M_A4c_0_60))
                    (over all (not_occupied seg_M_A4d_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A4b_0_60 ?a))
                    (at start (not (not_blocked seg_M_A4b_0_60 ?a)))
                    (at start (blocked seg_M_A4c_0_60 ?a))
                    (at start (not (not_blocked seg_M_A4c_0_60 ?a)))
                    (at start (blocked seg_M_A4d_0_60 ?a))
                    (at start (not (not_blocked seg_M_A4d_0_60 ?a)))
         )
)
(:durative-action startup_seg_M_A4b_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A4b_0_60))
                    (over all (not_occupied seg_M_A4A7a_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A4A7a_0_75 ?a))
                    (at start (not (not_blocked seg_M_A4A7a_0_75 ?a)))
         )
)
(:durative-action startup_seg_M_A4b_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A4b_0_60))
                    (over all (not_occupied seg_M_A4a_0_120_934))
                    (over all (not_occupied seg_M_A4c_0_60))
                    (over all (not_occupied seg_M_A4d_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A4a_0_120_934 ?a))
                    (at start (not (not_blocked seg_M_A4a_0_120_934 ?a)))
                    (at start (blocked seg_M_A4c_0_60 ?a))
                    (at start (not (not_blocked seg_M_A4c_0_60 ?a)))
                    (at start (blocked seg_M_A4d_0_60 ?a))
                    (at start (not (not_blocked seg_M_A4d_0_60 ?a)))
         )
)
(:durative-action startup_seg_M_A4c_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A4c_0_60))
                    (over all (not_occupied seg_N_A4a_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A4a_0_60 ?a))
                    (at start (not (not_blocked seg_N_A4a_0_60 ?a)))
         )
)
(:durative-action startup_seg_M_A4c_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A4c_0_60))
                    (over all (not_occupied seg_M_A4a_0_120_934))
                    (over all (not_occupied seg_M_A4b_0_60))
                    (over all (not_occupied seg_M_A4d_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A4a_0_120_934 ?a))
                    (at start (not (not_blocked seg_M_A4a_0_120_934 ?a)))
                    (at start (blocked seg_M_A4b_0_60 ?a))
                    (at start (not (not_blocked seg_M_A4b_0_60 ?a)))
                    (at start (blocked seg_M_A4d_0_60 ?a))
                    (at start (not (not_blocked seg_M_A4d_0_60 ?a)))
         )
)
(:durative-action startup_seg_M_A4d_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A4d_0_60))
                    (over all (not_occupied seg_M_A3A4f_0_115))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A3A4f_0_115 ?a))
                    (at start (not (not_blocked seg_M_A3A4f_0_115 ?a)))
         )
)
(:durative-action startup_seg_M_A4d_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A4d_0_60))
                    (over all (not_occupied seg_M_A4a_0_120_934))
                    (over all (not_occupied seg_M_A4b_0_60))
                    (over all (not_occupied seg_M_A4c_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A4a_0_120_934 ?a))
                    (at start (not (not_blocked seg_M_A4a_0_120_934 ?a)))
                    (at start (blocked seg_M_A4b_0_60 ?a))
                    (at start (not (not_blocked seg_M_A4b_0_60 ?a)))
                    (at start (blocked seg_M_A4c_0_60 ?a))
                    (at start (not (not_blocked seg_M_A4c_0_60 ?a)))
         )
)
(:durative-action startup_seg_A4_b_0_79_7559_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_A4_b_0_79_7559))
                    (over all (not_occupied seg_M_A4a_0_120_934))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A4a_0_120_934 ?a))
                    (at start (not (not_blocked seg_M_A4a_0_120_934 ?a)))
         )
)
(:durative-action startup_seg_A4_b_0_79_7559_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_A4_b_0_79_7559))
                    (over all (not_occupied seg_A4_b_1_0_80_6226))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_A4_b_1_0_80_6226 ?a))
                    (at start (not (not_blocked seg_A4_b_1_0_80_6226 ?a)))
         )
)
(:durative-action startup_seg_M_A4A7a_0_75_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A4A7a_0_75))
                    (over all (not_occupied seg_M_A4A7b_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A4A7b_0_75 ?a))
                    (at start (not (not_blocked seg_M_A4A7b_0_75 ?a)))
         )
)
(:durative-action startup_seg_M_A4A7a_0_75_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A4A7a_0_75))
                    (over all (not_occupied seg_M_A4b_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A4b_0_60 ?a))
                    (at start (not (not_blocked seg_M_A4b_0_60 ?a)))
         )
)
(:durative-action startup_seg_N_A4a_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A4a_0_60))
                    (over all (not_occupied seg_M_A4c_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A4c_0_60 ?a))
                    (at start (not (not_blocked seg_M_A4c_0_60 ?a)))
         )
)
(:durative-action startup_seg_N_A4a_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A4a_0_60))
                    (over all (not_occupied seg_N_A4b_0_60))
                    (over all (not_occupied seg_N_A4c_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A4b_0_60 ?a))
                    (at start (not (not_blocked seg_N_A4b_0_60 ?a)))
                    (at start (blocked seg_N_A4c_0_60 ?a))
                    (at start (not (not_blocked seg_N_A4c_0_60 ?a)))
         )
)
(:durative-action startup_seg_M_A4A7b_0_75_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A4A7b_0_75))
                    (over all (not_occupied seg_M_A4A7c_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A4A7c_0_75 ?a))
                    (at start (not (not_blocked seg_M_A4A7c_0_75 ?a)))
         )
)
(:durative-action startup_seg_M_A4A7b_0_75_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A4A7b_0_75))
                    (over all (not_occupied seg_M_A4A7a_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A4A7a_0_75 ?a))
                    (at start (not (not_blocked seg_M_A4A7a_0_75 ?a)))
         )
)
(:durative-action startup_seg_M_A4A7c_0_75_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A4A7c_0_75))
                    (over all (not_occupied seg_M_A4A7d_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A4A7d_0_75 ?a))
                    (at start (not (not_blocked seg_M_A4A7d_0_75 ?a)))
         )
)
(:durative-action startup_seg_M_A4A7c_0_75_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A4A7c_0_75))
                    (over all (not_occupied seg_M_A4A7b_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A4A7b_0_75 ?a))
                    (at start (not (not_blocked seg_M_A4A7b_0_75 ?a)))
         )
)
(:durative-action startup_seg_M_A4A7d_0_75_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A4A7d_0_75))
                    (over all (not_occupied seg_M_A4A7e_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A4A7e_0_75 ?a))
                    (at start (not (not_blocked seg_M_A4A7e_0_75 ?a)))
         )
)
(:durative-action startup_seg_M_A4A7d_0_75_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A4A7d_0_75))
                    (over all (not_occupied seg_M_A4A7c_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A4A7c_0_75 ?a))
                    (at start (not (not_blocked seg_M_A4A7c_0_75 ?a)))
         )
)
(:durative-action startup_seg_M_A4A7e_0_75_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A4A7e_0_75))
                    (over all (not_occupied seg_M_A4A7f_0_115))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A4A7f_0_115 ?a))
                    (at start (not (not_blocked seg_M_A4A7f_0_115 ?a)))
         )
)
(:durative-action startup_seg_M_A4A7e_0_75_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A4A7e_0_75))
                    (over all (not_occupied seg_M_A4A7d_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A4A7d_0_75 ?a))
                    (at start (not (not_blocked seg_M_A4A7d_0_75 ?a)))
         )
)
(:durative-action startup_seg_M_A4A7f_0_115_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A4A7f_0_115))
                    (over all (not_occupied seg_M_A7d_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A7d_0_60 ?a))
                    (at start (not (not_blocked seg_M_A7d_0_60 ?a)))
         )
)
(:durative-action startup_seg_M_A4A7f_0_115_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A4A7f_0_115))
                    (over all (not_occupied seg_M_A4A7e_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A4A7e_0_75 ?a))
                    (at start (not (not_blocked seg_M_A4A7e_0_75 ?a)))
         )
)
(:durative-action startup_seg_M_A7a_0_120_934_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A7a_0_120_934))
                    (over all (not_occupied seg_A7_b_0_80_6226))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_A7_b_0_80_6226 ?a))
                    (at start (not (not_blocked seg_A7_b_0_80_6226 ?a)))
         )
)
(:durative-action startup_seg_M_A7a_0_120_934_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A7a_0_120_934))
                    (over all (not_occupied seg_M_A7b_0_60))
                    (over all (not_occupied seg_M_A7c_0_60))
                    (over all (not_occupied seg_M_A7d_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A7b_0_60 ?a))
                    (at start (not (not_blocked seg_M_A7b_0_60 ?a)))
                    (at start (blocked seg_M_A7c_0_60 ?a))
                    (at start (not (not_blocked seg_M_A7c_0_60 ?a)))
                    (at start (blocked seg_M_A7d_0_60 ?a))
                    (at start (not (not_blocked seg_M_A7d_0_60 ?a)))
         )
)
(:durative-action startup_seg_M_A7b_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A7b_0_60))
                    (over all (not_occupied seg_M_A7A6a_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A7A6a_0_75 ?a))
                    (at start (not (not_blocked seg_M_A7A6a_0_75 ?a)))
         )
)
(:durative-action startup_seg_M_A7b_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A7b_0_60))
                    (over all (not_occupied seg_M_A7a_0_120_934))
                    (over all (not_occupied seg_M_A7c_0_60))
                    (over all (not_occupied seg_M_A7d_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A7a_0_120_934 ?a))
                    (at start (not (not_blocked seg_M_A7a_0_120_934 ?a)))
                    (at start (blocked seg_M_A7c_0_60 ?a))
                    (at start (not (not_blocked seg_M_A7c_0_60 ?a)))
                    (at start (blocked seg_M_A7d_0_60 ?a))
                    (at start (not (not_blocked seg_M_A7d_0_60 ?a)))
         )
)
(:durative-action startup_seg_M_A7c_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A7c_0_60))
                    (over all (not_occupied seg_N_A7a_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A7a_0_60 ?a))
                    (at start (not (not_blocked seg_N_A7a_0_60 ?a)))
         )
)
(:durative-action startup_seg_M_A7c_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A7c_0_60))
                    (over all (not_occupied seg_M_A7a_0_120_934))
                    (over all (not_occupied seg_M_A7b_0_60))
                    (over all (not_occupied seg_M_A7d_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A7a_0_120_934 ?a))
                    (at start (not (not_blocked seg_M_A7a_0_120_934 ?a)))
                    (at start (blocked seg_M_A7b_0_60 ?a))
                    (at start (not (not_blocked seg_M_A7b_0_60 ?a)))
                    (at start (blocked seg_M_A7d_0_60 ?a))
                    (at start (not (not_blocked seg_M_A7d_0_60 ?a)))
         )
)
(:durative-action startup_seg_M_A7d_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A7d_0_60))
                    (over all (not_occupied seg_M_A4A7f_0_115))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A4A7f_0_115 ?a))
                    (at start (not (not_blocked seg_M_A4A7f_0_115 ?a)))
         )
)
(:durative-action startup_seg_M_A7d_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A7d_0_60))
                    (over all (not_occupied seg_M_A7a_0_120_934))
                    (over all (not_occupied seg_M_A7b_0_60))
                    (over all (not_occupied seg_M_A7c_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A7a_0_120_934 ?a))
                    (at start (not (not_blocked seg_M_A7a_0_120_934 ?a)))
                    (at start (blocked seg_M_A7b_0_60 ?a))
                    (at start (not (not_blocked seg_M_A7b_0_60 ?a)))
                    (at start (blocked seg_M_A7c_0_60 ?a))
                    (at start (not (not_blocked seg_M_A7c_0_60 ?a)))
         )
)
(:durative-action startup_seg_A7_b_0_80_6226_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_A7_b_0_80_6226))
                    (over all (not_occupied seg_M_A7a_0_120_934))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A7a_0_120_934 ?a))
                    (at start (not (not_blocked seg_M_A7a_0_120_934 ?a)))
         )
)
(:durative-action startup_seg_A7_b_0_80_6226_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_A7_b_0_80_6226))
                    (over all (not_occupied seg_A7_b_1_0_80_6226))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_A7_b_1_0_80_6226 ?a))
                    (at start (not (not_blocked seg_A7_b_1_0_80_6226 ?a)))
         )
)
(:durative-action startup_seg_M_A7A6a_0_75_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A7A6a_0_75))
                    (over all (not_occupied seg_M_A7A6b_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A7A6b_0_75 ?a))
                    (at start (not (not_blocked seg_M_A7A6b_0_75 ?a)))
         )
)
(:durative-action startup_seg_M_A7A6a_0_75_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A7A6a_0_75))
                    (over all (not_occupied seg_M_A7b_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A7b_0_60 ?a))
                    (at start (not (not_blocked seg_M_A7b_0_60 ?a)))
         )
)
(:durative-action startup_seg_N_A7a_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A7a_0_60))
                    (over all (not_occupied seg_M_A7c_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A7c_0_60 ?a))
                    (at start (not (not_blocked seg_M_A7c_0_60 ?a)))
         )
)
(:durative-action startup_seg_N_A7a_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A7a_0_60))
                    (over all (not_occupied seg_N_A7b_0_60))
                    (over all (not_occupied seg_N_A7c_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A7b_0_60 ?a))
                    (at start (not (not_blocked seg_N_A7b_0_60 ?a)))
                    (at start (blocked seg_N_A7c_0_60 ?a))
                    (at start (not (not_blocked seg_N_A7c_0_60 ?a)))
         )
)
(:durative-action startup_seg_M_A7A6b_0_75_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A7A6b_0_75))
                    (over all (not_occupied seg_M_A7A6c_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A7A6c_0_75 ?a))
                    (at start (not (not_blocked seg_M_A7A6c_0_75 ?a)))
         )
)
(:durative-action startup_seg_M_A7A6b_0_75_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A7A6b_0_75))
                    (over all (not_occupied seg_M_A7A6a_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A7A6a_0_75 ?a))
                    (at start (not (not_blocked seg_M_A7A6a_0_75 ?a)))
         )
)
(:durative-action startup_seg_M_A7A6c_0_75_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A7A6c_0_75))
                    (over all (not_occupied seg_M_A7A6d_0_85))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A7A6d_0_85 ?a))
                    (at start (not (not_blocked seg_M_A7A6d_0_85 ?a)))
         )
)
(:durative-action startup_seg_M_A7A6c_0_75_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A7A6c_0_75))
                    (over all (not_occupied seg_M_A7A6b_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A7A6b_0_75 ?a))
                    (at start (not (not_blocked seg_M_A7A6b_0_75 ?a)))
         )
)
(:durative-action startup_seg_M_A7A6d_0_85_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A7A6d_0_85))
                    (over all (not_occupied seg_M_A6c_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A6c_0_60 ?a))
                    (at start (not (not_blocked seg_M_A6c_0_60 ?a)))
         )
)
(:durative-action startup_seg_M_A7A6d_0_85_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A7A6d_0_85))
                    (over all (not_occupied seg_M_A7A6c_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A7A6c_0_75 ?a))
                    (at start (not (not_blocked seg_M_A7A6c_0_75 ?a)))
         )
)
(:durative-action startup_seg_M_A6a_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A6a_0_60))
                    (over all (not_occupied seg_M_A6A8a_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A6A8a_0_75 ?a))
                    (at start (not (not_blocked seg_M_A6A8a_0_75 ?a)))
         )
)
(:durative-action startup_seg_M_A6a_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A6a_0_60))
                    (over all (not_occupied seg_M_A6b_0_60))
                    (over all (not_occupied seg_M_A6c_0_60))
                    (over all (not_occupied seg_M_A6d_0_120_934))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A6b_0_60 ?a))
                    (at start (not (not_blocked seg_M_A6b_0_60 ?a)))
                    (at start (blocked seg_M_A6c_0_60 ?a))
                    (at start (not (not_blocked seg_M_A6c_0_60 ?a)))
                    (at start (blocked seg_M_A6d_0_120_934 ?a))
                    (at start (not (not_blocked seg_M_A6d_0_120_934 ?a)))
         )
)
(:durative-action startup_seg_M_A6b_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A6b_0_60))
                    (over all (not_occupied seg_N_A6a_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A6a_0_60 ?a))
                    (at start (not (not_blocked seg_N_A6a_0_60 ?a)))
         )
)
(:durative-action startup_seg_M_A6b_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A6b_0_60))
                    (over all (not_occupied seg_M_A6a_0_60))
                    (over all (not_occupied seg_M_A6c_0_60))
                    (over all (not_occupied seg_M_A6d_0_120_934))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A6a_0_60 ?a))
                    (at start (not (not_blocked seg_M_A6a_0_60 ?a)))
                    (at start (blocked seg_M_A6c_0_60 ?a))
                    (at start (not (not_blocked seg_M_A6c_0_60 ?a)))
                    (at start (blocked seg_M_A6d_0_120_934 ?a))
                    (at start (not (not_blocked seg_M_A6d_0_120_934 ?a)))
         )
)
(:durative-action startup_seg_M_A6c_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A6c_0_60))
                    (over all (not_occupied seg_M_A7A6d_0_85))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A7A6d_0_85 ?a))
                    (at start (not (not_blocked seg_M_A7A6d_0_85 ?a)))
         )
)
(:durative-action startup_seg_M_A6c_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A6c_0_60))
                    (over all (not_occupied seg_M_A6a_0_60))
                    (over all (not_occupied seg_M_A6b_0_60))
                    (over all (not_occupied seg_M_A6d_0_120_934))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A6a_0_60 ?a))
                    (at start (not (not_blocked seg_M_A6a_0_60 ?a)))
                    (at start (blocked seg_M_A6b_0_60 ?a))
                    (at start (not (not_blocked seg_M_A6b_0_60 ?a)))
                    (at start (blocked seg_M_A6d_0_120_934 ?a))
                    (at start (not (not_blocked seg_M_A6d_0_120_934 ?a)))
         )
)
(:durative-action startup_seg_M_A6d_0_120_934_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A6d_0_120_934))
                    (over all (not_occupied seg_A6_b_0_159_512))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_A6_b_0_159_512 ?a))
                    (at start (not (not_blocked seg_A6_b_0_159_512 ?a)))
         )
)
(:durative-action startup_seg_M_A6d_0_120_934_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A6d_0_120_934))
                    (over all (not_occupied seg_M_A6a_0_60))
                    (over all (not_occupied seg_M_A6b_0_60))
                    (over all (not_occupied seg_M_A6c_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A6a_0_60 ?a))
                    (at start (not (not_blocked seg_M_A6a_0_60 ?a)))
                    (at start (blocked seg_M_A6b_0_60 ?a))
                    (at start (not (not_blocked seg_M_A6b_0_60 ?a)))
                    (at start (blocked seg_M_A6c_0_60 ?a))
                    (at start (not (not_blocked seg_M_A6c_0_60 ?a)))
         )
)
(:durative-action startup_seg_M_A6A8a_0_75_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A6A8a_0_75))
                    (over all (not_occupied seg_M_A6A8b_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A6A8b_0_75 ?a))
                    (at start (not (not_blocked seg_M_A6A8b_0_75 ?a)))
         )
)
(:durative-action startup_seg_M_A6A8a_0_75_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A6A8a_0_75))
                    (over all (not_occupied seg_M_A6a_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A6a_0_60 ?a))
                    (at start (not (not_blocked seg_M_A6a_0_60 ?a)))
         )
)
(:durative-action startup_seg_N_A6a_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A6a_0_60))
                    (over all (not_occupied seg_M_A6b_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A6b_0_60 ?a))
                    (at start (not (not_blocked seg_M_A6b_0_60 ?a)))
         )
)
(:durative-action startup_seg_N_A6a_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A6a_0_60))
                    (over all (not_occupied seg_N_A6b_0_60))
                    (over all (not_occupied seg_N_A6c_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A6b_0_60 ?a))
                    (at start (not (not_blocked seg_N_A6b_0_60 ?a)))
                    (at start (blocked seg_N_A6c_0_60 ?a))
                    (at start (not (not_blocked seg_N_A6c_0_60 ?a)))
         )
)
(:durative-action startup_seg_A6_b_0_159_512_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_A6_b_0_159_512))
                    (over all (not_occupied seg_M_A6d_0_120_934))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A6d_0_120_934 ?a))
                    (at start (not (not_blocked seg_M_A6d_0_120_934 ?a)))
         )
)
(:durative-action startup_seg_A6_b_0_159_512_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_A6_b_0_159_512))
                    (over all (not_occupied seg_A6_a_0_158_647))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_A6_a_0_158_647 ?a))
                    (at start (not (not_blocked seg_A6_a_0_158_647 ?a)))
         )
)
(:durative-action startup_seg_M_A6A8b_0_75_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A6A8b_0_75))
                    (over all (not_occupied seg_M_A6A8c_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A6A8c_0_75 ?a))
                    (at start (not (not_blocked seg_M_A6A8c_0_75 ?a)))
         )
)
(:durative-action startup_seg_M_A6A8b_0_75_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A6A8b_0_75))
                    (over all (not_occupied seg_M_A6A8a_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A6A8a_0_75 ?a))
                    (at start (not (not_blocked seg_M_A6A8a_0_75 ?a)))
         )
)
(:durative-action startup_seg_M_A6A8c_0_75_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A6A8c_0_75))
                    (over all (not_occupied seg_M_A6A8d_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A6A8d_0_75 ?a))
                    (at start (not (not_blocked seg_M_A6A8d_0_75 ?a)))
         )
)
(:durative-action startup_seg_M_A6A8c_0_75_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A6A8c_0_75))
                    (over all (not_occupied seg_M_A6A8b_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A6A8b_0_75 ?a))
                    (at start (not (not_blocked seg_M_A6A8b_0_75 ?a)))
         )
)
(:durative-action startup_seg_M_A6A8d_0_75_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A6A8d_0_75))
                    (over all (not_occupied seg_M_A6A8e_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A6A8e_0_75 ?a))
                    (at start (not (not_blocked seg_M_A6A8e_0_75 ?a)))
         )
)
(:durative-action startup_seg_M_A6A8d_0_75_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A6A8d_0_75))
                    (over all (not_occupied seg_M_A6A8c_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A6A8c_0_75 ?a))
                    (at start (not (not_blocked seg_M_A6A8c_0_75 ?a)))
         )
)
(:durative-action startup_seg_M_A6A8e_0_75_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A6A8e_0_75))
                    (over all (not_occupied seg_M_A6A8f_0_115))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A6A8f_0_115 ?a))
                    (at start (not (not_blocked seg_M_A6A8f_0_115 ?a)))
         )
)
(:durative-action startup_seg_M_A6A8e_0_75_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A6A8e_0_75))
                    (over all (not_occupied seg_M_A6A8d_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A6A8d_0_75 ?a))
                    (at start (not (not_blocked seg_M_A6A8d_0_75 ?a)))
         )
)
(:durative-action startup_seg_M_A6A8f_0_115_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A6A8f_0_115))
                    (over all (not_occupied seg_M_A8c_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A8c_0_60 ?a))
                    (at start (not (not_blocked seg_M_A8c_0_60 ?a)))
         )
)
(:durative-action startup_seg_M_A6A8f_0_115_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A6A8f_0_115))
                    (over all (not_occupied seg_M_A6A8e_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A6A8e_0_75 ?a))
                    (at start (not (not_blocked seg_M_A6A8e_0_75 ?a)))
         )
)
(:durative-action startup_seg_M_A8a_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A8a_0_60))
                    (over all (not_occupied seg_M_A8A9a_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A8A9a_0_75 ?a))
                    (at start (not (not_blocked seg_M_A8A9a_0_75 ?a)))
         )
)
(:durative-action startup_seg_M_A8a_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A8a_0_60))
                    (over all (not_occupied seg_M_A8b_0_60))
                    (over all (not_occupied seg_M_A8c_0_60))
                    (over all (not_occupied seg_M_A8d_0_120_934))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A8b_0_60 ?a))
                    (at start (not (not_blocked seg_M_A8b_0_60 ?a)))
                    (at start (blocked seg_M_A8c_0_60 ?a))
                    (at start (not (not_blocked seg_M_A8c_0_60 ?a)))
                    (at start (blocked seg_M_A8d_0_120_934 ?a))
                    (at start (not (not_blocked seg_M_A8d_0_120_934 ?a)))
         )
)
(:durative-action startup_seg_M_A8b_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A8b_0_60))
                    (over all (not_occupied seg_N_A8a_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A8a_0_60 ?a))
                    (at start (not (not_blocked seg_N_A8a_0_60 ?a)))
         )
)
(:durative-action startup_seg_M_A8b_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A8b_0_60))
                    (over all (not_occupied seg_M_A8a_0_60))
                    (over all (not_occupied seg_M_A8c_0_60))
                    (over all (not_occupied seg_M_A8d_0_120_934))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A8a_0_60 ?a))
                    (at start (not (not_blocked seg_M_A8a_0_60 ?a)))
                    (at start (blocked seg_M_A8c_0_60 ?a))
                    (at start (not (not_blocked seg_M_A8c_0_60 ?a)))
                    (at start (blocked seg_M_A8d_0_120_934 ?a))
                    (at start (not (not_blocked seg_M_A8d_0_120_934 ?a)))
         )
)
(:durative-action startup_seg_M_A8c_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A8c_0_60))
                    (over all (not_occupied seg_M_A6A8f_0_115))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A6A8f_0_115 ?a))
                    (at start (not (not_blocked seg_M_A6A8f_0_115 ?a)))
         )
)
(:durative-action startup_seg_M_A8c_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A8c_0_60))
                    (over all (not_occupied seg_M_A8a_0_60))
                    (over all (not_occupied seg_M_A8b_0_60))
                    (over all (not_occupied seg_M_A8d_0_120_934))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A8a_0_60 ?a))
                    (at start (not (not_blocked seg_M_A8a_0_60 ?a)))
                    (at start (blocked seg_M_A8b_0_60 ?a))
                    (at start (not (not_blocked seg_M_A8b_0_60 ?a)))
                    (at start (blocked seg_M_A8d_0_120_934 ?a))
                    (at start (not (not_blocked seg_M_A8d_0_120_934 ?a)))
         )
)
(:durative-action startup_seg_M_A8d_0_120_934_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A8d_0_120_934))
                    (over all (not_occupied seg_A8_b_0_80_6226))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_A8_b_0_80_6226 ?a))
                    (at start (not (not_blocked seg_A8_b_0_80_6226 ?a)))
         )
)
(:durative-action startup_seg_M_A8d_0_120_934_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A8d_0_120_934))
                    (over all (not_occupied seg_M_A8a_0_60))
                    (over all (not_occupied seg_M_A8b_0_60))
                    (over all (not_occupied seg_M_A8c_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A8a_0_60 ?a))
                    (at start (not (not_blocked seg_M_A8a_0_60 ?a)))
                    (at start (blocked seg_M_A8b_0_60 ?a))
                    (at start (not (not_blocked seg_M_A8b_0_60 ?a)))
                    (at start (blocked seg_M_A8c_0_60 ?a))
                    (at start (not (not_blocked seg_M_A8c_0_60 ?a)))
         )
)
(:durative-action startup_seg_M_A8A9a_0_75_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A8A9a_0_75))
                    (over all (not_occupied seg_M_A8A9b_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A8A9b_0_75 ?a))
                    (at start (not (not_blocked seg_M_A8A9b_0_75 ?a)))
         )
)
(:durative-action startup_seg_M_A8A9a_0_75_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A8A9a_0_75))
                    (over all (not_occupied seg_M_A8a_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A8a_0_60 ?a))
                    (at start (not (not_blocked seg_M_A8a_0_60 ?a)))
         )
)
(:durative-action startup_seg_N_A8a_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A8a_0_60))
                    (over all (not_occupied seg_M_A8b_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A8b_0_60 ?a))
                    (at start (not (not_blocked seg_M_A8b_0_60 ?a)))
         )
)
(:durative-action startup_seg_N_A8a_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A8a_0_60))
                    (over all (not_occupied seg_N_A8b_0_60))
                    (over all (not_occupied seg_N_A8c_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A8b_0_60 ?a))
                    (at start (not (not_blocked seg_N_A8b_0_60 ?a)))
                    (at start (blocked seg_N_A8c_0_60 ?a))
                    (at start (not (not_blocked seg_N_A8c_0_60 ?a)))
         )
)
(:durative-action startup_seg_A8_b_0_80_6226_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_A8_b_0_80_6226))
                    (over all (not_occupied seg_M_A8d_0_120_934))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A8d_0_120_934 ?a))
                    (at start (not (not_blocked seg_M_A8d_0_120_934 ?a)))
         )
)
(:durative-action startup_seg_A8_b_0_80_6226_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_A8_b_0_80_6226))
                    (over all (not_occupied seg_A8_b_1_0_79_7559))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_A8_b_1_0_79_7559 ?a))
                    (at start (not (not_blocked seg_A8_b_1_0_79_7559 ?a)))
         )
)
(:durative-action startup_seg_M_A8A9b_0_75_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A8A9b_0_75))
                    (over all (not_occupied seg_M_A8A9c_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A8A9c_0_75 ?a))
                    (at start (not (not_blocked seg_M_A8A9c_0_75 ?a)))
         )
)
(:durative-action startup_seg_M_A8A9b_0_75_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A8A9b_0_75))
                    (over all (not_occupied seg_M_A8A9a_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A8A9a_0_75 ?a))
                    (at start (not (not_blocked seg_M_A8A9a_0_75 ?a)))
         )
)
(:durative-action startup_seg_M_A8A9c_0_75_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A8A9c_0_75))
                    (over all (not_occupied seg_M_A8A9d_0_85))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A8A9d_0_85 ?a))
                    (at start (not (not_blocked seg_M_A8A9d_0_85 ?a)))
         )
)
(:durative-action startup_seg_M_A8A9c_0_75_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A8A9c_0_75))
                    (over all (not_occupied seg_M_A8A9b_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A8A9b_0_75 ?a))
                    (at start (not (not_blocked seg_M_A8A9b_0_75 ?a)))
         )
)
(:durative-action startup_seg_M_A8A9d_0_85_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A8A9d_0_85))
                    (over all (not_occupied seg_M_A9c_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A9c_0_60 ?a))
                    (at start (not (not_blocked seg_M_A9c_0_60 ?a)))
         )
)
(:durative-action startup_seg_M_A8A9d_0_85_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A8A9d_0_85))
                    (over all (not_occupied seg_M_A8A9c_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A8A9c_0_75 ?a))
                    (at start (not (not_blocked seg_M_A8A9c_0_75 ?a)))
         )
)
(:durative-action startup_seg_M_A9a_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A9a_0_60))
                    (over all (not_occupied seg_M_A9A10a_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A9A10a_0_75 ?a))
                    (at start (not (not_blocked seg_M_A9A10a_0_75 ?a)))
         )
)
(:durative-action startup_seg_M_A9a_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A9a_0_60))
                    (over all (not_occupied seg_M_A9b_0_60))
                    (over all (not_occupied seg_M_A9c_0_60))
                    (over all (not_occupied seg_M_A9d_0_120_934))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A9b_0_60 ?a))
                    (at start (not (not_blocked seg_M_A9b_0_60 ?a)))
                    (at start (blocked seg_M_A9c_0_60 ?a))
                    (at start (not (not_blocked seg_M_A9c_0_60 ?a)))
                    (at start (blocked seg_M_A9d_0_120_934 ?a))
                    (at start (not (not_blocked seg_M_A9d_0_120_934 ?a)))
         )
)
(:durative-action startup_seg_M_A9b_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A9b_0_60))
                    (over all (not_occupied seg_N_A9a_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A9a_0_60 ?a))
                    (at start (not (not_blocked seg_N_A9a_0_60 ?a)))
         )
)
(:durative-action startup_seg_M_A9b_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A9b_0_60))
                    (over all (not_occupied seg_M_A9a_0_60))
                    (over all (not_occupied seg_M_A9c_0_60))
                    (over all (not_occupied seg_M_A9d_0_120_934))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A9a_0_60 ?a))
                    (at start (not (not_blocked seg_M_A9a_0_60 ?a)))
                    (at start (blocked seg_M_A9c_0_60 ?a))
                    (at start (not (not_blocked seg_M_A9c_0_60 ?a)))
                    (at start (blocked seg_M_A9d_0_120_934 ?a))
                    (at start (not (not_blocked seg_M_A9d_0_120_934 ?a)))
         )
)
(:durative-action startup_seg_M_A9c_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A9c_0_60))
                    (over all (not_occupied seg_M_A8A9d_0_85))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A8A9d_0_85 ?a))
                    (at start (not (not_blocked seg_M_A8A9d_0_85 ?a)))
         )
)
(:durative-action startup_seg_M_A9c_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A9c_0_60))
                    (over all (not_occupied seg_M_A9a_0_60))
                    (over all (not_occupied seg_M_A9b_0_60))
                    (over all (not_occupied seg_M_A9d_0_120_934))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A9a_0_60 ?a))
                    (at start (not (not_blocked seg_M_A9a_0_60 ?a)))
                    (at start (blocked seg_M_A9b_0_60 ?a))
                    (at start (not (not_blocked seg_M_A9b_0_60 ?a)))
                    (at start (blocked seg_M_A9d_0_120_934 ?a))
                    (at start (not (not_blocked seg_M_A9d_0_120_934 ?a)))
         )
)
(:durative-action startup_seg_M_A9d_0_120_934_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A9d_0_120_934))
                    (over all (not_occupied seg_A9_b_0_159_512))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_A9_b_0_159_512 ?a))
                    (at start (not (not_blocked seg_A9_b_0_159_512 ?a)))
         )
)
(:durative-action startup_seg_M_A9d_0_120_934_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A9d_0_120_934))
                    (over all (not_occupied seg_M_A9a_0_60))
                    (over all (not_occupied seg_M_A9b_0_60))
                    (over all (not_occupied seg_M_A9c_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A9a_0_60 ?a))
                    (at start (not (not_blocked seg_M_A9a_0_60 ?a)))
                    (at start (blocked seg_M_A9b_0_60 ?a))
                    (at start (not (not_blocked seg_M_A9b_0_60 ?a)))
                    (at start (blocked seg_M_A9c_0_60 ?a))
                    (at start (not (not_blocked seg_M_A9c_0_60 ?a)))
         )
)
(:durative-action startup_seg_M_A9A10a_0_75_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A9A10a_0_75))
                    (over all (not_occupied seg_M_A9A10b_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A9A10b_0_75 ?a))
                    (at start (not (not_blocked seg_M_A9A10b_0_75 ?a)))
         )
)
(:durative-action startup_seg_M_A9A10a_0_75_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A9A10a_0_75))
                    (over all (not_occupied seg_M_A9a_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A9a_0_60 ?a))
                    (at start (not (not_blocked seg_M_A9a_0_60 ?a)))
         )
)
(:durative-action startup_seg_N_A9a_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A9a_0_60))
                    (over all (not_occupied seg_M_A9b_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A9b_0_60 ?a))
                    (at start (not (not_blocked seg_M_A9b_0_60 ?a)))
         )
)
(:durative-action startup_seg_N_A9a_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A9a_0_60))
                    (over all (not_occupied seg_N_A9b_0_60))
                    (over all (not_occupied seg_N_A9c_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A9b_0_60 ?a))
                    (at start (not (not_blocked seg_N_A9b_0_60 ?a)))
                    (at start (blocked seg_N_A9c_0_60 ?a))
                    (at start (not (not_blocked seg_N_A9c_0_60 ?a)))
         )
)
(:durative-action startup_seg_A9_b_0_159_512_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_A9_b_0_159_512))
                    (over all (not_occupied seg_M_A9d_0_120_934))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A9d_0_120_934 ?a))
                    (at start (not (not_blocked seg_M_A9d_0_120_934 ?a)))
         )
)
(:durative-action startup_seg_A9_b_0_159_512_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_A9_b_0_159_512))
                    (over all (not_occupied seg_A9_a_0_158_647))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_A9_a_0_158_647 ?a))
                    (at start (not (not_blocked seg_A9_a_0_158_647 ?a)))
         )
)
(:durative-action startup_seg_M_A9A10b_0_75_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A9A10b_0_75))
                    (over all (not_occupied seg_M_A9A10c_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A9A10c_0_75 ?a))
                    (at start (not (not_blocked seg_M_A9A10c_0_75 ?a)))
         )
)
(:durative-action startup_seg_M_A9A10b_0_75_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A9A10b_0_75))
                    (over all (not_occupied seg_M_A9A10a_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A9A10a_0_75 ?a))
                    (at start (not (not_blocked seg_M_A9A10a_0_75 ?a)))
         )
)
(:durative-action startup_seg_M_A9A10c_0_75_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A9A10c_0_75))
                    (over all (not_occupied seg_M_A9A10d_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A9A10d_0_75 ?a))
                    (at start (not (not_blocked seg_M_A9A10d_0_75 ?a)))
         )
)
(:durative-action startup_seg_M_A9A10c_0_75_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A9A10c_0_75))
                    (over all (not_occupied seg_M_A9A10b_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A9A10b_0_75 ?a))
                    (at start (not (not_blocked seg_M_A9A10b_0_75 ?a)))
         )
)
(:durative-action startup_seg_M_A9A10d_0_75_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A9A10d_0_75))
                    (over all (not_occupied seg_M_A9A10e_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A9A10e_0_75 ?a))
                    (at start (not (not_blocked seg_M_A9A10e_0_75 ?a)))
         )
)
(:durative-action startup_seg_M_A9A10d_0_75_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A9A10d_0_75))
                    (over all (not_occupied seg_M_A9A10c_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A9A10c_0_75 ?a))
                    (at start (not (not_blocked seg_M_A9A10c_0_75 ?a)))
         )
)
(:durative-action startup_seg_M_A9A10e_0_75_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A9A10e_0_75))
                    (over all (not_occupied seg_M_A9A10f_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A9A10f_0_75 ?a))
                    (at start (not (not_blocked seg_M_A9A10f_0_75 ?a)))
         )
)
(:durative-action startup_seg_M_A9A10e_0_75_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A9A10e_0_75))
                    (over all (not_occupied seg_M_A9A10d_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A9A10d_0_75 ?a))
                    (at start (not (not_blocked seg_M_A9A10d_0_75 ?a)))
         )
)
(:durative-action startup_seg_M_A9A10f_0_75_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A9A10f_0_75))
                    (over all (not_occupied seg_M_A9A10g_0_80))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A9A10g_0_80 ?a))
                    (at start (not (not_blocked seg_M_A9A10g_0_80 ?a)))
         )
)
(:durative-action startup_seg_M_A9A10f_0_75_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A9A10f_0_75))
                    (over all (not_occupied seg_M_A9A10e_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A9A10e_0_75 ?a))
                    (at start (not (not_blocked seg_M_A9A10e_0_75 ?a)))
         )
)
(:durative-action startup_seg_M_A9A10g_0_80_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A9A10g_0_80))
                    (over all (not_occupied seg_M_A10c_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A10c_0_60 ?a))
                    (at start (not (not_blocked seg_M_A10c_0_60 ?a)))
         )
)
(:durative-action startup_seg_M_A9A10g_0_80_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A9A10g_0_80))
                    (over all (not_occupied seg_M_A9A10f_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A9A10f_0_75 ?a))
                    (at start (not (not_blocked seg_M_A9A10f_0_75 ?a)))
         )
)
(:durative-action startup_seg_M_A10a_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A10a_0_60))
                    (over all (not_occupied seg_A10_0_80))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_A10_0_80 ?a))
                    (at start (not (not_blocked seg_A10_0_80 ?a)))
         )
)
(:durative-action startup_seg_M_A10a_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A10a_0_60))
                    (over all (not_occupied seg_M_A10b_0_60))
                    (over all (not_occupied seg_M_A10c_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A10b_0_60 ?a))
                    (at start (not (not_blocked seg_M_A10b_0_60 ?a)))
                    (at start (blocked seg_M_A10c_0_60 ?a))
                    (at start (not (not_blocked seg_M_A10c_0_60 ?a)))
         )
)
(:durative-action startup_seg_M_A10b_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A10b_0_60))
                    (over all (not_occupied seg_N_A10a_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A10a_0_60 ?a))
                    (at start (not (not_blocked seg_N_A10a_0_60 ?a)))
         )
)
(:durative-action startup_seg_M_A10b_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A10b_0_60))
                    (over all (not_occupied seg_M_A10a_0_60))
                    (over all (not_occupied seg_M_A10c_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A10a_0_60 ?a))
                    (at start (not (not_blocked seg_M_A10a_0_60 ?a)))
                    (at start (blocked seg_M_A10c_0_60 ?a))
                    (at start (not (not_blocked seg_M_A10c_0_60 ?a)))
         )
)
(:durative-action startup_seg_M_A10c_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A10c_0_60))
                    (over all (not_occupied seg_M_A9A10g_0_80))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A9A10g_0_80 ?a))
                    (at start (not (not_blocked seg_M_A9A10g_0_80 ?a)))
         )
)
(:durative-action startup_seg_M_A10c_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_M_A10c_0_60))
                    (over all (not_occupied seg_M_A10a_0_60))
                    (over all (not_occupied seg_M_A10b_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A10a_0_60 ?a))
                    (at start (not (not_blocked seg_M_A10a_0_60 ?a)))
                    (at start (blocked seg_M_A10b_0_60 ?a))
                    (at start (not (not_blocked seg_M_A10b_0_60 ?a)))
         )
)
(:durative-action startup_seg_A10_0_80_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_A10_0_80))
                    (over all (not_occupied seg_M_A10a_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A10a_0_60 ?a))
                    (at start (not (not_blocked seg_M_A10a_0_60 ?a)))
         )
)
(:durative-action startup_seg_A10_0_80_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_A10_0_80))
                    (over all (not_occupied seg_A10_1_0_80))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_A10_1_0_80 ?a))
                    (at start (not (not_blocked seg_A10_1_0_80 ?a)))
         )
)
(:durative-action startup_seg_N_A10a_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A10a_0_60))
                    (over all (not_occupied seg_M_A10b_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_M_A10b_0_60 ?a))
                    (at start (not (not_blocked seg_M_A10b_0_60 ?a)))
         )
)
(:durative-action startup_seg_N_A10a_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A10a_0_60))
                    (over all (not_occupied seg_N_A10b_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A10b_0_60 ?a))
                    (at start (not (not_blocked seg_N_A10b_0_60 ?a)))
         )
)
(:durative-action startup_seg_N_A2a_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A2a_0_60))
                    (over all (not_occupied seg_A2_c_0_100))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_A2_c_0_100 ?a))
                    (at start (not (not_blocked seg_A2_c_0_100 ?a)))
         )
)
(:durative-action startup_seg_N_A2a_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A2a_0_60))
                    (over all (not_occupied seg_N_A2b_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A2b_0_60 ?a))
                    (at start (not (not_blocked seg_N_A2b_0_60 ?a)))
         )
)
(:durative-action startup_seg_N_A2b_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A2b_0_60))
                    (over all (not_occupied seg_N_A2A3a_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A2A3a_0_75 ?a))
                    (at start (not (not_blocked seg_N_A2A3a_0_75 ?a)))
         )
)
(:durative-action startup_seg_N_A2b_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A2b_0_60))
                    (over all (not_occupied seg_N_A2a_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A2a_0_60 ?a))
                    (at start (not (not_blocked seg_N_A2a_0_60 ?a)))
         )
)
(:durative-action startup_seg_A2_c_0_100_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_A2_c_0_100))
                    (over all (not_occupied seg_N_A2a_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A2a_0_60 ?a))
                    (at start (not (not_blocked seg_N_A2a_0_60 ?a)))
         )
)
(:durative-action startup_seg_A2_c_0_100_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_A2_c_0_100))
                    (over all (not_occupied seg_A2_b_0_90))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_A2_b_0_90 ?a))
                    (at start (not (not_blocked seg_A2_b_0_90 ?a)))
         )
)
(:durative-action startup_seg_N_A2A3a_0_75_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A2A3a_0_75))
                    (over all (not_occupied seg_N_A2A3b_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A2A3b_0_75 ?a))
                    (at start (not (not_blocked seg_N_A2A3b_0_75 ?a)))
         )
)
(:durative-action startup_seg_N_A2A3a_0_75_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A2A3a_0_75))
                    (over all (not_occupied seg_N_A2b_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A2b_0_60 ?a))
                    (at start (not (not_blocked seg_N_A2b_0_60 ?a)))
         )
)
(:durative-action startup_seg_N_A2A3b_0_75_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A2A3b_0_75))
                    (over all (not_occupied seg_N_A2A3c_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A2A3c_0_75 ?a))
                    (at start (not (not_blocked seg_N_A2A3c_0_75 ?a)))
         )
)
(:durative-action startup_seg_N_A2A3b_0_75_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A2A3b_0_75))
                    (over all (not_occupied seg_N_A2A3a_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A2A3a_0_75 ?a))
                    (at start (not (not_blocked seg_N_A2A3a_0_75 ?a)))
         )
)
(:durative-action startup_seg_N_A2A3c_0_75_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A2A3c_0_75))
                    (over all (not_occupied seg_N_A2A3d_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A2A3d_0_75 ?a))
                    (at start (not (not_blocked seg_N_A2A3d_0_75 ?a)))
         )
)
(:durative-action startup_seg_N_A2A3c_0_75_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A2A3c_0_75))
                    (over all (not_occupied seg_N_A2A3b_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A2A3b_0_75 ?a))
                    (at start (not (not_blocked seg_N_A2A3b_0_75 ?a)))
         )
)
(:durative-action startup_seg_N_A2A3d_0_75_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A2A3d_0_75))
                    (over all (not_occupied seg_N_A2A3e_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A2A3e_0_75 ?a))
                    (at start (not (not_blocked seg_N_A2A3e_0_75 ?a)))
         )
)
(:durative-action startup_seg_N_A2A3d_0_75_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A2A3d_0_75))
                    (over all (not_occupied seg_N_A2A3c_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A2A3c_0_75 ?a))
                    (at start (not (not_blocked seg_N_A2A3c_0_75 ?a)))
         )
)
(:durative-action startup_seg_N_A2A3e_0_75_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A2A3e_0_75))
                    (over all (not_occupied seg_N_A2A3f_0_115))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A2A3f_0_115 ?a))
                    (at start (not (not_blocked seg_N_A2A3f_0_115 ?a)))
         )
)
(:durative-action startup_seg_N_A2A3e_0_75_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A2A3e_0_75))
                    (over all (not_occupied seg_N_A2A3d_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A2A3d_0_75 ?a))
                    (at start (not (not_blocked seg_N_A2A3d_0_75 ?a)))
         )
)
(:durative-action startup_seg_N_A2A3f_0_115_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A2A3f_0_115))
                    (over all (not_occupied seg_N_A3d_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A3d_0_60 ?a))
                    (at start (not (not_blocked seg_N_A3d_0_60 ?a)))
         )
)
(:durative-action startup_seg_N_A2A3f_0_115_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A2A3f_0_115))
                    (over all (not_occupied seg_N_A2A3e_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A2A3e_0_75 ?a))
                    (at start (not (not_blocked seg_N_A2A3e_0_75 ?a)))
         )
)
(:durative-action startup_seg_N_A3b_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A3b_0_60))
                    (over all (not_occupied seg_N_N2c_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_N2c_0_60 ?a))
                    (at start (not (not_blocked seg_N_N2c_0_60 ?a)))
         )
)
(:durative-action startup_seg_N_A3b_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A3b_0_60))
                    (over all (not_occupied seg_N_A3a_0_60))
                    (over all (not_occupied seg_N_A3c_0_60))
                    (over all (not_occupied seg_N_A3d_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A3a_0_60 ?a))
                    (at start (not (not_blocked seg_N_A3a_0_60 ?a)))
                    (at start (blocked seg_N_A3c_0_60 ?a))
                    (at start (not (not_blocked seg_N_A3c_0_60 ?a)))
                    (at start (blocked seg_N_A3d_0_60 ?a))
                    (at start (not (not_blocked seg_N_A3d_0_60 ?a)))
         )
)
(:durative-action startup_seg_N_A3c_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A3c_0_60))
                    (over all (not_occupied seg_N1_0_108))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N1_0_108 ?a))
                    (at start (not (not_blocked seg_N1_0_108 ?a)))
         )
)
(:durative-action startup_seg_N_A3c_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A3c_0_60))
                    (over all (not_occupied seg_N_A3a_0_60))
                    (over all (not_occupied seg_N_A3b_0_60))
                    (over all (not_occupied seg_N_A3d_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A3a_0_60 ?a))
                    (at start (not (not_blocked seg_N_A3a_0_60 ?a)))
                    (at start (blocked seg_N_A3b_0_60 ?a))
                    (at start (not (not_blocked seg_N_A3b_0_60 ?a)))
                    (at start (blocked seg_N_A3d_0_60 ?a))
                    (at start (not (not_blocked seg_N_A3d_0_60 ?a)))
         )
)
(:durative-action startup_seg_N_A3d_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A3d_0_60))
                    (over all (not_occupied seg_N_A2A3f_0_115))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A2A3f_0_115 ?a))
                    (at start (not (not_blocked seg_N_A2A3f_0_115 ?a)))
         )
)
(:durative-action startup_seg_N_A3d_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A3d_0_60))
                    (over all (not_occupied seg_N_A3a_0_60))
                    (over all (not_occupied seg_N_A3b_0_60))
                    (over all (not_occupied seg_N_A3c_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A3a_0_60 ?a))
                    (at start (not (not_blocked seg_N_A3a_0_60 ?a)))
                    (at start (blocked seg_N_A3b_0_60 ?a))
                    (at start (not (not_blocked seg_N_A3b_0_60 ?a)))
                    (at start (blocked seg_N_A3c_0_60 ?a))
                    (at start (not (not_blocked seg_N_A3c_0_60 ?a)))
         )
)
(:durative-action startup_seg_N_N2c_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_N2c_0_60))
                    (over all (not_occupied seg_N_A3b_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A3b_0_60 ?a))
                    (at start (not (not_blocked seg_N_A3b_0_60 ?a)))
         )
)
(:durative-action startup_seg_N_N2c_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_N2c_0_60))
                    (over all (not_occupied seg_N_N2a_0_60))
                    (over all (not_occupied seg_N_N2b_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_N2a_0_60 ?a))
                    (at start (not (not_blocked seg_N_N2a_0_60 ?a)))
                    (at start (blocked seg_N_N2b_0_60 ?a))
                    (at start (not (not_blocked seg_N_N2b_0_60 ?a)))
         )
)
(:durative-action startup_seg_N_N2a_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_N2a_0_60))
                    (over all (not_occupied seg_N_N2A4a_0_70))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_N2A4a_0_70 ?a))
                    (at start (not (not_blocked seg_N_N2A4a_0_70 ?a)))
         )
)
(:durative-action startup_seg_N_N2a_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_N2a_0_60))
                    (over all (not_occupied seg_N_N2b_0_60))
                    (over all (not_occupied seg_N_N2c_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_N2b_0_60 ?a))
                    (at start (not (not_blocked seg_N_N2b_0_60 ?a)))
                    (at start (blocked seg_N_N2c_0_60 ?a))
                    (at start (not (not_blocked seg_N_N2c_0_60 ?a)))
         )
)
(:durative-action startup_seg_N_N2b_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_N2b_0_60))
                    (over all (not_occupied seg_N2_0_108))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N2_0_108 ?a))
                    (at start (not (not_blocked seg_N2_0_108 ?a)))
         )
)
(:durative-action startup_seg_N_N2b_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_N2b_0_60))
                    (over all (not_occupied seg_N_N2a_0_60))
                    (over all (not_occupied seg_N_N2c_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_N2a_0_60 ?a))
                    (at start (not (not_blocked seg_N_N2a_0_60 ?a)))
                    (at start (blocked seg_N_N2c_0_60 ?a))
                    (at start (not (not_blocked seg_N_N2c_0_60 ?a)))
         )
)
(:durative-action startup_seg_N_N2A4a_0_70_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_N2A4a_0_70))
                    (over all (not_occupied seg_N_N2A4b_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_N2A4b_0_75 ?a))
                    (at start (not (not_blocked seg_N_N2A4b_0_75 ?a)))
         )
)
(:durative-action startup_seg_N_N2A4a_0_70_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_N2A4a_0_70))
                    (over all (not_occupied seg_N_N2a_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_N2a_0_60 ?a))
                    (at start (not (not_blocked seg_N_N2a_0_60 ?a)))
         )
)
(:durative-action startup_seg_N_N2A4b_0_75_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_N2A4b_0_75))
                    (over all (not_occupied seg_N_N2A4c_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_N2A4c_0_75 ?a))
                    (at start (not (not_blocked seg_N_N2A4c_0_75 ?a)))
         )
)
(:durative-action startup_seg_N_N2A4b_0_75_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_N2A4b_0_75))
                    (over all (not_occupied seg_N_N2A4a_0_70))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_N2A4a_0_70 ?a))
                    (at start (not (not_blocked seg_N_N2A4a_0_70 ?a)))
         )
)
(:durative-action startup_seg_N_N2A4c_0_75_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_N2A4c_0_75))
                    (over all (not_occupied seg_N_N2A4d_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_N2A4d_0_75 ?a))
                    (at start (not (not_blocked seg_N_N2A4d_0_75 ?a)))
         )
)
(:durative-action startup_seg_N_N2A4c_0_75_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_N2A4c_0_75))
                    (over all (not_occupied seg_N_N2A4b_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_N2A4b_0_75 ?a))
                    (at start (not (not_blocked seg_N_N2A4b_0_75 ?a)))
         )
)
(:durative-action startup_seg_N_N2A4d_0_75_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_N2A4d_0_75))
                    (over all (not_occupied seg_N_N2A4e_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_N2A4e_0_75 ?a))
                    (at start (not (not_blocked seg_N_N2A4e_0_75 ?a)))
         )
)
(:durative-action startup_seg_N_N2A4d_0_75_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_N2A4d_0_75))
                    (over all (not_occupied seg_N_N2A4c_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_N2A4c_0_75 ?a))
                    (at start (not (not_blocked seg_N_N2A4c_0_75 ?a)))
         )
)
(:durative-action startup_seg_N_N2A4e_0_75_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_N2A4e_0_75))
                    (over all (not_occupied seg_N_A4c_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A4c_0_60 ?a))
                    (at start (not (not_blocked seg_N_A4c_0_60 ?a)))
         )
)
(:durative-action startup_seg_N_N2A4e_0_75_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_N2A4e_0_75))
                    (over all (not_occupied seg_N_N2A4d_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_N2A4d_0_75 ?a))
                    (at start (not (not_blocked seg_N_N2A4d_0_75 ?a)))
         )
)
(:durative-action startup_seg_N_A4b_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A4b_0_60))
                    (over all (not_occupied seg_N_A4A7a_0_115))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A4A7a_0_115 ?a))
                    (at start (not (not_blocked seg_N_A4A7a_0_115 ?a)))
         )
)
(:durative-action startup_seg_N_A4b_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A4b_0_60))
                    (over all (not_occupied seg_N_A4a_0_60))
                    (over all (not_occupied seg_N_A4c_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A4a_0_60 ?a))
                    (at start (not (not_blocked seg_N_A4a_0_60 ?a)))
                    (at start (blocked seg_N_A4c_0_60 ?a))
                    (at start (not (not_blocked seg_N_A4c_0_60 ?a)))
         )
)
(:durative-action startup_seg_N_A4c_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A4c_0_60))
                    (over all (not_occupied seg_N_N2A4e_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_N2A4e_0_75 ?a))
                    (at start (not (not_blocked seg_N_N2A4e_0_75 ?a)))
         )
)
(:durative-action startup_seg_N_A4c_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A4c_0_60))
                    (over all (not_occupied seg_N_A4a_0_60))
                    (over all (not_occupied seg_N_A4b_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A4a_0_60 ?a))
                    (at start (not (not_blocked seg_N_A4a_0_60 ?a)))
                    (at start (blocked seg_N_A4b_0_60 ?a))
                    (at start (not (not_blocked seg_N_A4b_0_60 ?a)))
         )
)
(:durative-action startup_seg_N_A4A7a_0_115_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A4A7a_0_115))
                    (over all (not_occupied seg_N_A4A7b_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A4A7b_0_75 ?a))
                    (at start (not (not_blocked seg_N_A4A7b_0_75 ?a)))
         )
)
(:durative-action startup_seg_N_A4A7a_0_115_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A4A7a_0_115))
                    (over all (not_occupied seg_N_A4b_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A4b_0_60 ?a))
                    (at start (not (not_blocked seg_N_A4b_0_60 ?a)))
         )
)
(:durative-action startup_seg_N_A4A7b_0_75_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A4A7b_0_75))
                    (over all (not_occupied seg_N_A4A7c_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A4A7c_0_75 ?a))
                    (at start (not (not_blocked seg_N_A4A7c_0_75 ?a)))
         )
)
(:durative-action startup_seg_N_A4A7b_0_75_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A4A7b_0_75))
                    (over all (not_occupied seg_N_A4A7a_0_115))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A4A7a_0_115 ?a))
                    (at start (not (not_blocked seg_N_A4A7a_0_115 ?a)))
         )
)
(:durative-action startup_seg_N_A4A7c_0_75_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A4A7c_0_75))
                    (over all (not_occupied seg_N_A4A7d_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A4A7d_0_75 ?a))
                    (at start (not (not_blocked seg_N_A4A7d_0_75 ?a)))
         )
)
(:durative-action startup_seg_N_A4A7c_0_75_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A4A7c_0_75))
                    (over all (not_occupied seg_N_A4A7b_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A4A7b_0_75 ?a))
                    (at start (not (not_blocked seg_N_A4A7b_0_75 ?a)))
         )
)
(:durative-action startup_seg_N_A4A7d_0_75_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A4A7d_0_75))
                    (over all (not_occupied seg_N_A4A7e_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A4A7e_0_75 ?a))
                    (at start (not (not_blocked seg_N_A4A7e_0_75 ?a)))
         )
)
(:durative-action startup_seg_N_A4A7d_0_75_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A4A7d_0_75))
                    (over all (not_occupied seg_N_A4A7c_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A4A7c_0_75 ?a))
                    (at start (not (not_blocked seg_N_A4A7c_0_75 ?a)))
         )
)
(:durative-action startup_seg_N_A4A7e_0_75_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A4A7e_0_75))
                    (over all (not_occupied seg_N_A4A7f_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A4A7f_0_75 ?a))
                    (at start (not (not_blocked seg_N_A4A7f_0_75 ?a)))
         )
)
(:durative-action startup_seg_N_A4A7e_0_75_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A4A7e_0_75))
                    (over all (not_occupied seg_N_A4A7d_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A4A7d_0_75 ?a))
                    (at start (not (not_blocked seg_N_A4A7d_0_75 ?a)))
         )
)
(:durative-action startup_seg_N_A4A7f_0_75_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A4A7f_0_75))
                    (over all (not_occupied seg_N_A7c_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A7c_0_60 ?a))
                    (at start (not (not_blocked seg_N_A7c_0_60 ?a)))
         )
)
(:durative-action startup_seg_N_A4A7f_0_75_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A4A7f_0_75))
                    (over all (not_occupied seg_N_A4A7e_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A4A7e_0_75 ?a))
                    (at start (not (not_blocked seg_N_A4A7e_0_75 ?a)))
         )
)
(:durative-action startup_seg_N_A7b_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A7b_0_60))
                    (over all (not_occupied seg_N_A7A6a_0_85))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A7A6a_0_85 ?a))
                    (at start (not (not_blocked seg_N_A7A6a_0_85 ?a)))
         )
)
(:durative-action startup_seg_N_A7b_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A7b_0_60))
                    (over all (not_occupied seg_N_A7a_0_60))
                    (over all (not_occupied seg_N_A7c_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A7a_0_60 ?a))
                    (at start (not (not_blocked seg_N_A7a_0_60 ?a)))
                    (at start (blocked seg_N_A7c_0_60 ?a))
                    (at start (not (not_blocked seg_N_A7c_0_60 ?a)))
         )
)
(:durative-action startup_seg_N_A7c_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A7c_0_60))
                    (over all (not_occupied seg_N_A4A7f_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A4A7f_0_75 ?a))
                    (at start (not (not_blocked seg_N_A4A7f_0_75 ?a)))
         )
)
(:durative-action startup_seg_N_A7c_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A7c_0_60))
                    (over all (not_occupied seg_N_A7a_0_60))
                    (over all (not_occupied seg_N_A7b_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A7a_0_60 ?a))
                    (at start (not (not_blocked seg_N_A7a_0_60 ?a)))
                    (at start (blocked seg_N_A7b_0_60 ?a))
                    (at start (not (not_blocked seg_N_A7b_0_60 ?a)))
         )
)
(:durative-action startup_seg_N_A7A6a_0_85_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A7A6a_0_85))
                    (over all (not_occupied seg_N_A7A6b_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A7A6b_0_75 ?a))
                    (at start (not (not_blocked seg_N_A7A6b_0_75 ?a)))
         )
)
(:durative-action startup_seg_N_A7A6a_0_85_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A7A6a_0_85))
                    (over all (not_occupied seg_N_A7b_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A7b_0_60 ?a))
                    (at start (not (not_blocked seg_N_A7b_0_60 ?a)))
         )
)
(:durative-action startup_seg_N_A7A6b_0_75_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A7A6b_0_75))
                    (over all (not_occupied seg_N_A7A6c_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A7A6c_0_75 ?a))
                    (at start (not (not_blocked seg_N_A7A6c_0_75 ?a)))
         )
)
(:durative-action startup_seg_N_A7A6b_0_75_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A7A6b_0_75))
                    (over all (not_occupied seg_N_A7A6a_0_85))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A7A6a_0_85 ?a))
                    (at start (not (not_blocked seg_N_A7A6a_0_85 ?a)))
         )
)
(:durative-action startup_seg_N_A7A6c_0_75_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A7A6c_0_75))
                    (over all (not_occupied seg_N_A7A6d_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A7A6d_0_75 ?a))
                    (at start (not (not_blocked seg_N_A7A6d_0_75 ?a)))
         )
)
(:durative-action startup_seg_N_A7A6c_0_75_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A7A6c_0_75))
                    (over all (not_occupied seg_N_A7A6b_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A7A6b_0_75 ?a))
                    (at start (not (not_blocked seg_N_A7A6b_0_75 ?a)))
         )
)
(:durative-action startup_seg_N_A7A6d_0_75_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A7A6d_0_75))
                    (over all (not_occupied seg_N_A6c_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A6c_0_60 ?a))
                    (at start (not (not_blocked seg_N_A6c_0_60 ?a)))
         )
)
(:durative-action startup_seg_N_A7A6d_0_75_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A7A6d_0_75))
                    (over all (not_occupied seg_N_A7A6c_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A7A6c_0_75 ?a))
                    (at start (not (not_blocked seg_N_A7A6c_0_75 ?a)))
         )
)
(:durative-action startup_seg_N_A6b_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A6b_0_60))
                    (over all (not_occupied seg_N_A6A8a_0_115))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A6A8a_0_115 ?a))
                    (at start (not (not_blocked seg_N_A6A8a_0_115 ?a)))
         )
)
(:durative-action startup_seg_N_A6b_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A6b_0_60))
                    (over all (not_occupied seg_N_A6a_0_60))
                    (over all (not_occupied seg_N_A6c_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A6a_0_60 ?a))
                    (at start (not (not_blocked seg_N_A6a_0_60 ?a)))
                    (at start (blocked seg_N_A6c_0_60 ?a))
                    (at start (not (not_blocked seg_N_A6c_0_60 ?a)))
         )
)
(:durative-action startup_seg_N_A6c_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A6c_0_60))
                    (over all (not_occupied seg_N_A7A6d_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A7A6d_0_75 ?a))
                    (at start (not (not_blocked seg_N_A7A6d_0_75 ?a)))
         )
)
(:durative-action startup_seg_N_A6c_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A6c_0_60))
                    (over all (not_occupied seg_N_A6a_0_60))
                    (over all (not_occupied seg_N_A6b_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A6a_0_60 ?a))
                    (at start (not (not_blocked seg_N_A6a_0_60 ?a)))
                    (at start (blocked seg_N_A6b_0_60 ?a))
                    (at start (not (not_blocked seg_N_A6b_0_60 ?a)))
         )
)
(:durative-action startup_seg_N_A6A8a_0_115_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A6A8a_0_115))
                    (over all (not_occupied seg_N_A6A8b_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A6A8b_0_75 ?a))
                    (at start (not (not_blocked seg_N_A6A8b_0_75 ?a)))
         )
)
(:durative-action startup_seg_N_A6A8a_0_115_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A6A8a_0_115))
                    (over all (not_occupied seg_N_A6b_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A6b_0_60 ?a))
                    (at start (not (not_blocked seg_N_A6b_0_60 ?a)))
         )
)
(:durative-action startup_seg_N_A6A8b_0_75_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A6A8b_0_75))
                    (over all (not_occupied seg_N_A6A8c_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A6A8c_0_75 ?a))
                    (at start (not (not_blocked seg_N_A6A8c_0_75 ?a)))
         )
)
(:durative-action startup_seg_N_A6A8b_0_75_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A6A8b_0_75))
                    (over all (not_occupied seg_N_A6A8a_0_115))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A6A8a_0_115 ?a))
                    (at start (not (not_blocked seg_N_A6A8a_0_115 ?a)))
         )
)
(:durative-action startup_seg_N_A6A8c_0_75_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A6A8c_0_75))
                    (over all (not_occupied seg_N_A6A8d_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A6A8d_0_75 ?a))
                    (at start (not (not_blocked seg_N_A6A8d_0_75 ?a)))
         )
)
(:durative-action startup_seg_N_A6A8c_0_75_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A6A8c_0_75))
                    (over all (not_occupied seg_N_A6A8b_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A6A8b_0_75 ?a))
                    (at start (not (not_blocked seg_N_A6A8b_0_75 ?a)))
         )
)
(:durative-action startup_seg_N_A6A8d_0_75_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A6A8d_0_75))
                    (over all (not_occupied seg_N_A6A8e_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A6A8e_0_75 ?a))
                    (at start (not (not_blocked seg_N_A6A8e_0_75 ?a)))
         )
)
(:durative-action startup_seg_N_A6A8d_0_75_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A6A8d_0_75))
                    (over all (not_occupied seg_N_A6A8c_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A6A8c_0_75 ?a))
                    (at start (not (not_blocked seg_N_A6A8c_0_75 ?a)))
         )
)
(:durative-action startup_seg_N_A6A8e_0_75_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A6A8e_0_75))
                    (over all (not_occupied seg_N_A6A8f_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A6A8f_0_75 ?a))
                    (at start (not (not_blocked seg_N_A6A8f_0_75 ?a)))
         )
)
(:durative-action startup_seg_N_A6A8e_0_75_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A6A8e_0_75))
                    (over all (not_occupied seg_N_A6A8d_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A6A8d_0_75 ?a))
                    (at start (not (not_blocked seg_N_A6A8d_0_75 ?a)))
         )
)
(:durative-action startup_seg_N_A6A8f_0_75_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A6A8f_0_75))
                    (over all (not_occupied seg_N_A8c_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A8c_0_60 ?a))
                    (at start (not (not_blocked seg_N_A8c_0_60 ?a)))
         )
)
(:durative-action startup_seg_N_A6A8f_0_75_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A6A8f_0_75))
                    (over all (not_occupied seg_N_A6A8e_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A6A8e_0_75 ?a))
                    (at start (not (not_blocked seg_N_A6A8e_0_75 ?a)))
         )
)
(:durative-action startup_seg_N_A8b_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A8b_0_60))
                    (over all (not_occupied seg_N_A8A9a_0_85))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A8A9a_0_85 ?a))
                    (at start (not (not_blocked seg_N_A8A9a_0_85 ?a)))
         )
)
(:durative-action startup_seg_N_A8b_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A8b_0_60))
                    (over all (not_occupied seg_N_A8a_0_60))
                    (over all (not_occupied seg_N_A8c_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A8a_0_60 ?a))
                    (at start (not (not_blocked seg_N_A8a_0_60 ?a)))
                    (at start (blocked seg_N_A8c_0_60 ?a))
                    (at start (not (not_blocked seg_N_A8c_0_60 ?a)))
         )
)
(:durative-action startup_seg_N_A8c_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A8c_0_60))
                    (over all (not_occupied seg_N_A6A8f_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A6A8f_0_75 ?a))
                    (at start (not (not_blocked seg_N_A6A8f_0_75 ?a)))
         )
)
(:durative-action startup_seg_N_A8c_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A8c_0_60))
                    (over all (not_occupied seg_N_A8a_0_60))
                    (over all (not_occupied seg_N_A8b_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A8a_0_60 ?a))
                    (at start (not (not_blocked seg_N_A8a_0_60 ?a)))
                    (at start (blocked seg_N_A8b_0_60 ?a))
                    (at start (not (not_blocked seg_N_A8b_0_60 ?a)))
         )
)
(:durative-action startup_seg_N_A8A9a_0_85_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A8A9a_0_85))
                    (over all (not_occupied seg_N_A8A9b_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A8A9b_0_75 ?a))
                    (at start (not (not_blocked seg_N_A8A9b_0_75 ?a)))
         )
)
(:durative-action startup_seg_N_A8A9a_0_85_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A8A9a_0_85))
                    (over all (not_occupied seg_N_A8b_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A8b_0_60 ?a))
                    (at start (not (not_blocked seg_N_A8b_0_60 ?a)))
         )
)
(:durative-action startup_seg_N_A8A9b_0_75_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A8A9b_0_75))
                    (over all (not_occupied seg_N_A8A9c_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A8A9c_0_75 ?a))
                    (at start (not (not_blocked seg_N_A8A9c_0_75 ?a)))
         )
)
(:durative-action startup_seg_N_A8A9b_0_75_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A8A9b_0_75))
                    (over all (not_occupied seg_N_A8A9a_0_85))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A8A9a_0_85 ?a))
                    (at start (not (not_blocked seg_N_A8A9a_0_85 ?a)))
         )
)
(:durative-action startup_seg_N_A8A9c_0_75_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A8A9c_0_75))
                    (over all (not_occupied seg_N_A8A9d_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A8A9d_0_75 ?a))
                    (at start (not (not_blocked seg_N_A8A9d_0_75 ?a)))
         )
)
(:durative-action startup_seg_N_A8A9c_0_75_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A8A9c_0_75))
                    (over all (not_occupied seg_N_A8A9b_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A8A9b_0_75 ?a))
                    (at start (not (not_blocked seg_N_A8A9b_0_75 ?a)))
         )
)
(:durative-action startup_seg_N_A8A9d_0_75_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A8A9d_0_75))
                    (over all (not_occupied seg_N_A9c_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A9c_0_60 ?a))
                    (at start (not (not_blocked seg_N_A9c_0_60 ?a)))
         )
)
(:durative-action startup_seg_N_A8A9d_0_75_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A8A9d_0_75))
                    (over all (not_occupied seg_N_A8A9c_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A8A9c_0_75 ?a))
                    (at start (not (not_blocked seg_N_A8A9c_0_75 ?a)))
         )
)
(:durative-action startup_seg_N_A9b_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A9b_0_60))
                    (over all (not_occupied seg_N_A9A10a_0_80))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A9A10a_0_80 ?a))
                    (at start (not (not_blocked seg_N_A9A10a_0_80 ?a)))
         )
)
(:durative-action startup_seg_N_A9b_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A9b_0_60))
                    (over all (not_occupied seg_N_A9a_0_60))
                    (over all (not_occupied seg_N_A9c_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A9a_0_60 ?a))
                    (at start (not (not_blocked seg_N_A9a_0_60 ?a)))
                    (at start (blocked seg_N_A9c_0_60 ?a))
                    (at start (not (not_blocked seg_N_A9c_0_60 ?a)))
         )
)
(:durative-action startup_seg_N_A9c_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A9c_0_60))
                    (over all (not_occupied seg_N_A8A9d_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A8A9d_0_75 ?a))
                    (at start (not (not_blocked seg_N_A8A9d_0_75 ?a)))
         )
)
(:durative-action startup_seg_N_A9c_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A9c_0_60))
                    (over all (not_occupied seg_N_A9a_0_60))
                    (over all (not_occupied seg_N_A9b_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A9a_0_60 ?a))
                    (at start (not (not_blocked seg_N_A9a_0_60 ?a)))
                    (at start (blocked seg_N_A9b_0_60 ?a))
                    (at start (not (not_blocked seg_N_A9b_0_60 ?a)))
         )
)
(:durative-action startup_seg_N_A9A10a_0_80_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A9A10a_0_80))
                    (over all (not_occupied seg_N_A9A10b_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A9A10b_0_75 ?a))
                    (at start (not (not_blocked seg_N_A9A10b_0_75 ?a)))
         )
)
(:durative-action startup_seg_N_A9A10a_0_80_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A9A10a_0_80))
                    (over all (not_occupied seg_N_A9b_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A9b_0_60 ?a))
                    (at start (not (not_blocked seg_N_A9b_0_60 ?a)))
         )
)
(:durative-action startup_seg_N_A9A10b_0_75_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A9A10b_0_75))
                    (over all (not_occupied seg_N_A9A10c_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A9A10c_0_75 ?a))
                    (at start (not (not_blocked seg_N_A9A10c_0_75 ?a)))
         )
)
(:durative-action startup_seg_N_A9A10b_0_75_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A9A10b_0_75))
                    (over all (not_occupied seg_N_A9A10a_0_80))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A9A10a_0_80 ?a))
                    (at start (not (not_blocked seg_N_A9A10a_0_80 ?a)))
         )
)
(:durative-action startup_seg_N_A9A10c_0_75_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A9A10c_0_75))
                    (over all (not_occupied seg_N_A9A10d_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A9A10d_0_75 ?a))
                    (at start (not (not_blocked seg_N_A9A10d_0_75 ?a)))
         )
)
(:durative-action startup_seg_N_A9A10c_0_75_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A9A10c_0_75))
                    (over all (not_occupied seg_N_A9A10b_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A9A10b_0_75 ?a))
                    (at start (not (not_blocked seg_N_A9A10b_0_75 ?a)))
         )
)
(:durative-action startup_seg_N_A9A10d_0_75_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A9A10d_0_75))
                    (over all (not_occupied seg_N_A9A10e_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A9A10e_0_75 ?a))
                    (at start (not (not_blocked seg_N_A9A10e_0_75 ?a)))
         )
)
(:durative-action startup_seg_N_A9A10d_0_75_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A9A10d_0_75))
                    (over all (not_occupied seg_N_A9A10c_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A9A10c_0_75 ?a))
                    (at start (not (not_blocked seg_N_A9A10c_0_75 ?a)))
         )
)
(:durative-action startup_seg_N_A9A10e_0_75_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A9A10e_0_75))
                    (over all (not_occupied seg_N_A9A10f_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A9A10f_0_75 ?a))
                    (at start (not (not_blocked seg_N_A9A10f_0_75 ?a)))
         )
)
(:durative-action startup_seg_N_A9A10e_0_75_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A9A10e_0_75))
                    (over all (not_occupied seg_N_A9A10d_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A9A10d_0_75 ?a))
                    (at start (not (not_blocked seg_N_A9A10d_0_75 ?a)))
         )
)
(:durative-action startup_seg_N_A9A10f_0_75_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A9A10f_0_75))
                    (over all (not_occupied seg_N_A9A10g_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A9A10g_0_75 ?a))
                    (at start (not (not_blocked seg_N_A9A10g_0_75 ?a)))
         )
)
(:durative-action startup_seg_N_A9A10f_0_75_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A9A10f_0_75))
                    (over all (not_occupied seg_N_A9A10e_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A9A10e_0_75 ?a))
                    (at start (not (not_blocked seg_N_A9A10e_0_75 ?a)))
         )
)
(:durative-action startup_seg_N_A9A10g_0_75_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A9A10g_0_75))
                    (over all (not_occupied seg_N_A10b_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A10b_0_60 ?a))
                    (at start (not (not_blocked seg_N_A10b_0_60 ?a)))
         )
)
(:durative-action startup_seg_N_A9A10g_0_75_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A9A10g_0_75))
                    (over all (not_occupied seg_N_A9A10f_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A9A10f_0_75 ?a))
                    (at start (not (not_blocked seg_N_A9A10f_0_75 ?a)))
         )
)
(:durative-action startup_seg_N_A10b_0_60_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A10b_0_60))
                    (over all (not_occupied seg_N_A9A10g_0_75))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A9A10g_0_75 ?a))
                    (at start (not (not_blocked seg_N_A9A10g_0_75 ?a)))
         )
)
(:durative-action startup_seg_N_A10b_0_60_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_N_A10b_0_60))
                    (over all (not_occupied seg_N_A10a_0_60))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_N_A10a_0_60 ?a))
                    (at start (not (not_blocked seg_N_A10a_0_60 ?a)))
         )
)
(:durative-action startup_seg_A2_b_0_90_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_A2_b_0_90))
                    (over all (not_occupied seg_A2_c_0_100))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_A2_c_0_100 ?a))
                    (at start (not (not_blocked seg_A2_c_0_100 ?a)))
         )
)
(:durative-action startup_seg_A2_b_0_90_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_A2_b_0_90))
                    (over all (not_occupied seg_A2_a_0_90))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_A2_a_0_90 ?a))
                    (at start (not (not_blocked seg_A2_a_0_90 ?a)))
         )
)
(:durative-action startup_seg_A4_b_1_0_80_6226_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_A4_b_1_0_80_6226))
                    (over all (not_occupied seg_A4_b_0_79_7559))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_A4_b_0_79_7559 ?a))
                    (at start (not (not_blocked seg_A4_b_0_79_7559 ?a)))
         )
)
(:durative-action startup_seg_A4_b_1_0_80_6226_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_A4_b_1_0_80_6226))
                    (over all (not_occupied seg_A4_a_0_157_785))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_A4_a_0_157_785 ?a))
                    (at start (not (not_blocked seg_A4_a_0_157_785 ?a)))
         )
)
(:durative-action startup_seg_A7_b_1_0_80_6226_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_A7_b_1_0_80_6226))
                    (over all (not_occupied seg_A7_b_0_80_6226))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_A7_b_0_80_6226 ?a))
                    (at start (not (not_blocked seg_A7_b_0_80_6226 ?a)))
         )
)
(:durative-action startup_seg_A7_b_1_0_80_6226_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_A7_b_1_0_80_6226))
                    (over all (not_occupied seg_A7_a_0_156_924))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_A7_a_0_156_924 ?a))
                    (at start (not (not_blocked seg_A7_a_0_156_924 ?a)))
         )
)
(:durative-action startup_seg_A8_b_1_0_79_7559_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_A8_b_1_0_79_7559))
                    (over all (not_occupied seg_A8_b_0_80_6226))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_A8_b_0_80_6226 ?a))
                    (at start (not (not_blocked seg_A8_b_0_80_6226 ?a)))
         )
)
(:durative-action startup_seg_A8_b_1_0_79_7559_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_A8_b_1_0_79_7559))
                    (over all (not_occupied seg_A8_a_0_157_785))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_A8_a_0_157_785 ?a))
                    (at start (not (not_blocked seg_A8_a_0_157_785 ?a)))
         )
)
(:durative-action startup_seg_T_B9B10c_2_0_83_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B9B10c_2_0_83))
                    (over all (not_occupied seg_T_B9B10c_0_84))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B9B10c_0_84 ?a))
                    (at start (not (not_blocked seg_T_B9B10c_0_84 ?a)))
         )
)
(:durative-action startup_seg_T_B9B10c_2_0_83_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_T_B9B10c_2_0_83))
                    (over all (not_occupied seg_T_B9B10c_1_0_83))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_T_B9B10c_1_0_83 ?a))
                    (at start (not (not_blocked seg_T_B9B10c_1_0_83 ?a)))
         )
)
(:durative-action startup_seg_S_B9B10c_2_0_83_north_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B9B10c_2_0_83))
                    (over all (not_occupied seg_S_B9B10c_0_84))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B9B10c_0_84 ?a))
                    (at start (not (not_blocked seg_S_B9B10c_0_84 ?a)))
         )
)
(:durative-action startup_seg_S_B9B10c_2_0_83_south_medium

 :parameters (?a - airplane)

 :duration  (= ?duration (* 60 (engines ?a) ) )

 :condition    (and (at start (is-pushing ?a))
		(at start (candostuff))
			(at start (can-start ?a))
                    (over all (at-segment ?a seg_S_B9B10c_2_0_83))
                    (over all (not_occupied seg_S_B9B10c_1_0_83))
               )

 :effect       (and (at start (not (is-pushing ?a)))
                    (at end (is-moving ?a))
                    (at start (blocked seg_S_B9B10c_1_0_83 ?a))
                    (at start (not (not_blocked seg_S_B9B10c_1_0_83 ?a)))
         )
)
)
